
/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Calcula autovetor e autovalores de uma matriz de entrada

Desenvolvido por: 

	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/
#include "cm_cm01.h"
#include "f2c.h"


extern	char	*PegaMsg();

/* Subroutine */ int rg_(nm, n, a, wr, wi, matz, z, iv1, fv1, ierr)
integer nm, n;
real *a, *wr, *wi;
integer *matz;
real *z;
integer *iv1;
real *fv1;
integer *ierr;
{
    /* System generated locals */
    integer a_dim1, a_offset, z_dim1, z_offset;

    /* Local variables */
    extern /* Subroutine */ int balbak_(), balanc_(), elmhes_(), eltran_();
    static integer is1, is2;
    extern /* Subroutine */ int hqr_(), hqr2_();

/* ***DESCRIPTION */
/*     This subroutine calls the recommended sequence of */
/*     subroutines from the eigensystem subroutine package (EISPACK) */
/*     To find the eigenvalues and eigenvectors (if desired) */
/*     of a REAL GENERAL matrix. */
/*     On Input */
/*        NM  must be set to the row dimension of the two-dimensional */
/*        array parameters as declared in the calling program */
/*        dimension statement. */
/*        N  is the order of the matrix  A. */
/*        A  contains the real general matrix. */
/*        MATZ  is an integer variable set equal to zero if */
/*        only eigenvalues are desired.  Otherwise it is set to */
/*        any non-zero integer for both eigenvalues and eigenvectors. */
/*     On Output */
/*        WR  and  WI  contain the real and imaginary parts, */
/*        respectively, of the eigenvalues.  Complex conjugate */
/*        pairs of eigenvalues appear consecutively with the */
/*        eigenvalue having the positive imaginary part first. */
/*        Z  contains the real and imaginary parts of the eigenvectors */
/*        if MATZ is not zero.  If the J-th eigenvalue is real, the */
/*        J-th column of  Z  contains its eigenvector.  If the J-TH */
/*        eigenvalue is complex with positive imaginary part, the */
/*        J-th and (J+1)-th columns of  Z  contain the real and */
/*        imaginary parts of its eigenvector.  The conjugate of this */
/*        vector is the eigenvector for the conjugate eigenvalue. */
/*        IERR  is an integer output variable set equal to an */
/*        error completion code described in section 2B of the */
/*        documentation.  The normal completion code is zero. */
/*        IV1  and  FV1  are temporary storage arrays. */
/*     ------------------------------------------------------------------ 
*/
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, 
*/
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */

/* ***FIRST EXECUTABLE STATEMENT  RG */

		
    /* Parameter adjustments */
    --fv1;
    --iv1;
    z_dim1 = nm;
    z_offset = z_dim1 + 1;
    z -= z_offset;
    --wi;
    --wr;
    a_dim1 = nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;
	
    /* Function Body */
    if (n <= nm) {
	goto L10;
    }
    *ierr = n * 10;
    goto L50;

L10:
    balanc_(nm, n, &a[a_offset], &is1, &is2, &fv1[1]);
    elmhes_(nm, n, &is1, &is2, &a[a_offset], &iv1[1]);
    if (*matz != 0) {
	goto L20;
    }
/*     .......... FIND EIGENVALUES ONLY .......... */
    hqr_(nm, n, &is1, &is2, &a[a_offset], &wr[1], &wi[1], ierr);
    goto L50;
/*     .......... FIND BOTH EIGENVALUES AND EIGENVECTORS .......... */
L20:
    eltran_(nm, n, &is1, &is2, &a[a_offset], &iv1[1], &z[z_offset]);
    hqr2_(nm, n, &is1, &is2, &a[a_offset], &wr[1], &wi[1], &z[z_offset], ierr)
	    ;
    if (*ierr != 0) {
	goto L50;
    }
    balbak_(nm, n, &is1, &is2, &fv1[1], n, &z[z_offset]);
L50:
    return 0;
} /* rg_ */

/* Subroutine */ int balanc_(nm, n, a, low, igh, scale)
integer nm, n;
real *a;
integer *low, *igh;
real *scale;
{
    /* System generated locals */
    integer a_dim1, a_offset, i_1, i_2;
    real r_1;

    /* Local variables */
    static integer iexc;
    static real c, f, g;
    static integer i, j, k, l, m;
    static real r, s, radix, b2;
    static integer jj;
    static logical noconv;

/* ***BEGIN PROLOGUE  BALANC */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4C1A */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Balances a general real matrix and isolates eigenvalue */
/*            whenever possible. */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure BALANCE, */

/*     NUM. MATH. 13, 293-304(1969) by Parlett and Reinsch. */
/*     HANDBOOk FOR AUTO. COMP., Vol.II-LINEAR ALGEBRA, 315-326(1971). */

/*     This subroutine balances a REAL matrix and isolates */
/*     eigenvalues whenever possible. */

/*     On INPUT */

/*        NM must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        N is the order of the matrix. */

/*        A contains the input matrix to be balanced. */

/*     On OUTPUT */

/*        A contains the balanced matrix. */

/*        LOW and IGH are two integers such that A(I,J) */
/*          is equal to zero if */
/*           (1) I is greater than J and */
/*           (2) J=1,...,LOW-1 or I=IGH+1,...,N. */

/*        SCALE contains information determining the */
/*           permutations and scaling factors used. */

/*     Suppose that the principal submatrix in rows LOW through IGH */
/*     has been balanced, that P(J) denotes the index interchanged */
/*     with J during the permutation step, and that the elements */
/*     of the diagonal matrix used are denoted by D(I,J).  Then */
/*        SCALE(J) = P(J),    for J = 1,...,LOW-1 */
/*                 = D(J,J),      J = LOW,...,IGH */
/*                 = P(J)         J = IGH+1,...,N. */
/*     The order in which the interchanges are made is N to IGH+1, */
/*     then 1 TO LOW-1. */

/*     Note that 1 is returned for IGH if IGH is zero formally. */

/*     The ALGOL procedure EXC contained in BALANCE appears in */
/*     BALANC  in line.  (Note that the ALGOL roles of identifiers */
/*     K,L have been reversed.) */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     Applied Mathematics Division, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ 
*/
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, 
*/
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  BALANC */


/* ***FIRST EXECUTABLE STATEMENT  BALANC */
    /* Parameter adjustments */
    --scale;
    a_dim1 = nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    radix = (real) 12.;
	
    b2 = radix * radix;
    k = 1;
    l = n;
    goto L100;
/*     .......... IN-LINE PROCEDURE FOR ROW AND */
/*                COLUMN EXCHANGE .......... */
L20:
    scale[m] = (real) j;
    if (j == m) {
	goto L50;
    }

    i_1 = l;
    for (i = 1; i <= i_1; ++i) {
	f = a[i + j * a_dim1];
	a[i + j * a_dim1] = a[i + m * a_dim1];
	a[i + m * a_dim1] = f;
/* L30: */
    }

    i_1 = n;
    for (i = k; i <= i_1; ++i) {
	f = a[j + i * a_dim1];
	a[j + i * a_dim1] = a[m + i * a_dim1];
	a[m + i * a_dim1] = f;
/* L40: */
    }

L50:
    switch ((int)iexc) {
	case 1:  goto L80;
	case 2:  goto L130;
    }
/*     .......... SEARCH FOR ROWS ISOLATING AN EIGENVALUE */
/*                AND PUSH THEM DOWN .......... */
L80:
    if (l == 1) {
	goto L280;
    }
    --l;
/*     .......... FOR J=L STEP -1 UNTIL 1 DO -- .......... */
L100:
    i_1 = l;
    for (jj = 1; jj <= i_1; ++jj) {
	j = l + 1 - jj;

	i_2 = l;
	for (i = 1; i <= i_2; ++i) {
	    if (i == j) {
		goto L110;
	    }
	    if (a[j + i * a_dim1] != (real)0.) {
		goto L120;
	    }
L110:
	    ;
	}

	m = l;
	iexc = 1;
	goto L20;
L120:
	;
    }

    goto L140;
/*     .......... SEARCH FOR COLUMNS ISOLATING AN EIGENVALUE */
/*                AND PUSH THEM LEFT .......... */
L130:
    ++k;

L140:
    i_1 = l;
    for (j = k; j <= i_1; ++j) {

	i_2 = l;
	for (i = k; i <= i_2; ++i) {
	    if (i == j) {
		goto L150;
	    }
	    if (a[i + j * a_dim1] != (real)0.) {
		goto L170;
	    }
L150:
	    ;
	}

	m = k;
	iexc = 2;
	goto L20;
L170:
	;
    }
/*     .......... NOW BALANCE THE SUBMATRIX IN ROWS K TO L .......... */
    i_1 = l;
    for (i = k; i <= i_1; ++i) {
/* L180: */
	scale[i] = (real)1.;
    }
/*     .......... ITERATIVE LOOP FOR NORM REDUCTION .......... */
L190:
    noconv = FALSE_;

    i_1 = l;
    for (i = k; i <= i_1; ++i) {
	c = (real)0.;
	r = (real)0.;

	i_2 = l;
	for (j = k; j <= i_2; ++j) {
	    if (j == i) {
		goto L200;
	    }
	    c += (r_1 = a[j + i * a_dim1], dabs(r_1));
	    r += (r_1 = a[i + j * a_dim1], dabs(r_1));
L200:
	    ;
	}
/*     .......... GUARD AGAINST ZERO C OR R DUE TO UNDERFLOW .........
. */
	if (c == (real)0. || r == (real)0.) {
	    goto L270;
	}
	g = r / radix;
	f = (real)1.;
	s = c + r;
L210:
	if (c >= g) {
	    goto L220;
	}
	f *= radix;
	c *= b2;
	goto L210;
L220:
	g = r * radix;
L230:
	if (c < g) {
	    goto L240;
	}
	f /= radix;
	c /= b2;
	goto L230;
/*     .......... NOW BALANCE .......... */
L240:
	if ((c + r) / f >= s * (real).95) {
	    goto L270;
	}
	g = (real)1. / f;
	scale[i] *= f;
	noconv = TRUE_;

	i_2 = n;
	for (j = k; j <= i_2; ++j) {
/* L250: */
	    a[i + j * a_dim1] *= g;
	}

	i_2 = l;
	for (j = 1; j <= i_2; ++j) {
/* L260: */
	    a[j + i * a_dim1] *= f;
	}

L270:
	;
    }

    if (noconv) {
	goto L190;
    }

L280:
    *low = k;
    *igh = l;
    return 0;
} /* balanc_ */

/* Subroutine */ int elmhes_(nm, n, low, igh, a, int_)
integer nm, n, *low, *igh;
real *a;
integer *int_;
{
    /* System generated locals */
    integer a_dim1, a_offset, i_1, i_2, i_3;
    real r_1;

    /* Local variables */
    static integer i, j, m;
    static real x, y;
    static integer la, mm1, kp1, mp1;


	
    /* Parameter adjustments */
    --int_;
    a_dim1 = nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    la = *igh - 1;
    kp1 = *low + 1;
    if (la < kp1) {
	goto L200;
    }

    i_1 = la;
    for (m = kp1; m <= i_1; ++m) {
	mm1 = m - 1;
	x = (real)0.;
	i = m;

	i_2 = *igh;
	for (j = m; j <= i_2; ++j) {
	    if ((r_1 = a[j + mm1 * a_dim1], dabs(r_1)) <= dabs(x)) {
		goto L100;
	    }
	    x = a[j + mm1 * a_dim1];
	    i = j;
L100:
	    ;
	}

	int_[m] = i;
	if (i == m) {
	    goto L130;
	}
/*     ********** INTERCHANGE ROWS AND COLUMNS OF A ********** */
	i_2 = n;
	for (j = mm1; j <= i_2; ++j) {
	    y = a[i + j * a_dim1];
	    a[i + j * a_dim1] = a[m + j * a_dim1];
	    a[m + j * a_dim1] = y;
/* L110: */
	}

	i_2 = *igh;
	for (j = 1; j <= i_2; ++j) {
	    y = a[j + i * a_dim1];
	    a[j + i * a_dim1] = a[j + m * a_dim1];
	    a[j + m * a_dim1] = y;
/* L120: */
	}
/*     ********** END INTERCHANGE ********** */
L130:
	if (x == (real)0.) {
	    goto L180;
	}
	mp1 = m + 1;

	i_2 = *igh;
	for (i = mp1; i <= i_2; ++i) {
	    y = a[i + mm1 * a_dim1];
	    if (y == (real)0.) {
		goto L160;
	    }
	    y /= x;
	    a[i + mm1 * a_dim1] = y;

	    i_3 = n;
	    for (j = m; j <= i_3; ++j) {
/* L140: */
		a[i + j * a_dim1] -= y * a[m + j * a_dim1];
	    }

	    i_3 = *igh;
	    for (j = 1; j <= i_3; ++j) {
/* L150: */
		a[j + m * a_dim1] += y * a[j + i * a_dim1];
	    }

L160:
	    ;
	}

L180:
	;
    }

L200:
    return 0;
} /* elmhes_ */

/* Subroutine */ int eltran_(nm, n, low, igh, a, int_, z)
integer nm, n, *low, *igh;
real *a;
integer *int_;
real *z;
{
    /* System generated locals */
    integer a_dim1, a_offset, z_dim1, z_offset, i_1, i_2;

    /* Local variables */
    static integer i, j, kl, mm, mp, mp1;



/*     ********** INITIALIZE Z TO IDENTITY MATRIX ********** */
    /* Parameter adjustments */
    z_dim1 = nm;
    z_offset = z_dim1 + 1;
    z -= z_offset;
    --int_;
    a_dim1 = nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;

	
    /* Function Body */
    i_1 = n;
    for (i = 1; i <= i_1; ++i) {

	i_2 = n;
	for (j = 1; j <= i_2; ++j) {
/* L60: */
	    z[i + j * z_dim1] = (real)0.;
	}

	z[i + i * z_dim1] = (real)1.;
/* L80: */
    }

    kl = *igh - *low - 1;
    if (kl < 1) {
	goto L200;
    }
/*     ********** FOR MP=IGH-1 STEP -1 UNTIL LOW+1 DO -- ********** */
    i_1 = kl;
    for (mm = 1; mm <= i_1; ++mm) {
	mp = *igh - mm;
	mp1 = mp + 1;

	i_2 = *igh;
	for (i = mp1; i <= i_2; ++i) {
/* L100: */
	    z[i + mp * z_dim1] = a[i + (mp - 1) * a_dim1];
	}

	i = int_[mp];
	if (i == mp) {
	    goto L140;
	}

	i_2 = *igh;
	for (j = mp; j <= i_2; ++j) {
	    z[mp + j * z_dim1] = z[i + j * z_dim1];
	    z[i + j * z_dim1] = (real)0.;
/* L130: */
	}

	z[i + mp * z_dim1] = (real)1.;
L140:
	;
    }

L200:
    return 0;
} /* eltran_ */

/* Subroutine */ int balbak_(nm, n, low, igh, scale, m, z)
integer nm, n, *low, *igh;
real *scale;
integer m;
real *z;
{
    /* System generated locals */
    integer z_dim1, z_offset, i_1, i_2;

    /* Local variables */
    static integer i, j, k;
    static real s;
    static integer ii;

/* ***BEGIN PROLOGUE  BALBAK */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4C4 */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Forms eigenvectors of real general matrix from */
/*            eigenvectors of matrix output from BALANC. */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure BALBAK, */
/*     NUM. MATH. 13, 293-304(1969) by Parlett and Reinsch. */
/*     HANDBOOK FOR AUTO. COMP., Vol.II-LINEAR ALGEBRA, 315-326(1971). */

/*     This subroutine forms the eigenvectors of a REAL GENERAL */
/*     matrix by back transforming those of the corresponding */
/*     balanced matrix determined by  BALANC. */

/*     On INPUT */

/*        NM must be set to the row dimension of two-dimensional */
/*          array parameters as declared in the calling program */
/*          dimension statement. */

/*        N is the order of the matrix. */

/*        LOW and IGH are integers determined by  BALANC. */

/*        SCALE contains information determining the permutations */
/*          and scaling factors used by  BALANC. */

/*        M is the number of columns of Z to be back transformed. */

/*        Z contains the real and imaginary parts of the eigen- */
/*          vectors to be back transformed in its first M columns. */

/*     On OUTPUT */

/*        Z contains the real and imaginary parts of the */
/*          transformed eigenvectors in its first M columns. */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     Applied Mathematics Division, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ 
*/
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, 
*/
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  BALBAK */


/* ***FIRST EXECUTABLE STATEMENT  BALBAK */
    /* Parameter adjustments */
    z_dim1 = nm;
    z_offset = z_dim1 + 1;
    z -= z_offset;
    --scale;

		
    /* Function Body */
    if (m == 0) {
	goto L200;
    }
    if (*igh == *low) {
	goto L120;
    }

    i_1 = *igh;
    for (i = *low; i <= i_1; ++i) {
	s = scale[i];
/*     .......... LEFT HAND EIGENVECTORS ARE BACK TRANSFORMED */
/*                IF THE FOREGOING STATEMENT IS REPLACED BY */
/*                S=1.0E0/SCALE(I). .......... */
	i_2 = m;
	for (j = 1; j <= i_2; ++j) {
/* L100: */
	    z[i + j * z_dim1] *= s;
	}

/* L110: */
    }
/*     ......... FOR I=LOW-1 STEP -1 UNTIL 1, */
/*               IGH+1 STEP 1 UNTIL N DO -- .......... */
L120:
    i_1 = n;
    for (ii = 1; ii <= i_1; ++ii) {
	i = ii;
	if (i >= *low && i <= *igh) {
	    goto L140;
	}
	if (i < *low) {
	    i = *low - ii;
	}
	k = (integer) scale[i];
	if (k == i) {
	    goto L140;
	}

	i_2 = m;
	for (j = 1; j <= i_2; ++j) {
	    s = z[i + j * z_dim1];
	    z[i + j * z_dim1] = z[k + j * z_dim1];
	    z[k + j * z_dim1] = s;
/* L130: */
	}

L140:
	;
    }

L200:
    return 0;
} /* balbak_ */

/* Subroutine */ int hqr_(nm, n, low, igh, h, wr, wi, ierr)
integer nm, n, *low, *igh;
real *h, *wr, *wi;
integer *ierr;
{
    /* System generated locals */
    integer h_dim1, h_offset, i_1, i_2;
    real r_1, r_2, r_3;

    /* Builtin functions */
    double sqrt(), r_sign();

    /* Local variables */
    extern integer min0_();
    static real norm;
    static integer i, j, k, l, m;
    static real p, q, r, s, t, w, x, y;
    static integer na, en, ll, mm;
    static real machep, zz;
    static logical notlas;
    static integer mp2, its, enm2;



/*     ********** MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING */
/*                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC. */

/*                ********** */
    /* Parameter adjustments */
    --wi;
    --wr;
    h_dim1 = nm;
    h_offset = h_dim1 + 1;
    h -= h_offset;

    /* Function Body */
    machep = (real)1.e-12;
	
    *ierr = 0;
    norm = (real)0.;
    k = 1;
/*     ********** STORE ROOTS ISOLATED BY BALANC */
/*                AND COMPUTE MATRIX NORM ********** */
    i_1 = n;
    for (i = 1; i <= i_1; ++i) {

	i_2 = n;
	for (j = k; j <= i_2; ++j) {
/* L40: */
	    norm += (r_1 = h[i + j * h_dim1], dabs(r_1));
	}

	k = i;
	if (i >= *low && i <= *igh) {
	    goto L50;
	}
	wr[i] = h[i + i * h_dim1];
	wi[i] = (real)0.;
L50:
	;
    }

    en = *igh;
    t = (real)0.;
/*     ********** SEARCH FOR NEXT EIGENVALUES ********** */
L60:
    if (en < *low) {
	goto L1001;
    }
    its = 0;
    na = en - 1;
    enm2 = na - 1;
/*     ********** LOOK FOR SINGLE SMALL SUB-DIAGONAL ELEMENT */
/*                FOR L=EN STEP -1 UNTIL LOW DO -- ********** */
L70:
    i_1 = en;
    for (ll = *low; ll <= i_1; ++ll) {
	l = en + *low - ll;
	if (l == *low) {
	    goto L100;
	}
	s = (r_1 = h[l - 1 + (l - 1) * h_dim1], dabs(r_1)) + (r_2 = h[l + l * 
		h_dim1], dabs(r_2));
	if (s == (real)0.) {
	    s = norm;
	}
	if ((r_1 = h[l + (l - 1) * h_dim1], dabs(r_1)) <= machep * s) {
	    goto L100;
	}
/* L80: */
    }
/*     ********** FORM SHIFT ********** */
L100:
    x = h[en + en * h_dim1];
    if (l == en) {
	goto L270;
    }
    y = h[na + na * h_dim1];
    w = h[en + na * h_dim1] * h[na + en * h_dim1];
    if (l == na) {
	goto L280;
    }
    if (its == 30) {
	goto L1000;
    }
    if (its != 10 && its != 20) {
	goto L130;
    }
/*     ********** FORM EXCEPTIONAL SHIFT ********** */
    t += x;

    i_1 = en;
    for (i = *low; i <= i_1; ++i) {
/* L120: */
	h[i + i * h_dim1] -= x;
    }

    s = (r_1 = h[en + na * h_dim1], dabs(r_1)) + (r_2 = h[na + enm2 * h_dim1],
	     dabs(r_2));
    x = s * (real).75;
    y = x;
    w = s * (real)-.4375 * s;
L130:
    ++its;
/*     ********** LOOK FOR TWO CONSECUTIVE SMALL */
/*                SUB-DIAGONAL ELEMENTS. */
/*                FOR M=EN-2 STEP -1 UNTIL L DO -- ********** */
    i_1 = enm2;
    for (mm = l; mm <= i_1; ++mm) {
	m = enm2 + l - mm;
	zz = h[m + m * h_dim1];
	r = x - zz;
	s = y - zz;
	p = (r * s - w) / h[m + 1 + m * h_dim1] + h[m + (m + 1) * h_dim1];
	q = h[m + 1 + (m + 1) * h_dim1] - zz - r - s;
	r = h[m + 2 + (m + 1) * h_dim1];
	s = dabs(p) + dabs(q) + dabs(r);
	p /= s;
	q /= s;
	r /= s;
	if (m == l) {
	    goto L150;
	}
	if ((r_1 = h[m + (m - 1) * h_dim1], dabs(r_1)) * (dabs(q) + dabs(r)) 
		<= machep * dabs(p) * ((r_2 = h[m - 1 + (m - 1) * h_dim1], 
		dabs(r_2)) + dabs(zz) + (r_3 = h[m + 1 + (m + 1) * h_dim1], 
		dabs(r_3)))) {
	    goto L150;
	}
/* L140: */
    }

L150:
    mp2 = m + 2;

    i_1 = en;
    for (i = mp2; i <= i_1; ++i) {
	h[i + (i - 2) * h_dim1] = (real)0.;
	if (i == mp2) {
	    goto L160;
	}
	h[i + (i - 3) * h_dim1] = (real)0.;
L160:
	;
    }
/*     ********** DOUBLE QR STEP INVOLVING ROWS L TO EN AND */
/*                COLUMNS M TO EN ********** */
    i_1 = na;
    for (k = m; k <= i_1; ++k) {
	notlas = k != na;
	if (k == m) {
	    goto L170;
	}
	p = h[k + (k - 1) * h_dim1];
	q = h[k + 1 + (k - 1) * h_dim1];
	r = (real)0.;
	if (notlas) {
	    r = h[k + 2 + (k - 1) * h_dim1];
	}
	x = dabs(p) + dabs(q) + dabs(r);
	if (x == (real)0.) {
	    goto L260;
	}
	p /= x;
	q /= x;
	r /= x;
L170:
	r_1 = sqrt(p * p + q * q + r * r);
	s = r_sign(&r_1, &p);
	if (k == m) {
	    goto L180;
	}
	h[k + (k - 1) * h_dim1] = -(doublereal)s * x;
	goto L190;
L180:
	if (l != m) {
	    h[k + (k - 1) * h_dim1] = -(doublereal)h[k + (k - 1) * h_dim1];
	}
L190:
	p += s;
	x = p / s;
	y = q / s;
	zz = r / s;
	q /= p;
	r /= p;
/*     ********** ROW MODIFICATION ********** */
	i_2 = en;
	for (j = k; j <= i_2; ++j) {
	    p = h[k + j * h_dim1] + q * h[k + 1 + j * h_dim1];
	    if (! notlas) {
		goto L200;
	    }
	    p += r * h[k + 2 + j * h_dim1];
	    h[k + 2 + j * h_dim1] -= p * zz;
L200:
	    h[k + 1 + j * h_dim1] -= p * y;
	    h[k + j * h_dim1] -= p * x;
/* L210: */
	}

	i_2 = k + 3;
	j = min0_(&en, &i_2);
/*     ********** COLUMN MODIFICATION ********** */
	i_2 = j;
	for (i = l; i <= i_2; ++i) {
	    p = x * h[i + k * h_dim1] + y * h[i + (k + 1) * h_dim1];
	    if (! notlas) {
		goto L220;
	    }
	    p += zz * h[i + (k + 2) * h_dim1];
	    h[i + (k + 2) * h_dim1] -= p * r;
L220:
	    h[i + (k + 1) * h_dim1] -= p * q;
	    h[i + k * h_dim1] -= p;
/* L230: */
	}

L260:
	;
    }

    goto L70;
/*     ********** ONE ROOT FOUND ********** */
L270:
    wr[en] = x + t;
    wi[en] = (real)0.;
    en = na;
    goto L60;
/*     ********** TWO ROOTS FOUND ********** */
L280:
    p = (y - x) / (real)2.;
    q = p * p + w;
    zz = sqrt((dabs(q)));
    x += t;
    if (q < (real)0.) {
	goto L320;
    }
/*     ********** REAL PAIR ********** */
    zz = p + r_sign(&zz, &p);
    wr[na] = x + zz;
    wr[en] = wr[na];
    if (zz != (real)0.) {
	wr[en] = x - w / zz;
    }
    wi[na] = (real)0.;
    wi[en] = (real)0.;
    goto L330;
/*     ********** COMPLEX PAIR ********** */
L320:
    wr[na] = x + p;
    wr[en] = x + p;
    wi[na] = zz;
    wi[en] = -(doublereal)zz;
L330:
    en = enm2;
    goto L60;
/*     ********** SET ERROR -- NO CONVERGENCE TO AN */
/*                EIGENVALUE AFTER 30 ITERATIONS ********** */
L1000:

/* *** Padroniz. msg erro - Luciana 21/12/94
    execerro("Autog","Nao convergiu apos 30 iteracoes");
*** */
    execerro(PegaMsg(1101),(char *) 0);
    *ierr = en;
L1001:
    return 0;
} /* hqr_ */

/* Subroutine */ int hqr2_(nm, n, low, igh, h, wr, wi, z, ierr)
integer nm, n, *low, *igh;
real *h, *wr, *wi, *z;
integer *ierr;
{
    /* System generated locals */
    integer h_dim1, h_offset, z_dim1, z_offset, i_1, i_2, i_3;
    real r_1, r_2, r_3;
    doublereal d_1, d_2;
    complex q_1, q_2, q_3;

    /* Builtin functions */
    double sqrt(), r_sign();
    void c_div();
    double r_imag();

    /* Local variables */
    extern integer min0_();
    static real norm;
    static integer i, j, k, l, m;
    static real p, q, r, s, t, w, x, y;
    static complex z3;
    static integer na, ii, en, jj;
    static real ra, sa;
    static integer ll, mm, nn;
    static real machep, vi, vr, zz;
    static logical notlas;
    static integer mp2, its, enm2;



/*     ********** MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING */
/*                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC. */

/*                ********** */
    /* Parameter adjustments */
    z_dim1 = nm;
    z_offset = z_dim1 + 1;
    z -= z_offset;
    --wi;
    --wr;
    h_dim1 = nm;
    h_offset = h_dim1 + 1;
    h -= h_offset;
	
    /* Function Body */
    machep = (real)1.e-16;

    *ierr = 0;
    norm = (real)0.;
    k = 1;
/*     ********** STORE ROOTS ISOLATED BY BALANC */
/*                AND COMPUTE MATRIX NORM ********** */
    i_1 = n;
    for (i = 1; i <= i_1; ++i) {

	i_2 = n;
	for (j = k; j <= i_2; ++j) {
/* L40: */
	    norm += (r_1 = h[i + j * h_dim1], dabs(r_1));
	}

	k = i;
	if (i >= *low && i <= *igh) {
	    goto L50;
	}
	wr[i] = h[i + i * h_dim1];
	wi[i] = (real)0.;
L50:
	;
    }

    en = *igh;
    t = (real)0.;
/*     ********** SEARCH FOR NEXT EIGENVALUES ********** */
L60:
    if (en < *low) {
	goto L340;
    }
    its = 0;
    na = en - 1;
    enm2 = na - 1;
/*     ********** LOOK FOR SINGLE SMALL SUB-DIAGONAL ELEMENT */
/*                FOR L=EN STEP -1 UNTIL LOW DO -- ********** */
L70:
    i_1 = en;
    for (ll = *low; ll <= i_1; ++ll) {
	l = en + *low - ll;
	if (l == *low) {
	    goto L100;
	}
	s = (r_1 = h[l - 1 + (l - 1) * h_dim1], dabs(r_1)) + (r_2 = h[l + l * 
		h_dim1], dabs(r_2));
	if (s == (real)0.) {
	    s = norm;
	}
	if ((r_1 = h[l + (l - 1) * h_dim1], dabs(r_1)) <= machep * s) {
	    goto L100;
	}
/* L80: */
    }
/*     ********** FORM SHIFT ********** */
L100:
    x = h[en + en * h_dim1];
    if (l == en) {
	goto L270;
    }
    y = h[na + na * h_dim1];
    w = h[en + na * h_dim1] * h[na + en * h_dim1];
    if (l == na) {
	goto L280;
    }
    if (its == 30) {
	goto L1000;
    }
    if (its != 10 && its != 20) {
	goto L130;
    }
/*     ********** FORM EXCEPTIONAL SHIFT ********** */
    t += x;

    i_1 = en;
    for (i = *low; i <= i_1; ++i) {
/* L120: */
	h[i + i * h_dim1] -= x;
    }

    s = (r_1 = h[en + na * h_dim1], dabs(r_1)) + (r_2 = h[na + enm2 * h_dim1],
	     dabs(r_2));
    x = s * (real).75;
    y = x;
    w = s * (real)-.4375 * s;
L130:
    ++its;
/*     ********** LOOK FOR TWO CONSECUTIVE SMALL */
/*                SUB-DIAGONAL ELEMENTS. */
/*                FOR M=EN-2 STEP -1 UNTIL L DO -- ********** */
    i_1 = enm2;
    for (mm = l; mm <= i_1; ++mm) {
	m = enm2 + l - mm;
	zz = h[m + m * h_dim1];
	r = x - zz;
	s = y - zz;
	p = (r * s - w) / h[m + 1 + m * h_dim1] + h[m + (m + 1) * h_dim1];
	q = h[m + 1 + (m + 1) * h_dim1] - zz - r - s;
	r = h[m + 2 + (m + 1) * h_dim1];
	s = dabs(p) + dabs(q) + dabs(r);
	p /= s;
	q /= s;
	r /= s;
	if (m == l) {
	    goto L150;
	}
	if ((r_1 = h[m + (m - 1) * h_dim1], dabs(r_1)) * (dabs(q) + dabs(r)) 
		<= machep * dabs(p) * ((r_2 = h[m - 1 + (m - 1) * h_dim1], 
		dabs(r_2)) + dabs(zz) + (r_3 = h[m + 1 + (m + 1) * h_dim1], 
		dabs(r_3)))) {
	    goto L150;
	}
/* L140: */
    }

L150:
    mp2 = m + 2;

    i_1 = en;
    for (i = mp2; i <= i_1; ++i) {
	h[i + (i - 2) * h_dim1] = (real)0.;
	if (i == mp2) {
	    goto L160;
	}
	h[i + (i - 3) * h_dim1] = (real)0.;
L160:
	;
    }
/*     ********** DOUBLE QR STEP INVOLVING ROWS L TO EN AND */
/*                COLUMNS M TO EN ********** */
    i_1 = na;
    for (k = m; k <= i_1; ++k) {
	notlas = k != na;
	if (k == m) {
	    goto L170;
	}
	p = h[k + (k - 1) * h_dim1];
	q = h[k + 1 + (k - 1) * h_dim1];
	r = (real)0.;
	if (notlas) {
	    r = h[k + 2 + (k - 1) * h_dim1];
	}
	x = dabs(p) + dabs(q) + dabs(r);
	if (x == (real)0.) {
	    goto L260;
	}
	p /= x;
	q /= x;
	r /= x;
L170:
	r_1 = sqrt(p * p + q * q + r * r);
	s = r_sign(&r_1, &p);
	if (k == m) {
	    goto L180;
	}
	h[k + (k - 1) * h_dim1] = -(doublereal)s * x;
	goto L190;
L180:
	if (l != m) {
	    h[k + (k - 1) * h_dim1] = -(doublereal)h[k + (k - 1) * h_dim1];
	}
L190:
	p += s;
	x = p / s;
	y = q / s;
	zz = r / s;
	q /= p;
	r /= p;
/*     ********** ROW MODIFICATION ********** */
	i_2 = n;
	for (j = k; j <= i_2; ++j) {
	    p = h[k + j * h_dim1] + q * h[k + 1 + j * h_dim1];
	    if (! notlas) {
		goto L200;
	    }
	    p += r * h[k + 2 + j * h_dim1];
	    h[k + 2 + j * h_dim1] -= p * zz;
L200:
	    h[k + 1 + j * h_dim1] -= p * y;
	    h[k + j * h_dim1] -= p * x;
/* L210: */
	}

	i_2 = k + 3;
	j = min0_(&en, &i_2);
/*     ********** COLUMN MODIFICATION ********** */
	i_2 = j;
	for (i = 1; i <= i_2; ++i) {
	    p = x * h[i + k * h_dim1] + y * h[i + (k + 1) * h_dim1];
	    if (! notlas) {
		goto L220;
	    }
	    p += zz * h[i + (k + 2) * h_dim1];
	    h[i + (k + 2) * h_dim1] -= p * r;
L220:
	    h[i + (k + 1) * h_dim1] -= p * q;
	    h[i + k * h_dim1] -= p;
/* L230: */
	}
/*     ********** ACCUMULATE TRANSFORMATIONS ********** */
	i_2 = *igh;
	for (i = *low; i <= i_2; ++i) {
	    p = x * z[i + k * z_dim1] + y * z[i + (k + 1) * z_dim1];
	    if (! notlas) {
		goto L240;
	    }
	    p += zz * z[i + (k + 2) * z_dim1];
	    z[i + (k + 2) * z_dim1] -= p * r;
L240:
	    z[i + (k + 1) * z_dim1] -= p * q;
	    z[i + k * z_dim1] -= p;
/* L250: */
	}

L260:
	;
    }

    goto L70;
/*     ********** ONE ROOT FOUND ********** */
L270:
    h[en + en * h_dim1] = x + t;
    wr[en] = h[en + en * h_dim1];
    wi[en] = (real)0.;
    en = na;
    goto L60;
/*     ********** TWO ROOTS FOUND ********** */
L280:
    p = (y - x) / (real)2.;
    q = p * p + w;
    zz = sqrt((dabs(q)));
    h[en + en * h_dim1] = x + t;
    x = h[en + en * h_dim1];
    h[na + na * h_dim1] = y + t;
    if (q < (real)0.) {
	goto L320;
    }
/*     ********** REAL PAIR ********** */
    zz = p + r_sign(&zz, &p);
    wr[na] = x + zz;
    wr[en] = wr[na];
    if (zz != (real)0.) {
	wr[en] = x - w / zz;
    }
    wi[na] = (real)0.;
    wi[en] = (real)0.;
    x = h[en + na * h_dim1];
    s = dabs(x) + dabs(zz);
    p = x / s;
    q = zz / s;
    r = sqrt(p * p + q * q);
    p /= r;
    q /= r;
/*     ********** ROW MODIFICATION ********** */
    i_1 = n;
    for (j = na; j <= i_1; ++j) {
	zz = h[na + j * h_dim1];
	h[na + j * h_dim1] = q * zz + p * h[en + j * h_dim1];
	h[en + j * h_dim1] = q * h[en + j * h_dim1] - p * zz;
/* L290: */
    }
/*     ********** COLUMN MODIFICATION ********** */
    i_1 = en;
    for (i = 1; i <= i_1; ++i) {
	zz = h[i + na * h_dim1];
	h[i + na * h_dim1] = q * zz + p * h[i + en * h_dim1];
	h[i + en * h_dim1] = q * h[i + en * h_dim1] - p * zz;
/* L300: */
    }
/*     ********** ACCUMULATE TRANSFORMATIONS ********** */
    i_1 = *igh;
    for (i = *low; i <= i_1; ++i) {
	zz = z[i + na * z_dim1];
	z[i + na * z_dim1] = q * zz + p * z[i + en * z_dim1];
	z[i + en * z_dim1] = q * z[i + en * z_dim1] - p * zz;
/* L310: */
    }

    goto L330;
/*     ********** COMPLEX PAIR ********** */
L320:
    wr[na] = x + p;
    wr[en] = x + p;
    wi[na] = zz;
    wi[en] = -(doublereal)zz;
L330:
    en = enm2;
    goto L60;
/*     ********** ALL ROOTS FOUND.  BACKSUBSTITUTE TO FIND */
/*                VECTORS OF UPPER TRIANGULAR FORM ********** */
L340:
    if (norm == (real)0.) {
	goto L1001;
    }
/*     ********** FOR EN=N STEP -1 UNTIL 1 DO -- ********** */
    i_1 = n;
    for (nn = 1; nn <= i_1; ++nn) {
	en = n + 1 - nn;
	p = wr[en];
	q = wi[en];
	na = en - 1;
	if (q < (real)0.) {
	    goto L710;
	} else if (q == 0.0) {
	    goto L600;
	} else {
	    goto L800;
	}
/*     ********** REAL VECTOR ********** */
L600:
	m = en;
	h[en + en * h_dim1] = (real)1.;
	if (na == 0) {
	    goto L800;
	}
/*     ********** FOR I=EN-1 STEP -1 UNTIL 1 DO -- ********** */
	i_2 = na;
	for (ii = 1; ii <= i_2; ++ii) {
	    i = en - ii;
	    w = h[i + i * h_dim1] - p;
	    r = h[i + en * h_dim1];
	    if (m > na) {
		goto L620;
	    }

	    i_3 = na;
	    for (j = m; j <= i_3; ++j) {
/* L610: */
		r += h[i + j * h_dim1] * h[j + en * h_dim1];
	    }

L620:
	    if (wi[i] >= (real)0.) {
		goto L630;
	    }
	    zz = w;
	    s = r;
	    goto L700;
L630:
	    m = i;
	    if (wi[i] != (real)0.) {
		goto L640;
	    }
	    t = w;
	    if (w == (real)0.) {
		t = machep * norm;
	    }
	    h[i + en * h_dim1] = -(doublereal)r / t;
	    goto L700;
/*     ********** SOLVE REAL EQUATIONS ********** */
L640:
	    x = h[i + (i + 1) * h_dim1];
	    y = h[i + 1 + i * h_dim1];
	    q = (wr[i] - p) * (wr[i] - p) + wi[i] * wi[i];
	    t = (x * s - zz * r) / q;
	    h[i + en * h_dim1] = t;
	    if (dabs(x) <= dabs(zz)) {
		goto L650;
	    }
	    h[i + 1 + en * h_dim1] = (-(doublereal)r - w * t) / x;
	    goto L700;
L650:
	    h[i + 1 + en * h_dim1] = (-(doublereal)s - y * t) / zz;
L700:
	    ;
	}
/*     ********** END REAL VECTOR ********** */
	goto L800;
/*     ********** COMPLEX VECTOR ********** */
L710:
	m = na;
/*     ********** LAST VECTOR COMPONENT CHOSEN IMAGINARY SO THAT */
/*                EIGENVECTOR MATRIX IS TRIANGULAR ********** */
	if ((r_1 = h[en + na * h_dim1], dabs(r_1)) <= (r_2 = h[na + en * 
		h_dim1], dabs(r_2))) {
	    goto L720;
	}
	h[na + na * h_dim1] = q / h[en + na * h_dim1];
	h[na + en * h_dim1] = -(doublereal)(h[en + en * h_dim1] - p) / h[en + 
		na * h_dim1];
	goto L730;
L720:
	d_1 = -(doublereal)h[na + en * h_dim1];
	q_2.r = (real)0., q_2.i = d_1;
	d_2 = h[na + na * h_dim1] - p;
	q_3.r = d_2, q_3.i = q;
	c_div(&q_1, &q_2, &q_3);
	z3.r = q_1.r, z3.i = q_1.i;
	h[na + na * h_dim1] = z3.r;
	h[na + en * h_dim1] = r_imag(&z3);
L730:
	h[en + na * h_dim1] = (real)0.;
	h[en + en * h_dim1] = (real)1.;
	enm2 = na - 1;
	if (enm2 == 0) {
	    goto L800;
	}
/*     ********** FOR I=EN-2 STEP -1 UNTIL 1 DO -- ********** */
	i_2 = enm2;
	for (ii = 1; ii <= i_2; ++ii) {
	    i = na - ii;
	    w = h[i + i * h_dim1] - p;
	    ra = (real)0.;
	    sa = h[i + en * h_dim1];

	    i_3 = na;
	    for (j = m; j <= i_3; ++j) {
		ra += h[i + j * h_dim1] * h[j + na * h_dim1];
		sa += h[i + j * h_dim1] * h[j + en * h_dim1];
/* L760: */
	    }

	    if (wi[i] >= (real)0.) {
		goto L770;
	    }
	    zz = w;
	    r = ra;
	    s = sa;
	    goto L790;
L770:
	    m = i;
	    if (wi[i] != (real)0.) {
		goto L780;
	    }
	    d_1 = -(doublereal)ra;
	    d_2 = -(doublereal)sa;
	    q_2.r = d_1, q_2.i = d_2;
	    q_3.r = w, q_3.i = q;
	    c_div(&q_1, &q_2, &q_3);
	    z3.r = q_1.r, z3.i = q_1.i;
	    h[i + na * h_dim1] = z3.r;
	    h[i + en * h_dim1] = r_imag(&z3);
	    goto L790;
/*     ********** SOLVE COMPLEX EQUATIONS ********** */
L780:
	    x = h[i + (i + 1) * h_dim1];
	    y = h[i + 1 + i * h_dim1];
	    vr = (wr[i] - p) * (wr[i] - p) + wi[i] * wi[i] - q * q;
	    vi = (wr[i] - p) * (real)2. * q;
	    if (vr == (real)0. && vi == (real)0.) {
		vr = machep * norm * (dabs(w) + dabs(q) + dabs(x) + dabs(y) + 
			dabs(zz));
	    }
	    d_1 = x * r - zz * ra + q * sa;
	    d_2 = x * s - zz * sa - q * ra;
	    q_2.r = d_1, q_2.i = d_2;
	    q_3.r = vr, q_3.i = vi;
	    c_div(&q_1, &q_2, &q_3);
	    z3.r = q_1.r, z3.i = q_1.i;
	    h[i + na * h_dim1] = z3.r;
	    h[i + en * h_dim1] = r_imag(&z3);
	    if (dabs(x) <= dabs(zz) + dabs(q)) {
		goto L785;
	    }
	    h[i + 1 + na * h_dim1] = (-(doublereal)ra - w * h[i + na * h_dim1]
		     + q * h[i + en * h_dim1]) / x;
	    h[i + 1 + en * h_dim1] = (-(doublereal)sa - w * h[i + en * h_dim1]
		     - q * h[i + na * h_dim1]) / x;
	    goto L790;
L785:
	    d_1 = -(doublereal)r - y * h[i + na * h_dim1];
	    d_2 = -(doublereal)s - y * h[i + en * h_dim1];
	    q_2.r = d_1, q_2.i = d_2;
	    q_3.r = zz, q_3.i = q;
	    c_div(&q_1, &q_2, &q_3);
	    z3.r = q_1.r, z3.i = q_1.i;
	    h[i + 1 + na * h_dim1] = z3.r;
	    h[i + 1 + en * h_dim1] = r_imag(&z3);
L790:
	    ;
	}
/*     ********** END COMPLEX VECTOR ********** */
L800:
	;
    }
/*     ********** END BACK SUBSTITUTION. */
/*                VECTORS OF ISOLATED ROOTS ********** */
    i_1 = n;
    for (i = 1; i <= i_1; ++i) {
	if (i >= *low && i <= *igh) {
	    goto L840;
	}

	i_2 = n;
	for (j = i; j <= i_2; ++j) {
/* L820: */
	    z[i + j * z_dim1] = h[i + j * h_dim1];
	}

L840:
	;
    }
/*     ********** MULTIPLY BY TRANSFORMATION MATRIX TO GIVE */
/*                VECTORS OF ORIGINAL FULL MATRIX. */
/*                FOR J=N STEP -1 UNTIL LOW DO -- ********** */
    i_1 = n;
    for (jj = *low; jj <= i_1; ++jj) {
	j = n + *low - jj;
	m = min0_(&j, igh);

	i_2 = *igh;
	for (i = *low; i <= i_2; ++i) {
	    zz = (real)0.;

	    i_3 = m;
	    for (k = *low; k <= i_3; ++k) {
/* L860: */
		zz += z[i + k * z_dim1] * h[k + j * h_dim1];
	    }

	    z[i + j * z_dim1] = zz;
/* L880: */
	}
    }

    goto L1001;
/*     ********** SET ERROR -- NO CONVERGENCE TO AN */
/*                EIGENVALUE AFTER 30 ITERATIONS ********** */
L1000:

/* *** Padroniz. msg erro - Luciana 21/12/94
    execerro("Autog","Nao convergiu apos 30 iteracoes");
*** */
    execerro(PegaMsg(1101),(char *) 0);
    *ierr = en;
L1001:
    return 0;
} /* hqr2_ */


integer min0_(i, j)
int *i;
int *j;
{
	if (*i <= *j)
		return(*i);
	else
		return(*j);
}

double r_sign(a,b)
real *a, *b;
{
	double x;
	x = (*a >= 0.0 ? *a : - *a);
	return( *b >= 0.0 ? x : -x);
}


double r_imag(z)
complex *z;
{
	return(z->i);
}



VOID c_div(c, a, b)
complex *a, *b, *c;
{
	double ratio, den;
	double abr, abi;

	if( (abr = b->r) < 0.)
		abr = - abr;
	if( (abi = b->i) < 0.)
		abi = - abi;
	if( abr <= abi )
		{
		if(abi == 0.0)

/* *** Padroniz. msg erro - Luciana 21/12/94
			execerro("AUTOG","Divisao por zero");
*** */
			execerro(PegaMsg(1056),(char *) 0);
		ratio = (double)b->r / b->i ;
		den = b->i * (1 + ratio*ratio);
		c->r = (a->r*ratio + a->i) / den;
		c->i = (a->i*ratio - a->r) / den;
	}

	else
	{
		ratio = (double)b->i / b->r ;
		den = b->r * (1 + ratio*ratio);
		c->r = (a->r + a->i*ratio) / den;
		c->i = (a->i - a->r*ratio) / den;
	}
}

