#include <stdio.h>
#include <setjmp.h>
#include <signal.h>
#include <string.h>

#if defined(MSDOS) | defined(IRIX) | defined(SUN)
# include <stdlib.h>
#endif

#define  EXTVAR                                             
#include "pcsgbd.h"
#include "cm_cm01.h"

#ifdef MSDOS
# include "y_tab.h"
#else
#ifdef VAXVMS
# include "y_tab.h"
#else
# include "y.tab.h"
#endif
#endif


/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Programa principal. Verifica as opes de execuo e invoca a funo de anlise
	sinttica do CM.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


char	*progname;
int	linhanum;
jmp_buf	comeco;
char	*infile;	/* nome do arquivo de entrada */
FILE	*fin;		/* ponteiro para arquivo de entrada */
int	c;		/* global para uso por aviso() */

struct guarda_arq {
	FILE	*arquivo;
	int	numlinha;
	char	*nomearq;
};
struct	guarda_arq	guarda_arq[30];

int	numero_arq;

double	_toleri = 12.0;		/* Tolerancia para impressao no liste	  */	
char    _nomesai[MAXDIR];	/* Local do redirecionamento		  */

int	valret;
int	retlex;
YYSTYPE valyyl;
int	nivel;	/* Controla o numero de if's ou while nested */
int	excprg = -1;
int	flagX = 0;
int	flagP = 0;
int	flagA = 0;
int      fvideo;	/* Indice se saida e' video ou nao */

/*
** Variaveis  externas, declaradas em init() para possibilitar a montagem
** da libcm sem inclusao do arquivo cm.c
*/
extern FILE	*fsaida; 	/* Indica aonde sera' a saida */
extern char    _diretorio[MAXDIR];	/* Diretorio Default  */
extern int     _colunas;		/* Numero de Colunas para impressao  */
extern double  _toler_;		/* Tolerancia para criterio de num = zero */
extern int	fl_mis;

extern char 	exretstd[]; /* Contem o nome do arquivo exretstd */
extern int 	flagstd;

#ifdef MSDOS
int	 nlins = 25;
#else
int	 nlins = 24;
#endif

int	 ncols = 80;

#ifdef YYDEBUG
extern int yydebug;
#endif

extern Inst *progbase;

main(argc, argv)
int argc;
char *argv[];
{
	int i;
	int fp;

#ifdef VAXVMS
	argc = prepvax(argc, argv);
#endif

	fsaida = stdout;	/* Default e' stdout (Video) */
	fvideo = 1;

	strcpy(_diretorio,  "");

	strcpy(_nomesai, "video");

	valret = -1;
	valyyl.simb = (Simbolo_t *) NULL;

	progname = "CM";
	numero_arq = 1;
	linhanum = 0;
	debugflag = 0;

	fp = 0;

	--argc;
	++argv;
	while (argc--) {
		if (argv[0][0] == '-') {
			for (i = 1; argv[0][i] ;++i) {
				switch (argv[0][i]) {
				case 'd':
					debugflag = 1;
					break;
				case 'P':
					flagP = 1;
					break;
				case 'D':
					debugflag = 1;
#ifdef YYDEBUG
					yydebug = 1;
#endif
					break;
				case 'A':
#ifdef RS6000
					flagstd = 1;

					/*
					*strchr(&argv[0][i+1], '|') = '\0';
					*/
					if (*strchr(&argv[0][i+1], '|'))
						*strchr(&argv[0][i+1], '|') = '\0';

					if (freopen(&argv[0][i+1], "r", stdin)==
							(FILE *) NULL) {

/* *** Padroniz. msg erro - Luciana 21/12/94
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
						i += (strlen(&argv[0][i+1]) + 1);
						*strchr(&argv[0][i+1], '|') = '\0';
						i += (strlen(&argv[0][i+1]) + 1);
						strcpy(exretstd, &argv[0][i+1]);
						fprintf(stderr, PegaMsg(1034),"stdin");
						setOSstdin();
#ifdef MEM_DEBUG
						if (Mem_Used() != 0) {
							printf("*** Lista de memoria nao esta' vazia ***\n");
							Mem_Store("cm");
							exit(5);
						}
#endif

						exit(5);
					}
					i += (strlen(&argv[0][i+1]) + 1);
					*strchr(&argv[0][i+1], '|') = '\0';
					fseek(stdin, atol(&argv[0][i+1]), 0);
					i += (strlen(&argv[0][i+1]) + 1);
					strcpy(exretstd, &argv[0][i+1]);
					i += strlen(&argv[0][i+1]);
#endif
					setbuf(stdin, (char *) NULL);
					fp = 1;
					flagA = 1;
					break;

				/*
				** Habilita impressao de mensagens
				*/

				case 'M':

					break;

				/*
				** Habilita impressao de tempo
				*/

				case 't':

					break;

				case 'X':
					if (strcmp(&argv[0][i+1],"ntia") == 0) {
						flagX = 1;
						i += 4;
					}
					break;

				case 'l':

					nlins = atoi(&argv[0][i+1]);
					i += strlen(&argv[0][i+1]);
					break;

				case 'c':

					ncols = atoi(&argv[0][i+1]);
					i += strlen(&argv[0][i+1]);
					break;
				default:

/* *** Padroniz. msg erro - Luciana 21/12/94
					fprintf(stderr, "Flag <%c> ilegal\n", argv[0][1]);
*** */
					fprintf(stderr, PegaMsg(3086),argv[0][1]);
					setOSstdin();
#ifdef MEM_DEBUG
					if (Mem_Used() != 0) {
						printf("*** Lista de memoria nao esta' vazia ***\n");
						Mem_Store("cm");
						exit(1);
					}
#endif
					exit(1);

					break;
				}
			}
		}
		else
			break;
		++argv;
	}

	if (argc < 0) {
		fin = stdin;
		if (fp > 0) {
			infile = "sendo executado";
			interativo = 1;
		}
		else {
			infile = "stdin";
			interativo = 0;
		}
		guarda_arq[0].arquivo = stdin;
		guarda_arq[0].numlinha = 0;
		guarda_arq[0].nomearq = infile;
	}
	else {
		infile = argv[0];
		interativo = 1;
		if((fin=fopen(infile, "r")) == NULL) {

/* *** Padroniz. msg erro - Luciana 21/12/94
			fprintf(stderr, "Nao foi possivel abrir o arquivo %s\n",
				infile);
*** */
			fprintf(stderr, PegaMsg(1034),infile);
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(1);
			}
#endif
			exit(1);
		}
		guarda_arq[0].arquivo = fin;
		guarda_arq[0].numlinha = 0;
		guarda_arq[0].nomearq = infile;
	}

	if (flagP && interativo)
		printf("\f\n\nCalcMat\n\n");

	numerro = 0;

	if (!interativo)
		fprintf(stderr, "Info esta' disponivel. Entre \"info;\".\n\n");

	init();
	pprompt();
	setjmp(comeco);
	signal(SIGFPE, fpecatch);
	signal(SIGINT, intcatch);
	for(initcode(); (i = yyparse()); initcode()) {
		execute(progbase);
		excprg = -1;
	}

	/* Teste para alocacao/liberacao de memoria */

	setOSstdin();
#ifdef MEM_DEBUG

		if (Mem_Used() != 0) {
			
			printf("*** Lista de memoria nao esta' vazia ***\n");

			Mem_Store("cm");

			exit(i);
		}

#endif

	/* Finalizacao da execucao */

	exit(i);
}

