%{

#include <stdio.h>
#include <string.h>

#ifdef MSDOS
# include <process.h>
#endif
#ifdef VAXVMS
# include <processes.h>
#endif

#include "pcsgbd.h"
#include "cm_cm01.h"


/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Mdulo em YACC para o compilador do CM.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/



#define code2(c1,c2)	code(c1);code(c2)
#define code3(c1,c2,c3) code(c1);code(c2);code(c3)

extern  Inst *progp, *progbase, prog[];
extern  int 	nivel;
extern	int	indef;
extern  int	n_inst;
extern  char	_diretorio[MAXDIR];

extern	int	valret, retlex;
extern	int     fl_mis;
extern  int	parametro; /* declarada em  init() para possibilitar a
			      montagem da libcm sem a inclusao de initcode.c */
extern  int	argumento; /* declarada em  init() para possibilitar a
			      montagem da libcm sem a inclusao de initcode.c */

static	int	fl_onde;/* fl_onde = 1 : operando de comparacao e' string */
			/* fl_onde = 0 : operando de comparacao e' numerico */
static  int     op_onde;

Simbolo_t *sserro;	/* armazema entrada na tabela de simbolo caso
			   ocorra erro na funcao */
int	  ssninst=0;	/* armazena o numero de instrucoes de maquina
			   para 'reset' em caso de erro */
static char temp[MAXDIR];  /* variavel temporaria para concatenar strings */
extern	  int n_inst;

%}

%union {			/* stack do YACC */
	Simbolo_t *simb;	/* ponteiro paara tabela de simbolos */
	Inst	  *inst;	/* Instrucao de Maquina */
	int	  narg;		/* Numero de argumentos de uma funcao */
}
%{
extern	YYSTYPE	valyyl;
%}

%start		lista

%type		<inst>  atrib expr matriz linhas linha cond while if 
%type		<inst>  comando stmtlist stmtcom inif else
%type		<inst>  cmds begin end endproc
%token		<simb>  ID INTRINS INDEF TEMP STRING WHILE IF ELSE
%token		<simb>	FUNCTION PROCEDURE RETURN FUNC PROC LOCAL
%token		<narg>	ARG
%type		<simb>  procname operando
%type		<narg>  arglist
%token		<simb>  NUMERO NUMEROL STRINGL INDEFL
%token		INFO LISTE TREX FIM LIMPE GRAVE LEIA ANOTE CMD DIR MYEOF EXEC
%token		AUTO GS DVS IMPRIME CATA FPROB XPROB FUNCAO PERD BDIAG LIBTEMP
%token		CRIAMAT PULE ASSUMA COLUNA TOLER SAIDA FINV TINV TPROB  XINV
%token		CONFIG CRIARND CONTAGEM CONSOLE SEMENTE ONDE 
%token		';'
%token		'('
%token		')'
%token		'{'
%token		'}'
%token		'['
%token		']'
%token		':'
%token		'$'
%token		','
%token		'='
%token		'+'
%token		'-'
%token		EMULT   /* *! */
%token		EDIVD   /* /! */
%token		EDIVE   /* \! */
%token		CMULT   /* *% */
%token		'*'
%token		'@'
%token		'\\'
%token		'/'
%token		'#'
%token		'^'
%token		'\''
%token		MENOSU  NOT /* - unario */


		/* precedencia e associatividade dos operadores */

%left		OR
%left		AND
%left		GT GE LT LE EQ NE
%left		'+' '-'
%left		EMULT EDIVD EDIVE CMULT
%left		'*' '\\' '/'
%nonassoc	'@'
%left		MENOSU  /* - unario */
%right		'#'
%right		'^'
%nonassoc	'\''
%nonassoc	':'
%nonassoc	dummy   /* forca alguma reducao */

%%

		/* gramatica de CALCMAT */

lista		: /* nada */
		|  lista  pv 
		| lista stmtcom
			{
				code(STOP);
				return 1;
			}
		| lista defn 
		| lista linha pv
			{
				code2((Inst) imprimr , STOP);
				return 1;
			}
		| lista cmds1
		| error 
			{
				code(STOP);
				return 1;
			}
		;


stmtcom		: comando
		| '{' stmtlist '}'
		{
			$$ = $2;
		}
		;



atrib		: ID '=' linha
			{
				$$ = $3;
				code3((Inst) varpshn,(Inst) $1,(Inst) atribu1);
			}
		| ID '[' linha ',' linha ']' '=' linha
			{
				$$ = $8;
				code3((Inst) varpush ,(Inst) $1,(Inst) setsub1);
			}
		| ID '[' ',' linha ']' '=' linha
			{
				$$ = $7;
				code3((Inst) varpush ,(Inst) $1,(Inst) setsub2);
			}
		| ID '[' linha ',' ']' '=' linha
			{
				$$ = $7;
				code3((Inst) varpush ,(Inst) $1,(Inst) setsub3);
			}
		| ID '=' LEIA STRING
			{
				$$ = code2((Inst) varpshn, (Inst) $1);
				code2((Inst) varpshs, (Inst) $4);
				code((Inst) leia1);
			}
		| ID '=' LEIA STRING ',' PERD
			{
				fl_mis = 1;
				$$ = code2((Inst) varpshn, (Inst) $1);
				code2((Inst) varpshs, (Inst) $4);
				code((Inst) leia1);
			}
		| ID '=' LEIA STRING ONDE ID operador operando
			{
				$$ = code2((Inst) varpshn, (Inst) $1);
				code2((Inst) varpshs, (Inst) $4);
				code2((Inst) varpshn, (Inst) $6);
				code2((Inst) varpsint, (Inst) op_onde);
				if (fl_onde) {
					code2((Inst) varpshs, (Inst) $8);
					code((Inst) leia2);
				}
				else {
					code2((Inst) constpush, (Inst) $8);
					code((Inst) leia3);
				}
			}
		| ID '=' LEIA STRING ONDE ID operador operando ',' PERD
			{
				fl_mis = 1;
				$$ = code2((Inst) varpshn, (Inst) $1);
				code2((Inst) varpshs, (Inst) $4);
				code2((Inst) varpshn, (Inst) $6);
				code2((Inst) varpsint, (Inst) op_onde);
				if (fl_onde) {
					code2((Inst) varpshs, (Inst) $8);
					code((Inst) leia2);
				}
				else {
					code2((Inst) constpush, (Inst) $8);
					code((Inst) leia3);
				}
			}
       		| ARG '=' linha
			{
				$$ = $3;
				defnonly("&");
				code2((Inst) argassign,(Inst) ((long) $1));
			}
		| ARG '[' linha ',' linha ']' '=' linha
			{
				$$ = $8;
				defnonly("&");
				code2((Inst) argsub1 , (Inst) ((long) $1));
			}
		| ARG '[' ',' linha ']' '=' linha
			{
				$$ = $7;
				defnonly("&");
				code2((Inst) argsub2 , (Inst) ((long) $1));
			}
		| ARG '[' linha ',' ']' '=' linha
			{
				$$ = $7;
				defnonly("&");
				code2((Inst) argsub3 , (Inst) ((long) $1));
			}
		;

		;

operando	: STRING
			{
				$$ = $1;
				fl_onde = 1;
			}
		| NUMERO
			{
				$$ = $1;
				fl_onde = 0;
			}
		| '-' NUMERO 
			{
				fl_onde = 0;
				DADOij($2, 0, 0) = -(DADOij($2, 0, 0));
				$$ = $2;
			}
		;
		
operador	:  nulo EQ
			{
				op_onde = 1;
			}
		|  nulo GE
			{
				op_onde = 2;
			}
		|  nulo GT
			{
				op_onde = 3;
			}
		|  nulo LE
			{
				op_onde = 4;
			}
		|  nulo LT
			{
				op_onde = 5;
			}
		|  nulo NE
			{
				op_onde = 6;
			}
		;

nulo 		: 	/* nada */
		;

comando		: cmds pv
		| EXEC STRING pv
			{
				execarq(NOME($2));
			}
		| MYEOF
			{
				eofarq();
			}
		| CONSOLE   
			{
				eofarq();
			}
		| RETURN pv
			{
				defnonly("return");
				code((Inst) procret);
			}

		| RETURN expr pv
			{
				defnonly("return");
				$$ = $2;
				code((Inst) funcret);
			}
		| PROCEDURE begin '(' arglist ')' endproc pv
			{
				$$ = $2;
				code3((Inst) call, (Inst) ((long) $1),
					(Inst) ((long) $4));
			}
		| atrib pv
		{
				code((Inst) pop);
		}
	 	| while cond inif stmtcom end {
				($1)[1] = (Inst) $3;
				($1)[2] = (Inst) $5; 
				--nivel;
			}		
		| if cond inif stmtcom else end {
				($1)[1] = (Inst) $3;
				($1)[2] = (Inst) $5;
				($1)[3] = (Inst) $6;
				--nivel;
			}
		;


else		: /* nada */
		{
			if (nivel == 1) {
				valret = retlex;
				valyyl = yylval;
			}
			$$ = progp;
		}
		| ELSE end stmtcom {
				$$ = $2;
			}
		;


inif		: /* nada */
		{
			$$ = progp;
		}
		;

cond:		'(' ID ')' {
			code2((Inst) existe, (Inst) $2);
			code(STOP);
		}
		| '(' NOT ID ')' {
			code3((Inst) existe, (Inst) $3,(Inst) not);
			code(STOP);
		}
		| '(' linha ')' {
			code(STOP);
			$$ = $2;
		}
		;

while:		WHILE {
			$$ = code3((Inst) whilecod, STOP, STOP);
			++nivel;
		}
		;
if:		IF {
			$$ = code((Inst) ifcode);
			code3(STOP, STOP, STOP);
			++nivel;
		}
		;
end:		/* Nada */
		{
			code2((Inst) libtmp1,STOP);
			$$ = progp;
		}
		;
begin:		/* nada */
		{
			$$ = progp;
			code((Inst) set_parm);
		}
		;
endproc:	/* nada */
		{
			code((Inst) reset_parm);
		}
		;
stmtlist:	/* Nada */
		{
			$$ = progp;
		}
		| stmtlist stmtcom
		{
			$$ = $2;
		}
		;

linha		: expr		/* primeiro elemento da linha */
			{
				$$ = $1; 
			}
		| linha expr	/* elementos seguintes */
			{
				code((Inst) hconca1);
			}
		;



expr		: NUMERO
			{	
				 $$ = code2((Inst) constpush, (Inst) $1);
			}
		| matriz
			{
				$$ = $1;
			}
		| ID
			{
				$$ = code2((Inst) varpush, (Inst) $1);
			}
		| ARG
			{
				defnonly("&");
				$$ = code2((Inst) arg, (Inst) ((long) $1));
			}
		| FUNCTION begin '(' arglist ')' endproc
			{
				$$ = $2;
				code3((Inst) call, (Inst) ((long) $1),
					(Inst) ((long) $4));
			}
		| INTRINS '(' expr pd
			{
				$$ = $3;
				code2((Inst) bltin, (Inst)$1->u.fcn);
			}
		| CATA '(' expr ',' expr ',' expr ',' STRING pd 
			{
				code2((Inst) varpshs, (Inst) $9);
				code((Inst) mcata1);
			}
		| BDIAG 
			{ code((Inst) varnulo); }
			'(' listab ')'
			{
				code((Inst) mbdiag);
			}
		| CRIAMAT '(' expr ',' expr ',' expr pd 
			{
				code((Inst) criamat);
			}
		| CRIARND '(' expr ',' expr  pd 
			{
				code((Inst) criarnd);
			}
		| CONTAGEM '(' expr ',' expr pd 
			{
				code((Inst) contagem);
			}
		| FPROB '(' expr ',' expr ',' expr pd
			{
				code((Inst) mfprob1);
			}
		| FINV '(' expr ',' expr ',' expr pd
			{
				code((Inst) mfinv1);
			}
		| XPROB '(' expr ',' expr pd
			{
				code((Inst) mxprob1);
			}
		| XINV '(' expr ',' expr pd
			{
				code((Inst) mxinv1);
			}
		| TINV '(' expr ',' expr pd
			{
				code((Inst) mtinv1);
			}
		| TPROB '(' expr ',' expr pd
			{
				code((Inst) mtprob1);
			}
		| expr '+' expr
			{
				code((Inst) add);
			}
		| expr '-' expr
			{
				code((Inst) sub);
			}
		| expr EMULT expr
			{
				code((Inst) mult);
			}
		| expr EDIVD expr
			{
				code((Inst) divv);
			}
		| expr EDIVE expr
			{
				code((Inst) divi);
			}
		| expr CMULT expr
			{
				code((Inst) multc);
			}
		| expr '*' expr
			{
				code((Inst) multp);
			}
		| expr '\\' expr
			{
				code((Inst) dive);
			}
		| expr '/' expr
			{
				code((Inst) divd);
			}
		| expr '@' expr
			{
				code((Inst) kron);
			}
		| expr '#' expr
			{
				code((Inst) epot);
			}
		| expr '^' expr
			{
				code((Inst) pot);
			}
		| expr '\''
			{
				code((Inst) tran);
			}
		| expr '\'' expr
			{
				code((Inst) multran);
			}
		| expr '[' linha ',' linha ']'  %prec dummy
			{
				code((Inst) matsub1);
			}
		| expr '[' ',' linha ']'       %prec dummy
			{
				code((Inst) matsub2);
			}
		| expr '[' linha ',' ']'       %prec dummy
			{
				code((Inst) matsub3);
			}
		| expr ':' expr
			{
				code((Inst) genind1);
			}
		| '-' expr %prec MENOSU
			{
				$$ = $2;
				code((Inst) matneg1);
			}
		| '(' linha pd
			{
				$$ = $2;
			}
		| expr GT expr
			{
				code((Inst) gt);
			}
		| expr GE expr
			{
				code((Inst) ge);
			}
		| expr LT expr
			{
				code((Inst) lt);
			}
		| expr LE expr
			{
				code((Inst) le);
			}
		| expr EQ expr
			{
				code((Inst) eq);
			}
		| expr NE expr
			{
				code((Inst) ne);
			}
		| expr AND expr
			{
				code((Inst) and);
			}
		| expr OR expr
			{
				code((Inst) or);
			}
		| NOT expr
			{
				$$ = $2;
				code((Inst) not);
			}
		;

defn:		FUNC procname { (($2)->tipo)  = FUNCTION;indef = 1; nivel++;
				sserro = $2; ssninst=n_inst;
			      }
			'(' ')' stmtcom
		{  
			code((Inst) procret); define($2); indef=0; --nivel;
		}
		| PROC procname { (($2)->tipo)  = PROCEDURE; indef = 1; nivel++;
				  sserro = $2; ssninst=n_inst;
				}
			'(' ')' stmtcom
		{ 
			code((Inst) procret); define($2); indef=0; --nivel;
		}
		;

procname:	ID
		| FUNCTION
		| PROCEDURE
		;


arglist:	/* nada */		{ $$ = 0; }
		| expr			{ $$ = 1; }
		| arglist ',' expr	{ $$ = $1 + 1; }
		;

cmds		: GRAVE expr 
			{
				code((Inst) grave1);
			}
		| GRAVE expr  '(' STRING ')'
			{
				code2((Inst) varpshs, (Inst) $4);
				code((Inst) grave2);
			}
		| GRAVE expr STRING 
			{
				code2((Inst) varpshs, (Inst) $3);
				code((Inst) grave3);
			}
		| GRAVE expr STRING '(' STRING ')'
			{
				code2((Inst) varpshs, (Inst) $3);
				code2((Inst) varpshs, (Inst) $5);
				code((Inst) grave4);
			}
		| TOLER '=' NUMERO
			{
				code3((Inst) constpush, (Inst) $3,(Inst) toler);
			}
		| ASSUMA listaopt
			{
			}
		| CMD STRING
			{
				code3((Inst) varpshs,(Inst) $2,(Inst) execar1);
			}
		| ANOTE STRING 
			{
				code3((Inst) varpshs,(Inst) $2,(Inst) anote1);
			}
		| ANOTE PULE STRING 
			{
				code3((Inst) varpshs,(Inst) $3,(Inst) anote2);
			}
		| ANOTE STRING PULE
			{
				code3((Inst) varpshs,(Inst) $2,(Inst) anote2);
			}
		| LIBTEMP   
			{
				code((Inst) libtemp);
			}
		| FIM   
			{
				code((Inst) fim);
			}
		| ID ',' ID '=' AUTO '(' expr pd 
			{
				code2((Inst) varpshn, (Inst) $1);
				code2((Inst) varpshn, (Inst) $3);
				code((Inst) meigen1);
			}
		| ID ',' ID '=' GS '(' expr pd 
			{
				code2((Inst) varpshn, (Inst) $1);
				code2((Inst) varpshn, (Inst) $3);
				code((Inst) gs1);
			}
		| ID ',' ID ',' ID '=' DVS '(' expr pd 
			{
				code2((Inst) varpshn, (Inst) $1);
				code2((Inst) varpshn, (Inst) $3);
				code2((Inst) varpshn, (Inst) $5);
				code((Inst) mdvs1);
			}
		| IMPRIME seq 
			{
			}
		;

cmds1		:
		INFO pv
			{
				info();
			}
		| ID '=' pv
			{
				libsim($1);
			}
		| LISTE pv
			{
				liste();
			}
		| LIMPE pv   
			{
				limpe();
			}
		| LIMPE FUNCAO pv
			{
				limpe_f();
			}
		| TREX pv 
			{
				settrex();
			}
		| DIR pv
			{
#ifdef MSDOS
				strcpy(temp, "dir /w ");
				if (_diretorio[0] != '\0') {
					strcat(temp, _diretorio);
					if (temp[strlen(temp)-1] != '\\')
						strcat(temp, "\\");
					strcat(temp, "*.hdr");
				}
				else
					strcat(temp, "*.hdr");
				system(temp);
#else
#ifdef VAXVMS
				system("dir *.hdr");
				printf("\n");
#else
				strcpy(temp, "ls ");
				if (_diretorio[0] != '\0') {
					strcat(temp, _diretorio);
					if (temp[strlen(temp)-1] != '/')
						strcat(temp, "/");
					strcat(temp, "*.hdr");
				}
				else
					strcat(temp, "*.hdr");
				system(temp);
#endif
#endif
			}
		;


matriz		: '{' linhas cd
			{
				$$ = $2;
			}
		;



linhas		: linha		/* primeira linha */
			{
				$$ = $1;
			}
		| linhas ',' linha /* linhas subsequentes */
			{
				code((Inst) vconca1);
			}
		;



pv		: ';'
			{
				yyerrok;
			}
		;



pd		: ')'
			{
				yyerrok;
			}
		;



cd		: '}'
			{
				yyerrok;
			}
		;
listab		: expr {
		}
		| listab ',' expr {
		}
		;

seq		: item
			{
			}
		| seq item
			{
			}
		;


item		: expr NUMERO ':' NUMERO '(' STRING ')'
			{
				code2((Inst) constpush, (Inst) $2);
				code2((Inst) constpush, (Inst) $4);
				code3((Inst) varpshs,(Inst) $6,(Inst) imprim7);
			}
		| expr '$' NUMERO ':' NUMERO '(' STRING ')'
			{
				code2((Inst) constpush, (Inst) $3);
				code2((Inst) constpush,(Inst) $5);
				code3((Inst) varpshs,(Inst) $7,(Inst) imprim6);
			}
		| expr  NUMERO ':' NUMERO
			{
				code2((Inst) constpush,(Inst) $2);
				code3((Inst) constpush,(Inst) $4,(Inst) imprim5);
			}
		| expr '$' NUMERO ':' NUMERO
			{
				code2((Inst) constpush,(Inst) $3);
				code3((Inst) constpush,(Inst) $5,(Inst) imprim4);
			}
		| expr  '(' STRING ')'
			{
				code3((Inst) varpshs,(Inst) $3,(Inst) imprim3);
			}
		| expr  '$' '(' STRING ')'
			{
				code3((Inst) varpshs,(Inst) $4,(Inst) imprim2);
				
			}
		| expr '$'
			{
				code((Inst) imprimr);
			}
		| expr
			{
				code((Inst) imprim1);
			}
		;

listaopt: 	/* NADA */
			{
				code((Inst) setdef);
			}
        	| item1
			{
			}
		| listaopt item1
			{
			}
		;
item1		: TOLER '=' NUMERO
			{
				code3((Inst) constpush, (Inst) $3,(Inst) toler);
			}
		| SEMENTE '=' NUMERO
			{
				code3((Inst) constpush,(Inst) $3,(Inst)setsem);
			}
		| COLUNA '=' NUMERO
			{
				code3((Inst) constpush,(Inst) $3,(Inst)setcol);
			}
		| SAIDA '=' STRING
			{
				code3((Inst) varpshs,(Inst) $3,(Inst)setsai);
			}
		| DIR   '=' STRING
			{
				code3((Inst) varpshs,(Inst) $3,(Inst)setdir);
			}
		| CONFIG '=' STRING
			{
				code3((Inst) varpshs,(Inst) $3,(Inst)setimp);
			}
		;
%%

		/* fim da gramatica */

