#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "pcsgbd.h"

#include "cm_cm01.h"

#if defined(ULTRIX) | defined(VAXVMS)
#define	MAXRAND		2147483647.
#else
#define	MAXRAND		RAND_MAX
#endif

#ifndef VAXVMS
	extern void srand();
#endif


static char *sccsid = "@(#)criarnd.c	3.3	(NTIA/cm)	95/05/19";

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Cria uma matriz com nmeros aleatrios com a dimenso armazenada nos dois prximos
	itens da pilha de execuo.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/



void criarnd()
{

#ifdef EDIX
	double *dp;
#endif
	
	extern int rand();
	Datum d1, d2;
	int i, j;
	int nc, nl;
	Simbolo_t *sr;
	double valor;

	d2 = pop();
	d1 = pop();

	if (((NLINS( (Simbolo_t *) d1) *NCOLS( (Simbolo_t *) d1) ) > 1) ||
	    ((NLINS( (Simbolo_t *) d2) *NCOLS( (Simbolo_t *) d2) ) > 1) ) {

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("CRIARND","argumento nao e' escalar");
*** */
		execerro(PegaMsg(3104),(char *) 0);
	}

	nl = (int) ( DADOij( (Simbolo_t *) d1, 0, 0));
	nc = (int) ( DADOij( (Simbolo_t *) d2, 0, 0));

	if (nl <= 0 || nc <= 0)

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("CRIARND","nao posso criar matriz desta dimensao");
*** */
		execerro(PegaMsg(3104),(char *) 0);

	sr = faztemp(nl, nc);	


	for(i=0; i < nl; i++) {	
		for(j=0; j < nc; j++) {	
			valor = ((double) rand()) / MAXRAND;

#ifdef EDIX
			dp = &(DADOij(sr, i, j));
			*dp= valor;
#else	
			DADOij(sr,i,j) = valor;
#endif	
		}
	}

	push((Datum) sr);

	tentaLibSim((Simbolo_t *) d1);
	tentaLibSim((Simbolo_t *) d2);
}
