#include <stdio.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include "pcsgbd.h"
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Grava uma matriz no disco.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

void grave(x, s1, s2, fl_grave)
Simbolo_t *x;
char *s1;
char *s2;
int  fl_grave;
{
	ARQ     *parq;
	char    nomearq[MAXDIR];
	char    nome[MAXDIR];
	int     i, j, k, l ;
	long	ret;
	char    *obser;
	char    **obs;
	char    c;
	extern char _diretorio[MAXDIR];
	char 	tmpbuf[128]; /* Luciana */

	char namelock[TAMSTR];

	if (fl_grave == 3 || fl_grave == 4) {
		char temp[MAXDIR];

		strncpy(nome, s1, 63);
		nome[63] = '\0';

		j = 1;
		for(i=0; i < (int) strlen(nome); i++) {
			c = nome[i];
			if (c == '.' || c == '/' || c == '\\' || c == ':') {
				j = 0;
				break;
			}
		}
		if (j) {
			if (_diretorio[0] != '\0') {
				strcpy(temp, _diretorio);
#ifdef MSDOS
				if (temp[strlen(temp)-1] != '\\')
					strcat(temp,"\\");
#else
				if (temp[strlen(temp)-1] != '/')
					strcat(temp,"/");
#endif
				strcat(temp, nome);
				(void) trim(temp, nomearq);
			}
			else {
				(void) trim(nome, nomearq);
			}
		}
		else {
			(void) trim(nome, nomearq);
		}

		i =  strlen(nomearq)-1;

		c = nomearq[i];
		if (!isalnum(c)  && c != '_' && c != '-') {

/* *** Padroniz. msg erro - Luciana 21/12/94
			execerro("GRAVE", "Falta nome de arquivo ou invalido");
*** */
			execerro(PegaMsg(3105),(char *) 0);
		}
	}
	else {
		if (_diretorio[0] != '\0') {
			strcpy(nome, _diretorio);
			strncpy(nomearq, NOME(x), 8);
			nomearq[8] = '\0';
#ifdef MSDOS
			if (nome[strlen(nome)-1] != '\\')
				strcat(nome, "\\");
#else
			if (nome[strlen(nome)-1] != '/')
				strcat(nome, "/");
#endif
			strcat(nome, nomearq);
			(void) trim(nome, nomearq);
		}
		else {
			strncpy(nomearq, NOME(x), 8);
			nomearq[8] = '\0';
		}
	}

	/* Bloqueio do arquivo de saida */
	strcpy(namelock,nomearq);
	strcat(namelock,".dat");

	/* Criacao do arquivo de saida */
	if ((ret = (long) (parq = cria_arq(nomearq))) < 0L && ret > -4L) {

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro(nomearq, ": nao foi possivel criar arquivo");
*** */
		execerro(PegaMsg(3105),(char *) 0);
	}
	obs = (char **) emalloc((OBSSIZE) * sizeof(char *));

	k = NCOLS(x);
	for (i = 1; i <= k; ++i) {
		if (fl_grave == 2 || fl_grave == 4) {
			strncpy(nome, word_k(s2, i, ","), 8);
			nome[8] = '\0';
			if (nome[0] == '\0') 
				sprintf(nome, "Col%d", i);
		}		
		else { 
			sprintf(nome, "Col%d", i);
		}

		if (def_var(parq, nome, 'n') == -1) {
			if (fech_arq(parq) < 0) {
				fprintf(stderr,PegaMsg(1011),nomearq);
				setOSstdin();
#ifdef MEM_DEBUG
				if (Mem_Used() != 0) {
					printf("*** Lista de memoria nao esta' vazia ***\n");
					Mem_Store("cm");
					exit(2);
				}
#endif

				exit(2);
			}

			efree( (char *) obs);

/* *** Padroniz. msg erro - Luciana 21/12/94
			execerro(NOME(x), ": matriz contem muitas colunas");
*** */
			execerro(PegaMsg(1103),(char *) 0);
		}
	}

	l = NLINS(x);
	for (i = 0; i < l; ++i) {
		obser = (char *) &obs[MAXVAR];
		for (j = 0; j < k; ++j) {
			obs[j] = obser;
			(void) ftoa(DADOij(x, i, j), 15, obser);
			obser += (strlen(obser) + 1);
		}
		if (grav_obs(parq, obs) < 0L) {
			if (fech_arq(parq) < 0) {
				fprintf(stderr,PegaMsg(1011),nomearq);
				setOSstdin();
#ifdef MEM_DEBUG
				if (Mem_Used() != 0) {
					printf("*** Lista de memoria nao esta' vazia ***\n");
					Mem_Store("cm");
					exit(2);
				}
#endif

				exit(2);
			}

			efree( (char *) obs);

/* *** Padroniz. msg erro - Luciana 21/12/94
			execerro("nao consegui gravar matriz ", NOME(x));
*** */
			sprintf(tmpbuf,PegaMsg(5049),NOME(x));
			execerro(tmpbuf, (char *) 0);
		}
	}
	if (fech_arq(parq) < 0) {
                fprintf(stderr,PegaMsg(1011),nomearq);
                setOSstdin();
#ifdef MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("cm");
                        exit(2);
                }
#endif

                exit(2);
        }

	printf(" Arquivo %s criado. \n", nomearq);
	efree( (char *) obs);
}

/* -----------------------------------------------------------------------*/
/* Funcao: retorna palavra 'n' de uma string a partir de um conj. de      */
/*         separadores							  */
/* -----------------------------------------------------------------------*/
/* Parametros:								  */
/*	   char *y ---> Palavra de entrada				  */
/*	   int  k  ---> Posicao desejada 				  */
/*	   char *l_s--> Lista de separadores 				  */
/* -----------------------------------------------------------------------*/
/* Retorna:  a palavra selecionada					  */
/* -----------------------------------------------------------------------*/

char *word_k(y, k, l_s)
char *y; 
int  k;
char *l_s;
{
	static char temp[257];
	int i, l, m;

	temp[0] = '\0';
	l = 1;
	m = 0;
	for(i=0; i <= (int) strlen(y); ++i) {
		if (y[i] == l_s[0]) {
			if (l == k) {
				temp[m] = '\0';
				return(temp);
			}
			l++;
			m = 0;
		}
		else {
			if (y[i] != ' ')
				temp[m++] = y[i];
		}
	}
	return (temp);
}

/* -----------------------------------------------------------------------*/
/* Funcao: Retira os brancos de uma string
/* -----------------------------------------------------------------------*/
/* Parametros:								  */
/*	   char *x ---> STRING						  */
/* -----------------------------------------------------------------------*/
/* Retorna:  STRING sem brancos
/* -----------------------------------------------------------------------*/

void trim(s, s1)
char *s;
char *s1;
{
	int  i;
	int  k;

	k = 0;
	for(i=0;  i <  (int) strlen(s); i++) {
		if (s[i] != ' ')
			s1[k++] = s[i];
	}
	s1[k]  = '\0';
}

