#ifdef ULTRIX
# include <cursesX.h>
#else
# include <stdio.h>
# include <malloc.h>
# ifdef i486
#  include <ncurses.h>
# else
#  include <curses.h>
# endif
#endif

# include <stdlib.h>

#include <string.h>

#include <signal.h>
#include <ctype.h>

#include "video.h"
#include "info.h"
#include "pcsgbd.h"
#include "cm_cm01.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

#define   MAXLINHA 400
#define   MAXMEM   15360
 
WINDOW * win;

static char *sccsid = "@(#)info.c	3.9	(NTIA/cm)	95/05/26";

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Mdulo para gerao de info online do CM.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

static char s[512];

extern char *emalloc();
extern void efree();

static char *AREA;
static char *p;
static char *linha[MAXLINHA];

static char *modulos[] = {
		0,
	        "cm1",
	        "cm2",
		"cm3",
		"cm4",
		"cm5"
	};

FILE *fd;
int   fdi; /* diz se arquivo esta aberto */

int linhasup = 0;
int linhainf = 23;
int colunae = 0;
int colunad = 79;
int memusa;

extern int nlins;
extern int ncols;

void info()
{
	int c;
	int cc;
	int i;
	int nlin,ii,lcor;
	int fim;
	double porc;
	int loop;
	char *nome;
	char *ptr;

	AREA = (char *) emalloc(MAXMEM);
	
	linhainf = nlins - 1;
	colunad = ncols - 1;
	fdi     = 0;
	memusa  = 0;

	signal(SIGINT, minha_fn);

	initscr();
        win=newwin(LINES,COLS,0,0);
        wclear(win);

/*
	clear();
*/
	noecho();
	cbreak();

	linhainf = LINES - 1;

	keypad(win, TRUE);

	wrefresh(win);

	for (;;) {
		wclear(win);

		setvrev(win, TRUE);
		wmove(win,linhasup, colunae);
		putnchar(win, 79, ' ');
		mvwprintw(win, linhasup, colunae,"Informacoes sobre o CM");
		setvrev(win, FALSE);

		mvwprintw(win, linhasup+2, colunae,
			"Nomenclatura da sintaxe dos comandos:");
		mvwprintw(win, linhasup+4, colunae+6,
			"Expressoes indicadas entre os simbolos de menor");
		mvwprintw(win, linhasup+5, colunae+6,
			"(<) e maior (>) descrevem especificacoes que devem");
		mvwprintw(win, linhasup+6, colunae+6,
			"ser fornecidas pelo  usuario.  Comandos  expressos");
		mvwprintw(win, linhasup+7, colunae+6,
			"entre colchetes ([]) sao opcionais");

		mvwprintw(win, linhasup+ 9, colunae+11,
			" 0   Termina o Info");

		mvwprintw(win, linhasup+10, colunae+11,
			" 1   Sumario dos operadores numericos");

		mvwprintw(win, linhasup+11, colunae+11,
			" 2   Sumario dos operadores de comparacao e logicos");
		mvwprintw(win, linhasup+12, colunae+11,
			" 3   Sumario das funcoes");
		mvwprintw(win, linhasup+13, colunae+11,
			" 4   Sumario dos comandos");
		mvwprintw(win, linhasup+14, colunae+11,
			" 5   Funcoes e Procedimentos do usuario");

		setvrev(win, TRUE);
		wmove(win,linhainf, colunae);
		putnchar(win, 79, ' ');
		mvwprintw(win, linhainf, colunae,
		"       Entre o numero da opcao:");
		setvrev(win, FALSE);
l1:
#ifdef VAXVMS
		s[0] = '\0';
		wmove(win,linhainf, colunae+33);
		setvrev(win, TRUE);
		echo();
		getstr(s);
		noecho();
		setvrev(win, FALSE);
#else
		wrefresh(win);
		s[0] = '\0';

		while (pegares(s, 1, 2, linhainf, 33) != '\n')
			;
#endif
		c = atoi(s);

		if (c == 0) 
			break;

		if ( c < 0 || c > 5 ) {
			wmove(win,linhainf, colunae+33);
			setvrev(win, TRUE);
			wprintw(win,"                          Opcao invalida     ");
			setvrev(win, FALSE);

#ifndef VAXVMS
			wrefresh(win);
#endif

			goto l1;
		}

		else {
			wmove(win,linhainf, colunae+33);
			setvrev(win, TRUE);
			wprintw(win,"                                             ");
			setvrev(win, FALSE);

#ifndef VAXVMS
			wrefresh(win);
#endif
		}

		nome = vrArqPath(modulos[c], "PATH", ".inf");

		cc    = c;

		if (nome) {
			wclear(win);

			fd = fopen(nome,"r");
			if (fd == (FILE *) NULL) {
				set_video();
				fprintf(stderr,PegaMsg(5020),nome);
				setOSstdin();
#ifdef MEM_DEBUG
				if (Mem_Used() != 0) {
					printf("*** Lista de memoria nao esta' vazia ***\n");
					Mem_Store("cm");
					exit(2);
				}
#endif

				exit(2);
			}

			fdi = 1;

			p  = AREA;
			memusa = 0;
			ii = 0;

			linha[0] = p;

			while(le_linha() != EOF ) {
				if ((ii+1) < MAXLINHA)
					linha[++ii] = p;
				else
					break;
			}

			nlin = ii-1;
			lcor = 0;
			fim = LINES - 5;

			c = ' ';

			setvrev(win, TRUE);
			wmove(win,linhasup, colunae);
			putnchar(win, 79, ' ');
			mvwprintw(win, linhasup, colunae, modulos[cc]);
			wmove(win,linhainf, colunae);
			putnchar(win, 79, ' ');
			mvwprintw(win, linhainf, colunae,
				"Tecle : P)roxima  A)nterior  F)im   :");
			setvrev(win, FALSE);

			while ( (c != 'F') && (c != 'f') ) {
				for (i = 2; i < LINES - 1; ++i) {
					wmove(win,linhasup+i, colunae);
					wclrtoeol(win);
				}

				i = 2;

				for ( ii=lcor ; (ii<=fim)&&(ii<=nlin) ; ii++) {
					mvwprintw(win, linhasup+i, colunae,
						linha[ii]);
					++i;
				}

				if ( fim >= nlin ) 
						fim = nlin;

				porc = ((double) fim/(double) nlin)*100.0;
				sprintf(s,"%5.1f",porc);
				strcat(s, " %%");
				setvrev(win, TRUE);
				mvwprintw(win, linhasup,colunae+71, s);
				setvrev(win, FALSE);
				wmove(win,linhainf, colunae+38);
				wrefresh(win);

				loop = 1;

				while (loop) {
					c = le_tecla();

					switch (c) {

					case 'A':
					case 'a':

						if (lcor > 0) {
							fim  = lcor -  1;
							lcor = lcor - LINES + 4;
							loop = 0;
						}
						else
							beep();

						break;

					case 'P':
					case 'p':

						if (fim < nlin) {
							lcor = ii;
							fim  = ii + LINES - 5;
							loop = 0;
						}
						else
							beep();

						break;

					case 'F':
					case 'f':

						loop = 0;

						break;

					default :

						beep();

						break;
					}
				}
			}

			if (fclose(fd) == EOF) {
				set_video();
				fprintf(stderr,PegaMsg(5005),nome);
				setOSstdin();
#ifdef MEM_DEBUG
				if (Mem_Used() != 0) {
					printf("*** Lista de memoria nao esta' vazia ***\n");
					Mem_Store("cm");
					exit(2);
				}
#endif

				exit(2);
			}

			fdi = 0;
		}

		else {
			setvrev(win, TRUE);
			mvwprintw(win, linhainf, colunae+59,
				"Menu nao encontrado");
			mvwprintw(win, linhainf, colunae+33, " ");
			wrefresh(win);
			setvrev(win, FALSE);
			goto l1;
		}
	}

	setvrev(win, FALSE);

/*
	if (!(ptr = getenv("TERM")) || !isWinTerm(ptr)) {
		wclear(win);

		wrefresh(win);
	}
*/

	wclear(win);
	wrefresh(win);
	delwin(win);

	echo();
	refresh();
	
	endwin();

	setOSstdin();
	signal(SIGINT, intcatch);
	efree( (char *) AREA);
}

void minha_fn(sig)
int sig;
{
	setvrev(win, FALSE);


/*
	if (!getenv("TERM") || strcmp(getenv("TERM"), "sun-cmd")) {
		wclear(win);

		wrefresh(win);
	}
*/

	wclear(win);
	wrefresh(win);
	delwin(win);

	echo();
	refresh();

	endwin();

	setOSstdin();
	efree( (char *) AREA);

	if (fdi) {	/* Existe arquivo aberto */
		if (fclose(fd) == EOF) {
			set_video();
			fprintf(stderr,PegaMsg(5005),"");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(2);
			}
#endif

			exit(2);
		}
	}


	signal(SIGINT, intcatch);

	execerro("info interrompido pelo usuario", (char *) 0);
}

int le_linha()
{
	int c;
	int  i;

	while( ((c = getc(fd)) != '\n') && (c != EOF) )  {
		if ( c == '\t' ) {
			for (i=1; i<=5 ; i++) {
				*p = ' ';
				p++;
				memusa++;

				if (memusa >= MAXMEM - 2) {
					*p = '\0';
					p++;
					return(EOF);
				}
			}
		}
		else {
			*p = (char) c;
			p++;
			memusa++;

			if (memusa >= MAXMEM - 2) {
				*p = '\0';
				p++;
				return(EOF);
			}
		}
	}

	*p = '\0';
	p++;
	memusa++;

	if (memusa >= MAXMEM - 2) {
		*p = '\0';
		p++;

		return(EOF);
	}

	return(c);
}



char *nmalloc(id, size)
int id;
unsigned int size;
{
	char*q;

	q = (char *) malloc((PATIPO) (size+1));	/* alloc user memory */

	if (q == (char *) NULL) {
		setOSstdin();

/* *** Padroniz. msg erro - Luciana 21/12/94
		execerro("Memoria disponivel esgotada ", "info");
*** */
		execerro(PegaMsg(1039),(char *) 0);
	}

	return (q);
}

void nfree(id, pointer)
int id;
char *pointer;
{
	free((ALTIPO) pointer);
}

