#include  <stdio.h>
#include  <math.h>
#include "pcsgbd.h"

#ifndef  EXTVAR
#define  EXTVAR
#endif

#include "cm_cm01.h"

#ifdef MSDOS
# include "y_tab.h"
#else
#ifdef VAXVMS
#include "y_tab.h"
#else
# include "y.tab.h"
#endif
#endif

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Inicializa o CM. Entre as vrias atividades realizadas, est a criao e inicializao
	da tabela de smbolos uilizada pelo CM.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

		/* comandos */
static struct {
	char *nome;
	int tkval;
} cmds[] = {
	"console",	CONSOLE,
	"info",		INFO,
	"liste",	LISTE,
	"limpe",	LIMPE,
	"funcao",	FUNCAO,
	"fim",		FIM,
	"trex",		TREX,
	"grave",	GRAVE,
	"leia",		LEIA,
	"anote",	ANOTE,
	"cmd",		CMD,
	"dir",		DIR,
	"exec",		EXEC,
	"auto",		AUTO,
	"gs",		GS,
	"dvs",		DVS,
	"imprime",	IMPRIME,
	"cata",		CATA,
	"fprob",	FPROB,
	"finv",		FINV,
	"xprob",	XPROB,
	"xinv",		XINV,
	"tinv",		TINV,
	"tprob",	TPROB,
	"perd",		PERD,
	"onde",		ONDE,
	"bdiag",	BDIAG,
	"criamat",	CRIAMAT,
	"criarnd",	CRIARND,
	"contagem",	CONTAGEM,
	"pule",		PULE,
	"assuma",	ASSUMA,
	"coluna",	COLUNA,
	"saida",	SAIDA,
	"semente",	SEMENTE,
	"config",	CONFIG,
	"toler",	TOLER,
	"libtemp",	LIBTEMP,
	0,		0,
};

		/* intrinsicos */
static struct {
	char *nome;
	Simbolo_t *(*matfun)();  /* ponteiro p/ fcn que retorna ptr p/ simb */
} intrins[] = {
	"sin",		mSin,
	"cos",		mCos,
	"atan",		mAtan,
	"abs",		mAbs,
	"int",		mInt,
	"inv",		mInv,
	"log",		mLog,
	"log10",	mLog10,
	"exp",		mExp,
	"sqrt",		mSqrt,
	"nlin",		mNlin,
	"ncol",		mNcol,
	"ident",	mIdent,
	"diag",		mDiag,
	"vdiag",	mVdiag,
	"delin",	mDesign,
	"max",		mMax,
	"min",		mMin,
	"soma",		mSum,
	"squad",	mSsq,
	"lsoma",	mLinsum,
	"csoma",	mColsum,
	"lsquad",	mLinssq,
	"csquad",	mColssq,
	"traco",	mTraco,
	"det",		mdet,
	"posto",	mposto,
	"cho",		mcho,
	"invp",		minvp,
	"ordem",	ordem,
	"vec",		mvetor,
	"uvec",		muvetor,
	"ninv",		ninv1,
	"nprob",	nprob1,
	0,		0,
};

static struct {
	char *name;
	int  kval;
} keywords[]= {
	"if",		IF,
	"else",		ELSE,
	"while",	WHILE,
	"se",		IF,
	"cc",		ELSE,
	"enquanto",	WHILE,
	"proc",		PROC,
	"func",		FUNC,
	"return",	RETURN,
	"retornar",	RETURN,
	0,		0,
};
Simbolo_t falso_no;
Simbolo_t *tabsimb;		/* tabela de simbolos */

/*
** Variaveis Globais
*/
FILE    *fsaida;        	/* Indica aonde sera' a saida */
char    _diretorio[MAXDIR];     /* Diretorio Default                      */
int     _colunas= 70;           /* Numero de Colunas para impressao       */
double  _toler_ = 1.e-12;       /* Tolerancia para criterio de num = zero */
int     fl_mis= 0;
int       parametro=0;  /* Flag que indica se e' parametro, para
                           instalado na tabela de simbolos como LOCAL */
int       argumento=0;  /* Flag que indica se esta dentro de uma funcao
                           para nao ser desinstalado da tabela de simbolos */

void init()			/* instale comandos e intrinsicos */
{
	int i;
	Simbolo_t *sp;

	tabsimb = &falso_no;   /* tabela de simbolos */

	falso_no.nome = "!falso_no!";
	falso_no.tipo = 0;
	falso_no.u.val = (Matriz_t *) 0;
	falso_no.proximo = (struct Simbolo *) 0;
	falso_no.previo = (struct Simbolo *) 0;

	for (i = 0; keywords[i].name; ++i)
		instale(keywords[i].name, keywords[i].kval, (Matriz_t *) 0);

	for (i = 0; cmds[i].nome; i++)
		instale(cmds[i].nome, cmds[i].tkval, (Matriz_t *) 0);

	for (i = 0; intrins[i].nome; i++) {
		sp = instale(intrins[i].nome, INTRINS, (Matriz_t *) 0);
		sp->u.fcn = intrins[i].matfun;
	}

	instale("", 9999, (Matriz_t *) 0);
}

/*
** Codigos incluidos para possibilitar  a  montagem de libcm sem a inclusao
** do arquivo initcode.c:  Sonia - 27/03/95
*/
void tentaLibSim(d)
Simbolo_t *d;
{
        if ((TIPO(d)==TEMP) && (argumento == 0))
                libsim(d);
}
 
Simbolo_t *nprob1(d1)
Simbolo_t *d1;
{
        double p1;
        Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
        double *dp;
#endif
 
        if (NLINS(d1) > 1 || NCOLS(d1) > 1)
 
/* *** Padroniz. msg erro - Luciana 21/12/94
                execerro("parametro  1 tem que ser escalar", (char *) 0);
*** */
                execerro(PegaMsg(3111), (char *) 0);
 
        p1 = DADOij(d1,0,0);
 
#ifdef EDIX
        dp = &(DADOij(sr,0,0));
        *dp = nprob(p1);
#else
        DADOij(sr,0,0) = nprob(p1);
#endif
 
        return sr;
 
}

Simbolo_t *ninv1(d1)
Simbolo_t *d1;
{
        double p1;
        Simbolo_t *sr = faztemp(1,1);
#ifdef EDIX
        double *dp;
#endif
 
        if (NLINS(d1) > 1 || NCOLS(d1) > 1)
 
/* *** Padroniz. msg erro - Luciana 23/12/94
                execerro("parametro 1 tem que ser escalar", (char *) 0);
*** */
                execerro(PegaMsg(3110), (char *) 0);
 
        p1 = DADOij(d1,0,0);
 
        if (p1 < 0.0 || p1 > 1.0)
                execerro(PegaMsg(3106), (char *) 0);
 
#ifdef EDIX
        dp = &(DADOij(sr,0,0));
        *dp = ninv(p1);
#else
        DADOij(sr,0,0) = ninv(p1);
#endif
 
        return sr;
 
}

/* --------------------------------------------------------------
** Funcao: Fuzz
**         Teste dois numeros, em relacao a uma precisao
**         exemplo:
**              a = 1.000000000001;
**              b = 1.000000000002;
**              toler = 1.e-12;
**              a seria considerado igual a b
**
**              retorno: 1. se  a > b
**                      -1. se  a < b
**                       0. se  a = b
** --------------------------------------------------------------
*/
 
int fuzz(d1,d2)
double d1, d2;
{
        double f1, f2;
        extern double _toler_;
 
 
        f1 = d1;
 
        if (f1 < 0.)
                f1 = -f1;
 
        f2 = d2;
 
        if (f2 < 0.)
                f2 = -f2;
 
        if (f2 > f1)
                f1 = f2;
 
        if (fabs(f1) >= 1.0)
                f1 *= _toler_;
        else
                f1 = _toler_;
 
        if (d1 > d2) {
                if ((d2+f1) >= d1)
                        return(0);
 
                return(1);
        }
 
        if ((d1+f1) >= d2)
                return(0);
 
        return(-1);
}
 
