#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "pcsgbd.h"
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Funo responsvel pela leitura de uma matriz gravada em disco.


Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern int fl_mis;

Simbolo_t *leia(x, id, op, ops, opn )
char *x;
char *id;	/* Variavel de teste usada no token ONDE */
int  op;	/* 0 -> nao existe token ONDE */
		/* 1 -> EQ : ==  */
		/* 2 -> GE : >=  */
		/* 3 -> GT : >   */
		/* 4 -> LE : <=  */
		/* 5 -> LT : <   */
		/* 6 -> NE : !=  */
char *ops;	/* Valor de id (tipo string) a ser testado, se for o caso */
double opn;     /* Valor de id (tipo numerico) a ser testado, se for o caso */
{
	ARQ *parq;
	VAR *ivar;
	int nc, n, i, j, n1;
	long ret;
	char token[256];
	char tmpbuf[128];
	Simbolo_t *sr, *stemp, *linha;
	char **obs;
	int  *v;
	int  jonde;		/* posicao da variavel id no arquivo NTIA */
	int  leu_primeira;	/* primeira observacao valida */
	int  resultado;		/* teste de comparacao do token ONDE satisfeito */

	char	namelock[TAMSTR];

	extern char _diretorio[MAXDIR];

#ifdef EDIX
	double *dp;
#endif

	n1 = 0;
	nc = 0;

	obs = (char **) emalloc((OBSSIZE) * sizeof(char *));
	v   = (int *)   emalloc((MAXVAR)  * sizeof(int));

	pegtok(x,' ',token, &n1);

	if (_diretorio[0] != '\0') {
		char c;
		char temp[256];
		j = 1;

		for(i=0; i < (int) strlen(token); i++) {
			c = token[i];
			if (c == '.' || c == '/' || c == '\\' || c == ':') {
				j = 0;
				break;
			}
		}
		if (j) {
			strcpy(temp, _diretorio);
#ifdef MSDOS
			if (temp[strlen(temp)-1] != '\\')
				strcat(temp,"\\");
#else
			if (temp[strlen(temp)-1] != '/')
				strcat(temp,"/");
#endif
			strcat(temp, token);
			(void) trim(temp, token);
		}
	}

	/* Bloqueio do arquivo a ser lido */
	strcpy(namelock,token);
	strcat(namelock,".dat");

	/* Abertura do arquivo de entrada */
	if ((ret = (long) (parq = abre_arq(token,0,1))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("Nao consegui abrir arquivo ", token);
*** */
		sprintf(tmpbuf,PegaMsg(1034),token);
		execerro(tmpbuf, (char *) 0);
	}

	ivar = parq -> pvar; 
	n = parq -> nvar;

	if (pegtok(x,'=',token, &n1) != 0) {

		if (strcmpi(token,"var") != 0) {

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("LEIA","Erro de Sintaxe");
*** */
			execerro(PegaMsg(3116), (char *) 0);
		}

		if ((i=pegtok(x,' ',token, &n1)) != 0) {
			while(i != 0 || strcmpi(token, ",") == 0 ) {
				j = veri_var(parq, token);
				if (j < 0) {
					fprintf(stderr,PegaMsg(1062));
					setOSstdin();
#ifdef MEM_DEBUG
					if (Mem_Used() != 0) {
						printf("*** Lista de memoria nao esta' vazia ***\n");
						Mem_Store("cm");
						exit(2);
					}
#endif

					exit(2);
				}

				if ((ivar+j)-> tipo == 'n')
					v[nc++] = j;
				else

/* *** Padroniz. msg erro - Luciana 23/12/94
					execerro("Variavel nao existe ou nao e' numerica. ",token);
*** */
					execerro(PegaMsg(3117), (char *) 0);
				i = pegtok(x,' ',token, &n1);
			}
		}
	}
	else {
		for (i = 0, nc = 0; i < n; ++i) {
			if ((ivar++) -> tipo == 'n') {
				v[nc++] = i;
			}
		}
	}

	if ( nc == 0) {
		if (fech_arq(parq) < 0) {
			fprintf(stderr,PegaMsg(1011),"");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(2);
			}
#endif

			exit(2);
		}


/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro( x, ": arquivo nao tem variaveis numericas");
*** */
		sprintf(tmpbuf,PegaMsg(1012),x);
		execerro(tmpbuf, (char *) 0);
	}


	if (op > 0) {	/* Existe o token ONDE */
		jonde = veri_var(parq, id); /* Posicao da variavel ID no arq. NTIA */
		if (jonde < 0) {
			fprintf(stderr,PegaMsg(1062));
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(2);
			}
#endif

			exit(2);
		}

	}

	sr = faztemp(1, nc);
	linha = faztemp(1, nc);
	leu_primeira = 0;

	l1:
	if (ler_obs(parq, obs) < 0L) {
		if (fech_arq(parq)) {
			fprintf(stderr,PegaMsg(1011),"");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("cm");
				exit(2);
			}
#endif

			exit(2);
		}


/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro(x, ": zero observacoes");
*** */
		sprintf(tmpbuf,PegaMsg(1004),x);
		execerro(tmpbuf, (char *) 0);
	}

	if (op == 0)
		resultado = 1; /* nao existe token ONDE */
	else
		resultado = ver_val_var(obs[jonde], op, ops, opn);

	if (resultado) {
		for (i = 0; i < nc; ++i) {

			if ((n=strcmpi(obs[v[i]],".")) != 0 || fl_mis) {
				leu_primeira = 1;
			
#ifdef EDIX
				dp = &(DADOij(sr, 0, i));
				*dp = atof(obs[v[i]]);
#else
				DADOij(sr, 0, i) = atof(obs[v[i]]);
#endif
				if (fl_mis && n == 0)
					fprintf(stderr,"Advertencia: Valor 'perdido' convertido para zero linha=%d coluna=%d\n",1,i+1);
			}
			else  {
				leu_primeira = 0;
				break;
			}
		}
	}
	if (leu_primeira == 0)
		goto l1;

	j = 1;
	while (ler_obs(parq,obs) >= 0L) {
		++j;

		if (op == 0)
			resultado = 1; /* nao existe token ONDE */
		else
			resultado = ver_val_var(obs[jonde], op, ops, opn);

		if (resultado) {
			for (i = 0; i < nc; ++i) {
				if ((n=strcmpi(obs[v[i]],".")) != 0 || fl_mis) {
#ifdef EDIX
					dp = &(DADOij(linha, 0, i));
					*dp = atof(obs[v[i]]);
#else
					DADOij(linha, 0, i) = atof(obs[v[i]]);
#endif
					if (fl_mis && n == 0)
						fprintf(stderr,"Advertencia: Valor 'perdido' convertido para zero linha=%d coluna=%d\n",j,i+1);
				}
				else
					break;
			}
			if (n != 0 || fl_mis)  {
				stemp = vconcat(sr, linha);
				libsim(sr);
				sr = stemp;
			}
		}
	}

	fl_mis = 0;
	if (fech_arq(parq) < 0) {
                fprintf(stderr,PegaMsg(1011),"");
                setOSstdin();
#ifdef MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("cm");
                        exit(2);
                }
#endif

                exit(2);
        }

	efree( (char *) obs);
	efree( (char *) v);
	libsim(linha);

	return sr;
}

int pegtok(s, c, s1, n)
char *s;
char c;
char *s1;
int  *n;
{
	int i;
	int j;
	int k;

	j = strlen(s);
	k = 0;

	if (*n == j)
		return(0);

	for(i= *n; i < j; i++) {		/* Tira brancos a esquerda */
		if (s[i] != ' ')
			break;
	}

	for(i=i; i < j; i++) {		/* Para quando encontrar 1 delimitador*/
		if (s[i] == c) {
			break;
		}
		else {
			if (s[i] != ' ')
				s1[k++] = s[i];
		}
	}
	s1[k] ='\0';
	if (i < j)
		*n = i + 1;
	else
		*n = i;
	return(1);
}

int ver_val_var(obs, op, ops, opn)
char *obs;	/* valor lido da variavel */
int  op;	/* operador de comparacao */
char *ops;	/* valor (tipo string) usado para teste de comparacao */
double opn;	/* valor (tipo numero) usado para teste de comparacao */
{
	switch(op) {

		case 1: /* EQ */
			if (ops != (char *) NULL) {
				if (strcmpi(ops, obs) == 0)
					return(1);
				else	
					return(0);
			}
			else {
				if (atof(obs) == opn)
					return(1);
				else
					return(0);
			}
			break;
		case 2: /* GE */
			if (ops != (char *) NULL) {
				if (strcmpi(obs, ops) >= 0 )
					return(1);
				else	
					return(0);
			}
			else {
				if (atof(obs) >= opn)
					return(1);
				else
					return(0);
			}
			break;
		case 3: /* GT */
			if (ops != (char *) NULL) {
				if (strcmpi(obs, ops) > 0 )
					return(1);
				else	
					return(0);
			}
			else {
				if (atof(obs) > opn)
					return(1);
				else
					return(0);
			}
			break;
		case 4: /* LE */
			if (ops != (char *) NULL) {
				if (strcmpi(obs, ops) <= 0 )
					return(1);
				else	
					return(0);
			}
			else {
				if (atof(obs) <= opn)
					return(1);
				else
					return(0);
			}
			break;
		case 5: /* LT */
			if (ops != (char *) NULL) {
				if (strcmpi(obs, ops) < 0 )
					return(1);
				else	
					return(0);
			}
			else {
				if (atof(obs) < opn)
					return(1);
				else
					return(0);
			}
			break;
		case 6: /* NE */
			if (ops != (char *) NULL) {
				if (strcmpi(obs, ops) != 0 )
					return(1);
				else	
					return(0);
			}
			else {
				if (atof(obs) != opn)
					return(1);
				else
					return(0);
			}
			break;
			
	}
}

