#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif
#include <stdio.h>
#include <string.h>

#include "pcsgbd.h"
#include "cm_cm01.h"

#ifdef MSDOS
# include "y_tab.h"
#else
#ifdef VAXVMS
#include "y_tab.h"
#else
# include "y.tab.h"
#endif
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Lista todo o contedo da tabela de smbolos.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/
extern Simbolo_t *tabsimb;	/* tabela de simbolos */
extern int n_inst;

void liste()
{
	Simbolo_t *sp;
	int n = 0;
	int t;
	long  tbytes, duplos = 0, t1, t2;
	int flagDefault;
	int ntemp = 0;

	for (sp = tabsimb; sp != (Simbolo_t *) 0; sp = PROXIMO(sp)) {
		if (((t=TIPO(sp)) == ID) || (debugflag ) ) {
			n++;
			t1 = (long) NLINS(sp);
			t2 = (long) NCOLS(sp);
			flagDefault = 0;

			if (debugflag) {
				printf("\n%-8.8s ", NOME(sp));

				if (	t == ID      || t == TEMP   ||
					t == LOCAL   || t == NUMERO ||
					t == NUMEROL || t == STRING ||
					t == STRINGL || t == INDEF  ||
					t == INDEFL) {

					printf(" [%ldx%ld]\t\t ---> %ld bytes ",
					t1,t2,(t1*t2*((long) sizeof(double))));
				}

				else
					printf(" [...]\t\t ---> ?????? ");

				switch(t) {

				case ID:

					printf(" ID");

					break;

				case TEMP:

					printf(" TEMP");

					break;

				case LOCAL:

					printf(" LOCAL");

					break;

				case NUMERO:

					printf(" NUMERO");

					break;

				case NUMEROL:

					printf(" NUMEROL");

					break;

				case STRING:

					printf(" STRING");

					break;

				case STRINGL:

					printf(" STRINGL");

					break;

				case INDEF:

					printf(" INDEF");

					break;

				case INDEFL:

					printf(" INDEFL");

					break;

				default:

					flagDefault = 1;
					printf(" %d", t);

					break;
				}
			}

			else  {
				printf("\n%-8.8s [%ldx%ld]\t\t ---> %ld bytes ",
				NOME(sp),t1,t2,(t1*t2*((long) sizeof(double))));
			}

			if (!flagDefault)
				duplos += t1 * t2;
		}

		if (TIPO(sp) == TEMP)
			++ntemp;
	}

	tbytes = duplos * ((long) sizeof(double));

	printf("\n\n%d matrizes ativas; %ld bytes usados\n", n, tbytes);

	if (debugflag)
		printf("%d matrizes temporarias.\n", ntemp);

	liste_f();
	liste_o();
	fflush(stdout);
}

void liste_f()
{
	Simbolo_t *sp;

	for (sp = tabsimb; sp != (Simbolo_t *) 0; sp = PROXIMO(sp))
		if ((TIPO(sp) == FUNCTION) || (TIPO(sp) == PROCEDURE)) {
			printf("\n%-8.8s   %-12.12s   ", NOME(sp),
			(TIPO(sp) == FUNCTION)? "FUNCAO":"PROCEDIMENTO" );
		}

	printf("\n\n%d Instrucoes de maquina \n\n", n_inst);
}

void liste_o() 
{
	extern double _toleri;
	extern char   _nomesai[MAXDIR];
	extern char   _diretorio[MAXDIR];
	extern int    _colunas;

	printf("\n\nOpcoes definidas:\n\n");
	printf("\tTolerancia:        \t%g\n", _toleri);
	printf("\tSaida Impressao:   \t%s\n", _nomesai);	
	printf("\tDiretorio corrente:\t%s\n", _diretorio);
	printf("\tLargura formulario:\t%d\n", _colunas);
}
