#include <stdio.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Calcula a diviso matricial de duas matrizes. Elemento a elemento.


Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *matdivd(x,y)			/* divide x / y */
Simbolo_t *x;
Simbolo_t *y;
{
	Simbolo_t *sr; 
#ifdef EDIX
	double *dp;
#endif

	switch (verdim(x,y)) {

	/*
	** matriz x e' um escalar
	*/

	case 1: 
		{
			int  numelem = NLINS(y) * NCOLS(y);
			double d = DADOij(x, 0, 0);
			int i;

			sr = faztemp(NLINS(y),NCOLS(y)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = DADOS(y)[i] / d;
#else
				DADOS(sr)[i] = DADOS(y)[i] / d;
#endif
			}

			break;
		}

	/*
	** matriz y e' um escalar
	*/

	case 2:
		{
			int  numelem = NLINS(x) * NCOLS(x);
			double d = DADOij(y, 0, 0);
			int i;

			sr = faztemp(NLINS(x),NCOLS(x)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = d / DADOS(x)[i];
#else
				DADOS(sr)[i] = d / DADOS(x)[i];
#endif
			}

			break;
		}

	/*
	** divisao direita matricial
	*/

	case 0:
	case 3: 
		if (NLINS(x) == NCOLS(x)) {
			/*
			** caso quadrado
			*/

			Simbolo_t *copyx;
			double *onelin;
			int *ipvt;
			int i, j;

			if (NCOLS(x) != NCOLS(y))
				conferro(x, y,"/");

			sr = faztemp(NLINS(y), NLINS(x));

			copyx = faztemp(NLINS(x),NCOLS(x));
			copmat(MATRIZ(copyx), MATRIZ(x));

			onelin = (double *) emalloc((unsigned int)(NCOLS(y) *
				sizeof(double)));

			ipvt = (int *) emalloc((unsigned int)(NLINS(x) *
				sizeof(int)));

			/*
			** primeiro fatore a matriz x
			*/

			if (sgefa(DADOS(copyx), NLINS(x), ipvt) >= 0) {
				efree((char *) ipvt);
				efree((char *) onelin);

/* *** Padroniz. msg erro - Luciana 23/12/94
				execerro("/: ", "matriz e' singular");
*** */
				execerro(PegaMsg(1074), (char *) 0);
			}

			/*
			** agora resolva para cada linha de y
			*/

			for (i = 0; i < NLINS(y); i++) {

				/*
				** faca uma copia (como coluna) dessa linha
				*/

				for (j = 0; j < NCOLS(y); j++)
					onelin[j] = DADOij(y,i,j);

				/*
				** resolva o sistema transposto
				*/

				sgesl(DADOS(copyx), NLINS(x), ipvt, onelin, 1);

				/*
				** copie a solucao para o simbolo resultado
				** tomando o cuidado de transpor
				*/

				for (j = 0; j < NCOLS(y); j++) {
#ifdef EDIX
					dp = &(DADOij(sr,i,j));
					*dp = onelin[j];
#else
					DADOij(sr,i,j) = onelin[j];
#endif
				}
			}

			tentaLibSim((Simbolo_t *) copyx);

			efree((char *) ipvt);
			efree((char *) onelin);
		}
		else {
			numerro = MATDIVDER;

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("erro de sintaxe", "(/)");
*** */
			execerro(PegaMsg(3085), (char *) 0);
		}

		break;
	}

	return sr;
}

