#include <stdio.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

static char *sccsid = "@(#)matdive.c	3.2	(NTIA/cm)	95/01/02";

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Calcula a diviso esquerda de matrizes.


Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *matdive(x,y)			/* divide x \ y */
Simbolo_t *x, *y;
{
	Simbolo_t *sr; 
#ifdef EDIX
	double *dp;
#endif

	switch (verdim(x,y)) {

	/*
	** matriz x e' um escalar
	*/

	case 1:
		{
			int  numelem = NLINS(y) * NCOLS(y);
			double d = DADOij(x, 0, 0);
			int i;

			sr = faztemp(NLINS(y),NCOLS(y)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = DADOS(y)[i] / d;
#else
				DADOS(sr)[i] = DADOS(y)[i] / d;
#endif
			}

			break;
		}

	/*
	** matriz y e' um escalar
	*/

	case 2:
		{
			int  numelem = NLINS(x) * NCOLS(x);
			double d = DADOij(y, 0, 0);
			int i;

			sr = faztemp(NLINS(x),NCOLS(x)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = d / DADOS(x)[i];
#else
				DADOS(sr)[i] = d / DADOS(x)[i];
#endif
			}

			break;
		}

	/*
	** divisao esquerda matricial
	*/

	case 0:
	case 3:
		if (NLINS(x) == NCOLS(x)) {
			/*
			** caso quadrado
			*/

			Simbolo_t *copyx;
			double *onecol;
			int *ipvt;
			int i, j;

			if (NLINS(x) != NLINS(y))
				conferro(x, y,"\\");

			sr = faztemp(NCOLS(x), NCOLS(y));

			copyx = faztemp(NLINS(x),NCOLS(x));
			copmat(MATRIZ(copyx), MATRIZ(x));

			onecol = (double *) emalloc((unsigned int) (NLINS(y) * sizeof(double)));
			ipvt = (int *) emalloc((unsigned int)(NLINS(x) * sizeof(int)));

			/*
			** primeiro fatore a matriz x
			*/

			if (sgefa(DADOS(copyx), NLINS(x), ipvt) >= 0) {
				efree((char *) ipvt);
				efree((char *) onecol);

/* *** Padroniz. msg erro - Luciana 23/12/94
				execerro("\\: ", "matriz e' singular");
*** */
				execerro(PegaMsg(1074), (char *) 0);
			}

			/*
			** agora resolva para cada coluna de y
			*/

			for (j = 0; j < NCOLS(y); j++) {
				/*
				** faca uma copia dessa coluna
				*/

				for (i = 0; i < NLINS(y); i++)
					onecol[i] = DADOij(y,i,j);

				sgesl(DADOS(copyx), NLINS(x), ipvt, onecol, 0);

				/*
				** copie a solucao para o simbolo resultado
				*/

				for (i = 0; i < NLINS(y); i++) {
#ifdef EDIX
					dp = &(DADOij(sr,i,j));
					*dp = onecol[i];
#else
					DADOij(sr,i,j) = onecol[i];
#endif
				}
			}

			tentaLibSim((Simbolo_t *) copyx);

			efree((char *) ipvt);
			efree((char *) onecol);
		}

		else {
			numerro = MATDIVEER;

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("erro de sintaxe", "(\\)");
*** */
			execerro(PegaMsg(3085), (char *) 0);
		}

		break;
	}

	return sr;
}

