#include <stdio.h>
#include "cm_cm01.h"

static char *sccsid = "@(#)matpot.c	3.1	(NTIA/cm)	94/10/24";

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	calcula a exponenciao matricial



Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


Simbolo_t *matpot(x,y)		/* exponenciacao matricial */
Simbolo_t *x;
Simbolo_t *y;
{
	int n = (int) DADOij(y, 0, 0);
	int nl = NLINS(x);
	Simbolo_t *aux1, *aux2, *aux3;

	if ( NLINS(y) != 1  || NCOLS(y) != 1  || NLINS(x) != NCOLS(x)) {
		numerro = MATPOTER;
		conferro(x, y, "^");
	}

	if (n == 0) {
		aux2 = mNlin(x);
		aux1 = mIdent(aux2);
		tentaLibSim(aux2);

		return aux1;
	}
	else
		if (n < 0) {
			aux3 = matneg(y);
			aux2 = matpot(x,aux3);
			aux1 = mInv(aux2);
			tentaLibSim(aux2);
			tentaLibSim(aux3);

			return aux1;
		}
		else
			if (n == 1) {
				Simbolo_t *sr = faztemp(nl,nl);
				copmat(MATRIZ(sr),MATRIZ(x));
				return sr;
			}
			else
				if (n == 2) {      /* e' mais barato assim... */
					Simbolo_t *sr = faztemp(nl,nl);
					multmat(DADOS(x), DADOS(x), DADOS(sr),
						nl, nl, nl);
					return sr;
				}
				else {
					/* aqui se da' o verdadeiro trabalho */
					Simbolo_t *bigy;
					Simbolo_t *bigz = faztemp(nl, nl);
					Simbolo_t *temp = faztemp(nl, nl);
					unsigned int bign = n;

					aux1 = mNlin(x);
					bigy = mIdent(aux1);
					tentaLibSim(aux1);

					copmat(MATRIZ(bigz),MATRIZ(x));

					for(; bign != 0; bign >>= 1) {
						if (bign & 01) {  /* impar */
							multmat(DADOS(bigz),
								DADOS(bigy),
								DADOS(temp),
								nl, nl, nl);
							copmat(MATRIZ(bigy),
								MATRIZ(temp));
						}
						multmat(DADOS(bigz),DADOS(bigz),
							DADOS(temp), nl, nl, 
							nl);
						copmat(MATRIZ(bigz),
							MATRIZ(temp));
					}

					tentaLibSim(bigz);
					tentaLibSim(temp);

					return bigy;
				}
}

