#include <stdio.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	retorna a soma duas matrizes  ou um escalar e uma matriz,
	dependendo das dimensoes das matrizes associadas aos simbolos
	apontados pelos argumentos x e y.



Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/



Simbolo_t *matsoma(x,y)
Simbolo_t *x, *y;
{
	Simbolo_t *sr; 
#ifdef EDIX
	double *dp;
#endif

	switch (verdim(x,y)) {

	/*
	** matrizes tem a mesma dimensao
	*/

	case 0:
		{
			int  numelem = NLINS(x) * NCOLS(x);
			int i;

			sr = faztemp(NLINS(x),NCOLS(x)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = DADOS(x)[i] + DADOS(y)[i];
#else
				DADOS(sr)[i] = DADOS(x)[i] + DADOS(y)[i];
#endif
			}

			break;
		}

	/*
	** matriz x e' um escalar
	*/

	case 1:
		{
			int  numelem = NLINS(y) * NCOLS(y);
			double d = DADOij(x, 0, 0);
			int i;

			sr = faztemp(NLINS(y),NCOLS(y)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = d + DADOS(y)[i];
#else
				DADOS(sr)[i] = d + DADOS(y)[i];
#endif
			}

			break;
		}

	/*
	** matriz y e' um escalar
	*/

	case 2:
		{
			int  numelem = NLINS(x) * NCOLS(x);
			double d = DADOij(y, 0, 0);
			int i;

			sr = faztemp(NLINS(x),NCOLS(x)); 

			for (i=0; i < numelem; i++) {
#ifdef EDIX
				dp = &(DADOS(sr)[i]);
				*dp = d + DADOS(x)[i];
#else
				DADOS(sr)[i] = d + DADOS(x)[i];
#endif
			}

			break;
		}

	/*
	** matrizes sao incompativeis
	*/

	case 3:
		numerro = MATSOMAER;
		conferro(x, y, "+");
	}

	return sr;
}

