#include <stdio.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Cria uma submatriz a partir de uma matriz de entrada e ndices de controle.


Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


Simbolo_t *matsubs(from, linds, cinds)
Simbolo_t *from, *linds, *cinds;
{
	int ls, le, cs, ce, tl, tc, nlsr, ncsr, i, j, slin, scol;
	Simbolo_t *sr, *aux;
#ifdef EDIX
	double *dp;
#endif

	if (linds == (Simbolo_t *) 0) {
		ls = 0;
		le = NLINS(from) - 1;
		nlsr = NLINS(from);
		tl = 1;
	}
	else {
		if (NLINS(linds) != 1)
			conferro(from, linds, "subscrito nao e' vetor linha");
		aux = mMin(linds);
		ls = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		aux = mMax(linds);
		le = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		nlsr = NCOLS(linds);
		tl = 0;
	}

	if (cinds == (Simbolo_t *) 0) {
		cs = 0;
		ce = NCOLS(from) - 1;
		ncsr = NCOLS(from);
		tc = 1;
	}
	else {
		if (NLINS(cinds) != 1)
			conferro(from, cinds, "subscrito nao e' vetor linha");
		aux = mMin(cinds);
		cs = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		aux = mMax(cinds);
		ce = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		ncsr = NCOLS(cinds);
		tc = 0;
	}

	if (ls < 0 || ls >= NLINS(from) || le < 0 || le >= NLINS(from))
		conferro(from, linds, "subscrito fora do intervalo");

	if (cs < 0 || cs >= NCOLS(from) || ce < 0 || ce >= NCOLS(from))
		conferro(from, linds, "subscrito fora do intervalo");


	sr = faztemp(nlsr, ncsr);

	for (i = 0; i < nlsr; i++) {
		slin = ( tl ? i : ( (int)DADOij(linds, 0, i)) - 1);
		for (j = 0; j < ncsr; j++) {
			scol = ( tc ? j : ( (int)DADOij(cinds, 0, j)) - 1);
#ifdef EDIX
			dp = &(DADOij(sr, i, j));
			*dp = DADOij(from, slin, scol);
#else
			DADOij(sr, i, j) = DADOij(from, slin, scol);
#endif
		}
	}

	return sr;

}

