#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Calcula a Decomposio de Cholesky de uma matriz.


Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


extern double _toler_;

#define TOL	_toler_ 
   
Simbolo_t *mcho(a)
Simbolo_t *a;
{
	int i,j,k,lin,col;
	double s1;
	double tmp;
	Simbolo_t *s = faztemp(NLINS(a),NCOLS(a));
#ifdef EDIX
	double *dp;
#endif

	if ((lin = NLINS(a)) != (col = NCOLS(a)))

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("matriz nao e quadrada",(char *) 0);
*** */
		execerro(PegaMsg(3115),(char *) 0);
	if (DADOij(a,0,0) < TOL)

/* *** Padroniz. msg erro - Luciana 23/12/94
		execerro("matriz nao e positiva definida",(char *) 0);
*** */
		execerro(PegaMsg(3121),(char *) 0);
	for(i=0; i < lin; ++i) {
		for(k=i+1;k < col; ++k) {
#ifdef EDIX
			dp = &(DADOij(s,i,k));
			*dp = 0.0;
#else
			DADOij(s,i,k) = 0.0;
#endif
		}
		for(j=i; j < col; ++j)
			if (fuzz(DADOij(a,i,j),DADOij(a,j,i))  != 0)

/* *** Padroniz. msg erro - Luciana 23/12/94
				execerro("matriz nao e simetrica",(char *) 0);
*** */
				execerro(PegaMsg(3122),(char *) 0);
	}

#ifdef EDIX
	dp = &(DADOij(s,0,0));
	*dp = sqrt(DADOij(a,0,0));
#else
	DADOij(s,0,0) = sqrt(DADOij(a,0,0));
#endif
	for(i=0; i < lin; ++i)
		if (fabs(DADOij(s,0,0)) < TOL) {

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("matriz nao e positiva definida",(char *) 0);
*** */
			execerro(PegaMsg(3121),(char *) 0);
		}
		else {
#ifdef EDIX
			dp = &(DADOij(s,i,0));
			*dp = DADOij(a,i,0)/DADOij(s,0,0);
#else
			DADOij(s,i,0) = DADOij(a,i,0)/DADOij(s,0,0);
#endif
		}
	
	for(j=1; j < lin; ++j) {
		s1 = 0.0;
		for(i=0; i < j; ++i)
			s1 += (DADOij(s,j,i)*DADOij(s,j,i));
		if ((tmp=(DADOij(a,j,j) - s1)) > 0.0) {
#ifdef EDIX
			dp = &(DADOij(s,j,j));
			*dp = sqrt(tmp);
#else
			DADOij(s,j,j) = sqrt(tmp);
#endif
		}
		else

/* *** Padroniz. msg erro - Luciana 23/12/94
			execerro("matriz nao e positiva definida",(char *) 0);
*** */
			execerro(PegaMsg(3121),(char *) 0);
		for(i=j+1; i < lin; ++i) {
			s1 = 0.0;
			for(k=0; k < j; ++k)
				s1 += (DADOij(s,i,k)*DADOij(s,j,k));
			if (fabs(DADOij(s,j,j)) < TOL) {

/* *** Padroniz. msg erro - Luciana 23/12/94
				execerro("matriz nao e positiva definida",(char *) 0);
*** */
				execerro(PegaMsg(3121),(char *) 0);
			}
			else {
#ifdef EDIX
				dp = &(DADOij(s,i,j));
				*dp = (DADOij(a,i,j) - s1)/DADOij(s,j,j);
#else
				DADOij(s,i,j)=(DADOij(a,i,j)-s1)/DADOij(s,j,j);
#endif
			}
		}
	} 
	return s;
}

