#include <math.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
Cria  um vetor coluna a partir da soma dos elementos das linhas do argumento.
Se A = (a(i,j)) tem dimenso (mxn), ento LSOMA(A) = ((a(i,1) + ... + a(i,n))) tem dimenso (mx1).


Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/
Simbolo_t *mColsum(x)
Simbolo_t *x;
{
	Simbolo_t *sr = faztemp(1,NCOLS(x));
	int i, j;
	double sum;
#ifdef EDIX
	double *dp;
#endif


	for (j = 0; j < NCOLS(x); j++) {
		sum = 0.0;
		for (i = 0; i < NLINS(x); i++)
			sum += DADOij(x, i, j);
#ifdef EDIX
		dp = &(DADOij(sr, 0, j));
		*dp = sum;
#else
		DADOij(sr, 0, j) = sum;
#endif
	}

	return sr;
}

