#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Calcula a inversa de uma matriz quadrada no singular.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *mInv(x)
Simbolo_t *x;
{
	Simbolo_t *sr, *copyx;
	int n, i, j;
	int *ipvt;
	double *work;
#ifdef EDIX
	double *dp;
#endif

	if (NLINS(x) != NCOLS(x))

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("inv: ", "matriz nao e' quadrada");
*** */
		execerro(PegaMsg(3129), (char *) 0);

	/* salve a matriz x original */
	n = NLINS(x);
	sr = faztemp(n, n);
	copyx = faztemp(n, n);
	copmat(MATRIZ(copyx), MATRIZ(x));

	ipvt = (int *) emalloc((unsigned int)(n * sizeof(int)));

	/* fatorizacao LU de x */
	if (sgefa(DADOS(copyx), n, ipvt) >= 0) {
		efree((char *) ipvt);

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("inv: ", "matriz e' singular");
*** */
		execerro(PegaMsg(3129), (char *) 0);
	}

	/* agora calcule a inversa */
	work = (double *) emalloc((unsigned int)(n * sizeof(double)));
	/* sgedi nao esta ok ainda; resolva n sitemas com rhs unitario */
	/* sgedi(DADOS(sr), n, ipvt, work);     */

	for (j = 0; j < n; j++) {
		for (i = 0; i < n; i++)
			work[i] = (i == j)? 1.0 : 0.0;
		sgesl(DADOS(copyx), n, ipvt, work, 0);
		for (i = 0; i < n; i++) {
#ifdef EDIX
			dp = &(DADOij(sr,i,j));
			*dp = work[i];
#else
			DADOij(sr,i,j) = work[i];
#endif
		}
	}

	efree((char *) ipvt);
	efree((char *) work);

	tentaLibSim(copyx);

	return sr;
}

