#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Retorna uma matriz com o posto (rank) de uma matriz, isto , o nmero de colunas que no possuem 
	dependencia linear com outras colunas da matriz.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

extern  double _toler_;
#define TOL	_toler_
   
Simbolo_t *mposto(a)
Simbolo_t *a;
{
	int i;
	Simbolo_t *s = faztemp(1,1);
	Simbolo_t *t ;
	Simbolo_t *p = faztemp(NLINS(a),NCOLS(a));
#ifdef EDIX
	double *dp;
#endif

	if (NLINS(a) >= NCOLS(a)) {
		t = faztemp(NCOLS(a),NCOLS(a));
		mgs1(a,t,p);
	}
	else {
		t = faztemp(NLINS(a),NLINS(a));
		mgs(a,t,p);
	}
#ifdef EDIX
	dp = &(DADOij(s,0,0));
	*dp = 0.;
#else
	DADOij(s,0,0) = 0.;
#endif
	for(i=0; i < NLINS(t); ++i){
		if (DADOij(t,i,i) >= TOL) {
#ifdef EDIX
			dp = &(DADOij(s,0,0));
			*dp += 1.;  
#else
			DADOij(s,0,0) += 1.;  
#endif
		}
 	}

	tentaLibSim(t);
	tentaLibSim(p);

	return s;
}

