#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
Constri um vetor coluna a partir dos elementos da diagonal principal de uma matriz quadrada.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *mVdiag(x)
Simbolo_t *x;
{
	Simbolo_t *sr;
#ifdef EDIX
	double *dp;
#endif
	int i;

	if (NLINS(x) != NCOLS(x))

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("vdiag :","matriz nao e' quadrada");
*** */
		execerro(PegaMsg(3115), (char *) 0);

	sr  = faztemp(NLINS(x),1);

	for (i = 0; i < NLINS(x); i++) {
#ifdef EDIX
		dp = &(DADOij(sr, i, 0));
		*dp = DADOij(x, i, i);
#else
		DADOij(sr, i, 0) = DADOij(x, i, i);
#endif
	}

	return sr;
}

