#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"
#include "pcsgbd.h" /* Luciana */

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Cria um vetor linha a partir de uma matriz de entrada.
Se A tem dimemso (mxn) ento VEC(A) tem dimenso (nmx1).

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/
   
Simbolo_t *mvetor(a)
Simbolo_t *a;
{
	int i;
	int j;
	int k;

	Simbolo_t *s = faztemp(NLINS(a)*NCOLS(a) , 1);

#ifdef EDIX
	double *dp;
#endif

	k = 0;
	for(i=0; i < NLINS(a); ++i) {
		for(j=0; j < NCOLS(a); ++j) {
#ifdef EDIX
			dp = &(DADOij(s,k,0));
			*dp = DADOij(a,i,j);
#else
			DADOij(s,k,0) = DADOij(a,i,j);
#endif
			k++;
		}
	}
	return(s);
}


Simbolo_t *muvetor(a)
Simbolo_t *a;
{
	int i;
	int j;
	int k;
	Simbolo_t *s;
#ifdef EDIX
	double *dp;
#endif


	if (NLINS(a) != NCOLS(a))

/* *** Padroniz. msg erro - Luciana 02/01/95
		execerro("uvec","Matriz nao e quadrada");
*** */
		execerro(PegaMsg(3115), (char *) 0);

	k = NLINS(a);
	i = (k * (k-1))/ 2; 
	s = faztemp((NLINS(a)*NCOLS(a)-i) , 1);
		

	k = 0;
	for(i=0; i < NLINS(a); ++i) {
		for(j=i; j < NCOLS(a); ++j) {
#ifdef EDIX
			dp = &(DADOij(s,k,0));
			*dp = DADOij(a,i,j);
#else
			DADOij(s,k,0) = DADOij(a,i,j);
#endif
			k++;
		}
	}
	return(s);
}
