#include <stdio.h>
#include <math.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
Gera um vetor coluna cujos elementos representam as posies (rank) dos elementos do vetor coluna especificado como argumento.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

Simbolo_t *ordem(a)
Simbolo_t *a;
{
	int i;
	int j;
	int n1;
	int n2;
	int t1;
	int t2;
	int t3;
	double w;
#ifdef EDIX
	double *dp;
#endif

	Simbolo_t *s = faztemp(NLINS(a),NCOLS(a));
	
	n1 = NLINS(a);
	n2 = NCOLS(a);
	if (n2 != 1) {
		execerro("Matriz de entrada tem que ser um vetor coluna", (char *) 0);
	}

	for(i=0; i < n1; ++i) {
		t1 = 0;
		t2 = 0;
		t3 = 0;
		w  = DADOij(a,i,0);
		
		for(j=0; j < n1; ++j) {
			if ( DADOij(a,j,0) <= w) {
				if ( DADOij(a,j,0) < w) {
					t1++;
				}	
				else {
					t2++;
					if (i < j)
						t3++;
				}
			}
		}
#ifdef EDIX
		dp = &(DADOij(s,i,0));
		*dp = (double) ( t1 + (t2 - t3)); 
#else
		DADOij(s,i,0) = (double) ( t1 + (t2 - t3)); 
#endif
	}
	return s;
}
