#include <stdio.h>
#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	insere uma matriz de dimenso menor em outra matriz de dimenso superior.
 
Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

void setsubs(res, linds, cinds, from)
Simbolo_t *res, *linds, *cinds, *from;
{
	int ls, le, cs, ce, tl, tc, i, j, dlin, dcol;
	int n_col, n_lin;
	Simbolo_t *aux;
#ifdef EDIX
	double *dp;
#endif

	if (linds == (Simbolo_t *) 0) {
		ls = 0;
		le = NLINS(res) - 1;
		tl = 1;
		n_lin = NLINS(res);
	}
	else {
		n_lin = NCOLS(linds);
		if (NLINS(linds) != 1)
			conferro(res, linds, "subscrito nao e' vetor linha");
		aux = mMin(linds);
		ls = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		aux = mMax(linds);
		le = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		tl = 0;
	}

	if (cinds == (Simbolo_t *) 0) {
		cs = 0;
		ce = NCOLS(res) - 1;
		tc = 1;
		n_col = NCOLS(res);
	}
	else {
		n_col = NCOLS(cinds);
		if (NLINS(cinds) != 1)
			conferro(res, cinds, "subscrito nao e' vetor linha");
		aux = mMin(cinds);
		cs = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		aux = mMax(cinds);
		ce = ( (int)DADOij(aux, 0, 0) ) - 1;
		tentaLibSim(aux);
		tc = 0;
	}

	if (ls < 0 || ls >= NLINS(res) || le < 0 || le >= NLINS(res))
		conferro(res, linds, "subscrito fora do intervalo");

	if (n_lin != NLINS(from))
		conferro(from, linds, "diferente numero de linhas");

	if (cs < 0 || cs >= NCOLS(res) || ce < 0 || ce >= NCOLS(res))
		conferro(res, linds, "subscrito fora do intervalo");

	if (n_col != NCOLS(from))
		conferro(from, linds, "diferente numero de colunas");

	for (i = 0; i < NLINS(from); i++) {
		dlin = ( tl ? i : ( (int)DADOij(linds, 0, i) ) - 1);
		for (j = 0; j < NCOLS(from); j++) {
			dcol = ( tc ? j : ( (int)DADOij(cinds, 0, j) ) - 1);
#ifdef EDIX
			dp = &(DADOij(res, dlin, dcol));
			*dp = DADOij(from, i, j);
#else
			DADOij(res, dlin, dcol) = DADOij(from, i, j);
#endif
		}
	}
}

