#include <stdio.h>
#include <math.h>

#include "cm_cm01.h"

/***********************************************************************************
CM - Software para programao e manipulao de matrizes

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os 
termos da Licena Pblica Geral GNU conforme publicada pela Free Software 
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso 
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes. 

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este 
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59 
Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	 
	Executa a eliminacao gaussiana com pivotamento parcial.

Desenvolvido por: 

	Moacir Pedroso Junior 
	Silvio Evangelista
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#define	ind(n,i,j)	((n)*(i)+(j))
extern double _toler_;
#define TOL	_toler_

sgefa(a, n, ipvt)
double	a[];
int	n, ipvt[];
{
	double t;
	int j, k, l;
	int m;
	int info = -1;

	/*
	 *     eliminacao gaussiana com pivotamento parcial
	*/
	for (k = 0; k < n-1; k++) {

		/*
		 *  encontre l =  indice do pivot 
		*/
		l = isamax(n - k, &a[ind(n,k,k)], n) + k;
		ipvt[k] = l;

		/*
		 *  pivot = zero implica que esta coluna ja foi
		 *  triangularizada
		*/
		if (fabs(a[ind(n,l,k)]) < TOL) {
			m = ind(n,l,k);
			a[m] = 0.0;
			info = k;
		}
		else {
			/*
			*  troque se necesario
			*/
			if (l != k)
				swap(&a[ind(n,l,k)], &a[ind(n,k,k)]);

			/*
			*  calcule os multiplicadores
			*/
			sscal(n-k-1, (-1.0/a[ind(n,k,k)]), &a[ind(n,k+1,k)], n);

			/*
			*  eliminacao de linha com indexacao de col 
			*/
			for (j = k+1; j < n; j++) {
				t = a[ind(n,l,j)];
				if (l != k) 
					swap(&a[ind(n,l,j)],&a[ind(n,k,j)]);
				saxpy(n-k-1, t, &a[ind(n,k+1,k)], n, &a[ind(n,k+1,j)], n);
			}
		}
	}

	ipvt[n-1] = n-1;
	if (fabs(a[ind(n,n-1,n-1)]) < TOL) {
		m = ind(n,n-1,n-1);
		a[m] = 0.0;
		info = n-1;
	}

	return info;
}

