
/***********************************************************************************
 COMPARA - Mdulo para testar a hiptese de igualdade entre mdias

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/compara/fontes/compara.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:58:37 $:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#include <setjmp.h>
#include<malloc.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include <stdlib.h>

#if !defined(VAXVMS) & !defined(SCO) & !defined(i486)
#include <search.h>
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

#include "getoken.h"
#include "pcsgbd.h"
/*#include "lockfile.h"*/

static char *sccsid = "@(#)compara.c	3.14	(NTIA/compara)	95/09/20";


#define VAR1
#include "compara.h"

/* ----------------------------------------------------------------------------
** @(#)compara.c	3.14	(NTIA/compara)	95/09/20
**
** 
**
** Modulo para comparar medias.
**
** Forma de usar:
**
**		compara [opcoes] <arquivo_soc>
**
** Flags envolvidas:
**
**		opcoes   :
**		nomebase : nome da base de dados a ser utilizada
**
** Valor retornado:
**
**			
**
** Programado por:
**
**		Silvio Roberto Medeiros Evangelista
**
** Data da ultima alteracao:
**
**		95/09/20 11:28:59
**
** ----------------------------------------------------------------------------
*/

char *p = area;			/* ponteiro para a area nao usada */

int pflag = 0;			/* flag de impressao de leitura */
int lflag = 1;			/* flag de impressao de dados originais */
int nflag = 1;			/* flag de entrade de num. de obs */
int hflag = 1;

int c;
int nvi;
int nvi1;
int nb;
int nb1;
int nc;
int nc1;
int nn;
int nn1;
int ng;
int ng1;
int nq;
int nq1;
int numero;			/* flag se entrou com nobs ou variavel */
int flag_t;


jmp_buf go;

FILE *fout;

char *obs2[MAXEFTS];
int sv[MAXEFTS];
int sv1[MAXEFTS];
int tipo_c[MAXEFTS];
int npar;

ARQ *fd;

char qmr1[80];
char gl[80];
char nobs1[30];

char token[128];
char titulo[128];
char temp;

int executa;
int idflag = 0;
int flagX = 0;
int flagP = 0;
char *obs1[OBSSIZE];
char x[80];
char *arqtemp;

#ifdef MSDOS
int nlins = 25;
#else
int nlins = 24;
#endif

int ncols = 80;
int descarq;			/* descritor de arquivo para funcoes de bloqueio */

main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{
    int teste;
    long ret;
    char namelock[TAMSTR];

    alfa = 0.05;		/* alfa por default */
    opcao = '5';		/* SNK por default */

#ifdef VAXVMS
    argc = prepvax(argc, argv);
#endif

    getarg(argc, argv);		/* le os argumentos e abre arquivo */

    if ((arqtemp = (char *) malloc(TAMSTR)) == (char *) NULL) {
/* *** Padroniz. msg erro - Luciana 14/12/94
		fprintf(stderr,"Memoria insuficiente para diretorio.", "");
*** */
	fprintf(stderr, PegaMsg(1039));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("compara");
	    exit(2);
	}
#endif

	exit(2);
    }

    strcpy(arqtemp, pega_env(argv[argc - 1], ".hdr"));

    /* Bloqueio de escrita do arquivo de entrada */
    strcpy(namelock, arqtemp);
    strcat(namelock, ".dat");

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("compara");
	exit(5);
    }
#endif

    if ((ret = (long) (fd = abre_arq(arqtemp, 0, 1))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Luciana 14/12/94
		fprintf(stderr, "Nao consegui abrir <%s> %ld\n", arqtemp,
			ret);
*** */
	fprintf(stderr, PegaMsg(1034), arqtemp);
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("compara");
	    exit(2);
	}
#endif

	exit(2);
    } else {
	/*      arqtemp = "compara.out";        */
	strcpy(arqtemp, "compara.out");
    }
    if ((fout = fopen(arqtemp, "w")) == NULL) {

/* *** Padroniz. msg erro - Luciana 14/12/94
		fprintf(stderr, "Nao consegui abrir <%s>\n",arqtemp);
*** */
	fprintf(stderr, PegaMsg(5020), arqtemp);
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("compara");
	    exit(2);
	}
#endif

	exit(2);
    }
    setjmp(go);

    inicializa();		/* inicializa variaveis globais */
    teste = 0;

    for (;;) {
	c = getoken(token);

	if ((c == EOF) || (c == RB) || (strcmpi(token, "fim") == 0) || (c=='\r'))
	    saida();

	if (executa == 1)
	    break;

	if (strcmpi(token, "cancela") == 0) {
	    unlink(arqtemp);
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("compara");
		exit(0);
	    }
#endif
	    exit(0);
	}

	teste = descobre();

	if (teste == -1)
	    erroc(4);

	switch (temp) {

	case 'v':
	    token_var();
	    break;
	case 'c':
	    token_class();
	    break;
	case 'p':
	    token_by();
	    break;
	case 'n':
	    token_n();
	    break;
	case 'g':
	    token_g();
	    break;
	case 'q':
	    token_q();
	    break;
	case 't':
	    token_t();
	    break;
	default:
	    erroc(4);
	    break;
	}
    }
    ordenalista();
    imprimepar();
    impobs();
    fclose(fout);

    if ((fp = fopen(arqtemp, "r")) == NULL) {
/* *** Padroniz. msg erro - Luciana 14/12/94
		fprintf(stderr, "Erro na abertura do arquivo: <%s>\n", arqtemp);
*** */
	fprintf(stderr, PegaMsg(5020), arqtemp);
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("compara");
	    exit(1);
	}
#endif
	exit(1);
    }

    compar1();

    unlink(arqtemp);
    free(arqtemp);
    if ((ret = fech_arq(fd)) < 0 && ret >= -2) {
	fprintf(stderr, PegaMsg(1011), "");
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("compara");
	    exit(0);
	}
#endif
	setOSstdin();
	exit(2);
    }
    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("compara");
	exit(0);
    }
#endif
    /* Desbloqueio do arquivo */
    if (descarq != -1)
	/*  UnlockAFile(descarq); */

	exit(0);
}
