
/***********************************************************************************
 COMPARA - Mdulo para testar a hiptese de igualdade entre mdias

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/compara/fontes/compara1.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:58:37 $:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include "pcsgbd.h"

#include "compara.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)compara1.c	3.9	(NTIA/compara)	95/06/28";

extern char *arqtemp;
extern ARQ *fd;
static int comp[MEDIA], comp1[MEDIA];
static int ant[MEDIA], prof[MEDIA];

void compar1()
{
    long ret;
    int ll;
    char nnome[15];
    char ttipo;
    MINVAL mmin;
    MAXVAL mmax;
    char pbuff[15];
    int m = 0, k, i, dif, j;
    int tt = 0, ind;
    double x1, soma, qp;
    char id_temp[50];		/* variavel temporaria */
    int id_i = 0;		/* variavel que contem o numero da media que
				   esta sendo impressa */
    char buffer_gcvt[30];	/* colocada apenas para auxiliar aa funcao 
				   gcvt */
    nv = 0;
    nby = 1;			/* numero de bys - inicio */
    varby = 0;
    iby[1] = 1;			/* inicializa um possivel by */

    ler_par();			/* le os parametros do modelo */
    hflag = 0;			/* artificio para se usar apenas media harmo
				   nica */

/* *** Padroniz. msg erro - Luciana 30/11/94
	fprintf(stderr, "Lendo Obs.\n");
	fprintf(stderr, "\r%d", ++m);
*** */
    ++m;
/*
	fprintf(stderr, "Aguarde...\n");
*/
    while (lerobs(m) != EOF) {
/*		fprintf(stderr, "\r%d", ++m); */
	++m;
    }
    fprintf(stderr, "\n");
    nv = m - 1;			/* Numero de niveis */
    fby[nby] = nv;		/* posicao do ultimo elemento */
    if (nflag == 0)		/* seta valor de n se nflag */
	for (i = 1; i <= nv; ++i) {
	    nobs[i] = (double) count;
	}

    ordena();			/* Ordena as medias */
    print();

    for (ind = 1; ind <= nby; ++ind) {
	/* Se hflag, entao calcula mq,i como media harmonica */
	for (i = INICIO; i <= FIM; ++i) {
	    for (j = i; j <= FIM; ++j) {
		if (nobs[i] != nobs[j]) {
		    hflag = 1;
		    break;
		}
	    }
	}

	if (nby > 1)
	    nv = FIM - INICIO + 1;

	if (hflag) {
	    soma = 0.0;
	    for (i = INICIO; i <= FIM; ++i) {
		if (nobs[i] == 0.0) {
		    fprintf(stderr, "Numero de casos <N> igual a zero\n");
		    unlink(arqtemp);
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf
			    ("*** Lista de memoria nao esta' vazia *** \n");
			Mem_Store("compara");
			exit(0);
		    }
#endif
		    exit(0);
		}
		soma += 1. / nobs[i];
	    }
	    x1 = sqrt(soma * qmr / ((double) nv));
	}
	dif = 0;
	comp1[0] = 0;
	comp[0] = 0;
	for (k = INICIO; k <= FIM; ++k) {
	    for (i = FIM; i >= k; --i) {
		if (hflag == 0)	/* Se hflag=0 => mq,i e media */
		    x1 = mqi(nobs[k], nobs[i]);
		if ((opcao == '1' || opcao == '3' ||
		     opcao == '4') && k == INICIO)
		    qp = rqi(opcao, alfa, 2);

		if (opcao == '6' && k == INICIO)
		    qp = rqi(opcao, alfa, nv);

		if (opcao == '7') {
		    j = abs(k - i) + 1;
		    j = (j + nv) / 2;
		    qp = rqi(opcao, alfa, j);
		}

		if (opcao == '2' || opcao == '5') {
		    j = abs(k - i) + 1;
		    qp = rqi(opcao, alfa, j);
		}
		if ((fabs(obs[k] - obs[i])) > (qp * x1)) {
		} else {
		    if (comp1[dif] != i) {
			++dif;
			comp[dif] = k;
			comp1[dif] = i;
			tt = 1;
		    }
		    break;
		}
	    }
	    if (i == FIM && tt == 1)
		break;
	    tt = 0;

	}
	for (i = 1; i <= dif; ++i) {
	    ant[i] = 0;
	    prof[i] = 0;
	}
	tt = 0;
	for (i = INICIO; i <= FIM; ++i) {
	    if ((nby > 1) && (tt == 0)) {
		printf("\n---------------------");
		for (k = 1; k <= varby; ++k) {
		    printf(" %s = ", nomeby[k]);
		    if ((ll = veri_var(fd, nomeby[k])) < 0) {
			fprintf(stderr,
				"Variavel <%s> nao existe.\n", nomeby[k]);
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("*** Lista de memoria nao esta' vazia *** \n");
			    Mem_Store("compara");
			    exit(1);
			}
#endif
			exit(1);
		    }
		    if ((ret =
			 (long) pega_var(fd, ll, nnome, &ttipo, &mmin,
					 &mmax)) < 0L) {
			fprintf(stderr, PegaMsg(1062));
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("***Lista de memoria nao esta vazia ***\n");
			    Mem_Store("compara");
			    exit(0);
			}
#endif
			setOSstdin();
			exit(2);
		    }
		    if (ttipo == 'd') {
			dtoa(atof(antby[i][k]), pbuff);
			printf("%s ", pbuff);
		    } else {
			printf("%s ", antby[i][k]);
		    }
		}
		printf(" ---------------------\n\n");
		tt = 1;
	    }
	    if (idflag) {
		printf("%s", nome[i]);
		for (k = strlen(nome[i]); k <= 16; ++k)
		    printf(" ");
	    } else {
		itoa(id_i++, id_temp, 10);
		printf("%s", id_temp);
		for (k = strlen(id_temp); k <= 16; ++k)
		    printf(" ");
	    }
	    /* Antes :
	       printf("%5.0f %16.6f  ",nobs[i],obs[i]);
	       Depois : buffer_gcvt e' uma variavel incluida apenas
	       para garantir a impressao neste ponto.
	     */
	    printf("%5.0f %17s  ", nobs[i], gcvt(obs[i], 15, buffer_gcvt));
	    for (k = 1; k <= dif; ++k) {
		if (comp[k] == i) {
		    for (j = 1; j <= dif; ++j)
			if (prof[j] == 0) {
			    prof[j] = k;
			    break;
			}
		}
		if (comp[k] == i)
		    break;
	    }
	    for (k = 1; k <= dif; ++k) {
		if (prof[k] != 0) {
		    if (ant[k] == 0) {
			if (lflag)
			    printf(" %c ", 'a' + prof[k] - 1);
			else
			    printf(" %c ", CHAR);
		    } else {
			printf("   ");
			ant[k] = 0;
			prof[k] = 0;
		    }
		    if (comp1[prof[k]] == i)
			ant[k] = 1;
		} else {
		    for (j = k; j <= dif; ++j)
			if (prof[j] != 0) {
			    printf("   ");
			    break;
			}
		}
	    }
	    printf("\n");
	}
    }
}
