
/***********************************************************************************
 COMPARA - Mdulo para testar a hiptese de igualdade entre mdias

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:
	
	Calcula o valor crtico de duncan

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/compara/fontes/duncan.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:58:37 $:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include "compara.h"

static char *sccsid = "@(#)duncan.c	3.6	(NTIA/compara)	95/01/11";


double duncan(ff, nm, alfa)
double ff;
int nm;
double alfa;

{
    double r;
    double coef[10];
    double y;
    double z;
    int i;
    int n1;

    for (i = 0; i <= 9; ++i)
	coef[i] = 0.;
    n1 = (int) ff;
    if (alfa = 0.05) {
	if ((n1 + 2) < nm)
	    r = (double) (n1 + 2);
	else
	    r = (double) nm;
    } else {
	if ((n1 * 2) < nm)
	    r = (double) (n1 * 2);
	else
	    r = (double) nm;
    }

    y = 1. / ((double) ff);
    z = 1. / (sqrt(r));
    if (n1 == 1) {
	if (alfa == 0.05)
	    coef[0] = 17.97;
	else
	    coef[0] = 90.03;
    }
    if (n1 == 2) {
	if (alfa == 0.05)
	    coef[0] = 6.085;
	else
	    coef[0] = 14.04;
    }
    if (n1 >= 3 && nm == 2) {
	if (alfa == 0.05) {
	    coef[0] = 2.7784;
	    coef[1] = 3.0359;
	    coef[3] = 6.3404;
	} else {
	    coef[0] = 3.6405;
	    coef[1] = 7.1927;
	    coef[3] = 8.8962;
	    coef[6] = 33.2630;
	}
    }
    if ((n1 >= 3 && nm == 3) || (n1 == 3 && nm > 3)) {
	if (alfa == 0.05) {
	    coef[0] = 2.9217;
	    coef[1] = 3.2080;
	    coef[3] = 4.6911;
	} else {
	    coef[0] = 3.7941;
	    coef[1] = 7.5559;
	    coef[3] = 9.5681;
	    coef[6] = 25.4660;
	}
    }
    if (n1 > 3 && nm > 3) {
	if (alfa == 0.05) {
	    if (r >= 4.0 && r <= 17.0) {
		coef[0] = 3.5409;
		coef[1] = -4.8389;
		coef[2] = 0.9313;
		coef[3] = -2.123;
		coef[4] = 31.157;
		coef[5] = -7.6639;
		coef[6] = 12.759;
		coef[7] = 0.212;
		coef[8] = -27.779;
		coef[9] = 7.353;
	    } else {
		if (r >= 18.0 && r <= 100.0) {
		    coef[0] = 3.5883;
		    coef[1] = -45.660;
		    coef[2] = 5.099;
		    coef[3] = -2.32;
		    coef[4] = 396.24;
		    coef[5] = -46.554;
		    coef[6] = -1.39;
		    coef[7] = 21.74;
		    coef[8] = -855.99;
		    coef[9] = 95.07;
		}
	    }
	} else {
	    if (r >= 4.0 && r <= 14.0) {
		coef[0] = 4.5660;
		coef[1] = 3.4831;
		coef[2] = 0.5406;
		coef[3] = -7.246;
		coef[4] = 23.068;
		coef[5] = -7.8283;
		coef[6] = 27.158;
		coef[7] = 26.777;
		coef[8] = -27.626;
		coef[9] = 8.134;
	    } else {
		if (r >= 15.0 && r <= 100.0) {
		    coef[0] = 4.9138;
		    coef[1] = -12.756;
		    coef[2] = 0.341;
		    coef[3] = -31.179;
		    coef[4] = 169.221;
		    coef[5] = -23.023;
		    coef[6] = 18.74;
		    coef[7] = 118.36;
		    coef[8] = -350.15;
		    coef[9] = 50.37;
		}
	    }
	}
    }
    return (coef[0] + coef[1] * y + coef[2] * z + coef[3] * y * y +
	    coef[4] * y * z + coef[5] * z * z + coef[6] * y * y * y +
	    coef[7] * y * y * z + coef[8] * y * z * z +
	    coef[9] * z * z * z);
}
