
/***********************************************************************************
 COMPARA - Mdulo para testar a hiptese de igualdade entre mdias

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Calcula o valor de Rq-i+1

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/compara/fontes/rqi.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:58:37 $:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include "pcsgbd.h"
#include "compara.h"

static char *sccsid = "@(#)rqi.c	3.6	(NTIA/compara)	95/01/11";


extern double alfa;

double rqi(teste, n1, nm)
int teste;
int nm;
double n1;
{
    double valor;
    double alfa1;
    int fint;
    fint = (int) f;
    switch (teste) {
    case '1':			/* teste de lsd  */
	valor = sqrt(2. * finv(n1, 1.0, (double) fint));
	break;
    case '2':			/* teste de duncan */
	valor = duncan(f, nm, alfa);
	break;
    case '3':			/* teste de scheffe */
	valor =
	    sqrt(2. * ((double) (nv - 1)) *
		 finv(n1, (double) (nv - 1), (double) fint));
	break;
    case '4':			/* teste de modlsd */
	alfa1 = 2. * n1 / ((double) (nv * (nv - 1)));
	valor = sqrt(2. * finv(alfa1, 1.0, (double) fint));
	break;
    case '5':			/* teste de SNK */
	valor = tabela(f, nm, alfa);
	break;
    case '6':			/* teste de Tukey */
	valor = tabela(f, nm, alfa);
	break;
    case '7':			/* teste de TukeyB */
	valor = tabela(f, nm, alfa);
	break;
    }
    return (valor);
}
