
/***********************************************************************************
 CORREL - Constri a matriz de correlao (Pearson) entre as varivies. 

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Ler os dados e calcular os elementos da matriz de correlao

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/correl/fontes/calculo.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:13:11 $:

***********************************************************************************/

#include "correl.h"


static char *sccsid = "@(#)calculo.c	3.4	(NTIA/correl)	95/01/11";


void calculo(Corr)
struct Correl MY_HUGE *Corr;
{
    int k, i, j, ii, jj, l;
    long n;
    double nn;
    double Sx, Sy, Sx2, Sy2, Sxy;
    double r;
#ifdef EDIX
    double *dp;
#endif

    k = 0;
    for (i = 0; i < nvar; ++i) {
	ii = var[i];
	l = temcom ? i : ncom;
	for (j = 0; j < l; ++j) {
	    jj = com[j];
	    if (ii != jj) {
		Sx = Corr[k].Sx;
		Sy = Corr[k].Sy;
		Sx2 = Corr[k].Sx2;
		Sy2 = Corr[k].Sy2;
		Sxy = Corr[k].Sxy;
		n = Corr[k].n;
		nn = (double) n;
		if (n > 1)
		    r = (Sx2 - Sx * Sx / nn) * (Sy2 - Sy * Sy / nn);
		else
		    r = 0.0;
		if (r > 0.0)
		    r = (Sxy - Sx * Sy / nn) / sqrt(r);
#ifdef EDIX
		dp = &(Corr[k].C);
		*dp = r;
#else
		Corr[k].C = r;
#endif
		++k;
	    }
	}
    }
}
