
/***********************************************************************************
 CORREL - Constri a matriz de correlao (Pearson) entre as varivies. 

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Mdulo SOC para clculo de correlaes

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/correl/fontes/correl.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:13:11 $:

***********************************************************************************/

#define EXTERN

#include <setjmp.h>
#include <stdlib.h>
#include <string.h>

#ifndef VAXVMS
#include <malloc.h>
#endif

#ifdef MEM_DEBUG
#include <stdio.h>
#include "mshell.h"
#endif

#include "correl.h"
#include "getoken.h"
#include "pcsgbd.h"
/*#include "lockfile.h"*/

static char *sccsid = "@(#)correl.c	3.8	(NTIA/correl)	95/04/12";


extern int gtoken1();
jmp_buf env;

#ifdef MSDOS
int nlins = 25;
#else
int nlins = 24;
#endif

int ncols = 80;
int descarq;			/* descritor de arquivo para funcoes de bloqueio */


/* --------------------------------------------------*/



main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{
    long m;
    struct Correl MY_HUGE *Corr;
    long n;
    long c;
    long ret;

#ifdef VAXVMS
    argc = prepvax(argc, argv);
#endif

    flagX = 0;
    xflag = 0;			/* flag de impressao de x'x */

    getarg(argc, argv);		/* le os argumentos e abre arquivo */

    setjmp(env);
    titulo[0] = '\0';
    ordc = temcom = nclass = nvar = ncom = 0;

    /*
     *      Ler os parametros iniciais
     */

    ler_par();			/* le os parametros do modelo */

    /*
     *      Calcular m e alocar espaco
     */

    m = temcom ? ncom * nvar / 2 : ncom * nvar;
    if ((Corr = (struct Correl MY_HUGE *) HALLOC((TIPO) m,
						 sizeof(struct Correl))) ==
	(struct Correl MY_HUGE *) NULL) {

/* *** Padroniz. msg erro - Luciana 15/12/94
		fprintf(stderr, "Nao consegui espaco para matriz de correl.\n");
*** */
	fprintf(stderr, PegaMsg(3144));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("correl");
	    exit(1);
	}
#endif
	exit(1);
    }

    /*
     *      Ler a primeira obs
     */

    c = ler1_obs(obs, class, nclass);

    while (c != (long) EOF) {
	/*
	 *      Inicializa o vetor de correlacoes
	 */

	n = 0l;
	inicialize(Corr, m);

	while (c != (long) EOF && c != QUEBRA) {
	    fprintf(stderr, "%ld\t%ld\r", c + 1, ++n);

	    ntotal = processa(Corr);

	    /*
	     *      le a matriz de correlacao e calcula a estrutura 
	     */

	    c = lern_obs(obs, class, nclass);
	}
	fprintf(stderr, "       \t  \r");
	if (c == QUEBRA)
	    c = 0;		/* retirar condicao para reentrar */

	if (n > 2l) {
	    /*
	     *      Calcule as correlacoes
	     */

	    calculo(Corr);

	    /*
	     *      Imprime a tabela
	     */

	    imprime(Corr);
	} else {
	    printf("Numero insuficiente de observacoes-(%ld).\n\n", n);
	    q_imprime(class, nclass);	/* imprime quebra */
	}

	/*
	 *      Copia as variaveis de quebra
	 */

	q_copie(obs, class, nclass);
    }

    HFREE((char MY_HUGE *) Corr);
    if ((ret = fech_arq(fd)) < 0 && ret >= -2) {
	fprintf(stderr, PegaMsg(1011), "");
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("correl");
	    exit(0);
	}
#endif
	setOSstdin();
	exit(2);
    }

    printf("\n");
    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("correl");
	exit(0);
    }
#endif
    /* Desbloqueio dos arquivos */
    if (descarq != -1)
	/*UnlockAFile(descarq); */

	exit(0);
}
