/* ----------------------------------------------------------------------------
**
** 
** "@(#)correl.h	3.4	(NTIA/correl)	95/05/24";
**
** 
**
** ----------------------------------------------------------------------------
*/

#include <stdio.h>
#include <math.h>

#if !defined(VAXVMS) & !defined(SCO) & !defined(i486)
#include <search.h>
#endif

#include "pcsgbd.h"

#ifdef RS6000
#define class		cclass
#endif

#ifndef EXTERN
# define	EXTERN	extern
#endif
#ifdef MSDOS
# define MY_HUGE	huge
# define TIPO		long
# define HALLOC		halloc
# define HFREE		hfree
# define TINT		unsigned
#else
# define MY_HUGE
# define TIPO		unsigned
# define HALLOC		calloc
# define HFREE		free
# define TINT		int
#endif

#define MAXMEM		100
#define MAXMEM1		MAXMEM-1
#define MAXCLASS	8
#define EPS   		1.e-15
#define QUEBRA		(-2l)

EXTERN ARQ 	*fd;			/* apontador para o arquivo de dados */

EXTERN int	nvar;			/* numero de variaveis no com. var */
EXTERN int	var[MAXMEM];		/* posicao das variaveis do com. var */
EXTERN char 	vvar[MAXMEM][9];	/* nome das variaveis */
EXTERN int	ncom;			/* numero de variaveis no com. com */
EXTERN int	com[MAXMEM];		/* posicao das variaveis do com. com */
EXTERN char 	vcom[MAXMEM][9];	/* nome das variaveis */
EXTERN int	nclass;			/* numero de variaveis no com. class */
EXTERN int	class[MAXCLASS];	/* posicao das variaveis class */
EXTERN int	tclass[MAXCLASS];	/* tipo das variaveis class */
					/* 1 = numerica ; 0 = alfa */
EXTERN char 	vclass[MAXMEM][9];	/* nome das variaveis */
EXTERN int 	ntotal;			/* numero de elementos em Corr */

EXTERN char 	*obs[OBSSIZE];		/* linha de dados lida */
EXTERN char	titulo[128];		/* titulo geral do programa */
EXTERN int	xflag;			/* impressao de x'x */
EXTERN int	flagX;			/* */
EXTERN int	fl_imp;			/* parar pagina */
EXTERN int	iterativo;		/* esta em modo iterativo */
EXTERN int	temcom;			/* se tem ou nao o comando com */
EXTERN int	ordc;			/* qual a ordem de classificacao */

struct Correl {
		double	Sx;		/* Somatorio de x */
		double	Sy;		/* Somatorio de y */
		double	Sx2;		/* Somatorio de x ^ 2 */
		double	Sy2;		/* Somatorio de y ^ 2 */
		double	Sxy;		/* Somatorio de x * y */
		double	C;		/* Correlacao */
		long	n;		/* numero de obs de x & y */
		short	i;		/* linha da correl */
		short	j;		/* coluna da correl */
};


#ifdef MSDOS
extern void getarg(int ,char * *);
extern void token_tl(void);
extern void token_var(void);
extern void token_class(void);
extern void ler_par(void);
extern void erro(int ,int );
extern void inicialize(struct Correl huge *,long );
extern int processa(struct Correl huge *);
extern void calculo(struct Correl huge *);
extern void imprime(struct Correl huge *);
extern int acha(struct Correl huge *,int ,int );
extern void imp_titulo(char * );
extern void q_imprime(int *, int);
extern long lern_obs(char * *, int *, int);
extern long ler1_obs(char * *, int *, int);
extern void q_copie(char * *, int *, int);
#else
extern void getarg();
extern void token_tl();
extern void token_var();
extern void token_class();
extern void ler_par();
extern void erro();
extern void inicialize();
extern int processa();
extern void calculo();
extern void imprime();
extern int acha();
extern void imp_titulo();
extern void q_imprime();
extern long lern_obs();
extern long ler1_obs();
extern void q_copie();
#endif

