
/***********************************************************************************
 CORREL - Constri a matriz de correlao (Pearson) entre as varivies. 

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Le as flags e abre o arquivo de dados

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/correl/fontes/getarg.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:13:11 $:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>


#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include "correl.h"
#include "getoken.h"
#include "pcsgbd.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif
/*#include "lockfile.h"*/

static int flag_exec = 0;
extern void controlC();

static char *sccsid = "@(#)getarg.c	3.15	(NTIA/correl)	95/09/21";


extern int flagX;
extern int nlins;
extern int ncols;
extern int descarq;

extern char exretstd[];		/* Contem o nome do arquivo exretstd */
extern int flagstd;

void getarg(argc, argv)
int argc;
char *argv[];
{
    int i;
    extern int iterativo;
    char *pdir;
    long ret;
    char namelock[TAMSTR];


    ++argv;			/* aponta para o primeiro parametro */
    --argc;			/* decrementa o apontador */
    flagX = 1;
    while (argc--) {
	if (argv[0][0] == '-') {
	    for (i = 1; argv[0][i]; ++i) {
		switch (argv[0][i]) {

		case 'P':

		    fl_imp = 1;

		    break;

		case 'A':

		    flag_exec = 1;
#ifdef RS6000
		    flagstd = 1;

		    if (*strchr(&argv[0][i + 1], '|'))
			*strchr(&argv[0][i + 1], '|') = '\0';

		    if (freopen(&argv[0][i + 1], "r", stdin) ==
			(FILE *) NULL) {

			i += (strlen(&argv[0][i + 1]) + 1);
			*strchr(&argv[0][i + 1], '|') = '\0';
			i += (strlen(&argv[0][i + 1]) + 1);
			strcpy(exretstd, &argv[0][i + 1]);
/* *** Padroniz. msg erro - Luciana 15/12/94
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
			fprintf(stderr, PegaMsg(1034), "stdin");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("***Lista de memoria nao esta vazia ***\n");
			    Mem_Store("correl");
			    exit(5);
			}
#endif
			exit(5);
		    }
		    i += (strlen(&argv[0][i + 1]) + 1);
		    *strchr(&argv[0][i + 1], '|') = '\0';
		    fseek(stdin, atol(&argv[0][i + 1]), 0);
		    i += (strlen(&argv[0][i + 1]) + 1);
		    strcpy(exretstd, &argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);
#endif
		    iterativo = 0;
		    setbuf(stdin, (char *) NULL);

		    break;


		    /*
		     ** Habilita impressao de mensagens
		     */

		case 'M':

		    break;

		    /*
		     ** Habilita impressao de tempo
		     */

		case 't':

		    break;

		case 'X':

		    if (strcmp(&argv[0][i + 1], "ntia") == 0) {
			flagX = 1;
			i += 4;
		    }

		    break;

		case 'x':

		    ++xflag;

		    break;

		case 'l':

		    nlins = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

		    break;

		case 'c':

		    ncols = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

		    break;

		default:

/* *** Padroniz. msg erro - Luciana 15/12/94
					fprintf(stderr,
					"Flag <%c> ilegal\n", argv[0][1]);
*** */
		    fprintf(stderr, PegaMsg(3086), argv[0][1]);
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf("***Lista de memoria nao esta vazia ***\n");
			Mem_Store("correl");
			exit(1);
		    }
#endif
		    exit(1);
		}
	    }
	} else
	    break;
	++argv;
    }

    if (!flagX) {
/* *** Padroniz. msg erro - Luciana 15/12/94
		fprintf(stderr, "Execucao nao permitida\n");
*** */
	fprintf(stderr, PegaMsg(1000));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("correl");
	    exit(1);
	}
#endif
	exit(1);
    }

    if (argc < 0) {
/* *** Padroniz. msg erro - Luciana 15/12/94
		fprintf(stderr, "Falta nome de arquivo\n");
*** */
	fprintf(stderr, PegaMsg(3000));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("correl");
	    exit(2);
	}
#endif
	exit(2);
    }

    pdir = pega_env(argv[0], ".hdr");
    /* Bloqueio de escrita do arquivo de entrada */
    strcpy(namelock, pdir);
    strcat(namelock, ".dat");
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("correl");
	exit(5);
    }
#endif

    if ((ret = (long) (fd = abre_arq(pdir, 0, 1))) < 0L && ret > -5L) {
/* *** Padroniz. msg erro - Luciana 15/12/94
		fprintf(stderr, "Nao consegui abrir <%s> %ld\n", pdir, ret);
*** */
	fprintf(stderr, PegaMsg(1034), pdir);
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("correl");
	    exit(2);
	}
#endif
	exit(2);
    }
    signal(SIGINT, controlC);

}

void controlC(sig)
int sig;
{
    /*
     ** Apagar, se necessario, arquivos temporarios
     */
    extern int descarq;

    if (!flag_exec)
	fprintf(stderr, "\n********  Interrompido pelo usuario\n");

    if (descarq != -1)
	/*                UnlockAFile(descarq); */

	setOSstdin();

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Men_Store("nome_modulo");
	exit(1);
    }
#endif
    exit(sig);
}
