
/***********************************************************************************
 CORREL - Constri a matriz de correlao (Pearson) entre as varivies. 

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Ler os dados e calcular os elementos da matriz de correlao

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/correl/fontes/imprime.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:13:11 $:

***********************************************************************************/

#include "correl.h"


static char *sccsid = "@(#)imprime.c	3.4	(NTIA/correl)	95/01/11";


void imprime(Corr)
struct Correl MY_HUGE *Corr;
{
    int m, l, i, j, ii, jj, k, lcom, lvar;
    double nn, p, r;

    lcom = temcom ? ncom - 1 : ncom;
    lvar = temcom ? 1 : 0;

    for (m = 0; m < lcom; m += 7) {
	if (fl_imp)
	    putchar(12);
	imp_titulo(titulo);
	printf
	    ("Matriz de Correlacoes, Numeros de obs. e Niveis desc. do teste Ho:Correl=0\n\n");

	q_imprime(class, nclass);	/* imprime quebra */

	l = ((m + 7) < lcom) ? m + 7 : lcom;
	printf("         ");
	for (j = m; j < l; ++j) {
	    printf("%10s", vcom[j]);
	}
	printf("\n\n");
	for (i = lvar; i < nvar; ++i) {
	    ii = var[i];
	    for (j = m; j < l; ++j) {
		jj = com[j];
		if (acha(Corr, ii, jj) >= 0) {
		    printf("%-9s", vvar[i]);
		    break;
		}
	    }
	    if (j == l)
		goto imp_nok;
	    for (j = m; j < l; ++j) {
		jj = com[j];
		if ((k = acha(Corr, ii, jj)) < 0)
		    printf("          ");
		else {
		    printf("%10.4f", Corr[k].C);
		}
	    }
	    printf("\n");
	    printf("         ");
	    for (j = m; j < l; ++j) {
		jj = com[j];
		if ((k = acha(Corr, ii, jj)) < 0)
		    printf("          ");
		else {
		    printf("%10d", Corr[k].n);
		}
	    }
	    printf("\n");
	    printf("         ");
	    for (j = m; j < l; ++j) {
		jj = com[j];
		if ((k = acha(Corr, ii, jj)) < 0)
		    printf("          ");
		else {
		    nn = ((double) Corr[k].n) - 2.0;
		    r = Corr[k].C;
		    p = 1.0 - r * r;
		    if (p < EPS)
			p = 0.0;
		    else
			p = 2.0 * tprob(fabs(r * sqrt(nn) / sqrt(p)), nn);
		    printf("   (%5.3f)", p);
		}
	    }
	    printf("\n\n");
	  imp_nok:;
	}
	printf("\n\n");
    }
}
