
/***********************************************************************************
 CORREL - Constri a matriz de correlao (Pearson) entre as varivies. 

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Calcular os elementos da matriz de correlao

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/correl/fontes/processa.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:13:11 $:

***********************************************************************************/

#include "correl.h"
#include <string.h>
#include <stdlib.h>


static char *sccsid = "@(#)processa.c	3.4	(NTIA/correl)	95/01/11";


int processa(Corr)
struct Correl MY_HUGE *Corr;
{
    int n, i, j, ii, jj, l, miss;
    double x, y;

    n = 0;
    for (i = 0; i < nvar; ++i) {
	ii = var[i];
	x = atof(obs[ii]);
	l = temcom ? i : ncom;
	miss = strcmp(obs[ii], ".") != 0;
	for (j = 0; j < l; ++j) {
	    jj = com[j];
	    y = atof(obs[jj]);
	    if (ii != jj) {
		if (miss && strcmp(obs[jj], ".") != 0) {
		    Corr[n].Sx += x;
		    Corr[n].Sy += y;
		    Corr[n].Sx2 += (x * x);
		    Corr[n].Sy2 += (y * y);
		    Corr[n].Sxy += (x * y);
		    Corr[n].n += 1;
		    Corr[n].i = ii;
		    Corr[n].j = jj;
		}
		++n;
	    }
	}
    }

    return (n);
}
