
/***********************************************************************************
 CORREL - Constri a matriz de correlao (Pearson) entre as varivies. 

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Modulo para tratamento de quebra

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/correl/fontes/quebra.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:13:11 $:

***********************************************************************************/

#include "correl.h"
#include <string.h>
#include <stdlib.h>
#include <assert.h>


static char *sccsid = "@(#)quebra.c	3.4	(NTIA/correl)	95/01/11";


#define QBSIZE		1024
static char *quebra[QBSIZE];

#ifdef MSDOS
static int q_testa(char **, int *, int);
#endif


void q_copie(obs, class, nclass)
char *obs[];
int class[];
int nclass;
{
    char *p;
    int i;
    int j;

    p = (char *) &quebra[MAXCLASS];

    for (i = 0; i < nclass; ++i) {
	j = class[i];
	strcpy(p, obs[j]);
	quebra[i] = p;
	p += (strlen(p) + 1);
    }
    assert(p < (char *) &quebra[QBSIZE]);
}



static int q_testa(obs, class, nclass)
char *obs[];
int class[];
int nclass;
{
    int n;
    int i;
    int j;
    double x, y;

    for (i = 0; i < nclass; ++i) {
	j = class[i];
	if (tclass[i] == 0) {
	    n = strcmpi(quebra[i], obs[j]);
	} else {
	    if (strcmp(quebra[i], ".") == 0)
		x = MISSING;
	    else
		x = atof(quebra[i]);
	    if (strcmp(obs[j], ".") == 0)
		y = MISSING;
	    else
		y = atof(obs[j]);
	    if (x == y)
		n = 0;
	    else if (x < y)
		n = -1;
	    else
		n = 1;
	}
	if (n) {
	    switch (ordc) {
	    case 0:		/* ascendente */
		if (n < 0)
		    return (1);
		else
		    erro(12, 1);
	    case 1:		/* descendente */
		if (n > 0)
		    return (1);
		else
		    erro(12, 1);
	    case 2:		/* nao ordenada */
		return (1);
	    }
	}
    }
    return (0);
}



long ler1_obs(obs, class, nclass)
char *obs[];
int class[];
int nclass;
{
    long n;

    if ((n = ler_obs(fd, obs)) != (long) EOF)
	q_copie(obs, class, nclass);

    return (n);
}


long lern_obs(obs, class, nclass)
char *obs[];
int class[];
int nclass;
{
    long n;

    if ((n = ler_obs(fd, obs)) == (long) EOF)
	return (n);
    if (q_testa(obs, class, nclass) == 0)
	return (n);
    return (QUEBRA);
}



void q_imprime(class, nclass)
int class[];
int nclass;
{
    int i;
    char pbuff[15];

    if (nclass) {
	printf("      --- ");
	for (i = 0; i < nclass; ++i) {
	    if (tclass[i] == 2)
		printf("%s=%s ", vclass[i], dtoa(atof(quebra[i]), pbuff));
	    else
		printf("%s=%s ", vclass[i], quebra[i]);
	}
	printf("---\n\n");
    }
}
