/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo principal.	

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maria Fernanda Moura
	  Maurcio Noronha Festa
	  Slvio Roberto Medeiros Evangelista
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#define VAR1
#include <string.h>
#include "estat.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/* ........................  FLAGS .............................. */

int linhas = NLINHAS;		/* num.de linhas p/relatorio       */
int ncolunas = LARGURA;		/* num.de colunas p/relatorio      */
int comeco = 1;			/* indica inicio do processamento  */
int output = 0;			/* se ha ou nao arquivo_ntia_saida */
int flag_imp = 1;		/* Flag de impressao do resultado  */
int flagX = 1;			/* assume-se flagX verdadeira para o estat como sw livre */
int flagP = 0;			/* se ha ou nao mudanca de pagina  */
int mnmx = 0;			/* se calcula minimo e/ou maximo   */
int flaghdr = 0;		/* se hdr ja criado tem valor um   */

/* ............. CONTROLES PARA USAR HASHING ..................... */

int cpercentis = 0;		/* se ha calculos de percentis     */
int ehashing = 0;		/* se ha estatisticas que precisam da
				   tabela de hashing  */
int ghashing = 0;		/* se ha graficos que precisam da
				   tabela de hashing  */
int tamhash;			/* tamanho  da tabela de hashing   */
int tamnome;			/* tamanho do vetor nomes          */
unsigned int nobs = 0;		/* posicao relativa da ultima obs. lida    */
unsigned int obsant = 0;	/* pos.rel. da primeira obs. de uma classe */
int v_hash = -1;		/* primeira variavel para hashing          */

/* ............................................................... */

char **aux_ins;
int aux_insm;
int controle = 0;

/* ............................................................... */

unsigned int obs_corr = 0;	/* correcao para o valor final do numero
				   de observacoes em caso de final de ar-
				   quivo */

main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{
    int j;
    int mudouby = 0;
    double a1, a2;		/* variaveis para comparar valores numericos --- class */
    long ret;

    /* Inicializacao dos descritores */

    if ((aux_ins = (char **) calloc(50, sizeof(char *))) == NULL) {
	fprintf(stderr, PegaMsg(1039));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("estat");
	    exit(1);
	}
#endif
	exit(1);
    }

    aux_insm = 50;
    for (j = 0; j < aux_insm; j++) {
	if ((aux_ins[j] = (char *) calloc(MAXNOME, sizeof(char))) == NULL) {
	    fprintf(stderr, PegaMsg(1039));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("estat");
		exit(1);
	    }
#endif
	    exit(1);
	}
    }
    getpar(argc, argv, &flagP, &flag_imp, &flagX, &output, &linhas,
	   &ncolunas);
    semantica();
    /* aloca os vetores que serao utilizados para os calculos */

    aloc_ests();

    /* inicializa valores e flags de miss */

    ini_flag();

    /* decide quais rotinas de calculo serao utilizadas */

    decide(&mnmx, &ehashing, &ghashing, &cpercentis);

    if (ehashing || ghashing)
	ini_hash();

    signal(SIGFPE, estourou);

    while ((nobs = (unsigned int) ler_obs(fd, obs)) != (unsigned int) EOF) {

	obs_corr = nobs;
	for (j = 0; j < nvar; ++j)
	    if (strcmp(obs[posvar[j]], ".") == 0)
		missing[j] = 1;
	    else {
		x[j] = atof(obs[posvar[j]]);
		missing[j] = 0;
	    }
	for (j = 0; j < nby; ++j) {
	    strcpy(by[j], obs[posclass[j]]);
	}
	if (pondera) {
	    if (strcmp(obs[pospeso], ".") == 0)
		goto outro;
	    else
		wt = atof(obs[pospeso]);
	    if (wt <= 0.) {
		fprintf(stderr, PegaMsg(3077));
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("***Lista de memoria nao esta vazia ***\n");
		    Mem_Store("estat");
		    exit(1);
		}
#endif
		exit(1);
	    }
	} else
	    wt = 1.0;		/* peso = 1 */
	if (nfreq) {
	    if (strcmp(obs[posfreq], ".") == 0)
		goto outro;
	    else
		qfreq = atof(obs[posfreq]);
	    if ((qfreq <= 0.0) || (qfreq != (double) ((int) qfreq))) {
		fprintf(stderr, PegaMsg(3078));
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("***Lista de memoria nao esta vazia ***\n");
		    Mem_Store("estat");
		    exit(1);
		}
#endif
		exit(1);
	    }
	} else
	    qfreq = 1.0;	/* frequencia = 1 */
	if (comeco) {
	    comeco = 0;
	    ini_by();
	} else {
	    for (j = 0; j < nby; ++j) {
		if (tipby[j] == 'c') {
		    if (strcmpi(by[j], ant[j]) != 0) {
			mudouby = 1;
			break;
		    }
		} else {
		    if (strcmp(by[j], ".") == 0)
			a1 = MISSING;
		    else
			a1 = atof(by[j]);
		    if (strcmp(ant[j], ".") == 0)
			a2 = MISSING;
		    else
			a2 = atof(ant[j]);
		    if (lfuzz(a1, a2) != 0) {
			mudouby = 1;
			break;
		    }
		}
	    }
	    if (mudouby) {
		veri_class();
		if (ehashing || ghashing) {
		    trata_outras(&obsant, &v_hash, &nobs);
		    ini_hash();
		}
		if (flag_imp) {
		    fprintf(stderr, "\r         \n");
		    imprime();
		}
		if (output) {
		    if (!flaghdr) {
			outhdr();
			flaghdr = 1;
		    }
		    grava_ntia();
		}
		ini_by();
		ini_flag();
		mudouby = 0;
	    }
	}
	for (j = 0; j < nvar; ++j) {
	    if ((inicio[j] == 0) && (missing[j] == 0)) {
		inicio[j] = 1;
		ini_var(j);
	    }
	}
	for (j = 0; j < nvar; ++j) {
	    if ((missing[j] == 0) && (inicio[j]) == 2) {
		if (mnmx)
		    aminmax(x[j], j);
		momentos(x[j], wt, qfreq, j);
		if (v_hash == j)
		    t_hashing(v_hash);
	    } else {
		if (inicio[j] == 1)
		    inicio[j] = 2;
	    }
	}
      outro:;
    }
    if (ehashing || ghashing) {
	/* trata_outras(&obsant,&v_hash,&nobs); */
	++obs_corr;
	trata_outras(&obsant, &v_hash, &obs_corr);
    }
    if (flag_imp) {
	fprintf(stderr, "\r         \n");
	imprime();
    }
    if (output) {
	if (!flaghdr)
	    outhdr();
	grava_ntia();
	if ((ret = fech_arq(fout)) < 0L && ret >= -2L) {
	    fprintf(stderr, PegaMsg(5005), "");
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("estat");
		exit(5);
	    }
#endif
	    setOSstdin();
	    exit(2);
	}
    }
    if ((ret = fech_arq(fd)) < 0L && ret >= -2L) {
	fprintf(stderr, PegaMsg(1011), "");
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("estat");
	    exit(5);
	}
#endif
	setOSstdin();
	exit(2);
    }
    libera_est();
    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("estat");
	exit(5);
    }
#endif

    /* Final da execucao do programa */
    exit(0);
}

/*.......................................................................*/

void ini_by()
{
    int i;

    for (i = 0; i < nby; ++i)
	strcpy(ant[i], by[i]);
}

/*.......................................................................*/

void ini_flag()
{
    /* Inicializa o calculo de momentos (em relacao aa media) */
    int i;

    for (i = 0; i < nvar; ++i) {
	inicio[i] = 0;
	wsum[i] = 0.0;
	wfreq[i] = 0.0;
	xmean[i] = MISSING;
	xmean2[i] = MISSING;
	s2[i] = MISSING;
	s22[i] = MISSING;
	if (pert(est, "curtose") || pert(est, "assimetria"))
	    s3[i] = MISSING;
	if (pert(est, "curtose"))
	    s4[i] = MISSING;
	if (mnmx) {
	    xmin[i] = MISSING;
	    xmax[i] = MISSING;
	}
	soma[i] = MISSING;
    }
}

/*.......................................................................*/

void aminmax(x, pos)
double x;
int pos;
{
    if (x < xmin[pos])
	xmin[pos] = x;
    if (x > xmax[pos])
	xmax[pos] = x;
}

/*.......................................................................*/

void momentos(p1, p2, p3, i)
double p1, p2, p3;
int i;
{

    double btemp, atemp;	/* considera pesos */
    double btemp2, atemp2;	/* nao considera pesos */
    double xtemp;		/* considera pesos */
    double xtemp2;		/* nao considera pesos */
    double wtemp;
    double ftemp;
    wtemp = p2 * p3;
    ftemp = p3;

    soma[i] = soma[i] + p1 * ftemp;
    xtemp = p1 - xmean[i];
    xtemp2 = p1 - xmean2[i];
    atemp = wtemp * xtemp;
    atemp2 = ftemp * xtemp2;
    wsum[i] += wtemp;
    wfreq[i] += ftemp;
    btemp = atemp / wsum[i];
    btemp2 = atemp2 / wfreq[i];
    atemp = atemp * (xtemp - btemp);
    atemp2 = atemp2 * (xtemp2 - btemp2);
    if (pert(est, "curtose")) {
	s4[i] = s4[i] + btemp2 * (-4.0 * s3[i] + btemp2 *
				  (6.0 * s22[i] +
				   xtemp2 * xtemp2 * ((wfreq[i] - ftemp)
						      / (wfreq[i] *
							 ftemp)) *
				   (wfreq[i] * wfreq[i] -
				    3.0 * ftemp * wfreq[i] +
				    3.0 * ftemp * ftemp)));
    }
    if (pert(est, "curtose") || pert(est, "assimetria")) {
	s3[i] = s3[i] + btemp2 * (-3.0 * s22[i] + xtemp2 * xtemp2 * ((wfreq
								      [i] -
								      ftemp)
								     *
								     (wfreq
								      [i] -
								      2.0 *
								      ftemp)
								     /
								     wfreq
								     [i]));
    }
    s2[i] = atemp + s2[i];
    s22[i] = atemp2 + s22[i];
    xmean[i] = btemp + xmean[i];
    xmean2[i] = btemp2 + xmean2[i];
}

/*.......................................................................*/

void ini_var(i)
int i;
{
    s2[i] = 0.0;
    xmean[i] = x[i];
    s22[i] = 0.0;
    xmean2[i] = x[i];
    wsum[i] = wt * qfreq;
    wfreq[i] = qfreq;
    if (mnmx) {
	xmin[i] = xmean[i];
	xmax[i] = xmean[i];
    }
    if (pert(est, "curtose"))
	s4[i] = 0.0;
    if (pert(est, "curtose") || pert(est, "assimetria"))
	s3[i] = 0.0;
    soma[i] = x[i] * qfreq;
    if (v_hash == i)
	t_hashing(v_hash);
}

/*.......................................................................*/

void decide(mnmax, ehashing, ghashing, cpercentis)
int *mnmax;
int *ehashing;
int *ghashing;
int *cpercentis;
{
    if (pert(est, "minimo") || pert(est, "maximo"))
	*mnmax = 1;
    else
	*mnmax = 0;

    if (pert(est, "mediana") || pert(est, "moda")
	|| pert(est, "D_Kolmog."))
	*ehashing = 1;

    if (pert(est, "p05") ||
	pert(est, "p10") || pert(est, "p15") || pert(est, "p20") ||
	pert(est, "p25") || pert(est, "p30") || pert(est, "p35") ||
	pert(est, "p40") || pert(est, "p45") || pert(est, "p50") ||
	pert(est, "p55") || pert(est, "p60") || pert(est, "p65") ||
	pert(est, "p70") || pert(est, "p75") || pert(est, "p80") ||
	pert(est, "p85") || pert(est, "p90") || pert(est, "p95")) {
	*ehashing = 1;
	*cpercentis = 1;
    }
    if (nrf || nbp || nnp)
	*ghashing = 1;
}

/*.......................................................................*/

void estourou(sig)
int sig;
{
    fprintf(stderr, PegaMsg(1026));
    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("estat");
	exit(1);
    }
#endif
    exit(1);
}

/*.......................................................................*/

void veri_class()
{
    int ok = 1;
    int igual = 1;
    int n;
    double a1, a2;
    int i;

    for (i = 0; (i < nby) && igual; i++) {
	if (tipby[i] == 'c') {
	    n = strcmpi(by[i], ant[i]);
	    if (tip_ord == 'a') {
		if (n < 0) {
		    ok = 0;
		    break;
		}
	    } else {
		if (n > 0) {
		    ok = 0;
		    break;
		}
	    }
	    if (n != 0)
		igual = 0;
	} else {
	    if (strcmp(by[i], ".") == 0)
		a1 = MISSING;
	    else
		a1 = atof(by[i]);
	    if (strcmp(ant[i], ".") == 0)
		a2 = MISSING;
	    else
		a2 = atof(ant[i]);
	    if (((tip_ord == 'a') && (a1 < a2)) ||
		((tip_ord == 'd') && (a1 > a2))) {
		ok = 0;
		break;
	    }
	    if (lfuzz(a1, a2) != 0)
		igual = 0;
	}
    }
    if (!ok) {
	printf(PegaMsg(1082));
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("estat");
	    exit(1);
	}
#endif
	exit(1);
    }
}

void libera_est()
{
    int i;

    free(missing);
    free(inicio);
    free(soma);
    free(xmean);
    free(xmean2);
    free(wsum);
    free(wfreq);
    free(s2);
    free(s22);
    if (pert(est, "mediana"))
	free(mediana);
    if (pert(est, "curtose"))
	free(s4);
    if (pert(est, "curtose") || pert(est, "assimetria"))
	free(s3);
    if (pert(est, "D_Kolmog."))
	free(kolmogorov);
    if (pert(est, "minimo") || pert(est, "maximo")) {
	free(xmin);
	free(xmax);
    }
    if (pert(est, "moda"))
	free(moda);
    if (pert(est, "p05") || pert(est, "p10") || pert(est, "p15") ||
	pert(est, "p20") || pert(est, "p25") || pert(est, "p30") ||
	pert(est, "p35") || pert(est, "p40") || pert(est, "p45") ||
	pert(est, "p50") || pert(est, "p55") || pert(est, "p60") ||
	pert(est, "p65") || pert(est, "p70") || pert(est, "p75") ||
	pert(est, "p80") || pert(est, "p85") || pert(est, "p90") ||
	pert(est, "p95"))
	free(percentis);
}
