/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo que contem as funcoes referentes a tabela de hashing

 Desenvolvido por:

	  Slvio Roberto Medeiros Evangelista
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include "estat.h"

extern int tamhash;

int hash(s)
char *s;			/* ponteiro para a tabela */
{
    long valhash;
    int aux;
    int i = 0;

    for (valhash = 0L; *s != '\0';) {
	valhash += (*s + i);
	s++;
	i++;
    }
    aux = (int) (valhash % ((long) tamhash));
    return (aux);
}

struct simb *pesquisa(s, tab)
char *s;
struct simb **tab;
{
    struct simb *as;

    for (as = tab[hash(s)]; as != SNULL; as = as->proximo) {
	if (strcmp(s, as->nome) == 0)
	    return (as);

    }
    return (SNULL);
}

struct simb *instala(nome, def, tabhash)
char *nome;			/* obs. a ser instalada na tabela */
TIPO_H def;			/* contem informacao sobre obs. */
struct simb **tabhash;		/* tabela onde havera a instalacao */
{
    int valhash;
    struct simb *as;

    as = (struct simb *) aloc(1, sizeof(struct simb));
    as->nome = guardacad(nome);
    valhash = hash(as->nome);
    as->proximo = tabhash[valhash];
    tabhash[valhash] = as;
    as->def = def;
    return (as);
}
