/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo de declaraes dos operadores usados pelo tipo Lista Encadeada
    O tipo lista implementado aqui foi baseado na lista definida em "Aho, A.V. & Hopcroft, 
    J.E & Ullman, J.D.Data Structures and Algorithms, Addison-Wesley, 1983"
    
 Desenvolvido por:

 	  Antonio Luis Peloso
	  Carla Geovana do Nascimento Macrio
	  Fani Barbosa Camargo
	  Maria Fernanda Moura
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#ifndef	__ATOMIC
#include	"atomic.h"
#endif

#define	__LISTA	(100)

typedef	int	Node;

typedef struct	No	{
	Node	Posicao;
	Dado	Elemento;
	struct	No *Ant;
	struct	No *Prox;
} No;

struct	Lista { 
	int	Tam;
	No	*Prim, *Ulti;
};

typedef	struct Lista	*Lista;

#define	L_Size()	(sizeof(struct Lista))

#ifdef MSDOS

extern Lista	L_Create(void);
extern void	L_Destroy(Lista);
extern void	L_MakeNull(Lista);
extern void	L_Insert(Lista, Dado, Node);
extern void	L_Delete(Lista, Node);
extern void	L_Split(Lista, Lista, Lista, Node);
extern void	L_Join(Lista, Lista, Lista);
extern void	L_Swap(Lista, Node, Node);
extern Dado	TrocaDado(Dado, Dado);
extern Dado	L_Retrieve(Lista, int);
extern int	L_Locate(Lista, Dado);
extern int	L_Next(Lista, int);
extern int	L_Previous(Lista, int);
extern int	L_End(Lista);
extern Dado	L_First(Lista);

#else

extern Lista	L_Create();
extern void	L_Destroy();
extern void	L_MakeNull();
extern void	L_Insert();
extern void	L_Delete();
extern void	L_Split();
extern void	L_Join();
extern void	L_Swap();
extern Dado	TrocaDado();
extern Dado	L_Retrieve();
extern int	L_Locate();
extern int	L_Next();
extern int	L_Previous();
extern int	L_End();
extern Dado	L_First();

#endif

/*
//	Final de lista.h
*/
