/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo que implementa funcoes referentes a alocacao ou liberacao de memoria
    
 Desenvolvido por:

 	  Maria Fernanda Moura
	  Slvio Roberto Medeiros Evangelista
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include "estat.h"

char *aloc(n, t)
int n;				/* tamanho do espaco a ser alocado */
int t;				/* tamanho de cada elemento */
{
    char *p;

    p = (char *) calloc((unsigned) n, (unsigned) t);
    if (p == CNULL) {
	fprintf(stderr, PegaMsg(1039));
	setOSstdin();
	exit(1);
    }
    return (p);
}


char *realoca(nome, tipo, tam)
char **nome;
int tipo;
int tam;
{
    char *p;

    p = (char *) realloc((char *) nome, (unsigned) (tam * tipo));
    if (p == CNULL) {
	fprintf(stderr, PegaMsg(1039));
	setOSstdin();
	exit(1);
    }
    return (p);
}


char *guardacad(s)
char *s;			/* aponta para cadeia a ser guardada */
{
    char *ap;

    if ((ap = aloc(strlen(s) + 1, sizeof(char))) != CNULL)
	strcpy(ap, s);
    else {
	fprintf(stderr, PegaMsg(1039));
	setOSstdin();
	exit(1);
    }
    return (ap);
}
