/***********************************************************************************
 ESTAT - Clculo de Estatsticas Descritivas
 
 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo integrante do software ESTAT, que  calcula estatsticas descritivas 
    de variveis  numricas. As  estatsticas  que  podem  ser requeridas so: nmero 
    de observaes, valor mnimo, valor mximo, total, mdia, varincia, desvio padro, 
    erro padro, coeficiente de variao, assimetria, curtose, mediana, estatstica D 
    de Kolmogorov, percentis e modas.
    Este  o mdulo que implementa a anlise semantica dos comandos especificados para 
    a execuo do software ESTAT.
    
 Desenvolvido por:

 	  Maria Fernanda Moura
	  Slvio Roberto Medeiros Evangelista
	  
 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <string.h>
#include <setjmp.h>

#if !defined(VAXVMS) & !defined(SCO) & !defined(i486)
#include <search.h>
#endif

#include "getoken.h"
#include "estat.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/* ..........Estatisticas que podem aparecer em um <listest> ...............*/

static char *estat[] = {
    "n",			/* 1  : numero de observacoes   */
    "m",			/* 2  : media                   */
    "dp",			/* 3  : desvio_padrao           */
    "ep",			/* 4  : erro-padrao             */
    "cv",			/* 5  : coeficiente de variacao */
    "as",			/* 6  : assimetria              */
    "c",			/* 7  : curtose                 */
    "me",			/* 8  : mediana                 */
    "mo",			/* 9  : moda                    */
    "mn",			/* 10 : minimo                  */
    "mx",			/* 11 : maximo                  */
    "p05",			/* 12 : percentil ==>> 0.05     */
    "p10",			/* 13 : percentil ==>> 0.10     */
    "p15",			/* 14 : percentil ==>> 0.15     */
    "p20",			/* 15 : percentil ==>> 0.20     */
    "p25",			/* 16 : percentil ==>> 0.25     */
    "p30",			/* 17 : percentil ==>> 0.30     */
    "p35",			/* 18 : percentil ==>> 0.35     */
    "p40",			/* 19 : percentil ==>> 0.40     */
    "p45",			/* 20 : percentil ==>> 0.45     */
    "p50",			/* 21 : percentil ==>> 0.50     */
    "p55",			/* 22 : percentil ==>> 0.55     */
    "p60",			/* 23 : percentil ==>> 0.60     */
    "p65",			/* 24 : percentil ==>> 0.65     */
    "p70",			/* 25 : percentil ==>> 0.70     */
    "p75",			/* 26 : percentil ==>> 0.75     */
    "p80",			/* 27 : percentil ==>> 0.80     */
    "p85",			/* 28 : percentil ==>> 0.85     */
    "p90",			/* 29 : percentil ==>> 0.90     */
    "p95",			/* 30 : percentil ==>> 0.95     */
    "v",			/* 31 : variancia               */
    "D",			/* 32 : est. D de kolmogorov    */
    "tt",			/* 33 : total                   */
    0
};

/* ..... nomes das estatisticas nos conjuntos "est" e "ests" .....*/

static char *nomest[] = {
    "n", "media", "desv.padrao", "err.padrao", "coef.var.",
    "assimetria", "curtose", "mediana", "moda", "minimo", "maximo",
    "p05", "p10", "p15", "p20", "p25", "p30", "p35", "p40",
    "p45", "p50", "p55", "p60", "p65", "p70", "p75", "p80",
    "p85", "p90", "p95",
    "variancia", "D_Kolmog.", "total",
    0
};

/* ....... tamanho dos vetores estat e nomest ....... */

#define TAMEST 33

jmp_buf go;

extern int output;		/* se ha ou nao arquivo_ntia_saida */
/* ...................................................................*/

void semantica()
{
    extern void exit();
    int teste;
    double mmax;
    double mmin;
    char nome[MAXNOME];
    char token[128];
    char tipo;
    char temp;
    int i;
    int c;
    int nv;			/* var. de controle para o numero de cmd VAR     */
    int nb;			/* var. de controle para o numero de cmd BY      */
    int ncp;			/* var. de controle para o numero de cmd PESO    */
    int ne;			/* var. de controle para o numero de cmd EST     */
    int nes;			/* var. de controle para o numero de cmd ESTS    */
    int nvs;			/* var. de controle para o numero de cmd VARS    */
    int ncrf;			/* var. de controle para o numero de cmd RF      */
    int ncbp;			/* var. de controle para o numero de cmd BP      */
    int ncnp;			/* var. de controle para o numero de cmd NP      */
    int ncf;			/* var. de controle para o comando "FREQ"        */
    char *P;

    setjmp(go);

    /* inicializa variaveis de controle */
    nvar = nby = nvars = 0;
    nrf = nbp = nnp = nest = nests = ntit = 0;
    pondera = 0;
    nv = ncf = nb = ncp = ne = nes = nvs = ncrf = ncbp = ncnp = 0;
    teste = 0;

    /* ................................ */

    for (;;) {
	c = getoken(token);

	if ((c == EOF) || (c == RB)) {
	    break;
	}

	if (strcmpi(token, "cancela") == 0) {
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("estat");
		exit(0);
	    }
#endif
	    exit(0);
	}

	teste = descobre(&temp, token);

	if (teste == -1)
	    erroc(8);

	switch (temp) {

	case 'v':
	    if (++nv > 1)
		erroc(7);
	    var = listvar(fd, posvar, 'n', &nvar);
	    break;
	case 'p':
	    if (++nb > 1)
		erroc(7);
	    class = listclass(fd, posclass, ' ', &nby);
	    break;
	case 'w':
	    if (++ncp > 1)
		erroc(7);
	    peso = umavar(fd, &pospeso, 'n', &pondera);
	    break;
	case 'e':
	    if (++ne > 1)
		erroc(7);
	    est = listest(&nest);
	    break;
	case '&':
	    if (++nes > 1)
		erroc(7);
	    ests = listest(&nests);
	    break;
	case 's':
	    if (++nvs > 1)
		erroc(7);
	    vars = listvar(fd, pvar_s, 'n', &nvars);
	    break;
	case 'r':
	    if (++ncrf > 1)
		erroc(7);
	    rf = listvar(fd, posrf, 'n', &nrf);
	    break;
	case 'b':
	    if (++ncbp > 1)
		erroc(7);
	    bp = listvar(fd, posbp, 'n', &nbp);
	    break;
	case 'n':
	    if (++ncnp > 1)
		erroc(7);
	    np = listvar(fd, posnp, 'n', &nnp);
	    break;
	case 't':
	    if (ntit >= MAXTIT)
		erroc(15);
	    tk_titulo();
	    break;
	case 'f':
	    if (++ncf > 1)
		erroc(7);
	    freq = umavar(fd, &posfreq, 'n', &nfreq);
	    break;
	default:
	    erroc(8);
	    break;
	}
    }

    /* Consistencia entre os comandos */

    if ((nvar == 0) || (strcmpi(L_Retrieve(var, 1), "todas") == 0)) {
	if (nvar == 0)
	    var = L_Create();
	else {
	    ret(var, "todas");
	    nvar = 0;
	}
	for (i = 0; i < MAXVAR; ++i) {
	    if ((pega_var(fd, i, nome, &tipo, (MINVAL *) & mmin,
			  (MAXVAL *) & mmax) == EOF))
		break;
	    if (tipo == 'n') {
		if (nby)
		    if (pert(class, nome))
			goto l1;
		if (pondera)
		    if (pert(peso, nome))
			goto l1;
		if (nfreq)
		    if (pert(freq, nome))
			goto l1;
		ins(var, nome);
		posvar[nvar++] = i;
	      l1:;
	    }
	}
    }
    if (pondera) {
	if (econt(peso, var))
	    erroc(10);
	if (nby && econt(peso, class))
	    erroc(10);
	if (nfreq && econt(peso, freq))
	    erroc(10);
    }
    if (nfreq) {
	if (econt(freq, var))
	    erroc(10);
	if (nby && econt(freq, class))
	    erroc(10);
    }
    if (nby)
	if (card(inter(class, var)))
	    erroc(10);
    if (nvars) {
	if (!output)
	    erroc(12);
	if (strcmpi(L_Retrieve(vars, 1), "todas") == 0)
	    idemvar(var, posvar, pvar_s, &nvars, vars);
	else if (!econt(vars, var))
	    erroc(13);
    } else if (output) {
	vars = L_Create();
	ins(vars, "todas");
	idemvar(var, posvar, pvar_s, &nvars, vars);
    }
    if (nrf) {
	if (strcmpi(L_Retrieve(rf, 1), "todas") == 0)
	    idemvar(var, posvar, posrf, &nrf, rf);
	else if (!econt(rf, var))
	    erroc(13);
    }
    if (nbp) {
	if (strcmpi(L_Retrieve(bp, 1), "todas") == 0)
	    idemvar(var, posvar, posbp, &nbp, bp);
	else if (!econt(bp, var))
	    erroc(13);
    }
    if (nnp) {
	if (strcmpi(L_Retrieve(np, 1), "todas") == 0)
	    idemvar(var, posvar, posnp, &nnp, np);
	else if (!econt(np, var))
	    erroc(13);
    }
    if (!nest) {
	est = L_Create();
	ins(est, "n");
	ins(est, "media");
	ins(est, "desv.padrao");
	ins(est, "minimo");
	ins(est, "maximo");
	ins(est, "total");
    }
    if (nest && (strcmpi(L_Retrieve(est, 1), "todas") == 0)) {
	ret(est, "todas");
	for (i = 0; i < TAMEST; i++)
	    ins(est, nomest[i]);
    }
    if (nests) {
	if (!output)
	    erroc(12);
	if (strcmpi(L_Retrieve(ests, 1), "todas") == 0) {
	    ret(ests, "todas");
	    for (i = 1; (P = L_Retrieve(est, i)) != DNULL; i++)
		ins(ests, P);
	} else if (!econt(ests, est))
	    erroc(14);
    } else {
	if (output) {
	    if (!nest) {
		ests = L_Create();
		ins(ests, "n");
		ins(ests, "media");
		ins(ests, "desv.padrao");
		ins(ests, "minimo");
		ins(ests, "maximo");
		ins(ests, "total");
	    } else {
		ests = L_Create();
		for (i = 1; (P = L_Retrieve(est, i)) != DNULL; i++)
		    ins(ests, P);
	    }
	}
    }

}

/* ...................................................................*/

void idemvar(var, posvar, posls, n, ls)
Lista var;
int posvar[];
int posls[];
int *n;
Lista ls;
{
    int i;
    char *P;

    ret(ls, "todas");
    *n = 0;
    for (i = 1; (P = L_Retrieve(var, i)) != DNULL; i++) {
	ins(ls, P);
	posls[(*n)++] = posvar[i - 1];
    }
}

/* ...................................................................*/

Lista listvar(fd, lspos, tpdes, n)
ARQ *fd;			/* descritor para o arquivo_ntia */
int lspos[];			/* lista para as posicoes das variaveis */
char tpdes;			/* tipo para as variaveis */
int *n;
{
    int i;
    int c;
    char nome[MAXNOME];
    char token[128];
    double mmin;
    double mmax;
    char tipo;
    Lista lsnome;
    long ret;

    *n = 0;
    lsnome = L_Create();
    c = getoken(token);
    if (strcmpi(token, "todas") == 0) {
	ins(lsnome, "todas");
	++(*n);
	c = getoken(token);
	if (c != PTVG)
	    erroc(15);
    } else {
	do {
	    if (c != VARIAV)
		erroc(1);
	    if (pert(lsnome, token))
		erroc(2);
	    if ((i = veri_var(fd, token)) < 0)
		erroc(3);
	    if (tpdes != ' ') {
		if ((ret =
		     (long) pega_var(fd, i, nome, &tipo, (MINVAL *) & mmin,
				     (MAXVAL *) & mmax)) < 0L) {
		    fprintf(stderr, PegaMsg(1062));
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf("***Lista de memoria nao esta vazia ***\n");
			Mem_Store("estat");
			exit(0);
		    }
#endif
		    setOSstdin();
		    exit(2);
		}
		if (tpdes != tipo) {
		    if (tpdes == 'n')
			erroc(4);
		    else if (tpdes == 'd')
			erroc(6);
		    else
			erroc(5);
		}
	    }
	    ins(lsnome, token);
	    lspos[*n] = i;
	    ++(*n);
	    c = getoken(token);
	} while (c != PTVG);
    }
    return (lsnome);
}

/* .....................................................................*/

Lista listclass(fd, lspos, tpdes, n)
ARQ *fd;			/* descritor para o arquivo_ntia */
int lspos[];			/* lista para as posicoes das variaveis */
char tpdes;			/* tipo para as variaveis */
int *n;
{
    int i;
    int c;
    char nome[MAXNOME];
    char token[128];
    double mmin;
    double mmax;
    char tipo;
    Lista lsnome;
    long ret;

    tip_ord = 'a';
    *n = 0;
    lsnome = L_Create();
    c = getoken(token);
    do {
	if (c != VARIAV)
	    erroc(1);
	if (pert(lsnome, token))
	    erroc(2);
	if ((i = veri_var(fd, token)) < 0)
	    erroc(3);
	if ((ret =
	     (long) pega_var(fd, i, nome, &tipo, (MINVAL *) & mmin,
			     (MAXVAL *) & mmax)) < 0L) {
	    fprintf(stderr, PegaMsg(1062));
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("estat");
		exit(0);
	    }
#endif
	    setOSstdin();
	    exit(2);
	}
	if (tpdes != ' ') {
	    if (tpdes != tipo) {
		if (tpdes == 'n')
		    erroc(4);
		else if (tpdes == 'd')
		    erroc(6);
		else
		    erroc(5);
	    }
	}
	tipby[*n] = tipo;
	ins(lsnome, token);
	lspos[*n] = i;
	++(*n);
	if (*n > MAXBY)
	    erroc(17);
	c = getoken(token);
	if (strcmpi(token, "ord") == 0) {
	    c = getoken(token);
	    if (c != IGUAL)
		erroc(18);
	    c = getoken(token);
	    if (strcmpi(token, "asc") == 0)
		tip_ord = 'a';
	    else if (strcmpi(token, "desc") == 0)
		tip_ord = 'd';
	    else
		erroc(19);
	    c = getoken(token);
	    if (c != PTVG)
		erroc(20);
	    else
		break;
	}

    } while (c != PTVG);
    return (lsnome);
}

/* ...................................................................*/

Lista umavar(fd, lspos, tpdes, n)
ARQ *fd;			/* descritor para arquivo_ntia */
int lspos[];			/* lista para as posicoes das variaveis */
char tpdes;			/* tipo para as variaveis */
int *n;
{
    int i;
    char nome[MAXNOME];
    char token[128];
    double mmin;
    double mmax;
    char tipo;
    Lista lsnome;
    long ret;

    *n = 0;
    lsnome = L_Create();
    if (getoken(token) != VARIAV)
	erroc(1);
    if ((i = veri_var(fd, token)) < 0)
	erroc(3);
    if (tpdes != ' ') {
	if ((ret =
	     (long) pega_var(fd, i, nome, &tipo, (MINVAL *) & mmin,
			     (MAXVAL *) & mmax)) < 0L) {
	    fprintf(stderr, PegaMsg(1062));
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("estat");
		exit(0);
	    }
#endif
	    setOSstdin();
	    exit(2);
	}
	if (tpdes != tipo) {
	    if (tpdes == 'c')
		erroc(5);
	    else if (tpdes == 'd')
		erroc(6);
	    else
		erroc(4);
	}
    }
    ins(lsnome, token);
    lspos[*n] = i;
    ++(*n);
    if (getoken(token) != PTVG)
	erroc(6);
    return (lsnome);
}

/* ...................................................................*/

Lista listest(n)
int *n;
{
    Lista ls;
    int i;
    int achou;
    char token[128];
    int c;

    *n = 0;
    ls = L_Create();
    c = getoken(token);
    if (strcmpi(token, "todas") == 0) {
	ins(ls, "todas");
	++(*n);
	c = getoken(token);
	if (c != PTVG)
	    erroc(15);
    } else {
	do {
	    achou = 0;
	    for (i = 0; i < TAMEST; i++) {
		if (strcmpi(token, estat[i]) == 0) {
		    achou = 1;
		    break;
		}
	    }
	    if (!achou)
		erroc(11);
	    ins(ls, nomest[i]);
	    ++(*n);
	    c = getoken(token);
	} while (c != PTVG);
    }
    return (ls);
}

/* ...................................................................*/

void tk_titulo()
{
    int i = 0;
    int c;

    while ((c = xgetc(stdin)) == ' ' || c == '\t' || c == '\n');
    while (c != ';' && i < TAMTIT) {
	titulo[ntit][i++] = (char) c;
	c = xgetc(stdin);
    }
    titulo[ntit][i] = 0;
    ++ntit;
}

/* ...................................................................*/

descobre(temp, token)
char *temp;
char *token;
{
    *temp = 'x';
    if ((strcmpi(token, "var") == 0) || (strcmpi(token, "variavel")) == 0)
	*temp = 'v';
    if ((strcmpi(token, "vars") == 0))
	*temp = 's';
    if ((strcmpi(token, "est") == 0))
	*temp = 'e';
    if ((strcmpi(token, "ests") == 0))
	*temp = '&';
    if ((strcmpi(token, "rep") == 0))
	*temp = 'f';
/*
	if (strcmpi(token,"np") == 0) 		*temp = 'n';
	if (strcmpi(token,"bp") == 0) 		*temp = 'b';
	if (strcmpi(token,"rf") == 0) 		*temp = 'r';
*/
    if ((strcmpi(token, "class") == 0) || (strcmpi(token, "classif")) == 0)
	*temp = 'p';
    if (strcmpi(token, "peso") == 0)
	*temp = 'w';
    if ((strcmpi(token, "tl") == 0) || (strcmpi(token, "titulo")) == 0)
	*temp = 't';
    if (*temp == 'x')
	return (-1);
    else
	return (1);
}

/* ...................................................................*/

static int arg_erro[] = {
    3002,
    3151,
    1062,
    3009,
    3152,
    3004,
    3003,
    3005,
    9999,			/* nao usado */
    3079,
    3080,
    3081,
    3082,
    3083,
    3022,
    9999,			/* nao usado */
    1081,
    3084,
    3021,
    3022,
    0
};

/* ...................................................................*/

void erroc(n)
int n;
{
    int c;
    fprintf(stderr, "%sEntre com todos os comandos novamente.\n",
	    PegaMsg(arg_erro[n - 1]));
    while ((c = xgetc(stdin)) != '\n' && c != EOF);
    longjmp(go, -1);
}

/* ...................................................................*/
