/* --------------------------------------------------------------------------
**
** ENTRADA.C : Funcoes referentes a analise dos comandos do usuario 
**
** Programado  por:
**
**	Sonia  Ternes - 1988/89
**
** ------------------------------------------------------------------------- */


#include <stdio.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include <string.h>
#include <stdlib.h>
#include "pcsgbd.h"
#include "freq.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "%W%	%Y%	%E%";

/* ------------------------------------------------------------------------
** getpar()
** 	Programado por:	Silvio Evangelista
**	Data:		Junho 1988	
**	Descricao:	Le as flags e abre o arquivo de dados
**	Variaveis sai.	[a-z]flag	flags ligadas no processamento
** ------------------------------------------------------------------------- */

extern ARQ *fd;
extern ARQ *fout;
extern int output;
extern fl_para;

void getpar(argc,argv,fl_mis,fl_iter,fl_imp,n_linhas,n_col,fl_ord)
int	argc;
char	*argv[];
int *fl_iter;
int *fl_mis;
int *fl_imp;
int *fl_ord;
int *n_linhas;
int *n_col;
{
	int i;
	long ret;
	double t;
	int flagX;
        char *pdir;
	char *p1, *p2;
	char pout[TAMSTR];

	++argv;		/* aponta para o primeiro parametro */
	--argc;		/* decrementa o apontador */
	while (argc--) {
		if (argv[0][0] == '-') {
			for (i=1; argv[0][i]; ++i) {
				switch (argv[0][i]) {
				case 'c':
					number(&t, argv, &i);
					if (t > 65.0 && t < 257.0)
						*n_col = (int) t;
					--i;
					break;
				case 'l':
					number(&t, argv, &i);
					if (t > 30.0 && t < 89.0)
						*n_linhas = (int) t;
					--i;
					break;
				case 'm':
					*fl_mis = 1;
					break;
				case 'M': /* Habilita impressao de mensagens */
					break;
				case 't': /* Habilita impressao de tempo */
					break;
				case 'o':
					*fl_ord = 1;
					break;
				case 'P':

					if (fl_para) {
						fprintf(stderr,
						"Opcoes -P e -p sao");
						fprintf(stderr,
							" incompativeis.\n");
						setOSstdin();
#ifdef MEM_DEBUG
						if (Mem_Used() != 0) {
							printf("*** Lista de memoria nao esta' vazia ***\n");
							Mem_Store("freq");
							exit(6);
						}
#endif

						exit(6);
					}

					*fl_imp = 1;

					break;

				case 'p':

					if (*fl_imp) {
						fprintf(stderr,
						"Opcoes -P e -p sao");
						fprintf(stderr,
							" incompativeis.\n");
						setOSstdin();
#ifdef MEM_DEBUG
						if (Mem_Used() != 0) {
							printf("*** Lista de memoria nao esta' vazia ***\n");
							Mem_Store("freq");
							exit(7);
						}
#endif
						exit(7);
					}

					fl_para = 1;

					break;

				case 'A':
#ifdef RS6000
					*strchr(&argv[0][i+1], '|') = '\0';
					if (freopen(&argv[0][i+1], "r", stdin)==
							(FILE *) NULL) {
/* *** Padroniz. msg erro - Luciana 15/12/94 
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
						fprintf(stderr,PegaMsg(1034),"stdin");
						setOSstdin();
#ifdef MEM_DEBUG
						if (Mem_Used() != 0) {
							printf("*** Lista de memoria nao esta' vazia ***\n");
							Mem_Store("freq");
							exit(5);
						}
#endif
						exit(5);
					}
					i += (strlen(&argv[0][i+1]) + 1);
					fseek(stdin, atol(&argv[0][i+1]), 0);
					i += strlen(&argv[0][i+1]);
#endif
					setbuf(stdin, CNULL);
					*fl_iter = 1;
					break;
				case 'X':
					if (strcmp(&argv[0][i+1],"ntia") == 0) {
						flagX = 1;
						i += 4;
					}
					break;
				default:
/* *** Padroniz. msg erro - Luciana 15/12/94 
					fprintf(stderr, "Opcao <%c> ilegal\n", 
							argv[0][1]);
*** */
					fprintf(stderr, PegaMsg(3086),argv[0][1]);

					setOSstdin();
#ifdef MEM_DEBUG
					if (Mem_Used() != 0) {
						printf("*** Lista de memoria nao esta' vazia ***\n");
						Mem_Store("freq");
						exit(1);
					}
#endif
					exit(1);
				}
			}
		}
		else
			break;
		++argv;
	}

	if (!flagX) {
/* *** Padroniz. msg erro - Luciana 15/12/94 
		fprintf(stderr, "Execucao nao permitida\n");
*** */
		fprintf(stderr, PegaMsg(1000));
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("freq");
			exit(1);
		}
#endif
		exit(1);
	}

	if (argc < 0)
		usage();

	pdir = pega_env(argv[0], ".hdr");

	strcpy(pout, pdir);
	p1 = strrchr(pout, '/');
	p2 = strrchr(pout, '\\');

	if (p1 < p2)
		p1 = p2;

	if (p1)
		*(p1+1) = '\0';

	if ((ret = (long) (fd = abre_arq(pdir, 0))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Luciana 15/12/94 
		fprintf(stderr, "Nao consegui abrir <%s> %ld\n", pdir, ret);
*** */
		fprintf(stderr, PegaMsg(1034),pdir);
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("freq");
			exit(2);
		}
#endif

		exit(2);
	}

	if (argc) {
		output = 1;
		strcat(pout, argv[1]);

		if ((ret = (long) (fout = cria_arq(pout))) < 0L && ret > -4L) {
/* *** Padroniz. msg erro - Luciana 15/12/94 
			fprintf(stderr, "Nao consegui abrir <%s> %ld\n",
				pout, ret);
*** */
			fprintf(stderr,PegaMsg(5006),pout);
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("freq");
				exit(2);
			}
#endif

			exit(2);
		}
	}
}

number(alfa,argv,k)
double *alfa;
char *argv[];
int *k;
{
	int j, i;
	char s[80];
	j = 0;
	i = (*k);
	for (i=i+1;;++i) {
		switch (argv[0][i]) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
		case '.':
		case '+':
		case '-':
		case 'E':
			s[j++] = argv[0][i];
			break;
		default:
			s[j] = '\0';
			*alfa = atof(s);
			(*k) = i;
			if (s[0] == '\0')
				return(0);
			else
				return(1);
			break;
		}
	}
}

