/* -------------------------------------------------------------------------
**
** MULTD.C : Funcoes referentes a execucao do modulo FREQ 
**		no caso multidimensional
**
** Programado por :
**
**		Sonia Ternes  - 1988/89
**
** ------------------------------------------------------------------------- */

#include <stdio.h>
#ifndef VAXVMS
#include <search.h>
#endif
#include <string.h>
#include "freq.h"
#include "pcsgbd.h"

static char *sccsid = "%W%	%Y%	%E%";

#ifdef MSDOS
#include <stdlib.h>
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

extern struct simb **tabhash[MAXDIM];
extern char   **nome[MAXDIM];
extern struct acao ac_freq[MAXFREQ];

extern ARQ *fd;
extern ARQ *fout;

extern int tamhash;
extern int output;
extern int pos_rep;
extern int n_class;
extern int ordc;
extern int classv[MAXCLASS];

extern char *obs[OBSSIZE];	/* observacao lida */
extern char obs2[MAXCLASS][80];	/* obs. correspondente as var. de classe */
extern char obser[MAXTOBS];	/* vetor com o conteudo das observacoes */
extern char *pchar;		/* ponteiro para obser */
extern char *obserp[MAXVAR];	/* vetor de ponteiros que guarda pchar */

void multd (i,fl_mis,fl_imp,fl_iter,n_linhas,n_col)
int  i;			/* indice do comando sendo analisado */
int  fl_mis;		/* usa missing ou nao :default nao usar */
int  fl_imp;		/* para controle de paginas */
int  fl_iter;		/* saber se e' iterativo ou em batch */
int  n_linhas;		/* numero de linhas do relatorio : default 30 */
int  n_col;		/* numero de colunas do relatorio : default 78 */
{

	int      n_obs[MAXDIM]; /* num. de niveis diferentes p/ cada var */
	long     *mat;		/* matriz de frequencia */
	unsigned int emis;	/* numero de observacoes missing */

	unsigned int ret;	/* posicao de retorno apos primeira leitura */
	unsigned int m;
	long total;
	int ii,num;
	int tamalloc;
	long *somalin;
	long *somacol;

	int k,j;

	m = 0;
	emis = 0;
	num = ac_freq[i].num_freq;

	if (output && (i == 0))
		outnhdr(i);

	if (ler_obs(fd,obs) != EOF ) {

		ret = 0;
/*
		alocn(n_obs,&tamalloc,i);
*/
        for (k=0;k<ac_freq[i].num_freq;k++) {
                n_obs[k] = 0;
                nome[k] = (char **) calloc(TAMINI,sizeof (char **));
        }
        tamalloc = TAMINI;
/* */
/*
		aloct(i);
*/
        for ( k=0 ; k < ac_freq[i].num_freq; ++k )
                tabhash[k] = (struct simb **) calloc(tamhash,
                                sizeof (struct simb **));
/* */

		inicioby();

		poe_hash(n_obs,fl_mis,&emis,&tamalloc,i); /* 1a observ. lida */
		
		while(ler_obs(fd,obs) != EOF ) {

			fprintf(stderr,"\r%d",++m);
	
			if ( class() == 0 ) {
				poe_hash(n_obs,fl_mis,&emis,&tamalloc,i);
			}
			else {
/*
				libt(i);
*/
        for (k = 0 ; k < ac_freq[i].num_freq; ++k ) {
		for (j = 0; j < tamhash; ++j) {
			if (tabhash[k][j] != SNULL)
				free((char *) tabhash[k][j]);
		}
                free((char *)tabhash[k]);
        }
/*  */
				incompleto(n_obs,i);
				mat = matriz(n_obs,i);

				fprintf(stderr,"\r         \r");

				preenche(ret,m,i,fl_mis,mat,n_obs);

				/* ARQUIVO NTIA_SAIDA */
				if (output && (i==0)) {
					pchar = obser;
					outn(mat,n_obs,fl_mis,i,num);
				}

				/* TOTAIS MARGINAIS */
				total = 0L;
				somalin = som_lin(n_obs,mat,num);
				somacol = som_col(n_obs,mat,num);
				for (ii = 0; ii < n_obs[num-1]; ++ii)
					total += somacol[ii];

				/* RELATORIO */

				pula_pagina(fl_imp,fl_iter);
				pag1n(num,(int) emis,total,
					n_obs,n_col,i, fl_mis);
				imp_tab(num,n_obs, fl_imp,fl_iter,mat,i,
					n_linhas,n_col,somalin,
					somacol,total);

				/* INICIALIZACOES */
/*
				libm(mat);
				libm((long *) somalin);
				libm((long *) somacol);
*/
         free((long *) mat);
         free((long *) somalin);
         free((long *) somacol);
/* */

/*
				libn(i,tamalloc);
*/
        for (k=0 ; k < ac_freq[i].num_freq; ++k ) {
		for (j=0; j < tamalloc; ++j) {
			if (nome[k][j] != CNULL)
				free((char *) nome[k][j]);
		}
		free((char *) nome[k]);
	}
/* */

/*
				alocn(n_obs,&tamalloc,i);
*/
        for (k=0;k<ac_freq[i].num_freq;k++) {
                n_obs[k] = 0;
                nome[k] = (char **) calloc(TAMINI,sizeof (char **));
        }
        tamalloc = TAMINI;
/* */


/*
				aloct(i);
*/
        for ( k=0 ; k < ac_freq[i].num_freq; ++k )
                tabhash[k] = (struct simb **) calloc(tamhash,
                                sizeof (struct simb **));
/* */

				inicioby();

				poe_hash(n_obs,fl_mis,&emis, &tamalloc,i);
				ret = m;
			}
		}
	
		fprintf(stderr,"\r         \r");

/*
		libt(i);
*/
        for (k = 0 ; k < ac_freq[i].num_freq; ++k ) {
		for (j = 0; j < tamhash; ++j) {
			if (tabhash[k][j] != SNULL)
				free((char *) tabhash[k][j]);
		}
                free((char *)tabhash[k]);
        }
/* */
		incompleto(n_obs,i);
		mat = matriz(n_obs,i);

		preenche(ret,m+1,i,fl_mis,mat,n_obs);

		/* ARQUIVO NTIA_SAIDA */
		if (output && (i==0)) {
			pchar = obser;
			outn(mat,n_obs,fl_mis,i,num);
		}

		/* TOTAIS MARGINAIS */
		total = 0L;
		somalin = som_lin(n_obs,mat,num);
		somacol = som_col(n_obs,mat,num);
		for (ii = 0; ii < n_obs[num-1]; ++ii)
			total += somacol[ii];

		/* RELATORIO */

		pula_pagina(fl_imp,fl_iter);
		pag1n(num,(int) emis,total,n_obs,n_col,i,fl_mis);
		imp_tab(num,n_obs,fl_imp,fl_iter,
			mat,i,n_linhas,n_col,somalin,somacol,total);

/*
		libm(mat);
		libm((long *) somalin);
		libm((long *) somacol);
*/
         free((long *) mat);
         free((long *) somalin);
         free((long *) somacol);
/* */
/*
		libn(i,tamalloc);
*/
        for (k=0 ; k < ac_freq[i].num_freq; ++k ) {
		for (j=0; j < tamalloc; ++j) {
			if (nome[k][j] != CNULL)
				free((char *) nome[k][j]);
		}
                free((char *) nome[k]);
	}
/*  */
	}
	else {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("ARQUIVO VAZIO",CNULL,1);
*** */
		execerro(PegaMsg(1004),CNULL,1);
	}
	printf("\n");
	if (output && (i==0))
		fech_arq(fout);
}

/* ====================================================================== */


long *matriz(n_obs,i)
int *n_obs;
int i;
{
		ord_vet(nome,n_obs,ac_freq[i].num_freq,i);

		return( cria_mat(n_obs,ac_freq[i].num_freq) );
}

/* ====================================================================== */

void poe_hash(n_obs,fl_mis,emis,tamalloc,i)
int *n_obs;
int fl_mis;
unsigned int *emis;		/* numero de observacoes missing */
int *tamalloc;
int i;
{
	int j,m;
	int tem;
	struct simb *p;

	for (j=0;j<ac_freq[i].num_freq;++j) {
		if (strcmpi(obs[ac_freq[i].pos_freq[j]],".") == 0 ) {
			(*emis)++;
			break;
		}
	}

	for (j=0;j<ac_freq[i].num_freq;++j) {
		m = mis(i,ac_freq[i].num_freq);
		if (fl_mis || (m == 0) ) {
			p =instala(obs[ac_freq[i].pos_freq[j]],(TIPO_H)
					0, tabhash[j],&tem);
			if (!tem) {
				if ( n_obs[j] >= (*tamalloc) ) {
					(*tamalloc) += 100;
/*
					nome[j] = (char **) realoca(
						nome[j],sizeof(char **),
						(*tamalloc));
*/
					nome[j] = (char **) realloc(
						nome[j],(unsigned) 
						((sizeof (char **)) *
						(*tamalloc)));
				}
				nome[j][(n_obs[j])++] = p->nome;
				free((char *) p);
			}
		}
	}
}


/* ====================================================================== */

void incompleto(n_obs,i)
int *n_obs;
int i;
{
	int k;

	for (k=0;k<ac_freq[i].num_freq;k++) {
		if (n_obs[k] == 0 ) { 
			execerro("ARQUIVO INCOMPLETO",CNULL,1);
		}
	}
}

/* ====================================================================== */

void preenche(pos_ret,final,i,fl_mis,mat,n_obs)
unsigned int pos_ret;	/* inicio da segunda leitura */
unsigned int final;	/* fim da segunda leitura */
int   i;		/* numero do freq sendo analisado */
int   fl_mis;		/* inclui ou nao missing */
long  *mat;		/* ponteiro para a matriz de frequencia */
int   *n_obs;		/* num. de obs. de cada var. do comando */
{
	int pos_mat[MAXDIM];
	
	int j;
	char *ptr;
	long rep = 1L;
	unsigned int m;

	rew_arq(fd);

	if (pos_ret != 0)
		while ( ((unsigned int) ler_obs(fd,obs)) < (pos_ret-1) )
			;

	m = pos_ret;

	while ((unsigned int) (ler_obs(fd,obs)) < final ) {
		if ( pos_rep != -1 ) {
			if (strcmp(obs[pos_rep],".") == 0)
				goto outra_obs;
			else {
				rep = atol(obs[pos_rep]);
				if (rep <= 0L ||
					((ptr=strchr(obs[pos_rep], '.')) &&
						atoi(ptr+1) != 0)) {

/* *** Padroniz. msg erro - Luciana 15/12/94
					execerro("Variavel do comando REP nao e"
							," inteira positiva",1);
*** */
					execerro(PegaMsg(3087), CNULL, 1);
				}
			}
		}
		for (j=0;j<ac_freq[i].num_freq;++j) {
			if (fl_mis || !mis(i,ac_freq[i].num_freq)) {
				pos_mat[j] = busca_bin(nome[j],
					obs[ac_freq[i].pos_freq[j]],n_obs[j]-1,
					ac_freq[i].tipo[j]);
			}
			else
				goto outra_obs;
		}
		poe_mat(mat,pos_mat,n_obs,ac_freq[i].num_freq,rep);
		outra_obs :
		fprintf(stderr,"\r%d",++m);
	}
	fprintf(stderr,"\r         \r");
}

/* ====================================================================== */

void outn(mat,n_obs,fl_mis,i,num)
long *mat;
int *n_obs;
int fl_mis;
int i;
int num;
{
	int pos_nome[MAXDIM];	/* posicao das observacoes no vetor nome */
	int n0,n1;
	int n2,n3,n4;

	n0 = n_obs[num-1];
	n1 = n_obs[num-2];
	n2 = n3 = n4 = 0;

	/* VALORES DAS VARIAVEIS DE CLASSE E TABELA */
	if (num > 2)
		limit(&n2,&n3,&n4,num,n_obs);
	gera_sai(n0,n1,n2,n3,n4,num,pos_nome,mat,n_obs);
}

/* ====================================================================== */

void gera_sai(n0,n1,n2,n3,n4,num,pos,mat,n_obs)
int n0;
int n1;
int n2;
int n3;
int n4;
int num;
int *pos;
long *mat;
int *n_obs;
{
	int i,j,k,l,m;
	int posmat;
	long freq;

	i = j = k = l = m = 0;
	do {
		do {
			do {
				for (i = 0; i < n1; ++i) {
					for ( j = 0; j < n0; ++j) {
						switch (num) {
						case 5 : pos[0] = m;pos[1] = l;
							 pos[2] = k;pos[3] = i;
							 pos[4] = j; 
							 break;
						case 4 : pos[0] = l;pos[1] = k;
							 pos[2] = i;pos[3] = j;
							 break;
						case 3 : pos[0] = k;pos[1] = i;
							 pos[2] = j;
							 break;
						case 2 : pos[0] = i;pos[1] = j;
							 break;
						}

						posmat=calc_pos(pos,num,n_obs);
						freq = mat[posmat];
						poe_obser(num,pos,freq);
					}
				}
			++k;
			} while ( k < n2);
		k = 0;
		++l;
		} while ( l < n3);
	k = 0; l = 0;
	++m;
	} while (m < n4);
}

/* ====================================================================== */

int calc_pos(pos,num,n_obs)
int *pos;
int num;
int *n_obs;
{
	int j;
	int posi;

	/* POSICAO DA FREQ. NA MATRIZ MAT */
	if (num == 2) {
		posi = pos[0] * n_obs[1]+pos[1];
	}
	else {
		posi = pos[0];
		for (j = 1; j < num; ++j) {
			posi = n_obs[j]*posi + pos[j];
		}
	}
	return(posi);
}

/* ====================================================================== */

void poe_obser(num,pos_nome,freq)
int num;
int *pos_nome;
long freq;
{
	int j;


	/* VALORES DAS VARIAVEIS DE CLASSE */
	for ( j =0; j < n_class; ++j) {
		obserp[j] = pchar;
		strcpy(pchar,obs2[j]);
		pchar += (strlen(pchar)+1);
	}

	/* COLOCAR O RESULTADO EM OBSERP */
	for ( j=0; j < num; ++j) {
		obserp[n_class+j] = pchar;
		strcpy(pchar,nome[j][pos_nome[j]]);
		pchar += (strlen(pchar)+1);
	}
		
	obserp[n_class+num] = pchar;
	gcvt((double) freq,15,pchar);
	pchar += (strlen(pchar)+1);

	/* GRAVAR OBSERP */
	grav_obs(fout,obserp);

	pchar = obser;
}

/* ====================================================================== */

void outnhdr(i)
int i;
{
	int j;
	char tipo;
	char nome[16];
	double mmin,mmax;
	int ret;          /* Luciana */
	char tmpbuf[128]; /* Luciana */

	for (j = 0; j < n_class; ++j) {
		pega_var(fd,classv[j],nome,&tipo,(MINVAL *) &mmin,
				(MAXVAL *) &mmax);
		errovar(nome);
		if (ret = def_var(fout,nome,tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 15/12/94
			execerro("Nao pode criar mais variaveis",CNULL,1);
*** */
			sprintf(tmpbuf,PegaMsg(5046),nome,ret);
			execerro(tmpbuf,CNULL,1);
		}
	}

	for (j = 0; j < ac_freq[i].num_freq; ++j) {
		pega_var(fd,ac_freq[i].pos_freq[j],nome,&tipo,(MINVAL *) &mmin,
				(MAXVAL *) &mmax);
		errovar(nome);
		if (ret = def_var(fout,nome,tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 15/12/94
			execerro("Nao pode criar mais variaveis",CNULL,1);
*** */
			sprintf(tmpbuf,PegaMsg(5046),nome,ret);
			execerro(tmpbuf,CNULL,1);
		}
	}

	if (ret = def_var(fout,"freq",'n') == -1) {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("Nao pode criar mais variaveis",CNULL,1);
*** */
		sprintf(tmpbuf,PegaMsg(5046),"freq",ret);
		execerro(tmpbuf,CNULL,1);
	}
	
}

