
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:
	
	Funcoes referentes a mensagens de erros

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/erros.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <setjmp.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>

#include "freq.h"
#include "pcsgbd.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)erros.c	3.4	(NTIA/freq)	95/10/11";

extern jmp_buf comeco;

/*
 *	execerro()
 *
 *	reporta erros de execucao
 */

void execerro(s, t, id)
char *s;
char *t;
int id;
{
    while (xgetc(stdin) != '\n');
    if (t)
	fprintf(stderr, "\n%s %s", s, t);
    else
	fprintf(stderr, "\n%s", s);

    if (id) {
/*		printf("\n"); */
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    } else {
/* *** Padroniz. msg erro - Luciana 15/12/94
		printf("Reinicie.\n");
*** */
	printf("Entre com todos os comandos novamente.\n");
    }
}




/* ------------------------------------------------------------------------
** usage()
** 	Programado por:	Silvio roberto Medeiros Evangelista
**	Data:		Junho 1988
** ------------------------------------------------------------------------- */


void usage()
{
/* *** Padroniz. msg erro - Luciana 15/12/94
	fprintf(stderr, "Falta nome de arquivo\n");
*** */
    fprintf(stderr, PegaMsg(3000));

    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("freq");
	exit(2);
    }
#endif
    exit(2);
}



void yyerror(s)
char *s;
{
/* *** Padroniz. msg erro - Luciana 15/12/94
	execerro("Erro de Sintaxe, CNULL,0);
*** */
    execerro(PegaMsg(3085), CNULL, 0);
}

void errovar(name)
char *name;
{
    if (strlen(name) > 8) {
	execerro("Nome de variavel com mais de", " 8 caracteres", 1);
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif
	exit(2);
    }
}
