
/* ----------------------------------------------------------------------------
** @(#)freq.h	3.5	(NTIA/freq)	95/10/09
**
** 
**
** Programado por:
**
**	Sonia Ternes - 1988/89
**
** Data da ultima alteracao:
**
**		95/10/09 15:43:54
**
** ----------------------------------------------------------------------------
*/

#ifndef EXTERN
# define	EXTERN	extern
#endif

#define MAXCLASS  6	/* Se este valor for alterado, deve-se rever as 
			rotinas de impressao de identificacao das classes */
#define MAXTIT  10
#define MAXFREQ 10
#define MAXDIM  5
#define TABMAX	1001		/* Numero maximo permitido para tab. hash */
#define TABMIN	3		/* Numero minimo permitido para tab.  hash */
#define TABDEF1 119		/* Numero default para tab. hash no caso unid*/
#define TABDEF2 11		/* Numero default para tab. hash no caso mult*/
#define TAMINI  100		/* Tamanho inicial do vetor de nomes */

#define TIPO_H long		/* Tipo do campo def da tabhash */

#define NRO_OBS(parq) (parq->proxobs) 	/* Numero de observacoes atualizado */

/* ------------------------------------------------------------------*/
/* Estrutura para a tabela de hash:				     */
/*	   nome   :	Nome do nivel.				     */
/*	   def    : 	frequencia.				     */
/*	   proximo:	Aponta para uma lista em caso de colisao     */
/* ------------------------------------------------------------------*/

EXTERN struct simb {
		char *nome;
		TIPO_H def;
		struct simb *proximo;
	} simb ;

/*
 *  Tabela de Hashing : struct simb **tabhash[MAXDIM]
 *
 *
 *		 +----------+
 *        +------| tabhash  |
 *	  |      +----------+
 * 	  |
 *        |
 *	  \/
 *   +--------+		       (simb)
 *   |   0    |-----------> +---------+         +-------------------+
 *   +--------+		    |    0    |-------> | nome | def | prox |--->||
 *   |   1    |--->||	    +---------+         +-------------------+
 *   +--------+		    |    1    |--->||
 *   |   2    |--->||	    +---------+
 *   +--------+		    .         .
 *   |   3    |--->||	    .         .
 *   +--------+		    .         .
 *   .        .		    +---------+
 *   .        .		    |TAMHASH-1|--->||
 *   .        .		    +---------+
 *   +--------+
 *   |MAXDIM-1|--->||
 *   +--------+
*/


/* ------------------------------------------------------------------*/
/* Estrutura para os titulos					     */
/*	tit    :	Titulo					     */
/* ------------------------------------------------------------------*/

EXTERN struct titulo {
		char tit[127];
	} s_titulo;


/* ------------------------------------------------------------------*/
/* Estrutura para acao						     */
/* 	pos_freq: Ponteiro para as posicoes das variaveis 	     */
/*	um_freq : dimensao da frequencia			     */
/* ------------------------------------------------------------------*/

EXTERN struct acao {
	char tipo[MAXDIM];
	int  pos_freq[MAXDIM];
	int  num_freq;
} acao ;

#define	CNULL	((char *)NULL)
#define	SNULL	((struct simb *)NULL)

/* -------------------------------------------------------------------*/
/*                                                                    */
/* Declaracao das funcoes usadas no modulo FREQ                       */
/*                                                                    */
/* -------------------------------------------------------------------*/

#ifdef MSDOS
extern void	errovar(char *);
extern void	unid(int,int,int,int,int,int,int);
extern void	multd(int,int,int,int,int,int);
extern void	gera_sai(int,int,int,int,int,int,int *,
			long *,int *);
extern void	poe_obser(int,int *,long );
extern void	outnhdr(int);
extern void	out1hdr(int);
extern void	outn(long *,int *,int, int, int);
extern void	limit(int *,int *,int *,int ,int *);
extern void	poe_mat(long *,int *,int *,int,long);
extern void	poe_hash(int *,int,unsigned int *,int *,int);
extern void	getpar(int,char **,int *,int *,int *,int *,int *,
			int *);
extern void	execerro(char *,char *, int);
extern void	exec1(int,unsigned int *,long *,int ,int *);
extern void	exec2(int,unsigned int,int);
extern void	usage(void);
extern void	libera1(void);
extern void	libt(int);
extern void	libn(int,int *);
extern void	libm(long *);
extern void	rep(int);
extern void	variavel(int);
extern void	inicioby(void);
extern void	incompleto(int *,int);
extern void	lib1(unsigned int *, long *, int);
extern void	aloc1(int *);
extern void	aloct(int);
extern void	alocn(int *,int *,int);
extern void	imp_x(double,int *,int);
extern void	setacol(int *,int *,int *);
extern void	setalin(int *,int *,int *,int);
extern void	imp_traco(int,int,int,int,int);
extern void	imp_var(int,char *);
extern void	pula_pagina(int,int);
extern void	titulo(void);
extern void	imp_tl(int);
extern void	pag1n(int,int,long,int *,int,int,int);
extern void	pag11(unsigned,int,int,long,int);
extern void	titn(int,int,int);
extern void	tit1(int,int);
extern void	titclass(int);
extern void	titpeso(int);
extern void	qclass(int);
extern void	brancos(int);
extern void	tnivn(int *,int,int);
extern void	tniv1(int,unsigned);
extern void	titfinal(long,long,int);
extern void	quebra_buf(char *,char,int);
extern void	ord_vet(char ***,int *,int,int);
extern void	imp_id(int,int,int,int *,int);
extern void	by(int);
extern void	cabecalho(int,int,int,int,int,int,int,int,int,
			int,int,int,int);
extern void	tab1(char **,long,unsigned int,int,int,int,int,
			int,int,int);
extern void	preenche(unsigned int,unsigned int,int,int,
			long *,int *);
extern void	imp_tab(int,int *,int,int,long *,int,
			int,int,long *,long *,long );
extern void	imp_linha(int,int,long *,int,int,int,long,long *,
			long *,double *,int,int,int,int,int,int,int);
extern void	tabn(int *,int *,int *,int,int,int,int,int,int *,
		 int,double *,long ,long *,int,int,int,
		 int,int,long *,long *,int,int);

extern int 	yyparse(void);
extern int	hash(char *);
extern int	mis(int,int);
extern int	class(void);
extern int	busca_bin(char **,char *,int,char);
extern int	comps(const void **,const void **);
extern int	compn(const void **,const void **);
extern int	comp_freq(const void **,const void **);
extern int	number(double *,char **,int *);
extern int	yylex(void);
extern int	ncas(char,int,int,int,int);
extern int	calc_pos(int *,int, int *);

extern long	*som_lin(int *,long *,int);
extern long	*som_col(int *,long *,int);

extern long	*matriz(int *,int);
extern long 	*cria_mat(int *,int);

extern char	*guardacad(char *);
extern char	*center(char *,int);
extern char	*realoca(char **,int,int);
extern char	*aloc(int,int);
extern char	*char_str(int,char);

extern struct	simb *pesquisa(char *,struct simb **);
extern struct	simb *instala(char *,TIPO_H,struct simb **,int *);

extern double	xprob(double,double);

extern void	yyerror(char *);
extern void	initcode(void);
extern void	erroclass(void);

#else

extern char	*gcvt();

extern void	errovar();
extern void	unid();
extern void	multd();
extern void	gera_sai();
extern void	poe_obser();
extern void	outn();
extern void	outnhdr();
extern void	out1hdr();
extern void	limit();
extern void	poe_mat();
extern void	poe_hash();
extern void	getpar();
extern void	execerro();
extern void	exec1();
extern void	exec2();
extern void	usage();
extern void	libera1();
extern void	rep();
extern void	variavel();
extern void	inicioby();
extern void	incompleto();
extern void	preenche();
extern void	lib1();
extern void	libt();
extern void	libn();
extern void	libm();
extern void	libt();
extern void	aloc1();
extern void	aloct();
extern void	alocn();
extern void	imp_tab();
extern void	setacol();
extern void	setalin();
extern void	tabn();
extern void	cabecalho();
extern void	imp_traco();
extern void	imp_var();
extern void	pula_pagina();
extern void	imp_linha();
extern void	imp_x();
extern void	titulo();
extern void	imp_tl();
extern void	pag1n();
extern void	pag11();
extern void	titn();
extern void	tit1();
extern void	titclass();
extern void	titfinal();
extern void	titpeso();
extern void	qclass();
extern void	brancos();
extern void	tnivn();
extern void	tniv1();
extern void	quebra_buf();
extern void	by();
extern void	tab1();
extern void	imp_id();
extern void	ord_vet();

extern int	mis();
extern int	class();
extern int	hash();
extern int	yyparse();
extern int	busca_bin();
extern int	comps();
extern int	compn();
extern int	comp_freq();
extern int	number();
extern int	yylex();
extern int	ncas();
extern int	calc_pos();

extern long	*som_lin();
extern long	*som_col();

extern long	*cria_mat();
extern long	*matriz();

extern char	*guardacad();
extern char	*realoca();
extern char	*aloc();
extern char	*center();
extern char	*char_str();

extern struct simb *pesquisa();
extern struct simb *instala();

extern double	xprob();

extern void	yyerror();
extern void	initcode();
extern void	erroclass();

#endif

