
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a tabela de hashing

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/hash.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include "freq.h"

#ifdef MSDOS
#include <stdlib.h>
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

extern int tamhash;

static char *sccsid = "@(#)hash.c	3.2	(NTIA/freq)	94/12/16";

int hash(s)
char *s;			/* ponteiro para a tabela */
{
    long valhash;
    int aux;
    int i = 0;

    for (valhash = 0L; *s != '\0';) {
	valhash += (*s + i);
	s++;
	i++;
    }

    aux = (int) (valhash % ((long) tamhash));
    return (aux);
}


struct simb *pesquisa(s, tab)
char *s;
struct simb **tab;
{
    struct simb *as;

    for (as = tab[hash(s)]; as != SNULL; as = as->proximo) {
	if (strcmpi(s, as->nome) == 0)
	    return (as);

    }
    return (SNULL);
}

struct simb *instala(nome, def, tabhash, tem)
char *nome;			/* obs. a ser instalada na tabela */
TIPO_H def;			/* contem informacao sobre obs. */
struct simb **tabhash;		/* tabela onde havera a instalacao */
int *tem;			/* tem = 1 -> nome ja existia na tab */
			/* tem = 0 -> nome nao existia e foi instalado */
{
    int valhash;
    struct simb *as;

    *tem = 1;

    if ((as = pesquisa(nome, tabhash)) == SNULL) {
/*
		as = ( struct simb * ) aloc(1,sizeof(struct simb));
*/
	as = (struct simb *) calloc(1, sizeof(struct simb));

	*tem = 0;

	as->nome = guardacad(nome);

	valhash = hash(as->nome);
	as->proximo = tabhash[valhash];
	tabhash[valhash] = as;
    }
    as->def = def;
    return (as);
}
