
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a impressao do relatorio para o usuario

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/imprel.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "freq.h"
#include "pcsgbd.h"

static char *sccsid = "@(#)imprel.c	3.7	(NTIA/freq)	95/07/26";

extern int n_class;
extern int pos_rep;
extern int n_tit;
extern int opp, opm, opx;

extern struct acao ac_freq[MAXFREQ];
extern char **nome[MAXDIM];
extern int fl_para;

#ifdef MSDOS
#define		CONSOLE		"con"
#else
#define		CONSOLE		"/dev/tty"
#endif

void imp_var(pos, vetnome)
int pos;
char *vetnome;
{
    extern ARQ *fd;

    char name[16];
    char vet[11];
    char tipo;
    double mmin, mmax;

    int ret;

    name[0] = '\0';
    vet[0] = '\0';

    ret =
	pega_var(fd, pos, name, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(name);

    if (strlen(vetnome) > 10) {
	strncpy(vet, vetnome, 10);
	vet[10] = '\0';
    } else
	strcpy(vet, vetnome);
    printf("%-*s=%-11s  ", strlen(name), name, vet);
}

/* ====================================================================== */

void imp_traco(col, cesq, ccel, totl, nbrancos)
int col;
int cesq;
int ccel;
int totl;
int nbrancos;

{
    int j, k;

    brancos(nbrancos);

    for (j = 0; j <= cesq; ++j)
	printf("-");

    printf("+");

    for (j = 0; j < col; ++j) {
	for (k = 0; k <= ccel; ++k)
	    printf("-");
	printf("+");
    }

    if (opm && totl)
	printf("----------");
}

/* ====================================================================== */

void pula_pagina(fl_imp, fl_a)
int fl_imp;
int fl_a;
{
    if (fl_imp)
	putchar(12);

    if (fl_para == 1) {
	fl_para = 2;

#ifdef MSDOS
	system("cls");
#else
	system("clear");
#endif
    }

    else if (fl_para == 2) {
	FILE *fd;

	fd = fopen(CONSOLE, "r");
	if (fd == (FILE *) NULL) {
	    fprintf(stderr, PegaMsg(5020), CONSOLE);
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}


/* *** Padroniz. msg erro - Luciana 15/12/94
		fprintf(stderr, "Tecle ENTER para continuar.");
*** */
	fprintf(stderr, "Digite <ENTER> para continuar");

	while (fgetc(fd) != '\n');

	fclose(fd);


#ifdef MSDOS
	system("cls");
#else
	system("clear");
#endif
    }
}

/* ====================================================================== */

void imp_linha(flag, inic, mat, cesq, cdir, ii, total, somalin, somacol,
	       q1, num, col, ccel, totl, n0, ncol, nbrancos)
int flag;
int inic;
long *mat;
int cesq;
int cdir;
int ii;
long total;
long *somalin;
long *somacol;
double *q1;
int num;
int col;
int ccel;
int totl;
int n0;
int ncol;
int nbrancos;
{
    int j, aux;
    double Eij, x2;
    char vet[11];
    char c[2];

    c[0] = ' ';
    c[1] = '\0';

    Eij = x2 = 0.0;

    brancos(nbrancos);

    switch (flag) {
    case 1:			/* imp. frequencia */
	if (opp)
	    printf("%*s |", cesq, c);
	else {
	    if (strlen(nome[num - 2][ii]) > 10) {
		strncpy(vet, nome[num - 2][ii], 10);
		vet[10] = '\0';
		printf("%-*s |", cesq, center(vet, cesq));
	    } else
		printf("%-*s |", cesq, center(nome[num - 2]
					      [ii], cesq));
	}

	aux = col + inic;
	for (j = inic; j < aux; ++j) {
	    /*
	       printf("%*ld |",ccel,mat[j]);
	     */
	    printf("%*s |", ccel, rounddec((double) mat[j], ccel, 0));
	}

	if (totl && opm)
	    /*
	       printf(" %*ld",(cdir-1),somalin[ii]);
	     */
	    printf(" %*s", (cdir - 1), rounddec((double) somalin[ii],
						(cdir - 1), 0));
	break;

    case 2:			/* imprime porcentagem */
	if (opx)
	    printf("%*s |", cesq, c);
	else {
	    if (strlen(nome[num - 2][ii]) > 10) {
		strncpy(vet, nome[num - 2][ii], 10);
		vet[10] = '\0';
		printf("%-*s |", cesq, center(vet, cesq));
	    } else
		printf("%-*s |", cesq, center(nome[num - 2]
					      [ii], cesq));
	}

	aux = col + inic;
	for (j = inic; j < aux; ++j) {
	    printf("%*.3f |", ccel, (float) (mat[j]) / (float) (total));
	}

	if (totl && opm)
	    printf(" %*.3f", (cdir - 1), (float) (somalin
						  [ii]) / (float) (total));
	break;

    case 3:			/* imprime porcentagem por linha */
	if (opx) {
	    if (strlen(nome[num - 2][ii]) > 10) {
		strncpy(vet, nome[num - 2][ii], 10);
		vet[10] = '\0';
		printf("%-*s |", cesq, center(vet, cesq));
	    } else
		printf("%-*s |", cesq, center(nome[num - 2]
					      [ii], cesq));
	} else
	    printf("%*s |", cesq, c);

	aux = col + inic;
	for (j = inic; j < aux; ++j) {
	    printf("%*.3f |", ccel, (float) (mat[j]) /
		   (float) (somalin[ii]));
	}

	break;

    case 4:			/* imprime porcentagem por coluna */
	printf("%*s |", cesq, c);

	aux = col + inic;
	for (j = inic; j < aux; ++j) {
	    printf("%*.3f |", ccel, (float) (mat[j])
		   / (float) (somacol[(j % n0)]));

	}
	break;

    case 5:			/* imprime qui-quadrado */
	printf("%*s |", cesq, c);

	aux = col + inic;
	for (j = inic; j < aux; ++j) {

	    Eij = (double) (((double) somalin[ii] *
			     (double) somacol[(j % n0)])) /
		(double) (total);
	    x2 = (((double) mat[j] - Eij) * ((double) mat[j] - Eij)) / Eij;

	    (*q1) += x2;	/* guarda qui-quad. total */
	    /*
	       printf("%*.3lf |",ccel,x2);
	     */
	    printf("%*s |", ccel, rounddec(x2, ccel, 3));
	}
	break;
    }

}

/* ====================================================================== */

void pag1n(num, emis, total, n_obs, ncol, i, fl_mis)
int num;
int emis;
long total;
int *n_obs;
int ncol;
int i;
int fl_mis;
{
    if (n_tit > 0) {
	imp_tl(ncol);
    } else {
	titn(num, ncol, i);

	if (pos_rep != -1)
	    titpeso(ncol);

	if (n_class > 0)
	    titclass(ncol);
	printf("\n");
    }

    if (n_class > 0) {
	/*qclass(ncol);
	   printf("\n\n"); */
    }

    tnivn(n_obs, num, i);

    printf("\n");
    titfinal(total, emis, fl_mis);
}

/* ====================================================================== */

void pag11(n, ncol, pos, geral, fl_mis)
unsigned n;
int ncol;
int pos;
long geral;
int fl_mis;
{
    extern struct simb **tabhash[MAXDIM];

    long emis;
    unsigned nn;
    struct simb *p;

    if (n_tit > 0) {
	imp_tl(ncol);
    } else {
	tit1(ncol, pos);

	if (pos_rep != -1)
	    titpeso(ncol);

	if (n_class > 0)
	    titclass(ncol);
	printf("\n");
    }

    if (n_class > 0) {
	qclass(ncol);
	printf("\n\n");
    }

    nn = n;

    p = pesquisa(".", tabhash[0]);
    if (p != SNULL) {
	emis = p->def;
	if (!fl_mis)
	    nn = n - 1;		/* #niveis menos o nivel miss */
    } else
	emis = 0;

    tniv1(pos, nn);
    printf("\n");

    titfinal(geral, emis, fl_mis);
}

/* ====================================================================== */

void brancos(nbrancos)
int nbrancos;
{
    if (nbrancos > 0)
	printf("\n%*s", nbrancos, " ");
    else
	printf("\n");
}
