
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a inicializacao das variaveis

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/inicio.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include "freq.h"

static char *sccsid = "@(#)inicio.c	3.2	(NTIA/freq)	94/12/16";

extern int n_class;
extern int n_tit;
extern int opp, opm, opx;

void limit(n2, n3, n4, num, n_obs)
int *n2;
int *n3;
int *n4;
int num;
int *n_obs;
{
    if (num == 3) {
	(*n2) = n_obs[0];
    } else if (num == 4) {
	(*n2) = n_obs[1];
	(*n3) = n_obs[0];
    } else {
	(*n2) = n_obs[2];
	(*n3) = n_obs[1];
	(*n4) = n_obs[0];
    }
}

/* ====================================================================== */

void setacol(cesq, ccel, cdir)
int *cesq;			/* no. de colunas a esq. da tabela no cabecalho */
int *ccel;			/* no. de colunas por celula */
int *cdir;			/* no. de colunas a direita da tabela no cabecalho */
{
    (*cesq) = 10;		/* no. de minimo de colunas a esq. da tabela */
    (*ccel) = 11;		/* ' '  +  10 caracteres */
    (*cdir) = 0;		/* sem escrever marginais */

    if (opx)
	(*cesq) = 12;		/* no. de col. da palavra QUI-QUADRADO */
    if (opm)
	(*cdir) = 9;		/* no. de col. de ' MARGINAL' */
}


/* ====================================================================== */

void setalin(lcab, lcel, ldep, num)
int *lcab;			/* no. de linhas cabecalho */
int *lcel;			/* no. de linhas por celula */
int *ldep;			/* no. de linhas  depois da tabela */
int num;			/* dimensao do comando */
{
    *ldep = 0;			/* nenhuma linha no final da tabela */
    *lcel = 2;			/* tracejado + freq */
    *lcab = 2;			/* tracejado + frequencia */

    (*lcab) += (n_tit + 1);

    /* identificacao das variaveis do comando tab com dimensao > 2 */
    if (num > 2)
	(*lcab) += 1;

    if (n_tit == 0)		/* uma linha a mais para titdef */
	(*lcab)++;

    if (n_class != 0) {
	if (n_class > 2)
	    (*lcab) += 4;
	else
	    (*lcab) += 2;
    }

    if (opp) {			/* imprime porcentagem */
	if (opx) {		/* imp. qui-quadrado e porcent. */
	    (*lcab) += 4;
	    (*lcel) += 4;
	} else {
	    (*lcab) += 3;
	    (*lcel) += 3;
	}
    } else {			/* nap imp. porcentagem */
	if (opx) {
	    (*lcab)++;		/* qui */
	    (*lcel)++;		/* qui */
	}
    }

    if (opm)			/* imprime marginais */
	(*ldep) += 2;

    (*ldep)++;			/* linha em branco ni final da tabela */
}

/* ====================================================================== */


int ncas(flag, nsup, ncel, nlinhas, ncol)
char flag;			/* l => linha    c => coluna */
int nsup;			/* no. de linhas do cabecalho ou no. de colunas a esq. de tab. */
int ncel;			/* no. de linhas ou no. de colunas da celula */
int nlinhas;
int ncol;
{
    int num;


    if (flag == 'c')
	num = ncol;
    else
	num = nlinhas;

    return ((int) ((num - nsup - 1) / ncel));
    /* -1 => ult. lin ou col pontilhada */

}

/* =================================================================== */
