
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:
	
	Gerenciamento das funcoes referentes ao modulo FREQ

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/main.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/

#define EXTERN
#include <stdio.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include <setjmp.h>
#include "freq.h"

#ifdef MSDOS
#include <stdlib.h>
#endif

#include "pcsgbd.h"
/*#include "lockfile.h"*/

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)main.c	3.7	(NTIA/freq)	95/04/10";

jmp_buf comeco;

ARQ *fd;			/* Apontador para arquivo 'ntia' de entrada */
ARQ *fout;			/* Apontador para arquivo 'ntia' de saida */


/* ------------------------------------------------------------------*/
/* Estrutura para a tabela de frequencias que serao executadas.
	     nome    :	Ponteiro para uma lista de de variaveis.
	     pos_freq: 	Posicao de cada variavel na observacao.
	     num_freq:  Numero de frequencias por subcomando freq.   */
/* ------------------------------------------------------------------*/

struct simb **tabhash[MAXDIM];
struct titulo tit[MAXTIT];
struct acao ac_freq[MAXFREQ];
char **nome[MAXDIM];

/* ------------------    Varia. globais ------------------------------- */

int pos_rep;			/* variavel que indica a existencia de rep:
				   se pos_rep = -1 --> rep = 1;
				   cc pos_rep = posicao do rep na observacao lida */

int tamhash;			/* variavel que indica o tamanho da tabela de */
		 /* hashing */

int n_tit = 0;			/* Numero total de titulos */
int n_freq = 0;			/* Numero total de freqsa  */
int ret_lex = 0;		/* Variavel que indica que o comando freq espera */
			/* Mais uma variavel --> Ex: A*B */
int classv[MAXCLASS];		/* vetor que armazena endereco das variaveis de class */
int tip_by[MAXCLASS];		/* vetor que armazena o tipo das variaveis de class */
int n_class = 0;		/* numero de variaveis que estao no comando class */

int opm = 0;			/* Calcula marginais */
int opp = 0;			/* Calcula porcentagens */
int opx = 0;			/* Calcula qui-quadrado */
int output = 0;			/* Nao produz arquivo ntia_saida */
int ordc = 1;			/* 1 : ordem ascendente no CLASS ; 0 : cc */

int fl_para = 0;

int descarq[2];			/* descritor de arquivo para funcoes de bloqueio */

/* ------------------------------------------------------------------*/


main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{
    /* ---------------------------------------------------------------- */

    int i;			/* Indica o freq que esta sendo executado */

    int fl_mis;			/* Usa missing ou nao */
    int fl_iter;		/* Saber se e' iterativo ou em batch */
    int fl_imp;			/* Saber se e' para ter controle de pagina */
    int n_linhas;		/* Numero de linhas por pagina */
    int n_col;			/* Numero de colunas por linha */
    int fl_ord;			/* 0= Ordenar por chave */
    /* 1= ordenar por freq */

    int ret;			/* retorno defuncoes */

    /* ---------------------------------------------------------------- */

    fl_mis = fl_iter = fl_imp = fl_ord = 0;
    n_linhas = 30;
    n_col = 78;

    /* Inicializacao dos descritores */
    descarq[0] = -1;
    descarq[1] = -1;

    /* Tratamento dos parametros */
    getpar(argc, argv, &fl_mis, &fl_iter, &fl_imp, &n_linhas, &n_col,
	   &fl_ord);

    setjmp(comeco);

    for (initcode(); yyparse(); initcode());

    for (i = 0; i < n_freq; ++i) {

	tamhash = (ac_freq[i].num_freq == 1) ? TABDEF1 : TABDEF2;

	if (ac_freq[i].num_freq == 1) {
	    unid(i, fl_mis, fl_ord, fl_imp, fl_iter, n_linhas, n_col);
	} else {
	    if (ac_freq[i].num_freq > 2)
		opx = 0;	/* calculo so para LxC */

	    multd(i, fl_mis, fl_imp, fl_iter, n_linhas, n_col);
	}
	rew_arq(fd);
    }

    ret = fech_arq(fd);

    if (ret < 0) {
	fprintf(stderr, PegaMsg(1011), "");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    setOSstdin();

    /*
     **  Verifica alocacao e liberacao de memoria
     */
#ifdef MEM_DEBUG

    if (Mem_Used() != 0) {

	printf("*** Lista de memoria nao esta' vazia ***\n");

	Mem_Store("freq");

	exit(0);

    }
#endif

    /* Desbloqueio dos arquivos */
    if (descarq[0] != -1) {
	/*UnlockAFile(descarq[0]); */
    }
    if (descarq[1] != -1) {
	/*UnlockAFile(descarq[1]); */
    }

    /* Final da execucao do programa */
    exit(0);
}

void initcode()
{

    /* ---------------------- Inicializacoes ------------------------ */

    pos_rep = -1;		/* Caso a opcao de 'rep' nao seja usada
				   pos_rep=-1 indica que devera ser usado
				   rep = 1 para cada observacao */
    libera1();			/* Libera area ja' alocada em caso de 
				   erro de sintaxe */
    n_tit = 0;			/* Numero de titulos */
    n_freq = 0;			/* Numero de freq */
    n_class = 0;		/* numero de variaveis  no comando class */
    ret_lex = 0;		/* Variavel indica que o comando freq espera */
    /* Mais uma variavel --> Ex: A*B */
    opm = 0;			/* Calcula marginais */
    opp = 0;			/* Calcula porcentagens */
    opx = 0;			/* Calcula qui-quadrado */
    ordc = 1;			/* 1 : ordem ascendente no CLASS ; 0 : cc */
}
