
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a montagem da "matriz" de frequencias

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/mat_freq.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <limits.h>
#include <malloc.h>
#include "freq.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)mat_freq.c	3.4	(NTIA/freq)	95/10/11";

long *cria_mat(n_obs, num)
int *n_obs;			/* ponteiro para o vetor de num. de obs. de cada var */
int num;			/* dimensao do comando sendo analisado */
{
    int dim = 1;
    double dim1 = 1.0;
    int k;

    for (k = 0; k < num; ++k) {
	dim1 *= ((double) n_obs[k]);
    }

    if (dim1 >= (double) INT_MAX) {
	execerro(PegaMsg(1039), CNULL, 1);
    }

    dim = (int) dim1;


    /* aponta para mat */
/*
	return( (long *) aloc(dim,sizeof (long)) ); 
*/
    return ((long *) calloc(dim, sizeof(long)));
}


void poe_mat(p, v, r, num, rep)
long *p;			/* ponteiro para a matriz */
int *v;				/* pont. para pos. do elem. a ser somado 1 */
int *r;				/* ponteiro para o vetor de num. de obs de cada var */
int num;			/* dimensao do comando sendo analisado */
long rep;			/* valor da var. rep na observacao */
{
    int pos;
    int j;

    if (num == 2) {
	p[v[0] * r[1] + v[1]] += rep;
    } else {
	pos = v[0];
	for (j = 1; j < num; ++j) {
	    pos = r[j] * pos + v[j];
	}
	p[pos] += rep;
    }

}
