
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a alocacao ou liberacao de memoria

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/memoria.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "freq.h"
#include "pcsgbd.h"		/* Luciana */

static char *sccsid = "@(#)memoria.c	3.4	(NTIA/freq)	95/10/09";

#ifdef MSDOS
#include <stdlib.h>
#endif

#ifdef  MEM_DEBUG
#include "mshell.h"
#endif

extern struct simb **tabhash[MAXDIM];
extern char **nome[MAXDIM];

extern int tamhash;
extern struct acao ac_freq[MAXFREQ];
extern struct titulo tit[MAXTIT];


char *aloc(n, t)
int n;				/* tamanho do espaco a ser alocado */
int t;				/* tamanho de cada elemento */
{
    char *p;

    p = (char *) calloc((unsigned) n, (unsigned) t);
    if (p == CNULL) {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("MEMORIA ESGOTADA",CNULL,1);
*** */
	execerro(PegaMsg(1039), CNULL, 1);
    }
    return (p);
}


char *realoca(nome, tipo, tam)
char **nome;
int tipo;
int tam;
{
    char *p;

    p = (char *) realloc((char *) nome, (unsigned) (tam * tipo));
    if (p == CNULL) {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("MEMORIA ESGOTADA",CNULL,1);
*** */
	execerro(PegaMsg(1039), CNULL, 1);
    }
    return (p);
}


char *guardacad(s)
char *s;			/* aponta para cadeia a ser guardada */
{
    char *ap;

/*
	if ( (ap = aloc(strlen(s) + 1,sizeof (char) )) != CNULL )
*/
    if ((ap = calloc(strlen(s) + 1, sizeof(char))) != CNULL)
/* Sonia: troca acima feita para uso do MSHELL */
	strcpy(ap, s);
    else {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("MEMORIA ESGOTADA",CNULL,1);
*** */
	execerro(PegaMsg(1039), CNULL, 1);
    }
    return (ap);
}


void libera1()
{
    extern int n_tit;
    int i;

    if (n_tit > 0) {
	for (i = 0; i < n_tit; ++i) {
	    tit[i].tit[0] = '\0';
	}
    }
    for (i = 0; i < MAXFREQ; ++i) {
	ac_freq[i].num_freq = 0;
    }
}


void libn(i, tamalloc)
int i;
int *tamalloc;
{
    int j, k;

    for (j = 0; j < ac_freq[i].num_freq; ++j) {
	for (k = 0; k < tamalloc[j]; ++k) {
	    if (nome[j][k] != CNULL)
		free((char *) nome[j][k]);
	}
	free((char *) nome[j]);
    }
}


void libm(thing)
long *thing;
{
    free((long *) thing);
}


void alocn(n_obs, tamalloc, i)
int *n_obs;
int *tamalloc;
int i;
{
    int k;

    for (k = 0; k < ac_freq[i].num_freq; k++) {
	n_obs[k] = 0;
	nome[k] = (char **) aloc(TAMINI, sizeof(char *));
	tamalloc[k] = TAMINI;
    }
}


void aloct(i)
int i;
{
    int j;

    for (j = 0; j < ac_freq[i].num_freq; ++j)
	tabhash[j] = (struct simb **) aloc(tamhash, sizeof(struct simb *));
}


void libt(i)
int i;
{
    int j, k;

    for (j = 0; j < ac_freq[i].num_freq; ++j) {
	for (k = 0; k < tamhash; ++k) {
	    if (tabhash[j][k] != SNULL)
		free((char *) tabhash[j][k]);
	}
	free((char *) tabhash[j]);
    }
}
