
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes ao tratamento para cada obs. lida

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/observ.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/



#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

#if !defined(VAXVMS) & !defined(SCO) & !defined(i486)
# include <search.h>
#endif

#include <sys/types.h>

#include "freq.h"
#include "pcsgbd.h"

static char *sccsid = "@(#)observ.c	3.5	(NTIA/freq)	95/05/24";

extern char **nome[MAXDIM];
extern char *obs[OBSSIZE];	/* ponteiro para a obs. lida */

int mis(i, num)
int i;				/* indice do freq sendo analisado */
int num;			/* dimensao do comando sendo analisado */
{
    int k;
    extern struct acao ac_freq[MAXFREQ];

    for (k = 0; k < num; ++k) {
	if (strcmp(obs[ac_freq[i].pos_freq[k]], ".") == 0)
	    return (1);
    }
    return (0);
}


void ord_vet(nome, n, num, i)
char **nome[MAXDIM];		/* vetor de nomes a ser ordenado */
int *n;				/* ponteiro para o num. de obs. de cada var */
int num;			/* dimensao do comando sendo analisado */
int i;				/* indice do freq sendo analisado */
{
    extern struct acao ac_freq[MAXFREQ];
    extern ARQ *fd;

    char tipo;
    char name[16];
    double mmin, mmax;
    int k;
    int ret;


    for (k = 0; k < num; ++k) {
	ret = pega_var(fd, ac_freq[i].pos_freq[k], name, &tipo, (MINVAL *)
		       & mmin, (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}

	errovar(name);
	if (tipo == 'c') {
	    qsort((void *) nome[k], (size_t) n[k],
		  (size_t) sizeof(char *), comps);
	} else {
	    qsort((void *) nome[k], (size_t) n[k],
		  (size_t) sizeof(char *), compn);
	}
    }
}


int busca_bin(v, arg, sup, tipo)
char **v;			/* ponteiro para vetor a ser feita a busca */
char *arg;			/* argumento a ser procurado */
int sup;			/* posicao do ultimo elem. de v */
char tipo;			/* tipo da variavel */
{
    int inf = 0;
    int atu;
    int c;

    atu = (int) (inf + sup) / 2;

    if (tipo == 'c') {
	while ((inf <= sup) && ((c = strcmpi(v[atu], arg)) != 0)) {
	    if (c < 0)
		inf = atu + 1;
	    else
		sup = atu - 1;
	    atu = (int) (inf + sup) / 2;
	}
    } else {
	while ((inf <= sup) && (atof(v[atu]) != atof(arg))) {
	    if (atof(v[atu]) < atof(arg))
		inf = atu + 1;
	    else
		sup = atu - 1;
	    atu = (int) (inf + sup) / 2;
	}
    }

    if (inf <= sup)
	return (atu);
    else
/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("ERRO:elem deveria existir.Avise NTIA",CNULL,1);
*** */
	execerro(PegaMsg(5014), CNULL, 1);
    return (-1);
}
