
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a montagem da tabela unidimensional

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/tab1.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include "pcsgbd.h"
#include "freq.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

#ifdef MSDOS
#include <stdlib.h>
#endif

static char *sccsid = "@(#)tab1.c	3.5	(NTIA/freq)	95/07/26";

extern ARQ *fd;
extern ARQ *fout;

extern int n_tit;
extern int n_class;
extern int classv[MAXCLASS];
extern int pos_rep;
extern int output;

extern char *pchar;
extern char obser[MAXTOBS];
extern char *obserp[MAXVAR];
extern char obs2[MAXCLASS][80];

void tab1(nome, geral, n, n_linhas, fl_imp, fl_mis, n_col, pos, i, fl_iter)
char **nome;
long geral;
unsigned n;
int n_linhas;
int fl_imp;
int fl_mis;
int n_col;
int pos;
int i;
int fl_iter;
{
    extern struct simb **tabhash[MAXDIM];

    long ret;

    unsigned k;			/* Variavel temporaria */
    long f_a;
    double f_r, f_ra;
    char name[11];		/* tamanho maximo da observacao a imprimir */
    int nbrancos;		/* numero de brancos a esquerda da tabela */
    int lintit;			/* numero de linhas do cabecalho */
    int j;

    struct simb *p;		/* Ponteiro para tabela de hash */

    nbrancos = (int) ((n_col - 47) / 2);

    imp_id(pos, fl_imp, n_col, &lintit, nbrancos);

    k = 0;
    f_a = 0;
    f_ra = 0.0;

    while (k < n) {

	if ((p = pesquisa(nome[k], tabhash[0])) != SNULL) {

	    if (strcmp(p->nome, ".") || fl_mis) {
		f_a += p->def;
		f_r = (double) p->def / (double) geral;
		f_ra += f_r;

		if (strlen(p->nome) > 10) {
		    strncpy(name, p->nome, 10);
		    name[10] = '\0';
		} else
		    strcpy(name, p->nome);

		brancos(nbrancos);
		/*
		   printf("%10s %9ld ",name,p->def);
		   printf("%9ld %9.2f %11.2f",f_a,
		   f_r*100.,f_ra*100.); 
		 */
		printf("%10s %9s ", name, rounddec((double) p->def, 9, 0));
		printf("%9s %9.2f %11.2f", rounddec((double) f_a, 9, 0),
		       f_r * 100., f_ra * 100.);

		/* ARQUIVO NTIA_SAIDA */
		if (output && (i == 0)) {
		    for (j = 0; j < n_class; ++j) {
			obserp[j] = pchar;
			strcpy(pchar, obs2[j]);
			pchar += (strlen(pchar) + 1);
		    }

		    obserp[n_class] = pchar;
		    strcpy(pchar, p->nome);
		    pchar += (strlen(pchar) + 1);

		    obserp[n_class + 1] = pchar;
		    gcvt((double) p->def, 15, pchar);
		    pchar += (strlen(pchar) + 1);

		    /* GRAVAR OBSERP */
		    ret = grav_obs(fout, obserp);
		    if (ret < 0L) {
			fprintf(stderr, PegaMsg(5018), "");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("*** Lista de memoria nao esta' vazia ***\n");
			    Mem_Store("freq");
			    exit(2);
			}
#endif

			exit(2);
		    }

		    pchar = obser;
		}
	    }

	} else {

/* *** Padroniz. msg erro - Luciana 15/12/94
			printf("*** Problema no algoritmo de hash.Avise NTIA ***\n");
*** */
	    printf(PegaMsg(5013));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(1);
	    }
#endif
	    exit(1);
	}
	++k;

	if (k != n && (k % (n_linhas - lintit - 4)) == 0) {
	    brancos(nbrancos);
	    printf
		("----------------------------------------------------\n");
	    imp_id(pos, fl_imp, n_col, &lintit, nbrancos);
	}
    }

    brancos(nbrancos);
    printf("----------------------------------------------------\n");
}

void imp_id(pos, fl_imp, n_col, lintit, nbrancos)
int pos;
int fl_imp;
int n_col;
int *lintit;
int nbrancos;
{
    int ret;

    double mmax;
    double mmin;
    char tipo;
    char name[9];
    char tit[16];

    tit[0] = '\0';
    name[0] = '\0';
    (*lintit) = 0;

    ret =
	pega_var(fd, pos, name, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }


    if (fl_imp)
	putchar(12);

    if (n_tit > 0) {
	printf("\n");
	imp_tl(n_col);
	(*lintit) = n_tit;
    } else {
	tit1(n_col, pos);
	(*lintit) += 2;
	if (pos_rep != -1) {
	    titpeso(n_col);
	    (*lintit) += 2;
	}
	if (n_class > 0) {
	    titclass(n_col);
	    (*lintit) += 3;

	    if (n_class > 2)
		(*lintit) += 4;
	    else
		(*lintit) += 2;
	}
	printf("\n");
    }


    /* Identificacao das var. de classe */

    if (n_class > 0) {
	qclass(n_col);
	printf("\n");
    }


    brancos(nbrancos);
    printf("----------------------------------------------------");

    brancos(nbrancos);
    printf("%10s %9s %9s %9s %11s", " ", " ", "Freq.", "Freq.",
	   "Freq.Rel.");

    brancos(nbrancos);
    printf("%10s %9s %9s %9s", name, "Freq.", "Acum.", "Rel. ");
    printf(" %11s", "Acum.    ");

    brancos(nbrancos);
    printf("----------------------------------------------------");
}
