
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a montagem de tabela multidimensional

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/tabn.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#ifndef VAXVMS
#include <malloc.h>
#endif
#include "freq.h"
#include "pcsgbd.h"

#ifdef  MEM_DEBUG
#include "mshell.h"
#endif

extern int n_tit;
extern int opm, opp, opx;
extern int n_class;
extern int classv[MAXCLASS];
extern int pos_rep;

static char *sccsid = "@(#)tabn.c	3.5	(NTIA/freq)	95/07/26";

extern char obs2[MAXCLASS][80];

void imp_tab(num, n_obs, fl_imp, fl_a, mat, i, nlinhas, ncol,
	     somalin, somacol, total)
int num;
int *n_obs;
int fl_imp;
int fl_a;
long *mat;
int i;
int nlinhas;
int ncol;
long *somalin;
long *somacol;
long total;
{

    int cesq, ccel, cdir, lcab, lcel, ldep;
    int n0, n1, n2, n3, n4;
    int k, l, m, t;
    int tem_linha, tem_col;
    int inil, inic, inic2, inicio, fim, ncolimp;
    int lin, col, aux;
    double qui;
    int totl, totc;
    int nbrancos;
    char tipo;

    n0 = n_obs[num - 1];	/* numero de colunas de tab */
    n1 = n_obs[num - 2];	/* numero de linhas de tab */
    n2 = k = 0;			/* controle para a terceira dimensao */
    n3 = l = 0;			/* controle para a quarta dimensao */
    n4 = m = 0;			/* controle para a quinta dimensao */

    tem_linha = 0;		/* existem linhas a serem impressas */
    tem_col = 0;		/* existem colunas a serem impressas */
    totl = 0;			/* imprimir marginal de linha */
    totc = 0;			/* imprimir marginal de coluna */
    qui = 0.0;
    inil = 0;			/* numero de linhas ja impressas */
    ncolimp = 0;		/* numero de colunas ja impressas */
    inic = 0;			/* apontador de colunas impressas */
    inic2 = 0;			/* apontador da ultima posicao ocupada por inic */
    inicio = 0;			/* apontador para ultima coluna impressa */
    t = 1;			/* no. do intervalo em que ocorre a impressao */

    if (num > 2)
	limit(&n2, &n3, &n4, num, n_obs);

    setacol(&cesq, &ccel, &cdir);
    setalin(&lcab, &lcel, &ldep, num);

    /* quebra dos niveis e impressao das tabelas */

    do {
	do {
	    do {
		/* IMPRESSAO DA TABELA BI DIMENSIONAL */
		/* CONTROLE DE LINHAS E COLUNAS */

		fim = t * n0 * n1;

		do {		/* PARA AS LINHAS DA TABELA */

		    tipo = 'l';
		    lin = ncas(tipo, lcab + 1, lcel, nlinhas, ncol);
		    tipo = 'c';
		    col = ncas(tipo, cesq + 2, ccel + 2, nlinhas, ncol);

		    if ((lin + inil) >= n1) {
			lin = n1 - inil;
			aux = lin * lcel + lcab + 1 + ldep;
			if (aux > nlinhas) {
			    --lin;
			    tem_linha = 0;
			    totc = 0;
			} else {
			    tem_linha = 1;
			    totc = 1;
			}
		    }

		    do {	/* PARA AS COLUNAS DA TABELA */
			if ((col + ncolimp) >= n0) {
			    col = n0 - ncolimp;
			    aux = col * (ccel + 2) + cdir + cesq;
			    if (aux > ncol) {
				--col;
				tem_col = 0;
				totl = 0;
			    } else {
				tem_col = 1;
				totl = 1;
			    }
			}

			/* Numero de brancos a esq. */

			aux = col * (ccel + 2) + cesq + cdir * totl;
			nbrancos = (int) ((ncol - aux) / 2);

			/* imprime a tabela */

			inic = inicio;

			pula_pagina(fl_imp, fl_a);

			cabecalho(num, cesq, inic, col,
				  ccel, totl, i, ncol, k,
				  l, m, n0, nbrancos);

			tabn(&inicio, &inil, &inic, lin,
			     col, fim, totc, totl, &inic2,
			     n0, &qui, total, mat, num, cesq,
			     cdir, ccel, ncol, somalin,
			     somacol, ncolimp, nbrancos);

			ncolimp += col;

		    } while (!tem_col);

		    inil += lin;
		    ncolimp = 0;
		    tem_col = 0;
		    totl = 0;
		    inic = inic2;
		    inicio = inic2;

		} while (!tem_linha);

		inil = 0;
		ncolimp = 0;
		inicio = fim;
		inic = fim;
		inic2 = fim;
		tem_linha = 0;
		tem_col = 0;
		totl = 0;
		totc = 0;
		++t;		/* proximo intervalo */

		++k;		/* muda nivel da terceira var */
	    }
	    while (k < n2);

	    k = 0;
	    ++l;		/* muda nivel da segunda variavel */
	}
	while (l < n3);

	l = 0;
	++m;			/* muda nivel da primeira variavel */
    }
    while (m < n4);

    if (opx) {			/* calcula e imprime valor do qui-quadrado */
	if ((lcab + lcel * lin + ldep + 5) < nlinhas) {
	    printf("\n");
	    imp_x(qui, n_obs, num);
	} else {
	    pula_pagina(fl_imp, fl_a);
	    imp_x(qui, n_obs, num);
	}
    }

}				/* final da impressao */


/* ====================================================================== */

void tabn(inicio, inil, inic, lin, col, fim, totc, totl, inic2, n0, qui,
	  total, mat, num, cesq, cdir, ccel, ncol, somalin, somacol,
	  ncolimp, nbrancos)
int *inicio;
int *inil;
int *inic;
int lin;
int col;
int fim;
int totc;
int totl;
int *inic2;
int n0;
double *qui;
long total;
long *mat;
int num;
int cesq;
int cdir;
int ccel;
int ncol;
long *somalin;
long *somacol;
int ncolimp;
int nbrancos;

{

    int ii, aux;
    double q1;			/* qui-quadrado */

    q1 = *qui;

    aux = (*inil) + lin;
    for (ii = (*inil); ii < aux; ii++) {
	/*imp. valor da freq. */
	imp_linha(1, *inic, mat, cesq, cdir, ii, total, somalin,
		  somacol, &q1, num, col, ccel, totl, n0, ncol, nbrancos);

	if (opp) {
	    /*imp. valor porc. */
	    imp_linha(2, *inic, mat, cesq, cdir, ii,
		      total, somalin, somacol, &q1, num, col, ccel, totl,
		      n0, ncol, nbrancos);

	    /*valor porc. linha */
	    imp_linha(3, *inic, mat, cesq, cdir, ii,
		      total, somalin, somacol, &q1, num, col, ccel, totl,
		      n0, ncol, nbrancos);

	    /*valor porc. coluna */
	    imp_linha(4, *inic, mat, cesq, cdir, ii,
		      total, somalin, somacol, &q1, num, col, ccel, totl,
		      n0, ncol, nbrancos);

	}
	if (opx) {
	    /* valor qui-quadrado */
	    imp_linha(5, *inic, mat, cesq, cdir, ii,
		      total, somalin, somacol, &q1, num, col, ccel, totl,
		      n0, ncol, nbrancos);

	}

	imp_traco(col, cesq, ccel, totl, nbrancos);

	if (((*inic) + n0) < fim)
	    (*inic) += n0;

	if (ncolimp == 0)
	    (*inic2) = (*inic);

	if (ii == (*inil))
	    (*inicio) += col;

    }
    if (totc && opm) {
	brancos(nbrancos);
	printf("%*s |", cesq, "marginal");

	aux = (*inic) + col;
	for (ii = (*inic); ii < aux; ++ii)
	    /*
	       printf("%*ld |",ccel,somacol[(ii % n0)]);
	     */
	    printf("%*s |", ccel, rounddec((double) somacol[(ii % n0)],
					   ccel, 0));

	if (totl)
	    /*
	       printf(" %*ld",(cdir-1),total);
	     */
	    printf(" %*s", (cdir - 1),
		   rounddec((double) total, (cdir - 1), 0));

	if (opp) {
	    brancos(nbrancos);
	    printf("%*s |", cesq, "   ");

	    for (ii = (*inic); ii < aux; ++ii)
		printf("%*.3g |", ccel, (float) (somacol
						 [(ii % n0)]) /
		       (float) (total));

	    if (totl)
		printf(" %*s", (cdir - 1), "1.0");
	}
    }

    printf("\n");

    (*qui) = q1;
}

/* ======================================================================= */

void cabecalho(num, cesq, inic, col, ccel, totl, i, ncol, k, l, m, n0,
	       nbrancos)
int num;
int cesq;
int inic;
int col;
int ccel;
int totl;
int i;
int ncol;
int k;
int l;
int m;
int n0;
int nbrancos;
{

    extern struct acao ac_freq[MAXFREQ];
    extern char **nome[MAXDIM];
    extern ARQ *fd;

    char name[30];
    char vet[11];
    char buf[61];
    double mmin;
    double mmax;
    char tipo;
    int j, aux;
    int ret;


    if (n_tit > 0) {
	printf("\n");
	imp_tl(ncol);
    } else {
	titn(num, ncol, i);
	if (pos_rep != -1)
	    titpeso(ncol);
	if (n_class > 0)
	    titclass(ncol);
	printf("\n");
    }

    /* Identificacao das variaveis do comando class */

    if (n_class > 0) {
	qclass(ncol);
	printf("\n");
    }

    /* Nome dos niveis de cada tabela */

    if (num > 2) {

	switch (num) {
	case 3:		/* imp. nome da terceira variavel */
	    printf("\n      ");
	    imp_var(ac_freq[i].pos_freq[0], nome[0][k]);
	    printf("\n");
	    break;

	case 4:		/* imp. nome da terceira e quarta variaveis */
	    printf("\n      ");
	    imp_var(ac_freq[i].pos_freq[0], nome[0][l]);
	    imp_var(ac_freq[i].pos_freq[1], nome[1][k]);
	    printf("\n");
	    break;

	case 5:		/* imp. nome da terceira, quarta e quinta variaveis */
	    printf("\n      ");
	    imp_var(ac_freq[i].pos_freq[0], nome[0][m]);
	    imp_var(ac_freq[i].pos_freq[1], nome[1][l]);
	    imp_var(ac_freq[i].pos_freq[2], nome[2][k]);
	    printf("\n");
	    break;
	}

    }

    /* IDENTIFICACAO DAS VARIAVEIS DE LINHA E COLUNA */

    if (n_tit == 0) {
	buf[0] = '\0';
	strcpy(buf, "Tabela: ");
	ret = pega_var(fd, ac_freq[i].pos_freq[num - 2], name, &tipo,
		       (MINVAL *) & mmin, (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}

	errovar(name);
	strcat(buf, name);
	strcat(buf, " (linha) por ");

	ret = pega_var(fd, ac_freq[i].pos_freq[num - 1], name, &tipo,
		       (MINVAL *) & mmin, (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}
	errovar(name);
	strcat(buf, name);
	strcat(buf, " (coluna)");
	printf("\n%*s\n", strlen(buf), center(buf, ncol));
    }

    /* TABELA */

    brancos(nbrancos);
    printf("%-*s |", cesq, center("frequencia", cesq));
    if (opp) {
	brancos(nbrancos);
	printf("%-*s |", cesq, center("% total", cesq));

	brancos(nbrancos);
	printf("%-*s |", cesq, center("% linha", cesq));

	brancos(nbrancos);
	printf("%-*s |", cesq, center("% coluna", cesq));
    }

    if (opx) {
	brancos(nbrancos);
	printf("%-*s |", cesq, center("qui-quadrado", cesq));
    }

    aux = col + inic;
    for (j = inic; j < aux; ++j) {
	if (strlen(nome[num - 1][(j % n0)]) > 10) {
	    strncpy(vet, nome[num - 1][(j % n0)], 10);
	    vet[10] = '\0';
	    printf("%*s |", ccel, center(vet, ccel));
	} else
	    printf("%*s |", ccel, center(nome[num - 1][(j % n0)], ccel));
    }

    if (opm && totl)
	printf("%10s", "marginal");

    imp_traco(col, cesq, ccel, totl, nbrancos);
}
