
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a montagem/impressao dos titulos

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/titdef.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "freq.h"
#include "pcsgbd.h"

extern int pos_rep;
extern struct acao ac_freq[MAXFREQ];

extern ARQ *fd;
extern char obs2[MAXCLASS][80];

static char *sccsid = "@(#)titdef.c	3.3	(NTIA/freq)	95/01/11";

void titn(num, ncol, i)		/* imprime : Tabela xx*yy*zz*ww*tt */
int num;			/* (caso multidimensional) */
int ncol;
int i;
{
    int j;
    int ret;
    char tit[53];
    char name[16];
    char tipo;
    double mmin, mmax;

    tit[0] = '\0';
    name[0] = '\0';

    strcpy(tit, "Tabela: ");
    ret = pega_var(fd, ac_freq[i].pos_freq[0], name, &tipo,
		   (MINVAL *) & mmin, (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(name);
    strcat(tit, name);

    for (j = 1; j < num; ++j) {
	strcat(tit, "*");
	name[0] = '\0';
	ret = pega_var(fd, ac_freq[i].pos_freq[j], name, &tipo,
		       (MINVAL *) & mmin, (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}
	errovar(name);
	strcat(tit, name);
    }

    printf("\n%*s", strlen(tit), center(tit, ncol));
}

/* ================================================================== */

void titclass(ncol)		/* identificacao das variaveis de classe */
int ncol;
{
    char name[16];
    char tit[72];
    char tipo, s;
    double mmin, mmax;
    int j;
    int ret;

    extern int n_class;
    extern int classv[MAXCLASS];

    tit[0] = '\0';

    strcpy(tit, "Classificada por:");
    for (j = 0; j < n_class; ++j) {
	name[0] = '\0';
	ret = pega_var(fd, classv[j], name, &tipo,
		       (MINVAL *) & mmin, (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}

	errovar(name);
	strcat(tit, " ");
	strcat(tit, name);
    }

    if ((j = strlen(tit)) > ncol) {
	s = ' ';
	quebra_buf(tit, s, ncol);
    } else {
	printf("\n%*s", strlen(tit), center(tit, ncol));
    }
}


/* ================================================================== */

void titpeso(ncol)		/* imprime : Repeticao xxxxx */
int ncol;
{
    char tit[19];
    char name[16];
    char tipo;
    double mmin, mmax;
    int ret;

    tit[0] = '\0';
    name[0] = '\0';

    ret =
	pega_var(fd, pos_rep, name, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(name);
    strcpy(tit, "Repeticao ");
    strcat(tit, name);

    printf("\n%*s", strlen(tit), center(tit, ncol));
}

/* ================================================================== */

void qclass(ncol)		/* imprime os niveis das var. de classe */
int ncol;
{
    char tit[120];
    char namev[16];		/* guarda nome da variavel */
    char namen[15];		/* guarda os 10 primeiros caracteres da obser.  */
    char s, tipo;
    double mmin, mmax;

    extern int n_class;
    extern int classv[MAXCLASS];

    int j, k;
    int ret;

    tit[0] = '\0';
    namev[0] = '\0';
    namen[0] = '\0';

    for (j = 0; j < n_class; ++j) {
	ret = pega_var(fd, classv[j], namev, &tipo,
		       (MINVAL *) & mmin, (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}

	errovar(namev);
	strcat(tit, namev);
	strcat(tit, "=");

	namen[0] = '\0';

	if (tipo == 'd') {
	    dtoa(atof(obs2[j]), namen);
	    k = 10;
	} else {
	    if ((k = strlen(obs2[j])) > 10) {
		strncpy(namen, obs2[j], 10);
		namen[10] = '\0';
	    } else {
		strcpy(namen, obs2[j]);
	    }
	}

	strcat(tit, namen);
	strcat(tit, " ");
	namev[0] = '\0';
    }

    if ((k = strlen(tit)) > ncol) {
	s = ' ';
	quebra_buf(tit, s, ncol);
    } else {
	printf("\n%*s", k, center(tit, ncol));
    }
}

/* ================================================================== */

void tnivn(n_obs, num, i)	/* imprime: variavel1 = nn niveis */
int *n_obs;
int num;
int i;
{
    int j;
    int ret;
    char name[16];
    char tipo;
    double mmin, mmax;

    printf("\n      Descricao das variaveis da tabela\n\n");
    printf("\n      Variavel    # niveis");

    for (j = 0; j < num; ++j) {
	ret = pega_var(fd, ac_freq[i].pos_freq[j], name, &tipo,
		       (MINVAL *) & mmin, (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}

	errovar(name);
	printf("\n      %8s    %5d", name, n_obs[j]);
    }
}

/* ================================================================== */

void tniv1(pos, n)
int pos;
unsigned n;
{
    char name[16];
    char tipo;
    double mmin, mmax;
    int ret;

    printf("\n      Descricao da variavel da tabela\n\n");
    ret =
	pega_var(fd, pos, name, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(name);
    printf("\n      Variavel    # niveis");
    printf("\n      %8s    %5d", name, n);
}

/* ================================================================== */

void tit1(n_col, pos)
int n_col;
int pos;
{
    char tit[17];
    char name[16];
    char tipo;
    double mmin, mmax;
    int ret;

    ret =
	pega_var(fd, pos, name, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(name);
    strcpy(tit, "Tabela: ");
    strcat(tit, name);
    printf("\n%*s", strlen(tit), center(tit, n_col));
}

/* ================================================================== */

void quebra_buf(buf, s, ncol)	/* quebra buf no s mais a esquerda possivel */
char *buf;
char s;
int ncol;
{
    int quebra, acabou, vai, ini;
    int tam, k, j;
    char buf1[150];

    buf1[0] = '\0';
    quebra = acabou = vai = 0;

    tam = strlen(buf);

    while (acabou == 0) {	/* todas as quebras */
	ini = vai;
	while (quebra == 0) {	/* primeira quebra */
	    for (k = vai; (buf[k] != s) && (buf[k] != '\0'); ++k);
	    if ((k - ini) < ncol) {
		vai = k + 1;
		if (buf[k] == '\0')
		    quebra = 1;
	    } else {
		quebra = 1;
	    }
	}

	j = 0;
	for (k = ini; k < (vai - 1); ++k) {
	    buf1[j] = buf[k];
	    ++j;
	}

	buf1[vai - 1] = '\0';
	printf("\n%*s", vai, center(buf1, ncol));
	buf1[0] = '\0';

	if ((tam - vai) < ncol) {
	    if ((tam - vai) < 0)
		acabou = 1;
	    else {
		j = 0;
		for (k = vai; k < tam; ++k) {
		    buf1[j] = buf[k];
		    ++j;
		}

		buf1[j] = '\0';
		printf("\n%*s", j + 1, center(buf1, ncol));
		acabou = 1;
	    }
	}

	quebra = 0;
	buf1[0] = '\0';
	vai++;
    }
    printf("\n");
}

/* ================================================================== */

void titfinal(total, nmis, fl_mis)
long total;
long nmis;
int fl_mis;
{
    long n;

    if (fl_mis)
	n = total;
    else
	n = total + nmis;

    printf("\n      Numero de observacoes lidas      : %ld", n);
    printf("\n      Numero de observacoes utilizadas : %ld\n", total);
}
