
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes utilizadas no tratamento do comando class

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/tratcl.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include "freq.h"
#include "pcsgbd.h"

#ifdef MSDOS
#include <stdlib.h>
#endif

#ifdef SUN
#include <stdlib.h>
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)tratcl.c	3.3	(NTIA/freq)	94/12/16";

extern int n_class;
extern int classv[MAXCLASS];
extern int tip_by[MAXCLASS];

extern char obs2[MAXCLASS][80];
extern char *obs[OBSSIZE];

void inicioby()
{				/* inicializa obs2 com as classes */
    int ii;

    for (ii = 0; ii < n_class; ++ii) {
	strcpy(obs2[ii], obs[classv[ii]]);
    }
}

/* ====================================================================== */

class()
{
    int i;
    int k;
    int flag;
    double x;
    double y;
    extern int ordc;

    if (n_class == 0)
	return 0;

    flag = 0;
    for (i = 0; i < n_class; ++i) {
	k = classv[i];
	if (tip_by[i]) {	/* Var. Numerica  ou Data */
	    x = ((strcmpi(obs[k], ".")) == 0) ? MISSING : atof(obs[k]);
	    y = ((strcmpi(obs2[i], ".")) == 0) ? MISSING : atof(obs2[i]);
	    if (x != y) {
		flag = -1;
		if (ordc) {
		    if (x < y)
			erroclass();
		} else {
		    if (x > y)
			erroclass();
		}
		break;
	    }
	} else {
	    if (strcmpi(obs[k], obs2[i]) != 0) {
		flag = -1;
		if (ordc) {
		    if (strcmpi(obs[k], obs2[i]) < 0)
			erroclass();
		} else {
		    if (strcmpi(obs[k], obs2[i]) > 0)
			erroclass();
		}
		break;
	    }
	}
    }
    return flag;
}

/* ====================================================================== */

void erroclass()
{
    fprintf(stderr, "\r            \n");

/* *** Padroniz. msg erro - Luciana 16/12/94
	printf("\nADVERTENCIA :\n");
	printf("	Arquivo nao ordenado pela(s) variavel(is) do comando CLASS.\n");
	printf("	Use o modulo ORDENA para obter ordenacao apropriada.\n");
*** */
    printf(PegaMsg(1082));
    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("freq");
	exit(1);
    }
#endif

    exit(1);
}
