
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes a execucao do modulo FREQ no caso unidimensional

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/unid.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/



#include <stdio.h>
#include <malloc.h>

#if !defined(VAXVMS) & !defined(i486)
#include <search.h>
#endif

#include <sys/types.h>

#include <string.h>
#include "pcsgbd.h"
#include "freq.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)unid.c	3.12	(NTIA/freq)	95/10/09";

#ifdef MSDOS
#include <stdlib.h>
#endif

extern struct simb **tabhash[MAXDIM];
extern int tamhash;

extern char **nome[MAXDIM];

extern struct acao ac_freq[MAXFREQ];
extern ARQ *fd;
extern ARQ *fout;

extern int pos_rep;
extern int n_class;
extern int ordc;
extern int output;
extern int classv[MAXCLASS];

#if defined(SUN) & !defined(RS6000) & !defined(IRIX)
#define labs			abs
#endif

char *obs[OBSSIZE];		/* observacao lida */
char obs2[MAXCLASS][80];	/* obser. das variaveis de classe */
char obser[MAXTOBS];		/* vetor com o conteudo das observacoes */
char *pchar;			/* ponteiro par os elementos de obser */
char *obserp[MAXVAR];		/* guarda os pontiros para obser */

void unid(i, fl_mis, fl_ord, fl_imp, fl_iter, n_linhas, n_col)
int i;				/* indice do comando sendo analisado */
int fl_mis;			/* usa missing ou nao :default nao usar */
int fl_ord;			/* 0 : ordenar por chave   1 : ordenar por freq. */
int fl_imp;			/* para controle de paginas */
int fl_iter;			/* saber se e' iterativo ou em batch */
int n_linhas;			/* numero de linhas do relatorio : default 30 */
int n_col;			/* numero de colunas do relatorio : default 78 */
{
    int ret;
    char tmpbuf[128];		/* Luciana */

    unsigned n = 0;
    unsigned m = 0;
    long geral = 0L;

    int tamalloc;

    if (output && (i == 0))
	out1hdr(i);

    if (ler_obs(fd, obs) != EOF) {

	aloc1(&tamalloc);
	inicioby();
	exec1(i, &n, &geral, fl_mis, &tamalloc);

	while (ler_obs(fd, obs) != EOF) {

	    fprintf(stderr, "\r%d", ++m);

	    if (class() == 0) {
		exec1(i, &n, &geral, fl_mis, &tamalloc);
	    } else {
		exec2(i, n, fl_ord);

		/* ARQUIVO NTIA_SAIDA */
		if (output && (i == 0)) {
		    pchar = obser;
		}

		/* RELATORIO */

		fprintf(stderr, "\r         \r");
		pula_pagina(fl_imp, fl_iter);
		pag11(n, n_col, ac_freq[i].pos_freq[0],
		      (long) geral, fl_mis);
		tab1(nome[0], geral, n, n_linhas, fl_imp,
		     fl_mis, n_col, ac_freq[i].pos_freq[0], i, fl_iter);

		n = 0;
		inicioby();
		lib1(&n, &geral, tamalloc);
		aloc1(&tamalloc);
		exec1(i, &n, &geral, fl_mis, &tamalloc);
	    }
	}

	fprintf(stderr, "\r         \r");

	exec2(i, n, fl_ord);

	/* ARQUIVO NTIA_SAIDA */
	if (output && (i == 0)) {
	    pchar = obser;
	}

	/* RELATORIO */
	pula_pagina(fl_imp, fl_iter);
	pag11(n, n_col, ac_freq[i].pos_freq[0], (long) geral, fl_mis);
	tab1(nome[0], geral, n, n_linhas, fl_imp, fl_mis, n_col,
	     ac_freq[i].pos_freq[0], i, fl_iter);
	lib1(&n, &geral, tamalloc);
    } else {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("ARQUIVO VAZIO",CNULL,1);
*** */
	sprintf(tmpbuf, PegaMsg(1004), "");
	execerro(tmpbuf, CNULL, 1);
    }

    if (output && (i == 0)) {
	if (NRO_OBS(fout) == 0L) {
	    ret = fech_vazio(fout);
	    if (ret < 0) {
		fprintf(stderr, PegaMsg(1011), "");
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("*** Lista de memoria nao esta' vazia ***\n");
		    Mem_Store("freq");
		    exit(2);
		}
#endif

		exit(2);
	    }
	} else {
	    ret = fech_arq(fout);
	    if (ret < 0) {
		fprintf(stderr, PegaMsg(1011), "");
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("*** Lista de memoria nao esta' vazia ***\n");
		    Mem_Store("freq");
		    exit(2);
		}
#endif

		exit(2);
	    }
	}
    }
}

/* ====================================================================== */

void exec1(i, n, geral, fl_mis, tamalloc)
int i;
unsigned int *n;
long *geral;
int fl_mis;
int *tamalloc;
{
    TIPO_H rep;
    char ss[128];
    char *ptr;
    struct simb *p;
    int tem;

    rep = 1L;

    if (pos_rep != -1) {
	if (strcmp(obs[pos_rep], ".") == 0)
	    goto outra_obs;
	else {
	    rep = atol(obs[pos_rep]);
	    if (rep <= 0L || ((ptr = strchr(obs[pos_rep], '.')) &&
			      atoi(ptr + 1) != 0)) {

/* *** Padroniz. msg erro - Luciana 15/12/94
					execerro("Variavel do comando REP nao e"
							," inteira positiva",1);
*** */
		execerro(PegaMsg(3087), CNULL, 1);
	    }
	}
    }

    strcpy(ss, obs[ac_freq[i].pos_freq[0]]);
    p = pesquisa(ss, tabhash[0]);
    if (p != SNULL) {
	p->def += rep;
    } else {
	p = instala(ss, rep, tabhash[0], &tem);
	if ((int) (*n) >= (*tamalloc)) {
	    (*tamalloc) += 100;
/*
			nome[0] = (char **) realoca(nome[0],sizeof
					(char *),(*tamalloc) );
*/
	    nome[0] = (char **) realloc(nome[0], (unsigned)
					((sizeof(char *)) * (*tamalloc)));
/* Sonia: troca acima feita para uso do MSHELL */
	}
	nome[0][(*n)++] = p->nome;
    }

    if (fl_mis || !(mis(i, 1)))
	*geral += rep;

  outra_obs:;

}


/* ====================================================================== */

void exec2(i, n, fl_ord)
int i;
unsigned int n;
int fl_ord;
{
    int ret;

    char tipo;
    char name[16];
    double mmin, mmax;

    ret = pega_var(fd, ac_freq[i].pos_freq[0], name, &tipo,
		   (MINVAL *) & mmin, (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(name);

    if (fl_ord) {
	qsort((void *) nome[0], (size_t) n, (size_t) sizeof(char *),
	      comp_freq);
    } else {
	if (tipo == 'c')
	    qsort((void *) nome[0], (size_t) n,
		  (size_t) sizeof(char *), comps);
	else
	    qsort((void *) nome[0], (size_t) n,
		  (size_t) sizeof(char *), compn);

    }

}


/* ====================================================================== */

void aloc1(tamalloc)
int *tamalloc;
{

    tabhash[0] = (struct simb **) aloc(tamhash, sizeof(struct simb *));
/*
	nome[0] = (char **) aloc(TAMINI,sizeof (char *));
*/
    nome[0] = (char **) calloc(TAMINI, sizeof(char *));
/* Sonia: troca acima feita para uso do MSHELL */
    (*tamalloc) = TAMINI;
}


/* ====================================================================== */

void lib1(n, geral, tamalloc)
unsigned int *n;
long *geral;
int tamalloc;
{
    int k;

    (*n) = 0;
    (*geral) = 0;

    for (k = 0; k < tamalloc; ++k) {
	if (nome[0][k] != CNULL)
	    free((char *) nome[0][k]);
    }
    free((char *) nome[0]);

    for (k = 0; k < tamhash; ++k) {
	if (tabhash[0][k] != SNULL)
	    free((char *) tabhash[0][k]);
    }
    free((char *) tabhash[0]);
}

/* ====================================================================== */

void out1hdr(i)
int i;
{
    int j;
    char tipo;
    char nome[16];
    double mmin, mmax;
    int ret;			/* Luciana */
    char tmpbuf[128];		/* Luciana */

    for (j = 0; j < n_class; ++j) {
	ret = pega_var(fd, classv[j], nome, &tipo, (MINVAL *) & mmin,
		       (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}

	errovar(nome);
	if (ret = def_var(fout, nome, tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 15/12/94
			execerro("Erro : nao pode criar mais variaveis",CNULL,1);
*** */
	    sprintf(tmpbuf, PegaMsg(5046), nome, ret);
	    execerro(tmpbuf, CNULL, 1);
	}
    }

    ret =
	pega_var(fd, ac_freq[i].pos_freq[0], nome, &tipo,
		 (MINVAL *) & mmin, (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(nome);
    if (ret = def_var(fout, nome, tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("Erro : nao pode criar mais variaveis",CNULL,1);
*** */
	sprintf(tmpbuf, PegaMsg(5046), nome, ret);
	execerro(tmpbuf, CNULL, 1);
    }

    if (ret = def_var(fout, "freq", 'n') == -1) {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("Erro : nao pode criar mais variaveis",CNULL,1);
*** */
	sprintf(tmpbuf, PegaMsg(5046), "freq", ret);
	execerro(tmpbuf, CNULL, 1);
    }
}
