
/***********************************************************************************
 FREQ - Gera tabelas para descrever a distribuio da frequencia dos valores

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes referentes ao tratamento das variaveis de cada comando do
	modulo

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/freq/fontes/variavel.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:07:20 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>

#include "getoken.h"
#include "pcsgbd.h"
#include "freq.h"

#ifdef MSDOS
# include "y_tab.h"
# include <stdlib.h>
#else
#ifdef VAXVMS
# include "y_tab.h"
#else
# include "y.tab.h"
#endif
#endif

static char *sccsid = "@(#)variavel.c	3.6	(NTIA/freq)	95/01/24";

extern YYSTYPE yylval;
extern ARQ *fd;
extern int ret_lex;
extern struct acao ac_freq[MAXFREQ];

/*
 *	yylex()
 *
 *	analisador lexico para freq 
 * 
 */

yylex()
{

    char error[128];
    char token[128];
    int c;
    int s;

    c = getoken(token);

    if (strcmpi(token, "tab") == 0)
	return TAB;
    if (strcmpi(token, "est") == 0)
	return EST;
    if (strcmpi(token, "marg") == 0)
	return MARG;
    if (strcmpi(token, "pct") == 0)
	return PCT;
    if (strcmpi(token, "qui") == 0)
	return QUI;
    if (strcmpi(token, "rep") == 0)
	return REP;
    if (strcmpi(token, "class") == 0)
	return CLASS;
    if (strcmpi(token, "ord") == 0)
	return ORD;
    if (strcmpi(token, "asc") == 0)
	return ASC;
    if (strcmpi(token, "desc") == 0)
	return DESC;
    if (strcmpi(token, "tl") == 0)
	return TL;
    if (strcmpi(token, "}") == 0)
	return '}';

    switch (c) {
    case VARIAV:{
	    if ((s = veri_var(fd, token)) < 0) {

/* *** Padroniz. msg erro - Luciana 15/12/94
				strcpy(error,"Variavel '");
				strcat(error,token);
				strcat(error,"'");
				execerro(error,"nao existe no arquivo",1);
*** */
		execerro(PegaMsg(3214), CNULL, 1);
	    } else {
		yylval.simb = s;
		return VARIAVEL;
	    }
	}
    case PTVG:
	return ';';
    case IGUAL:
	return '=';
    case STAR:{
	    ret_lex = 1;
	    return '*';
	}
    }

    return c;

}


void variavel(pos)
int pos;
{
    int i;
    int ret;
    char tipo;
    double mmin, mmax;
    char nomev[16];

    extern int n_freq;

    ret =
	pega_var(fd, pos, nomev, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(nomev);

    if (n_freq >= MAXFREQ)

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("Limite maximo de frequencias e' 10",CNULL,1);
*** */
	execerro(PegaMsg(1060), CNULL, 1);

    if (ac_freq[n_freq].num_freq >= MAXDIM)

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("Dimensao maxima e' 5",CNULL,1);
*** */
	execerro(PegaMsg(1083), CNULL, 1);

    if (ret_lex) {
	i = ac_freq[n_freq - 1].num_freq;
	++i;
	ac_freq[n_freq - 1].num_freq = i;
	ac_freq[n_freq - 1].pos_freq[i - 1] = pos;
	ac_freq[n_freq - 1].tipo[i - 1] = tipo;
	ret_lex = 0;
    } else {
	ac_freq[n_freq].num_freq = 1;
	ac_freq[n_freq].pos_freq[0] = pos;
	ac_freq[n_freq].tipo[0] = tipo;
	++n_freq;
    }
}



void rep(pos)
int pos;
{
    extern int pos_rep;
    double mmax;
    double mmin;
    char tipo;
    char nome[16];
    int ret;

    ret =
	pega_var(fd, pos, nome, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("freq");
	    exit(2);
	}
#endif

	exit(2);
    }

    errovar(nome);

    if (tipo == 'n') {
	pos_rep = pos;
    } else {

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("Variavel do comando REP nao e' numerica",CNULL,1);
*** */
	execerro(PegaMsg(3087), CNULL, 1);
    }
}


void by(pos)
int pos;
{
    extern int n_class;
    extern int classv[MAXCLASS];
    extern int tip_by[MAXCLASS];
    extern ARQ *fd;

    char vet[9];
    char nome[16];
    double mmin, mmax;
    char tipo;
    int ret;

    ++n_class;
    if (n_class > MAXCLASS) {
	strcpy(vet, "MAXCLASS");

/* *** Padroniz. msg erro - Luciana 15/12/94
		execerro("Limite maximo de variaveis de classe e' ",vet,1);
*** */
	execerro(PegaMsg(1089), CNULL, 1);
    } else {
	classv[n_class - 1] = pos;
	ret =
	    pega_var(fd, pos, nome, &tipo, (MINVAL *) & mmin,
		     (MAXVAL *) & mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("freq");
		exit(2);
	    }
#endif

	    exit(2);
	}

	if (tipo == 'n')
	    tip_by[n_class - 1] = 1;
/* OSCAR: Ate' a marca. */
	else if (tipo == 'd')
	    tip_by[n_class - 1] = 2;
/* XXXXXXXXXXXXXXXXXXXX */
	else
	    tip_by[n_class - 1] = 0;
    }
}
