/***********************************************************************************
 Genese - Linguagem de programacao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientifico

 Descrio:

	Funcao que retorna o valor interpretado de um caracter apos a barra (\).
	Tem como entrada um caracter, que deve ser a barra, obtem o na entrada padrao o 
	caracter apos a barra e retorna seu valor interpretado.
	Caso o caracter informado nao seja a barra, retorna o proprio caracter.

	int backslash(c)		
	int c: caracter no qual est posicionado e que espera-se que seja uma \;

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "pcsgbd.h"

/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para pegar o proximo caracter com \ que seja interpretado
**
**
** Valor retornado:
**		o caracter interpretado (\caracter)
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
** Data da ultima alteracao:
**
**		94/10/17 12:49:22
**
** ----------------------------------------------------------------------------
*/

int backslash(c)		/* get next char with \'s interpreted */
int c;
{
    /*
     ** Define a tabela com os caracteres interpretados
     */
    static char transtab[] = "b\bf\fn\nr\rt\t";

    /*
     ** O caracter fornecido nao e' uma \
     */
    if (c != '\\')		
	return c;
    /*
     ** Obtem o proximo caracter da entrada e procura-o na tabela,  
     ** retornando seu valor com a \.
     */
    c = xgetc(stdin);
    if (islower(c) && strchr(transtab, c))
	return strchr(transtab, c)[1];
    /*
     ** Nao encontrou o caracter na tabela
     */
    return c;
}
