/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	identifica as funcoes especiais, chamando-as para execucao


 Desenvolvido por:

      Oscar Ivan Palma Pacheco
      Carla Geovana do N. Macario
	Maria Fernanda Moura
	Adriana Delfino dos Santos
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>

#ifdef MSDOS
#include <stdlib.h>
#endif

#include <malloc.h>

#include "pcsgbd.h"
#include "genese.h"
#include "socasm.h"

#ifdef MEM_DEBUG
#include	"mshell.h"
#endif


/* ----------------------------------------------------------------------------
**
**	
**
** Identifica as funcoes especiais, chamando-as para execucao
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/06/20 10:59:17
**
** ----------------------------------------------------------------------------
*/

#ifdef DEBUG
extern int	f_1;
#endif

extern struct arquivos arquivos[];	/* estrutura com informacoes dos 
					   arquivos existentes */

extern unsigned int inst;	/* instrucao do vetor de instrucoes a ser
				   executada  */

extern char *frdform;	/* buffer com formatacao do arq. externo formatado */
extern char *formatos[];/* tabela com formatos de cada arq. formatado  */
extern int fim;		/* flag - idica fim do programa genese  */
extern int *listas[];	/* lista com vars. de cada arquivo externo  */	
extern int numvar[];	/* vetor com o no. de vars. de cara arq. externo */
extern	double	pilha[];/* pilha de dados */	
extern	int	idpilha;/* indice da pilha de dados */
extern	char	*spilha[];/* pilha de dados */	
extern	int	idspilha;/* indice da pilha de dados */

extern	char	*ops2;/* indice da pilha de dados */

void especial(s)
int s;
{
	int i, j;
	int num, op;
	static int *frdlst, frdvars;

	/* 
	** Pega o paramentro da instrucao a ser executada 
	*/

	i = OPER1;	

	/* 
	** Verifica qual e'  a funcao a ser executada 
	*/

	switch (s) {	

		/* 
		** Ler arquivo interno		
		*/

		case 0:		
			lerint(i);
			break;
		/*
		** Gravar arquivo interno	
		*/

		case 1:		
			grvint(i);
			break;

		/* 
		** Ler arquivo externo		
		*/

		case 2:		

			/*
			** Obtem o indice para acessar informacoes 
			** de arq. formatado
			*/

			num = i >> 4;
			op = i - (num << 4);
			if (op == 1) {
#ifdef DEBUG
			D1print("\tFRD formato %d\n", num);
#endif
				frdform = formatos[num];
				frdlst = listas[num];
				frdvars = numvar[num];
				break;
			}

			/* 
			** Ler arquivo externo formatado	
			*/

			if (frdform != (char *) NULL) {
				arquivos[num].pos = frdlst;
				arquivos[num].nvar = frdvars;
				lerextf(num);
				frdform = (char *) NULL;
			}

			/* 
			** Ler arquivo externo nao formatado 
			*/

			else 	
				lerextnf(num);
			break;

		/* 
		** Funcao especial		
		*/

		case 3:		

			switch (i) {

			/*
			** Verificacao de fim de arquivos.
			*/

			case VFA:
#ifdef DEBUG
				D1print("\tVerificar arquivos\n");
#endif
				if (veriarq())
					fim = 0;

				break;
			/* 
			** Comando REWIND 
			*/

			case RWND:

				/* 
				** Pega o indice do arquivo na pilha de 
				** dados
				*/

				j = (int) pilha[--idpilha];
#ifdef DEBUG
				D1print("\tRewind arquivo %s\n",
					arquivos[j].nome);
#endif
				/*
				** Posiciona logicamente na 1a. observacao
				** do arquivo
				*/

				arquivos[j].obs = 0L;

				/*
				** Executa o rewind fisicamente
				*/

				/* arq. externo */
				if (arquivos[j].arqfile) 
					fseek(arquivos[j].arq.ptraf, 0L,
						SEEK_SET);

				else	/* arq. do sistema */
					rew_arq(arquivos[j].arq.ptraa);
			

				break;

			/* 
			** Comando EXECUTE 
			*/

			case PSE:

				/* 
				** Pega o comando a ser executado na pilha de
				** strings
				*/

				ops2 = spilha[--idspilha]; 
#ifdef DEBUG
				D1print("\t PSE string: %s\n", ops2);
#endif
				/*
				** Executa o comando
				*/

				genpause(ops2); 
				free(ops2);
				ops2 = (char *) NULL;
				spilha[idspilha] = (char *) NULL;

				break;


			/*
			** Comando interno para controle do leia - onde 
			** Retira um valor da pilha.
			*/

			case POP:

				--idpilha;

				break;


		        default:

				break;

			}

			break;
	}
}

void	genpause(str)
char	*str;
{
	FILE	*fd;

	printf("%s", str);
	fflush(stdout);

#ifdef	MSDOS
	fd = fopen("con", "r");
#else
	fd = fopen("/dev/tty", "r");
#endif
	getc(fd);
	fclose(fd);
}
