/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcao execins para executar as instrucoes do vetor de instrucoes at que seja 
	detectado o final da execucao do programa genese


 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
      Carla Geovana do N. Macario
	Maria Fernanda Moura
	Adriana Delfino dos Santos
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <string.h>

#ifdef MSDOS
#include <stdlib.h>
#endif

#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif

#include "pcsgbd.h"
#include "genese.h"
#include "socasm.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para executar as instrucoes do vetor de instrucoes
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/08/10 16:21:04
**
** ----------------------------------------------------------------------------
*/


#ifdef DEBUG
extern int	f_1;
#endif

extern struct variavel variavel[]; /* informacoes das variaveis definidas */

extern struct arquivos arquivos[]; /* informacoes dos arquivos existentes */

extern	int	pc; 	/* contador do programa */
extern	int	narqs;	/* numero de arquivos existentes no programa */
extern	unsigned int	ins[]; /* vetor de instrucoes do programa */

double	pilha[MAXVAR];	/* pilha de dados para execucao */
int	idpilha = 0;	/* indice da pilha de dados  */
char	*spilha[MAXVAR];/* pilha de dados strings  */
int	idspilha = 0;	/* indice da pilha de strings */

unsigned int inst;	/* instrucao do vetor de instrucoes a ser executada */

double	randseed;

char	*obs[OBSSIZE];	/* armazena a observacao */

double	op1, op2, op3;
char	*ops1, *ops2, *ops3, *ops4;
int	fim = -1; 	/* flag - define o final do programa genese */
char	buffer[RDRBUF + 1];

extern 	int pareeof;
extern	int	warnings;

void execins()
{
	int	i, s;
	int	cont = 0;
	int	ret;
	unsigned ubytes;
#ifdef EDIX
	double *dp;
#endif

	randseed = 1.0;
	srand(1);

	/*
	** Executa as instrucoes enquanto nao for detectado o final 
	** da execucao do programa genese
	*/
	while (fim) {
#ifdef DEBUG
		printpilha();
#ifdef MSDOS
		D1print("%3d> %04x\t", pc, ins[pc]);
#else
#ifdef EDIX
		D1print("%3d> %04x\t", pc, ins[pc]);
#else
		D1print("%3d> %04x\t", pc, ins[pc]);
#endif
#endif
#endif
		/*
		** Pega a instrucao do vetor de instrucoes
		*/
		inst = ins[pc++];

		i = CODIGO1;	/* Verifica o tipo da funcao  a ser executada */
		s = OPER1;	/* Pega o parametro da funcao  */
		switch (i) {
		case 0:  /* Comando PARE */
#ifdef DEBUG
			D1print("STP\n");
#endif
			/*
			** Fim da execucao do programa genese
			*/
			if (s == 0)
				fim = 0;
			else
				termina(s);
			break;
		case 1:		/* LOAD: LDV, LDS ou LDI */
			/*
			** Testa o tipo do LOAD
			*/
			switch (SCOD) {

			/*
			** Carregar variavel numerica.
			*/

			case 0:
				if (s == VARNULL) { 
#ifdef DEBUG
					D1print("LD\t%lg <- nulo\n",
						pilha[idpilha]);
#endif
					/*
					** Variavel nula apenas incrementa o 
					** ponteiro da pilha, colocando
					** apenas um valor missing.
					*/
					pilha[idpilha++] = MISSING;
					break;
				}
				/*
				** Coloca o valor da variavel na pilha
				*/
				pilha[idpilha++] = variavel[s].ptrval.ptrf;
#ifdef DEBUG
				if (variavel[s].ptrval.ptrf >= MISSING) {
					D1print("LD\t. <- %s\n",
						variavel[s].nome);
				}
				else {
					D1print("LD\t%lf <- %s\n",
						variavel[s].ptrval.ptrf,
						variavel[s].nome);
				}
#endif
				break;

			/*
			** Carregar constante Inteira.
			*/

			case 1:

#ifdef DEBUG
					D1print("LDI\t%s\n",
						arquivos[s].nome);
#endif
				/* 
				** Coloca o valor inteiro na pilha
				*/
				pilha[idpilha++] = (double) s;

				break;

			/*
			** Carregar variavel string.
			*/

			case 3:
				ops1 = variavel[s].ptrval.ptrs;
				ubytes = (unsigned) (strlen(ops1) + 1);
				if ((ops2=(char *)malloc(ubytes))==(char *)NULL)

					execerror( PegaMsg (1039), "");

				strcpy(ops2, ops1);
#ifdef DEBUG
				if (variavel[s].nome) {
					D1print("LDS\t<%s> <- %s\n", ops2,
						variavel[s].nome);
				}
				else {
					D1print("LDS\t<%s> <- %s\n", ops2,
						variavel[s].ptrval.ptrs);
				}
#endif
				/* 
				** Coloca na pilha de string o apontador para 
				** a variavel string
				*/
				spilha[idspilha++] = ops2;
				break;
			}

			break;
		case 2:		/* STORE : STV ou STS */
			/*
			** Testa o tipo do STORE
			*/
			if (SCOD) { 
			/* 
			** Atribui valor para variavel string
			*/
				if ( variavel[s].ptrval.ptrs != (char *) NULL );
					free(variavel[s].ptrval.ptrs );

				variavel[s].ptrval.ptrs = spilha[--idspilha];
#ifdef DEBUG
				D1print("STS\t<%s> -> %s\n",
					variavel[s].ptrval.ptrs,
					variavel[s].nome);
#endif
				break;
			}
			else {
			/*
			** Atribui valor para variavel numerica
			*/
				if (s == VARNULL) {
					--idpilha;
#ifdef DEBUG
					D1print("ST\t%lg -> nulo\n",
						pilha[idpilha]);
#endif
					break;
				}
#ifdef EDIX
				dp = &(variavel[s].ptrval.ptrf);
				*dp = pilha[--idpilha];
#else
				/*
				** Atribui o valor numerico para a variavel
				*/
				variavel[s].ptrval.ptrf = pilha[--idpilha];
#endif
#ifdef DEBUG
				if (variavel[s].ptrval.ptrf >= MISSING) {
					D1print("ST\t. -> %s\n",
						variavel[s].nome);
				}
				else {
					D1print("ST\t%lg -> %s\n",
						variavel[s].ptrval.ptrf,
						variavel[s].nome);
				}
#endif
				break;
			}
		case 3:	/* OPER, PRT e LOGICA  */
#ifdef DEBUG
			D1print("OPER\t");
#endif
			/*
			** Chama a funcao que trata este tipo de funcao
			*/
			operacao();
			break;

		case 4:	/* FUNC, FUNCS e CNST  */
			/*
			** Chama a funcao que trata este tipo de funcao 
			*/
			operfun();
			break;

		case 5:	/* JMP  */
			/* 
			** Pega o parametro da funcao, atribuindo este
			** valor para pc, que indica o endereco para onde 
			** deve ser desviada a execucao do programa
			*/
			pc = OPER2;
#ifdef DEBUG
			D1print("JMP\t%d\n", pc);
#endif
			break;

		case 6:	/* JFDA, JF e JT  */
			{

			int k;   /* auxiliar para identificar o comando */


			k = SCOD;

			if (k == 1)   /*  e' JFDA */

			  {
			    if (pilha [idpilha -1] == (double) EOF )
			      pc = OPER1;

			  }
			else

			  {

			     /*
			     ** Verifica o resultado do teste da condicao 
			     ** e obtem o endereco para onde deve ser desviada a
			     ** execucao do programa
			     */
			     s = (int) (pilha[--idpilha] != 0.0);
			     i = CODIGO2 == 13;
			     if ((i && s) || ((!i) && (!s)))
				     pc = OPER2;
#ifdef DEBUG
			     D1print("J%c\t%d\n",(i) ? 'T' : 'F', pc);
#endif
			  }
			break;

			}

		case 7:	/* Funcoes especiais: SRD, SWR, FRD e FSPC */
#ifdef DEBUG
			D1print("ESPEC\t");
#endif
			/* 
			** Obtem o tipo de funcao especial, chamando a 
			** funcao para aua execucao
			*/
			s = SCOD; 
			especial(s); 
			break;

		default: /* Funcao inexistente - Erro  */
#ifdef DEBUG
			D1print("Erro de execucao -- Irrecuperavel\n");
#endif
			break;
		}
	}

	/*
	** Final da execucao do programa genese. Fecha todos os arquivos
	** existentes
	*/
	for (i=0; i < narqs; ++i) {
		if (arquivos[i].arqfile) { /* arq. externos */
			if ( strcmp(arquivos[i].nome, "con") ) {
				ret = fclose(arquivos[i].arq.ptraf);
			} else 
			    ret = 0;
		}
		else { /* arq. do sistema  */
			if ((arquivos[i].obs == 0L) && 
				(strcmp ( arquivos[i].nome, "nulo") != 0) 
					&& (arquivos[i].modo != ENTRADA) 
					&& (warnings) )
			  {
			      printf ("\n\tADVERTENCIA!!!\n");
			      printf ("\t\tO arquivo <%s> gerado esta' vazio\n", arquivos[i].nome);
			      Pausa_de_Advertencia ();
 			  }
		 	   ret = fech_arq(arquivos[i].arq.ptraa);
		}
		if (ret < 0){
			char buftmp[TAMSTR];
			sprintf(buftmp,PegaMsg(5005),arquivos[i].nome);
			execerror( buftmp,"");
		}
	}
}





