/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funo para verificar se o proximo caracter em uma cadeia  o 
	esperado,retornando se o caracter e' o esperado ou nao.

	int follow(expect, ifyes, ifno)	
	int	expect: valor esperado
	int	ifyes: valor a ser retornado caso seja o caracter desejado;
	int	ifno: valor a ser retornado caso no seja o caracter desejado;
	
	ex: 
		follow('=', GE, GT) ira retornar GE se o
		proximo caracter for '=' e GT caso contrario



 Desenvolvido por:

      Oscar Ivan Palma Pacheco


 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include "pcsgbd.h"


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para verificar se o proximo caracter em uma cadeia e' o 
** esperado
**
**
** Valor retornado:
**
**			Retorna se o caracter e' o esperado ou nao.
**			ex: 
**				follow('=', GE, GT) ira retornar GE se o
**				proximo caracter for '=' e GT caso contrario
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		94/10/17 12:50:52
**
** ----------------------------------------------------------------------------
*/


int follow(expect, ifyes, ifno)	/* look ahead for >=, etc. */
int	expect;
int	ifyes;
int	ifno;
{
	int c;
	
	c = xgetc(stdin);

	/*
	** Testa se c e' o caracter esperado e retorna yes ou no
	*/
	if (c == expect)
		return ifyes;
	unxgetc(c, stdin);
	return ifno;
}
