/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Funcoes diversas para manipulacao de strings

 Desenvolvido por:

      Oscar Ivan Palma Pacheco
      Carla Geovana do N. Macario
	Maria Fernanda Moura
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <ctype.h>

#ifndef VAXVMS
# include <malloc.h>
#endif

#include <string.h>

#ifdef	MEM_DEBUG
#include "mshell.h"
#endif

#include "pcsgbd.h"
#include "genese.h"


/* ----------------------------------------------------------------------------
**
**	
**
** Possui funcoes para manipulacao de strings
**
**
** Funcoes definidas:
**
**		void	repete(char *, int, char *);
**		char	*word_k(char *, int, char *);	 
**		void	trim(char *, char *);
**		void	substr(char *, char *, char *, char *);
**		void	supper(char *, char *);
**		void	slower(char *, char *);
**		int	scan(char *, char *);
**	
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
** Data da ultima alteracao:
**
**		96/12/05 11:27:16
**
** -------------------------------------------------------------------- */

/* -------------------------------------------------------------------- */
/* Repete: cria string com n caracteres 's' iguais			   	*/
/* -------------------------------------------------------------------- */
/* Entrada								    			*/
/*		s -> Caracter a ser expandido				           	*/
/*     	n -> numero de repeticoes				  	 	*/
/* -------------------------------------------------------------------- */
/*  retorna string							    		*/
/* -------------------------------------------------------------------- */

void repete(s, n, s1)
char *s;
int n;
char *s1;
{
/* Antes : 
**
	int   i;

	for(i=0; i < n; i++) {
		s1[i] = s[0];
	}
	s1[i] = '\0';
**
Correcao - Fernanda - 19/07/95 :
*/

    int i;

    strcpy(s1, s);
    for (i = 1; i < n; i++) {
	strcat(s1, s);
    }
}

/* ----------------------------------------------------------------------*/
/* Funcao: retorna palavra 'n' de uma string a partir de um conj. de     */
/*         separadores							 		 */
/* ----------------------------------------------------------------------*/
/* Parametros:										 */
/*	   char *y ---> Palavra de entrada						 */
/*	   int  k  ---> Posicao desejada 				 		 */
/*	   char *l_s--> Lista de separadores 					 */
/* ----------------------------------------------------------------------*/
/* Retorna:  a palavra selecionada					 		 */
/* ----------------------------------------------------------------------*/

char *word_k(y, k, l_s)
char *y;
int k;
char *l_s;
{
    char temp[256];
    char *s1;
    int i, j, l, m;
    unsigned ubytes;

    l = 1;
    m = 0;
    if (strlen(y) > 255) {
	char tmpbuf[128];	/* Adriana */

/* *** Padroniz. msg erro - Adriana 09/01/95
		execerror("String muito grande", "GETWORD");
*** */

	sprintf(tmpbuf, PegaMsg(1146), 255);
	execerror(tmpbuf, "");
    }
    for (i = 0; i < (int) strlen(y); ++i) {
	for (j = 0; j < (int) strlen(l_s); j++) {
	    if (y[i] == l_s[j]) {
		if (l == k) {
		    temp[m] = '\0';
		    ubytes = (unsigned) (strlen(temp) + 1);
		    if ((s1 = (char *) malloc(ubytes)) == (char *) NULL) {

/* *** Padroniz. msg erro - Adriana 09/01/95
						execerror("Falta memoria", "");
*** */

			execerror(PegaMsg(1039), "");
		    }
		    strcpy(s1, temp);
		    return (s1);
		}
		l++;
		m = 0;
		break;
	    }
	}
	if (j >= (int) strlen(l_s)) {
	    temp[m++] = y[i];
	    temp[m] = '\0';
	}
    }
    if ((s1 = (char *) malloc(1)) == (char *) NULL) {
	execerror(PegaMsg(1039), "");
    }
    *s1 = '\0';
    return (s1);
}


/* ----------------------------------------------------------------------*/
/* Funcao: Retira os brancos de uma string
/* ----------------------------------------------------------------------*/
/* Parametros:								 		 */
/*	   char *x ---> STRING						 		 */
/* ----------------------------------------------------------------------*/
/* Retorna:  STRING sem brancos
/* ----------------------------------------------------------------------*/

void trim(s, s1)
char *s;
char *s1;
{
    int i;
    int k;

    k = 0;
    for (i = 0; i < (int) strlen(s); i++) {
	if (s[i] != ' ')
	    s1[k++] = s[i];
    }
    s1[k] = '\0';
}

/* -----------------------------------------------------------------------*/
/* Funcao: Troca um determinado tipo de caracter por outro			  */
/* -----------------------------------------------------------------------*/
/* Parametros:								 		  */
/*	   char *x ---> STRING								  */
/*         char  c ---> Caracter a ser trocado					  */
/*	   char  c1---> Caracter substituto						  */
/*	   char *y ---> String Saida							  */
/* -----------------------------------------------------------------------*/
/* Retorna:  STRING trocada						 		  */
/* -----------------------------------------------------------------------*/

void substr(s, c, c1, s1)
char *s;
char *c;
char *c1;
char *s1;
{
    int i;

    strcpy(s1, s);
    for (i = 0; i < (int) strlen(s); i++) {
	if (s1[i] == c[0])
	    s1[i] = c1[0];
    }
}

/* -----------------------------------------------------------------------*/
/* Funcao: Coloca toda string em maiusculo					  */
/* -----------------------------------------------------------------------*/
/* Parametros:								 		  */
/*	   char *x ---> STRING						 	   	  */
/* -----------------------------------------------------------------------*/
/* Retorna:  STRING trocada
/* -----------------------------------------------------------------------*/

void supper(s, s1)
char *s;
char *s1;
{
    int i;

    for (i = 0; i < (int) strlen(s); i++) {
	s1[i] = (char) To_Upper(s[i]);
    }

    s1[i] = '\0';
}

/* -----------------------------------------------------------------------*/
/* Funcao: Coloca toda string em minusculo					  */
/* -----------------------------------------------------------------------*/
/* Parametros:								 	  	  */
/*	   char *x ---> STRING						 		  */
/* -----------------------------------------------------------------------*/
/* Retorna:  STRING trocada
/* -----------------------------------------------------------------------*/

void slower(s, s1)
char *s;
char *s1;
{
    int i;

    for (i = 0; i < (int) strlen(s); i++) {
	s1[i] = (char) To_Lower(s[i]);
    }

    s1[i] = '\0';
}


/* -----------------------------------------------------------------------*/
/* Funcao: compara se uma string contem uma sub-string			  */
/* -----------------------------------------------------------------------*/
/* Parametros:								 		  */
/*	   char *x ---> STRING								  */
/*	   char *y ---> SUB-STRING					 		  */
/* -----------------------------------------------------------------------*/
/* Retorna:  0 - Pertence	1 - Nao Pertence			  		  */
/* -----------------------------------------------------------------------*/

scan(x, y)
char *x;
char *y;
{
    int i, j, k;
    int tx, ty;

    if ((tx = strlen(x)) < (ty = strlen(y)))
	return 0;

    for (i = 0; i < tx; ++i) {
	if (x[i] == y[0]) {
	    k = 0;
	    for (j = i; j < (i + ty); j++) {
		if (x[j] != y[k])
		    break;
		k++;
	    }
	    if (j == (i + ty))
		return (i + 1);
	}
    }
    return 0;
}
