/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo lerumcampo para leitura de um campo da observacao  do 
	arquivo externo nao formatado

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	Maria Fernanda Moura
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>

#include "pcsgbd.h"
#include "genese.h"


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para ler um campo da observacao  do arquivo externo nao formatado
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/04/26 09:38:26
**
** ----------------------------------------------------------------------------
*/

int lerumcampo(s, n, f)
char	*s;
int	n;
FILE	*f;
{
	int 	c, c1;
	int 	j;
	char 	*p;
	int	truncou = 0;		/* Se truncou um campo (Fernanda) */
	static 	int 	nblk = 0;

	while (1) {
denovo:

		/* tira os brancos */
		while ((c = fgetc(f)) == ' ')
			++nblk;

		if (nblk == 1)
			break;

		ungetc(c, f);

		nblk = 0;

		/* ignora os caracteres especiais de formatacao  */
		while ((c = fgetc(f)) == '\n' || c == '\t'
			 || c == ';' || c == ',')
			;

		if (c == ' ') {
			nblk = 1;
			goto denovo;
		}

		if (c == EOF)
			break;

		c1 = fgetc(f);
		/* comentario  */
		if (c == '/' && c1 == '*') {
			c1 = c;
			c = fgetc(f);
			while (c1 != '*' || (c != '/' && c != EOF)) {
				c1 = c;
				c = fgetc(f);
			}
			if (c == EOF) {

/* *** Padroniz. msg erro - Adriana 06/01/95
				fprintf(stderr,
					"Falta fim de comentario nos dados.\n");
*** */

				fprintf(stderr, PegaMsg (1148) );
				termina(2);
			}
		}
		else {
			ungetc(c1, f);
			break;
		}
	}

	p = s;
	j = 0;

	/* pega o conteudo do campo  */
	while (c != ';' && c != '\n' && c != '\t' && c != EOF && c != ',') {
		if (c == '\\')
			c = fgetc(f);

		/* coloca o caracter no buffer do campo  */

		if ((++j) < n) {
			*p++ = (char) c;
		}
		else {
			truncou = 1;
		}

		if (c == ' ') {
			if (++nblk == 2)
				break;
		}
		else {
			nblk = 0;
		}
		c = fgetc(f);
	}

	/* tira os brancos do campo  */
	if (nblk == 2 && j <= n) {
		while ((c1 = fgetc(f)) == ' ')
			;
		ungetc(c1, f);
		nblk = 0;
		p -= 2;
	}

	if (*(p-1) == ' ')
		p -= 1;

	*p = '\0';

	if (truncou) {
		printf("\n\tADVERTENCIA!!!\n");
		printf("\t\tAtingido o tamanho maximo de um campo nao formatado.\n");
		printf("\t\tSeu conteudo foi truncado.\n\n");
		Pausa_de_Advertencia ();
	}

	return c;
}
