/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo listadevar para verificao do tipo da variavel, colocando esta informacao na 
	estrutura de variaveis

 Desenvolvido por:

      Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <string.h>
#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif
#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao que verifica o tipo da variavel, Colocando esta informacao na 
** estrutura de variaveis
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/01/09 09:34:03
**
** ----------------------------------------------------------------------------
*/

#ifdef DEBUG
extern	int	f_16;
#endif

extern struct arquivos arquivos[];   /* informacoes dos arqs. existentes  */

extern struct variavel variavel[];   /* informacoes das vars. existentes  */

extern	int	tarqs;		/* total de arqs. sem considerar os que vao
				   ser utilizados na concatenacao  */
extern	int	vetchave[];	/* vetor com os indices das chaves de conc. */
extern	int	yynch;
extern	int	nvar;		/* no. de vars. existentes  */
extern	int	pc;
extern	unsigned int	ins[];	/* veotr de instrucoes a serem executadas */
extern	int	pervar;		/* indica o tipo da variavel  */
extern	int	keepdrop[];	/* vetor com od indices das variaveis a serem
				   mantidas ou excluidas  */
extern	int	nkd;		/* no. de vars. a serem mantidas ou excluidas */
extern	int	narqs;		/* no. total de arquivos  */
extern	int	vars[];		/* vetor com os indices das variaveis  */
extern	int	indvar;		/* indice da var. de um arquivo  */

void listadevar(ind)
int	ind;
{
	char *pq;
#ifdef EDIX
	double *dp;
#endif

	int i,j,m,nv;

	/* verifica o tipo da variavel  */
	switch (pervar) {
	case 1:		/* var. numerica */
		variavel[ind].tipo = 'n';
#ifdef EDIX
		dp = &(variavel[ind].ptrval.ptrf);
		*dp = MISSING;
#else
		variavel[ind].ptrval.ptrf = MISSING;
#endif
		break;
	case 2:		/* var. string */
		variavel[ind].tipo = 'c';
		if ((pq = malloc(1)) == NULL)

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Falta memoria", "");
*** */

			execerror( PegaMsg (1039), "");
		*pq = '\0';
		variavel[ind].ptrval.ptrs = pq;
		break;
	case 4:		/* var. data  */
		variavel[ind].tipo = 'd';
#ifdef EDIX
		dp = &(variavel[ind].ptrval.ptrf);
		*dp = MISSING;
#else
		variavel[ind].ptrval.ptrf = MISSING;
#endif
		break;
	case 5:		/* vars. a serem mantidas ou excluidas  */
		if (nkd >= MAXVAR - 1)
		  {
		  	char	tmpbuf [128]; /* Adriana */

/* *** Padroniz. msg erro - Adriana 09/01/95
			execerror("Estourado o numero maximo de variaveis nos comando KEEP ou DROP", "");
*** */

			sprintf (tmpbuf, PegaMsg (3173), (MAXVAR -1) );
			execerror( tmpbuf, "");
		  }
		/* coloca o indice da var. no vetor de vars. a serem mantidas ou
		   excluidas  */
		keepdrop[nkd++] = ind;
		break;
	case 6:
	case 7:		/* arq. externo  */
		vars[indvar++] = ind;
		break;
	case 8:		/* var. chave de concatenacao  */
		for ( i=tarqs ; i < narqs ; i++) {
			nv = arquivos[i].nvar;
			for ( j=0 ; j < nv ; j++) {
				m = arquivos[i].pos[j];
				if ( m == ind )	break;
			}
			if ( j >= nv )

/* *** Padroniz. msg erro - Adriana 09/01/95
				execerror("Variavel da chave nao existe em todos os arquivos","");
*** */

				execerror( PegaMsg (3174),"");
		}
		/*  coloca o indice da var. no vetor de indices das chaves  */
		vetchave[yynch++] = ind;
		break;
	}
}
