/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo operacao para tratamento das operacoes do genese, executando-as
 

 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	Maria Fernanda Moura
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "pcsgbd.h"
#include "socasm.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/* ----------------------------------------------------------------------------
**
**	
**
** Funcao que trata as operacoes do genese, executando-as
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/07/28 16:49:56
**
** ----------------------------------------------------------------------------
*/


#ifdef DEBUG
extern int	f_1;
#endif

extern struct variavel variavel[];   /* informacoes das vars. existentes  */

extern struct arquivos arquivos[];   /* informacoes dos arqs. existentes  */

extern double pilha[];		/* pilha de dados  */
extern int idpilha;		/* indice da pilha de dados  */
extern char *spilha[];		/* pilha de strings  */
extern int idspilha;		/* indice da pilha de strings  */

extern	int	pc;		/* contador do programa  */
extern	unsigned int	ins[];	/* vetor de instrucoes a serem executadas  */
extern unsigned int inst;	/* instrucao a ser executada  */

extern	double	op1, op2, op3;
extern	char	*ops1, *ops2, *ops3;
extern	char	buffer[];	/* armazena o conteudo de cada campo lido  */
extern	int	lprind;		/* indica a coluna para a impressao  */
extern	char	printbuf[];	/*  buffer para armazenar a formatacao do arq.
			            ou a observacao lida no arq. externo */
extern	int	maxlprind;
extern	int	campo;		/* tamanho do campo  */
extern	int	decim;		/* no. de casas decimais */
extern	int	esque;		/* campo alinhado a esquerda na impressao */
extern	FILE	*prtffile;	/* apontador para arq. externo  */
extern	int	flagP;
extern	int	primP;

void operacao()
{
    int s;
    int num;
    int i;
    char *ptr;
    char buff[15];

    /* 
    ** Pega os 3o. e 4o. bits para definir o tipo de operacao 
    */ 
    switch(SCOD) {

    case 0:		/* operacao matematica  */
	opermat();

	break;

    case 2: /* PRT */	/* impressao  */

	/* Pega o parametro  */	

	num = OPER1 >> 3;

	s = OPER1 & 07;

	if (flagP && primP && (s != 0 || num != 6) &&
				(prtffile == stdout)) {
	    printf("\f\n\n");
	    primP = 0;
	}

	switch (s) {

	    case PPAR:	/* Diretivas sem parametros. */

		num = num << 3;

		switch (num) {

		    case PNUM: /* Imprimir numerico */

			if (campo) {
			    if (pilha[--idpilha] == MISSING) {  
				if (decim)
				    sprintf(buffer, "%*s%*s", campo-decim,
						    ".", decim, " ");
				else
				    sprintf(buffer, "%*s", campo, ".");
			    }

			    else { 	/* campo alinhado a esquerda  */
				if (esque) {
/* ROUNDEC  - FERNANDA
#ifdef MSDOS
				   sprintf(buffer,"%-*.*lf",
#else
				   sprintf(buffer,"%-*.*f",
#endif
					    campo, decim, pilha[idpilha]);
*/
/* Retirada a alteracao para testar o que vai pra rounddec
				    if (campo >= 16 ) {
					char	onde[126];
					sprintf(buffer,"%-*s",campo,gcvt(pilha[idpilha],15,onde));
				    }
				    else {
*/
				    sprintf(buffer,"%-*s",campo,
					rounddec(pilha[idpilha],campo,decim));
/* 
				    }
*/
				}
				else {
/* ROUNDEC  - FERNANDA
#ifdef MSDOS
				    sprintf(buffer,"%*.*lf",
#else
				    sprintf(buffer,"%*.*f",
#endif
					    campo, decim, pilha[idpilha]);
*/
/*
				    char	*p;
*/

				    sprintf(buffer,"%*s",campo,
					    rounddec(pilha[idpilha],campo,decim));
/*
				    for(p=buffer; *p == ' '; p++);
				    if (strlen(p) >= 17) {
					char	onde[126];
					sprintf(buffer,"%*s",campo,gcvt(pilha[idpilha],15,onde));
				    }
*/
				}
			    }

			    /*
			    ** valor do campo maior que o tamanho
			    ** definido
			    */

			    if ((int) strlen(buffer) > campo) {
				for (i=0; i < campo; ++i)
				    buffer[i] = '*';

				buffer[i] = '\0';
			    }
			}

			else { /* transforma o valor obtido em numero */

			    if (pilha[--idpilha] == MISSING)
				strcpy(buffer, ".");
			    else
				ftoa(pilha[idpilha], 15,buffer);
			}

			i = 0;

			/*
			** Coloca o campo da observacao no formato da
			** impressao.
			*/

			while (buffer[i])
			    printbuf[lprind++] = buffer[i++];
#ifdef DEBUG
#ifdef MSDOS
			    D1print("PRINT\t%lf\n", pilha[idpilha]);
#else
			    D1print("PRINT\t%f\n", pilha[idpilha]);
#endif
#endif
			campo = 0;
			decim = 0;
			esque = 0;

			break;

		    case PALF: /* Imprimir alfanumerico */

			--idspilha;
			if (campo) {	/* tamanho do campo definido  */

			    if (esque) /* campo alinh. a esquerda */
				sprintf(buffer, "%-*s", campo, spilha[idspilha]);
			    else
				sprintf(buffer, "%*s", campo, spilha[idspilha]);

			    /*
			    ** Valor do campo maior que o tamanho
			    ** definido
			    */

			    if ((int) strlen(buffer) > campo) {
				for (i=0; i < campo; ++i)
					buffer[i] = '*';
				buffer[i] = '\0';
			    }

			    ptr = buffer;
			}

			else /* Nao tem tamanho definido. Pega valor */

			    ptr = spilha[idspilha];
#ifdef DEBUG
			    D1print("PRINT\t%s\n", spilha[idspilha]);
#endif
			/*
			** Coloca o campo da observacao no formato
			** da impressao
			*/

			while (*ptr) {
			    printbuf[lprind++] = *ptr;
			    ++ptr;
			}

			free(spilha[idspilha]);
			spilha[idspilha] = (char *) NULL;

			campo = 0;
			decim = 0;
			esque = 0;

			break;

		    case PNL: /* Gerar nova linha */

			printbuf[lprind++] = '\n';
#ifdef DEBUG
			D1print("PRINT\tNL\n");
#endif
			break;

		    case PTAB: /* Gerar tab */

			/* Calcula quantas posicoes faltam para chegar 
			   no proximo tab e soma este no. 'a lprind  */

			num =  8 - lprind % 8;

			for (i = 0; i < num; ++i)

			    printbuf[lprind++] = ' ';
#ifdef DEBUG
			    D1print("PRINT\ttab\n");
#endif
			break;

		    case PLIN: /* Imprimir a linha preparada */
#ifdef DEBUG
			D1print("PRINT\tlinha\n");
#endif
			printbuf[maxlprind] = '\0';
			fprintf(prtffile, "%s", printbuf);
			fflush(prtffile);
			lprind = maxlprind = 0;
			break;

		    case PESQ: /* Alinhamento a esquerda */
#ifdef DEBUG
			D1print("PRINT\talinhamento esquerda\n");
#endif
			esque = 1;
			break;

		    case PFF: /* Gerar FF - pular pagina ou tela */

			printbuf[lprind++] = '\f';
#ifdef DEBUG
			D1print("PRINT\tFF\n");
#endif
			if (prtffile == stdout)
			    primP = 0;
			break;

		    case PDAT: /* Imprimir data */

			if (campo) {
			    if (pilha[--idpilha] == MISSING) {
				sprintf(buffer, "%*s", campo,
							".");
			    }

			    else {
				if (esque)
				    sprintf(buffer,"%-*s", campo,
						dtoa(pilha[idpilha], buff));
				else
				    sprintf(buffer,"%*s", campo, 
						dtoa(pilha[idpilha], buff));
			    }

			    if ((int) strlen(buffer) > campo) {
				for (i=0; i < campo; ++i)
				    buffer[i] = '*';
				buffer[i] = '\0';
			    }
			}

			else {
			    if (pilha[--idpilha] == MISSING)
				strcpy(buffer, ".");
			    else
				dtoa(pilha[idpilha], buffer);
			}

			i = 0;

			/*
			** Coloca o campo da observacao no formato
			** da impressao
			*/

			while (buffer[i])
			    printbuf[lprind++] = buffer[i++];
#ifdef DEBUG
#ifdef MSDOS
			    D1print("PRINT\t%lf\n", pilha[idpilha]);
#else
			    D1print("PRINT\t%f\n", pilha[idpilha]);
#endif
#endif
			campo = 0;
			decim = 0;
			esque = 0;
			break;
		    }
		    break;

		case PBRC: /* Gerar brancos */

		    for (i = 0; i < num; ++i)
			printbuf[lprind++] = ' ';
#ifdef DEBUG
		    D1print("PRINT\t%d brancos\n", num);
#endif
		    break;

		case PCOL: /* Posicionar na coluna especificada */

		    lprind = num - 1;
		    if (lprind > maxlprind)
			for (i = maxlprind; i < lprind; ++i)
					printbuf[i] = ' ';
#ifdef DEBUG
		    D1print("PRINT\tcoluna %d\n", num);
#endif
		    break;

		case PTAM: /* Tamanho do campo */

#ifdef DEBUG
		    D1print("PRINT\tcampo %d\n", num);
#endif
		    campo = num;
		    break;

		case PDEC: /* Decimais */

#ifdef DEBUG
		    D1print("PRINT\tdecimais %d\n", num);
#endif
		    decim = num;
		    break;

		case PUNI: /* Unidade de saida arquivo externo */

		    if (num == 100) {
#ifdef DEBUG
			D1print("PRINT\tunidade padrao\n");
#endif
			prtffile = stdout;
		    }
		    else {
#ifdef DEBUG
			D1print("PRINT\tunidade %s\n", arquivos[num].nome);
#endif
			prtffile = arquivos[num].arq.ptraf;
		    }
		    break;
	    }
	    if (lprind > maxlprind)
		maxlprind = lprind;
	    break;

	case 3:		/* operacoes logicas  */

	    operlog();
	    break;
    }
}
