/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo opermat para a execuo de funcoes matematicas

 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para executar funcoes matematicas
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		94/10/17 12:51:27
**
** ----------------------------------------------------------------------------
*/


#ifdef DEBUG
extern int	f_1;
#endif

extern	double	pilha[30];	/* pilha de dados  */
extern	int	idpilha;	/* indice da pilha de dados  */
extern unsigned int inst;	/* instrucao a ser executada  */

extern	double	op1, op2, op3;
extern	char	*ops1, *ops2, *ops3;

void opermat()
{
	int i;

	/* pega os parametros da funcao  */
	i = OPER1;
	/* pega o operador 2 na pulha  */
	op2 = pilha[--idpilha];
		
	/* 
	** Operacao de incremento, decremento ou meno unario. Coloca
	** o resultado na pilha  
	*/
	switch (i) {
		case OINC:	/* incrementar  */
#ifdef DEBUG
			D1print("GE\n");
#endif
			if (vmissing((double) 0.0, op2))
				pilha[idpilha++] = op2 + 1.0;
			break;
		case ODEC:	/* decrementar  */
#ifdef DEBUG
			D1print("GE\n");
#endif
			if (vmissing((double) 0.0, op2))
				pilha[idpilha++] = op2 - 1.0;
			break;
		case OMINUS:	/* menos unario  */
#ifdef DEBUG
			D1print("MINUS\n");
#endif
			if (vmissing((double) 0.0, op2))
				pilha[idpilha++] = -op2;
			break;
	}

	/* 
	** Outras operacoes. Pega o outro operador (1), executa a funcao e 
	** coloca o resultado na pilha 
	*/
	if (i != OINC && i != ODEC && i != OMINUS) {
		op1 = pilha[--idpilha];
		switch (i) {
			case OADD:	/* soma  */
#ifdef DEBUG
				D1print("ADD\n");
#endif
				if (vmissing(op1, op2))
					pilha[idpilha++] = op1 + op2;
				break;
				
			case OSUB:	/* subtracao  */
#ifdef DEBUG
				D1print("SUB\n");
#endif
				if (vmissing(op1, op2))
					pilha[idpilha++] = op1 - op2;
				break;

			case ODIV:	/* divisao  */
#ifdef DEBUG
				D1print("DIV\n");
#endif
				if (vmissing(op1, op2))
					if (op2 != 0.0)
						pilha[idpilha++] = op1 / op2;
					else
						pilha[idpilha++] = MISSING;
				break;
					
			case OMUL:	/* multiplicacao  */
#ifdef DEBUG
				D1print("MUL\n");
#endif
				if (vmissing(op1, op2))
					pilha[idpilha++] = op1 * op2;
				break;

			case OPOW:	/* potenciacao  */
#ifdef DEBUG
				D1print("POW\n");
#endif
				if (op2 == 0.)
					pilha[idpilha++] = 1.0;
				else
					if (vmissing(op1, op2))
						pilha[idpilha++] = pow(op1,op2);
				break;

			case OMOD:	/* divisao inteira  */
#ifdef DEBUG
				D1print("MOD\n");
#endif
				if (vmissing(op1, op2)) {
					pilha[idpilha++] = fmod(op1, op2);
				}
				break;
		}
	}
}
