/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Define a estrutura da pilha de dados e os operadores usados por ela

 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

/*
// ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
// PILHA.H		1.2			92/03/26 13:17:41
// ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
//
// Funcao:
//	Declara a estrutura e os operadores usados pelo 
//	tipo T_Pilha 
//
// Obs:
//	O tipo pilha implementado aqui foi baseado na
//	pilha definida em "Aho, A.V. & Hopcroft, J.E & Ullman, J.D.
//	Data Structures and Algorithms, Addison-Wesley, 1983"
//
//
// Sintaxe:
//
//	#include	"pilha.h"
//	
//	T_Pilha 	Pil_Create();
//	T_Pilha 	Pil_Destroy(T_Pilha);
//	T_Pilha		P_Push(T_Pilha, char);
//	T_Pilha		P_Pop(T_Pilha);
//	T_Pilha		P_MakeNull(T_Pilha);
//	char		P_Top(T_Pilha);
//	Tam		P_Depth(T_Pilha);
//	Bool		P_Empty(T_Pilha);
//	int		Pil_Print(T_Pilha, int);
//
// Autor:
//	Macario, C.G.
//
// Historico:
//	12-9-88		Primeira Versao		C.G.Macario
// ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
*/


#define	__PILHA	("PILHA")

struct	_T_Pilha	{
	int	Depth;
	int	Tamanho;
	char	Item[1024];
};

typedef	struct _T_Pilha	*T_Pilha;

/*
// 	Operadores que alteram o Estado do Tipo (O_Functions)
*/
#ifdef	MSDOS
extern	T_Pilha 	Pil_Create(int);
extern	T_Pilha 	Pil_Destroy(T_Pilha);
extern	T_Pilha		P_Push(T_Pilha, char );
extern	T_Pilha		P_Pop(T_Pilha);
extern	T_Pilha		P_MakeNull(T_Pilha);
extern	char 		P_Top(T_Pilha);
#else
extern	T_Pilha	Pil_Create();
extern	T_Pilha	Pil_Destroy();
extern	T_Pilha	P_Push();
extern	T_Pilha	P_Pop();
extern	T_Pilha	P_MakeNull();
#endif

/*
// 	Operadores que verificam o estado do Tipo (V_Functions)
*/

#ifdef	MSDOS
extern	int	P_Depth(T_Pilha);
extern	int	P_Empty(T_Pilha);
#else
extern	char	P_Top();
extern	int	P_Depth();
extern	int	P_Empty();
#endif

/*
//	Operador que armazena o estado do Tipo
*/

#ifdef	MSDOS
extern	int	Pil_Print(T_Pilha, int);
#else
extern	int	Pil_Print();
#endif

/*
//	Final de pilha.h
*/
