/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a definio da linguagem genese

 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	Carla Geovana do N. Macario
	Maria Fernanda Moura
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

/* ----------------------------------------------------------------------------
**
** 
**
** Data da ultima alteracao:
**
**		95/08/14 10:51:33
**
** ----------------------------------------------------------------------------
*/

/* Comandos basicos.							*/

#if defined(MSDOS) & !defined(DJGPP)
#define	PARE	0x0000		/* fim de execucao			*/
#define	LDV	0x2000		/* load variavel numerica		*/
#define	LDI	0x2800		/* load constante numerica		*/
#define LDS	0x3800		/* load string				*/
#define STV	0x4000		/* store varivel			*/
#define STS	0x5800		/* store string				*/
#define OPER	0x6000		/* operacao matematica			*/
#define	PRT	0x7000		/* imprime uma expressao		*/
#define LOGICA	0x7800		/* operacao logica			*/
#define FUNC	0x8000		/* funcao				*/
#define FUNCS	0x8800		/* funcao string			*/
#define	CNST	0x9000		/* constantes internas			*/
#define JMP	0xa000		/* jump incondicional			*/
#define JF	0xc000		/* jump se falso			*/
#define JFDA	0xc800		/* jump se fim de arquivo		*/
#define JT	0xd000		/* jump se verdadeira			*/
#define SRD	0xe000		/* ler arquivo do pacote		*/
#define SWR	0xe800		/* gravar arquivo do pacote		*/
#define FRD	0xf000		/* ler arquivo externo			*/
#define FSPC	0xf800		/* Funcao especial			*/
#else
#ifdef EDIX
#define	PARE	0x0000		/* fim de execucao			*/
#define	LDV	0x2000		/* load variavel numerica		*/
#define	LDI	0x2800		/* load constante numerica		*/
#define LDS	0x3800		/* load string				*/
#define STV	0x4000		/* store varivel			*/
#define STS	0x5800		/* store string				*/
#define OPER	0x6000		/* operacao matematica			*/
#define	PRT	0x7000		/* imprime uma expressao		*/
#define LOGICA	0x7800		/* operacao logica			*/
#define FUNC	0x8000		/* funcao				*/
#define FUNCS	0x8800		/* funcao string			*/
#define	CNST	0x9000		/* constantes internas			*/
#define JMP	0xa000		/* jump incondicional			*/
#define JF	0xc000		/* jump se falso			*/
#define JFDA	0xc800		/* jump se fim de arquivo		*/
#define JT	0xd000		/* jump se verdadeira			*/
#define SRD	0xe000		/* ler arquivo do pacote		*/
#define SWR	0xe800		/* gravar arquivo do pacote		*/
#define FRD	0xf000		/* ler arquivo externo			*/
#define FSPC	0xf800		/* Funcao especial			*/
#else
#define	PARE	0x00000000	/* fim de execucao			*/
#define	LDV	0x20000000	/* load variavel numerica		*/
#define	LDI	0x28000000	/* load constante numerica		*/
#define LDS	0x38000000	/* load string				*/
#define STV	0x40000000	/* store varivel			*/
#define STS	0x58000000	/* store string				*/
#define OPER	0x60000000	/* operacao matematica			*/
#define	PRT	0x70000000	/* imprime uma expressao		*/
#define LOGICA	0x78000000	/* operacao logica			*/
#define FUNC	0x80000000	/* funcao				*/
#define FUNCS	0x88000000	/* funcao string			*/
#define	CNST	0x90000000	/* constantes internas			*/
#define JMP	0xa0000000	/* jump incondicional			*/
#define JF	0xc0000000	/* jump se falso			*/
#define JFDA	0xc8000000	/* jump se fim de arquivo		*/
#define JT	0xd0000000	/* jump se verdadeira			*/
#define SRD	0xe0000000	/* ler arquivo do pacote		*/
#define SWR	0xe8000000	/* gravar arquivo do pacote		*/
#define FRD	0xf0000000	/* ler arquivo externo			*/
#define FSPC	0xf8000000	/* Funcao especial			*/
#endif
#endif

/* codigos para ser || com PRT						*/

#define PPAR	0x0000		/* Tem subcodigo			*/
#define PBRC	0x0001		/* Imprimir brancos			*/
#define PCOL	0x0002		/* Posicionar coluna			*/
#define PTAM	0x0003		/* Tamanho de campo			*/
#define PDEC	0x0004		/* Numero de decimais			*/
#define PUNI	0x0005		/* Unidade de saida			*/

#define PNUM	0x0000		/* Imprimir numerico			*/
#define PALF	0x0008		/* Imprimir alfanumerico		*/
#define PNL	0x0010		/* Mudar de linha			*/
#define PTAB	0x0018		/* Imprimir tab				*/
#define PLIN	0x0020		/* Imprimir linha			*/
#define PESQ	0x0028		/* Alinhamento aa esquerda		*/
#define PFF	0x0030		/* Mudar de pagina			*/
#define PDAT	0x0038		/* Imprimir data			*/


/* codigos para ser || com OPER						*/

#define	OADD	0x0001		/* soma					*/
#define OSUB	0x0002		/* subtracao				*/
#define ODIV	0x0004		/* divisao				*/
#define OMUL	0x0008		/* multiplicacao			*/
#define OPOW	0x0010		/* elevado a				*/
#define	OMINUS	0x0018		/* menos unario				*/
#define OMOD	0x0020		/* modulo (resto da divisao)		*/
#define ODEC	0x0040		/* decrementa de um			*/
#define OINC	0x0080		/* incrementa de um			*/


/* codigos para ser || com LOGICA 					*/

#define OAND	0x0001		/* e					*/
#define OOR	0x0002		/* ou					*/
#define ONOT	0x0004		/* nao					*/
#define OXOR	0x0008		/* ou exclusivo				*/
#define ONEQ	0x0020		/* diferente				*/
#define OEQ	0x0030		/* igual				*/
#define OLT	0x0050		/* menor que				*/
#define OLE	0x0070		/* menor ou iqual			*/
#define OGT	0x00c0		/* maior que				*/
#define OGE	0x00e0		/* maior				*/


/* codigos para funcoes matematicas					*/

#define OEXP	0x0001		/* exponencial				*/
#define OLOG	0x0002		/* logaritmo natural			*/
#define OLOG10	0x0003		/* logaritmo na base 10			*/
#define OABS	0x0004		/* valor absoluto			*/
#define OSQRT	0x0005		/* raiz quadrada			*/
#define OINT	0x0006		/* elimina decimais			*/
#define OCEIL	0x0007		/* menor inteiro >= que o numero	*/
#define OFLOOR	0x0008		/* maior inteiro <= que o numero	*/
#define OMAX    0x0009          /* Maximo entre dois numeros            */
#define OMIN    0x000a          /* Minimo entre dois numeros            */
#define ORAND	0x000b		/* gerador de numeros aleatorios	*/
#define OSRAND	0x000c		/* semente para o gerador ORAND		*/

/* codigos para funcoes trigonometricas					*/

#define OSIN	0x0021		/* seno					*/
#define OCOS	0x0022		/* cosseno				*/
#define OTAN	0x0023		/* tangente				*/
#define OASIN	0x0024		/* arco-seno				*/
#define OACOS	0x0025		/* arco-cosseno				*/
#define OATAN	0x0026		/* arco-tangente			*/

/* codigos para funcoes de tempo e data					*/

#define	ODATE	0x0041		/* data no formato aaaammdd (numerico)	*/
#define OTIME	0x0042		/* hora no formato hhmmss (numerico)	*/
#define ONDAY   0x0043		/* Numero de dias a a partir 0/0/00     */
#define	ODIA	0x0044		/* Extrai dia de uma data		*/
#define	OMES	0x0045		/* Extrai mes de uma data		*/
#define	OANO	0x0046		/* Extrai ano de uma data		*/

/* codigos para funcoes de tamanho e posicao de string e arquivo	*/

#define OSTRLEN	0x0061		/* tamanho do string			*/
#define	OSCAN	0x0062		/* retorna posicao de um sub-string	*/
#define OEXTARQ	0x0063		/* verifica a existencia de um arquivo	*/

/* codigos para funcoes estatisticas					*/

#define OFPROB  0x0081		/* Probabalidade F			*/
#define OFINV   0x0082		/* Inv Probabalidade F			*/
#define ONPROB  0x0083		/* Probabalidade N			*/
#define ONINV   0x0084		/* Inv Probabalidade N			*/
#define OTPROB  0x0085		/* Probabalidade T			*/
#define OTINV   0x0086		/* Inv Probabalidade T			*/
#define OXPROB  0x0087		/* Probabalidade X			*/
#define OXINV   0x0088		/* Inv Probabalidade X			*/

/* codigos para funcoes de conversao					*/

#define OFTOD	0x00a1		/* converte numerico para data		*/
#define ODTOF	0x00a2		/* converte data para numerico		*/
#define ODTOA	0x00a3		/* converte data para string		*/
#define OFTOA	0x00a4		/* converte numerico para string	*/
#define OMNT	0x00a5		/* converte numerico para string	*/

/* **************** Fim definicao de funcoes numericas **************** */
/************************************************************************/


/* codigo de constantes internas					*/

#define	OEOF	0x0000		/* representa fim de arquivo		*/
#define	OPI	0x0001		/* representa constante pi		*/
#define	OE	0x0002		/* representa a constante e		*/
#define	OEULER	0x0003		/* representa a constante de euler	*/

/* *************** Fim definicao de constantes internas *************** */
/************************************************************************/


/* codigos para funcoes de string					*/

#define OSTRCAT	0x0002		/* concatena string			*/
#define OSTRMID	0x0003		/* funcao mid$ do basic			*/
#define	OADATE	0x0004		/* data "dia, dia de mes de ano"	*/
#define OATIME	0x0005		/* hora no formato xx h xx m xx s	*/
#define	OASTRRP	0x0006		/* repete n vezes um caracter		*/
#define	OAWRDK	0x0007		/* retorna a n-esima palavara entre sep.*/
#define	OATRIM	0x0008		/* retira brancos de um string		*/
#define	OASSTR	0x0009		/* substitui caracteres			*/
#define OAUPPER	0x000a		/* passa tudo para maiuscula		*/
#define OALOWER	0x000b		/* passa tudo para minuscula		*/
#define OAESQ	0x000c		/* posiciona a string `a esquerda	*/
#define OADIR	0x00fc		/* posiciona a string `a direita	*/
#define OACENT	0x000d		/* centraliza a string			*/
#define OAJUST	0x00fd		/* centraliza a string			*/
#define OATOD	0x00fe		/* converte string para data		*/
#define OATOF	0x00ff		/* converte string para float		*/

/* ***************** Fim definicao de funcoes string ****************** */
/************************************************************************/


/*
** Codigos para funcoes especiais do sistema.
** Para ser || com FSPC.
*/

#define VFA	0x0001
#define RWND	0x0002
#define PSE	0x0003
#define POP	0x0004

/* **************** Fim definicao de funcoes especiais **************** */
/************************************************************************/



