/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo ssopen para abertura de arquivo do sistema (arquivo genese)

 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	Carla Geovana do N. Macario
	Maria Fernanda Moura
	Adriana Delfino dos Santos
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include <string.h>
#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif
#include "socasm.h"
#include "pcsgbd.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/* ----------------------------------------------------------------------------
**
**	
**
** Funcao para abrir arquivo do sistema
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/07/28 16:50:22
**
** ----------------------------------------------------------------------------
*/


extern struct arquivos arquivos[];  /* informacoes dos arqs. existentes */

extern struct variavel variavel[];  /* informacoes das vars. existentes */

extern	int	nvarc;		/* no. de vars. corrente  */
extern	int	nvar;		/* no. de vars. */
extern	int	narqs;		/* no. de arquivos  */
extern	char	anome[];
extern	char	atipo;
extern	int	varveris;	/* indice da variavel na tabela de vars. */
extern	int	vars[];		/* vetor com indice das vars.  */


extern 	char	*obs[OBSSIZE];
extern	int	warnings;

void ssopen(modo)
int modo;
{
	int	 numvrs;
	int	 i;
	int	 ind;
	long	 ret;
	MINVAL	 mmin;
	MAXVAL	 mmax;
	ARQ	*parq;
	char	*pq;
	char	*parea;
	char	 buf[TAMSTR];
	char	buffer[TAMSTR+128];
	int	*pv;
	unsigned ubytes;
#ifdef EDIX
	double	*dp;
#endif

	if (modo == ENTRADA ) {
		strcpy(buf, pega_env(arquivos[narqs].nome, ".hdr"));

		if ((ler_obs(arquivos[narqs].arq.ptraa,obs) == EOF) && (warnings) ) {
		    printf("\n\tADVERTENCIA !!! \n");
		    printf("\t\tArquivo <%s> de Entrada Vazio\n\n",arquivos[narqs].nome);
		    Pausa_de_Advertencia();
		}
		rew_arq(arquivos[narqs].arq.ptraa);
	}
	else {
		arquivos[narqs].arq.ptraa = 
					cria_arq(arquivos[narqs].nome);

		if ((ret = (long) (arquivos[narqs].arq.ptraa)) 
					< 0L && ret > -5L)
		{
			char	tmpbuf [128]; /* Adriana */

			sprintf (tmpbuf, PegaMsg (1008), 
							arquivos[narqs].nome);
			execerror( tmpbuf, "");
		}
	}

	/* inicializa as informacoes do arquivo na tabela  */

	numvrs = 0;
	parq = arquivos[narqs].arq.ptraa;
	arquivos[narqs].arqfile = 0;
	arquivos[narqs].obs = 0L;
	arquivos[narqs].modo = modo;

	if (modo == ENTRADA) {
		/* pega a definicao das variaveis  */
		while (pega_var(parq, numvrs, anome, &atipo, &mmin, &mmax)==0) {
			/* 
			** verifica se a variavel existe  
			*/
			if ((i = verivar(anome)) == 0) { /* var. nao existe */
				if (nvarc >= MAXGENVAR - 1)
				  {
					char	 tmpbuf [128]; /* Adriana */

					sprintf (tmpbuf, PegaMsg (3175), (MAXGENVAR - 1) );
					execerror( tmpbuf, "");
				  }
				ind = nvarc++;
				/* aloca area para o nome da var.  */
				ubytes = (unsigned) (strlen(anome) + 1);
				if ((parea = malloc(ubytes)) == NULL)
					execerror( PegaMsg (1039),"");
				variavel[ind].nome = parea;
				strcpy(parea, anome);
				variavel[ind].tipo = atipo;

				if (atipo == 'c') {
					if ((pq = malloc(1)) == NULL)
						execerror( PegaMsg (1039), "");
					*pq = '\0';
					variavel[ind].ptrval.ptrs = pq;
				}
				else {
#ifdef EDIX
					dp = &(variavel[ind].ptrval.ptrf);
					*dp = MISSING;
#else
					variavel[ind].ptrval.ptrf = MISSING;
#endif
				}
			}
			else {	/* var. ja' existe  */
				ind = varveris;
				if (variavel[ind].tipo != atipo)

					execerror( PegaMsg (1147), "");
			}
			/* coloca o indice da var. no vetor de indices  */
			vars[numvrs++] = ind;
		}

		/* aloca area para os indices das vars.  */
		ubytes = (unsigned) (numvrs * sizeof(int));
		if ((pv = (int *) malloc(ubytes)) == (int *) NULL)

			execerror( PegaMsg (1039), "");
		for (i = 0; i < numvrs; ++i)
			pv[i] = vars[i];

		/* coloca as informacoes das vars. na tabela de arqs. */
		arquivos[narqs].pos = pv;
		arquivos[narqs].nvar = numvrs;
	}
}

