/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo termina com acoes a serem executas no final da execucao de um programa genese

 Desenvolvido por:

	Carlos Eduardo Assis Paniago
	Oscar Ivan Palma Pacheco
	Carla Geovana do N. Macario
	Maria Fernanda Moura
	Adriana Delfino dos Santos
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "pcsgbd.h"
#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif


/* ----------------------------------------------------------------------------
**
**	
**
** Funcao com acoes de fim de execucao do genese
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		95/08/17 08:27:54
**
** ----------------------------------------------------------------------------
*/


extern struct arquivos arquivos[];   /* informacoes dos arqs. existentes */
extern struct variavel variavel[];   /* informacoes das vars. existentes */

extern int 	narqs;		/* no. total de arqs. */
extern int 	nvarc;		/* no. total de vars. */
extern int 	nform;		/* no. total de formatacoes. */
extern char 	*formatos[];	/* vetor que contem as formatacoes */



void	libera_area();

void termina(n)
int n;
{
	int i;

	for (i = 0; i < narqs; ++i)
		if (arquivos[i].modo == SAIDA)
			if (strcmpi(arquivos[0].nome, "nulo") == 0) {
				unlink("nulo.dat");
				unlink("nulo.hdr");
				break;
			}

	setOSstdin();
	libera_area();



/*
#if (defined(IRIX) | defined(SUN)) & !defined(RS6000)
	VerifysEndServer("genese");
#endif
*/
#ifdef MEM_DEBUG

         if (Mem_Used() != 0) {

                printf("*** Lista de memoria nao esta' vazia ***\n");

                Mem_Store("genese");

                exit(n);

         }

#endif


	exit(n);
}

void termina_ctrl_c(n)
int n;
{
extern int flagA;

	if (flagA == 0)
	  printf ("\n\n*******  Interrompido pelo usuario. \n\n");

	termina(1);
	
}



void termina_segfault(n)
int n;
{
	char	msg[TAMSTR];

	sprintf(msg,PegaMsg(5064),"GENESE");
	fprintf (stderr,msg);

	termina(1);
	
}


void termina_buserror(n)
int n;
{
	char	msg[TAMSTR];

	sprintf(msg,PegaMsg(5065),"GENESE");
	fprintf (stderr,msg);

	termina(1);
	
}


void	libera_area()
{
	int	i;

	for (i = 0; i < nvarc ; ++i ) {
		if ( variavel[i].nome ) {
			free(variavel[i].nome);
			variavel[i].nome = (char *) NULL;
		}
		if ( variavel[i].tipo == 'c' && (variavel[i].ptrval.ptrs  != (char *) NULL) ) {
			free(variavel[i].ptrval.ptrs);
			variavel[i].ptrval.ptrs = (char *) NULL;
		}
	}

	for (i = 0; i < narqs; ++i ) {
		if ( arquivos[i].nome ) {
			free(arquivos[i].nome);
			arquivos[i].nome = (char *) NULL;
		}
		if ( arquivos[i].nch > 0 ) {
			free(arquivos[i].ch);
		}
		/* if ( arquivos[i].qarea.pch != ChNULL ) {
			free(arquivos[i].qarea.pch);
		}
		if ( arquivos[i].qarea.pcv != WNULL ) {
			free(arquivos[i].qarea.pcv);
		} */
		if ( arquivos[i].nvar > 0 ) {
			free(arquivos[i].pos);
		}
	}
	for (i = 0; i < nform; ++i ) {
		free(formatos[i]);
	}
}
