/***********************************************************************************
 Genese - Linguagem de programao para a gerao e manipulao de arquivo .dat

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Contm a funo yylex para anlise lxica do genese

 Desenvolvido por:

	Carlos Fernando Assis Paniago
	Oscar Ivan Palma Pacheco
	Adriana Delfino dos Santos
	

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#ifdef VAXVMS
# include <stdlib.h>
#else
# include <malloc.h>
#endif

#include "pcsgbd.h"
#include "socasm.h"

#ifdef MSDOS
# include "y_tab.h"
#else
# ifdef VAXVMS
#  include "ytab.h"
# else
#  include "y.tab.h"
# endif
#endif

#include "genese.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/* ----------------------------------------------------------------------------
**	@(#)yylexgen.c	3.5	(NTIA/genese)	97/02/28
**
**	
**
**
** Documentado por:
**
**		Carla Geovana do N. Macario
**
**
** Data da ultima alteracao:
**
**		97/02/28 15:44:46
**
** ----------------------------------------------------------------------------
*/


#define YYSTYPE		int

extern	YYSTYPE	yylval;

extern	int	pc;		/* contador do programa  */

extern struct keywords keywords[];	/* informacoes das palavras reservardas
					   do genese  */
extern struct funcwords funcwords[];	/* informacoes de algumas funcoes de 
					   data e de funcoes matematicas */
extern struct funcwords funcdwords[];	/* informacoes de funcoes de data */
extern struct funcwords funcvwords[];	/* informacoes de funcoes void */
extern struct keywords cnstwords[];	/* informacoes das constantes EOF, PI, 
					   E e EULER  */
extern struct funcwords funcswords [];	/* informacoes de funcoes de strings */
extern struct keywords modos [];	/* informacoes dos modos dos arquivos:
					   entrada e saida  */
extern struct arquivos arquivos[];	/* informacoes dos arqs. existentes */ 
extern struct variavel variavel[];	/* informacoes das vars. existentes */

extern	int	nvarc;		/* no. de variaveis corrente  */
extern	int	nvar;		/* no. total de vars. */
extern	int	nomeflag;	/* flag - e' nome de arquivo  */
extern	int	flagord;	/* flag de ordenacao  */
extern	int	pervar;		/* contem o tipo da variavel  */
extern	int	narqs;		/* numero de arquivos existentes  */
extern	int	debflag;	/* flag - permite a depuracao do programa */
extern	int	varveris;	/* indice da variavel na tabela de variaveis */
extern	int	prtvar;		/* caracter especial de format. \L, \T ou \P  */
extern	int	posnum;		/* numero de coluna a partir da qual deve ser 
				   iniciada a leitura formatada  */
extern	int	formnum;	/* indice de variavel com formato numerico
				   para sua leitura */

extern	int	setmodo;	/* flag - modo */

extern	int	flag_dcls;	/* flag de declaracao  */
extern	int	flagA;

extern	int	lineno;
extern	int	c;			/* uso global pela funcao warning */

int yylex()			/* hoc3 */
{
	char	tmpbuf [128];  /* Adriana */

	double d;
	char sbuf[RDRBUF + 1];
	int i;
	char *p;
	int cc;
	char *parea;
#ifdef EDIX
	double *dp;
#endif

	/* 
	** testa o no. de comandos 
	*/

	if (pc >= MAXGENINS - 5)
	  {

/* *** Padroniz. msg erro - Adriana 06/01/95
		execerror("Estouro na area de comandos", "");
*** */

		sprintf (tmpbuf, PegaMsg (3176), "");
		execerror( tmpbuf, "");
	  }

	while (1) {
		/* 
		** brancos, \t e \n  
		*/
		while ((c = xgetc(stdin)) == ' ' || c == '\t' || c == '\n'|| c == '\r' )

			/* 
			** pular linha: incremanta contador de linha 
			*/

			if ((c == '\n')|| (c == '\r')) { 
				++lineno;

				if (!flagA)
					fprintf(stderr, "\r%d > ", lineno);
			}

		/* 
		** termino do programa 
		*/

		if (c == EOF) {	 
			--lineno;

/* *** Padroniz. msg erro - Adriana 06/01/95
			execerror("Termino inesperado do programa", "");
*** */

			execerror( PegaMsg (3188), "");
		}

		/* 
		** verifica se e' comentario  
		*/

		if (c == '/') {
			cc = xgetc(stdin);

			/* 
			** e' comentario. Procura o indicador de fim de 
			** comentario 
			*/

			if (cc == '*') {
				while((cc = xgetc(stdin)) != '/' || c != '*') {
					if (cc == '\n'|| cc == '\r' )
						++lineno;
					c = cc;
				}

				continue;
			}

			else {
				unxgetc(cc, stdin);
			}
		}

		break;
	}

	/*
	** verifica o modo do arquivo 
	*/

	if (setmodo) {	
		i = 0;

		while (modos[i].name) {
#ifdef MSDOS
			if (*(modos[i].name) == (char) (To_Lower(c))) {
#else
			if (*(modos[i].name) == To_Lower(c)) {
#endif
				yylval = modos[i].kval;
				return MODO;
			}

			++i;
		}
	}

	/* 
	** caracter de formatacao  
	*/

	if (prtvar)	
		return(c);

	/* 
	** nome de arquivo  
	*/

	if (nomeflag && c != '(' && c!=')' && c!=',') {
		p = sbuf;

		/* 
		** caracteres validos para nome de arquivo  
		*/

		if (c != '.' && c != '\\' && c != '/' && ! isalnum(c))

/* *** Padroniz. msg erro - Adriana 06/01/95
			execerror("Nome de arquivo invalido","");
*** */

			execerror( PegaMsg (3189),"");

		do {
#ifndef MSDOS
			if (c == '\\')
				c = '/';
#endif
			if ( p >= sbuf + sizeof(sbuf) - 1) {
				*p = 0;

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("nome muito grande", sbuf);
*** */

				sprintf (tmpbuf, PegaMsg (3026), ( (sbuf + sizeof (sbuf) ) - sbuf ), sbuf);
				execerror( tmpbuf, "");
			}

			*p++ = (char) c;
#ifdef MSDOS
		} while ((c = xgetc(stdin)) != EOF && (isalnum(c) ||
			c == '.' || c == '\\' || c == '/' || c == ':' || 
			c == '_'));
#else
		} while ((c = xgetc(stdin)) != EOF && (isalnum(c) ||
			c == '.' || c == '\\' || c == '/' || c == '_'));
#endif
		unxgetc(c, stdin);

		*p = '\0';

		/* 
		** aloca area para o nome do arquivo  
		*/

		if ((parea = malloc((unsigned) (strlen(sbuf) + 1))) == NULL)

/* *** Padroniz. msg erro - Adriana 06/01/95
			execerror("Falta memoria","");
*** */

			execerror(PegaMsg (1039),"");

		arquivos[narqs].nome = parea;

		strcpy(parea, sbuf);
/*
		nomeflag = 0;
*/
		return NOMEARQ;
	}

	/*
	** Numero
	*/
	if (c == '.' || isdigit(c)) {	/* number */

		/*
		** Numero com casas decimais em variavel com campo numerico
		*/

		if (c == '.' && formnum)
			return c;

		p = sbuf;

		*p++ = (char) c;

		/* 
		** Digito: coloca os digitos em sbuf 
		*/

		if (c != '.') {		
			while (isdigit(c = xgetc(stdin)))
				*p++ = (char) c;

			/* 
			** Tem '.'; Testa se e' campo formatado
			*/

			if (c == '.' && !formnum) {
				*p++ = (char) c;

				while (isdigit(c = xgetc(stdin)))
					*p++ = (char) c;
			}
		}

		/* 
		** E' '.' mas nao e' variavel formatada 
		*/

		else	
			while (isdigit(c = xgetc(stdin)))
				*p++ = (char) c;

		/*
		** exponencial; Coloca o valor em sbuf
		*/

		if (To_Lower(c) == 'e') {
			*p++ = (char) To_Lower(c);

			c = xgetc(stdin);

			if (c == '+' || c == '-') {
				*p++ = (char) c;
				c = xgetc(stdin);
			}

			while (isdigit(c)) {
				*p++ = (char) c;
				c = xgetc(stdin);
			}
		}

		unxgetc(c, stdin);

		*p = '\0';

		/*
		** Nenhum valor foi colocado em sbuf: valor missing  
		*/

		if (strcmp(sbuf, ".") == 0)
			d = MISSING;
		/* 
		** transforma para float o valor de sbuf, colocando na 
		** variavel d o resultado
		*/

		else 
			sscanf(sbuf, "%lf", &d);

		/*
		** Testa se variavel de debug esta setada, ou se e' valor de
		** variavel formatada
		*/

		if (debflag || posnum || formnum) {
			yylval = (int) d;
			return NUMBER;
		}

		/*
		** verifica se e' uma variavel numerica ja' definida
		*/

		for (i=nvar; i<nvarc; ++i) {
			if (variavel[i].tipo == 'n' || variavel[i].tipo == 'd'){
				if (variavel[i].ptrval.ptrf == d) {
					yylval = i;

					if (d == MISSING)
						return MISSNUM;
					else
						return NUMBER;
				}
			}
		}

		if (nvarc >= MAXGENVAR - 1)
		  {

/* *** Padroniz. msg erro - Adriana 06/01/95
			execerror("Estourado o numero maximo de variaveis", "");
*** */

			sprintf (tmpbuf, PegaMsg (3175), "");
			execerror( tmpbuf, "");
		  }

		/*
		** Define uma nova variavel, atribuindo o valor de d para ela
		*/

		yylval = nvarc++;
		variavel[yylval].tipo = 'n';
#ifdef EDIX
		dp = &(variavel[yylval].ptrval.ptrf);
		*dp = d;
#else
		variavel[yylval].ptrval.ptrf = d;
#endif

		variavel[yylval].nome = (char *) NULL;

		if (d == MISSING)
			return MISSNUM;
		else
			return NUMBER;
	}

	/*
	** Nome de variavel
	*/

	if ((isalpha(c) && c != '\\') || c == '_') {
		p = sbuf;

		/* 
		** testa o tamanho do nome e caso nao exista problema, coloca o
		** caracter em sbuf
		*/

		do {	
			if ( p >= sbuf + sizeof(sbuf) - 1) {
				*p = 0;

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("nome muito grande", sbuf);
*** */

				sprintf (tmpbuf, PegaMsg (3026), sbuf, ( (sbuf + sizeof (sbuf) ) - sbuf ) );
				execerror( tmpbuf, "");
			}

			*p++ = (char) c;
		} while ((c = xgetc(stdin)) != EOF && (isalnum(c) || c == '_'));

		unxgetc(c, stdin);

		*p = '\0';

		/*
		** Verifica se o nome nao e' a palavra data e date ou nao e'
		** declaracao
		*/

		if ((strcmpi(sbuf,"date") && strcmpi(sbuf,"data")) || !flag_dcls)
		/*
		** verifica se e' palavra-chave do genese
		*/

		for (i=0; keywords[i].name; ++i) {
			if (strcmpi(keywords[i].name, sbuf) == 0) {
				yylval = i;

				/* 
				** Verifica se a palavra-chave esta sendo 
				** usada como nome de variavel numerica, 
				** string ou data
				*/  

				if (pervar == 1 || pervar == 2 || pervar == 4)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Palavra reservada nao pode ser utilizada para dar nome a variavel","");
*** */

					execerror( PegaMsg (3177),"");

				return keywords[i].kval;
			}
		}

		/*
		** verifica se e' nome de funcao matamatica do genese
		*/

		for (i=0; funcwords[i].name; ++i) {
			if (strcmpi(funcwords[i].name, sbuf) == 0) {
				yylval = i;

				/*
				** Verifica se o nome da funcao esta sendo
				** usada como nome de variavel numerica,
				** string ou data
				*/

				if (pervar == 1 || pervar == 2 || pervar == 4)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Nome de funcao nao pode ser utilizado como nome de variavel","");
*** */

					execerror( PegaMsg (3178),"");

				return FUNCAO;
			}
		}

		/*
		** verifica se e' nome de funcao de strings do genese
		*/

		for (i=0; funcswords[i].name; ++i) {
			if (strcmpi(funcswords[i].name, sbuf) == 0) {
				yylval = i;

				/*
				** Verifica se o nome da funcao esta sendo
				** usada como nome de variavel numerica,
				** string ou data
				*/

				if (pervar == 1 || pervar == 2 || pervar == 4)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Nome de funcao nao pode ser utilizado como nome de variavel","");
*** */

					execerror( PegaMsg (3178),"");

				return FUNCAOS;
			}
		}

		/*
		** verifica se e' nome de funcao void.
		*/

		for (i=0; funcvwords[i].name; ++i) {
			if (strcmpi(funcvwords[i].name, sbuf) == 0) {
				yylval = i;

				/*
				** Verifica se o nome da funcao esta sendo
				** usada como nome de variavel numerica,
				** string ou data
				*/

				if (pervar == 1 || pervar == 2 || pervar == 4)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Nome de funcao nao pode ser utilizado como nome de variavel","");
*** */

					execerror(PegaMsg (3178),"");

				return FUNCAOV;
			}
		}

		/*
		** verifica se e' nome de funcao de data do genese
		*/

		for (i=0; funcdwords[i].name; ++i) {
			if (strcmpi(funcdwords[i].name, sbuf) == 0) {
				yylval = i;

				/*
				** Verifica se o nome da funcao esta sendo
				** usada como nome de variavel numerica,
				** string ou data
				*/

				if (pervar == 1 || pervar == 2 || pervar == 4)

/* *** Padroniz. msg erro - Adriana 06/01/95
					execerror("Nome de funcao nao pode ser utilizado como nome de variavel","");
*** */

					execerror( PegaMsg (3178),"");

				return FUNCAOD;
			}
		}

		/*
		** verifica se e' nome de constante do genese
		*/

		for (i=0; cnstwords[i].name; ++i) {
			if (strcmpi(cnstwords[i].name, sbuf) == 0) {
				yylval = i;
				return CONST;
			}
		}

		/*
		** verifica se a variavel ja' existe, obtendo, neste caso, seu
		** tipo
		*/

		if (i = verivar(sbuf)) {
			yylval = varveris;

			/*
			** variavel tipo arquivo
			*/

			if (pervar == 3)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("Nome da variavel referencia de arquivo ja' utilizada","");
*** */

				execerror( PegaMsg (3179),"");

			return i;
		}

		/*
		** Variavel ainda nao definida, sendo numerica, string, arquivo
		** ou data
		*/

		if (pervar && pervar <= 4) {
			if (strlen(sbuf) > 8)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("Variavel com mais de 8 caracteres",
					"");
*** */

				execerror( PegaMsg (3190), "");

			/*
			** incrementa o numero de variaveis existentes
			*/

			yylval = nvarc++;

			if ((parea=malloc((unsigned)(strlen(sbuf)+1))) == NULL)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("Falta memoria","");
*** */

				execerror(PegaMsg (1039),"");

			/*
			** coloca na tabela de variaveis o nome da variavel
			*/

			variavel[yylval].nome = parea;

			strcpy(parea, sbuf);

			/*
			** variavel numerica
			*/

			if (pervar == 1)
				return VARNUM;

			/*
			** variavel data
			*/

			else if (pervar == 4)
				return VARDATA;

			/*
			** variavel string
			*/

			else if (pervar == 2)
				return VARSTR;

			/*
			** variavel arquivo
			*/

			return VARFIL;
		}

		else {
			/*
			** verifica se tem ordenacao -> var. chave
			*/

			if (flagord)
				return VARFIL; /* pra dar erro no parser */
			/*
			** variavel indefinida
			*/

			else  {

/* *** Padroniz. msg erro - Adriana 06/01/95
				char temp[80];

				strcpy(temp,"Variavel ou funcao <");
				strcat(temp, sbuf);
				strcat(temp, "> indefinida");

				execerror(temp,"");
*** */

				sprintf (tmpbuf, PegaMsg (3180), sbuf);
				execerror(tmpbuf,"");
			}
		}
	}

	/* 
	** constante data 
	*/

	if (c == '\'') {	
		p = sbuf;

		/*
		** Pega o valor da data ate' encontrar outro '
		*/

		while (1) {
			if ((c = xgetc(stdin)) == '\'')
				break;

			if (c == '\n' || c == '\r' || c == EOF)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("falta plic", "");
*** */

				execerror( PegaMsg (3029), "");

			*p = (char) c;

			p++;
		}

		*p = '\0';

		/*
		** transforma em data o valor de sbuf
		*/

		if ((d = atod(sbuf)) < (double) 0)

/* *** Padroniz. msg erro - Adriana 06/01/95
			execerror("Data invalida entre com \'dd/mm/aaaa\'",
				"");
*** */

			execerror( PegaMsg (3191), "");

		/*
		** verifica se e' uma variavel data ja' definida
		*/

		for (i=nvar; i<nvarc; ++i) {
			if (variavel[i].tipo == 'n' || variavel[i].tipo == 'd'){
				if (variavel[i].ptrval.ptrf == d) {
					yylval = i;

					return VALDATA;
				}
			}
		}

		if (nvarc >= MAXGENVAR - 1)
		  {

/* *** Padroniz. msg erro - Adriana 06/01/95
			execerror("Estourado o numero maximo de variaveis", "");
*** */

			sprintf (tmpbuf, PegaMsg (3175), "");
			execerror( tmpbuf, "");
		  }
		/*
		** nova variavel data a ser definida
		*/

		yylval = nvarc++;
		variavel[yylval].tipo = 'd';

#ifdef EDIX
		dp = &(variavel[yylval].ptrval.ptrf);
		*dp = d;
#else
		variavel[yylval].ptrval.ptrf = d;
#endif

		variavel[yylval].nome = (char *) NULL;

		return VALDATA;
	}

	/*
	** string: pega os caracteres enquanto nao encontrar "
	*/

	if (c == '"') {		/* quoted string */
		p = sbuf;
		while (1) {
			if ((c = xgetc(stdin)) == '"')
				if ((cc = xgetc(stdin)) != '"') {
					unxgetc(cc, stdin);
					break;
				}

			if (c == '\n' || c == '\r' || c == EOF)

/* *** Padroniz. msg erro - Adriana 06/01/95
				execerror("falta aspas", "");
*** */

				execerror( PegaMsg (3030), "");

			/*
			** testa o tamanho da string
			*/

			if (p >= sbuf + sizeof(sbuf) - 1) {
				*p = '\0';

				fprintf(stderr, "cadeia muito grande;");
				fprintf(stderr, " sera truncada\n");

				while (1) {
					if ((c = xgetc(stdin)) == '"')
						if ((cc=xgetc(stdin)) != '"') {
							unxgetc(cc, stdin);
							break;
						}
				}
				break;
			}

			/* 
			** verifica se tem caracter interpretado na string, 
			** retornando seu valor
			*/

			*p = (char) backslash(c);

			p++;
		}

		*p = 0;

		/*
		** verifica se e' uma variavel string ja' definida
		*/

		for (i=nvar; i<nvarc; ++i) {
			if (variavel[i].tipo == 'c') {
				if (strcmp(variavel[i].ptrval.ptrs,sbuf) == 0) {
					yylval = i;

					return VALSTR;
				}
			}
		}

		/*
		** define nova variavel string
		*/

		yylval = nvarc++;

		variavel[yylval].tipo = 'c';

		if ((p = malloc((unsigned) (strlen(sbuf) + 1))) == NULL)

/* *** Padroniz. msg erro - Adriana 06/01/95
			execerror("Falta memoria","");
*** */

			execerror( PegaMsg (1039),"");

		strcpy(p, sbuf);

		variavel[yylval].ptrval.ptrs = p;
		variavel[yylval].nome = (char *) NULL;

		return VALSTR;
	}

	/*
	** verifica se e' sinal de operacao logica
	*/

	switch (c) {
		case '>':	return follow('=', GE, GT);
		case '<':	return follow('=', LE, LT);
		case '=':	return follow('=', EQ, '=');
		case '!':	return follow('=', NEQ, NOT);
		case '|':	return follow('|', OR, '|');
		case '&':	return follow('&', AND, '&');
		default:	return c;
	}
}

