
/***********************************************************************************
 IMPRIME - Lista as observaes de um arquivo de dados processado pelo SOC

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/imprime/fontes/getpar.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:30:57 $:

***********************************************************************************/

#include <string.h>
#include <signal.h>
#include "imprime.h"
/*#include "lockfile.h"*/

static char *sccsid = "@(#)getpar.c	3.8	(NTIA/imprime)	95/09/21";

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/* ------------------------------------------------------------------------
** getpar()
** 	Programado por:	Oscar Ivan Palma Pacheco
**			Maria Fernanda Moura
**	Data:		Abril 1989
** ------------------------------------------------------------------------- */

extern int linha;
extern int coluna;
extern int pula;
extern long n_obs;
extern int decimais;
extern int externo;
extern int redirecao;
extern int flagX;
extern int f_obs;
extern int flagPage;

extern int descarq;

extern char exretstd[];		/* Contem o nome do arquivo exretstd */
extern int flagstd;

static int flag_exec = 0;
extern void controlC();

void getpar(argc, argv)
int argc;
char *argv[];
{
    int i, j;
    long ret;
    int trocou = 0;		/* se houver troca do numero de linhas */
    int flag_vazio;
    char *pdir;
    char namelock[TAMSTR];


    ++argv;			/* aponta para o primeiro parametro */
    --argc;			/* decrementa o apontador */
    flag_vazio = 1;		/* habilita teste arq. vazio */


    while (argc--) {
	if (argv[0][0] == '-') {
	    for (i = 1; argv[0][i]; ++i) {
		switch (argv[0][i]) {

		case 'd':

		    number(&decimais, argv, &i);
		    if (decimais > 16 || decimais < 0)
			decimais = 4;

		    break;

		case 'l':

		    linha = 0;
		    number(&linha, argv, &i);

		    if (linha > 88 || linha < 0)
			linha = 24;

		    trocou = 1;

		    break;

		case 'c':

		    coluna = 0;
		    number(&coluna, argv, &i);

		    if (coluna > 256 || coluna < 0)
			coluna = 79;

		    break;

		case 'p':

		    if (strncmp(&argv[0][i], "page", 4)) {
			pula = 0;
			number(&pula, argv, &i);

			if (pula < 0)
			    pula = 0;
		    }

		    else {
			flagPage = 1;
			--linha;
			i += 3;
		    }

		    break;

		    /*
		     ** Habilita impressao de mensagens
		     */

		case 'M':
		    break;

		    /*
		     ** Habilita impressao de tempo
		     */

		case 't':

		    break;

		case 'n':

		    j = 0;
		    number(&j, argv, &i);

		    if (j < 0)
			j = 0;

		    n_obs = (long) j;

		    break;

		case 'o':

		    f_obs = 0;

		    break;

		case 'A':
		    flag_exec = 1;

#ifdef RS6000
		    flagstd = 1;
		    /*
		     *strchr(&argv[0][i+1], '|') = '\0';
		     */
		    if (*strchr(&argv[0][i + 1], '|'))
			*strchr(&argv[0][i + 1], '|') = '\0';

		    if (freopen(&argv[0][i + 1], "r", stdin) ==
			(FILE *) NULL) {
			i += (strlen(&argv[0][i + 1]) + 1);
			*strchr(&argv[0][i + 1], '|') = '\0';
			i += (strlen(&argv[0][i + 1]) + 1);
			strcpy(exretstd, &argv[0][i + 1]);

/* *** Padroniz. msg erro - Luciana 03/01/95
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
			fprintf(stderr, PegaMsg(1034), "stdin");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("***Lista de memoria nao esta vazia ***\n ");
			    Mem_Store("imprime");
			    exit(5);
			}
#endif

			exit(5);
		    }

		    i += (strlen(&argv[0][i + 1]) + 1);

		    *strchr(&argv[0][i + 1], '|') = '\0';
		    fseek(stdin, atol(&argv[0][i + 1]), 0);

		    i += (strlen(&argv[0][i + 1]) + 1);
		    strcpy(exretstd, &argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

#endif
		    setbuf(stdin, (char *) NULL);
		    externo = 1;

		    break;

		case 'P':

		    redirecao = 1;

		    break;

		case 'X':

		    if (strcmp(&argv[0][i + 1], "ntia") == 0) {
			flagX = 1;
			i += 4;
		    }

		    break;
		case 'k':
		    flag_vazio = 0;
		    break;

		default:

/* *** Padroniz. msg erro - Luciana 03/01/95
					printf("Flag <%c> ilegal\n",
*** */
		    printf(PegaMsg(3086), argv[0][i]);
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf
			    ("***Lista de memoria nao esta vazia ***\n ");
			Mem_Store("imprime");
			exit(1);
		    }
#endif

		    exit(1);
		}
	    }
	}

	else {
	    break;
	}

	++argv;
    }

    if (!trocou && redirecao)
	linha = 58;

    if (!flagX) {

/* *** Padroniz. msg erro - Luciana 03/01/95
		fprintf(stderr, "Execucao nao permitida\n");
*** */
	fprintf(stderr, PegaMsg(1000));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n ");
	    Mem_Store("imprime");
	    exit(1);
	}
#endif

	exit(1);
    }
    if (argc < 0) {

/* *** Padroniz. msg erro - Luciana 03/01/95
		fprintf(stderr,"Falta nome de arquivo\n");
*** */
	fprintf(stderr, PegaMsg(3000));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n ");
	    Mem_Store("imprime");
	    exit(1);
	}
#endif

	exit(1);
    }

    pdir = pega_env(argv[0], ".hdr");

    /* Bloqueio de leitura do arquivo de entrada */
    strcpy(namelock, pdir);
    strcat(namelock, ".dat");

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n ");
	Mem_Store("imprime");
	exit(5);
    }
#endif

    ret = (long) (fd = abre_arq(pdir, 0, flag_vazio));

    if (ret < 0L && ret > -5L) {
	if (flag_vazio) {

/* *** Padroniz. msg erro - Luciana 03/01/95
		    fprintf(stderr,"Nao consegui abrir <%s> %ld\n", pdir, ret);
    *** */
	    fprintf(stderr, PegaMsg(1034), pdir);
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n ");
		Mem_Store("imprime");
		exit(2);
	    }
#endif

	    exit(2);
	}
    }
    signal(SIGINT, controlC);

}

void number(alfa, argv, k)
int *alfa;
char *argv[];
int *k;
{
    int j;
    int i;
    int t;
    char s[15];

    j = 0;
    t = 0;
    i = *k;

    for (i = i + 1;; ++i) {
	switch (argv[0][i]) {

	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':

	    s[j++] = argv[0][i];

	    break;

	default:

	    t = 1;
	    s[j++] = '\0';
	    *alfa = atoi(s);
	    --i;
	    *k = i;

	    break;
	}

	if (t)
	    break;
    }
}

void controlC(sig)
int sig;
{
    /*
     ** Apagar, se necessario, arquivos temporarios
     */

    if (!flag_exec)
	fprintf(stderr, "\n********  Interrompido pelo usuario\n");
    /* Desbloqueio dos arquivos */

    if (descarq != -1) {
	/*                UnlockAFile(descarq); */
    }


    setOSstdin();

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Men_Store("imprime");
	exit(1);
    }
#endif
    exit(sig);
}
