
/***********************************************************************************
 IMPRIME - Lista as observaes de um arquivo de dados processado pelo SOC

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Modulo para imprimir arquivos de dados do SOC

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/imprime/fontes/imprime.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:30:57 $:

***********************************************************************************/

#define VAR1
#include "imprime.h"
#include <stdlib.h>

#ifdef VAXVMS
#include <signal.h>
#else
#include <malloc.h>
#endif

#include <string.h>

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

/*#include "lockfile.h"*/

static char *sccsid = "@(#)imprime.c	3.12	(NTIA/imprime)	97/02/03";

#define MAXDIG		18
#define TAM_NOME 	strlen(nome)
#define LINHA 	 	linha
#define COLUNA	 	coluna

int linhas;
int *pag_pos;
int *pag_pof;

char nome[16];
char *p;

int *t_campo;			/* tamanho do campo a ser impresso */
int *t_nome;			/* tamanho do nome e/ou rotulo, que e' o tamanho
				   real de um campo ( ou coluna) */
int *t_sobra;			/* sobra entre o t_nome e o t_campo */
int *muitogrd;			/* casos de numeros muito grandes ou muito pequenos */
int centro;

int linha;
int tam;
int coluna;
int pula;
int maxsep;
int decimais;
int muda_pag;			/* flag  para  form_feed   */
int flag_total;			/*se verdadeira, total geral a ser impresso */
int flag_soma;			/* se verdadeira, total parcial a imprimir */
int flag_le1;			/* se verdadeira, leu, pelo menos uma obs */
int quebra;			/* se verdadeira : quebra de nivel        */
int flagX;			/* se verdadeira, executa */
int externo;			/* Variavel controle se execucao vem do Exec */
int redirecao;			/* Variavel controle se impressao redirecionada */
int BRANCOS;			/* folga de brancos para o numero da obs */
int f_obs;			/* flag que determina se imprime ou nao o
				   numero da observacao */
long n_obs;			/* numero de observacoes */
int flagPage = 0;		/* Parada em cada tela. */

char **obs[88];			/* Ponteiro para cada linha a ser impressa */
char *class_ant[OBSSIZE];	/* valor anterior para quebra de nivel */
char *pclass;			/* ponteiro para classe anterior */
long totali;
long total;
int cont_pag;			/* contador de paginas impressas */
int npag;
int *num_dec;
double *soma;
double *somaclass;

char token[128];

int executa;
char t_token;
int c;
int nt1;			/* existe titulo1 */
int j = 0;
int i;
int l;

int descarq;			/* descritor de arquivo para funcoes de lock */

#ifdef MSDOS

# define CONSOLE	"con"

#else

# define CONSOLE	"/dev/tty"

#endif

main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{

    int k;
    long numero;
    double a1, a2;		/* para comparar variaveis numericas --- class */
    char pbuff[15];
    char *ptr;
    double daux;
    int ret;

#ifdef VAXVMS
    argc = prepvax(argc, argv);
    signal(SIGINT, exit);
#endif

/* Valores default das variaveis globais */

#ifdef MSDOS
    LINHA = 25;
#else
    LINHA = 24;
#endif
    COLUNA = 78;
    redirecao = 0;
    decimais = 4;		/*  decimais = 4, em teste pode nao ser bom */
    pula = 0;
    t_token = ' ';
    n_obs = 0L;
    numero = 1L;
    flag_total = 0;
    flag_soma = 0;
    flag_le1 = 0;
    quebra = 0;
    flagX = 1;
    cont_pag = 0;
    externo = 0;
    f_obs = 1;			/* default : imprime num.da observacao */
    descarq = -1;

/* ..............*/

    getpar(argc, argv);

    if (redirecao)
	muda_pag = 12;		/* se formulario */
    else
	muda_pag = 0;		/* se "tela" */


    pclass = (char *) &class_ant[MAXVAR];
    for (i = 0; i < MAXVAR; ++i) {
	class_ant[i] = pclass;
	*pclass = '\0';
	++pclass;
    }

    semantica();

    pag_pos = (int *) calloc((unsigned) (nvar + 1), sizeof(int));
    pag_pof = (int *) calloc((unsigned) (nvar + 1), sizeof(int));
    t_campo = (int *) calloc((unsigned) (nvar + 1), sizeof(int));
    t_nome = (int *) calloc((unsigned) (nvar + 1), sizeof(int));
    t_sobra = (int *) calloc((unsigned) (nvar + 1), sizeof(int));
    muitogrd = (int *) calloc((unsigned) (nvar + 1), sizeof(int));
    num_dec = (int *) calloc((unsigned) (nvar + 1), sizeof(int));
    soma = (double *) calloc((unsigned) (nvar + 1), sizeof(double));
    somaclass = (double *) calloc((unsigned) (nvar + 1), sizeof(double));

    bloco_obs();

    total = 1L;
    tam = 0;
    linhas = 0;
    centro = coluna;

    for (i = 0; i < nvar; ++i) {
	t_campo[i] = 0;
	muitogrd[i] = 0;
	num_dec[i] = 0;
    }

    if (nsoma && nclass)
	for (i = 0; i < nsoma; ++i)
	    somaclass[i];

    if (nsoma)
	for (i = 0; i < nsoma; ++i)
	    soma[i] = 0.;

    while (ler_obs(fd, obs2) != EOF) {
	for (i = 0; i < nvar; ++i) {
	    if ((ptr = strchr(obs2[posvar[i]], '\n'))) {
		*ptr++ = '~';
		*ptr = '\0';
	    }
	    if ((int) strlen(obs2[posvar[i]]) > COLUNA - 10)
		obs2[posvar[i]][COLUNA - 10] = '\0';
	}
	if ((n_obs < numero++) && (n_obs > 0L))
	    break;
	if ((flag_le1 == 0) && nclass) {	/* trata a primeira obs. de classe */
	    pclass = (char *) (class_ant - obs2 + (char **) obs2[0]);
	    for (i = 0; i < nclass; ++i) {
		class_ant[i] = pclass;
		if (tipclass[i] == 'd') {
		    if (strcmp(obs2[posclass[i]], "."))
			daux = atof(obs2[posclass[i]]);
		    else
			daux = MISSING;
		    dtoa(daux, pbuff);
		    strcpy(pclass, pbuff);
		} else
		    strcpy(pclass, obs2[posclass[i]]);
		pclass += (strlen(pclass) + 1);
	    }
	}
	if ((flag_le1 == 1) && nclass) {
	    for (i = 0; i < nclass; ++i) {
		if (tipclass[i] == 'c') {
		    if (strcmpi(class_ant[i], obs2[posclass[i]]) != 0) {
			quebra = 1;
			break;
		    }
		} else if (tipclass[i] == 'd') {
		    if (strcmp(obs2[posclass[i]], "."))
			daux = atof(obs2[posclass[i]]);
		    else
			daux = MISSING;
		    dtoa(daux, pbuff);
		    if (strcmpi(class_ant[i], pbuff) != 0) {
			quebra = 1;
			break;
		    }
		} else {
		    if (strcmpi(class_ant[i], ".") == 0)
			a1 = MISSING;
		    else
			a1 = atof(class_ant[i]);
		    if (strcmpi(obs2[posclass[i]], ".") == 0)
			a2 = MISSING;
		    else
			a2 = atof(obs2[posclass[i]]);
		    if (lfuzz(a1, a2) != 0) {
			quebra = 1;
			break;
		    }
		}
	    }
	    if (quebra) {
		veri_class();
		if (nsoma) {
		    formsoma(somaclass);
		    ++flag_soma;
		    impr();
		    linhas = 0;
		    for (i = 0; i < nsoma; ++i)
			somaclass[i] = 0.;
		}
		if (linhas)
		    impr();
		linhas = 0;
		for (l = 0; l < nvar; ++l) {
		    t_campo[l] = 0;
/*  Sonia: retirada inicializacao de num_dec, pois a cada pagina e' alterado o
    numero de decimais a serem impressas.  
					num_dec[l] = 0;
*/
		}
		pclass = (char *) (class_ant - obs2 + (char **) obs2[0]);
		for (i = 0; i < nclass; ++i) {
		    class_ant[i] = pclass;

		    if (tipclass[i] == 'd') {
			if (strcmp(obs2[posclass[i]], "."))
			    daux = atof(obs2[posclass[i]]);
			else
			    daux = MISSING;
			dtoa(daux, pbuff);
			strcpy(pclass, pbuff);
		    } else
			strcpy(pclass, obs2[posclass[i]]);
		    pclass += (strlen(pclass) + 1);
		}
		quebra = 0;
		flag_soma = 0;
	    }
	}

	flag_le1 = 1;

	if (nsoma)
	    for (i = 0; i < nsoma; ++i)
		soma[i] += atof(obs2[posoma[i]]);
	if (nsoma && nclass)
	    for (i = 0; i < nsoma; ++i)
		somaclass[i] += atof(obs2[posoma[i]]);

	for (i = 0; i < nvar; ++i)
	    tam += (strlen(obs2[posvar[i]]) + 1);


	tam = tam / (sizeof(char *)) + 1 + nvar;

	obs[linhas] = (char **) malloc((unsigned) (tam * sizeof(char *)));


	if (obs[linhas] == 0) {

/* *** Padroniz. msg erro - Luciana 03/01/95
			fprintf(stderr,"===>>>> Memoria Insuficiente\n");
*** */
	    fprintf(stderr, PegaMsg(1039));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("imprime");
		exit(-1);
	    }
#endif

	    exit(-1);
	}
	p = (char *) &obs[linhas][nvar];
	tam = 0;

	for (i = 0; i < nvar; ++i) {
	    strcpy(p, obs2[posvar[i]]);
	    obs[linhas][i] = p;
	    p += (strlen(p) + 1);
	}
	++linhas;

	for (j = 0; j < nvar; ++j) {
	    ret = pega_var(fd, posvar[j], nome, &tipo, &mmin, &mmax);
	    if (ret < 0) {
		fprintf(stderr, PegaMsg(1062));
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("*** Lista de memoria nao esta' vazia ***\n");
		    Mem_Store("imprime");
		    exit(2);
		}
#endif

		exit(2);
	    }

	    if (tipo == 'n') {
		if (nform && ((k = proc_form(posvar[j])) < nform)) {
		    t_form(obs2[posvar[j]], k, &l, &i);
		    if (t_campo[j] < l)
			t_campo[j] = l;
		    if (num_dec[j] < i)
			num_dec[j] = i;
		} else {
		    if (strlen(obs2[posvar[j]]) ==
			strcspn(obs2[posvar[j]], "e")) {
			if (*(obs2[posvar[j]]) == '.') {
			    i = strlen(obs2[posvar[j]]) -
				(int) strcspn(obs2[posvar[j]], ".") - 1;
			    l = strcspn(obs2[posvar[j]], ".") + 2;
			} else {
			    if ((*(obs2[posvar[j]]) == '-') &&
				(*(obs2[posvar[j]] + 1) == '.')) {
				i = strlen(obs2[posvar[j]]) -
				    (int) strcspn(obs2[posvar[j]],
						  ".") - 1;
				l = strcspn(obs2[posvar[j]], ".")
				    + 2;
			    } else {
				i = strlen(obs2[posvar[j]]) -
				    (int) strcspn(obs2[posvar[j]],
						  ".") - 1;
				l = strcspn(obs2[posvar[j]], ".") + 1;
			    }
			}
		    } else {
			qtamanho(&l, &i, obs2[posvar[j]]);
			++l;
		    }
		    if (num_dec[j] < i)
			num_dec[j] = decimais;
		    if (l > t_campo[j])
			t_campo[j] = l;
		}
	    } else if (tipo == 'd') {
		if (t_campo[j] < 10)
		    t_campo[j] = 10;
	    } else {
		if (t_campo[j] < (l = strlen(obs2[posvar[j]])))
		    t_campo[j] = l;
	    }
	}
	if (linhas >= LINHA) {
	    impr();
	    linhas = 0;
	    for (l = 0; l < nvar; ++l) {
		t_campo[l] = 0;
/*  Sonia: retirada inicializacao de num_dec, pois a cada pagina e' alterado o
    numero de decimais a serem impressas.  
				num_dec[l] = 0;
*/
	    }
	}
    }
    if ((linhas > 0) && nsoma && nclass) {
	formsoma(somaclass);
	++flag_soma;
	quebra = 1;
    }
    if (nsoma) {
	formsoma(soma);
	++flag_total;
    }

    if (linhas > 0)
	impr();

    /*
     ** Fecha arquivo .hdr
     */
    ret = fech_arq(fd);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1011), "");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("imprime");
	    exit(2);
	}
#endif

	exit(2);
    }


    /*
     ** Liberacao de areas alocadas
     */

    /*
     ** Vetores sempre alocados 
     */
    free(pag_pos);
    free(pag_pof);
    free(t_campo);
    free(t_nome);
    free(t_sobra);
    free(muitogrd);
    free(num_dec);
    free(soma);
    free(somaclass);

    for (i = 0; i < nvar; i++) {
	if (nomevar[i] != (char *) NULL)
	    free(nomevar[i]);
    }
    free(nomevar);
    free(posvar);

    /*
     ** Vetores alocados dependendo do comando usado
     */
    if (nsoma)
	free(posoma);

    if (nrot) {
	for (i = 0; i < nrot; i++) {
	    if (rotulo[i] != (char *) NULL)
		free(rotulo[i]);
	}
	free(rotulo);
	free(posrot);
    }

    setOSstdin();

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("imprime");
	exit(0);
    }
#endif

    /* Desbloqueio dos arquivos */
    if (descarq != -1) {
	/*        UnlockAFile(descarq); */
    }

    exit(0);
}

void bloco_obs()
{
    if (f_obs) {
	if (nrot) {
	    BRANCOS = t_rot(-1);
	    /* tamanho do maior rotulo para "obs" */
	    if (BRANCOS)
		BRANCOS = BRANCOS + 2;
	}
	if (!BRANCOS)
	    BRANCOS = 5;	/* "obs  " */
    } else
	BRANCOS = 0;		/* nao ha' folga */
}

int tam_col;

void impr()
{
    int ret;
    int tstot;
    int i;
    int ii;
    int j;
    int l;
    int k;
    int maior_rot;
    double x;
    char buf[30];
    int sob_dir;
    int sob_esq;
    int sob_obs;
    int tam_obs;
    char buf_obs[20];
    double daux;
    FILE *ftty;

    npag = 0;
    pag_pos[npag] = 0;

    if (flagPage) {
	ftty = fopen(CONSOLE, "r");
	if (ftty == (FILE *) NULL) {
	    fprintf(stderr, PegaMsg(5020), CONSOLE);
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("imprime");
		exit(2);
	    }
#endif

	    exit(2);
	}
    }

    /*corrigi os tamanhos, obtendo o tamanho para a pagina a ser impressa */

    if (f_obs) {
	/* calcula as sobras para obs */
	tam_obs = (int) total + linhas - 1;	/* num.da ultima obser-
						   vacao da pagina */
	itoa(tam_obs, buf_obs, 10);
	tam_obs = strlen(buf_obs);	/* numero de digitos */
	if ((BRANCOS - 2) > tam_obs) {
	    sob_esq = (int) (((BRANCOS - 2) - tam_obs) / 2);
	    sob_dir = ((BRANCOS - 2) - tam_obs) % 2;
	    tam_obs += sob_esq;
	    sob_obs = sob_dir + sob_esq;
	} else {
	    BRANCOS = tam_obs + 2;
	    sob_obs = 0;
	}
    }
    tam = BRANCOS;

    for (i = 0; i < nvar; ++i) {
	ret = pega_var(fd, posvar[i], nome, &tipo, &mmin, &mmax);
	if (ret < 0) {
	    fprintf(stderr, PegaMsg(1062));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("imprime");
		exit(2);
	    }
#endif

	    exit(2);
	}

	if (tipo == 'n') {
	    if (nform) {
		if (!((k = proc_form(posvar[i])) < nform)) {
		    if (num_dec[i] == 0)
			--t_campo[i];
		    else
			t_campo[i] = t_campo[i] + num_dec[i];
		}
	    } else {
		if (num_dec[i] == 0)
		    --t_campo[i];
		else
		    t_campo[i] = t_campo[i] + num_dec[i];
	    }
	    if (t_campo[i] > MAXDIG) {
		if (nform) {
		    if (!((k = proc_form(posvar[i])) < nform))
			t_campo[i] = 10;
		    muitogrd[i] = 1;
		} else
		    t_campo[i] = 10;
		muitogrd[i] = 1;
	    }
	}
	/* calcula tamanho dos nomes e das sobras, assim como ajusta
	   o tamanho do campo  */
	if ((nrot) && (maior_rot = t_rot(posvar[i])))
	    t_nome[i] = maior_rot;
	else
	    t_nome[i] = TAM_NOME;
	if (t_nome[i] > t_campo[i]) {
	    sob_dir = (t_nome[i] - t_campo[i]) % 2;
	    sob_esq = (int) (t_nome[i] - t_campo[i]) / 2;
	    if (tipo == 'n') {
		t_campo[i] += sob_esq;
		t_sobra[i] = sob_dir + sob_esq;
	    } else {
		t_campo[i] += sob_dir + sob_esq;
		t_sobra[i] = sob_esq;
	    }
	} else {
	    t_nome[i] = t_campo[i];
	    t_sobra[i] = 0;
	}
	tam += (t_nome[i] + 2);
	if (tam > (COLUNA - 2)) {
	    pag_pof[npag] = i - 1;
	    pag_pos[++npag] = i;
	    tam = BRANCOS + t_nome[i] + 2;
	}
    }
    pag_pof[npag] = i - 1;

    /* a seguir imprime a pagina */

    totali = total;
    for (j = 0; j <= npag; ++j) {
	/* 
	   if ( !externo && (redirecao == 0) ) 
	   do { c = xgetc(stdin); }  while ( c != '\n' );
	 */
	tam_col = BRANCOS - 2;
	for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
	    tam_col += t_nome[i] + 2;
	}
	tam_col = (coluna - tam_col) / 2;
	if (tam_col < 0)
	    tam_col = 0;
	imptl(j);
	total = totali;
	tstot = 0;
	for (l = 0; l < linhas; ++l) {
	    if (flag_total && (l == (linhas - 1))) {
		if (tam_col)
		    printf("%*s", tam_col, " ");
		if (BRANCOS)
		    printf("%*s", BRANCOS, " ");
		for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
		    tstot = teste_tot(i);
		    if (tstot)
			for (ii = 0; ii < t_nome[i]; ++ii)
			    printf(" ");
		    else
			for (ii = 0; ii < t_nome[i]; ++ii)
			    printf(" ");
		    printf("  ");
		}
		printf("\n");
		tstot = pag_tot(j);
		if (tstot) {
		    if (tam_col)
			printf("%*s", tam_col, " ");
		    printf("%-*s", (BRANCOS - 2),
			   center("Total", (BRANCOS - 2)));
		    printf("  ");
		} else {
		    if (tam_col)
			printf("%*s", tam_col, " ");
		    if (BRANCOS)
			printf("%*s", BRANCOS, " ");
		}
	    } else {
		if ((l == linhas - 2) && quebra && flag_total) {
		    if (tam_col)
			printf("%*s", tam_col, " ");
		    if (BRANCOS)
			printf("%*s", BRANCOS, " ");
		    for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
			tstot = teste_tot(i);
			if (tstot)
			    for (ii = 0; ii < t_nome[i]; ++ii)
				printf(" ");
			else
			    for (ii = 0; ii < t_nome[i]; ++ii)
				printf(" ");
			printf("  ");
		    }
		    printf("\n");
		    tstot = pag_tot(j);
		    if (tstot) {
			if (tam_col)
			    printf("%*s", tam_col, " ");
			printf("%-*s", (BRANCOS - 2),
			       center("Total", (BRANCOS - 2)));
			printf("  ");
		    } else {
			if (tam_col)
			    printf("%*s", tam_col, " ");
			if (BRANCOS)
			    printf("%*s", BRANCOS, " ");
		    }
		} else {
		    if (quebra && flag_soma && (flag_total == 0)
			&& (l == (linhas - 1))) {
			if (tam_col)
			    printf("%*s", tam_col, " ");
			if (BRANCOS)
			    printf("%*s", BRANCOS, " ");
			for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
			    tstot = teste_tot(i);
			    if (tstot) {
				for (ii = 0; ii < t_nome[i]; ++ii) {
				    printf(" ");
				}
			    } else {
				for (ii = 0; ii < t_nome[i]; ++ii) {
				    printf(" ");
				}
			    }
			    printf("  ");
			}
			printf("\n");
			tstot = pag_tot(j);
			if (tstot) {
			    if (tam_col)
				printf("%*s", tam_col, " ");
			    printf("%-*s", (BRANCOS - 2),
				   center("Total", (BRANCOS - 2)));
			    printf("  ");
			} else {
			    if (tam_col)
				printf("%*s", tam_col, " ");
			    if (BRANCOS)
				printf("%*s", BRANCOS, " ");
			}
		    } else {
			if (tam_col)
			    printf("%*s", tam_col, " ");
			if (f_obs) {
			    printf("%*ld  ", tam_obs, total++);
			    if (sob_obs)
				printf("%*s", sob_obs, " ");
			} else if (BRANCOS)
			    printf("%*s", BRANCOS, " ");
		    }
		}
	    }
	    for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
		ret = pega_var(fd, posvar[i], nome, &tipo, &mmin, &mmax);
		if (ret < 0) {
		    fprintf(stderr, PegaMsg(1062));
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf
			    ("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("imprime");
			exit(2);
		    }
#endif

		    exit(2);
		}

		if (tipo == 'n') {
		    if (strcmpi(obs[l][i], ".") != 0) {
			if (nform && ((k = proc_form(posvar[i])) < nform)) {
			    if (formato[k].codigo == 1)
				printf("%*s  ", t_campo[i],
				       czfor(obs[l][i]));
			    else {
				if (formato[k].codigo < 4) {
				    char buf_num[128];
				    char *p_buf;
				    sprintf(buf_num, "%*s", t_campo[i],
					    rounddec(atof(obs[l][i]),
						     t_campo[i],
						     num_dec[i]));
				    for (p_buf = buf_num; *p_buf == ' ';
					 ++p_buf);
				    if (strlen(p_buf) >= 17) {
					printf("%*s  ", t_campo[i],
					       gcvt(atof(obs[l][i]), 15,
						    buf_num));
				    } else {
					printf("%*s  ", t_campo[i],
					       buf_num);
				    }
				} else
				    printf("%*.*e  ", t_campo[i],
					   num_dec[i], atof(obs[l][i]));
			    }
			} else {
			    /* nao formatado */
			    x = atof(obs[l][i]);
			    if (muitogrd[i])
				printf("%10.3e  ", x);
			    else {
				char buf_num[128];
				sprintf(buf_num, "%*s",
					t_campo[i],
					rounddec(atof(obs[l][i]),
						 t_campo[i], num_dec[i]));
				printf("%*s  ", t_campo[i], buf_num);
			    }
			}
		    } else {
			/* e' missing */
			if ((flag_total && (l == (linhas - 1))) ||
			    (quebra && flag_total && (l == (linhas - 2)))
			    || (quebra && flag_soma
				&& (l == (linhas - 1))))

			    buf[0] = ' ';
			else
			    buf[0] = '.';

			for (k = 1; k <= num_dec[i]; ++k)
			    buf[k] = ' ';
			buf[k] = '\0';
			printf("%*s  ", t_campo[i], buf);
		    }
		    if (t_sobra[i])
			printf("%*s", t_sobra[i], " ");
		}
/* OSCAR: Ate' a marca. */
		else if (tipo == 'd') {
		    char pbuff[15];

		    if (t_sobra[i])
			printf("%*s", t_sobra[i], " ");
		    if ((flag_total && (l == (linhas - 1)))
			|| (quebra && flag_total && (l == (linhas - 2)))
			|| (quebra && flag_soma && (l == (linhas - 1)))) {
			printf("%-*s  ", t_campo[i], " ");
		    } else {
			if (strcmp(obs[l][i], "."))
			    daux = atof(obs[l][i]);
			else
			    daux = MISSING;
			dtoa(daux, pbuff);
			printf("%-*s  ", t_campo[i], pbuff);
		    }
		}
/* XXXXXXXXXXXXXXXXXXXX */
		else {
		    /* variavel alfabetica */
		    if (t_sobra[i])
			printf("%*s", t_sobra[i], " ");
		    if ((flag_total && (l == (linhas - 1)))
			|| (quebra && flag_total && (l == (linhas - 2)))
			|| (quebra && flag_soma && (l == (linhas - 1)))) {
			printf("%-*s  ", t_campo[i], " ");
		    } else {
			printf("%-*s  ", t_campo[i], obs[l][i]);
		    }
		}
	    }
	    printf("\n");

	}

	for (l = 0; l < pula; ++l)
	    printf("\n");
/*
		if (linha > 20) 		printf("\n\n");
*/

	if (flagPage) {

/* *** Padroniz. msg erro - Luciana 03/01/95
			fprintf(stderr, "TECLE ENTER PARA CONTINUAR ...");
*** */
	    fprintf(stderr, "Digite <ENTER> para continuar");
	    fflush(stderr);
	    while (fgetc(ftty) != '\n');
	    fprintf(stderr, "\r                          \r");
	}
    }

    for (l = 0; l < linhas; ++l) {
	if (obs[l] != (char **) NULL) {
	    free(obs[l]);
	    obs[l] = (char **) NULL;
	}
    }

    bloco_obs();

    if (flagPage)
	fclose(ftty);
}


int teste_tot(j)

int j;

{

    int i;

    for (i = 0; i < nsoma; ++i)
	if (posvar[j] == posoma[i])
	    break;
    if (i != nsoma)
	return (1);
    else
	return (0);
}


int pag_tot(j)

int j;

{

    int i;
    int k;

    for (k = pag_pos[j]; k <= pag_pof[j]; ++k) {
	for (i = 0; i < nsoma; ++i)
	    if (posvar[k] == posoma[i])
		break;
	if (i != nsoma)
	    break;
    }
    if (i != nsoma)
	return (1);
    else
	return (0);
}
