
/***********************************************************************************
 IMPRIME - Lista as observaes de um arquivo de dados processado pelo SOC

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Dalton Francisco Andrade
	Maria Fernanda Moura
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/imprime/fontes/imptl.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:30:57 $:

***********************************************************************************/

#include "imprime.h"

static char *sccsid = "@(#)imptl.c	3.2	(NTIA/imprime)	95/01/11";

extern int *pag_pos;
extern int *pag_pof;
extern char nome[16];
extern int *t_nome;
extern int centro;
extern int cont_pag;
extern int maxsep;		/* max. de separadores para rotulos */
extern int f_obs;
extern int flag_soma;
extern int flag_total;
extern int BRANCOS;

char improt[TAMROT];
int m;
int k;
int auxsep;
int d;
int t;

/* IMPTL : imprime titulos e cabecalho */
void imptl(j)
int j;
{
    extern int nt1;
    extern int nclass;
    extern int nrot;
    extern int tam_col;
    extern int muda_pag;
    int i;
    int ret;

    if (muda_pag)
	putchar((char) muda_pag);

    ++cont_pag;

    printf("\n");
    if (!f_obs && (flag_total || flag_soma)) {
	i = centro + BRANCOS;
	for (k = 0; k < nt1; k++)
	    printf("%-*s\n", i, center(titulo[k], i));
    } else {
	for (k = 0; k < nt1; ++k)
	    printf("%-*s\n", centro, center(titulo[k], centro));
    }

    if (nclass)
	impclass();

    printf("\n");

    if (tam_col)
	printf("%*s", tam_col, " ");

    if (f_obs)
	for (i = 0; i < BRANCOS; i++)
	    printf("-");
    else if (BRANCOS)
	printf("%*s", BRANCOS, " ");

    for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
	for (k = 0; k < t_nome[i]; ++k)
	    printf("-");
	if (i < pag_pof[j])
	    printf("--");
    }
    printf("\n");

    if (tam_col)
	printf("%*s", tam_col, " ");

    if (f_obs) {
	if (nrot)
	    k = proc_rot(-1);
	else
	    k = 1;
	if (k < nrot) {
	    monta_rot();
	    improt[m] = '\0';
	    printf("%-*s  ", (BRANCOS - 2), center(improt, (BRANCOS - 2)));
	} else
	    printf("%-*s  ", (BRANCOS - 2), center("obs", (BRANCOS - 2)));
    } else if (BRANCOS)
	printf("%*s", BRANCOS, " ");

    auxsep = maxsep;
    while (auxsep >= 0) {
	if (auxsep < maxsep) {
	    printf("\n");
	    if (tam_col)
		printf("%*s", tam_col, " ");
	    if (f_obs) {
		if (nrot) {
		    k = proc_rot(-1);
		    if (k < nrot) {
			cont_rot();
			improt[m] = '\0';
			printf("%-*s  ", (BRANCOS - 2),
			       center(improt, (BRANCOS - 2)));
		    } else
			printf("%*s", BRANCOS, " ");
		} else
		    printf("%*s", BRANCOS, " ");
	    } else if (BRANCOS)
		printf("%*s", BRANCOS, " ");
	}
	for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
	    ret = pega_var(fd, posvar[i], nome, &tipo, &mmin, &mmax);
	    if (ret < 0) {
		fprintf(stderr, PegaMsg(1062));
		setOSstdin();
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("*** Lista de memoria nao esta' vazia ***\n");
		    Mem_Store("imprime");
		    exit(2);
		}
#endif

		exit(2);
	    }

	    if (nrot) {
		k = proc_rot(posvar[i]);
		if (k < nrot) {
		    if (auxsep == maxsep)
			monta_rot();
		    else
			cont_rot();
		    improt[m] = '\0';
		    printf("%-*s  ", t_nome[i], center(improt, t_nome[i]));
		} else {
		    if (auxsep == maxsep)
			printf("%-*s  ", t_nome[i],
			       center(nomevar[i], t_nome[i]));
		    else
			printf("%-*s  ", t_nome[i],
			       center(" ", t_nome[i]));
		}
	    } else
		printf("%-*s  ", t_nome[i], center(nomevar[i], t_nome[i]));
	}
	--auxsep;
    }

    printf("\n");

    if (tam_col)
	printf("%*s", tam_col, " ");

    if (f_obs)
	for (k = 0; k < BRANCOS; k++)
	    printf("-");
    else if (BRANCOS)
	printf("%*s", BRANCOS, " ");

    for (i = pag_pos[j]; i <= pag_pof[j]; ++i) {
	for (k = 0; k < t_nome[i]; ++k)
	    printf("-");
	if (i < pag_pof[j])
	    printf("--");
    }
    printf("\n");
}

/* MONTA_ROT : faz a montagem da primeira parte do rotulo */
void monta_rot()
{
    for (m = 0;; ++m) {
	if ((rotulo[k][m] != '\0') && (rotulo[k][m] != SEPARADOR))
	    improt[m] = rotulo[k][m];
	else
	    break;
    }
}

/* CONT_ROT : verifica se o rotulo tem continuacao e monta a continuacao */
void cont_rot()
{
    d = 0;
    for (t = 0; t < (maxsep - auxsep); ++t) {
	for (m = d;; ++m) {
	    if (rotulo[k][m] == SEPARADOR) {
		d = m + 1;
		break;
	    }
	    if (rotulo[k][m] == '\0') {
		d = m;
		break;
	    }
	}
    }
    for (m = d;; ++m) {
	if ((rotulo[k][m] != '\0') && (rotulo[k][m] != SEPARADOR))
	    improt[m - d] = rotulo[k][m];
	else {
	    if (rotulo[k][m] == '\0')
		improt[m - d] = '\040';
	    m = m - d;
	    break;
	}
    }
}
