/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Rotina para fechar arquivos de dados.

 Desenvolvido por:

        	Oscar Ivan Palma Pacheco
		Carlos Fernando Assis Paniago
		Adriana Delfino dos Santos

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/


/*
** --------------------------------------------------------------------------
**
** Rotina para fechar arquivos de dados.
**
** Forma de usar:
**
**		cod = fech_arq(parq);
**
** Variaveis envolvidas:
**
**		int	cod;	Codigo de retorno
**		ARQ	parq;	Ponteiro de referencia dos arquivos
**
** Valor retornado:
**
**			 0 : Normal
**			-1 : Nao conseguiu gravar no arquivo ".hdr"
**			-2 : Nao conseguiu abrir o arquivo ".hdr"
**
** -------------------------------------------------------------------------
*/

#include <stdio.h>
#include <string.h>

#ifdef MSDOS
# include <stdlib.h>
#endif

#ifdef SUN
# include <stdlib.h>
#endif

#include "pcsgbd.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

fech_arq(parq)
ARQ	*parq;
{
	VAR	*ivar;
	int	i;
	char	*ichar, buffer[128];

	/*
	** Atualizar definicoes das variaveis.
	*/

	if (parq -> novo == 1) {
		strcpy(buffer, parq -> nome);
		strcat(buffer, ".hdr");

		fclose(parq -> fdhdr);

		if ((parq -> fdhdr = fopen(buffer, "w")) == (FILE *) NULL) {
			return -2;
		}
		ivar = parq -> pvar + parq -> nvar;
		ivar -> nome[0] = '\0';
		ivar -> tipo = 'c';
		ivar -> mmin.len = TIPOARQ;
		ivar -> mmax.len = TIPOARQ;
		fseek(parq -> fdhdr, 0L, 0);
		ivar = parq -> pvar;
		for (i = 0; i <= parq -> nvar; ++i) {
			ichar = (char *) ivar;
			gravacampo(parq -> fdhdr, ichar, ';');

			buffer[0] = ivar -> tipo;
			buffer[1] = '\0';
			gravacampo(parq -> fdhdr, buffer, ';');

			if (ivar -> tipo == 'c')
				itoa(ivar -> mmin.len, buffer, 10);
			else
/*** 19/07/95 - Adriana
				ftoa(ivar -> mmin.valor, 16, buffer);
 ***/
				ftoa(ivar -> mmin.valor, 15, buffer);

			gravacampo(parq -> fdhdr, buffer, ';');

			if (ivar -> tipo == 'c')
				itoa(ivar -> mmax.len, buffer, 10);
			else
/*** 19/07/95 - Adriana
				ftoa(ivar -> mmax.valor, 16, buffer);
 ***/
				ftoa(ivar -> mmax.valor, 15, buffer);

			if (gravacampo(parq -> fdhdr, buffer, '\n') == EOF)
				return -1;

			ivar++;
		}
	}

	/*
	** Fechar arquivos.
	*/

	if (parq -> fdhdr != (FILE *) NULL)
		fclose(parq -> fdhdr);

	Reset_Buff(parq -> fddat);

	fclose(parq -> fddat);

	/*
	** Desalocar area na memoria para estes arquivos.
	*/

	if (((char *) parq -> pvar) != (char *) NULL)
		free((ALTIPO) parq -> pvar);
	if (((char *) parq ) != (char *) NULL)
		free((ALTIPO) parq);

	return 0;
}


int fech_vazio (parq)
ARQ	*parq;
{
	VAR	*ivar;
	int	i;
	char	*ichar, buffer[128];

	/*
	** Gera .hdr vazio.
	*/

	strcpy(buffer, parq -> nome);
	strcat(buffer, ".hdr");

	fclose(parq -> fdhdr);


	/*
	** Fechar arquivo .dat.
	*/


	Reset_Buff(parq -> fddat);

	fclose(parq -> fddat);

	/*
	** Desalocar area na memoria para estes arquivos.
	*/

	if (((char *) parq -> pvar) != (char *) NULL)
		free((ALTIPO) parq -> pvar);
	if (((char *) parq ) != (char *) NULL)
		free((ALTIPO) parq);

	return 0;
}


