/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Calcula a inversa da distribuio F centralizada

Desenvolvido por: 
		Dalton Francisco Andrade
		Maria Fernanda Moura 		
		Oscar Ivan Palma Pacheco
		Slvio Roberto Medeiros Evangelista 		
		Snia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include "pcsgbd.h"

/*------------------------------------------------------------------*/
/*                 Finv -- Inverse Central F Distribution           */
/*------------------------------------------------------------------*/

double finv( Alpha, Dfn, Dfe)
double Alpha;
double Dfn;
double Dfe;
{
	int MaxIter  = 100;
	int Dprec    = 10;

	double  Fin;
	int 	Iter;
	double  Cprec;
	int 	Ierr;

	/* Inicio Finv */

	if ( Alpha == 1.0 )		return(0.0);

	if ( Dfn >= 150.0 ) 
		Dfn = 150.0;
	else {
		if ( Dfn <= 0.00001 ) 
			Dfn = 0.00001;
	}

	if ( Dfe >= 150.0 ) 
		Dfe = 150.0;
	else {
		if ( Dfe <= 0.00001 ) 
			Dfe = 0.00001;
	}

	if ( Alpha <= 0.00001 ) {
		Alpha = 0.00001;
	}
	else {
		if ( Alpha >= .99999 ) 
			Alpha = 0.99999;
	}

	Fin   = -1.0;

	if( ( Dfn > 0.0 ) && ( Dfe > 0.0 ) ) {
		if( ( Alpha >= 0.0 ) && ( Alpha <= 1.0 ) ) {
			Fin = BetaInv( 1.0 - Alpha, Dfn/2.0, Dfe/2.0, 
				MaxIter, Dprec,&Iter, &Cprec,&Ierr  );

			if( ( Fin >= 0.0 ) && ( Fin < 1.0 ) && ( Ierr == 0 )) 
				Fin  = Fin * Dfe / ( Dfn * ( 1.0 - Fin ) );
		}
	}
	return(Fin);
}
