/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Funcao para transformar valor real em cadeia de caracteres

 Desenvolvido por:

		Oscar Ivan Palma Pacheco
		Carla Geovana do Nascimento Macrio
		Maria Fernanda Moura
		Adriana Delfino dos Santos


 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include <string.h>

#ifdef MSDOS
# include <stdlib.h>
#endif

#ifdef VAXVMS
# include <stdlib.h>
# include <ctype.h>
#endif

#include "pcsgbd.h"

#if defined (i486) || defined (DJGPP)
    char *gcvt( double d, int n, char *s);
#endif


/* ----------------------------------------------------------------------------
**
** Funcao para transformar valor real em cadeia de caracteres
**
** Forma de usar:
**
**		char *ftoa(d, n, s)
**		double d;
**		int n;
**		char *s;
**
** Valor retornado:
**
**		Ponteiro para a cadeia de caracteres
**
** ----------------------------------------------------------------------------
*/

char *ftoa(d, n, s)
double d;
int n;
char *s;
{
	int i;
	extern  char *gcvt();

#if defined(VAXVMS) 
	int nz;
	char *pponto;
	char *paux;
#endif

#if defined(VAXVMS) 
	nz = 0;
#endif

	if (fabs(d) >= MAXREAL) {
		strcpy(s, ".");
	}
	else {
		s = gcvt(d, n, s);
		for (i = 0; s[i]; ++i)
#if defined(VAXVMS) 
			if (s[i] == 'e') {
				nz = atoi(&s[i+1]);
				if (abs(nz) > 4)
					return s;
				s[i] = '\0';
			}
		if ((pponto = strrchr(s, '.')) == NULL)
			if (nz == 0)
				return s;
			else {
				strcat(s, ".0000");
				pponto = strrchr(s, '.');
			}

		if (nz > 0)
			for (i = 0; i < nz; ++i) {
				*pponto = *(pponto+1);
				*++pponto = '.';
			}

		if (!isdigit(*(pponto-1)) || pponto == s) {
			paux = &s[strlen(s)] + 1;
			while (*paux != '.') {
				*paux = *(paux-1);
				--paux;
			}
			*paux = '0';
			++pponto;
		}

		if (nz < 0) {
			nz = -nz;
			for (i = 0; i < nz; ++i) {
				*pponto = *(pponto-1);
				*--pponto = '.';
				if (!isdigit(*(pponto-1)) || pponto == s) {
					paux = &s[strlen(s)] + 1;
					while (*paux != '.') {
						*paux = *(paux-1);
						--paux;
					}
					*paux = '0';
					++pponto;
				}
			}
		}
					

		i = strlen(s) - 1;

#else
			if (s[i] == 'e')
				 return s;
		--i;
		if (strrchr(s, '.') == (char *) NULL)
			return s;
#endif

		while (s[i] == '0')
			s[i--] = '\0';
	
		if (s[i] == '.')
			s[i] = '\0';
	}
	return s;
}

#if defined (i486) || defined (DJGPP)

    char *gcvt( double d, int n, char *s)

    {
	sprintf(s,"%.*g",n,d);
	return(s);
    }

#endif


