/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Rotina para gravar a proxima observacao.

 Desenvolvido por:

			Oscar Ivan Palma Pacheco
                	Carlos Fernando Assis Paniago		
			Carla Geovana do Nascimento Macrio
			Adriana Delfino dos Santos
			Maria Fernanda Moura

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#ifndef VAXVMS
#include <string.h>
#endif
#include "pcsgbd.h"


/* --------------------------------------------------------------------------
**
** Rotina para gravar a proxima observacao.
**
** Forma de usar:
**
**		nob = grav_obs(parq, obs);
**
** Variaveis envolvidas:
**
**		long	nob;	  Numero da observacao gravada
**		ARQ	*parq;	  Ponteiro de referencia da base de dados
**		char	*obs[];	  Vetor de ponteiros para cada valor
**
** Valor retornado:
**
**		nobs : Numero da observacao
**		  -1 : Nao consegue gravar
**
** ------------------------------------------------------------------------- */
extern int	__tamobs;

long grav_obs(parq, obs)
ARQ	*parq;
char	*obs[];
{
	int	i;
	VAR	*ivar;

	ivar = parq -> pvar;

	__tamobs = (OBSSIZE - (MAXVAR + 1)) * sizeof(char *);
	
	/*
	** Grava variaveis exceto ultima.
	*/

	for (i = 0; i < parq -> nvar -1; i++) {
		minmax(ivar, obs[i]);

		if (ivar->tipo != 'c' && !strcmp(obs[i], "."))
			obs[i][0] = '\0';

		if (gravacampo(parq -> fddat, obs[i], ';') == EOF)
			return -1L;

		++ivar;
	}

	/*
	** Grava ultima variavel.
	*/

	minmax(ivar, obs[i]);

	if (ivar->tipo != 'c' && !strcmp(obs[i], "."))
		obs[i][0] = '\0';

	if (gravacampo(parq -> fddat, obs[i], '\n') == EOF)
		return -1L;

	__tamobs = 0;

	/*
	** Atualizar numero da observacao gravada.
	*/
		

	return (parq -> proxobs++);
}

