/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Redirecionar a saida de um programa gerador de relatorios
    opcionalmente para uma arquivo em disco ou para impressora#

 Desenvolvido por:

		Paulo Henrique G. Cruz Jr.
		Oscar Ivan Palma Pacheco
		Marcos Lordello Chaim
		Carla Geovana do Nascimento Macrio

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/


/*
**------------------------------------------------------------------------
**
**       Redirecionar a saida de um programa gerador de relatorios
**       opcionalmente para uma arquivo em disco ou para impressora#
**
**  Parametros
**
**       Imp_Rel <arquivo saida>    onde :
**
**       arquivo saida : nome do arquivo a ser impresso
**------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#ifdef  MSDOS

# include <io.h>
# define console		"con"

#else

# define console		"/dev/tty"

#endif

void 	main(argc,argv) 
	
	int 	argc;
	char 	*argv[];

{
	FILE	*imp;
	FILE	*arq1;
	FILE *fd;
	char    ch;
	char	opcao;
	char	nome_arq[128];
	char	comando[128];
	long	c;

	++argv;
	--argc;

	/*
	fprintf(stderr, "\n\nCopyright (C) EMBRAPA 1995. ");
	fprintf(stderr, "Todos os direitos reservados.\n\n");
	*/

	if(argc < 1) {
		fprintf(stderr,"\n\nUso : imp_rel [Nome_arquivo]\n\n\n");
		fflush(stdout);
		exit(0);
	}

	if(access(argv[0], 0)) {

		strcpy(nome_arq, getenv("NTIABASES"));

		if( nome_arq == (char *) NULL )  {
			fprintf(stderr,"Arquivo no encontrado.\n");
			exit(2);
		}
		else {
#ifdef MSDOS
			strcat(nome_arq, "\\");
#else
			strcat(nome_arq, "/");
#endif
			strcat(nome_arq, argv[0]);

		}		
	}
	else {
		strcpy(nome_arq, argv[0]);
	}

	if(!(arq1 = fopen(nome_arq,"r"))) {
		fprintf(stderr,"\n\n\nArquivo de entrada inexistente\n\n\n");
		fprintf(stderr,"Arquivo : %s\n\n\n", nome_arq);
		fflush(stdout);
		exit(2);
	}

	fprintf(stderr,"\n\n\nDeseja imprimir o relatorio ? (S/N) : ");

	fd = fopen(console, "r");

	opcao = fgetc(fd);
	if(opcao !='\n')
		while(fgetc(fd) != '\n');

	if(opcao == 'S' || opcao == 's') {

		while(argc) {	
	
#ifdef MSDOS
			imp  = fopen("prn","w");
			if(imp == NULL ) {
				imp  = fopen("lpt1","w");
				if(imp == NULL )  {
					fprintf(stderr,
						"Nao ha impressora dispon!vel");
					fprintf(stderr,
						" ou impressora indefinida.");
					fprintf(stderr,
						"\n\n\n");
				}
			}
	
       		 	while(!feof(arq1)) {
				ch = (char) fgetc(arq1);
				fputc(ch,imp);
			}

			fflush(stdout);
			fclose(imp);
#else
			strcpy(comando, "lpr ");
			strcat(comando, nome_arq);

			if (system(comando))
				fprintf(stderr, "Advertencia: SYSTEM.\n");
#endif

			fprintf(stderr,
				"\n\nArquivo impresso ==>> %s\n\n", nome_arq);

#ifdef  MSDOS
			strcpy(comando, "del ");
#else
			strcpy(comando, "rm ");
#endif

			strcat(comando, nome_arq);
			system(comando);

			++argv;
			--argc;
		}
	} 

	else
		{
		fprintf(stderr,"\n\nArquivo gerado ==>> %s\n\n", nome_arq);
		fprintf(stderr,"\nTecle <ENTER> para continuar ...");
		fgetc(fd);
		}

	fclose(fd);
	fclose(arq1);

	exit(0);
}
