/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Rotina para ler a proxima observacao.

 Desenvolvido por:

			Oscar Ivan Palma Pacheco
                	Carlos Fernando Assis Paniago		
			Adriana Delfino dos Santos
			Carla Geovana do Nascimento Macrio

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#ifndef VAXVMS
#include <string.h>
#endif
#include "pcsgbd.h"



/* --------------------------------------------------------------------------
**
** Rotina para ler a proxima observacao.
**
** Forma de usar:
**
**		nob = ler_obs(parq, obs);
**
** Variaveis envolvidas:
**
**		long	nob;	  	Numero da observacao lida
**		ARQ	*parq;	  	Ponteiro de referencia da base de dados
**		char	*obs[OBSSIZE];	Vetor de ponteiros para cada valor
**
** Valor retornado:
**
**		nobs : Numero da observacao
**		  -1 : Fim de arquivo
**
** ------------------------------------------------------------------------- */

int	__tamobs = 0;

long ler_obs(parq, obs)
ARQ	*parq;
char	*obs[];
{
	int	i, ch;
	char	*obser;
	VAR	*ivar;

	/*
	** Ler observacao.
	*/

	obser = (char *) &obs[MAXVAR];
	obs[0] = (char *) NULL;
	ivar = parq -> pvar;

	__tamobs = (OBSSIZE - (MAXVAR + 1)) * sizeof(char *);

	for (i = 0; i < parq -> nvar; ++i) {

		obs[i] = obser;

		if((ch = lercampo(parq -> fddat, obser)) == EOF) {
			if (i != 0)

/* *** Padroniz. msg erro - Adriana 30/11/94 
				fprintf(stderr,"\nObservacao %ld incompleta.\n",
					parq -> proxobs + 1);
*** */

				fprintf(stderr, PegaMsg (1052),
					parq -> proxobs + 1, -2 ); /* fim de arquivo inesperado */
			return -1L;
		}

		if (ch == '\n' && i < parq -> nvar - 1) {

/* *** Padroniz. msg erro - Adriana 30/11/94 
			fprintf(stderr, "\nObservacao %ld incompleta.\n",
				parq -> proxobs + 1);
*** */

				fprintf(stderr, PegaMsg (1052),
				parq -> proxobs + 1, -1); /* nro. imcompleto de campos */
			return -1L;
		}

		if (ivar -> tipo != 'c') {
			if (!strlen(obser)) {
				*obser = '.';
				*(obser+1) = '\0';
			}
		}

		obser += (strlen(obser) + 1);
		++ivar;
	}

	obs[i] = (char *) NULL;

	__tamobs = 0;

	/*
	** Atualizar numero da observacao lida.
	*/
	
	return (parq -> proxobs++);

}

