/***********************************************************************************
 LIBSOC - Biblioteca padro para o SOftware Cientfico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob 
 os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free 
 Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio) 
 qualquer verso posterior.

 Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA 
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA 
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais 
 detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com 
 esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no 
 endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA. 

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Testa dois numeros, em relacao a uma precisao

 Desenvolvido por:

			Oscar Ivan Palma Pacheco
                	Snia Ternes
			Maria Fernanda Moura

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <math.h>
#include "pcsgbd.h"


/* ----------------------------------------------------------------------------
**
** Funcao: lfuzz							 
** 	   Testa dois numeros, em relacao a uma precisao         
**	   exemplo:						 
**		a = 1.000000000001;				 
**		b = 1.000000000002; 				 
**		ltoler = 1.e-12;				
**		a seria considerado igual a b		
**						
**		retorno: 1. se  a > b	
**			-1. se  a < b
**			 0. se  a = b
**
** Forma de usar:
**
**		int lfuzz(f1, f2)
**		double	f1, f2;
**
** ----------------------------------------------------------------------------
*/

static double _ltoler_ = 1.e-12;

void setlfuzz(val)
double val;
{
	_ltoler_ = val;
}

lfuzz(d1,d2) 
double d1, d2;
{
	double f1, f2;
	
	f1 = d1;

	if (f1 < 0.)
		f1 = -f1;

	f2 = d2;

	if (f2 < 0.)
		f2 = -f2;

	if (f2 > f1)
		f1 = f2;

	if(fabs(f1) >= 1.0) 
		f1 *= _ltoler_;
	else
		f1 =  _ltoler_;

	if (d1 > d2) {
		if ((d2+f1) >= d1)
			return(0);
		return(1);
	}

	if ((d1+f1) >= d2)
		return(0);

	return(-1);
}	
