/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Funcao para preparar passagem de arquivo aberto como entrada ou 
    ou saida padrao.

 Desenvolvido por:

			Oscar Ivan Palma Pacheco


 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>

#ifdef MSDOS
# include <stdlib.h>
# include <io.h>
#endif

#ifdef SUN
# include <stdlib.h>
#endif

#include "pcsgbd.h"


/*--------------------------------------------------------------------
** 
**
**
**  Funcao para preparar passagem de arquivo aberto como entrada ou 
**  ou saida padrao.
**
**  Forma geral:
**
**	mudastd(arquivo, modo);
**	char *arquivo;
**	char *modo;
**
**	onde modo e' uma das seguintes alternativas:
**		"r" : para redirecionar o stdin
**		"w" : para redirecionar o stdout criando arquivo
**		"a" : para redirecionar o stdout incrementando arquivo
**
**--------------------------------------------------------------------
*/

static int inmuda = 0;
static int outmuda = 0;
static int fdi;
static int fdo;

void mudastd(arquivo, modo)
char *arquivo;
char *modo;
{
	if (*modo == 'r') {
		if (inmuda) {

/* *** Padroniz. msg erro - Adriana 30/11/94 
			fprintf(stderr, "Erro: stdin nao restaurado.\n");
*** */
			fprintf(stderr, PegaMsg (5026), "stdin");
			exit(10);
		}
		fdi = dobrastd(arquivo, modo, stdin);
		inmuda = 1;
	}
	else
		if (*modo == 'w' || *modo == 'a') {
			if (outmuda) {

/* *** Padroniz. msg erro - Adriana 30/11/94 
				fprintf(stderr, 
					"Erro: stdout nao restaurado.\n");
*** */
				fprintf(stderr, PegaMsg (5026), "stdout");
				exit(11);
			}
			fdo = dobrastd(arquivo, modo, stdout);
			outmuda = 1;
		}
		else {

/* *** Padroniz. msg erro - Adriana 30/11/94 
			fprintf(stderr, "Modo invalido.\n");
*** */
			fprintf(stderr, PegaMsg (5027) );
			exit(12);
		}
}


/*--------------------------------------------------------------------
**
**  Funcao para restaurar a entrada e saida padrao.
**
**  Forma geral:
**
**	reststd();
**
**--------------------------------------------------------------------
*/

void reststd()
{

	if (inmuda) {
		if (dup2(fdi, fileno(stdin)))
#ifdef MSDOS
			freopen("con", "r", stdin);
#else
#ifdef VAXVMS
			freopen("SYS$INPUT", "r", stdin);
#else
			freopen("/dev/tty", "r", stdin);
#endif
#endif
		close(fdi);
		inmuda = 0;
	}

	if (outmuda) {
		if (dup2(fdo, fileno(stdout)))
#ifdef MSDOS
			freopen("con", "w", stdout);
#else
#ifdef VAXVMS
			freopen("SYS$OUTPUT", "w", stdout);
#else
			freopen("/dev/tty", "w", stdout);
#endif
#endif
		close(fdo);
		outmuda = 0;
	}
}

