/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Definicoes para a utilizacao das funcoes da lib.

 Desenvolvido por:

        	Oscar Ivan Palma Pacheco
		Marcos Lordello Chaim
		Adriana Delfino dos Santos
		Carla Geovana do Nascimento Macrio

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
/*
** ----------------------------------------------------------------------------
**
**	Definicoes para a utilizacao das funcoes da lib.
**
** ----------------------------------------------------------------------------
*/

#ifndef _pcsgbd_h_

#define _pcsgbd_h_

#define TAMSTR			128

#ifdef SYSTEMV
# define ALTIPO			void *
# define PATIPO			size_t
#else
# define ALTIPO			char *
# define PATIPO			unsigned
#endif

#ifdef MSDOS
# define	TAMFILEBUF	10240
#define		MAXTOBS		8192
#else
# ifdef EDIX
#  define	TAMFILEBUF	10240
#define		MAXTOBS		8192
# else
#  define	TAMFILEBUF	65000
#define		MAXTOBS		24576
# endif
#endif

#define		MAXVAR		512
#define		MINVAL		union MINS
#define		MAXVAL		union MAXS
#define		OBSSIZE		(MAXVAR + (MAXTOBS / sizeof (char *)) + 1)
#define		NOVO_MAXSTR	(MAXTOBS - (2 * MAXVAR) - 1)

#ifdef VAXVMS
# define	exit		exitvax
# define	unlink		delete
#endif

#ifdef MSDOS
# define	MININT		(-32768)
# define	MAX_INT		(32767)
# define	MINREAL		(-1.0e306)
# define	MAXREAL		(1.0e306)
#else

# ifdef VAXVMS
#  define	MININT		(-2147483647)
#  define	MAX_INT		(2147483647)
#  define	MINREAL		(-1.7e38)
#  define	MAXREAL		(1.7e38)
# else
# ifdef SUN
   /***							***/	
   /***#  define	MININT		(-2147483647-1)	***/	
   /***#  define	MAX_INT		(2147483647)	***/
   /***							***/	
#  define	MININT		(-2147483647-1)	/* min value of an "int" */
#  define	MAX_INT		2147483647	/* max value of an "int" */

# else
#  define	MININT		(-2147483648)
#  define	MAX_INT		(2147483647)

# endif
  /***							***/	
  /***#  define	MINREAL		(-1.7e38)	***/
  /***#  define	MAXREAL		(1.7e38)	***/
  /***							***/	
# define	MINREAL		-1.0e+306
# define	MAXREAL		1.0e+306
# endif

#endif


#ifdef MSDOS
# define	MISSING		1.0e306
#else
/****# define	MISSING		1.7e38   ****/
# define	MISSING		1.0e306
#endif

#define		To_Lower(x)	(isupper(x)?tolower(x):x)
#define		To_Upper(x)	(islower(x)?toupper(x):x)



#define TAM_MSG		154

/*-------------------------------------------------------------------------*/
/* Formato do cabecalho registro do arquivo de mensagens de erro.	   */
/* No arquivo de mensagens de erro o 1o. registro contem os indices de     */
/* onde comecam cada bloco de mensagem: Usuario, Sintaxe e Interna.        */
/*-------------------------------------------------------------------------*/

typedef struct tagCABEC
	{
	  int	ap_usuario;   /* apontador logico p/ msg do usuario */
	  int	ap_sintaxe;   /* apontador logico p/ msg de sintaxe */
	  int	ap_interno;   /* apontador logico p/ msg interna    */

	} CABEC;

/*-------------------------------------------------------------------------*/
/* Formato do registro do arquivo de mensagens de erro			   */
/*-------------------------------------------------------------------------*/

typedef union tagDADOS
	{
	  char	mensagem [TAM_MSG];    /* mensagem de erro     */
	  CABEC cabec;		       /* cabecalho do arquivo */
	} TIPO_DADOS;


typedef enum
	 { 

	  TR_CABEC,
	  TR_MENSAGEM

	} TIPO_REG;


typedef struct tagREG_MSG
	{
	  TIPO_REG	tipo;   /* tipo do registro: cabecalho ou mensagem */
	  TIPO_DADOS	dados;  /* dados do registro de acordo com o tipo */
	} REG_MSG;





union	MINS	{
	double	valor;
	int	len;
};

union	MAXS	{
	double	valor;
	int	len;
};

struct	VARS	{	
	char	nome[9];
	char	tipo;
	MINVAL	mmin;
	MAXVAL	mmax;
};

typedef	struct	VARS	VAR;

struct	ARQS	{
	FILE		*fddat;	
	FILE		*fdhdr;
	int		nvar;
	struct	VARS	*pvar;
	char		novo;
	char		nome[128];
	long		proxobs;
};

typedef	struct	ARQS	ARQ;

#define		TIPOARQ		1

/*
** Definicoes para uso de access() no MSDOS.
*/

#ifdef MSDOS

# define F_OK		0
# define W_OK		2
# define R_OK		4

#endif

#ifdef MSDOS
 ARQ	*abre_arq(char *,int,int);
 ARQ	*abre_arq_ponteiro (char *,int);
 double	 ALGama(double);
 int	 apaga_arq(char *);
 double	 atod(char *);
 int	 atualarq(ARQ *, char *);
 double	 BetaInv(double, double, double, int, int, int *, double *, int *);
 double	 CDBeta(double, double, double, int, int, double *, int *, int *);
 int	 copia_arq(char *, char *);
 ARQ	*cria_arq(char *);
 long	 Curr_OffSet(ARQ *);
 int	 def_var(ARQ *, char *, char);
 void	 delOSstdin(void);
 int	 dobrastd(char *, char *, FILE *);
 char	*dtoa(double, char *);
 void	 embrapa(int);
 double  Erf(double);
 int	 fech_arq(ARQ *);
 int	 fech_vazio(ARQ *);
 double	 finv(double, double, double);
 double	 fprob(double, double, double);
 char	*ftoa(double, int, char *);
 double	 GammaIn(double, double, int, int, double *, int *, int *);
 int	 GetNext(FILE *);
 int	 getoken(char *);
 long	 getOSstdin(void);
 long	 grav_obs(ARQ *, char **);
 int	 gravacampo(FILE *, char *, char);
 int	 gtoken1(char *, FILE *);
 int	 isWinTerm(char *);
 int	 isemptyxgetc(FILE *); 	
 char	**LeMensagens(char *);
 int	 ler0campo(FILE *, char *);
 long	 ler0obs(FILE *, VAR *, int, long, char **);
 long	 ler_obs(ARQ *, char **);
 int	 lercampo(FILE *, char *);
 int	 lfuzz(double, double);
 void	 minmax(VAR *, char *);
 void	 mudastd(char *, char *);
 double	 ninv(double);
 double	 nprob(double);
 int	 ntia_sleep(unsigned);
 void	 PathGetDir(char *, char *);
 void	 PathGetEnv(void);
 void	 PathGetNextName(char *);
 char 	*pega_env(char *, char *);
 int	 pega_var(ARQ *, int , char *, char *, union MINS *, union MAXS *);
 char   *PegaMsg (int);
 int	 PutNext(int, FILE *);
void	 qsort (void *, size_t, size_t, int(*)());
 char	*remblk(char *);
 int	 rename_arq(char *, char *);
 int	 Reset_Buff(FILE *);
 void	 reststd(void);
 char	*reverse(char *);
 void	 retOSstdin(void);
 int	 rew_arq(ARQ *);
 char	*rounddec(double, int, int);
 int	 sel_vars(ARQ *, char **, int *);
 void	 Set_Buff(FILE *, unsigned);
 int	 Set_OffSet(ARQ *, long);
 void	 setOSstdin(void);
 void	 setlfuzz(double);
 double	 tinv(double, double);
 int	 ToNextObs(ARQ *);
 int	 ToPrevObs(ARQ *);
 double	 tprob(double, double);
 int	 UnGetNext(int, FILE *);
 int	 unxgetc(int, FILE *);
 int	 veri_var(ARQ *, char *);
 char	*vrArqPath(char *, char *, char *);
 int	 xgetc(FILE *);
 double	 xinv(double, double);
 double	 xprob(double, double);
 int	 nao_dgt(char *);
 void	 set_video(void);
#else
 ARQ	*abre_arq();
 ARQ	*abre_arq_ponteiro();
 double	 ALGama();
 int	 apaga_arq();
 double	 atod();
 int	 atualarq();
 double	 BetaInv();
 double	 CDBeta();
 int	 copia_arq();
 ARQ	*cria_arq();
 long	 Curr_OffSet();
 int	 def_var();
 int	 dobrastd();
 char	*dtoa();
 int	 dup2();
 void	 embrapa();
 double  Erf();
 int	 execfil();
 void	 exitvax();
 int	 fech_arq();
 int	 fech_vazio();
 double	 finv();
 double	 fprob();
 char	*ftoa();
 double	 GammaIn();
 int	 GetNext();
 int	 getoken();
 long	 grav_obs();
 int	 gravacampo();
 int	 gtoken1();
 int	 isWinTerm();
 int	 isemptyxgetc(); 	
 char	**LeMensagens();
 char	*itoa();
 long	 ler_obs();
 int	 ler0campo();
 long	 ler0obs();
 int	 lercampo();
 int	 lfuzz();
 char	*ltoa();
 void	 minmax();
 void	 mudastd();
 double	 ninv();
 double	 nprob();
 int	 ntia_sleep();
 void	 PathGetDir();
 void	 PathGetEnv();
 void	 PathGetNextName();
 char 	*pega_env();
 int	 pega_var();
 int	 prepvax();
 char   *PegaMsg ();
 int	 PutNext();
void	 qsort ();
 char	*remblk();
 int	 rename_arq();
 int	 Reset_Buff();
 void	 reststd();
 char	*reverse();
 void	 retOSstdin();
 int	 rew_arq();
 char	*rounddec();
 int	 sel_vars();
 void	 Set_Buff();
 int	 Set_OffSet();
 void	 setlfuzz();
 int	 spawnlp();
 int	 strcmpi();
 double	 tinv();
 int	 ToNextObs();
 int	 ToPrevObs();
 double	 tprob();
 int	 UnGetNext();
 int	 unxgetc();
 int	 veri_var();
 char	*vrArqPath();
 int	 xgetc();
 double	 xinv();
 double	 xprob();
 int	 nao_dgt();
 void	 set_video();
#endif

#endif

