/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Implementacao do QuickSort.

 Desenvolvido por:

		Oscar Ivan Palma Pacheco

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <string.h>


/* ----------------------------------------------------------------------------
**
** Implementacao do QuickSort.
**
** ----------------------------------------------------------------------------
*/

#ifdef MSDOS
extern int DefComp(char **, char **);
extern void swap(char *, char *);
static void rtqsort(char *, char *);
#else
extern int DefComp();
extern void swap();
static void rtqsort();
#endif

typedef	int (*CompFunc)();

static	CompFunc	CompF;
static	int		Width;


int DefComp(s1, s2)
char **s1;
char **s2;
{
	return (strcmp(*s1, *s2));
}

void qsort(base, tam, width, compara)
void	*base;
size_t	tam;
size_t	width;
int	(*compara)();
{
	Width = width;

	CompF = (compara == (CompFunc) NULL) ? DefComp : compara;

	if(tam > 1)
		rtqsort((char *) base, (char *) base + ((tam - 1) * width));
}

void swap(c1, c2)
char *c1;
char *c2;
{
	char	tmp;

	tmp = *c2;
	*c2 = *c1;
	*c1 = tmp;
}

static void rtqsort(low, high)
register char *low;
register char *high;
{
	char		*pivot;
	char		*base;
	static char	*ind1;
	static char	*ind2;
	static int	i;

	/*
	** Determinar a particao.
	*/

	base = low;
	pivot = high;
	high -= Width;

	do {
		while (low < high && (*CompF)(low, pivot) <= 0)
			low += Width;

		while(low < high && (*CompF)(high, pivot) >= 0)
			high -= Width;

		if(low < high) {
			for (ind1 = high, ind2 = low, i = Width; i > 0; --i)
				swap(ind1++, ind2++);
		}
	} while (low < high);

	/*
	** Inverter se necessario.
	*/

	if (low < pivot && (*CompF)(low, pivot) > 0)
		for (ind2 = low, ind1 = pivot, i = Width; i > 0; --i)
			swap(ind1++, ind2++);

	low += Width;

	if (high-base < pivot-low) {
		if (low < pivot)
			rtqsort(low, pivot);

		if (base < high)
			rtqsort(base, high);
	}
	else {
		if (base < high)
			rtqsort(base, high);

		if (low < pivot)
			rtqsort(low, pivot);
	}
}

