/***********************************************************************************
LIBSOC - Biblioteca padro para o SOftware Cientfico

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 ***********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Tinv -- Calcula a inversa da distribuio t de Student
 

 Desenvolvido por:

		Dalton Francisco Andrade
		Maria Fernanda Moura
		Oscar Ivan Palma Pacheco
		Slvio Roberto Medeiros Evangelista
            Snia Ternes


 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <math.h>
#include "const.h"
#include "pcsgbd.h"


/*----------------------------------------------------------------*/
/*                 Tinv -- Inverse Central t Distribution         */
/*----------------------------------------------------------------*/
/*                                                                */
/*       Function:  tinv                                          */
/*                                                                */
/*       Purpose:   Calculates central inverse t                  */
/*                                                                */
/*       Calling Sequence:                                        */
/*                                                                */
/*            tval   := tinv( Alpha, Df : REAL ) : REAL;          */
/*                                                                */
/*                 Alpha  --- Probability value                   */
/*                 Df     --- Degrees of freedom                  */
/*                                                                */
/*                 tval   --- returned t-value corresponding      */
/*				to 'Alpha'.    			  */
/*                                                                */
/*       Calls:                                                   */
/*                                                                */
/*            BetaInv (Inverse Beta Distribution)                 */
/*                                                                */
/*       Remarks:                                                 */
/*                                                                */
/*            Any error results in '-1.0' as returned t value.    */
/* Data da ultima alteracao:					  */
/*					  	  		  */
/* -------------------------------------------------------------- */

double tinv( Alpha,Df ) 
double Alpha;
double Df;
{
	int MaxIter = 100;
	int Dprec   = 10;

	double tin;
	int Iter; 
	double Cprec;
	int Ierr;

	/* Inicio tinv */

	if ( Alpha == 0.5 )		return(0.0);

	if ( Df >= 120.0 ) 
		Df = 120.0;
	else {
		if ( Df <= 0.00001 ) 
			Df = 0.00001;
	}

	if ( Alpha <= 0.00001 ) {
		Alpha = 0.00001;
	}
	else {
		if ( Alpha >= .99999 ) 
			Alpha = 0.99999;
	}

	tin   = -1.0;

	if( Df > 0.0 ) {
		if( ( Alpha >= 0.0 ) && ( Alpha <= 1.0 ) ) {
			if (Alpha == 0.5) 
				tin = 0.0;
			else {
				if (Alpha < 0.5) 
					tin = BetaInv( 1.0 - 2.0*Alpha,
						 0.5, Df / 2.0, MaxIter, Dprec,
					         &Iter,&Cprec,&Ierr );
				else
					tin = BetaInv( 2.0*Alpha - 1.0, 
						 0.5, Df / 2.0, MaxIter, Dprec,
					         &Iter,&Cprec,&Ierr );
				if( (tin >= 0.0) && (tin < 1.0) && (Ierr== 0)) 
					tin = sqrt( tin * Df / ( 1.0 - tin ) );
			}
            		if (Alpha > 0.5) 
				  tin = -1.0 * tin;

		}

	}
	return(tin);

} /* Fim tinv */

