
/* ----------------------------------------------------------------------------
** @(#)anova.h	3.2	(NTIA/modlin)	95/11/10
**
** 
**
** Data da ultima alteracao:
**
**		95/11/10 14:57:48
**
** ----------------------------------------------------------------------------
*/


#ifndef EXTERN
# define	EXTERN	extern
#endif
#if defined(MSDOS) & !defined(DJGPP)
# define MY_HUGE	huge
# define TIPO		long
# define HALLOC		halloc
# define HFREE		hfree
# define TINT		unsigned
#else
# define MY_HUGE
# define TIPO		unsigned
# define HALLOC		calloc
# define HFREE		free
# define TINT		int
#endif

#include <stdio.h>
#include <math.h>

#define MAXBY		8
#define MAXDEP		8

#if defined(MSDOS) & !defined(DJGPP) 
# define MAXMEM		300
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	100
#endif

#ifdef EDIX 
# define MAXMEM		600
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	200
#endif

#ifdef ULTRIX
# define MAXMEM		2300
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	300
#endif

#if defined(SUN) | defined(DJGPP)
# define MAXMEM		3000
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	300
#endif

#ifdef VAXVMS
# define MAXMEM		2300
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	300
#endif

EXTERN FILE		*fp;		/* apontador para o arquivo de dados */
EXTERN int		nf;		/* numero de fatores */
EXTERN int		nd;		/* numero variaveis dependentes (Y) */
EXTERN int		nxlx;		/* dimensao da matriz x'x */
EXTERN int		ndim;		/* dimensao da matriz z'z */
EXTERN int		nef;		/* numero de efeitos */
EXTERN int		ntotal;		/* numero de efeitos total */
EXTERN int		glr;		/* graus de liberdade do residuo */
EXTERN int		glt;		/* graus de liberdade do total */
EXTERN double		qmr;		/* quadrado medio do erro */
EXTERN int		ef[MAXEFTS][5];	/* par de efeitos */
EXTERN int		nv[MAXMEM1];	/* numero de niveis */
EXTERN int		sv[MAXMEM1];	/* soma dos niveis */
EXTERN int		v[MAXMEM1];	/* */
EXTERN double		obs[MAXMEM];	/* valores das observacoes */
EXTERN double		saida[MAXMEM];  /* saida de cada observacao */
EXTERN double		css[MAXMEM];	/* corrected sum of squares */
EXTERN double		mean[MAXMEM];	/* media das observacoes */
EXTERN double		sse[MAXMEM];	/* sum squares of error */
EXTERN double MY_HUGE	*xlx;		/* matriz z'z */
EXTERN char		area[1024];	/* area para quardar strings */
EXTERN char		titulo[128];	/* titulo geral do programa */
EXTERN char		*efts[MAXEFTS];
					/* apontador para area, onde ficam
					   os nomes dos efeitos */
EXTERN int		linhazerada[MAXMEM1];
					/* vetor que indica a linha zerada */
EXTERN int		nmedias;        /* numero de medias */
EXTERN int		med[MAXEFTS][3]; /* medias pedidas */
EXTERN char		*nomemed[MAXEFTS];
EXTERN double		*com_med[MAXDEP];
EXTERN int		*com_nv[MAXDEP];
					/* apontador para a area onde ficam
						os nomes das medias */
extern char		*p;		/* ponteiro para a area nao usada */

extern int		pflag;		/* impressao de leitura */
extern int		xflag;		/* impressao de x'x */
extern int		lflag;		/* impressao de dados originais */
extern int		rflag;		/* impressao de passos de calculo */
extern int		bflag;		/* imprimir beta */


#ifdef MSDOS
 extern void	grav_mat(void);
 extern void	grav_esp(void);
 extern void	grav_efe(void);
 extern void	grav_efts(void);
 extern void	erromult(int);
 extern void    advert(char *);
 extern void	ajustasvhi(void);
 extern void	aloca_xlx(void);
 extern void	cab_comp(double, int, int, int, double, double);
 extern int	ccomp(char *, char *);
 extern int	class(void);
 extern void	com_mul(int, int, double, int, int, double);
 extern int	compara(char **, char **);
 extern int	compare(const void *, const void *);
 extern void	concat(int, char *, int);
 extern int	contraste(int, FILE *, char *);
 extern void	cri_c_comb(int *, int, int, double);
 extern void	cria_xlx(void);
 extern double	cxlxcl(void);
 extern int	des_est(char *);
 extern void	des_qme(int, double *, double *);
 extern double	doolitle(double *, int );
 extern double	duncan(double, int, double);
 extern char	*elemento(char *, int);
 extern void	erro(int);
 extern void	errocon(int, int);
 extern void	erromod(int);
 extern void	escrevelst(void);
 extern void	exe_cp(char *, int, double, double, int, int, int, char *,
			int, int);
 extern void	executa(void);
 extern void	expand_mat(void);
 extern int	expande(int);
 extern void	fill_nome(int, int *, int);
 extern void	gera_c(double *, int, int, int *, int *, double *, char *);
 extern void	gera_d(double *, int, int, int *, int *, double *, double *,
			char *, int, int);
 extern int	gera(double *, int, char *);
 extern int	gera1(double *, int, char *, int, char *);
 extern void	getarg(int, char **);
 extern int	getbit(int, int, int);
 extern void	grava_par(void);
 extern void	gs(double *, double *, double *, int, int);
 extern void	hierarquicos(void);
 extern TINT	idx(int, int);
 extern TINT	idy(int, int);
 extern void	implstnv(void);
 extern int	impmedia(int, FILE *);
 extern void	impme(char *, char *, double, double);
 extern void	imprimel(void);
 extern void	imptitulo(char *);
 extern void	inicializa(void);
 extern void	inicioby(void);
 extern void	ini_niveis(void);
 extern int	leia_c(double *, int, char *, int *);
 extern int	lerumaobs(void);
 extern void	ler_par(int *);
 extern void	libera(void);
 extern void	media1(int);
 extern void	media2(int, int, double, double );
 extern int	missing(int, int);
 extern int	modelo(void);
 extern void	modelo1(void);
 extern void	modelo2(long);
 extern void	monta_c_efeitop(int, int, int);
 extern double	mqi(double, double, double);
 extern void	nao_acumular(void);
 extern int	num_medias(int);
 extern int	numero(char *);
 extern void	ordena(int, int, int *, double *, int *);
 extern void	ordenalista(void);
 extern void	p_cmp(int, FILE *);
 extern int	par_c(int *, char *, FILE *, int, int *);
 extern int	par_cp(int *, char *, FILE *, int *, int *, int *);
 extern void	par_hier(char *, char *, int);
 extern int	par_m(int *, char *, FILE *);
 extern void	par_rot(int *, char *, char *, FILE *);
 extern void	pegalista(void);
 extern void	peg_elemento(char *, char *, int *);
 extern void	pivota(void);
 extern void	poe_forma(char *, char *);
 extern void	printanv(int);
 extern void	printbeta(int);
 extern void	printcov(int);
 extern void	print_par(void);
 extern void	print_xlx(void);
 extern void	putchar1(void);
 extern void	recupera_par(void);
 extern double	rqi(int, double, int, int, double);
 extern int	sao_iguais(char *, char *, int);
 extern int	substr(char *, char *);
 extern void	sweep(int);
 extern double	tabela(double, int, double);
 extern char	*tira_mais(char *);
 extern void	troca(int);
 extern void	usage(void);
 extern void	var_verifica(int, int *);
 extern int	var_tipo(int);
 extern void	var1_verifica(int, char *);
 extern int	ver_ef_cp(char *, char *, char *, int *);
 extern void	ver_xlx(void);
 extern int	ver1(int);
 extern void	ver1_xlx(void);
 extern int	ver2(int);
 extern int	veri_fica(int);
 extern void	verifica(void);
 extern int	verpo0(char *, char *, int, int);
 extern int	verpo1(char *, char *, int, int);
 extern void	vol_niveis(void);
 extern char	*word_k(char *, int, char *, int *);
 extern void	zera_linha(int);
#else
 extern void	grav_mat();
 extern void	grav_esp();
 extern void	grav_efe();
 extern void	grav_efts();
 extern void	erromult();
 extern void	advert();
 extern void	ajustasvhi();
 extern void	aloca_xlx();
 extern void	cab_comp();
 extern int	ccomp();
 extern int	class();
 extern void	com_mul();
 extern int	compara();
 extern int	compare();
 extern void	concat();
 extern int	contraste();
 extern void	cri_c_comb();
 extern void	errocon();
 extern void	cria_xlx();
 extern double	cxlxcl();
 extern int	des_est();
 extern void	des_qme();
 extern double	doolitle();
 extern double	duncan();
 extern char	*elemento();
 extern void	erro();
 extern void	erromod();
 extern void	escrevelst();
 extern void	exe_cp();
 extern void	executa();
 extern void	expand_mat();
 extern int	expande();
 extern void	fill_nome();
 extern void	gera_c();
 extern void	gera_d();
 extern int	gera();
 extern int	gera1();
 extern void	getarg();
 extern int	getbit();
 extern void	grava_par();
 extern void	gs();
 extern void	hierarquicos();
 extern TINT	idx();
 extern TINT	idy();
 extern void	implstnv();
 extern int	impmedia();
 extern void	impme();
 extern void	imprimel();
 extern void	imptitulo();
 extern void	inicializa();
 extern void	inicioby();
 extern void	ini_niveis();
 extern int	leia_c();
 extern int	lerumaobs();
 extern void	ler_par();
 extern void	libera();
 extern void	media1();
 extern void	media2();
 extern int	missing();
 extern int	modelo();
 extern void	modelo1();
 extern void	modelo2();
 extern void	monta_c_efeitop();
 extern double	mqi();
 extern void	nao_acumular();
 extern int	num_medias();
 extern int	numero();
 extern void	ordena();
 extern void	ordenalista();
 extern void	p_cmp();
 extern int	par_c();
 extern int	par_cp();
 extern void	par_hier();
 extern int	par_m();
 extern void	par_rot();
 extern void	peg_elemento();
 extern void	pegalista();
 extern void	pivota();
 extern void	poe_forma();
 extern void	printanv();
 extern void	printbeta();
 extern void	printcov();
 extern void	print_par();
 extern void	print_xlx();
 extern void	putchar1();
 extern void	recupera_par();
 extern double	rqi();
 extern int	sao_iguais();
 extern int	substr();
 extern void	sweep();
 extern double	tabela();
 extern char	*tira_mais();
 extern void	troca();
 extern void	usage();
 extern void	var_verifica();
 extern int	var_tipo();
 extern void	var1_verifica();
 extern int	ver_ef_cp();
 extern void	ver_xlx();
 extern int	ver1();
 extern void	ver1_xlx();
 extern int	ver2();
 extern int	veri_fica();
 extern void	verifica();
 extern int	verpo0();
 extern int	verpo1();
 extern void	vol_niveis();
 extern char	*word_k();
 extern void	zera_linha();
#endif

