/* ----------------------------------------------------------------------------
**
** %W%	%Y%	%E%
**
** %Q%
**
** ----------------------------------------------------------------------------
*/

#ifndef EXTERN
# define	EXTERN	extern
#endif
#ifdef MSDOS
# define MY_HUGE	huge
# define TIPO		long
# define HALLOC		halloc
# define HFREE		hfree
# define TINT		unsigned
#else
# define MY_HUGE
# define TIPO		unsigned
# define HALLOC		calloc
# define HFREE		free
# define TINT		int
#endif

#include <stdio.h>
#include <math.h>

#define MAXBY		1

#ifdef MSDOS 
# define MAXMEM		300
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	100
#endif

#ifdef EDIX 
# define MAXMEM		300
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	100
#endif

#ifdef ULTRIX
# define MAXMEM		1500
# define MAXMEM1	MAXMEM-1
# define MAXEFTS	500
#endif

EXTERN FILE		*fp;		/* apontador para o arquivo de dados */
EXTERN int		nf;		/* numero de fatores */
EXTERN int		nd;		/* numero variaveis dependentes (Y) */
EXTERN int		nxlx;		/* dimensao da matriz x'x */
EXTERN int		ndim;		/* dimensao da matriz z'z */
EXTERN int		nef;		/* numero de efeitos */
EXTERN int		ntotal;		/* numero de efeitos total */
EXTERN int		glr;		/* graus de liberdade do residuo */
EXTERN int		glt;		/* graus de liberdade do total */
EXTERN double		qmr;		/* quadrado medio do erro */
EXTERN int		ef[MAXEFTS][4];	/* par de efeitos */
EXTERN int		nv[MAXMEM1];	/* numero de niveis */
EXTERN int		sv[MAXMEM1];	/* soma dos niveis */
EXTERN int		v[MAXMEM1];	/* */
EXTERN double		obs[MAXMEM];	/* valores das observacoes */
EXTERN double		saida[MAXMEM];  /* saida de cada observacao */
EXTERN double		css[MAXMEM];	/* corrected sum of squares */
EXTERN double		mean[MAXMEM];	/* media das observacoes */
EXTERN double		sse[5*MAXMEM];	/* sum squares of error */
EXTERN double MY_HUGE	*xlx;		/* matriz z'z */
EXTERN char		area[512];	/* area para quardar strings */
EXTERN char		titulo[128];	/* titulo geral do programa */
EXTERN char		*efts[MAXEFTS];
					/* apontador para area, onde ficam
					   os nomes dos efeitos */
EXTERN int		linhazerada[MAXMEM1];
					/* vetor que indica a linha zerada */
EXTERN int		nmedias;        /* numero de medias */
EXTERN int		med[MAXEFTS][3]; /* medias pedidas */
EXTERN char		*nomemed[MAXEFTS];
					/* apontador para a area onde ficam
						os nomes das medias */
extern char		*p;		/* ponteiro para a area nao usada */

extern int		pflag;		/* impressao de leitura */
extern int		xflag;		/* impressao de x'x */
extern int		lflag;		/* impressao de dados originais */
extern int		rflag;		/* impressao de passos de calculo */
extern int		bflag;		/* imprimir beta */


#ifdef MSDOS
 extern int	compara(char * *,char * *);
 extern int	compare(int *,int *);
 extern int	contraste(int);
 extern void	errocon(int, int);
 extern void	cria_xlx(void);
 extern double	cxlxcl(void);
 extern double	doolitle(double *,int );
 extern void	erro(int );
 extern void	erromod(int );
 extern void	escrevelst(void);
 extern void	expand_mat(void);
 extern int	expande(int );
 extern double	fprob(double ,int ,int );
 extern void	getarg(int ,char * *);
 extern TINT	idx(int ,int );
 extern TINT	idy(int ,int );
 extern void	implstnv(void);
 extern int	impmedia(int);
 extern void	impmed(int ,int ,char *,double ,double );
 extern void	imprimel(void);
 extern int	lerumaobs(void);
 extern void	ler_par(void);
 extern void	media2(int ,int ,double ,double ,char *);
 extern int	missing(void);
 extern int	modelo(void);
 extern void	modelo1(void);
 extern void	modelo2(void);
 extern void	ordenalista(void);
 extern void	pegalista(void);
 extern void	pivota(void);
 extern void	printanv(void);
 extern void	printbeta(int);
 extern void	printcov(int);
 extern void	print_par(void);
 extern void	print_xlx(void);
 extern void	sweep(int );
 extern void	usage(void);
 extern void	var_verifica(int );
 extern int	ver1(int );
 extern int	ver2(int );
 extern int	veri_fica(int );
 extern void	verifica(void);
 extern void	zera_linha(int );
#else
 extern int	compara();
 extern int	compare();
 extern int	contraste();
 extern void	errocon();
 extern void	cria_xlx();
 extern double	cxlxcl();
 extern double	doolitle();
 extern void	erro();
 extern void	erromod();
 extern void	escrevelst();
 extern void	expand_mat();
 extern int	expande();
 extern double	fprob();
 extern void	getarg();
 extern TINT	idx();
 extern TINT	idy();
 extern void	implstnv();
 extern int	impmedia();
 extern void	impmed();
 extern void	imprimel();
 extern int	lerumaobs();
 extern void	ler_par();
 extern void	media2();
 extern int	missing();
 extern int	modelo();
 extern void	modelo1();
 extern void	modelo2();
 extern void	ordenalista();
 extern void	pegalista();
 extern void	pivota();
 extern void	printanv();
 extern void	printbeta();
 extern void	printcov();
 extern void	print_par();
 extern void	print_xlx();
 extern void	sweep();
 extern void	usage();
 extern void	var_verifica();
 extern int	ver1();
 extern int	ver2();
 extern int	veri_fica();
 extern void	verifica();
 extern void	zera_linha();
#endif
