
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Parse do comando compara

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/comp_med.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include <stdlib.h>
#include <string.h>

#include "pcsgbd.h"
#include "getoken.h"
#include "modelo.h"

#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif

#ifdef   MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)comp_med.c	3.8	(NTIA/modlin)	95/11/10";

#define INICIO 	  pos[ie]
#define FIM    	  pos[ie]+nm
#define COM(i)    cmp_nv[i-INICIO]
#define MEDIA(i)  cmp_med[i-INICIO]
#define IMPRIME   if (!iterativo && !tem_comando) fprintf(fout, "%s ", token);

extern double f_qm;
extern double f_gl;

/*
#if !defined(MSDOS) & !defined(VAXVMS) & !defined(RS6000) & !defined(IRIX)
# if !defined(SCO)
   extern char *calloc();
# endif
#endif
*/

#ifdef MSDOS
extern int yyparse(void);
#else
extern int yyparse();
#endif

/* --------------------------------------------------------------------------*/
/* As tres variaveis, abaixo, sao 'setadas' no yyparse                       */

int c_opcao;			/* Variavel utilizada para pegar a opcao escolhida   */
double c_alfa;			/* Utilizada para armazenar o nivel de significancia */
int n_vardep;			/* Numero de variaveis dependentes                   */
/* --------------------------------------------------------------------------*/

void p_cmp(n, faux)
int n;
FILE *faux;
{

    extern int ctoken;
    extern int impflag;
    extern int tem_comando;
    extern int iterativo;
    extern FILE *fout;
    extern char *p2;
    extern char *efts1[MAXEFTS];

    int i, k, cmp, opcao;
    double alfa, qm, gl;

    cmp = 0;
    f_qm = -9.0;
    f_gl = -9.0;
    c_alfa = -9.0;
    c_opcao = -9;
    n_vardep = 0;

    /* -------------------------------------------------------------- */
    /* Valores defaults                                               */
    /* -------------------------------------------------------------- */
    alfa = 0.05;
    opcao = 5;
    /* -------------------------------------------------------------- */

    ctoken = gtoken1(token, faux);
    while (ctoken != PTVG && ctoken != VG && ctoken != LC) {
	if (ctoken != VARIAV)
	    errocon(9, 3);
	IMPRIME;
	strcpy(buffer, token);
	for (i = 1; i < nef + nd; ++i) {
	    if (ef[i][0] == 0) {
		if (strcmpi(token, efts[i]) == 0 && ef[i][3] == 0) {
		    qtde[cmp] = i;
		    break;
		}
	    }
	}
	ctoken = gtoken1(token, faux);

	if (ctoken == LP) {
	    IMPRIME;
	    ctoken = gtoken1(token, faux);
	    if (ctoken != VARIAV)
		errocon(9, 3);
	    IMPRIME;

	    strcat(buffer, "(");
	    strcat(buffer, token);

	    while ((ctoken = gtoken1(token, faux)) == VARIAV) {
		IMPRIME;
		strcat(buffer, " ");
		strcat(buffer, token);
	    }

	    if (ctoken != RP)
		errocon(13, 3);
	    IMPRIME;
	    strcat(buffer, ")");

	    for (i = 0; i < nef + nd; ++i) {
		if (ef[i][0] == 0 && ef[i][3] == 0) {
		    if (strcmpi(buffer, efts[i]) == 0) {
			qtde[cmp] = i;
			break;
		    }
		}
	    }
	    ctoken = gtoken1(token, faux);
	}

	cmp++;
	if (i == (nef + nd))
	    errocon(9, 3);
    }
    IMPRIME;
    if (!iterativo && !tem_comando)
	fprintf(fout, "\n");

    /* -------------------------------------------------------------- */

    if (ctoken != PTVG)
	yyparse();

    if ((f_qm == -9.0 && f_gl != -9.0) || (f_qm != -9.0 && f_gl == -9.0))
	errocon(25, 3);

    if (c_opcao != -9)
	opcao = c_opcao;

    if (c_alfa != -9.0)
	alfa = c_alfa;

    /* -------------------------------------------------------------- */

    if (!iterativo && n_vardep) {
	for (i = 0; i < n_vardep; ++i) {
	    if (strcmpi(efts1[i], efts[nef + nd + n]) == 0) {
		for (k = 0; k < cmp; ++k) {
		    des_qme(qtde[k], &qm, &gl);
		    com_mul(qtde[k], n, qm, (int) gl, opcao, alfa);
		}
	    }
	}
    } else {
	if (iterativo && n_vardep) {
	    fprintf(stderr,
		    "\nAdvertencia: No modo interativo a especificacao da variavel dependente para");
	    fprintf(stderr,
		    "\n             calculo das medias de Minimos Quadrados e' desprezada.");
	    fprintf(stderr,
		    "\n             As comparacoes serao calculadas para a variavel %s.\n\n",
		    efts[nd + nef + n]);
	}
	for (k = 0; k < cmp; ++k) {
	    des_qme(qtde[k], &qm, &gl);
	    com_mul(qtde[k], n, qm, (int) gl, opcao, alfa);
	}
    }
}

void com_mul(ie, id, qmr, gle, opcao, alfa)
int ie;				/* Posicao do efeito */
int id;				/* Posicao da variavel dependente */
double qmr;
int gle;
int opcao;
double alfa;
{
    int k, i, dif, j;
    int hflag;
    int tt = 0;
    double x1, soma, qp;
    int nm;			/* Numero de medias do efeito */
    int *nome;
    int *cmp_nv;
    double *cmp_med;
    int *comp, *comp1;
    int *ant, *prof;

    hflag = 0;			/* artificio para se usar apenas media harmonica */

    nm = num_medias(ie);

#if defined(MSDOS) & !defined(DJGPP)
    if (nm > 100) {
	cab_comp(alfa, opcao, ie, id, (double) gle, qmr);

/* *** Padroniz. msg erro - Adriana 24/01/95
		printf(
	"Numero maximo de niveis do efeito tem que ser menor do que 100.\n");
*** */

	printf(PegaMsg(1014));
	printf("Efeito %s, numero de niveis = %d\n", efts[ie], nm);
	printf
	    ("Neste caso, o teste de comparacoes multiplas nao e' realizado.\n\n");
	return;
    }
#endif

    nome = (int *) calloc((unsigned) nm, sizeof(int));
    if (nome == (int *) NULL) {

/* *** Padroniz. msg erro - Adriana 12/12/94
		errocon(21,3);
*** */

	errocon(23, 3);
    }
    cmp_nv = (int *) calloc((unsigned) nm, sizeof(int));
    if (cmp_nv == (int *) NULL) {
	free((char *) nome);

/* *** Padroniz. msg erro - Adriana 12/12/94
		errocon(21,3);
*** */

	errocon(23, 3);
    }
    cmp_med = (double *) calloc((unsigned) nm, sizeof(double));
    if (cmp_med == (double *) NULL) {
	free((char *) nome);
	free((char *) cmp_nv);

/* *** Padroniz. msg erro - Adriana 12/12/94
		errocon(21,3);
*** */

	errocon(23, 3);
    }
    comp = (int *) calloc((unsigned) (nm + 2), sizeof(int));
    if (comp == (int *) NULL) {
	free((char *) nome);
	free((char *) cmp_nv);
	free((char *) cmp_med);

/* *** Padroniz. msg erro - Adriana 12/12/94
		errocon(21,3);
*** */

	errocon(23, 3);
    }
    comp1 = (int *) calloc((unsigned) (nm + 2), sizeof(int));
    if (comp1 == (int *) NULL) {
	free((char *) nome);
	free((char *) cmp_nv);
	free((char *) cmp_med);
	free((char *) comp);

/* *** Padroniz. msg erro - Adriana 12/12/94
		errocon(21,3);
*** */

	errocon(23, 3);
    }
    ant = (int *) calloc((unsigned) (nm + 2), sizeof(int));
    if (ant == (int *) NULL) {
	free((char *) nome);
	free((char *) cmp_nv);
	free((char *) cmp_med);
	free((char *) comp);
	free((char *) comp1);

/* *** Padroniz. msg erro - Adriana 12/12/94
		errocon(21,3);
*** */

	errocon(23, 3);
    }
    prof = (int *) calloc((unsigned) (nm + 2), sizeof(int));
    if (prof == (int *) NULL) {
	free((char *) nome);
	free((char *) cmp_nv);
	free((char *) cmp_med);
	free((char *) comp);
	free((char *) comp1);
	free((char *) ant);

/* *** Padroniz. msg erro - Adriana 12/12/94
		errocon(21,3);
*** */

	errocon(23, 3);
    }

    /* ------------------------------------------------------------- */
    /* copiar: posicaoes de Com_med e com_nv */
    /* ------------------------------------------------------------- */
    j = 0;
    for (i = INICIO; i < FIM; ++i) {
	cmp_med[j] = (com_med[id][i] / ((double) com_nv[id][i]));
	cmp_nv[j++] = com_nv[id][i];
    }
    /* ------------------------------------------------------------- */

    fill_nome(ie, nome, nm);

    ordena(ie, nm, nome, cmp_med, cmp_nv);	/* Ordena as medias */

    cab_comp(alfa, opcao, ie, id, (double) gle, qmr);

    /* Se hflag, entao calcula mq,i como media harmonica */
    for (i = INICIO; i < FIM; ++i) {
	for (j = i; j < FIM; ++j) {
	    if (COM(i) != COM(j)) {
		hflag = 1;
		break;
	    }
	}
    }

    if (hflag) {
	soma = 0.0;
	for (i = INICIO; i < FIM; ++i) {
	    if (COM(i) == 0) {
		fprintf(stderr, "Numero de casos <N> igual a zero\n");
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("*** Lista de memoria nao esta' vazia ***\n");
		    Mem_Store("modlin");
		    exit(0);
		}
#endif
		exit(0);
	    }
	    soma += 1. / ((double) COM(i));
	}
	x1 = sqrt(soma * qmr / ((double) nm));
    }

    dif = 0;
    comp1[0] = 0;
    comp[0] = 0;
    for (k = INICIO; k < FIM; ++k) {
	for (i = FIM - 1; i >= k; --i) {
	    if (hflag == 0)	/* Se hflag=0 => mq,i e media */
		x1 = mqi((double) COM(k), (double) COM(i), qmr);
	    if (((opcao == 1) || (opcao == 3) || (opcao == 4))
		&& (k == INICIO))
		qp = rqi(opcao, alfa, 2, nm, (double) gle);

	    if (opcao == 6 && k == INICIO)
		qp = rqi(opcao, alfa, nm, nm, (double) gle);

	    if (opcao == 7) {
		j = abs(k - i) + 1;
		j = (j + nm) / 2;
		qp = rqi(opcao, alfa, j, nm, (double) gle);
	    }

	    if (opcao == 2 || opcao == 5) {
		j = abs(k - i) + 1;
		qp = rqi(opcao, alfa, j, nm, (double) gle);
	    }
	    if ((fabs(MEDIA(k) - MEDIA(i))) <= (qp * x1)) {
		if (comp1[dif] != (i + 1)) {
		    ++dif;
		    comp[dif] = k + 1;
		    comp1[dif] = i + 1;
		    tt = 1;
		}
		break;
	    }
	}
	if (i == (FIM - 1) && tt == 1)
	    break;
	tt = 0;

    }

    /* ---------------------------------------------------------- */
    /*                      ADVERTENCIA                           */
    /* ---------------------------------------------------------- */
    if (dif >= (nm + 2)) {

/* *** Padroniz. msg erro - Adriana 07/12/94
		printf("Erro Fatal Compara: Avise NTIA\n");
*** */

	printf(PegaMsg(5034));
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(1);
	}
#endif
	exit(1);
    }
    /* ---------------------------------------------------------- */

    for (i = 1; i <= dif; ++i) {
	ant[i] = 0;
	prof[i] = 0;
    }
    tt = 0;

    for (i = INICIO; i < FIM; ++i) {

	strcpy(buffer, tira_mais(lista[nome[i - INICIO]].q));
	printf("%-16.16s", buffer);
	printf("%5d %16s  ", COM(i), rounddec(MEDIA(i), 16, 6));
	for (k = 1; k <= dif; ++k) {
	    if (comp[k] == (i + 1)) {
		for (j = 1; j <= dif; ++j)
		    if (prof[j] == 0) {
			prof[j] = k;
			break;
		    }
	    }
	    if (comp[k] == (i + 1))
		break;
	}
	for (k = 1; k <= dif; ++k) {
	    if (prof[k] != 0) {
		if (ant[k] == 0) {
		    printf(" %c ", 'a' + prof[k] - 1);
		} else {
		    printf("   ");
		    ant[k] = 0;
		    prof[k] = 0;
		}
		if (comp1[prof[k]] == (i + 1))
		    ant[k] = 1;
	    } else {
		for (j = k; j <= dif; ++j)
		    if (prof[j] != 0) {
			printf("   ");
			break;
		    }
	    }
	}
	printf("\n");
    }
    free((char *) nome);
    free((char *) cmp_med);
    free((char *) cmp_nv);
    free((char *) comp);
    free((char *) comp1);
    free((char *) ant);
    free((char *) prof);
}

/* ------------------------------------------------------------------------
** rqi()
** 	Programado por:	Silvio Evangelista
**	Data:		Outubro 1986
**	Descricao:	calcula o valor de Rq-i+1                         
**	Variaveis ent.	qmr  - 
**	nesultado:	rq-1+1              
** ------------------------------------------------------------------------- */

double rqi(opcao, alfa, nm, nv, f)
int opcao;
double alfa;
int nm;
int nv;				/* Num. de medias envolvidas */
double f;			/* G.l erro */
{
    double valor;
    double alfa1;
    int fint;
    fint = (int) f;
    switch (opcao) {
    case 1:			/* teste de lsd  */
	valor = sqrt(2. * finv(alfa, 1.0, (double) fint));
	break;
    case 2:			/* teste de duncan */
	valor = duncan(f, nm, alfa);
	break;
    case 3:			/* teste de scheffe */
	valor =
	    sqrt(2. * ((double) (nv - 1)) *
		 finv(alfa, (double) (nv - 1), (double) fint));
	break;
    case 4:			/* teste de modlsd */
	alfa1 = 2. * alfa / ((double) (nv * (nv - 1)));
	valor = sqrt(2. * finv(alfa1, 1.0, (double) fint));
	break;
    case 5:			/* teste de SNK */
	valor = tabela(f, nm, alfa);
	break;
    case 6:			/* teste de Tukey */
	valor = tabela(f, nm, alfa);
	break;
    case 7:			/* teste de TukeyB */
	valor = tabela(f, nm, alfa);
	break;
    }
    return (valor);
}

/* ------------------------------------------------------------------------
** duncan()
** 	Programado por:	Silvio Evangelista
**	Data:		Outubro 1986
**	Descricao:	calcula o valor critico de duncan                    
**	Variaveis ent.	
**			n1   - gl do qmr
**			nm   - numero de medias p/ comparacao
**			alfa - probabilidade
**	nesultado:	duncan                
** ------------------------------------------------------------------------- */


double duncan(ff, nm, alfa)
double ff;
int nm;
double alfa;
{
    double r;
    double coef[10];
    double y;
    double z;
    int i;
    int n1;

    for (i = 0; i <= 9; ++i)
	coef[i] = 0.;
    n1 = (int) ff;
    if (alfa == 0.05) {
	if ((n1 + 2) < nm)
	    r = (double) (n1 + 2);
	else
	    r = (double) nm;
    } else {
	if ((n1 * 2) < nm)
	    r = (double) (n1 * 2);
	else
	    r = (double) nm;
    }

    y = 1. / ((double) ff);
    z = 1. / (sqrt(r));
    if (n1 == 1) {
	if (alfa == 0.05)
	    coef[0] = 17.97;
	else
	    coef[0] = 90.03;
    }
    if (n1 == 2) {
	if (alfa == 0.05)
	    coef[0] = 6.085;
	else
	    coef[0] = 14.04;
    }
    if (n1 >= 3 && nm == 2) {
	if (alfa == 0.05) {
	    coef[0] = 2.7784;
	    coef[1] = 3.0359;
	    coef[3] = 6.3404;
	} else {
	    coef[0] = 3.6405;
	    coef[1] = 7.1927;
	    coef[3] = 8.8962;
	    coef[6] = 33.2630;
	}
    }
    if ((n1 >= 3 && nm == 3) || (n1 == 3 && nm > 3)) {
	if (alfa == 0.05) {
	    coef[0] = 2.9217;
	    coef[1] = 3.2080;
	    coef[3] = 4.6911;
	} else {
	    coef[0] = 3.7941;
	    coef[1] = 7.5559;
	    coef[3] = 9.5681;
	    coef[6] = 25.4660;
	}
    }
    if (n1 > 3 && nm > 3) {
	if (alfa == 0.05) {
	    if (r >= 4.0 && r <= 17.0) {
		coef[0] = 3.5409;
		coef[1] = -4.8389;
		coef[2] = 0.9313;
		coef[3] = -2.123;
		coef[4] = 31.157;
		coef[5] = -7.6639;
		coef[6] = 12.759;
		coef[7] = 0.212;
		coef[8] = -27.779;
		coef[9] = 7.353;
	    } else {
		if (r >= 18.0 && r <= 100.0) {
		    coef[0] = 3.5883;
		    coef[1] = -45.660;
		    coef[2] = 5.099;
		    coef[3] = -2.32;
		    coef[4] = 396.24;
		    coef[5] = -46.554;
		    coef[6] = -1.39;
		    coef[7] = 21.74;
		    coef[8] = -855.99;
		    coef[9] = 95.07;
		}
	    }
	} else {
	    if (r >= 4.0 && r <= 14.0) {
		coef[0] = 4.5660;
		coef[1] = 3.4831;
		coef[2] = 0.5406;
		coef[3] = -7.246;
		coef[4] = 23.068;
		coef[5] = -7.8283;
		coef[6] = 27.158;
		coef[7] = 26.777;
		coef[8] = -27.626;
		coef[9] = 8.134;
	    } else {
		if (r >= 15.0 && r <= 100.0) {
		    coef[0] = 4.9138;
		    coef[1] = -12.756;
		    coef[2] = 0.341;
		    coef[3] = -31.179;
		    coef[4] = 169.221;
		    coef[5] = -23.023;
		    coef[6] = 18.74;
		    coef[7] = 118.36;
		    coef[8] = -350.15;
		    coef[9] = 50.37;
		}
	    }
	}
    }
    return (coef[0] + coef[1] * y + coef[2] * z + coef[3] * y * y +
	    coef[4] * y * z + coef[5] * z * z + coef[6] * y * y * y +
	    coef[7] * y * y * z + coef[8] * y * z * z +
	    coef[9] * z * z * z);
}

static double data[26][35] = {
    17.97, 26.98, 32.82, 37.08, 40.41, 43.12, 45.40, 47.36, 49.07, 50.59,
    51.96, 53.20,
    54.33, 55.36, 56.32, 57.22, 58.04, 58.83, 59.56, 60.91, 62.12, 63.22,
    64.23, 65.15,
    66.01, 66.81, 67.56, 68.26, 68.92, 71.73, 73.97, 75.82, 77.40, 78.77,
    79.98,

    6.085, 8.331, 9.798, 10.88, 11.74, 12.44, 13.03, 13.54, 13.99, 14.39,
    14.75, 15.08,
    15.38, 15.65, 15.91, 16.14, 16.37, 16.57, 16.77, 17.13, 17.45, 17.75,
    18.02, 18.27,
    18.50, 18.72, 18.92, 19.11, 19.28, 20.05, 20.66, 21.16, 21.59, 21.96,
    22.29,

    4.501, 5.910, 6.825, 7.502, 8.037, 8.478, 8.853, 9.177, 9.462, 9.717,
    9.946, 10.15,
    10.35, 10.53, 10.69, 10.84, 10.98, 11.11, 11.24, 11.47, 11.68, 11.87,
    12.05, 12.21,
    12.36, 12.50, 12.63, 12.75, 12.87, 13.36, 13.76, 14.08, 14.36, 14.61,
    14.82,

    3.927, 5.040, 5.757, 6.287, 6.707, 7.053, 7.347, 7.602, 7.826, 8.027,
    8.208, 8.373, 8.525,
    8.664, 8.794, 8.914, 9.028, 9.134, 9.233, 9.418, 9.584, 9.736, 9.875,
    10.00, 10.12,
    10.23, 10.34, 10.44, 10.53, 10.93, 11.24, 11.51, 11.73, 11.92, 12.09,

    3.635, 4.602, 5.218, 5.673, 6.033, 6.330, 6.582, 6.802, 6.995, 7.168,
    7.324, 7.466,
    7.596, 7.717, 7.828, 7.932, 8.030, 8.122, 8.208, 8.368, 8.512, 8.643,
    8.764, 8.875,
    8.979, 9.075, 9.165, 9.250, 9.330, 9.674, 9.949, 10.18, 10.38, 10.54,
    10.69,

    3.461, 4.339, 4.896, 5.305, 5.628, 5.895, 6.122, 6.319, 6.493, 6.649,
    6.789, 6.917,
    7.034, 7.143, 7.244, 7.338, 7.426, 7.508, 7.587, 7.730, 7.861, 7.979,
    8.088, 8.189,
    8.283, 8.370, 8.452, 8.529, 8.601, 8.913, 9.163, 9.370, 9.548, 9.702,
    9.839,

    3.344, 4.165, 4.681, 5.060, 5.359, 5.606, 5.815, 5.998, 6.158, 6.302,
    6.431, 6.550,
    6.658, 6.759, 6.852, 6.939, 7.020, 7.097, 7.170, 7.303, 7.423, 7.533,
    7.634, 7.728,
    7.814, 7.895, 7.972, 8.043, 8.110, 8.400, 8.632, 8.824, 8.989, 9.133,
    9.261,

    3.261, 4.041, 4.529, 4.886, 5.167, 5.399, 5.597, 5.767, 5.918, 6.054,
    6.175, 6.287,
    6.389, 6.483, 6.571, 6.653, 6.729, 6.802, 6.870, 6.995, 7.109, 7.212,
    7.307, 7.395,
    7.477, 7.554, 7.625, 7.693, 7.756, 8.029, 8.248, 8.430, 8.586, 8.722,
    8.843,

    3.199, 3.949, 4.415, 4.756, 5.024, 5.244, 5.432, 5.595, 5.739, 5.867,
    5.988, 6.089,
    6.186, 6.276, 6.359, 6.437, 6.510, 6.579, 6.644, 6.763, 6.871, 6.970,
    7.061, 7.145,
    7.222, 7.295, 7.363, 7.428, 7.488, 7.749, 7.958, 8.132, 8.281, 8.410,
    8.526,

    3.151, 3.877, 4.327, 4.654, 4.912, 5.124, 5.305, 5.461, 5.599, 5.722,
    5.833, 5.935,
    6.028, 6.114, 6.194, 6.269, 6.339, 6.405, 6.467, 6.582, 6.686, 6.781,
    6.868, 6.948,
    7.023, 7.093, 7.159, 7.220, 7.279, 7.529, 7.730, 7.897, 8.041, 8.166,
    8.276,

    3.113, 3.820, 4.256, 4.574, 4.823, 5.028, 5.202, 5.353, 5.487, 5.605,
    5.713, 5.811,
    5.901, 5.984, 6.062, 6.134, 6.202, 6.265, 6.326, 6.436, 6.536, 6.628,
    6.712, 6.790,
    6.863, 6.930, 6.994, 7.053, 7.110, 7.352, 7.546, 7.708, 7.847, 7.968,
    8.075,

    3.082, 3.773, 4.199, 4.508, 4.751, 4.950, 5.119, 5.265, 5.395, 5.511,
    5.615, 5.710,
    5.798, 5.878, 5.953, 6.023, 6.089, 6.151, 6.209, 6.317, 6.414, 6.503,
    6.585, 6.660,
    6.731, 6.796, 6.858, 6.916, 6.970, 7.205, 7.394, 7.552, 7.687, 7.804,
    7.909,

    3.055, 3.735, 4.151, 4.453, 4.690, 4.885, 5.049, 5.192, 5.318, 5.431,
    5.533, 5.625,
    5.711, 5.789, 5.862, 5.931, 5.995, 6.055, 6.112, 6.217, 6.312, 6.398,
    6.478, 6.551,
    6.620, 6.684, 6.744, 6.800, 6.854, 7.083, 7.267, 7.421, 7.552, 7.667,
    7.769,

    3.033, 3.702, 4.111, 4.407, 4.639, 4.829, 4.990, 5.131, 5.254, 5.364,
    5.463, 5.554,
    5.637, 5.714, 5.786, 5.852, 5.915, 5.974, 6.029, 6.132, 6.224, 6.309,
    6.387, 6.459,
    6.526, 6.588, 6.647, 6.702, 6.754, 6.979, 7.159, 7.309, 7.438, 7.550,
    7.650,

    3.014, 3.674, 4.076, 4.367, 4.595, 4.782, 4.940, 5.077, 5.198, 5.306,
    5.404, 5.493,
    5.574, 5.649, 5.720, 5.785, 5.846, 5.904, 5.958, 6.059, 6.149, 6.233,
    6.309, 6.379,
    6.445, 6.506, 6.564, 6.618, 6.669, 6.888, 7.065, 7.212, 7.339, 7.449,
    7.546,

    2.998, 3.649, 4.046, 4.333, 4.557, 4.741, 4.897, 5.031, 5.150, 5.256,
    5.352, 5.439,
    5.520, 5.593, 5.662, 5.727, 5.786, 5.843, 5.897, 5.995, 6.084, 6.166,
    6.241, 6.310,
    6.374, 6.434, 6.491, 6.544, 6.594, 6.810, 6.984, 7.128, 7.252, 7.360,
    7.457,

    2.984, 3.628, 4.020, 4.303, 4.524, 4.705, 4.858, 4.991, 5.108, 5.212,
    5.307, 5.392,
    5.471, 5.544, 5.612, 5.675, 5.734, 5.790, 5.842, 5.940, 6.027, 6.107,
    6.181, 6.249,
    6.313, 6.372, 6.427, 6.479, 6.529, 6.741, 6.912, 7.054, 7.176, 7.283,
    7.377,

    2.971, 3.609, 3.997, 4.277, 4.495, 4.673, 4.824, 4.956, 5.071, 5.174,
    5.267, 5.352,
    5.429, 5.501, 5.568, 5.660, 5.688, 5.743, 5.794, 5.890, 5.977, 6.055,
    6.128, 6.195,
    6.258, 6.316, 6.371, 6.422, 6.471, 6.680, 6.848, 6.989, 6.109, 7.213,
    7.307,

    2.960, 3.593, 3.977, 4.253, 4.469, 4.645, 4.794, 4.924, 5.038, 5.140,
    5.231, 5.315,
    5.391, 5.462, 5.528, 5.589, 5.647, 5.701, 5.752, 5.846, 5.932, 6.009,
    6.081, 6.147,
    6.209, 6.267, 6.321, 6.371, 6.419, 6.626, 6.792, 6.930, 7.048, 7.152,
    7.244,

    2.950, 3.578, 3.958, 4.232, 4.445, 4.620, 4.768, 4.896, 5.008, 5.108,
    5.199, 5.282,
    5.357, 5.427, 5.493, 5.553, 5.610, 5.663, 5.714, 5.807, 5.891, 5.968,
    6.039, 6.104,
    6.165, 6.222, 6.275, 6.325, 6.373, 6.576, 6.740, 6.877, 6.994, 7.097,
    7.187,

    2.919, 3.532, 3.901, 4.166, 4.373, 4.541, 4.684, 4.807, 4.915, 5.012,
    5.099, 5.179,
    5.251, 5.319, 5.381, 5.439, 5.494, 5.545, 5.594, 5.683, 5.764, 5.838,
    5.906, 5.968,
    6.027, 6.081, 6.132, 6.181, 6.226, 6.421, 6.579, 6.710, 6.822, 6.920,
    7.008,

    2.888, 3.486, 3.845, 4.102, 4.302, 4.464, 4.602, 4.720, 4.824, 4.917,
    5.001, 5.077,
    5.147, 5.211, 5.271, 5.327, 5.379, 5.429, 5.475, 5.561, 5.638, 5.709,
    5.774, 5.833,
    5.889, 5.941, 5.990, 6.037, 6.080, 6.267, 6.417, 6.543, 6.550, 6.744,
    6.827,

    2.858, 3.442, 3.791, 4.039, 4.232, 4.389, 4.521, 4.635, 4.735, 4.824,
    4.904, 4.977,
    5.044, 5.106, 5.163, 5.216, 5.266, 5.313, 5.358, 5.439, 5.513, 5.581,
    5.642, 5.700,
    5.753, 5.803, 5.849, 5.893, 5.934, 6.112, 6.255, 6.375, 6.477, 6.566,
    6.645,

    2.829, 3.399, 3.737, 3.977, 4.163, 4.314, 4.441, 4.550, 4.646, 4.732,
    4.808, 4.878,
    4.942, 5.001, 5.056, 5.107, 5.154, 5.199, 5.241, 5.319, 5.389, 5.453,
    5.512, 5.566,
    5.617, 5.664, 5.708, 5.750, 5.789, 5.958, 6.093, 6.206, 6.303, 6.387,
    6.462,

    2.800, 3.356, 3.685, 3.917, 4.096, 4.241, 4.363, 4.468, 4.560, 4.641,
    4.714, 4.781,
    4.842, 4.898, 4.950, 4.998, 5.044, 5.086, 5.126, 5.200, 5.266, 5.327,
    5.382, 5.434,
    5.481, 5.526, 5.568, 5.607, 5.644, 5.802, 5.929, 6.035, 6.126, 6.205,
    6.275,

    2.772, 3.314, 3.633, 3.858, 4.030, 4.170, 4.286, 4.387, 4.474, 4.552,
    4.622, 4.685,
    4.743, 4.796, 4.845, 4.891, 4.934, 4.974, 5.012, 5.081, 5.144, 5.201,
    5.253, 5.301,
    5.346, 5.388, 5.427, 5.463, 5.498, 5.646, 5.764, 5.863, 5.947, 6.020,
    6.085
}

;
static double data1[26][35] = {
    90.03, 135.0, 164.3, 185.6, 202.2, 215.8, 227.2, 237.0, 245.6, 253.2,
    260.0, 266.2,
    271.8, 277.0, 281.8, 286.3, 290.4, 294.3, 298.0, 304.7, 310.8, 316.3,
    321.3, 326.0,
    330.3, 334.3, 338.0, 341.5, 344.8, 358.9, 370.1, 379.4, 387.3, 394.1,
    400.1,

    14.04, 19.02, 22.29, 24.72, 26.63, 28.20, 29.53, 30.68, 31.69, 32.59,
    33.40, 34.13,
    34.81, 35.43, 36.00, 36.53, 37.03, 37.50, 37.95, 38.76, 39.49, 40.15,
    40.76, 41.32,
    41.84, 42.33, 42.78, 43.21, 43.61, 45.33, 46.70, 47.83, 48.80, 49.64,
    50.38,

    8.261, 10.62, 12.17, 13.33, 14.24, 15.00, 15.64, 16.20, 16.69, 17.13,
    17.53, 17.89,
    18.22, 18.52, 18.81, 19.07, 19.32, 19.55, 19.77, 20.17, 20.53, 20.86,
    21.16, 21.44,
    21.70, 21.95, 22.17, 22.39, 22.59, 23.45, 24.13, 24.71, 25.19, 25.62,
    25.99,

    6.512, 8.120, 9.173, 9.958, 10.58, 11.10, 11.55, 11.93, 12.27, 12.57,
    12.84, 13.09,
    13.32, 13.53, 13.73, 13.91, 14.08, 14.24, 14.40, 14.68, 14.93, 15.16,
    15.37, 15.57,
    15.75, 15.92, 16.08, 16.23, 16.37, 16.98, 17.46, 17.86, 18.20, 18.50,
    18.77,

    5.702, 6.976, 7.804, 8.421, 8.913, 9.321, 9.669, 9.972, 10.24, 10.48,
    10.70, 10.89,
    11.08, 11.24, 11.40, 11.55, 11.68, 11.81, 11.93, 12.16, 12.36, 12.54,
    12.71, 12.87, 13.02,
    13.15, 13.28, 13.40, 13.52, 14.00, 14.39, 14.72, 14.99, 15.23, 15.45,

    5.243, 6.331, 7.033, 7.556, 7.973, 8.318, 8.613, 8.869, 9.097, 9.301,
    9.485, 9.653,
    9.808, 9.951, 10.08, 10.21, 10.32, 10.43, 10.54, 10.73, 10.91, 11.06,
    11.21, 11.34,
    11.47, 11.58, 11.69, 11.80, 11.90, 12.31, 12.65, 12.92, 13.16, 13.37,
    13.55,

    4.949, 5.919, 6.543, 7.005, 7.373, 7.679, 7.939, 8.166, 8.368, 8.548,
    8.711, 8.860,
    8.997, 9.124, 9.242, 9.353, 9.456, 9.554, 9.646, 9.815, 9.970, 10.11,
    10.24, 10.36,
    10.47, 10.58, 10.67, 10.77, 10.85, 11.23, 11.52, 11.77, 11.99, 12.17,
    12.34,

    4.746, 5.635, 6.204, 6.625, 6.960, 7.237, 7.474, 7.681, 7.863, 8.027,
    8.176, 8.312,
    8.436, 8.552, 8.659, 8.760, 8.8554, 8.943, 9.027, 9.182, 9.322, 9.450,
    9.569, 9.678,
    9.779, 9.874, 9.964, 10.05, 10.13, 10.47, 10.75, 10.97, 11.17, 11.34,
    11.49,

    4.596, 5.428, 5.957, 6.348, 6.658, 6.915, 7.134, 7.325, 7.495, 7.647,
    7.784, 7.910,
    8.025, 8.132, 8.232, 8.325, 8.412, 8.495, 8.573, 8.717, 8.847, 8.966,
    9.075, 9.177, 9.271,
    9.360, 9.443, 9.521, 9.594, 9.912, 10.17, 10.38, 10.57, 10.73, 10.87,

    4.482, 5.270, 5.769, 6.136, 6.428, 6.669, 6.875, 7.055, 7.213, 7.356,
    7.485, 7.603,
    7.712, 7.812, 7.906, 7.993, 8.076, 8.153, 8.226, 8.361, 8.483, 8.595,
    8.698, 8.794,
    8.883, 8.966, 9.044, 9.117, 9.187, 9.486, 9.726, 9.927, 10.10, 10.25,
    10.39,

    4.392, 5.146, 5.621, 5.970, 6.247, 6.476, 6.672, 6.842, 6.992, 7.128,
    7.250, 7.362,
    7.465, 7.560, 7.649, 7.732, 7.809, 7.883, 7.952, 8.080, 8.196, 8.303,
    8.400, 8.491,
    8.575, 8.654, 8.728, 8.798, 8.864, 9.148, 9.377, 9.568, 9.732, 9.875,
    10.00,

    4.320, 5.046, 5.502, 5.836, 6.101, 6.321, 6.507, 6.670, 6.814, 6.943,
    7.060, 7.167,
    7.265, 7.356, 7.441, 7.520, 7.594, 7.665, 7.731, 7.853, 7.964, 8.066,
    8.159, 8.246,
    8.327, 8.402, 8.473, 8.539, 8.603, 8.875, 9.094, 9.277, 9.434, 9.571,
    9.693,

    4.260, 4.964, 5.404, 5.727, 5.981, 6.192, 6.372, 6.528, 6.667, 6.791,
    6.903, 7.006,
    7.101, 7.188, 7.269, 7.345, 7.417, 7.485, 7.548, 7.665, 7.772, 7.870,
    7.960, 8.043,
    8.121, 8.193, 8.262, 8.326, 8.387, 8.648, 8.859, 9.035, 9.187, 9.318,
    9.436,

    4.210, 4.895, 5.322, 5.634, 5.881, 6.085, 6.258, 6.409, 6.543, 6.664,
    6.772, 6.871,
    6.962, 7.047, 7.126, 7.199, 7.268, 7.333, 7.395, 7.508, 7.611, 7.705,
    7.792, 7.873,
    7.948, 8.018, 8.084, 8.146, 8.204, 8.457, 8.661, 8.832, 8.978, 9.106,
    9.219,

    4.168, 4.836, 5.252, 5.556, 5.796, 5.994, 6.162, 6.309, 6.439, 6.555,
    6.660, 6.757,
    6.845, 6.927, 7.003, 7.074, 7.142, 7.204, 7.264, 7.374, 7.474, 7.566,
    7.650, 7.728,
    7.800, 7.869, 7.932, 7.992, 8.049, 8.295, 8.492, 8.658, 8.800, 8.924,
    9.035,

    4.131, 4.786, 5.192, 5.489, 5.722, 5.915, 6.079, 6.222, 6.349, 6.462,
    6.564, 6.658,
    6.744, 6.823, 6.898, 6.967, 7.032, 7.093, 7.152, 7.258, 7.356, 7.445,
    7.527, 7.602,
    7.673, 7.739, 7.802, 7.860, 7.916, 8.154, 8.347, 8.507, 8.646, 8.767,
    8.874,

    4.099, 4.742, 5.140, 5.430, 5.659, 5.847, 6.007, 6.147, 6.270, 6.381,
    6.480, 6.572,
    6.656, 6.734, 6.806, 6.873, 6.937, 6.997, 7.053, 7.158, 7.253, 7.340,
    7.420, 7.493,
    7.563, 7.627, 7.687, 7.745, 7.799, 8.031, 8.219, 8.377, 8.511, 8.630,
    8.735,

    4.071, 4.703, 5.094, 5.379, 5.603, 5.788, 5.944, 6.081, 6.201, 6.310,
    6.407, 6.497,
    6.579, 6.655, 6.725, 6.792, 6.854, 6.912, 6.968, 7.070, 7.163, 7.247,
    7.325, 7.398,
    7.465, 7.528, 7.587, 7.643, 7.696, 7.924, 8.107, 8.261, 8.393, 8.508,
    8.611,

    4.046, 4.670, 5.054, 5.334, 5.554, 5.735, 5.889, 6.022, 6.141, 6.247,
    6.342, 6.430,
    6.510, 6.585, 6.654, 6.719, 6.780, 6.837, 6.891, 6.992, 7.082, 7.166,
    7.242, 7.313,
    7.379, 7.440, 7.498, 7.553, 7.605, 7.828, 8.008, 8.159, 8.288, 8.401,
    8.502,

    4.024, 4.639, 5.018, 5.294, 5.510, 5.688, 5.839, 5.970, 6.087, 6.191,
    6.285, 6.371,
    6.450, 6.523, 6.591, 6.654, 6.714, 6.771, 6.823, 6.922, 7.011, 7.092,
    7.168, 7.237,
    7.302, 7.362, 7.419, 7.473, 7.523, 7.742, 7.919, 8.067, 8.194, 8.305,
    8.404,

    3.956, 4.546, 4.907, 5.168, 5.374, 5.542, 5.685, 5.809, 5.919, 6.017,
    6.106, 6.186,
    6.261, 6.330, 6.394, 6.453, 6.510, 6.563, 6.612, 6.705, 6.789, 6.865,
    6.936, 7.001,
    7.062, 7.119, 7.173, 7.223, 7.270, 7.476, 7.642, 7.780, 7.900, 8.004,
    8.097,

    3.889, 4.455, 4.799, 5.048, 5.242, 5.401, 5.536, 5.653, 5.756, 5.849,
    5.932, 6.008,
    6.078, 6.143, 6.203, 6.259, 6.311, 6.361, 6.407, 6.494, 6.572, 6.644,
    6.710, 6.772,
    6.828, 6.881, 6.932, 6.978, 7.023, 7.215, 7.370, 7.500, 7.611, 7.709,
    7.796,

    3.825, 4.367, 4.696, 4.931, 5.114, 5.265, 5.392, 5.502, 5.599, 5.686,
    5.764, 5.835,
    5.900, 5.961, 6.017, 6.069, 6.119, 6.165, 6.209, 6.289, 6.362, 6.429,
    6.490, 6.547,
    6.600, 6.650, 6.697, 6.740, 6.782, 6.960, 7.104, 7.225, 7.328, 7.419,
    7.500,

    3.762, 4.282, 4.595, 4.818, 4.991, 5.133, 5.253, 5.356, 5.447, 5.528,
    5.601, 5.667,
    5.728, 5.785, 5.837, 5.886, 5.931, 5.974, 6.015, 6.090, 6.158, 6.220,
    6.277, 6.330,
    6.378, 6.424, 6.467, 6.507, 6.546, 6.710, 6.843, 6.954, 7.050, 7.133,
    7.207,

    3.702, 4.200, 4.497, 4.709, 4.872, 5.005, 5.118, 5.214, 5.299, 5.375,
    5.443, 5.505,
    5.562, 5.614, 5.662, 5.708, 5.750, 5.790, 5.827, 5.897, 5.959, 6.016,
    6.069, 6.117,
    6.162, 6.204, 6.244, 6.281, 6.316, 6.467, 6.588, 6.689, 6.776, 6.852,
    6.919,

    3.643, 4.120, 4.403, 4.603, 4.757, 4.882, 4.987, 5.078, 5.157, 5.227,
    5.290, 5.348,
    5.400, 5.448, 5.493, 5.535, 5.574, 5.611, 5.645, 5.709, 5.766, 5.818,
    5.866, 5.911,
    5.952, 5.990, 6.026, 6.060, 6.092, 6.228, 6.338, 6.429, 6.507, 6.575,
    6.636
};

static nao_n[17] =
    { 20, 22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 50, 60, 70, 80, 90,
    100
};
static nao_v[7] = { 20, 24, 30, 40, 60, 120, 121 };

#define DIV  ( ((double)  (n-n1)) / ((double) (n2-n1)))
#define DIV1 ( ((double)  (v-v1)) / ((double) (v2-v1)))

double tabela(vv, n, alfa)
double vv;
int n;
double alfa;
{
    int i_n, p_n, i_v, p_v, n1, n2, v1, v2, v;
    double ponto, vv1, vv2;
    int k;
    double dponto;

    v = (int) vv;
    if ((n > 1 && n < 20)) {
	i_n = n - 2;
	p_n = 0;
    } else {
	for (k = 0; k < 17; ++k) {
	    if ((nao_n[k] == n)) {
		i_n = 18 + k;
		p_n = 0;
		break;
	    } else {
		if (nao_n[k] > n) {
		    n1 = nao_n[k - 1];
		    n2 = nao_n[k];
		    i_n = 18 + k - 1;
		    p_n = 18 + k;
		    break;
		}
	    }
	}
    }

    if ((v >= 1 && v < 20)) {
	i_v = v - 1;
	p_v = 0;
    } else {
	for (k = 0; k < 7; ++k) {
	    if (v > 120) {
		i_v = 25;
		p_v = 0;
		break;
	    }
	    if ((nao_v[k] == v)) {
		i_v = 19 + k;
		p_v = 0;
		break;
	    } else {
		if (nao_v[k] > v) {
		    v1 = nao_v[k - 1];
		    v2 = nao_v[k];
		    i_v = 19 + k - 1;
		    p_v = 19 + k;
		    break;
		}
	    }
	}
    }
    if (alfa == 0.05) {

	if (p_v == 0 && p_n > 0)
	    ponto =
		data[i_v][i_n] + (data[i_v][p_n] - data[i_v][i_n]) * DIV;

	if (p_v > 0 && p_n == 0)
	    ponto =
		data[i_v][i_n] + (data[p_v][i_n] - data[i_v][i_n]) * DIV1;

	if (p_v == 0 && p_n == 0)
	    ponto = data[i_v][i_n];

	if (p_v > 0 && p_n > 0) {

	    vv1 = data[i_v][i_n] + (data[i_v][p_n] - data[i_v][i_n]) * DIV;

	    vv2 = data[i_v][i_n] + (data[p_v][p_n] - data[i_v][i_n]) * DIV;

	    ponto = vv1 + (vv2 - vv1) * DIV1;
	}
	if (p_v == 0 && p_n == 0)
	    ponto = data[i_v][i_n];
    }
    if (alfa == 0.01) {

	if (p_v == 0 && p_n > 0)
	    ponto =
		data1[i_v][i_n] + (data1[i_v][p_n] -
				   data1[i_v][i_n]) * DIV;

	if (p_v > 0 && p_n == 0)
	    ponto =
		data1[i_v][i_n] + (data1[p_v][i_n] -
				   data1[i_v][i_n]) * DIV1;

	if (p_v == 0 && p_n == 0)
	    ponto = data1[i_v][i_n];

	if (p_v > 0 && p_n > 0) {

	    vv1 =
		data1[i_v][i_n] + (data1[i_v][p_n] -
				   data1[i_v][i_n]) * DIV;

	    vv2 =
		data1[i_v][i_n] + (data1[p_v][p_n] -
				   data1[i_v][i_n]) * DIV;

	    ponto = vv1 + (vv2 - vv1) * DIV1;
	}
	if (p_v == 0 && p_n == 0)
	    ponto = data1[i_v][i_n];
    }
    dponto = (double) ponto;
    return (dponto);
}

/* ------------------------------------------------------------------------
** ordena()
** 	Programado por:	Silvio Evangelista
**	Data:		Outubro 1986
**	Descricao:	ordena o vetor de medias                          
**	Variaveis ent.	com_med  - valor da media.
**			com_nv   - numero de obs.
**			nomes    - nomes dos niveis
**	nesultado:	vetor ordenado      
** ------------------------------------------------------------------------- */

void ordena(ie, nm, nome, com_med, com_nv)
int ie;
int nm;
int *nome;
double *com_med;
int *com_nv;
{
    int inter, j;
    double temp1;
    int temp;

    for (inter = FIM - 1; inter > INICIO; --inter) {
	for (j = INICIO; j < inter; ++j) {
	    if (com_med[j - INICIO] < com_med[inter - INICIO]) {
		temp1 = com_med[j - INICIO];
		com_med[j - INICIO] = com_med[inter - INICIO];
		com_med[inter - INICIO] = temp1;
		temp = com_nv[j - INICIO];
		com_nv[j - INICIO] = com_nv[inter - INICIO];
		com_nv[inter - INICIO] = temp;
		temp = nome[j - INICIO];
		nome[j - INICIO] = nome[inter - INICIO];
		nome[inter - INICIO] = temp;
	    }
	}
    }
}

int num_medias(ie)
int ie;
{
    int l, j, k;

    j = 0;
    if (ef[ie][4] > 0) {
	l = ef[ie][4] - 1;
	for (k = 0; k < nchi[l]; k++) {
	    j += (nvhi[l][k + 1] - nvhi[l][k]);
	}
    } else {
	j = (nv[ie] + 1);
    }
    return (j);
}

void fill_nome(ie, nome, nm)
int ie;
int *nome;
int nm;
{

    int i;
    int pos;

    pos = 0;
    for (i = 1; i < ie; ++i) {
	if (ef[i][0] == 0
	    || (ef[i][4] > 0 && (ef[i][0] <= 0 || ef[i][1] < 0)))
	    pos++;
    }
    nome[0] = pos;
    for (i = 1; i < nm; ++i) {
	pos = lista[pos].prox;
	nome[i] = pos;
    }
}

/* ------------------------------------------------------------------------
** mqi()
** 	Programado por:	Silvio Evangelista
**	Data:		Outubro 1986
**	Descricao:	calcula o valor de Mq,i                           
**	Variaveis ent.	qmr  - 
**			n1   - n_obs da media i
**			n2   - n_obs da media q
**	nesultado:	Mq,i                
** ------------------------------------------------------------------------- */

double mqi(n1, n2, qmr)
double n1, n2, qmr;
{
    return ((double) sqrt((1. / 2.) * (1. / n1 + 1. / n2) * qmr));
}

void cab_comp(alfa, opcao, ie, id, f, qmr)
double alfa;
int opcao;
int ie;
int id;
double f;
double qmr;
{
    char *est[7];		/* ponteiro para o nome da estatistica */

    est[0] = "LSD";
    est[1] = "Duncan";
    est[2] = "Scheffe";
    est[3] = "MODLSD";
    est[4] = "SNK";
    est[5] = "Tukey";
    est[6] = "TukeyB";

    putchar1();
    printf("Teste \"%s\" para a variavel: \"%s.\" \n", est[opcao - 1],
	   efts[nef + nd + id]);
    /*
       printf("g.l =%4.0lf  qme =%11.4lf  alfa = %3.2lf\n",f,qmr,alfa);
     */
    printf("g.l =%4s  qme =%11s  alfa = %3.2lf\n",
	   rounddec(f, 4, 0), rounddec(qmr, 11, 4), alfa);

    printf("medias ligadas com uma mesma letra nao sao\n");
    printf("significativamente diferentes.\n\n");

    printf("%-18.18s", efts[ie]);
    printf("  n         ");
    printf("%-11.11s", efts[nef + nd + id]);
    printf("grupo \n\n");
}

int des_est(token)
char *token;
{
    int i;
    i = -1;

    if (strcmpi(token, "lsd") == 0 || strcmpi(token, "e1") == 0)
	i = 1;
    if (strcmpi(token, "duncan") == 0 || strcmpi(token, "e2") == 0)
	i = 2;
    if (strcmpi(token, "scheffe") == 0 || strcmpi(token, "e3") == 0)
	i = 3;
    if (strcmpi(token, "modlsd") == 0 || strcmpi(token, "e4") == 0)
	i = 4;
    if (strcmpi(token, "snk") == 0 || strcmpi(token, "e5") == 0)
	i = 5;
    if (strcmpi(token, "tukey") == 0 || strcmpi(token, "e6") == 0)
	i = 6;
    if (strcmpi(token, "tukeyb") == 0 || strcmpi(token, "e7") == 0)
	i = 7;

    return (i);
}

void des_qme(pos, qm, gl)
int pos;
double *qm;
double *gl;
{
    if (f_qm == -9.0) {
	if (ef[pos][2] == 0) {
	    *qm = qmr;
	    *gl = (double) glr;
	} else {
	    *qm = obs[ef[pos][2]];
	    *gl = (double) nv[ef[pos][2]];
	}
    } else {
	*qm = f_qm;
	*gl = f_gl;
    }
}
