
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:
	
	Funcao que realiza a comparacao de duas strings (letras ou numeros)

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/compara.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"

#include <ctype.h>
#include <string.h>
#include <stdlib.h>

static char *sccsid = "@(#)compara.c	3.2	(NTIA/modlin)	94/12/20";

extern int tip_comp;		/* Setada na funcao ordenalista */
			/* 1 --> Hierarquico   */
			/* 0 --> Outros        */

int compara(x, y)
char **x;
char **y;
{
    int c;

    if (tip_comp) {
	int posx, posy;
	char buff0[64], buff1[64];
	int c;

	posx = 0;
	posy = 0;

	for (;;) {
	    peg_elemento(*x, buff0, &posx);
	    peg_elemento(*y, buff1, &posy);
	    if ((c = ccomp(buff0, buff1)) != 0) {
		return (c);
	    }
	    if (c == 0 && posx == -1 && posy == -1)
		return (0);
	}
    } else {
	c = ccomp(*x, *y);
	return (c);
    }
}

int ccomp(x, y)
char *x;
char *y;
{
    /* Codigo para garantir a ordenacao correta de numeros */
    if (numero(x) && numero(y)) {
	if (atof(x) < atof(y))
	    return (-1);
	else {
	    if (atof(x) > atof(y))
		return (1);
	    else
		return (0);
	}
    } else
	return (strcmpi(x, y));
}

int numero(x)
char *x;
{
    int ponto;
    int i;
    ponto = 0;

    for (i = 0; i < (int) strlen(x); i++) {
	if (!isdigit(x[i])) {
	    if (x[i] == '.' && !ponto) {
		ponto++;
		continue;
	    } else
		return 0;
	}
    }
    return (1);
}

void peg_elemento(x, buf, pos)
char *x;
char *buf;
int *pos;
{
    int i;
    int k;

    k = 0;

    for (i = *pos; i < (int) strlen(x); i++) {
	if (x[i] != ' ' && x[i] != '+')
	    break;
    }
    for (i = i; i <= (int) strlen(x); i++) {
	if (x[i] == ' ' || x[i] == '+' || x[i] == '\0') {
	    if (x[i] == '\0') {
		*pos = -1;
	    } else {
		*pos = i;
	    }
	    buf[k] = '\0';
	    return;
	} else {
	    buf[k++] = x[i];
	}
    }
}
