
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Calcular o contraste a partir dos comandos:
		CP <efeitos>;
		rt "titulo";
		m = <numeros>
		c = <arquivo> ou <matriz c> ou <pol>;

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/contrast.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"

#include <stdlib.h>

#ifdef MSDOS
#include <io.h>
#endif

#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)contrast.c	3.10	(NTIA/modlin)	95/09/15";


#define TOL	1.e-10

#define IMPRIME  if (!iterativo && !tem_comando) fprintf(fout, "%s ", token);
#define IMPRIM1  if (!iterativo && !tem_comando) fprintf(fout, "\n");

#ifdef MSDOS
extern int yyparse(void);
#else
extern int yyparse();
#endif

/* Macro utilizada para busar um endereco bi-dimensional em um vetor */
/* Onde :
	s = Matriz.
	i = primeiro indice.
	j = segundo indice.
	m = num. de colunas da matriz.
*/

#define DADOij(s,i,j,m)   (s[(i)*(m)+(j)])


void gs();

/* ------------------------------------------------------------------------
** contraste()
** 	Programado por:	Carlos Paniago
**	Data:		Outubro 1986
**	Descricao:	faz contraste
** ------------------------------------------------------------------------- */

int ctoken;
int f_erro;

double f_qm, f_gl;		/* Armazena os valores qm e gl gerados pela formula */

double mean1[MAXMEM];		/* Vetor temporario para armazenar mean */
extern int n_vardep;
extern int tem_comando;
extern FILE *fout;
extern int iterativo;
extern int med1[MAXMEM];
extern char *efts1[MAXEFTS];
extern char *p2;

contraste(n_d, faux, token)
int n_d;
FILE *faux;
char *token;
{
    int c;
    int i, j, kd;
    int m;
    int cpflag;
    int nm;
    int nc;
    int tcontr;
    char titulo1[128];
    char arquivo[40];
    double *MA;
    double *CA;
    double *PA[2];

    /* ajuste de sv para situacoes que tenham valores escondidos */
    for (i = 0; i <= nef + nd; ++i)
	med1[i] = sv[i];
    for (i = nef + nd; i > 0; --i) {
	if ((j = ef[i][3]) != 0) {
	    med1[j] = med1[i];
	}
    }

    cpflag = 0;
    kd = 0;			/* Controla o n. de variaveis dependentes */
    tcontr = 0;
    f_qm = f_gl = -9.0;
    n_vardep = 0;
    f_erro = 0;

    cpflag = par_cp(&c, token, faux, &kd, &m, &tcontr);

    if (cpflag == 0) {
	/* todos os valores pois nao achou o comando cp */
	m = nxlx;
	cpflag = nef;
	for (i = 0; i < m; ++i)
	    v[i] = i;		/* mapeio o vetor um a um */
    }

  outro:			/* Posicao de retorno caso tenha mais de um C para o mesmo CP */

    nc = 0;			/* Numero de linhas de contraste */
    nm = -1;
    titulo1[0] = 0;

    par_rot(&c, token, titulo1, faux);

    nm = par_m(&c, token, faux);

    if (strcmpi(token, "c") == 0) {
	if ((c = gtoken1(token, faux)) != IGUAL)
	    errocon(4, 1);
	if (!iterativo && !tem_comando)
	    fprintf(fout, "=");
	c = gtoken1(token, faux);
	IMPRIME;
	if (c == VARIAV) {
	    if (strcmpi(token, "pol") == 0) {
		if (f_erro)
		    errocon(26, 1);
		nc = -1;	/*Indica para se gerar os polinomios */
		c = gtoken1(token, faux);
		IMPRIME;
		IMPRIM1;
	    } else {
		nc = -2;	/* Indica c e' um arq. externo */
		strcpy(arquivo, token);
		c = gtoken1(token, faux);
		IMPRIME;
		IMPRIM1;
	    }
	} else {
	    nc = par_c(&c, token, faux, m, &nm);
	}
    }
    if (c != PTVG || (c == PTVG && nc == 0)) {
	errocon(8, 1);
    }

    if (!iterativo && tcontr) {
	for (i = 0; i < kd; ++i) {
	    if (strcmpi(efts1[i], efts[nef + nd + n_d]) == 0) {
		break;
	    }
	}
	if (i == kd) {
	    c = gtoken1(token, faux);
	    return c;
	}
    } else {
	if (iterativo && tcontr) {
	    advert(efts[nd + nef + n_d]);
	}
    }

    if (nc == -1) {		/* Gerar polinomios ortogonais */
	int nefcp;		/* Numero de efeitos no comando cp */
	char ef1[2][15];
	int j, k;
	int mi[2];
	int tipo;

	if (cpflag > 1 || nm > 1)
	    errocon(19, 1);

	nefcp = ver_ef_cp(buffer, ef1[0], ef1[1], &tipo);
	if (nefcp > 1)
	    errocon(19, 1);

	i = m + 1;

	j = 0;
	if (!tipo) {		/* Tipo != Hierarquico */
	    while (j <= nefcp) {
		if (nefcp > 0) {
		    for (k = 0; k < nef + nd; ++k) {
			if (strcmpi(ef1[j], efts[k]) == 0) {
			    i = nv[k] + 1;
			    mi[j] = nv[k];
			    break;
			}
		    }
		    if (k == nef + nd)
			errocon(9, 1);
		}

		MA = (double *)
		    malloc((unsigned) (i * i * sizeof(double)));
		if (MA == (double *) NULL) {
		    errocon(23, 1);
		}

		CA = (double *)
		    malloc((unsigned) (i * i * sizeof(double)));
		if (CA == (double *) NULL) {
		    free((char *) MA);
		    errocon(23, 1);
		}
		PA[j] =
		    (double *) malloc((unsigned) (i * i * sizeof(double)));
		if (PA[j] == (double *) NULL) {
		    free((char *) MA);
		    free((char *) CA);
		    if (j > 0)
			free((char *) PA[0]);
		    errocon(23, 1);
		}

		if (gera(MA, i - 1, ef1[j]) == -1) {
		    free((char *) MA);
		    free((char *) CA);
		    free((char *) PA[0]);
		    if (j > 0)
			free((char *) PA[1]);
		    errocon(5, 1);
		}

		gs(MA, CA, PA[j], i, i);

		free((char *) CA);
		free((char *) MA);
		j++;
	    }
	    if (nefcp > 0) {
		for (i = 1; i <= mi[0]; i++) {
		    for (j = 1; j <= mi[1]; j++) {
			titulo1[0] = 0;
			gera_d(saida, i, j, &nm, &nc, PA[0], PA[1],
			       titulo1, mi[0], mi[1]);
			exe_cp(titulo1, nm, f_qm, f_gl, cpflag, m, n_d,
			       (char *) NULL, 0, 0);
		    }
		}
		free((char *) PA[0]);
		free((char *) PA[1]);
	    } else {
		i = 1;
		while (i < m + 1) {
		    titulo1[0] = 0;
		    gera_c(saida, i, m, &nm, &nc, PA[0], titulo1);
		    exe_cp(titulo1, nm, f_qm, f_gl, cpflag, m, n_d,
			   (char *) NULL, 0, 0);
		    i++;
		}
		free((char *) PA[0]);
	    }
	} else {
	    int l;
	    int p_i;
	    int vi;
	    char tit[60];

	    for (l = 0; l < nef + nd; ++l) {
		if (strcmpi(efts[l], buffer) == 0)
		    break;
	    }

	    j = ef[l][4] - 1;

	    p_i = 0;
	    vi = v[0];
	    for (k = 0; k < nchi[j]; ++k) {

		m = 0;
		for (i = p_i; i < (p_i + nvhi[j][k + 1] - nvhi[j][k] - 1);
		     ++i)
		    v[m++] = v[i];
		p_i = i;

		i = nvhi[j][k + 1] - nvhi[j][k];
		m = i - 1;

		MA = (double *)
		    malloc((unsigned) (i * i * sizeof(double)));
		if (MA == (double *) NULL) {
		    errocon(23, 1);
		}

		CA = (double *)
		    malloc((unsigned) (i * i * sizeof(double)));
		if (CA == (double *) NULL) {
		    free((char *) MA);
		    errocon(23, 1);
		}
		PA[0] =
		    (double *) malloc((unsigned) (i * i * sizeof(double)));
		if (PA[0] == (double *) NULL) {
		    free((char *) MA);
		    free((char *) CA);
		    errocon(23, 1);
		}

		if (gera1(MA, i - 1, buffer, k, tit) == -1) {
		    free((char *) MA);
		    free((char *) CA);
		    free((char *) PA[0]);
		    errocon(5, 1);
		}

		gs(MA, CA, PA[0], i, i);
		free((char *) CA);
		free((char *) MA);

		/* Colocar Subtitulo para imprimir hierar */
		i = 1;
		while (i < m + 1) {
		    titulo1[0] = 0;
		    gera_c(saida, i, m, &nm, &nc, PA[0], titulo1);
		    exe_cp(titulo1, nm, f_qm, f_gl, cpflag, m, n_d, tit, 1,
			   vi);
		    i++;
		}

		free((char *) PA[0]);
	    }
	}
    } else {
	if (nc == -2)
	    nc = leia_c(saida, m, arquivo, &nm);
	exe_cp(titulo1, nm, f_qm, f_gl, cpflag, m, n_d, (char *) NULL, 0,
	       0);
    }
    c = gtoken1(token, faux);
    if (strcmpi(token, "rot") == 0 || strcmpi(token, "rt") == 0 ||
	strcmpi(token, "c") == 0 || strcmpi(token, "m") == 0) {
	IMPRIME;
	goto outro;
    } else {
	f_qm = -9.0;		/* Precisa reinicializar para podermos usar */
	f_gl = -9.0;		/* a mesma variavel para calculo do erro do med */
	return c;
    }
}

/* *** Padroniz. msg erro - Adriana 09/12/94

char *msg_e[] = {
/@ 0 @/ "",
/@ 1 @/ "Nome de contrastes ou 'todos'",
/@ 2 @/ "Contraste nao existe",
/@ 3 @/ "Esperava ';'",
/@ 4 @/ "Esperava '='",
/@ 5 @/ "Esperava um numero",
/@ 6 @/ "Esperava ','",
/@ 7 @/ "Esperava uma variavel",
/@ 8 @/ "Subcomando invalido",
/@ 9 @/ "Efeito nao existe",
/@ 10@/ "Nao consegui abrir arquivo 'modlin.out' para executar 'cp' ou 'med'",
/@ 11@/ "Comando invalido -> Apenas cp, med, compara, multvar, fim ou '}' sao validos",
/@ 12@/ "Esperava um fator ou combinacao de dois fatores",
/@ 13@/ "Nao calcula medias de combinacoes com mais de dois fatores",
/@ 14@/ "Nao pode ser usado para este tipo de fator. (Use comando 'cp')",
/@ 15@/ "Esperava um '#' ao inves de '*'",
/@ 16@/ "Dimensao errada de 'c'. Esperava uma ','",
/@ 17@/ "Divisao por zero no calculo do erro",
/@ 18@/ "Erro de sintax",
/@ 19@/ "Apenas um efeito (de ordem ate 2) e/ou um valor para 'm' pode ser usado com 'pol'",
/@ 20@/ "",
/@ 21@/ "Arquivo nulo ou nao existe",
/@ 22@/ "Dimensao errada de c.",
/@ 23@/ "Erro: Memoria disponivel esgotada.",
/@ 24@/ "Esperava uma Estatistica: duncan, snk, ... ",
/@ 25@/ "Tem que ser especificado formula para: Q.M e G.L",
/@ 26@/ "Nao e' permitido o uso c=pol para efeitos hierarquicos com interacao", 
	0
};

*** */

int msg_e[] = {
    /* 0 */ 9999,
    /* nao usado */
    /* 1 */ 3052,
    /*  Especificacao invalida no comando CP         */
    /* 2 */ 1063,
    /*  Efeito nao existe no modulo                  */
    /* 3 */ 3022,
    /*  Caracter ';' esperado para finalizar comando */
    /* 4 */ 3054,
    /*  Caracter '=' esperado apos a especificacao C ou M do comando CP */
    /* 5 */ 3055,
    /* Especificacao invalida do vetor M ou da matriz C */
    /* 6 */ 9999,
    /* nao usado */
    /* 7 */ 9999,
    /* nao usado */
    /* 8 */ 3056,
    /* Especificacao invalida */
    /* 9 */ 3005,
    /* Especificacao invalida do comando */
    /* 10 */ 5021,
    /* Abertura do arquivo modlin.out para executar CP ou MED */
    /* 11 */ 3063,
    /* Comando CP, MED, COMPARA, MULTVAR, FIM; ou caracter '}' esperado */
    /* 12 */ 3064,
    /* Efeito invalido do comando MED */
    /* 13 */ 3065,
    /*  O comando MED nao calcula medias de combinacoes de mais de dois fatores */
    /* 14 */ 3066,
    /* Especificacao invalida no comando MED */
    /* 15 */ 3067,
    /* Caracter '#' esperado no lugar de '*' */
    /* 16 */ 3068,
    /* Especificacao invalida da matriz C */
    /* 17 */ 7018,
    /* Divisao por zero no calculo do erro */
    /* 18 */ 3005,
    /* Especificacao invalida do comando */
    /* 19 */ 3069,
    /* Este tipo de efeito nao permite a especificacao da matriz C = POL */
    /* 20 */ 9999,
    /* nao usado */
    /* 21 */ 1064,
    /* Arquivo-ntia especificado na matriz C e' nulo ou inexistente */
    /* 22 */ 3071,
    /*  A matriz expecificada no arquivo_ntia tem dimensao invalida */
    /* 23 */ 1039,
    /* Espaco de memoria insuficiente */
    /* 24 */ 3072,
    /* Especificacao invalida da estatistica no comando COMPARA */
    /* 25 */ 3073,
    /* Especificacoes ERRO ou GL invalidas */
    /* 26 */ 3069,
    /* Este tipo de efeito nao permite a especificacao da matriz C = POL */
    0
};

void errocon(n, tipo)
int n;
int tipo;
{
    extern int iterativo;
    extern FILE *faux;

    int ret;

/* *** Padroniz. msg erro - Adriana 20/12/94 
	if (tipo == 0 )
		fprintf(stderr, "\n%s.\nEntre com o comando novamente.\n\n", msg_e[n]);
	if (tipo == 1)
		fprintf(stderr, "\n%s.\nEntre com o comando CP novamente.\n\n", msg_e[n] );
	if (tipo == 2)
		fprintf(stderr, "\n%s.\nEntre com o comando MED novamente.\n\n", msg_e[n] );
	if (tipo == 3)
		fprintf(stderr, "\n%s.\nEntre com o comando COMPARA novamente.\n\n", msg_e[n]);

*** */

    if (tipo == 0)
	fprintf(stderr, "\n%s\nEntre com o comando novamente.\n\n",
		PegaMsg(msg_e[n]));
    if (tipo == 1)
	fprintf(stderr, "\n%s\nEntre com o comando CP novamente.\n\n",
		PegaMsg(msg_e[n]));
    if (tipo == 2)
	fprintf(stderr, "\n%s\nEntre com o comando MED novamente.\n\n",
		PegaMsg(msg_e[n]));
    if (tipo == 3)
	fprintf(stderr, "\n%s\nEntre com o comando COMPARA novamente.\n\n",
		PegaMsg(msg_e[n]));

    while ((n = xgetc(faux)) != '\n' && n != EOF);
    if (iterativo)
	longjmp(env, 1);
    else {
	if (tem_comando) {
/*
#ifdef MSDOS
			_fileno(stdin) = _fileno(faux);
#else
			fileno(stdin) = fileno(faux);
#endif
*/
#ifdef MSDOS
	    ret = _dup2(_fileno(faux), _fileno(stdin));
#else
	    ret = dup2(fileno(faux), fileno(stdin));
#endif
	    unlink("modlin.out");
	}
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(1);
	}
#endif
	exit(1);
    }
}

/* ------------------------------------------------------------------------
** par_cp()
** 	Programado por:	Carlos Paniago & Silvio Evangelista
**	Data:		Janeiro 1989
**	Descricao:	Parse do comando CP.
** ------------------------------------------------------------------------- */

par_cp(c, token, faux, kd, m, tcontr)
int *c;
char *token;
FILE *faux;
int *kd;
int *m;
int *tcontr;
{
    int n, i, cpflag;
    cpflag = 0;

    /* estou fazendo o parse do comando cp */
    if ((*c = gtoken1(token, faux)) != VARIAV && *c != PTVG && *c != VG)
	errocon(1, 1);
    IMPRIME;
    if (*c != PTVG) {
	if (*c == VG) {
	    yyparse();
	    if ((f_qm == -9.0 && f_gl != -9.0) ||
		(f_qm != -9.0 && f_gl == -9.0))
		errocon(25, 1);
	    if (n_vardep > 0) {
		*tcontr = 1;
		*kd = n_vardep;
	    }
	    *c = gtoken1(token, faux);
	    IMPRIME;
	} else {
	    *m = 0;		/* contador de niveis de iteracao */
	    do {
		buffer[0] = '\0';
	      l1:;
		do {
		    strcat(buffer, token);
		    *c = gtoken1(token, faux);
		    IMPRIME;
		    if (*c == STAR) {
			strcat(buffer, "*");
			n = gtoken1(token, faux);
			IMPRIME;
		    }
		} while (*c == STAR);
		if (*c == LP) {
		    strcat(buffer, "(");
		    while ((*c = gtoken1(token, faux)) != RP) {
			strcat(buffer, token);
			strcat(buffer, " ");
			IMPRIME;
		    }
		    IMPRIME;
		    buffer[strlen(buffer) - 1] = '\0';
		    strcat(buffer, ")");
		    *c = gtoken1(token, faux);
		    IMPRIME;
		}
		if (*c == STAR) {
		    strcat(buffer, "*");
		    *c = gtoken1(token, faux);
		    IMPRIME;
		    f_erro = 1;	/* Para Uso em c= pol */
		    goto l1;
		}

		for (i = 0; i <= nef + nd; ++i) {
		    if (ef[i][3] == 0) {
			if (strcmpi(efts[i], buffer) == 0) {
			    cpflag++;
			    for (n = med1[i]; n < med1[i + 1]; n++)
				v[(*m)++] = n;
			    break;
			}
		    }
		}
		if (i > nef + nd) {
		    fprintf(stderr, "<%s> ", buffer);
		    errocon(9, 1);
		}
	    } while (*c == VARIAV);
	    if (*c == VG) {
		yyparse();
		if ((f_qm == -9.0 && f_gl != -9.0) ||
		    (f_qm != -9.0 && f_gl == -9.0))
		    errocon(25, 1);
		if (n_vardep > 0) {
		    *tcontr = 1;
		    *kd = n_vardep;
		}
	    } else {
		if (*c != PTVG)
		    errocon(3, 1);
	    }
	    *c = gtoken1(token, faux);
	    IMPRIM1;
	    IMPRIME;
	    /* terminou o parser do cp */
	}
    } else {
	*c = gtoken1(token, faux);
	IMPRIM1;
	IMPRIME;
    }
    return cpflag;
}

void par_rot(c, token, titulo1, faux)
int *c;
char *token;
char *titulo1;
FILE *faux;
{
    int i;

    if ((strcmpi(token, "rt") == 0) || (strcmpi(token, "rot") == 0)
	|| (strcmpi(token, "rotulo") == 0)) {
	while ((*c = xgetc(faux)) == ' ' || *c == '\t' || *c == '\n' || *c == '\r');	/* tira brancos a direita */
	i = 0;
	while (*c != ';' && i < 128) {
	    titulo1[i++] = (char) *c;
	    if (!iterativo && !tem_comando)
		fprintf(fout, "%c", *c);
	    *c = xgetc(faux);
	}
	if (!iterativo && !tem_comando)
	    fprintf(fout, "%c\n", *c);
	titulo1[i] = 0;
	*c = gtoken1(token, faux);
	IMPRIME;
    }				/* terminou de processar o titulo */
}

par_m(c, token, faux)
int *c;
char *token;
FILE *faux;
{
    int nm;
    nm = -1;
    if (strcmpi(token, "m") == 0) {
	nm = 0;
	/* vetor M'= */
	if ((*c = gtoken1(token, faux)) != IGUAL)
	    errocon(4, 1);
	if (!iterativo && !tem_comando)
	    fprintf(fout, "=");
	while ((*c = gtoken1(token, faux)) != PTVG) {
	    if (!iterativo && !tem_comando)
		fprintf(fout, "%s ", token);
	    if (*c != NUMBER)
		errocon(5, 1);
	    css[nm++] = atof(token);
	}
	IMPRIME;
	IMPRIM1;
	*c = gtoken1(token, faux);
	IMPRIME;
    }
    return nm;
}

par_c(c, token, faux, m, nm)
int *c;
char *token;
FILE *faux;
int m;
int *nm;
{
    int i;
    int j;
    int nc;

    /* vetor C= */
    nc = j = 0;
    i = 1;
    while (*c != PTVG) {
	if (j++ == m) {
	    if (*c == VG) {
		IMPRIM1;
		*c = gtoken1(token, faux);
		IMPRIME;
		j = 1;
	    } else {
		errocon(16, 1);
	    }
	    ++i;
	}
	if (*c != NUMBER && *c != PTVG)
	    errocon(5, 1);
	if (*c != PTVG)
	    saida[nc++] = atof(token);
	*c = gtoken1(token, faux);
	IMPRIME;
    }
    IMPRIM1;

    if (*nm == -1) {
	for (*nm = 0; *nm < i; ++(*nm)) {
	    css[*nm] = 0.0;
	}
    }
    if (j != m || i != *nm) {

/* *** Padroniz. msg erro - Adriana 07/12/94
		fprintf(stderr, "\nErro comando cp: Dimensao correta de c e' (%d,%d) e nao c(%d,%d).\n Reinicie comando.\n\n", *nm, m, i, j);
*** */

	fprintf(stderr, PegaMsg(3025), *nm, m);
	/* errocon(0,8);  ** nao e' necessario */
    }
    return nc;
}

void exe_cp(titulo1, nm, f_qm, f_gl, cpflag, m, n_d, tit, tipo, vi)
char *titulo1;
int nm;
double f_qm;
double f_gl;
int cpflag;
int m;
int n_d;
char *tit;
int tipo;
int vi;
{
    int n1;
    double x1, sqc, qmc, valorF;
    double qm;			/* Armazena o qm do erro a ser usado */
    double qm1;			/* Variaveis temporarias para armazenar qm especifico */
    double qm2;			/* de um efeito e verificar se todos sao iguais */
    TINT id;
    int i, n, j, l, k;

    qm2 = -9.0;

    /* calculo da estimativa E = C*B-M */
    n = 0;
    for (i = 0; i < nm; ++i) {
	x1 = 0.0;
	for (j = 0; j < m; ++j) {
	    x1 += saida[n++] * xlx[idx(nxlx, v[j])];
	}
	mean1[i] = x1 - css[i];
    }
    /* Calcular C*INV(XLX)*C' e colocar em sse[] */
    for (i = 0; i < nm; ++i) {
	for (k = 0; k <= i; ++k) {
	    x1 = 0.0;
	    for (j = 0; j < m; ++j) {
		for (l = 0; l < m; ++l) {
		    x1 += saida[i * m + j] * saida[k * m + l] *
			xlx[idx(v[j], v[l])];
		}
	    }
	    id = idx(i, k);
	    sse[id] = x1;
	}
    }

    putchar1();
    imptitulo("Comparacao de parametros do modelo");
    printf("\t\t\t\tVariavel: %-8.8s\n", efts[nd + nef + n_d]);
    if (tit != (char *) NULL)
	printf("\t\t\t\tNivel: %-15.15s\n", tit);

    printf
	("\n               Estimativa     Desvio Padrao  Valor|T|   PR>|T|\n\n");

    /* ----------------------------------------------------------------- */
    /* ------ Este Codigo Abaixo e' responsavel de pegar o erro correto */

    qm = (f_qm == -9.0) ? qmr : f_qm;	/* Usar qmres ou gerado pela form */
    n = (f_gl == -9.0) ? (int) glr : (int) f_gl;

    if (f_qm == -9.0) {
	int kk;
	kk = 0;

	for (i = 0; i < cpflag; ++i) {
	    if (tipo)
		k = vi;
	    else
		k = v[kk];
	    for (j = 0; j <= nef + nd; ++j) {
		if (k == sv[j]) {
		    kk += (sv[j + 1] - sv[j]);
		    qm1 = (ef[j][2] == 0) ? qmr : obs[ef[j][2]];
		    n1 = (ef[j][2] == 0) ? glr : nv[ef[j][2]];
		    if (qm2 != -9.0 && qm1 != qm2)
			break;
		    else
			qm2 = qm1;
		}
	    }
	    if (j <= nef + nd)
		break;
	}
	if (i == cpflag && j > nef + nd && qm2 != -9.0) {
	    qm = qm1;
	    n = n1;
	}
    }

    for (i = 0; i < nm; ++i) {
	x1 = sse[idx(i, i)] * qm;
	if (x1 >= 1.e-10)
	    qm1 = (mean1[i] * mean1[i]) / x1;
	else
	    qm1 = 9999.99;

	printf("%7.7s %17s %17s %9s %8.3lf\n",
	       " ",
	       rounddec(mean1[i], 17, 8), rounddec(sqrt(x1), 17, 8),
	       rounddec(sqrt(qm1), 9, 4), fprob(qm1, 1.0, (double) n));
    }

    /* ----------------------------------------------------------------- */
    /* calculo da sqc para a comparacao */
    /* ----------------------------------------------------------------- */

    for (j = 0; j < nm; ++j) {
	id = idx(nm, j);
	sse[id] = mean1[j];
    }
    id = idx(nm, nm);
    sse[id] = 0.0;		/* acrecentou uma linha */
    sqc = doolitle(sse, nm + 1);

    qmc = sqc / ((double) nm);
    if (fabs(qm) < 1e-14)
	valorF = 99999.99;
    else
	valorF = qmc / qm;

    if (valorF > 10000.0)
	valorF = 9999.999;

    printf
	("\nComparacao              gl Soma de quadrados   Quadrado medio   Valor F  PR > F\n\n");
    printf("%-20.20s  %4d %17s %16s %9s  %6.3lf\n", titulo1, nm,
	   rounddec(sqc, 17, 8), rounddec(qmc, 16, 8), rounddec(valorF, 9,
								4),
	   fprob(valorF, (double) nm, (double) n));
    printf("%-20.20s  %4d %17s %16s\n", "Erro", n,
	   rounddec(qm * ((double) n), 17, 8), rounddec(qm, 16, 8));

}

gera(MA, m, buffer)
double *MA;
int m;
char *buffer;
{
    extern int nclass;
    extern int proximo;
    int l, j, i, k, n;
    double x;
#ifdef EDIX
    double *dp;
#endif

    for (i = 0; i < nclass; ++i) {
	if (strcmpi((char *) (ivar + (soma[i])), buffer) == 0)
	    break;
    }
    l = j = i;
    k = 0;

    while ((j = lista[l].prox)) {
	if (!numero(lista[l].q))
	    return (-1);

	x = atof(lista[l].q);
	l = j;

	for (n = 0; n < m + 1; n++) {
	    if (n == 0) {
#ifdef EDIX
		dp = &(DADOij(MA, k, n, m + 1));
		*dp = 1.0;
#else
		DADOij(MA, k, n, m + 1) = 1.0;
#endif
	    } else {
#ifdef EDIX
		dp = &(DADOij(MA, k, n, m + 1));
		*dp = pow(x, (double) n);
#else
		DADOij(MA, k, n, m + 1) = pow(x, (double) n);
#endif
	    }
	}
	k++;
    }
    return 0;
}

gera1(MA, m, buffer, l1, tit)
double *MA;
int m;
char *buffer;
int l1;
char *tit;
{
    extern int nclass;
    extern int proximo;
    int l, j, i, k, n;
    double x;
    char buf[30];
    int flag;
#ifdef EDIX
    double *dp;
#endif

    /* Posicionar na lista de efeitos */
    i = 0;
    for (l = 0; l < nef + nd; ++l) {
	if (strcmpi(buffer, efts[l]) == 0)
	    break;
	if (ef[l][0] == 0
	    || (ef[l][4] > 0 && (ef[l][0] <= 0 || ef[l][1] < 0)))
	    i++;

    }

    for (l = 0; l < (int) strlen(buffer); l++) {
	if (buffer[l] == '(')
	    break;
    }
    k = 0;
    for (j = l + 1; j < (int) strlen(buffer); j++) {
	if (buffer[j] == ')')
	    break;
	else
	    tit[k++] = buffer[j];
    }
    tit[k] = '\0';
    strcat(tit, " = ");

    l = j = i;
    k = 0;
    i = 0;
    flag = 1;

    strcpy(buf, elemento(lista[l].q, 1));

    while ((j = lista[l].prox)) {

	/* Posicionar na posicao da lista correta */
	if (i == l1) {
	    if (strcmpi(elemento(lista[l].q, 1), buf) != 0)
		return 0;
	    if (!numero(elemento(lista[l].q, 2)))
		return (-1);

	    x = atof(elemento(lista[l].q, 2));
	    if (flag) {
		strcat(tit, elemento(lista[l].q, 1));
		flag = 0;
	    }

	    for (n = 0; n < m + 1; n++) {
		if (n == 0) {
#ifdef EDIX
		    dp = &(DADOij(MA, k, n, m + 1));
		    *dp = 1.0;
#else
		    DADOij(MA, k, n, m + 1) = 1.0;
#endif
		} else {
#ifdef EDIX
		    dp = &(DADOij(MA, k, n, m + 1));
		    *dp = pow(x, (double) n);
#else
		    DADOij(MA, k, n, m + 1) = pow(x, (double) n);
#endif
		}
	    }
	    l = j;
	    k++;
	} else {
	    if (strcmpi(elemento(lista[l].q, 1), buf) != 0) {
		strcpy(buf, elemento(lista[l].q, 1));
		i++;
	    } else
		l = j;
	}
    }
    return 0;
}

char *elemento(q, pos)
char *q;
int pos;
{
    int i, j;
    static char s[40];

    j = 0;
    if (pos == 1) {
	for (i = 0; i < (int) strlen(q); ++i) {
	    if (q[i] == '+' || q[i] == ' ') {
		s[j] = '\0';
		return s;
	    } else
		s[j++] = q[i];
	}
    }

    if (pos == 2) {
	for (i = strlen(q); i >= 0; --i)
	    if (q[i] == ' ')
		break;
	for (i = i + 1; i <= (int) strlen(q); ++i) {
	    s[j++] = q[i];
	}
	return s;
    }

    return (char *) NULL;
}

void gera_c(saida, k, m, nm, nc, PA, titulo1)
double *saida;
int k;
int m;
int *nm;
int *nc;
double *PA;
char *titulo1;
{
    int i;
    static char buffer[30];

    *nc = 0;
    strcpy(titulo1, "Grau");
    strcat(titulo1, itoa(k, buffer, 10));
    for (i = 0; i < m; i++) {
	saida[(*nc)++] = DADOij(PA, i, k, m + 1) - DADOij(PA, m, k, m + 1);
    }
    if (*nm == -1) {
	*nm = 1;
	css[0] = 0.0;
    }
}

void gera_d(saida, i, j, nm, nc, PA0, PA1, titulo1, i1, j1)
double *saida, *PA0, *PA1;
int i, j;
int *nm, *nc;
char *titulo1;
int i1, j1;
{
    int t1, t2;
    char buffer[20];

    strcpy(titulo1, "G");
    strcat(titulo1, itoa(i, buffer, 10));
    strcat(titulo1, " X ");
    strcat(titulo1, " G ");
    strcat(titulo1, itoa(j, buffer, 10));

    *nc = 0;
    for (t1 = 0; t1 < i1; t1++) {
	for (t2 = 0; t2 < j1; t2++) {
	    saida[(*nc)++] =
		(DADOij(PA0, t1, i, i1 + 1) - DADOij(PA0, i1, i, i1 + 1)) *
		(DADOij(PA1, t2, j, j1 + 1) - DADOij(PA1, j1, j, j1 + 1));
	}
    }
    if (*nm == -1) {
	*nm = 1;
	css[0] = 0.0;
    }
}

void gs(a, t, p, lin, col)
double *a;
double *t;
double *p;
int lin;
int col;
{
    int i, k, j, l, l1;

    double *q;
    double *s;
#ifdef EDIX
    double *dp;
#endif

    s = (double *) malloc((unsigned) (lin * sizeof(double)));
    if (s == (double *) NULL) {
	errocon(23, 1);
    }
    q = (double *) malloc((unsigned) (lin * sizeof(double)));
    if (q == (double *) NULL) {
	free((char *) s);
	errocon(23, 1);
    }
#ifdef EDIX
    dp = &(DADOij(t, 0, 0, col));
    *dp = 0.;
#else
    DADOij(t, 0, 0, col) = 0.;
#endif

    for (i = 0; i < lin; i++) {
#ifdef EDIX
	dp = &(DADOij(t, 0, 0, col));
	*dp += DADOij(a, i, 0, col) * DADOij(a, i, 0, col);
#else
	DADOij(t, 0, 0, col) +=
	    DADOij(a, i, 0, col) * DADOij(a, i, 0, col);
#endif
    }
#ifdef EDIX
    dp = &(DADOij(t, 0, 0, col));
    *dp = sqrt(DADOij(t, 0, 0, col));
#else
    DADOij(t, 0, 0, col) = sqrt(DADOij(t, 0, 0, col));
#endif

    for (i = 0; i < lin; i++) {
	if (fabs(DADOij(t, 0, 0, col)) < TOL) {
#ifdef EDIX
	    dp = &(DADOij(p, i, 0, col));
	    *dp = 0.;
#else
	    DADOij(p, i, 0, col) = 0.;
#endif
	} else {
#ifdef EDIX
	    dp = &(DADOij(p, i, 0, col));
	    *dp = DADOij(a, i, 0, col) / DADOij(t, 0, 0, col);
#else
	    DADOij(p, i, 0, col) =
		DADOij(a, i, 0, col) / DADOij(t, 0, 0, col);
#endif
	}
    }

    for (k = 1; k < col; ++k) {
#ifdef EDIX
	dp = &(DADOij(t, k, k, col));
	*dp = 0.;
#else
	DADOij(t, k, k, col) = 0.;
#endif
	for (i = 0; i < k; ++i) {
#ifdef EDIX
	    dp = &(DADOij(t, i, k, col));
	    *dp = 0.;
#else
	    DADOij(t, i, k, col) = 0.;
#endif
	    for (j = 0; j < lin; ++j) {
#ifdef EDIX
		dp = &(DADOij(s, j, 0, 1));
		*dp = 0.;

		dp = &(DADOij(t, i, k, col));
		*dp += DADOij(p, j, i, col) * DADOij(a, j, k, col);
#else
		DADOij(s, j, 0, 1) = 0.;
		DADOij(t, i, k, col) +=
		    DADOij(p, j, i, col) * DADOij(a, j, k, col);
#endif
	    }
	}
	for (l = 0; l < k; ++l)
	    for (l1 = 0; l1 < lin; ++l1) {
#ifdef EDIX
		dp = &(DADOij(s, l1, 0, 1));
		*dp += DADOij(t, l, k, col) * DADOij(p, l1, l, col);
#else
		DADOij(s, l1, 0, 1) +=
		    DADOij(t, l, k, col) * DADOij(p, l1, l, col);
#endif
	    }
	for (j = 0; j < lin; ++j) {
#ifdef EDIX
	    dp = &(DADOij(q, j, 0, 1));
	    *dp = DADOij(a, j, k, col) - DADOij(s, j, 0, 1);

	    dp = &(DADOij(t, k, k, col));
	    *dp += DADOij(q, j, 0, 1) * DADOij(q, j, 0, 1);
#else
	    DADOij(q, j, 0, 1) = DADOij(a, j, k, col) - DADOij(s, j, 0, 1);
	    DADOij(t, k, k, col) +=
		DADOij(q, j, 0, 1) * DADOij(q, j, 0, 1);
#endif
	}
#ifdef EDIX
	dp = &(DADOij(t, k, k, col));
	*dp = sqrt(DADOij(t, k, k, col));
#else
	DADOij(t, k, k, col) = sqrt(DADOij(t, k, k, col));
#endif

	for (j = 0; j < lin; j++) {
	    if (fabs(DADOij(t, k, k, col)) < TOL) {
#ifdef EDIX
		dp = &(DADOij(p, j, k, col));
		*dp = 0.;
#else
		DADOij(p, j, k, col) = 0.;
#endif
	    } else {
#ifdef EDIX
		dp = &(DADOij(p, j, k, col));
		*dp = DADOij(q, j, 0, 1) / DADOij(t, k, k, col);
#else
		DADOij(p, j, k, col) =
		    DADOij(q, j, 0, 1) / DADOij(t, k, k, col);
#endif
	    }
	}
    }

    free((char *) s);
    free((char *) q);
}

ver_ef_cp(buffer, ef1, ef2, tipo)
char *buffer;
char *ef1;
char *ef2;
int *tipo;
{
    int nefcp, i, n;
    nefcp = 0;
    n = 0;
    *tipo = 0;

    for (i = 0; i <= (int) strlen(buffer); i++) {
	if (buffer[i] != '*' && buffer[i] != '(' && buffer[i] != ' ') {
	    if (buffer[i] != ')') {
		if (nefcp == 0) {
		    ef1[n++] = buffer[i];
		}
		if (nefcp == 1) {
		    ef2[n++] = buffer[i];
		}
	    } else
		*tipo = 1;
	} else {
	    if (nefcp == 0)
		ef1[n] = '\0';
	    if (nefcp == 1)
		ef2[n] = '\0';
	    nefcp++;
	    n = 0;
	}
    }
    return nefcp;
}

leia_c(saida, m, arquivo, nm)
double *saida;
int m;
char *arquivo;
int *nm;
{
    ARQ *parq;
    char *obs[OBSSIZE];
    int nc, n, i, j;
    long ret;

    if ((ret = (long) (parq = abre_arq(arquivo, 0, 1))) < 0L && ret > -5L) {
	errocon(21, 1);
    }

    nc = parq->nvar;

    if (nc != m) {
	errocon(22, 1);
    }

    if (ler_obs(parq, obs) < 0L) {
	fech_arq(parq);
	errocon(21, 1);
    }
    n = 0;
    for (i = 0; i < nc; ++i) {
	saida[n++] = atof(obs[i]);
    }

    j = 1;
    while (ler_obs(parq, obs) >= 0L) {
	++j;
	for (i = 0; i < nc; ++i) {
	    saida[n++] = atof(obs[i]);
	}
    }
    if (*nm == -1) {
	for (*nm = 0; *nm < j; ++(*nm)) {
	    css[*nm] = 0.0;
	}
    }
    if (j != *nm) {
	errocon(22, 1);
    }
    fech_arq(parq);
    return n;
}

void advert(s)
char *s;
{
    fprintf(stderr,
	    "\nAdvertencia: No modo interativo a especificacao da variavel dependente para");
    fprintf(stderr,
	    "\n             efetuar comparacoes entre parametros do modelo e' desprezada.");
    fprintf(stderr,
	    "\n             As comparacoes serao efetuadas para a variavel %s.\n\n",
	    s);
}
