
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	A partir da linha lida (saida) cria a matriz z'z fazendo o somatorio
	dos produtos cruzados

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/criaxlx.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "pcsgbd.h"

static char *sccsid = "@(#)criaxlx.c	3.2	(NTIA/modlin)	94/12/20";

extern double mean1[MAXMEM];
extern double t5[MAXMEM];
extern int fatual_xlx;

void cria_xlx()
{
    int i, j, m;
    double d, e;
    TINT id;

    m = 0;
    for (i = 0; i < ndim; ++i) {
	if (mean1[i] == 0.0) {
	    d = saida[i];
	    if (d != 0.0) {
		id = idx(m, 0);
		for (j = 0; j <= i; ++j) {
		    if (mean1[j] == 0.0) {
			if ((e = saida[j]) != 0.0) {
			    /* substitui idx */
			    xlx[id] += (d * e);
			}
			++id;
		    }
		    /* pois idx(i,j) e' equivalente a soma de id */
		}
	    }
	    m++;
	}
    }
    if (pflag) {
	for (i = 0; i < ndim - 1; ++i)
	    printf("%2s ", rounddec(saida[i], 2, 0));
	printf("%5s\n", rounddec(saida[i], 5, 2));
    }
}

/* ------------------------------------------------------------------------
** ver_xlx
** 	Programado por:	Silvio Evangelista
**	Data:		Fev. 1989
**	Descricao:	A partir dos tipos de efeitos tirar as colunas
**			de xlx que sao apenas covariaveis e acumulam em
**			outro lugar.
**	Rot. chamadas:	Nenhuma
**	Variaveis ent.	ndim, nxlx, nv, sv, nef, xlx
**			Estas variaveis serao modificadas se a situacao
**			acima ocorrer.
**	Variaveis sai.	Nenhuma
**	Impressao	Nada
** ------------------------------------------------------------------------- */

void ver_xlx()
{
    /* Var. Utilizada para guardar tmp os efts que serao atualizados */
    extern int med1[MAXMEM];
    /* ------------------------------------------------------------- */

    int i, j, l, l1, flag;

    for (i = 0; i <= nef + nd; ++i) {
	med1[i] = 0;
	t5[i] = 0.0;
    }
    flag = 0;

    for (i = 0; i <= nef + nd; ++i) {
	if ((ef[i][0] == -1 || ef[i][1] < 0) && ef[i][3] > 0) {

	    flag = 1;
	    l = 0;
	    l1 = 0;
	    ndim -= nv[i];
	    nxlx -= nv[i];

	    for (j = i; j < nef + nd; j++) {
		if (l != ef[j][3]) {
		    med1[ef[j][3]]++;
		}
		if (l1 != ef[j][2]) {
		    t5[ef[j][2]] += 1.0;
		}
		l = ef[j][3];
		l1 = ef[j][2];

		nv[j] = nv[j + 1];
		efts[j] = efts[j + 1];
		ef[j][0] = ef[j + 1][0];
		ef[j][1] = ef[j + 1][1];
		ef[j][2] = ef[j + 1][2];
		ef[j][3] = ef[j + 1][3];
		ef[j][4] = ef[j + 1][4];
	    }
	    nef--;
	    i--;
	}
    }
    if (flag) {
	sv[0] = 0;
	for (i = 0; i <= nef + nd; ++i) {
	    if (i) {
		sv[i] = sv[i - 1] + nv[i - 1];
	    }

	    if (ef[i][2] > 0)
		ef[i][2] = ef[i][2] - (int) t5[ef[i][2]];
	    if (ef[i][3] > 0)
		ef[i][3] = ef[i][3] - med1[ef[i][3]];
	}
	sv[i] = sv[i - 1] + 1;
	if (pflag)
	    print_par();
    }
}

/* ------------------------------------------------------------------------
** ver1_xlx
** 	Programado por:	Silvio Evangelista
**	Data:		Ago. 1989
**	Descricao:	Esta funcao e' responsavel em retirar as colunas 
**			de xlx == 0.
**	Rot. chamadas:	Nenhuma
**	Variaveis ent.	ndim, nxlx, nv, sv, nef, xlx
**			Estas variaveis serao modificadas se a situacao
**			acima ocorrer.
**	Variaveis sai.	Nenhuma
**	Impressao	Nada
** ------------------------------------------------------------------------- */

void ver1_xlx()
{
    int i, j, m;
    int k, n;

    for (i = 0; i < ndim; i++) {
	for (j = i; j < ndim; j++) {
	    m = idx(j, i);
	    if (xlx[m] != 0.0)
		break;
	}
	if (j >= ndim) {
	    for (k = i; k < ndim - 1; k++) {
		for (j = k + 1; j < ndim; j++) {
		    m = idx(j, k);
		    n = idx(j, k + 1);
		    xlx[m] = xlx[n];
		}
	    }
	    for (k = i; k < ndim - 1; k++) {
		for (j = 0; j <= k; j++) {
		    m = idx(k, j);
		    n = idx(k + 1, j);
		    xlx[m] = xlx[n];
		}
	    }
	    ndim--;
	    nxlx--;
	    for (j = 0; j <= nef + nd; ++j) {
		if (i >= sv[j] && i < sv[j + 1])
		    break;
	    }
	    nv[j]--;
	    if (i == sv[j])
		sv[j] = sv[j] - 1;
	    for (k = j + 1; k <= nef + nd + 1; ++k) {
		sv[k] = sv[k] - 1;
	    }
	    i--;
	}
    }
}
