
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Imprime uma mensagem de erro e termina a execucao caso este erro seja
	de alocacao de memoria ou fim de arquivo

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/erro_mod.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"

#include <stdlib.h>

#ifdef MSDOS
#include <io.h>
#endif

#include <malloc.h>

#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)erro_mod.c	3.6	(NTIA/modlin)	95/05/12";



/* *** Padroniz. msg erro - Adriana 12/12/94

char *erro_mod[] = {
	"Esperava uma variavel", 
	"Variavel nao existe no arquivo",
	"Comando precisa ser 'mod'",
	"Opcao <x> ou [x] precisa terminar",
	"Falta '='", 
	"Numero de variaveis > MAXMEM", 
	"Produto dos niveis > MAXMEM1", 
	"Fim de arquivo em momento inesperado",
	"O Modelo nao pode comecar com esfecificacao do erro a ser usado",
	"Efeito referente ao erro nao especificado no modelo", 
	"A mesma variavel dependente usada mais de uma vez",
	"Efeito tem que ser especificado no modelo", 
	"Efeito especificado de forma errada: O correto seria a*b(c)",
	"Numero maximo de variaveis no CLASS e' de MAXBY",
	"Modelo escrito de forma incorreta",
	"Numero maximo de variaveis dependentes e' 8",
	"Esperava um ';'",
	"Arquivo nao ordenado pela(s) variavel(is) do comando CLASS",
	"Comando MULTVAR nao pode ser utilizado com o comando CLASS",
 	0
};

*** */

int erro_mod[] = {
    3057,			/*Especificacao invalida do comando MOD */
    1062,			/*Variavel inexistente no arquivo */
    3005,			/*Especificacao invalida do comando */
    3058,			/*Especificacao invalida de covariavel */
    3023,			/*Caracter '=' esperado apos a especificacao ORD */
    1084,			/*Numero de parametros do modelo ultrapassou o limite operacional */
    1084,			/*Numero de parametros do modelo ultrapassou o limite operacional */
    9999,			/* nao usado */
    3059,			/*O efeito_erro nao pode ser usado como primeiro efeito do modelo */
    3060,			/*Efeito especificado como efeito_erro nao esta' definido no modelo */
    3061,			/*A mesma variavel dependente especificada mais de uma vez */
    9999,			/* nao usado */
    9999,			/* nao usado */
    1081,			/*O numero maximo de variaveis no comando CLASS e' 8 */
    3057,			/*Especificacao invalida no comando MOD */
    1090,			/*O numero maximo de variaveis dependentes e' 8 */
    3022,			/*Caracter ';' esperado para finalizar comando */
    1082,			/*Arquivo nao ordenado pela(s) variavel(is) do comando CLASS */
    3062,			/*Comando MULTVAR nao pode ser utilizado com o comando CLASS */
    0
};

void erromod(n)
int n;
{
    extern FILE *faux;
    extern int iterativo;
    extern int tem_comando;

    int ret;

    if (n >= 5 && n < 9 || n == 17) {	/* Erro de Alocacao */

/* *** Padroniz. msg erro - Adriana 07/12/94
		fprintf(stderr, "\nErro: %s. \n\n", erro_mod[n]);
*** */

	fprintf(stderr, "\n%s \nEntre com o comando novamente.\n",
		PegaMsg(erro_mod[n]));
	if (xlx != (double MY_HUGE *) NULL)
	    HFREE((char MY_HUGE *) xlx);
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(3 + n);
	}
#endif

	exit(3 + n);
    }

/* *** Padroniz. msg erro - Adriana 07/12/94
	fprintf(stderr, "\nErro: %s. Reinicie comando.\n\n", erro_mod[n]);
*** */

    fprintf(stderr, "\n%s\nEntre com o comando novamente.\n",
	    PegaMsg(erro_mod[n]));

    while ((n = xgetc(stdin)) != '\n' && n != EOF);
    if (iterativo)
	longjmp(env, -1);
    else {
	if (tem_comando)
#ifdef MSDOS
	    ret = _dup2(_fileno(faux), _fileno(stdin));
#else
	    ret = dup2(fileno(faux), fileno(stdin));
#endif
/*
#ifdef MSDOS
			_fileno(stdin) = _fileno(faux);
#else
			fileno(stdin) = fileno(faux);
#endif
*/
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(1);
	}
#endif
	exit(1);
    }
}

void erromult(n)
int n;
{
/* *** Padron. msg erro - Adriana 20/12/94
	fprintf(stderr, "\n%s.\nEntre com o comando novamente.\n", erro_mod[n]);
*** */

    fprintf(stderr, "\n%s\nEntre com o comando novamente.\n",
	    PegaMsg(erro_mod[n]));

    while ((n = xgetc(stdin)) != '\n' && n != EOF);

    if (xlx != (double MY_HUGE *) NULL)
	HFREE((char MY_HUGE *) xlx);
    libera();
    setOSstdin();
#ifdef  MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("modlin");
	exit(1);
    }
#endif
    exit(1);
}
