
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	A partir da linha da box. lida cria a linha da matriz expandida z'z

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/expand.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include <stdlib.h>
#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

static char *sccsid = "@(#)expand.c	3.2	(NTIA/modlin)	94/12/20";

void expand_mat()
{
    int i, j, k, l, t1;
    int m, n, ob;
    double x;

    for (i = 1; i <= nef + nd; ++i) {
	if (ef[i][0] == 0 || ef[i][4] > 0) {
	    if (ef[i][4] == 0) {
		m = abs(ef[i][1]) - 1;
		l = (obs[m] > (double) nv[i]) ? -1 : 0;
		for (j = sv[i]; j < sv[i + 1]; ++j) {
		    if (((int) obs[m]) == (j - sv[i] + 1))
			saida[j] = 1.;
		    else
			saida[j] = (double) l;
		}
	    } else {
		m = abs(ef[i][1]) - 1;
		n = ef[i][4] - 1;
		ob = (int) obs[m];
		if (ef[i][0] < 0) {
		    x = atof(xobs[hi[n][0]]);
		} else {
		    for (k = 0; k < nchi[n]; ++k) {
			if (ob >= nvhi[n][k] && ob <= nvhi[n][k + 1])
			    break;
		    }
		    x = (double) (nvhi[n][k + 1] - 1);
		    l = ((double) ob > x) ? -1 : 0;
		}
		for (j = sv[i]; j < sv[i + 1]; ++j) {
		    t1 = j - sv[i];
		    if (ef[i][0] == 0) {
			if (t1 >= (nvhi[n][k] - k) &&
			    t1 < (nvhi[n][k + 1] - 1 - k)) {
			    if ((ob - k) == (t1 + 1))
				saida[j] = 1.;
			    else
				saida[j] = (double) l;
			} else
			    saida[j] = 0.;
		    } else {
			saida[j] = (ob == (t1 + 1)) ? x : 0.;
		    }
		}
	    }
	} else if (ef[i][0] < 0) {
	    j = sv[i];
	    saida[j] = obs[abs(ef[i][1]) - 1];
	} else {
	    m = ef[i][0];
	    n = abs(ef[i][1]);
	    l = sv[i];
	    for (j = sv[m]; j < sv[m + 1]; ++j) {
		for (k = sv[n]; k < sv[n + 1]; ++k) {
		    saida[l++] = saida[j] * saida[k];
		}
	    }
	}
    }
}
