
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/expande.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

static char *sccsid = "@(#)expande.c	3.2	(NTIA/modlin)	94/12/20";


extern int qt[MAXMEM];
extern int s[MAXMEM];
extern int pp[3 * MAXMEM];
extern int ff[MAXMEM];
extern int nv[MAXMEM1];
extern int v[MAXMEM1];		/* Sera utilizado para armazenar a posicao
				   do efeito dentro da iteracao */
extern int numpar;
extern int lef;
extern int novo_k2;
extern char *efts1[MAXEFTS];
extern int cerro[MAXEFTS];
extern char *p1;

expande(n)
int n;
{
    int i, j, k, l;
    int i1;
    int k1, k2;
    int k4;
    int k5;
    int k6;
    int k7;			/* Numero de fat. hier. que serao gerados */
    int num;
    char buf1[128];

    k2 = 0;
    l = 0;
    num = 0;

    for (i = 0; i < MAXMEM1; ++i) {
	v[i] = -1;
	nv[i] = -1;
    }

    for (i = 0; i < qtde[n]; ++i) {
	qt[num] = 1;
	s[num] = l;
	k1 = pos[sv[n] + i];

	pp[l++] = k1;

	k2 += veri_fica(num);
	k = num++;
	for (j = 0; j < k; ++j) {
	    qt[num] = 1 + qt[j];
	    s[num] = l;
	    for (i1 = 0; i1 < qt[j]; ++i1) {
		pp[l++] = pp[s[j] + i1];
	    }

	    pp[l++] = k1;

	    k2 += veri_fica(num);
	    ++num;
	}
    }
    k4 = 1;
    for (i = 0; i < num; ++i) {
	if (v[pp[s[i]]] == -1) {
	    v[pp[s[i]]] = k4;
	    k4++;
	}
    }

    s[num] = l;
    i1 = tipo[n];
    k4 = 0;
    k7 = 0;
    /* ---------------------------------------------------- */
    /* Retirar efeitos repetidos                            */
    /* ---------------------------------------------------- */
    for (i = 0; i < num; ++i) {
	if (ff[i]) {
	    k5 = 0;
	    k6 = 0;
	    buffer[0] = '\0';
	    for (j = 0; j < qt[i] - 1; ++j) {
		k = pp[s[i] + j];
		if (ajuda[k] < 9999) {
		    strcat(buffer, (char *) (ivar + ajuda[k]));
		    strcat(buffer, "*");
		} else {
		    if (buffer[0] == '\0') {
			par_hier(buffer, xobs[n], v[k]);
		    } else {
			par_hier(buf1, xobs[n], v[k]);
			strcat(buffer, buf1);
		    }
		}
	    }
	    k = pp[s[i] + j];
	    if (ajuda[k] < 9999) {
		strcat(buffer, (char *) (ivar + ajuda[k]));
	    } else {
		if (buffer[0] == '\0') {
		    k6 = 1;
		    par_hier(buffer, xobs[n], v[k]);
		} else {
		    par_hier(buf1, xobs[n], v[k]);
		    strcat(buffer, buf1);
		}
	    }

	    for (l = 0; l < k4; l++) {
		if (strcmpi(efts[l], buffer) == 0) {
		    k5 = 1;
		    break;
		}

	    }
	    if (!k5) {
		for (l = 0; l < npar; l++) {
		    if (strcmpi(xobs[l], buffer) == 0) {
			k5 = 1;
			break;
		    }

		}
	    }
	    if (!k5) {
		if (k6)
		    k7++;
		efts[k4] = p1;
		strcpy(p1, buffer);
		p1 += (strlen(p1) + 1);
		k4++;
	    } else {
		ff[i] = 0;
		++k2;
	    }
	}
    }
    /* ---------------------------------------------------- */
    p1 = area;			/* Reinicializa ponteiro para area */
    /* ---------------------------------------------------- */

    /* colocar na lista de efeitos */
    if (k2 = abs(k2)) {
	/* abrir espaco */
	for (i = npar; i >= n; --i) {
	    j = i + k2;
	    xobs[j] = xobs[i];
	    qtde[j] = qtde[i];
	    sv[j] = sv[i];
	    tipo[j] = tipo[i];
	    cerro[j] = cerro[i];
	    soma[j] = soma[i];
	    efts1[j] = efts1[i];
	    ef[j][4] = ef[i][4];
	}

	/* acrescentar pedaco */
	ivar = fd->pvar;
	numpar = n;

	for (i = 0; i < num; ++i) {
	    if (ff[i]) {
		xobs[numpar] = p;
		qtde[numpar] = qt[i];
		buffer[0] = '\0';
		sv[numpar] = npos;
		soma[numpar] = n + k2;
		efts1[numpar] = "";
		cerro[numpar] = 0;

		for (j = 0; j < qt[i] - 1; ++j) {
		    k = pp[s[i] + j];
		    pos[npos++] = k;
		    if (ajuda[k] < 9999) {
			strcat(buffer, (char *) (ivar + ajuda[k]));
			strcat(buffer, "*");
			nv[i] = numpar;
		    } else {
			if (buffer[0] == '\0') {
			    par_hier(buffer, xobs[n + k2], v[k]);
			} else {
			    par_hier(buf1, xobs[n + k2], v[k]);
			    strcat(buffer, buf1);
			}
		    }

		}
		k = pp[s[i] + j];
		pos[npos++] = k;
		if (ajuda[k] < 9999) {
		    strcat(buffer, (char *) (ivar + ajuda[k]));
		    strcpy(p, buffer);
		    p += (strlen(p) + 1);
		    nv[i] = numpar;
		} else {
		    if (buffer[0] == '\0') {
			par_hier(buffer, xobs[n + k2], v[k]);
		    } else {
			par_hier(buf1, xobs[n + k2], v[k]);
			strcat(buffer, buf1);
		    }
		    strcpy(p, buffer);
		    p += (strlen(p) + 1);
		    if (j == 0) {
			k7--;
			ef[numpar][4] = ef[n + k2][4] - k7;
			nv[i] = -1;
		    } else
			nv[i] = numpar;
		}
		if (i1 > 512) {
		    tipo[numpar] =
			(qtde[numpar] == 1
			 && verpo0(xobs[numpar], xobs[n + k2], i1,
				   qtde[n + k2]) == 0) ? -3 : -1;
		    numpar++;
		} else
		    tipo[numpar++] = 0;

	    }
	}
	for (i = 0; i < num; ++i) {
	    if (nv[i] != -1)
		ef[nv[i]][4] = 0;
	}

	/* ajuste dos anteriores */
	novo_k2 += k2;
	for (i = n - 1; i >= 0; --i) {
	    if (tipo[i] > 0 && tipo[i] < 512) {
		tipo[i] += novo_k2;
	    } else
		break;
	}
	for (i = n - 1; i >= 0; --i) {
	    if (soma[i] > 0) {
		soma[i] += novo_k2;
	    } else
		break;
	}
    }
    ef[n + k2][4] = 0;

    for (i = 0; i < MAXMEM1; ++i) {
	v[i] = 0;
	nv[i] = 0;
    }
    return (k2);
}

int getbit(x, p, n)
int x;
int p;
int n;
{
    return ((x >> (p + 1 - n)) & ~(~0 << n));
}

/* -----------------------------------------------------------------------*/
/* Funcao: Verifica se todos as variaveis que estao no efeito sao covar. ou
	   var. de classificacao					 */
/* Retorno: -1 se todas sao cov.
	     0 se alguma nao e' cov.					 */
/* ----------------------------------------------------------------------*/

int verpo0(x, y, tipo, num)
char *x;
char *y;
int tipo;
int num;
{
    int i, n, k;
    char z[80];

    n = -1;
    k = 0;
    for (i = 0; i <= (int) strlen(x); i++) {
	if (x[i] == '*' || x[i] == ' ' || x[i] == '(' || x[i] == ')' ||
	    x[i] == '\0') {
	    z[k] = '\0';
	    k = 0;
	    n = (verpo1(z, y, tipo, num) == 1) ? -1 : 0;

	    if (n == -1)
		return (n);
	} else
	    z[k++] = x[i];
    }
    return (n);
}

int verpo1(x, y, tipo, num)
char *x;
char *y;
int tipo;
int num;
{
    int k;
    int n;
    char l_s[5];

    l_s[0] = '*';
    l_s[1] = '(';
    l_s[2] = ' ';
    l_s[3] = ')';
    l_s[4] = '\0';
    for (k = 0; k < num; k++) {
	if (strcmpi(x, word_k(y, k, l_s, &n)) == 0)
	    return (getbit(tipo, k, 1));
    }

    return -1;
}

/* -----------------------------------------------------------------------*/
/* Funcao: retorna palavra 'n' de uma string a partir de um conj. de      */
/*         separadores							  */
/* -----------------------------------------------------------------------*/
/* Parametros:								  */
/*	   char *y ---> Palavra de entrada				  */
/*	   int  k  ---> Posicao desejada 				  */
/*	   char *l_s--> Lista de separadores 				  */
/* -----------------------------------------------------------------------*/
/* Retorna:  a palavra selecionada					  */
/* -----------------------------------------------------------------------*/

char *word_k(y, k, l_s, n)
char *y;
int k;
char *l_s;
int *n;
{
    static char temp[45];
    int i, j, l, m;


    l = 0;
    m = 0;
    *n = 0;
    for (i = 0; i <= (int) strlen(y); ++i) {
	for (j = 0; j <= (int) strlen(l_s); j++) {
	    if (y[i] == l_s[j]) {
		if (l == k) {
		    temp[m] = '\0';
		    if (y[i] == '\0')
			*n = 1;
		    return (temp);	
		}
		l++;
		m = 0;
		break;
	    }
	}
	if (j > (int) strlen(l_s))
	    temp[m++] = y[i];
    }

    return (char *) NULL;
}

void par_hier(x, y, i2)
char *x;
char *y;
int i2;
{

    int i;
    int j;
    int k;
    int i1;

    i1 = strlen(y);
    k = 0;
    j = 0;

    for (i = 0; i <= i1; i++) {
	if (y[i] == '*' || y[i] == '\0') {
	    k++;
	    if (k == i2) {
		x[j] = '\0';
		j = 0;
		break;
	    }
	    j = 0;
	} else {
	    x[j++] = y[i];
	}
    }
}

/* -----------------------------------------------------------------------*/
/* Funcao: compara se uma string contem uma sub-string			  */
/* -----------------------------------------------------------------------*/
/* Parametros:								  */
/*	   char *x ---> STRING						  */
/*	   char *y ---> SUB-STRING					  */
/* -----------------------------------------------------------------------*/
/* Retorna:  0 - Pertence	1 - Nao Pertence			  */
/* -----------------------------------------------------------------------*/

int substr(x, y)
char *x;
char *y;
{
    int i, j, k;
    int par;

    par = 1;

    if (strlen(x) < strlen(y))
	return 0;

    for (i = 0; i < (int) strlen(x); ++i) {
	if (x[i] == '*')
	    par++;
	if (x[i] == y[0]) {
	    k = 0;
	    for (j = i; j < (i + (int) strlen(y)); j++) {
		if (x[j] != y[k])
		    break;
		k++;
	    }
	    if (j == (i + (int) strlen(y)))
		return (par);
	}
    }
    return 0;
}
