
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Parser para formulas do calculo do erro

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/formula.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/


# line 2 "formula.y"
#include "anova.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include "pcsgbd.h"

static char *sccsid = "@(#)formula.y	1.7	(NTIA/modlin)	95/11/10";

extern double f_qm;
extern double f_gl;
extern int fl_qm;

#ifdef MSDOS
extern void yyerror(char *);
extern int yylex(void);
#else
extern void yyerror();
extern int yylex();
#endif

/* ----------------------------------------------------------------- */
/*  Estas variaveis armazenaram as variaveis dependentes	     */
/*  Rotinas que utilizam: Contraste, media e compara		     */

extern char *p2;
extern char *efts1[MAXEFTS];
extern int n_vardep;

/* ----------------------------------------------------------------- */

extern int c_opcao;		/* Usado no compara                          */
extern double c_alfa;		/* Usado no compara                          */

/* ----------------------------------------------------------------- */

static int f_var = 0;
static int f_teste = 0;


# line 63 "formula.y"
typedef union {
    double num;
    char str[128];
} YYSTYPE;
# define NUMBER 257
# define VARIAV 258
# define VARIAV1 259
# define QM 260
# define GL 261
# define GRAU 262
# define ERRO 263
# define VAR 264
# define TESTE 265
# define SIG 266
# define UNARYMINUS 267
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 171 "formula.y"


/* ----------------------------------------------------------------------------
** @(#)
**
** Analisador lexico.
**
** Forma de usar:
**
**		yylex()
**
** Valor retornado:
**
**		Inteiro correspondente ao caracter separador
**
** Programado por:
**
**		Silvio Roberto M. Evangelista
**
** Atualizado por:
**
**		Silvio Evangelista
**
** Data da ultima alteracao:
**
**		89/01/17 10:39:03
**
** ----------------------------------------------------------------------------
*/

#define IMPRIME if (!iterativo && !tem_comando) fprintf(fout, "%s ", token);

int fl_qm = 0;			/* Flag utilizada para:     
				   1- Pegarmos efeitos: a*b, a(b) como um efeito unico
				   2- Saber se estamos interessados no gl ou qm
				   (fl_qm = 2 e 1 respectivamente)
				 */

int yylex()
{
    extern FILE *faux;
    extern FILE *fout;
    extern int tem_comando;
    extern int iterativo;
    char *q;
    int c;
    int tok;
    int i;
    char token[128];
    int par;

    par = 0;

    while ((c = xgetc(faux)) == ' ' || c == '\t' || c == '\n' || c == '\r');
    q = token;
    *q++ = (char) c;
    *q = '\0';
    switch (c) {
    case EOF:
	return 0;
    case ',':
    case ';':
    case '*':
    case '#':
    case '{':
    case '}':
    case '[':
    case ']':
    case '(':
    case ')':
    case '<':
    case '>':
    case '=':
    case '"':
    case '!':
    case '+':
    case '-':
    case '^':
    case '/':
    case ':':
    case '\\':{
	    IMPRIME;
	    return c;
	}
    }

    tok = NUMBER;
    q = token;
    *q = '\0';
    for (;;) {
	switch (c) {
	case EOF:
	    *q = '\0';
	    IMPRIME;
	    return tok;
	case ' ':
	case '\t':
	case '\n':
	case ',':
	case ';':
	case '*':
	case '#':
	case '{':
	case '}':
	case '[':
	case ']':
	case '(':
	case ')':
	case '<':
	case '>':
	case '=':
	case '"':
	case '!':
	case '+':
	case '-':
	case '^':
	case '/':
	case ':':
	case '\\':
	    if (fl_qm && (c == '*' || c == ')' || c == '(')) {
		if (c == '(')
		    par++;
		if (c == ')')
		    par--;
		if (par >= 0)
		    goto l1;
	    }
	    unxgetc(c, faux);
	    *q = '\0';
	    if (tok == VARIAV) {
		if (strcmpi("var", token) == 0) {
		    f_var = 1;
		    f_teste = 0;
		    IMPRIME;
		    return VAR;
		}
		if (strcmpi("teste", token) == 0) {
		    f_var = 0;
		    f_teste = 1;
		    IMPRIME;
		    return TESTE;
		}
		if (strcmpi("sig", token) == 0) {
		    f_var = 0;
		    f_teste = 0;
		    IMPRIME;
		    return SIG;
		}
		if (strcmpi("gl", token) == 0) {
		    fl_qm = 2;
		    IMPRIME;
		    return GL;
		}
		if (strcmpi("qm", token) == 0) {
		    fl_qm = 1;
		    IMPRIME;
		    return QM;
		}
		if (strcmpi("grau", token) == 0) {
		    f_var = 0;
		    f_teste = 0;
		    IMPRIME;
		    return GRAU;
		}
		if (strcmpi("erro", token) == 0) {
		    f_var = 0;
		    f_teste = 0;
		    IMPRIME;
		    return ERRO;
		}
		if (strcmpi("residuo", token) == 0) {
		    if (fl_qm == 1)
			yylval.num = qmr;
		    if (fl_qm == 2)
			yylval.num = (double) glr;
		    IMPRIME;
		    fl_qm = 0;
		    return VARIAV;
		}
		if (f_var || f_teste) {
		    strcpy(yylval.str, token);
		    IMPRIME;
		    return VARIAV1;
		}
		for (i = 0; i <= nef + nd; ++i) {
		    if ((ef[i][3] == 0)
			&& (ef[i][0] >= 0 || ef[i][0] == -1)) {
			if (strcmpi(efts[i], token) == 0) {
			    if (fl_qm == 1)
				yylval.num = obs[i];
			    if (fl_qm == 2)
				yylval.num = (double) nv[i];
			    IMPRIME;
			    fl_qm = 0;
			    return VARIAV;
			}
		    }
		}
		fl_qm = 0;
		fprintf(stderr, "Token: %s\n", token);
		errocon(9, 0);
	    }
	    if (tok == NUMBER) {
		yylval.num = atof(token);
		IMPRIME;
		return NUMBER;
	    }
	    IMPRIME;
	    return tok;
	}
      l1:
	if (!isdigit(c) && c != '.')
	    tok = VARIAV;
	if (!isdigit(c) && !isalpha(c) && c != '.' && !fl_qm) {
	    *q = '\0';
	    IMPRIME;
	    return c;
	}
	*q++ = (char) c;
	c = xgetc(faux);
    }
}

void yyerror(s)
char *s;
{
    errocon(18, 0);
}

yytabelem yyexca[] = {
    -1, 0,
    59, 4,
    -2, 1,
    -1, 1,
    0, -1,
    -2, 0,
};

# define YYNPROD 22
# define YYLAST 240
yytabelem yyact[] = {

    30, 29, 3, 28, 24, 31, 25, 48, 4, 5,
    6, 7, 8, 4, 5, 6, 7, 8, 20, 47,
    26, 32, 30, 21, 49, 30, 29, 31, 28, 15,
    31, 14, 13, 12, 11, 10, 9, 51, 50, 34,
    33, 2, 1, 0, 23, 0, 0, 0, 0, 16,
    0, 0, 32, 0, 0, 0, 0, 0, 27, 0,
    0, 0, 22, 0, 37, 38, 0, 40, 41, 39,
    35, 36, 0, 0, 32, 0, 0, 32, 42, 43,
    44, 45, 46, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    4, 5, 6, 7, 8, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 17, 0, 0, 19, 18
};
yytabelem yypact[] = {

    -254, -1000, -23, -24, -27, -28, -29, -30, -32, -1000,
    -1000, -22, -22, -255, -253, -237, -42, -1000, 0, -1,
    -22, -22, -42, -249, -255, -249, -249, -1000, -22, -22,
    -22, -22, -22, -239, -251, -17, -73, -1000, -1000, -1000,
    -1000, -1000, -20, -20, -73, -73, -73, -3, -4, -1000,
    -1000, -1000
};
yytabelem yypgo[] = {

    0, 42, 49, 41, 44
};
yytabelem yyr1[] = {

    0, 1, 1, 1, 3, 3, 3, 3, 3, 3,
    4, 4, 2, 2, 2, 2, 2, 2, 2, 2,
    2, 2
};
yytabelem yyr2[] = {

    0, 0, 5, 5, 0, 9, 9, 9, 9, 9,
    3, 5, 3, 9, 9, 7, 7, 7, 7, 7,
    7, 5
};
yytabelem yychk[] = {

    -1000, -1, -3, 256, 262, 263, 264, 265, 266, 59,
    59, 61, 61, 61, 61, 61, -2, 257, 261, 260,
    40, 45, -2, -4, 259, 259, 257, -3, 45, 43,
    42, 47, 94, 40, 40, -2, -2, -3, -3, -4,
    -3, -3, -2, -2, -2, -2, -2, 258, 258, 41,
    41, 41
};
yytabelem yydef[] = {

    -2, -2, 0, 0, 0, 0, 0, 0, 0, 2,
    3, 0, 0, 0, 0, 0, 4, 12, 0, 0,
    0, 0, 4, 4, 10, 4, 4, 5, 0, 0,
    0, 0, 0, 0, 0, 0, 21, 6, 7, 11,
    8, 9, 15, 16, 17, 18, 19, 0, 0, 20,
    13, 14
};
typedef struct {
    char *t_name;
    int t_val;
} yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] = {
    "NUMBER", 257,
    "VARIAV", 258,
    "VARIAV1", 259,
    "QM", 260,
    "GL", 261,
    "GRAU", 262,
    "ERRO", 263,
    "VAR", 264,
    "TESTE", 265,
    "SIG", 266,
    "]", 93,
    "(", 40,
    ")", 41,
    "+", 43,
    "-", 45,
    "*", 42,
    "/", 47,
    "UNARYMINUS", 267,
    "^", 94,
    "-unknown-", -1		/* ends search */
};

char *yyreds[] = {
    "-no such reduction-",
    "list : /* empty */",
    "list : list1 ';'",
    "list : error ';'",
    "list1 : /* empty */",
    "list1 : GRAU '=' expr list1",
    "list1 : ERRO '=' expr list1",
    "list1 : VAR '=' list2 list1",
    "list1 : TESTE '=' VARIAV1 list1",
    "list1 : SIG '=' NUMBER list1",
    "list2 : VARIAV1",
    "list2 : VARIAV1 list2",
    "expr : NUMBER",
    "expr : GL '(' VARIAV ')'",
    "expr : QM '(' VARIAV ')'",
    "expr : expr '-' expr",
    "expr : expr '+' expr",
    "expr : expr '*' expr",
    "expr : expr '/' expr",
    "expr : expr '^' expr",
    "expr : '(' expr ')'",
    "expr : '-' expr",
};
#endif				/* YYDEBUG */
/* @(#)27       1.7  com/cmd/lang/yacc/yaccpar, bos, bos320 8/12/91 16:09:43 */
/*
 * COMPONENT_NAME: (CMDLANG) Language Utilities
 *
 * FUNCTIONS: yyparse
 * ORIGINS: 03
 */
/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#ifdef YYSPLIT
#   define YYERROR      return(-2)
#else
#   define YYERROR      goto yyerrlab
#endif
#ifdef YACC_MSG
#ifndef _XOPEN_SOURCE
#define _XOPEN_SOURCE
#endif
#include <nl_types.h>
nl_catd catd;
#endif
#define YYACCEPT        return(0)
#define YYABORT         return(1)
#ifndef YACC_MSG
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                yyerror( "syntax error - cannot backup" );\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#else
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                catd=catopen("yacc_user.cat",0);\
                yyerror(catgets(catd,1,1,"syntax error - cannot backup" ));\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#endif
#define YYRECOVERING()  (!!yyerrflag)
#ifndef YYDEBUG
#       define YYDEBUG  1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG          (-1000)

#ifdef YYSPLIT
#   define YYSCODE { \
                        extern int (*_yyf[])(); \
                        register int yyret; \
                        if (_yyf[yytmp]) \
                            if ((yyret=(*_yyf[yytmp])()) == -2) \
                                    goto yyerrlab; \
                                else if (yyret>=0) return(yyret); \
                   }
#endif

/*
** global variables used by the parser
*/
YYSTYPE yyv[YYMAXDEPTH];	/* value stack */
int yys[YYMAXDEPTH];		/* state stack */

YYSTYPE *yypv;			/* top of value stack */
YYSTYPE *yypvt;			/* top of value stack for $vars */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int yyparse()
{
    /*
     ** Initialize externals - yyparse may be called more than once
     */
    yypv = &yyv[-1];
    yyps = &yys[-1];
    yystate = 0;
    yytmp = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = -1;
#ifdef YACC_MSG
    catd = catopen("yacc_user.cat", 0);
#endif
    goto yystack;
    {
	register YYSTYPE *yy_pv;	/* top of value stack */
	register int *yy_ps;	/* top of state stack */
	register int yy_state;	/* current state */
	register int yy_n;	/* internal state number info */

	/*
	 ** get globals into registers.
	 ** branch to here only if YYBACKUP was called.
	 */
      yynewstate:
	yy_pv = yypv;
	yy_ps = yyps;
	yy_state = yystate;
	goto yy_newstate;

	/*
	 ** get globals into registers.
	 ** either we just started, or we just finished a reduction
	 */
      yystack:
	yy_pv = yypv;
	yy_ps = yyps;
	yy_state = yystate;

	/*
	 ** top of for (;;) loop while no reductions done
	 */
      yy_stack:
	/*
	 ** put a state and value onto the stacks
	 */
#if YYDEBUG
	/*
	 ** if debugging, look up token value in list of value vs.
	 ** name pairs.  0 and negative (-1) are special values.
	 ** Note: linear search is used since time is not a real
	 ** consideration while debugging.
	 */
	if (yydebug) {
	    register int yy_i;

	    printf("State %d, token ", yy_state);
	    if (yychar == 0)
		printf("end-of-file\n");
	    else if (yychar < 0)
		printf("-none-\n");
	    else {
		for (yy_i = 0; yytoks[yy_i].t_val >= 0; yy_i++) {
		    if (yytoks[yy_i].t_val == yychar)
			break;
		}
		printf("%s\n", yytoks[yy_i].t_name);
	    }
	}
#endif				/* YYDEBUG */
	if (++yy_ps >= &yys[YYMAXDEPTH]) {	/* room on stack? */
#ifndef YACC_MSG
	    yyerror("yacc stack overflow");
#else
	    yyerror(catgets(catd, 1, 2, "yacc stack overflow"));
#endif
	    YYABORT;
	}
	*yy_ps = yy_state;
	*++yy_pv = yyval;

	/*
	 ** we have a new state - find out what to do
	 */
      yy_newstate:
	if ((yy_n = yypact[yy_state]) <= YYFLAG)
	    goto yydefault;	/* simple state */
#if YYDEBUG
	/*
	 ** if debugging, need to mark whether new token grabbed
	 */
	yytmp = yychar < 0;
#endif
	if ((yychar < 0) && ((yychar = yylex()) < 0))
	    yychar = 0;		/* reached EOF */
#if YYDEBUG
	if (yydebug && yytmp) {
	    register int yy_i;

	    printf("Received token ");
	    if (yychar == 0)
		printf("end-of-file\n");
	    else if (yychar < 0)
		printf("-none-\n");
	    else {
		for (yy_i = 0; yytoks[yy_i].t_val >= 0; yy_i++) {
		    if (yytoks[yy_i].t_val == yychar)
			break;
		}
		printf("%s\n", yytoks[yy_i].t_name);
	    }
	}
#endif				/* YYDEBUG */
	if (((yy_n += yychar) < 0) || (yy_n >= YYLAST))
	    goto yydefault;
	if (yychk[yy_n = yyact[yy_n]] == yychar) {	/*valid shift */
	    yychar = -1;
	    yyval = yylval;
	    yy_state = yy_n;
	    if (yyerrflag > 0)
		yyerrflag--;
	    goto yy_stack;
	}

      yydefault:
	if ((yy_n = yydef[yy_state]) == -2) {
#if YYDEBUG
	    yytmp = yychar < 0;
#endif
	    if ((yychar < 0) && ((yychar = yylex()) < 0))
		yychar = 0;	/* reached EOF */
#if YYDEBUG
	    if (yydebug && yytmp) {
		register int yy_i;

		printf("Received token ");
		if (yychar == 0)
		    printf("end-of-file\n");
		else if (yychar < 0)
		    printf("-none-\n");
		else {
		    for (yy_i = 0; yytoks[yy_i].t_val >= 0; yy_i++) {
			if (yytoks[yy_i].t_val == yychar) {
			    break;
			}
		    }
		    printf("%s\n", yytoks[yy_i].t_name);
		}
	    }
#endif				/* YYDEBUG */
	    /*
	     ** look through exception table
	     */
	    {
		register int *yyxi = yyexca;

		while ((*yyxi != -1) || (yyxi[1] != yy_state)) {
		    yyxi += 2;
		}
		while ((*(yyxi += 2) >= 0) && (*yyxi != yychar));
		if ((yy_n = yyxi[1]) < 0)
		    YYACCEPT;
	    }
	}

	/*
	 ** check for syntax error
	 */
	if (yy_n == 0) {	/* have an error */
	    /* no worry about speed here! */
	    switch (yyerrflag) {
	    case 0:		/* new error */
#ifndef YACC_MSG
		yyerror("syntax error");
#else
		yyerror(catgets(catd, 1, 3, "syntax error"));
#endif
		goto skip_init;
	      yyerrlab:
		/*
		 ** get globals into registers.
		 ** we have a user generated syntax type error
		 */
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		yynerrs++;
	      skip_init:
	    case 1:
	    case 2:		/* incompletely recovered error */
		/* try again... */
		yyerrflag = 3;
		/*
		 ** find state where "error" is a legal
		 ** shift action
		 */
		while (yy_ps >= yys) {
		    yy_n = yypact[*yy_ps] + YYERRCODE;
		    if (yy_n >= 0 && yy_n < YYLAST &&
			yychk[yyact[yy_n]] == YYERRCODE) {
			/*
			 ** simulate shift of "error"
			 */
			yy_state = yyact[yy_n];
			goto yy_stack;
		    }
		    /*
		     ** current state has no shift on
		     ** "error", pop stack
		     */
#if YYDEBUG
#       define _POP_ "Error recovery pops state %d, uncovers state %d\n"
		    if (yydebug)
			printf(_POP_, *yy_ps, yy_ps[-1]);
#       undef _POP_
#endif
		    yy_ps--;
		    yy_pv--;
		}
		/*
		 ** there is no state on stack with "error" as
		 ** a valid shift.  give up.
		 */
		YYABORT;
	    case 3:		/* no shift yet; eat a token */
#if YYDEBUG
		/*
		 ** if debugging, look up token in list of
		 ** pairs.  0 and negative shouldn't occur,
		 ** but since timing doesn't matter when
		 ** debugging, it doesn't hurt to leave the
		 ** tests here.
		 */
		if (yydebug) {
		    register int yy_i;

		    printf("Error recovery discards ");
		    if (yychar == 0)
			printf("token end-of-file\n");
		    else if (yychar < 0)
			printf("token -none-\n");
		    else {
			for (yy_i = 0; yytoks[yy_i].t_val >= 0; yy_i++) {
			    if (yytoks[yy_i].t_val == yychar) {
				break;
			    }
			}
			printf("token %s\n", yytoks[yy_i].t_name);
		    }
		}
#endif				/* YYDEBUG */
		if (yychar == 0)	/* reached EOF. quit */
		    YYABORT;
		yychar = -1;
		goto yy_newstate;
	    }
	}
	/* end if ( yy_n == 0 ) */
	/*
	 ** reduction by production yy_n
	 ** put stack tops, etc. so things right after switch
	 */
#if YYDEBUG
	/*
	 ** if debugging, print the string that is the user's
	 ** specification of the reduction which is just about
	 ** to be done.
	 */
	if (yydebug)
	    printf("Reduce by (%d) \"%s\"\n", yy_n, yyreds[yy_n]);
#endif
	yytmp = yy_n;		/* value to switch over */
	yypvt = yy_pv;		/* $vars top of value stack */
	/*
	 ** Look in goto table for next state
	 ** Sorry about using yy_state here as temporary
	 ** register variable, but why not, if it works...
	 ** If yyr2[ yy_n ] doesn't have the low order bit
	 ** set, then there is no action to be done for
	 ** this reduction.  So, no saving & unsaving of
	 ** registers done.  The only difference between the
	 ** code just after the if and the body of the if is
	 ** the goto yy_stack in the body.  This way the test
	 ** can be made before the choice of what to do is needed.
	 */
	{
	    /* length of production doubled with extra bit */
	    register int yy_len = yyr2[yy_n];

	    if (!(yy_len & 01)) {
		yy_len >>= 1;
		yyval = (yy_pv -= yy_len)[1];	/* $$ = $1 */
		yy_state = yypgo[yy_n = yyr1[yy_n]] +
		    *(yy_ps -= yy_len) + 1;
		if (yy_state >= YYLAST ||
		    yychk[yy_state = yyact[yy_state]] != -yy_n) {
		    yy_state = yyact[yypgo[yy_n]];
		}
		goto yy_stack;
	    }
	    yy_len >>= 1;
	    yyval = (yy_pv -= yy_len)[1];	/* $$ = $1 */
	    yy_state = yypgo[yy_n = yyr1[yy_n]] + *(yy_ps -= yy_len) + 1;
	    if (yy_state >= YYLAST ||
		yychk[yy_state = yyact[yy_state]] != -yy_n) {
		yy_state = yyact[yypgo[yy_n]];
	    }
	}
	/* save until reenter driver code */
	yystate = yy_state;
	yyps = yy_ps;
	yypv = yy_pv;
    }
    /*
     ** code supplied by user is placed in this switch
     */

    switch (yytmp) {

    case 2:
# line 88 "formula.y"
	{
	    f_var = 0;
	    f_teste = 0;
	    return (0);
	}
	 /*NOTREACHED*/ break;
    case 3:
# line 93 "formula.y"
	{
	    f_var = 0;
	    f_teste = 0;
	    errocon(18, 1);
	}
	 /*NOTREACHED*/ break;
    case 5:
# line 100 "formula.y"
	{
	    f_gl = yypvt[-1].num;
	}
	 /*NOTREACHED*/ break;
    case 6:
# line 103 "formula.y"
	{
	    f_qm = yypvt[-1].num;
	}
	 /*NOTREACHED*/ break;
    case 7:
# line 106 "formula.y"
	{
	}
	 /*NOTREACHED*/ break;
    case 8:
# line 108 "formula.y"
	{
	    if ((c_opcao = des_est(yypvt[-1].str)) == -1)
		errocon(24, 3);
	}
	 /*NOTREACHED*/ break;
    case 9:
# line 112 "formula.y"
	{
	    c_alfa = yypvt[-1].num;
	    /*
	     ** mascara para pegar as duas primeiras casas decimais
	     ** de c_alfa. atof()  do DJGPP produz lixo em casas decimais
	     */
	    c_alfa = (int) (c_alfa * 100.0) / 100.0;
	    if (c_alfa != 0.01) {
		c_alfa = 0.05;
	    }
	}
	 /*NOTREACHED*/ break;
    case 10:
# line 125 "formula.y"
	{
	    strcpy(p2, yypvt[-0].str);
	    efts1[n_vardep++] = p2;
	    p2 += (strlen(p2) + 1);
	}
	 /*NOTREACHED*/ break;
    case 11:
# line 130 "formula.y"
	{
	    strcpy(p2, yypvt[-1].str);
	    efts1[n_vardep++] = p2;
	    p2 += (strlen(p2) + 1);
	}
	 /*NOTREACHED*/ break;
    case 12:
# line 137 "formula.y"
	{
	    yyval.num = yypvt[-0].num;
	}
	 /*NOTREACHED*/ break;
    case 13:
# line 140 "formula.y"
	{
	    yyval.num = yypvt[-1].num;
	}
	 /*NOTREACHED*/ break;
    case 14:
# line 143 "formula.y"
	{
	    yyval.num = yypvt[-1].num;
	}
	 /*NOTREACHED*/ break;
    case 15:
# line 146 "formula.y"
	{
	    yyval.num = yypvt[-2].num - yypvt[-0].num;
	}
	 /*NOTREACHED*/ break;
    case 16:
# line 149 "formula.y"
	{
	    yyval.num = yypvt[-2].num + yypvt[-0].num;
	}
	 /*NOTREACHED*/ break;
    case 17:
# line 152 "formula.y"
	{
	    yyval.num = yypvt[-2].num * yypvt[-0].num;
	}
	 /*NOTREACHED*/ break;
    case 18:
# line 155 "formula.y"
	{
	    if (yypvt[-0].num == 0.0) {
		errocon(17, 0);
	    }
	    yyval.num = yypvt[-2].num / yypvt[-0].num;
	}
	 /*NOTREACHED*/ break;
    case 19:
# line 161 "formula.y"
	{
	    yyval.num = pow(yypvt[-2].num, yypvt[-0].num);
	}
	 /*NOTREACHED*/ break;
    case 20:
# line 164 "formula.y"
	{
	    yyval.num = yypvt[-1].num;
	}
	 /*NOTREACHED*/ break;
    case 21:
# line 167 "formula.y"
	{
	    yyval.num = -yypvt[-0].num;
	}
	 /*NOTREACHED*/ break;
    }


    goto yystack;		/* reset registers in driver code */
}
