%{
#include "anova.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include "pcsgbd.h"

static char *sccsid = "@(#)formula.y	1.7	(NTIA/modlin)	95/11/10";

/* ----------------------------------------------------------------------------
** @(#)formula.y	1.7	(NTIA/modlin)	95/11/10
**
** 
**
** Parser para formulas do calculo do erro.
**
** Programado por:
**
**		Silvio Roberto Medeiros Evangelista.
**
** Data da ultima alteracao:
**
**		95/11/10 14:56:34
**
** ----------------------------------------------------------------------------
*/



extern double f_qm;
extern double f_gl;
extern int    fl_qm;

#ifdef MSDOS
 extern void yyerror(char *);
 extern int yylex(void);
#else
 extern void yyerror();
 extern int yylex();
#endif

/* ----------------------------------------------------------------- */
/*  Estas variaveis armazenaram as variaveis dependentes	     */
/*  Rotinas que utilizam: Contraste, media e compara		     */

extern char *p2;
extern char *efts1[MAXEFTS];
extern int    n_vardep;

/* ----------------------------------------------------------------- */

extern int    c_opcao;	/* Usado no compara			     */
extern double c_alfa;	/* Usado no compara			     */

/* ----------------------------------------------------------------- */

static int f_var  = 0;
static int f_teste= 0;

%}

%union {
	double num;
	char   str[128];
}

%start list

%type   <num>   expr
%token  <num>  	NUMBER VARIAV
%token  <str>	VARIAV1
%token  QM
%token  GL
%token  GRAU
%token  ERRO
%token  VAR
%token  TESTE
%token  SIG
%token	']' '(' ')';
%left	'+' '-'
%left  	'*' '/'
%left 	UNARYMINUS
%right	'^'
%%

list:	/* Nada */
	| list1 ';' {
		f_var   = 0;
		f_teste = 0;
		return(0);
	}
	| error ';'  {
		f_var   = 0;
		f_teste = 0;
		errocon(18,1);
	}
	;
list1:  /* NADA */
	| GRAU '=' expr list1  {
		f_gl  = $3;
	}
	| ERRO '=' expr list1  {
		f_qm  = $3;
	}
	| VAR  '=' list2 list1 {
	}
	| TESTE '=' VARIAV1 list1 {
		if ( (c_opcao = des_est($3)) == -1)
			errocon(24,3);
	}
	| SIG   '=' NUMBER list1 {
		c_alfa = $3;
		/*
		** mascara para pegar as duas primeiras casas decimais
		** de c_alfa. atof()  do DJGPP produz lixo em casas decimais
		*/
		c_alfa = (int) (c_alfa*100.0) / 100.0;
		if (c_alfa != 0.01) {
			c_alfa = 0.05;
		}
	}
	;

list2:  VARIAV1 {
		strcpy(p2, $1);
		efts1[n_vardep++] = p2;
		p2 += (strlen(p2)+1);
	}
	| VARIAV1 list2 {
		strcpy(p2, $1);
		efts1[n_vardep++] = p2;
		p2 += (strlen(p2)+1);
	}
	;

expr:	NUMBER {
		$$ = $1;
	}
	| GL '(' VARIAV ')'{
		$$ = $3;
	}
	| QM '(' VARIAV ')'{
		$$ = $3;
	}
	| expr '-' expr {
		$$ = $1 - $3;
	}
	| expr '+' expr {
		$$ = $1 + $3;
	}
	| expr '*' expr {
		$$ = $1 * $3;
	}
	| expr '/' expr {
		if ($3 == 0.0 ) {
			errocon(17,0);
		}
		$$ = $1 / $3;
	}
	| expr '^' expr {
		$$ = pow($1, $3);
	}
	| '(' expr ')' {
		$$ = $2;
	}
	| '-' expr %prec UNARYMINUS {
		$$ = -$2;
	}
	;
%%

/* ----------------------------------------------------------------------------
** @(#)
**
** Analisador lexico.
**
** Forma de usar:
**
**		yylex()
**
** Valor retornado:
**
**		Inteiro correspondente ao caracter separador
**
** Programado por:
**
**		Silvio Roberto M. Evangelista
**
** Atualizado por:
**
**		Silvio Evangelista
**
** Data da ultima alteracao:
**
**		89/01/17 10:39:03
**
** ----------------------------------------------------------------------------
*/

#define IMPRIME if (!iterativo && !tem_comando) fprintf(fout, "%s ", token);

int fl_qm=0;		/* Flag utilizada para:     
			   1- Pegarmos efeitos: a*b, a(b) como um efeito unico
			   2- Saber se estamos interessados no gl ou qm
			      (fl_qm = 2 e 1 respectivamente)
			*/

int yylex()
{
	extern FILE *faux;
	extern FILE *fout;
	extern int tem_comando;
	extern int iterativo;
	char *q;
	int c;
	int tok;
	int i;
	char token[128];
	int par;

	par = 0;

	while ((c = xgetc(faux)) == ' ' || c == '\t' || c == '\n' ) 
		;	
	q = token;
	*q++ = (char) c;
	*q='\0';
	switch (c) {
		case EOF: 
			return 0;
		case ',':
		case ';':
		case '*':
		case '#':
		case '{':
		case '}':
		case '[':
		case ']':
		case '(':
		case ')':
		case '<':
		case '>':
		case '=':
		case '"':
		case '!':
		case '+':
		case '-':
		case '^':
		case '/':
		case ':':
		case '\\': {
			IMPRIME;
			return c;
		}
	}

	tok = NUMBER;
	q = token;
	*q='\0';
	for (;;) {
		switch (c) {
			case EOF:
				*q = '\0';
				IMPRIME;
				return tok;
			case ' ':
			case '\t':
			case '\n':
			case ',':
			case ';':
			case '*':
			case '#':
			case '{':
			case '}':
			case '[':
			case ']':
			case '(':
			case ')':
			case '<':
			case '>':
			case '=':
			case '"':
			case '!':
			case '+':
			case '-':
			case '^':
			case '/':
			case ':':
			case '\\':
				if (fl_qm && (c=='*' || c==')' || c=='(')) {
					if (c == '(')
						par++;
					if (c == ')')
						par--;
					if (par >= 0)
						goto l1;
				}
				unxgetc(c, faux);
				*q = '\0';
				if (tok == VARIAV) {
					if (strcmpi("var", token)==0) {
						f_var = 1;
						f_teste=0;
						IMPRIME;
						return VAR;
					}
					if (strcmpi("teste", token)==0) {
						f_var = 0;
						f_teste=1;
						IMPRIME;
						return TESTE;
					}
					if (strcmpi("sig", token)==0) {
						f_var = 0;
						f_teste=0;
						IMPRIME;
						return SIG;
					}
					if (strcmpi("gl", token)==0) {
						fl_qm = 2;
						IMPRIME;
						return GL;
					}
					if (strcmpi("qm", token)==0) {
						fl_qm = 1;
						IMPRIME;
						return QM;
					}
					if (strcmpi("grau", token)==0) {
						f_var = 0;
						f_teste=0;
						IMPRIME;
						return GRAU;
					}
					if (strcmpi("erro", token)==0) {
						f_var = 0;
						f_teste=0;
						IMPRIME;
						return ERRO;
					}
					if (strcmpi("residuo",token)==0 ) {
						if (fl_qm == 1)
							yylval.num = qmr;
						if (fl_qm == 2)
							yylval.num=(double) glr;
						IMPRIME;
						fl_qm = 0;
						return VARIAV;
					}
					if (f_var || f_teste) {
						strcpy(yylval.str, token);
						IMPRIME;
						return VARIAV1;
					}
					for(i=0; i <= nef+nd; ++i) {
						if ((ef[i][3] == 0) && (ef[i][0] >= 0|| ef[i][0] == -1)) {
							if (strcmpi(efts[i],token)==0) {
								if(fl_qm==1)
									yylval.num = obs[i];
								if(fl_qm==2)
									yylval.num = (double) nv[i];
								IMPRIME;
								fl_qm = 0;
								return VARIAV;
							}
						}
					}
					fl_qm = 0;
					fprintf(stderr, "Token: %s\n", token);
					errocon(9, 0);
				}
				if (tok == NUMBER) {
					yylval.num = atof(token);
					IMPRIME;
					return NUMBER;
				}
				IMPRIME;
				return tok;
		}
		l1:
		if (!isdigit(c) && c != '.' )
			tok = VARIAV;
		if (!isdigit(c) && !isalpha(c) && c != '.' && !fl_qm) {
			*q = '\0';
			IMPRIME;
			return c;
		}
		*q++ = (char) c;
		c = xgetc(faux);
	}
}

void yyerror(s)
char *s;
{
	errocon(18,0);
}
