
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Le as flags e abre o banco de dados

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/getarg.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"

#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <signal.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"
/*#include "lockfile.h"*/

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)getarg.c	3.14	(NTIA/modlin)	97/02/17";


extern int flagX;
extern int sflag;
extern int uflag;
extern int nlins;
extern int ncols;

extern int descarq;
extern char exretstd[];		/* Contem o nome do arquivo exretstd */
extern int flagstd;

int flagA = 0;

void getarg(argc, argv)
int argc;
char *argv[];
{
    void controlC();

    extern char *parm[];
    int nparm = 0;
    char *buf;
    char namelock[TAMSTR];

    extern int impflag;
    int i;
    extern int iterativo;
    char *pdir;
    long ret;

    flagX = 1;
    ++argv;			/* aponta para o primeiro parametro */
    --argc;			/* decrementa o apontador */
    while (argc--) {
	if (argv[0][0] == '-') {
	    for (i = 1; argv[0][i]; ++i) {
		switch (argv[0][i]) {

		case 's':
		    sflag = 1;

		    break;

		case 'b':

		    ++bflag;

		    break;

		case 'A':
		    flagA = 1;
#ifdef RS6000
		    buf = (char *) malloc(strlen(argv[0]) + 1);
		    strcpy(buf, argv[0]);
#else
		    buf = (char *) malloc(3);
		    strcpy(buf, "-A");
#endif
		    parm[nparm++] = buf;

#ifdef RS6000
		    flagstd = 1;
		    /*
		     *strchr(&argv[0][i+1], '|') = '\0';
		     */
		    if (*strchr(&argv[0][i + 1], '|'))
			*strchr(&argv[0][i + 1], '|') = '\0';

		    if (freopen(&argv[0][i + 1], "r", stdin) ==
			(FILE *) NULL) {

			i += (strlen(&argv[0][i + 1]) + 1);
			*strchr(&argv[0][i + 1], '|') = '\0';
			i += (strlen(&argv[0][i + 1]) + 1);
			strcpy(exretstd, &argv[0][i + 1]);
/* *** Padroniz. msg erro - Adriana 07/12/94
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */

			fprintf(stderr, PegaMsg(1034), "stdin");
			setOSstdin();
#ifdef  MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("*** Lista de memoria nao esta' vazia ***\n");
			    Mem_Store("modlin");
			    exit(5);
			}
#endif
			exit(5);
		    }
		    i += (strlen(&argv[0][i + 1]) + 1);

		    *strchr(&argv[0][i + 1], '|') = '\0';
		    fseek(stdin, atol(&argv[0][i + 1]), 0);

		    i += (strlen(&argv[0][i + 1]) + 1);
		    strcpy(exretstd, &argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

#endif
		    setbuf(stdin, (char *) NULL);
		    iterativo = 0;


		    break;

		case 'X':
		    if (strcmp(&argv[0][i + 1], "ntia") == 0) {
			flagX = 1;
			i += 4;

			buf = (char *)
			    malloc(strlen(argv[0]) + 1);
			strcpy(buf, argv[0]);
			parm[nparm++] = buf;
		    }

		    break;

		case 'r':

		    ++rflag;

		    break;

		case 'P':

		    ++impflag;

		    buf = (char *) malloc(strlen(argv[0]) + 1);
		    strcpy(buf, argv[0]);
		    parm[nparm++] = buf;

		    break;

		case 'u':
		    if (strncmp(&argv[0][i], "uni", 3) == 0) {
			++uflag;
			i += 2;
		    } else {

/* *** Padroniz. msg erro - Adriana 05/01/94
						fprintf(stderr, "Opcao <%c> invalida", argv[0][1]);

   *** neste caso a opcao digitada possui mais que um caracter, por isso nao 
   *** pode usar a msg 3086 
						fprintf(stderr, PegaMsg (3086), argv[0][1]);
*** */

			fprintf(stderr, PegaMsg(3154), argv[0]);

			setOSstdin();
#ifdef  MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("*** Lista de memoria nao esta' vazia ***\n");
			    Mem_Store("modlin");
			    exit(1);
			}
#endif
			exit(1);
		    }

		    break;

		case 'l':

		    if (isdigit(argv[0][i + 1])) {
			nlins = atoi(&argv[0][i + 1]);
			i += strlen(&argv[0][i + 1]);

			buf = (char *)
			    malloc(strlen(argv[0]) + 1);
			strcpy(buf, argv[0]);
			parm[nparm++] = buf;
		    } else
			++lflag;

		    break;

		    /*
		     ** Habilita impressao de mensagens
		     */

		case 'M':

		    break;

		    /*
		     ** Habilita impressao de tempo
		     */

		case 't':

		    break;

		case 'c':

		    ncols = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

		    buf = (char *) malloc(strlen(argv[0]) + 1);
		    strcpy(buf, argv[0]);
		    parm[nparm++] = buf;

		    break;

		case 'x':

		    ++xflag;

		    break;

		case 'p':

		    ++pflag;

		    break;

		default:


/* *** Padroniz. msg erro - Adriana 07/12/94
					fprintf(stderr, "Flag <%c> ilegal\n", argv[0][1]);
*** */

		    fprintf(stderr, PegaMsg(3086), argv[0][1]);

		    setOSstdin();
#ifdef  MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf
			    ("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("modlin");
			exit(1);
		    }
#endif
		    exit(1);
		}
	    }
	} else
	    break;
	++argv;
    }

    /*
     ** Marca o termino do vetor de parametros
     */

    parm[nparm] = (char *) NULL;

    if (!flagX) {

/* *** Padroniz. msg erro - Adriana 07/12/94
		fprintf(stderr, "\nErro: %s. \n\n", erro_mod[n]);
*** */

	fprintf(stderr, PegaMsg(1000));
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(1);
	}
#endif
	exit(1);
    }

    if (argc < 0)
	usage();

    pdir = pega_env(argv[0], ".hdr");

    strcpy(namelock, pdir);
    strcat(namelock, ".dat");

#ifdef  MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("modlin");
	exit(5);
    }
#endif

    if ((ret = (long) (fd = abre_arq(pdir, 0, 1))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Adriana 07/12/94
		fprintf(stderr, "Nao consegui abrir <%s> %ld\n", pdir, ret);
*** */

	fprintf(stderr, PegaMsg(1034), pdir);
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif
	exit(2);
    }

    signal(SIGINT, controlC);
}


void controlC(sig)
int sig;
{
    /* Eliminacao do arquivo intermediario */
    if (access("modlin.out", 0) != -1)
	unlink("modlin.out");

    /* Desbloqueio dos arquivos */
    if (descarq != -1) {
	/*    UnlockAFile(descarq); */
    }

    if (flagA == 0)
	fprintf(stderr, "\n********  Interrompido pelo usuario\n");

    setOSstdin();

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("modlin");
	exit(1);
    }
#endif

    exit(sig);
}
