
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Grava a matriz z'z

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/grav_mat.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/


static char *sccsid = "@(#)grav_mat.c	3.7	(NTIA/modlin)	97/02/13";

/* ----------------------------------------------------------------------------
** @(#)grav_mat.c	3.7	(NTIA/modlin)	97/02/13
**
** 
**
** Data da ultima alteracao:
**
**		97/02/13 16:04:49
**
** ----------------------------------------------------------------------------
*/

#include "anova.h"
#include <stdlib.h>
#include <string.h>
#include "pcsgbd.h"


char *gcvt();

/*
** Globais usadas em grav_efe(), grav_esp() e grav_mat()
*/
char *obserp[MAXVAR];		/* ponteiros para obser */
char obser[MAXTOBS];		/* conteudo da matriz */

void grav_mat()
{
    char *pchar;		/* ponteiro para elementos de obser */
    char tipo;
    char nome[64];
    char aux[64];
    ARQ *fout;

    int i, j, k;
    int numvar;

    long ret;
    int iret;

    if ((ret = (long) (fout = cria_arq("xlxmat"))) < 0L) {
	if (ret > -4L) {
	    fprintf(stderr, PegaMsg(5006), "xlxmat");
	    setOSstdin();
#ifdef  MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("modlin");
		exit(2);
	    }
#endif

	    exit(2);
	}
    }

    /* Gravacao do arquivo .hdr */
    i = 1;
    for (k = 0; k < ndim; ++k) {
	if (k < (ndim - nd)) {	/* analisando efeitos */
	    strcpy(nome, "col");
	    itoa(k + 1, aux, 10);
	    strcat(nome, aux);
	} else {		/* analisando  variaveis dependentes */
	    strcpy(nome, efts[nef + i]);
	    i++;
	}

	tipo = 'n';

	if ((numvar = def_var(fout, nome, tipo)) < 0) {
	    fprintf(stderr, PegaMsg(1013), nome, numvar);
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("modlin");
		exit(2);
	    }
#endif

	    exit(2);
	}

    }

    /* Gravacao do arquivo .dat */
    for (i = 0; i < ndim; ++i) {	/* controle das linhas de xlx */
	pchar = obser;
	for (j = 0; j < ndim; ++j) {	/* controle das colunas de xlx */
	    obserp[j] = pchar;
	    gcvt((double) xlx[idx(i, j)], 15, pchar);
	    pchar += (strlen(pchar) + 1);
	}
	ret = grav_obs(fout, obserp);
	if (ret < 0L) {
	    fprintf(stderr, PegaMsg(5018), "xlxmat");
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("modlin");
		exit(2);
	    }
#endif

	    exit(2);
	}
    }

    iret = fech_arq(fout);
    if (iret < 0) {
	fprintf(stderr, PegaMsg(5005), "xlxmat");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif

	exit(2);
    }
}
