
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Imprime as medias

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/impmedia.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"
#define IMPRIME if (!iterativo && !tem_comando) fprintf(fout, "%s ", token);

static char *sccsid = "@(#)impmedia.c	3.2	(NTIA/modlin)	94/12/20";


extern int ctoken;
extern int impflag;
extern char *p2;
extern char *efts1[MAXEFTS];
extern int tem_comando;
extern int iterativo;
extern FILE *fout;
extern double f_qm;
extern double f_gl;
extern int n_vardep;

#ifdef MSDOS
extern int yyparse(void);
#else
extern int yyparse();
#endif

int impmedia(n, faux)
int n;
FILE *faux;
{
    int i;
    char *q;

    nmedias = 1;
    f_qm = -9.0;
    f_gl = -9.0;
    n_vardep = 0;

    ctoken = gtoken1(token, faux);
    while (ctoken != PTVG && ctoken != VG && ctoken != LC) {
	if (ctoken != VARIAV)
	    errocon(12, 2);
	IMPRIME;
	strcpy(buffer, token);
	for (i = 1; i < nef + nd; ++i) {
	    if (ef[i][0] == 0) {
		if (strcmpi(token, efts[i]) == 0 && ef[i][3] == 0) {
		    med[nmedias][0] = 1;
		    med[nmedias][1] = 0;
		    med[nmedias][2] = i;
		    nomemed[nmedias] = efts[i];
		    break;
		}
	    }
	}
	ctoken = gtoken1(token, faux);

	if (ctoken == LP) {
	    IMPRIME;
	    ctoken = gtoken1(token, faux);
	    if (ctoken != VARIAV)
		errocon(12, 2);
	    IMPRIME;
	    for (i = 0; i < nef + nd; ++i) {
		if (ef[i][0] == 0) {
		    if (strcmpi(token, efts[i]) == 0) {
			med[nmedias][1] = i;
			break;
		    }
		}
	    }
	    if (i == (nef + nd))
		med[nmedias][1] = -1;

	    strcat(buffer, "(");
	    strcat(buffer, token);

	    ctoken = gtoken1(token, faux);
	    if (ctoken != RP)
		errocon(13, 2);
	    IMPRIME;
	    strcat(buffer, ")");
	    ctoken = gtoken1(token, faux);
	    for (i = 0; i < nef + nd; ++i) {
		if (ef[i][0] == 0 && ef[i][3] == 0) {
		    if (strcmpi(buffer, efts[i]) == 0) {
			med[nmedias][0] = 3;
			med[nmedias][2] = i;
			nomemed[nmedias] = efts[i];
			break;
		    }
		}
	    }
	}

	if (i == (nef + nd))
	    errocon(12, 2);

	if (ctoken == POUND) {
	    IMPRIME;
	    ctoken = gtoken1(token, faux);
	    if (ctoken != VARIAV)
		errocon(12, 2);
	    IMPRIME;
	    for (i = 1; i < nef + nd; ++i) {
		if (ef[i][0] == 0 && ef[i][3] == 0) {
		    if (strcmpi(token, efts[i]) == 0) {
			med[nmedias][0] = 2;
			med[nmedias][1] = med[nmedias][2];
			med[nmedias][2] = i;
			q = nomemed[nmedias];
			nomemed[nmedias] = p;
			strcpy(p, q);
			strcat(p, "#");
			strcat(p, efts[i]);
			p += (strlen(p) + 1);
			break;
		    }
		}
	    }
	    if (i == nef + nd)
		errocon(12, 2);

	    ctoken = gtoken1(token, faux);
	    if (ctoken == POUND)
		errocon(13, 2);
	}
	if (ctoken == STAR)
	    errocon(15, 2);
	if (ctoken == LP)
	    errocon(14, 2);
	++nmedias;
    }
    IMPRIME;
    if (!iterativo && !tem_comando)
	fprintf(fout, "\n");
    --nmedias;
    if (ctoken == VG) {
	yyparse();
    }
    if (!iterativo && n_vardep) {
	for (i = 0; i < n_vardep; ++i) {
	    if (strcmpi(efts1[i], efts[nef + nd + n]) == 0) {
		media1(n);
		break;
	    }
	}
    } else {
	if (iterativo && n_vardep) {
	    fprintf(stderr,
		    "\nAdvertencia: No modo interativo a especificacao da variavel dependente para");
	    fprintf(stderr,
		    "\n             calculo das medias de Minimos Quadrados e' desprezada.");
	    fprintf(stderr,
		    "\n             As medias serao calculadas para a variavel %s.\n\n",
		    efts[nd + nef + n]);
	}
	media1(n);
    }
    return 0;
}


void media1(n_d)
int n_d;
{
    extern int nclass;

    double mda;			/* ajuste para a media */
    double media;		/* media das vaiaveis */
    double ep;			/* erro padrao */
    double x1;			/* variavel auxiliar */
    double x2, x3;
    double fator;
    int i, j, k, l;
    int impr;
    int pos;			/* Indica posicao da variavel na lista de efts */
    double qmr1;		/* Variavel para armazenar o erro utilizado */
    int k1, k2, k3, k4, k5;

    impr = 0;

    /* calculo e impressao das medias */

    for (i = 1; i < ndim; ++i)	/* zera o vetor que simula C */
	saida[i] = 0.0;
    saida[0] = 1.0;		/* coloca 1 na posicao da media */
    mda = 0.0;			/* calculo da media * beta da cov */
    for (i = 1; i < nef + nd; ++i) {
	if (ef[i][0] == -1 || ef[i][1] < 0) {
	    j = sv[i];
	    mda += (xlx[idx(nxlx, j)] * mean[j]);
	    saida[j] = mean[j];
	}
    }
    for (i = 1; i < nef + nd; ++i) {
	impr = 0;
	for (l = 1; l <= nmedias; ++l)
	    if ((med[l][0] == 1 || med[l][0] == 3) && (med[l][2] == i)
		&& (ef[i][0] == 0)) {

		pos = 0;
		for (i = 0; i < nef + nd; ++i) {
		    if (strcmpi(efts[i], nomemed[l]) == 0)
			break;
		    if (ef[i][0] == 0
			|| (ef[i][4] > 0
			    && (ef[i][0] <= 0 || ef[i][1] < 0)))
			pos++;
		}

		if (f_qm == -9.0) {
		    qmr1 = (ef[i][2] == 0) ? qmr : obs[ef[i][2]];
		} else {
		    qmr1 = f_qm;
		}

		x1 = 0.0;	/* para calcular a soma */
		x2 = 0.0;	/* para calcular a soma */
		x3 = 0.0;
		k1 = 1;
		k3 = 1;
		fator = 0.0;
		if (med[l][1] >= 0)
		    k2 = sv[med[l][1]];

		if (!impr) {
		    putchar1();
		    imptitulo("Medias de Minimos Quadrados");
		    printf("\t\t\t\tVariavel: %-8.8s\n",
			   efts[nef + nd + n_d]);
		    printf("\n%-32.32s Media          Erro Padrao\n\n",
			   efts[i]);
		    impr = 1;
		} else
		    printf("\n");

		k = ef[i][4] - 1;
		for (j = sv[i]; j < sv[i + 1]; ++j) {

		    if (med[l][0] == 3) {
			if (med[l][1] == -1) {
			    fator = 0.0;
			} else {
			    if (k3 > (sv[med[l][1] + 1] - sv[med[l][1]]))
				fator = -x3;
			    else
				fator = xlx[idx(nxlx, k2)];
			    x2 += (xlx[idx(nxlx, j)]);
			    monta_c_efeitop(k3, med[l][1], 1);
			}
		    }

		    media = mda + xlx[idx(nxlx, 0)] + xlx[idx(nxlx, j)];
		    media += fator;
		    x1 += (xlx[idx(nxlx, j)]);
		    saida[j] = 1.0;
		    ep = sqrt(cxlxcl() * qmr1);

		    strcpy(buffer, tira_mais(lista[pos].q));
		    printf("%-23.23s", buffer);
		    printf("%17s  %17s\n",
			   rounddec(media, 17, 8), rounddec(ep, 17, 8));
		    pos = lista[pos].prox;
		    saida[j] = 0.0;

		    if (med[l][0] == 3) {
			k5 = (nvhi[k][k3] - nvhi[k][k3 - 1] - 1);
			if (k1 == k5) {
			    x3 += fator;
			    for (k4 = 0; k4 < k5; ++k4) {
				saida[j - k4] = -1.0;
			    }

			    media = mda + xlx[idx(nxlx, 0)] - x2 + fator;
			    ep = sqrt(cxlxcl() * qmr1);
			    strcpy(buffer, tira_mais(lista[pos].q));
			    printf("%-23.23s", buffer);
			    printf("%17s  %17s\n",
				   rounddec(media, 17, 8),
				   rounddec(ep, 17, 8));
			    pos = lista[pos].prox;
			    for (k4 = 0; k4 < k5; ++k4) {
				saida[j - k4] = 0.0;
			    }
			    if (med[l][1] >= 0)
				monta_c_efeitop(k3, med[l][1], 0);
			    x2 = 0.0;
			    ++k2;
			    ++k3;
			    k1 = 1;
			} else {
			    if (med[l][1] >= 0)
				monta_c_efeitop(k3, med[l][1], 0);
			    k1++;
			}
		    }
		}
		if (med[l][0] != 3) {
		    for (j = sv[i]; j < sv[i + 1]; ++j) {
			saida[j] = -1.0;
		    }
		    media = mda + xlx[idx(nxlx, 0)] - x1 - x3;
		    ep = sqrt(cxlxcl() * qmr1);
		    strcpy(buffer, tira_mais(lista[pos].q));
		    printf("%-23.23s", buffer);
		    printf("%17s  %17s\n",
			   rounddec(media, 17, 8), rounddec(ep, 17, 8));
		    for (j = sv[i]; j < sv[i + 1]; ++j) {
			saida[j] = 0.0;
		    }
		    pos = lista[pos].prox;
		}
	    }
    }

    for (i = 1; i <= nmedias; ++i) {
	if (med[i][0] == 2) {
	    putchar1();
	    imptitulo("Medias de Minimos Quadrados");

	    printf("\t\t\t\tVariavel: %-8.8s\n", efts[nef + nd + n_d]);
	    printf("\n%-32.32s Media          Erro Padrao\n\n",
		   nomemed[i]);
	    media2(med[i][1], med[i][2], f_qm, mda);
	}
    }
}

char *tira_mais(s)
char *s;
{
    static char buf[80];
    int i;

    for (i = 0; i <= (int) strlen(s); i++) {
	if (s[i] == '+')
	    buf[i] = ' ';
	else
	    buf[i] = s[i];
    }
    return (buf);
}

void monta_c_efeitop(i, j, t)
int i, j, t;
{
    int k;

    if (i <= (sv[j + 1] - sv[j])) {
	k = sv[j];
	if (t)
	    saida[k + i - 1] = 1.0;
	else
	    saida[k + i - 1] = 0.0;
    } else {
	for (k = sv[j]; k < sv[j + 1]; k++) {
	    if (t)
		saida[k] = -1.0;
	    else
		saida[k] = 0.0;
	}
    }
}
