
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/imprimel.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/


#ifdef MSDOS
#include <stdlib.h>
#endif
#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

static char *sccsid = "@(#)imprimel.c	3.2	(NTIA/modlin)	94/12/20";

extern int nclass;
extern int proximo;
extern int nobs, nmis;
extern int ndep;

void imprimel()
{
    int i, j, l;
    int k;
    int num;
    char buffer[80];
    int flag;

    i = strlen(titulo);
    if (i < 80) {
	i = (80 - i) / 2;
	for (j = 0; j < i; ++j)
	    printf(" ");
    }
    printf("%s\n\n", titulo);
    printf("\tDescricao das variaveis e fatores do modelo\n\n");
    if (nclass > 0)
	printf("\tFatores  # niveis    Niveis\n");

    k = 0;
    for (i = 0; i < npar; ++i) {
	if (ef[i][0] == 0) {
	    if (tipo[k] < 9999) {
		flag = 0;
		printf("\t%-8s  %5d       ", ivar + (tipo[k]), soma[k]);
	    } else {
		flag = 1;
		printf("\t%-8s  %5d       ", efts[i], soma[k]);
	    }
	    l = j = k;
	    num = 0;
	    k++;
	    while ((j = lista[l].prox)) {
		if (flag)
		    poe_forma(buffer, lista[l].q);
		else
		    strcpy(buffer, lista[l].q);
		if (num >= 44) {
		    printf("\n %29.29s", " ");
		    num = 0;
		}
		printf("%-11.11s", buffer);
		num += 11;
		l = j;
	    }
	    printf("\n");
	}
    }
    l = 0;
    for (i = 0; i < npar; ++i) {
	if ((ef[i][0] == -1 || ef[i][1] < 0) && ef[i][3] == 0) {
	    if (l == 0) {
		if ((nef - ndep) > 1)
		    printf("\n\tCovariaveis: ");
		else
		    printf("\n\tCovariavel: ");
		printf("\t%s", efts[i]);
	    } else
		printf(", %s ", efts[i]);
	    ++l;
	}
    }
    if (l > 0)
	printf("\n");

    l = 0;
    if (ndep > 1)
	printf("\n\tVariaveis dependentes: ");
    else
	printf("\n\tVariavel dependente: ");

    for (i = 1; i <= npar; ++i) {
	if (ef[i][0] == -2) {
	    if (l == 0) {
		printf("\t%s", efts[i]);
	    } else
		printf(", %s ", efts[i]);
	    ++l;
	}
    }
    if (l > 0)
	printf("\n");

    printf("\n");
    printf("\tNumero de observacoes lidas      : %5d\n", nobs + nmis);
    printf("\tNumero de observacoes utilizadas : %5d\n\n", nobs);
}

/* ------------------------------------------------------------------------
** poe_forma()
** 	Programado por:	Silvo Evangelista
**	Data:		julho 1989
**	Descricao:	A partir de um nivel hierarquico, esta funcao reescre-
**			ve este nivel na ordem natural, por exemplo:
**			Seja     x = 1 + 1 + 2
**			buffer ---> 2 (1 1);
**	Variaveis ent.	x	Nivel de entrada
**			buffer  Nivel de saida
** ------------------------------------------------------------------------- */

void poe_forma(buffer, x)
char *buffer;
char *x;
{
    int i, j, k;
    int tamx;

    tamx = strlen(x);

    for (i = tamx - 1; i >= 0; i--) {
	if (x[i] == '+') {
	    break;
	}
    }
    k = 0;
    for (j = i + 2; j < tamx; j++) {
	buffer[k++] = x[j];
    }
    buffer[k++] = ' ';
    buffer[k++] = '(';

    for (j = 0; j < (i - 1); j++) {
	if (x[j] != '+')
	    buffer[k++] = x[j];
    }
    buffer[k++] = ')';
    buffer[k] = '\0';
}
