
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	"Set" os parametros necessarios para a execucao do problema

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/lerpar.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#ifdef MSDOS
#include <stdlib.h>
#endif
#ifndef VAXVMS
#include <malloc.h>
#endif
#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)lerpar.c	3.4	(NTIA/modlin)	95/01/11";

extern int npar;
extern int nby;
extern int ndep;
extern double mean1[MAXMEM];
FILE *f_par;			/* ponteiro para arquivo contendo os parametros */

void ler_par(vez)
int *vez;
{
    int j, i;
    int m, n, k, l;
    int vi;


    if (*vez == 0) {
	strcpy(p, "mg");
	efts[0] = p;
	p += (strlen(p) + 1);

	ef[0][0] = -2;
	ef[0][1] = 0;

	ntotal = nf;
	nf = nf - nef;
	nd = nef;

	if (nf + nd >= MAXEFTS)
	    erromod(5);
	nef = npar - nef;
    }
    v[0] = nv[0] = 1;
    sv[0] = 0;

    j = vi = 1;
    for (i = 1; i <= nef + nd; ++i) {
	m = ef[i][0];
	n = abs(ef[i][1]);
	k = ef[i][2];
	l = ef[i][3];
	if (m <= 0 || ef[i][1] < 0) {
	    if (m == 0)
		n = v[vi++];
	    else {
		if (ef[i][4] > 0)
		    n = v[vi++];
		else
		    n = 1;
	    }
	    m = 1;
	} else {
	    m = nv[m];
	    n = nv[n];
	}
	nv[i] = m * n;
	sv[i] = j;
	j += nv[i];
	if (j >= MAXMEM1) {
	    fprintf(stderr, "%d -> ", j);
	    erromod(6);
	}
    }


    sv[i] = j;
    nxlx = j - ndep;
    ndim = j;

    if (pflag)
	print_par();

    if (nby != 0 && *vez == 0) {
	grava_par();
	*vez = 1;
    }

    nao_acumular();

    j = 0;
    for (i = 1; i < nef + nd; ++i) {
	if (ef[i][0] == 0) {
	    if (ef[i][4] > 0) {
		l = ef[i][4] - 1;
		pos[i] = j;
		for (k = 0; k < nchi[l]; k++) {
		    j += (nvhi[l][k + 1] - nvhi[l][k]);
		}
	    } else {
		pos[i] = j;
		j += (nv[i] + 1);
	    }
	}
    }
    for (i = 0; i < ndep; i++) {
	if (i > MAXDEP - 1)
	    break;
	com_med[i] = (double *) calloc((unsigned) j, sizeof(double));
	com_nv[i] = (int *) calloc((unsigned) j, sizeof(int));
    }
}


/* Coloca 1.0 nas colunas de XLX que deverao sair */
void nao_acumular()
{
    int i;
    int j;
    for (i = 0; i < ndim; i++)
	mean1[i] = 0.0;
    for (i = 1; i <= nef + nd; ++i) {
	if ((ef[i][0] == -1 || ef[i][1] < 0) && ef[i][3] > 0) {
	    for (j = sv[i]; j < sv[i + 1]; ++j) {
		mean1[j] = 1.0;
	    }
	}
    }
}

void grava_par()
{
    int i;
    int j;
    f_par = fopen("modlin.par", "w");
    if (f_par == (FILE *) NULL) {
	fprintf(stderr, PegaMsg(5006), "modlin.par");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif

	exit(2);
    }

    fprintf(f_par, "%d\n", nef);
    for (i = 0; i <= nef + nd; ++i) {
	for (j = 0; j < 5; ++j) {
	    fprintf(f_par, "%d ", ef[i][j]);
	}
	fprintf(f_par, "%s\n", efts[i]);
    }
    if (fclose(f_par) == EOF) {
	fprintf(stderr, PegaMsg(5005), "modlin.par");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif

	exit(2);
    }

}

void recupera_par()
{
    extern char *p1;

    int i;
    int j;

    p1 = area;
    f_par = fopen("modlin.par", "r");
    if (f_par == (FILE *) NULL) {
	fprintf(stderr, PegaMsg(5020), "modlin.par");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif

	exit(2);
    }

    fscanf(f_par, "%d\n", &nef);
    for (i = 0; i <= nef + nd; ++i) {
	for (j = 0; j < 5; ++j) {
	    fscanf(f_par, "%d ", &ef[i][j]);
	}
	fscanf(f_par, "%s\n", p1);
	efts[i] = p1;
	p1 += (strlen(p1) + 1);
    }
    if (fclose(f_par) == EOF) {
	fprintf(stderr, PegaMsg(5005), "modlin.par");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif

	exit(2);
    }

}
