
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:
	
	Calcula media e erro para dois fatores

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/media2.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)media2.c	3.2	(NTIA/modlin)	94/12/20";

#define DADOij(s,i,j) (s[(i)*xdim2 + (j)])

extern double mean1[MAXMEM];
double t5[MAXMEM];

void media2(i1, i2, f_qm, y5)
int i1, i2;
double f_qm, y5;
{
    int i, j, k, l, l1, tem = 0;
    int pos1, pos2;
    double *x1, *x3, iter = 0.0;
    double t1 = 0.0, t2 = 0.0, t3 = 0.0;
    double y4;
    int kk;
    int xdim;
    int xdim2;

/*
	x1 = (double *) calloc((unsigned) (nv[i1]+1)*(nv[i2]+1) , sizeof(double));
	if (x1 == (double *) NULL)
		errocon(23,2);
	x3 = (double *) calloc((unsigned) (nv[i1]+1)*(nv[i2]+1) , sizeof(double));
*/
    xdim2 = sv[i2 + 1] - sv[i2] + 1;
    xdim = (sv[i1 + 1] - sv[i1] + 1) * xdim2;

    x1 = (double *) calloc((unsigned) xdim, sizeof(double));
    if (x1 == (double *) NULL)
	errocon(23, 2);
    x3 = (double *) calloc((unsigned) xdim, sizeof(double));

    if (x3 == (double *) NULL) {
	free((char *) x1);
	errocon(23, 2);
    }

    /* Inicializa o vetor temporaio */

    for (i = 0; i < MAXMEM; ++i) {
	mean1[i] = 0.0;
	t5[i] = 0.0;
    }

    pos1 = 0;
    for (i = 0; i < nef + nd; ++i) {
	if (i == i1) {
	    break;
	}
	if (ef[i][0] == 0
	    || (ef[i][4] > 0 && (ef[i][0] <= 0 || ef[i][1] < 0))) {
	    pos1++;
	}
    }
    pos2 = 0;
    for (i = 0; i < nef + nd; ++i) {
	if (i == i2) {
	    break;
	}
	if (ef[i][0] == 0
	    || (ef[i][4] > 0 && (ef[i][0] <= 0 || ef[i][1] < 0))) {
	    pos2++;
	}
    }

    if (f_qm == -9.0) {
	y4 = ((ef[i1][2] - ef[i2][2]) == 0
	      && ef[i1][2] != 0) ? obs[ef[i][2]] : qmr;
    } else {
	y4 = f_qm;
    }

    /* Verifica se existe iteracao especificada no modelo */

    for (l = 1; l <= nef + nd; ++l) {
	if (((ef[l][0] == i1) && (abs(ef[l][1]) == i2)) ||
	    ((ef[l][0] == i2) && (abs(ef[l][1]) == i1))) {
	    tem = 1;
	    k = sv[l];		/* posicao da iteracao */
	    l1 = l;
	    break;
	}
    }
    for (i = sv[i1]; i < sv[i1 + 1]; ++i) {
	t1 += xlx[idx(nxlx, i)];	/* soma dos bi */
	for (j = sv[i2]; j < sv[i2 + 1]; ++j) {
	    saida[i] = 1.0;
	    saida[j] = 1.0;

	    if (tem == 1) {
		iter = xlx[idx(nxlx, k)];
		saida[k] = 1.0;
		k += 1;
	    } else
		iter = 0.0;

	    DADOij(x3, i - sv[i1], j - sv[i2]) = sqrt(cxlxcl() * y4);

	    saida[i] = 0.0;
	    saida[j] = 0.0;
	    if (tem == 1)
		saida[k - 1] = 0.0;

	    DADOij(x1, i - sv[i1], j - sv[i2]) =
		y5 + xlx[idx(nxlx, 0)] + xlx[idx(nxlx, j)]
		+ xlx[idx(nxlx, i)] + iter;

	    if (i == sv[i1])
		t2 += xlx[idx(nxlx, j)];	/* soma dos bj */

	    t3 += iter;		/* soma dos bibj */
	    t5[i - sv[i1] + 1] += iter;	/* soma dos bib* */
	    mean1[j - sv[i2] + 1] += iter;	/* soma dos b*bj */
	}
    }
    /* Calcula media e erro para o ultimo nivel do primeiro fator */
    /* combinado com todos os niveis (exceto o ultimo) do segundo */

    for (j = sv[i1]; j < sv[i1 + 1]; ++j) {
	saida[j] = -1.0;
    }

    if (tem)
	k = sv[l1];

    for (j = sv[i2]; j < sv[i2 + 1]; ++j) {
	DADOij(x1, sv[i1 + 1] - sv[i1], j - sv[i2]) =
	    y5 + xlx[idx(nxlx, 0)] - t1 + xlx[idx(nxlx, j)]
	    - (mean1[j - sv[i2] + 1]);

	if (tem) {
	    kk = k;
	    cri_c_comb(&k, i1, nv[i2], -1.0);
	    k = kk;
	}
	saida[j] = 1.0;
	DADOij(x3, sv[i1 + 1] - sv[i1], j - sv[i2]) = sqrt(cxlxcl() * y4);

	saida[j] = 0.0;
	if (tem) {
	    cri_c_comb(&k, i1, nv[i2], 0.0);
	    k = kk + 1;
	}

    }
    for (j = sv[i1]; j < sv[i1 + 1]; ++j) {
	saida[j] = 0.0;
    }

    /* Calcula media e erro para o ultimo nivel do segundo fator */
    /* combinado com todos os niveis (exceto o ultimo) do primeiro */

    for (j = sv[i2]; j < sv[i2 + 1]; ++j) {
	saida[j] = -1.0;
    }

    if (tem)
	k = sv[l1];
    for (i = sv[i1]; i < sv[i1 + 1]; ++i) {
	DADOij(x1, i - sv[i1], sv[i2 + 1] - sv[i2]) =
	    y5 + xlx[idx(nxlx, 0)] - t2 + xlx[idx(nxlx, i)]
	    - (t5[i - sv[i1] + 1]);
	saida[i] = 1.0;
	if (tem) {
	    kk = k;
	    cri_c_comb(&k, i2, 1, -1.0);
	    k = kk;
	}
	DADOij(x3, i - sv[i1], sv[i2 + 1] - sv[i2]) = sqrt(cxlxcl() * y4);

	saida[i] = 0.0;
	if (tem) {
	    cri_c_comb(&k, i2, 1, 0.0);
	}

    }
    if (tem)
	k = sv[l1];
    for (i = sv[i1]; i < sv[i1 + 1]; ++i) {
	for (j = sv[i2]; j < sv[i2 + 1]; ++j) {
	    saida[i] = -1.0;
	    saida[j] = -1.0;
	    if (tem) {
		saida[k] = 1.0;
		k += 1;
	    }
	}
    }

    /* Calcula media e erro para os ultimos niveis dos dois fatores */

    DADOij(x1, sv[i1 + 1] - sv[i1], sv[i2 + 1] - sv[i2]) =
	y5 + xlx[idx(nxlx, 0)] - t1 - t2 + t3;
    DADOij(x3, sv[i1 + 1] - sv[i1], sv[i2 + 1] - sv[i2]) =
	sqrt(cxlxcl() * y4);

    if (tem)
	k = sv[l1];
    for (i = sv[i1]; i < sv[i1 + 1]; ++i) {
	for (j = sv[i2]; j < sv[i2 + 1]; ++j) {
	    saida[i] = 0.0;
	    saida[j] = 0.0;
	    if (tem) {
		saida[k] = 0.0;
		k += 1;
	    }
	}
    }

    l = 0;
    for (i = sv[i1]; i < (sv[i1 + 1] + 1); ++i) {
	k = pos2;
	l1 = 0;
	for (j = sv[i2]; j < (sv[i2 + 1] + 1); ++j) {
	    impme(lista[pos1].q, lista[k].q,
		  DADOij(x1, l, l1), DADOij(x3, l, l1));
	    k = lista[k].prox;
	    l1++;
	}
	pos1 = lista[pos1].prox;
	l++;
    }

    free((char *) x1);
    free((char *) x3);
}

void cri_c_comb(k, i, passo, t)
int *k, i, passo;
double t;
{
    int j;
    for (j = sv[i]; j < sv[i + 1]; ++j) {
	saida[*k] = t;
	*k = *k + passo;
    }
}
