
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/modelo.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#define	EXTVAR
#include "anova.h"

#include <stdlib.h>

#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)modelo.c	3.4	(NTIA/modlin)	95/01/11";

extern int nclass;
extern int ndep;
extern int nby;
extern char *p2;
extern char *p3;
extern char *efts1[MAXEFTS];
extern char *efts_by[MAXBY];
extern int ef_by[MAXBY];
extern int tip_by[MAXBY];

int cerro[MAXEFTS];
int ordc = 1;			/* Flag ordenacao ascendente */
int nh = 0;

int fatual_xlx;			/* Esta flag indica se devemos atualizar xlx */
		/* Inicializado ---> modelo.c                */
		/* Utilizado    ---> ver1_xlx                */

int modelo()
{

    int c;
    int ind;
    int i, j, k, l, n;
    int flag1;
    int flag2;			/* Utilizado para mascarar as posicoes das
				   covariaveis nas iteracoes */
    int masc;
    char buf1[128];

    setjmp(env);
    npar = npos = 0;
    nby = 0;
    p = (char *) &xobs[MAXVAR];

    ndep = 0;
    nh = 0;
    fatual_xlx = 0;

    for (i = 0; i < MAXEFTS; ++i) {
	qtde[i] = 0;
	soma[i] = 0;
	tipo[i] = 0;
	cerro[i] = 0;
	ef[i][4] = 0;
    }
    nf = 0;

    c = getoken(token);
    if (c == EOF || c == RB) {
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(0);
	}
#endif
	exit(0);
    }

    if (c != VARIAV) {
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(0);
	}
#endif
	exit(0);		/* terminou */
    }

    if (strcmpi(token, "tl") == 0) {
	while ((c = xgetc(stdin)) == ' ' || c == '\t' || c == '\n' || c == '\r');	/* tira brancos a direita */
	i = 0;
	while (c != ';' && i < 127) {
	    titulo[i++] = (char) c;
	    c = xgetc(stdin);
	}
	titulo[i] = 0;
	c = getoken(token);
    }
    /* terminou de processar o titulo */
    if (strcmpi(token, "class") == 0) {
	c = getoken(token);
	if (c != VARIAV)
	    erromod(0);
	if ((i = veri_var(fd, token)) < 0)
	    erromod(1);
	strcpy(p3, token);
	efts_by[nby] = p3;
	p3 += (strlen(p3) + 1);
	tip_by[nby] = var_tipo(i);
	ef_by[nby++] = i;
	while ((c = getoken(token)) != PTVG
	       && (strcmpi(token, "ord") != 0)) {
	    if (c != VARIAV)
		erromod(0);
	    if ((i = veri_var(fd, token)) < 0)
		erromod(1);
	    strcpy(p3, token);
	    efts_by[nby] = p3;
	    p3 += (strlen(p3) + 1);
	    tip_by[nby] = var_tipo(i);
	    ef_by[nby++] = i;
	    if (nby > MAXBY)
		erromod(13);
	}
	if (strcmpi(token, "ord") == 0) {
	    c = getoken(token);
	    if (c != IGUAL)
		erromod(4);
	    c = getoken(token);
	    if (strcmpi(token, "asc") == 0)
		ordc = 1;
	    else {
		if (strcmpi(token, "desc") == 0)
		    ordc = 0;
	    }
	    if ((c = getoken(token)) != PTVG)
		erromod(16);
	}
	c = getoken(token);
    }
    /* Terminou de processar comando class */
    if (strcmpi(token, "mod") != 0)
	erromod(2);
    /* estou fazendo o parse do comando mod */
    while ((c = getoken(token)) != IGUAL) {
	if (ndep >= MAXDEP)
	    erromod(15);
	if (c != VARIAV) {	/* variavel dependente */
	    erromod(0);
	}
	if ((i = veri_var(fd, token)) < 0)
	    erromod(1);
	for (j = 0; j < ndep; ++j) {
	    if (strcmpi(xobs[j], token) == 0)
		erromod(10);
	}
	flag = -2;
	var_verifica(i, &ind);
	strcpy(p, token);
	xobs[npar++] = p;
	p += (strlen(p) + 1);
	sv[npar] = npos;
	++ndep;
    }
    c = getoken(token);
    if (c == LC)
	erromod(8);
    if (c == LP)
	erromod(0);
    flag1 = 0;
    flag2 = 0;
    masc = 1;
    while (c != PTVG) {
	flag = 0;
	if (c == LA) {
	    flag = RA;
	    c = getoken(token);
	    flag1 = 1;
	}

	if (c == LC) {
	    flag = RC;
	    c = getoken(token);
	    flag1 = 1;
	}

	if (c == LB) {
	    flag = RB;
	    c = getoken(token);
	    flag1 = 1;
	}

	while (c == VARIAV) {
	    flag1 = 1;
	    buffer[0] = '\0';
	    buf1[0] = '\0';
	  l1:
	    do {
		if ((i = veri_var(fd, token)) < 0)
		    erromod(1);
		var_verifica(i, &ind);
		strcpy(buf1, token);

		if (flag == RA) {
		    flag2 = flag2 | masc;
		}
		masc *= 2;

		c = getoken(token);

		/* ------------------------------ */
		/* Isto foi colocado para aceitar */
		/*  <a*b c>                       */

		if (c == VARIAV) {
		    if (flag == RA) {
			flag2 = flag2 | 512;
		    }
		}

		/* ------------------------------ */
		/* Isto foi colocado para aceitar */
		/*  <a>*b , <a>(b)                */
		if (c == RA) {
		    if (flag == RA) {
			flag2 = flag2 | 512;
			c = getoken(token);
			flag = 0;
		    } else {
			erromod(3);
		    }
		}
		/* ---------------------------- */

		if (c == STAR) {
		    strcat(buffer, "*");
		    j = getoken(token);
		}
		if (j == LA) {
		    if (flag == RA)
			erromod(3);
		    flag = RA;
		    j = getoken(token);
		    flag1 = 1;
		}
	    } while (c == STAR);
	    if (c == LP) {
		int jj;
		int j;
		j = 0;

		hi[nh][j++] = i;
		qtde[npar]--;
		npos--;

		if (ind) {
		    --nf;
		    ajuda[nf] = 0;
		}

		strcat(buffer, "(");
		strcat(buf1, "(");
		while ((c = getoken(token)) != RP) {

		    if ((i = veri_var(fd, token)) < 0)
			erromod(1);
		    hi[nh][j++] = i;
		    strcat(buffer, token);
		    strcat(buf1, token);
		    strcat(buffer, " ");
		    strcat(buf1, " ");
		}
		buffer[strlen(buffer) - 1] = '\0';
		buf1[strlen(buf1) - 1] = '\0';
		strcat(buffer, ")");
		strcat(buf1, ")");

		nhi[nh] = j;

		for (k = 0; k < npar; ++k) {
		    if ((jj = substr(xobs[k], buf1)) > 0) {
			--jj;
			break;
		    }
		}
		if (k == npar) {
		    var1_verifica(9999 + nh, buf1);
		    ++nh;
		    if (flag != RC)
			ef[npar][4] = nh;
		    else
			ef[npar][4] = 0;
		} else {
		    var1_verifica(ajuda[pos[sv[k]] + jj], buf1);
		    if (flag != RC)
			ef[npar][4] =
			    (ajuda[pos[sv[k + 1] - 1]] - 9999) + 1;
		    else
			ef[npar][4] = 0;
		}

		c = getoken(token);
	    }
	    if (c == STAR) {
		strcat(buffer, "*");
		c = getoken(token);
		fatual_xlx = 1;
		goto l1;
	    }
	    if (qtde[npar] > 1)
		qsort((void *) &pos[sv[npar]],
		      (size_t) qtde[npar], (size_t) sizeof(int), compare);

	    if (flag2 > 512)
		tipo[npar] = flag2;
	    flag2 = 0;
	    masc = 1;
	    strcpy(p, buffer);
	    xobs[npar++] = p;
	    p += (strlen(p) + 1);
	    sv[npar] = npos;
	}
	if (flag) {
	    if (c != flag) {
		erromod(3);
	    } else {
		c = getoken(token);
	    }
	}
	if (!flag1)
	    erromod(14);
    }
    sv[npar] = npos;

    ivar = fd->pvar;
    nef = 0;
    l = 0;
    n = 0;
    for (i = 0; i < npar; i++) {
	if (tipo[i] == RC) {
	    ++n;
	    if (tipo[i - 1] == 0 || tipo[i - 1] == -1 || tipo[i - 1] > 512) {
		strcpy(p2, xobs[i]);
		efts1[i - 1] = p2;
		p2 += (strlen(p2) + 1);
		c = n;
		for (j = i + 1; j < npar; ++j) {
		    if (tipo[j] == RC)
			++c;
		    if (strcmpi(xobs[i], xobs[j]) == 0) {
			break;
		    }
		}
		cerro[i - 1] = j - c;
	    }
	}
	if (tipo[i] == RA)
	    tipo[i] = -1;
	if (tipo[i] == RB) {
	    c = n;
	    for (j = i + 1; j < npar; ++j) {
		if (tipo[j] == RC) {
		    ++c;
		    break;
		}
	    }
	    for (k = j + 1; k < npar; ++k) {
		if (tipo[k] == RC)
		    ++c;
		if (strcmpi(xobs[j], xobs[k]) == 0) {
		    break;
		}
	    }
	    strcpy(p2, xobs[j]);
	    efts1[i] = p2;
	    p2 += (strlen(p2) + 1);
	    cerro[i] = k - c;
	}
	if (tipo[i] < 0)
	    ++nef;
    }
    l = ndep;
    n = sv[ndep];
    for (i = ndep; i < npar; ++i) {
	if (tipo[i] != RC) {
	    cerro[l] = cerro[i];
	    xobs[l] = xobs[i];
	    qtde[l] = qtde[i];
	    tipo[l] = tipo[i];
	    efts1[l] = efts1[i];
	    ef[l][4] = ef[i][4];
	    sv[l] = n;
	    n += qtde[l];
	    for (j = 0; j < qtde[i]; ++j)
		pos[sv[l] + j] = pos[sv[i] + j];
	    ++l;
	}
    }
    npar = l;
    modelo1();

    return 0;
}


/*.........................................................................*/

int var_tipo(num)
int num;
{
    char nome[20];
    double mmin, mmax;
    char tipo;
    int ret;

    ret =
	pega_var(fd, num, nome, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1062));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif

	exit(2);
    }

    if (tipo == 'c')
	return 0;
    else if (tipo == 'd')
	return 2;
    else
	return 1;
}
