
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/modelo1.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

static char *sccsid = "@(#)modelo1.c	3.2	(NTIA/modlin)	94/12/20";

int qt[MAXMEM];
int s[MAXMEM];
int pp[3 * MAXMEM];
int ff[MAXMEM];
int numpar;
int lef;
int novo_k2;			/* Indica o numero de colunas que foram acrescentadas */
extern int ndep;

void modelo1()
{
    int i, j, l, k, i1, i2, i3, i4;
    extern char *efts1[MAXEFTS];
    extern int cerro[MAXEFTS];
    extern char *p1;

    lef = 0;
    novo_k2 = 0;

    for (i = 0; i < npar; ++i) {
	if (qtde[i] > 1) {
	    j = expande(i);
	    i += j;
	    npar += j;
	}
    }

    for (i = 0; i < npar; ++i) {
	if (qtde[i] > 1) {
	    if (tipo[i] > 512) {
		for (k = 0; k < qtde[i]; ++k) {
		    if (getbit(tipo[i], k, 1) == 0)
			break;
		}
		if (k == qtde[i])
		    tipo[i] = -1;
		else
		    tipo[i] = 0;
	    }
	} else {
	    if (tipo[i] > 512)
		tipo[i] = -1;
	}
    }

    for (i = 0; i < npar; ++i) {	/* Atualiza parametros que talvez 
					   tenham que ser atualizados */
	if (cerro[i] > 0) {
	    for (j = 0; j < npar; ++j) {
		if ((strcmpi(efts1[i], xobs[j])) == 0) {
		    cerro[i] = j;
		    break;
		}
	    }
	    if (j == npar)
		erromod(9);
	}
    }

    i = 1;
    for (l = 0; l < npar; ++l) {
	if (tipo[l] != -2) {
	    j = qtde[l];
	    if (tipo[l] < 0) {
		i1 = (tipo[l] == -3) ? 0 : tipo[l];
		i3 = cerro[l];
	    } else {
		i1 = 0;
		i3 = cerro[l];
	    }
	    i4 = soma[l];
	    if (qtde[l] == 1) {
		i2 = (tipo[l] == -3) ? -pos[sv[l]] : pos[sv[l]];
	    } else {
		i1 = ver1(l);
		if (tipo[l] == -1)
		    i2 = (-1) * ver2(l);
		else
		    i2 = ver2(l);

	    }
	    ef[i][0] = i1;
	    ef[i][1] = i2;
	    if (ef[i][0] < 0 && ef[i][1] < 0)
		ef[i][0] = abs(ef[i][0]);
	    ef[i][2] = i3;
	    ef[i][3] = i4;
	    if (l != i) {
		ef[i][4] = ef[l][4];
		ef[l][4] = 0;
	    }
	    strcpy(p1, xobs[l]);
	    efts[i] = p1;
	    p1 += (strlen(p1) + 1);
	    i++;
	}
    }
    k = nf - 1;
    for (l = 0; l < npar; ++l) {
	if (tipo[l] == -2) {
	    j = qtde[l];
	    i1 = tipo[l];
	    i2 = pos[sv[l]];
	    i3 = 0;
	    i4 = soma[l];
	    ++k;
	    ef[i][0] = i1;
	    ef[i][1] = k;
	    ef[i][2] = i3;
	    ef[i][3] = i4;
	    ef[i][4] = 0;
	    strcpy(p1, xobs[l]);
	    efts[i] = p1;
	    p1 += (strlen(p1) + 1);
	    i++;
	}
    }
    ef[0][0] = -2;
    ef[0][1] = 0;
    ef[0][2] = 0;
    ef[0][3] = 0;
    ef[0][4] = 0;

    if (strlen(titulo) == 0)
	strcpy(titulo, "  ");

}
