
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/modelo2.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#ifdef MSDOS
#include <stdlib.h>
#endif
#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif
#include "anova.h"
#include "getoken.h"
#include "pcsgbd.h"
#include "modelo.h"

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)modelo2.c	3.3	(NTIA/modlin)	95/07/26";


int nclass;
int proximo;
int nobs, nmis;
extern int ndep;
extern int vez;
extern int nby;
extern int uflag;
extern char atividade[];

void modelo2(pos_ret)
long pos_ret;			/* pos_retorno apos a primeira leitura */
{
    int i, j, n;
    long ii;
    int jj;

    if (vez)
	recupera_par();

    /* -------------------------------------------------------------- */
    /* Este if e' necessario para fazer o missing certo para casos onde
       existe mais de uma variavel dependente */
    if (vez && ndep > 1)
	n = ndep - 1;
    else
	n = 0;
    /* -------------------------------------------------------------- */

    /* fazer lista de variaveis de classificacao */
    j = 0;
    for (i = 0; i < npar; ++i) {
	if (ef[i][0] == 0
	    || (ef[i][4] > 0 && (ef[i][0] <= 0 || ef[i][1] < 0))) {
	    if (ef[i][4] > 0) {
		if (ef[i][0] == 0)
		    tipo[j++] = 9999 + ef[i][4] - 1;
		else
		    tipo[j++] = 22222 + ef[i][4] - 1;
	    } else
		tipo[j++] = ajuda[abs(ef[i][1]) + n];
	}
    }
    nclass = j;
    for (i = 0; i < nclass; ++i) {
	lista[i].q = (char *) NULL;
	lista[i].prox = 0;
    }
    p = b;
    ivar = fd->pvar;
    proximo = nclass;



    nobs = nmis = 0;
    if (vez) {
	if (missing(npar, n))
	    ++nmis;
	else {
	    ++nobs;
	    pegalista();
	}
    }

    jj = 0;

    while ((ii = ler_obs(fd, xobs)) >= 0L) {
	if ((ii == 0L) && (nby > 0))
	    inicioby();
/*
#ifdef MSDOS
		fprintf(stderr, "\r%ld",ii+1);
#endif
*/

	if (ii % 10 == 0) {
	    fprintf(stderr, "\r%c", atividade[jj]);

	    jj = (jj + 1) % 4;
	}

	if (class() == 0) {
	    if (missing(npar, n))
		++nmis;
	    else {
		++nobs;
		pegalista();
	    }
	} else
	    break;
    }

/*
#ifdef MSDOS
	fprintf(stderr, "\n");
#endif
*/

    fprintf(stderr, "\r  \r");

    ordenalista();
    hierarquicos();
    if (uflag == 0)
	imprimel();
    implstnv();
    ajustasvhi();

    if (vez == 0) {
	for (i = 0; i <= npar; ++i) {
	    if (ndep > 1) {
		ef[i][0] = (ef[i][0] > 0) ? ef[i][0] - ndep + 1 : ef[i][0];
		n = abs(ef[i][1]) - ndep + 1;
		ef[i][1] = (ef[i][1] < 0) ? -n : n;
		ef[i][2] = (ef[i][2] == 0) ? 0 : ef[i][2] - ndep + 1;
		ef[i][3] = (ef[i][3] == 0) ? 0 : ef[i][3] - ndep + 1;
	    }
	}
    }
    rew_arq(fd);		/* volta arquivo ao inicio */

    /* ----------------------------------------------------------------- */
    /* Volta para na posicao que parou para executar o class             */
    if (pos_ret > 1l) {
	while (ler_obs(fd, xobs) < pos_ret);
    }
    /* ----------------------------------------------------------------- */

    ler_par(&vez);
    for (i = 0; i < nclass; ++i) {
	soma[i] = tipo[i];
    }
    j = 0;			/* colocar em tipo se var. e' class ou nao */
    for (i = 0; i < npar; ++i) {
	if (ef[i][0] <= 0) {
	    tipo[j++] = (ef[i][0] == 0) ? -1 : 0;
	}
    }
}

void hierarquicos()
{
    int i, l, j, m, np, k;

    for (i = 0; i < nclass; ++i) {
	if (tipo[i] >= 9999) {
	    np = 0;
	    l = j = i;
	    if (tipo[i] >= 22222)
		m = tipo[i] - 22222;
	    else
		m = tipo[i] - 9999;
	    while ((j = lista[l].prox)) {
		if (!sao_iguais(lista[l].q, lista[j].q, nhi[m]))
		    np++;
		l = j;
	    }
	    nvhi[m] = (int *) calloc((unsigned) (np + 1), sizeof(int));
	    nchi[m] = np;

	    l = j = i;
	    k = 0;
	    np = 1;
	    while ((j = lista[l].prox)) {
		if (sao_iguais(lista[l].q, lista[j].q, nhi[m])) {
		    np++;
		} else {
		    nvhi[m][k++] = np;
		    np = 1;
		}
		l = j;
	    }
	}
    }
}

int sao_iguais(a, b, n)
char *a;
char *b;
int n;
{
    int i;
    int k;
    int l;

    k = 1;
    for (i = 0; i < (int) strlen(a); ++i) {
	if (a[i] == '+')
	    k++;
	if (k == n) {
	    l = 1;
	    break;
	}
	if (a[i] != b[i]) {
	    l = 0;
	    break;
	}
    }
    return (l);
}

void ajustasvhi()
{
    int i, m;
    int j;
    int temp[MAXMEM];

    for (i = 0; i < nclass; ++i) {
	if (tipo[i] >= 9999) {
	    if (tipo[i] >= 22222)
		m = tipo[i] - 22222;
	    else
		m = tipo[i] - 9999;
	    temp[0] = 0;
	    for (j = 1; j < nchi[m] + 1; j++) {
		temp[j] = temp[j - 1] + nvhi[m][j - 1];
	    }
	    for (j = 0; j < nchi[m] + 1; j++) {
		nvhi[m][j] = temp[j];
	    }
	}
    }
}
