
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/modlin.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#define EXTERN

#include <stdio.h>
#include <stdlib.h>

#ifndef VAXVMS
#include <malloc.h>
#endif

#ifdef MSDOS
#include <process.h>
#endif

#ifdef i486
#include <unistd.h>
extern char **environ;
#endif

#include "anova.h"
#include "pcsgbd.h"
#include "getoken.h"
#include "modelo.h"

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

/*#include "lockfile.h"*/

#ifndef MISSING
#ifdef MSDOS
# define MISSING	1.0e306
#else
# define MISSING	1.7e38
#endif
#endif

static char *sccsid = "@(#)modlin.c	3.18	(NTIA/modlin)	97/02/17";

/* ----------------------------------------------------------------------------
** @(#)modlin.c	3.18	(NTIA/modlin)	97/02/17
**
** 
**
** Modulo para calculo de analise de variancia.
**
** Forma de usar:
**
**		modlin [opcoes] nomebase
**
** Opcoes envolvidas:
**
**		nomebase : nome da base de dados a ser atualizada
**
** Programado por:
**
**		Carlos Fernando Assis Paniago
**
** Alterado por:
**
**		Sonia Ternes e Silvio Evangelista (inclusao do MULTVAR)
**
** Data da ultima alteracao:
**
**		97/02/17 18:04:36
**
** ----------------------------------------------------------------------------
*/

char *p;			/* ponteiro para a area nao usada */
			/* utilizado para guardar os niveis dos efeit. prin */
char *p1;			/* ponteiro para a area nao usada */
			/* Utilizado para guardar nomes dos efeitos */
char *p2;			/* ponteiro para a area nao usada */
char *p3;			/* ponteiro para a area nao usada */
			/* utilizado para guardar as var.de by */

char area1[768];
char area2[15 * MAXBY];
char obs2[MAXBY][80];
char *efts_by[MAXBY];
int ef_by[MAXBY];
int tip_by[MAXBY];
int nby;			/* Numero de By's */
int vez;			/* Flag que indica se e' a primeira execucao ou nao
				   do modlin : Usado no Caso de Class */

int med1[MAXMEM];

int fl_mult = 0;		/* flag para execucao de analise multivariada */
int uflag = 0;			/* flag para nao imprimir analise univariada: neste
				   caso o usuario esta interessado no MULTVAR */
int pflag = 0;			/* flag de impressao de leitura */
int xflag = 0;			/* flag de impressao de x'x */
int lflag = 0;			/* flag de impressao de dados originais */
int rflag = 0;			/* flag de impressao de passos de calculo */
int bflag = 0;			/* flag de impressao de beta */
int sflag = 0;			/* flag de impressao e calcula da tabela parcial */
int impflag = 0;		/* flag de saida em impressora */
int singul = 0;			/* flag de singularidade da matriz */
int singul1 = 0;		/* flag de singularidade da matriz */
int ndep = 0;			/* numero de variaveis dependentes */
int iterativo = 1;
int flagX = 0;
int tem_comando;
int nd1;
int ndim1;
int nv1[MAXMEM];

#ifdef MSDOS
int nlins = 25;
#else
int nlins = 24;
#endif

int ncols = 80;

char *efts1[MAXEFTS];
char *parm[20];			/* opcoes fornecidas pelo usuario na execucao do modlin,                         a serem passadas para o multvar */

FILE *faux;

double sse1[MAXMEM];

#define MUDA_PAG 12

char atividade[] = "|/-\\";

int c, c1;
int tem1_comando;

int descarq;			/* descritor de arquivo para funcoes de lock */

extern char *xobs[];
extern int fatual_xlx;
extern int nobs;

/*
extern void execvp();
*/

main(argc, argv)
int argc;
char *argv[];
{
    int i;
    extern ARQ *fd;
    long m;
    char *ptr;
    char buff[32];
    int jj;
    int ret;

#ifdef VAXVMS
    argc = prepvax(argc, argv);
#endif

    /* Inicializa *parm para funcao getpar */
    for (i = 0; i < 20; i++)
	parm[i] = '\0';

    descarq = -1;

    getarg(argc, argv);		/* le os argumentos e abre arquivo */

    c1 = 0;
    c = 0;
    vez = 0;
    p1 = area;
    p2 = area1;
    p3 = area2;
    tem_comando = 0;
    tem1_comando = 0;
    nby = 0;

    for (i = 0; i < MAXEFTS; ++i)
	efts1[i] = "";

    if (uflag == 0)
	putchar1();
    modelo();
    modelo2(1l);

    if (nobs > 0) {		/* teste de primeira classe vazia */
	aloca_xlx();
    }

    inicializa();

/*
#ifdef MSDOS
	fprintf(stderr, "Lendo Obs.\n");
	fprintf(stderr, "\r%ld", m++);
#endif
*/

    jj = 0;

    while ((m = ler_obs(fd, xobs)) >= 0L) {
	if ((m == 1l) && (nby > 0))
	    inicioby();

/*
#ifdef MSDOS
		fprintf(stderr, "\r%ld", m++);
#endif
*/
	if (m % 10L == 0L) {
	    fprintf(stderr, "\r%c", atividade[jj]);

	    jj = (jj + 1) % 4;
	}

	if (class() == 0) {
	    if (!missing(nef + ndep, ndep - 1)) {
		escrevelst();
		expand_mat();
		cria_xlx();
	    }
	} else {
	    if (nobs > 0) {	/* teste de classe vazia */
/*
#ifdef MSDOS
			fprintf(stderr, "\n");
#endif
*/
		ver_xlx();
		if (fatual_xlx)
		    ver1_xlx();

		nd1 = nd;
		ndim1 = ndim;

		executa();

		nd = nd1;
		ndim = ndim1;

	    }

	    inicioby();
	    inicializa();

	    if (nobs > 0)
		HFREE((char MY_HUGE *) xlx);

	    libera();

	    if (uflag == 0)
		putchar1();

	    modelo2(m);

	    if (nobs > 0)
		aloca_xlx();

	    if (!missing(nef + ndep, ndep - 1)) {
		escrevelst();
		expand_mat();
		cria_xlx();
	    }

	}			/* else */

    }				/* while */

/*
#ifdef MSDOS
	fprintf(stderr, "\n");
#endif
*/

    fprintf(stderr, "\r  \r");

    if (nobs <= 0) {		/* teste de ultima classe vazia */
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(0);
	}
#endif

	/* Desbloqueio dos arquivos */
	if (descarq != -1) {
	    /*        UnlockAFile(descarq); */
	}

	exit(0);
    }

    ver_xlx();
    if (fatual_xlx)
	ver1_xlx();

    /* Gravacao de matrizes para uso na analise multivariada */
    if (ndim >= MAXVAR) {
	fprintf(stderr,
		"\nAdvertencia: O limite de colunas (512) para a gravacao da matriz Z'Z, onde");
	fprintf(stderr,
		"\n             Z=[X:Y], foi ultrapassado. Neste caso, o MODLIN so' pode  ser");
	fprintf(stderr, "\n             executado em modo univariado.\n");
    } else {
	grav_mat();
	grav_esp();
	grav_efe();
	grav_efts();
    }

    nd1 = nd;
    ndim1 = ndim;
    executa();
    ret = fech_arq(fd);
    if (ret < 0) {
	fprintf(stderr, PegaMsg(1011), "");
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(2);
	}
#endif

	exit(2);
    }

    if (tem_comando && !iterativo) {
	unlink("modlin.out");
    }
    if (nby > 0) {
	unlink("modlin.par");
    }


    fflush(stdout);

    HFREE((char MY_HUGE *) xlx);
    libera();

    /*
     ** Libera a  area  do vetor  parm, se nao  houver fl_mult.
     ** Apaga arquivos que seriam usados pelo multvar.
     */
    if (!fl_mult) {
	for (i = 0; parm[i] != '\0'; i++) {
	    free(parm[i]);
	}
	unlink("xlxefe.dat");
	unlink("xlxefe.hdr");
	unlink("xlxesp.dat");
	unlink("xlxesp.hdr");
	unlink("xlxmat.dat");
	unlink("xlxmat.hdr");
	unlink("xlxefts");
    }

    /*
     **  Verificacao de  memoria  alocada  e liberada
     */
#ifdef  MEM_DEBUG

    if (Mem_Used() != 0) {

	printf("*** Lista de memoria nao esta' vazia ***\n");


	Mem_Store("modlin");

	/*
	   exit(1);
	 */

    }
#endif


    if (fl_mult) {
	/*
	 ** Altera a execucao normal para chamada ao MULTVAR,
	 ** passando os parametros reconhecidos em getarg()
	 */

#ifdef RS6000
	if (!iterativo) {

	    char *Str;
	    char strtmp[8];

	    for (i = 0; strncmp(parm[i], "-A", 2); i++);

	    if ((Str = (char *) malloc(sizeof(char) *
				       ((unsigned) strlen(parm[i]) + 5)))
		== (char *) NULL) {
		fprintf(stderr, PegaMsg(1039));

		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("*** Lista de memoria nao esta' vazia ***\n");
		    Mem_Store("modlin");
		    exit(5);
		}
#endif

		exit(5);
	    }

	    ptr = strchr(parm[i], '|');

	    if (ptr != (char *) NULL)
		*(ptr + 1) = '\0';
	    strcpy(Str, parm[i]);
	    ltoa(ftell(stdin), strtmp, 10);
	    strcat(Str, strtmp);

	    ptr += 2;
	    ptr = strchr(ptr, '|');

	    strcat(Str, ptr);
	    free(parm[i]);
	    parm[i] = Str;
	}
#endif

	execvp("NTIAA015", parm);	/* Modulo MULTVAR */

	/*
	 ** Nao ha retorno para o modulo modlin, no caso de execucao multvariada (multvar).
	 */
    }

    setOSstdin();
#ifdef  MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("modlin");
	exit(0);
    }
#endif

    /* Desbloqueio dos arquivos */
    if (descarq != -1) {
	/* UnlockAFile(descarq); */
    }

    exit(0);
}

void executa()
{
    int i;
    char token[128];

    glt = (int) xlx[idx(0, 0)];

    if (xflag & 1) {
	putchar1();
	printf("\nMatriz z'z\n");
	print_xlx();
    }

    ini_niveis();
    pivota();			/* pivota a mtriz x'x */

    nd = nd1 - ndep + 1;
    ndim = ndim1 - ndep + 1;

    if (uflag == 0)
	putchar1();

    for (i = 0; i < ndep; ++i) {
	if (i > 0) {
	    if (uflag == 0)
		putchar1();
	    troca(i);
	}

	if (uflag == 0) {
	    printanv(i);	/* imprime o quadro de analise de variancia */

	    printcov(i);	/* imprime covariaveis e varivel dependente */
	}

	if (bflag) {
	    putchar1();
	    printbeta(i);	/* imprime o vetor beta */
	}

	/*
	 ** Continua tratamento interativo caso nao tenha pedido para
	 ** passar a fazer analise multivariada
	 */
	if (fl_mult == 0) {

	    setjmp(env);

	    if (tem_comando && !iterativo) {
		if ((fout = fopen("modlin.out", "r")) == (FILE *) NULL) {
		    HFREE((char MY_HUGE *) xlx);
		    fprintf(stderr, PegaMsg(5020), "modlin.out");
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf
			    ("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("modlin");
			exit(2);
		    }
#endif

		    exit(2);
		}

		faux = fout;
	    } else
		faux = stdin;

	    if (c1 != RB || (tem_comando && !iterativo)) {
		c1 = gtoken1(token, faux);
	    }

	    while (c1 != RB && (strcmpi(token, "fim"))) {
		if (!iterativo && !tem1_comando) {
		    if ((fout = fopen("modlin.out", "w")) == (FILE *) NULL) {
			HFREE((char MY_HUGE *) xlx);
			fprintf(stderr, PegaMsg(5006), "modlin.out");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("*** Lista de memoria nao esta' vazia ***\n");
			    Mem_Store("modlin");
			    exit(2);
			}
#endif

			exit(2);
		    }
		    tem1_comando = 1;
		}

		p2 = area1;	/* Inicializa ponteiro */

		if (iterativo) {
		    if (uflag == 0)
			fprintf(stderr, "\n");
		}
		if (strcmpi(token, "cp") == 0) {
		    if (!iterativo && !tem_comando)
			fprintf(fout, "cp ");
		    c1 = contraste(i, faux, token);
		} else {
		    if (strcmpi(token, "multvar") == 0) {
			if (nby > 0) {
			    erromult(18);
			} else {
			    c1 = gtoken1(token, faux);
			    if (c1 != PTVG)
				erromod(16);

			    else {
				fl_mult = 1;
				break;
			    }
			}
		    } else {
			if (strcmpi(token, "med") == 0) {
			    if (!iterativo && !tem_comando)
				fprintf(fout, "med ");
			    impmedia(i, faux);
			    c1 = gtoken1(token, faux);
			} else {
			    if (strcmpi(token, "compara") == 0) {
				if (!iterativo && !tem_comando)
				    fprintf(fout, "compara ");
				p_cmp(i, faux);
				c1 = gtoken1(token, faux);
			    } else {
				if (strcmpi(token, "fim") != 0) {
				    errocon(11, 0);
				}
			    }
			}
		    }
		}
	    }
	    if (strcmpi(token, "fim") == 0) {
		c1 = gtoken1(token, faux);
		if (c1 != PTVG)
		    errocon(3, 0);
	    }
	    if (tem1_comando)
		tem_comando++;
	    if (!iterativo && tem_comando && i == 0)
		fprintf(fout, "\n%s", token);
	    if (!iterativo && tem_comando) {
		if (fclose(fout) == EOF) {
		    fprintf(stderr, PegaMsg(1011), "");
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf
			    ("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("modlin");
			exit(2);
		    }
#endif

		    exit(2);
		}

	    }

	}
    }
    vol_niveis();
}

void troca(k)
int k;
{
    int i;
    int n;
    double temp;
    TINT id1, id2;

    for (i = 0; i < nxlx; ++i) {
	id1 = idx(nxlx + k, i);
	id2 = idx(nxlx, i);
	temp = xlx[id1];
	xlx[id1] = xlx[id2];
	xlx[id2] = temp;

    }
    temp = css[nxlx];
    css[nxlx] = css[nxlx + k];
    css[nxlx + k] = temp;

    temp = mean[nxlx];
    mean[nxlx] = mean[nxlx + k];
    mean[nxlx + k] = temp;

    id1 = idx(nxlx + k, nxlx + k);
    id2 = idx(nxlx, nxlx);
    temp = xlx[id1];
    xlx[id1] = xlx[id2];
    xlx[id2] = temp;

    sse[0] = css[nxlx];
    n = nef + nd - 1;
    for (i = 1; i <= nef + nd; ++i) {
	sse[i] = sse1[i + (k - 1) * n];
    }
}

void putchar1()
{
    int i;
    int j;
    char pbuff[15];

    if (impflag)
	putchar(MUDA_PAG);
    imptitulo(titulo);
    if (nby > 0) {
	j = 0;
	for (i = 0; i < nby; ++i) {
	    if (tip_by[i] == 2)
		j += 10;
	    else
		j += strlen(obs2[i]);

	    j += strlen(efts_by[i]);
	}

	for (i = 0; i < ((80 - j - 3 * nby) / 2); ++i)
	    printf("-");

	for (i = 0; i < nby; ++i) {
	    if (tip_by[i] == 2)
		printf(" %s=%s ", efts_by[i], dtoa(atof(obs2[i]), pbuff));
	    else
		printf(" %s=%s ", efts_by[i], obs2[i]);
	}

	for (i = 0; i < ((79 - j - 2 * nby) / 2); ++i)
	    printf("-");

	printf("\n\n");
    }
}

void imptitulo(titulo)
char *titulo;
{
    int i;
    int j;
    if (titulo[0] != '\0') {
	i = strlen(titulo);
	if (i < 79)
	    i = (80 - i) / 2;
	else
	    i = 0;
	for (j = 0; j < i; ++j)
	    printf(" ");
	printf("%s\n\n", titulo);
    }
}

void inicializa()
{
    int i;
    for (i = 0; i < ndim; ++i)
	linhazerada[i] = 0;
    saida[0] = 1.;
}

void inicioby()
{
    int i;

    for (i = 0; i < nby; ++i) {
	strcpy(obs2[i], xobs[ef_by[i]]);
    }
}



int class()
{
    int i;
    int k;
    int flag;
    double x;
    double y;
    extern int ordc;

    if (nby == 0)
	return 0;
    flag = 0;
    for (i = 0; i < nby; ++i) {
	k = ef_by[i];
	if (tip_by[i]) {	/* Var. Numerica ou Data */
	    x = (strcmpi(xobs[k], ".") == 0) ? MISSING : atof(xobs[k]);
	    y = (strcmpi(obs2[i], ".") == 0) ? MISSING : atof(obs2[i]);
	    if (x != y) {
		flag = -1;
		if (ordc) {
		    if (x < y)
			erromod(17);
		} else {
		    if (x > y)
			erromod(17);
		}
		break;
	    }
	} else {
	    if (strcmpi(xobs[k], obs2[i]) != 0) {
		flag = -1;
		if (ordc) {
		    if (strcmpi(xobs[k], obs2[i]) < 0)
			erromod(17);
		} else {
		    if (strcmpi(xobs[k], obs2[i]) > 0)
			erromod(17);
		}
		break;
	    }
	}
    }
    return flag;
}

void ini_niveis()
{
    int i;
    for (i = 1; i <= nef + nd; ++i) {
	nv1[i] = nv[i];
    }
}

void vol_niveis()
{
    int i;
    for (i = 1; i <= nef + nd; ++i) {
	nv[i] = nv1[i];
    }
}

void aloca_xlx()
{
    long l;

    l = ((long) ndim + 1l) * (long) ndim / 2l;
    if ((xlx = (double MY_HUGE *) HALLOC((TIPO) l, sizeof(double))) ==
	(double MY_HUGE *) NULL) {

/* *** Padroniz. msg erro - Adriana 07/12/94
		fprintf(stderr, "Nao consegui espaco para x'x\n");
*** */

	fprintf(stderr, PegaMsg(1042));
	setOSstdin();
#ifdef  MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("modlin");
	    exit(1);
	}
#endif
	exit(1);
    }
}

void libera()
{
    int i;

    for (i = 0; i < nef + nd; ++i) {
	if (ef[i][4] > 0)
	    free((char *) nvhi[ef[i][4] - 1]);
    }
    for (i = 0; i < ndep; ++i) {
	if (i > MAXDEP - 1)
	    break;
	free((char *) com_med[i]);
	free((char *) com_nv[i]);
    }
}
