
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Usa o operador sweep para pivotar z'z

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/pivota.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"

static char *sccsid = "@(#)pivota.c	3.2	(NTIA/modlin)	94/12/20";


extern int ndep;
extern double sse1[MAXMEM];
extern char atividade[];

void pivota()
{
    int i, j;
    int l;
    int n;
    int jj;

    n = nef + nd - ndep;	/* Numero de efeitos + numero de covariaveis */
    for (i = 0; i < ndim; ++i)
	v[i] = 1;

/*
#ifdef MSDOS
	fprintf(stderr, "\nIteracao\n\r0");
#endif
*/

    sweep(0);			/* calculei a iteracao 0 */

    sse[0] = xlx[idx(nxlx, nxlx)];

    for (i = 0; i < ndim; ++i) {
	css[i] = xlx[idx(i, i)];	/* armazenei o css */
	mean[i] = xlx[idx(i, 0)];	/* media */
    }

    j = 1;
    jj = 0;

    for (i = 1; i < nxlx; ++i) {
	if (rflag) {
	    printf("\nIteracao :%d", i - 1);
	    putchar1();
	    print_xlx();
	}
	if (fabs(css[i]) < 1.e-14) {
	    zera_linha(i);
	    --nv[j];
	} else {
	    if ((fabs(xlx[idx(i, i)]) / css[i]) < 1.e-8) {
		zera_linha(i);
		--nv[j];
	    } else
		sweep(i);
	}

/*
#ifdef MSDOS
		fprintf(stderr, "\r%d",i);
#endif
*/

	if (i % 10 == 0) {
	    fprintf(stderr, "\r%c", atividade[jj]);

	    jj = (jj + 1) % 4;
	}

	if (i + 1 >= sv[j + 1]) {
	    sse[j] = xlx[idx(nxlx, nxlx)];
	    for (l = 1; l < ndep; ++l) {
		sse1[j + (l - 1) * n] = xlx[idx(nxlx + l, nxlx + l)];
	    }
	    ++j;
	}
    }

/*
#ifdef MSDOS
	fprintf(stderr, "\n");
#endif
*/

    fprintf(stderr, "\r  \r");

    if ((xflag & 2) || rflag) {
	putchar1();
	printf("\nResultado final:\n");
	print_xlx();
    }
}
