
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Imprime o quadro de analise de variancia

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/printanv.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "pcsgbd.h"
#ifndef VAXVMS
#include <malloc.h>
#endif

#ifdef    MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)printanv.c	3.2	(NTIA/modlin)	94/12/20";

double *parte;
extern int sflag;		/* Calcular apenas soma sequencial */
extern int singul;
extern int med1[MAXMEM];

void printanv(n_d)
int n_d;
{

    int i, j, l, nm, m, n;
    double valorF;		/* valor de F */
    double x1, x2, x0;		/* variavel auxiliar */
    double temp, temp1;
    TINT id;

    printf("\t\t\tQuadro de analise de variancia\n\n");

    printf("\t\t\tVariavel Dependente : %s\n\n", efts[n_d + nef + nd]);

    printf
	("Fonte de variacao       gl  Soma de quadrados  Quadrado medio   Valor F  PR > F\n");
    printf("                            Sequencial\n\n");

    j = 0;
    for (i = 1; i < nef + nd; ++i) {
	j += nv[i];		/* calculo do gl do residuo */
	saida[i] = sse[i - 1] - sse[i];	/* soma de quadrados */
    }
    glr = (glt - 1) - j;	/* gl do residuo */

    for (i = 1; i < nef + nd; ++i) {	/* ajuste soma de quadrados */
	if ((j = ef[i][3]) != 0) {
	    saida[j] += saida[i];
	    nv[j] += nv[i];
	    saida[i] = 0.0;
	    nv[i] = 0;
	    med1[i + 1] = med1[i];
	}
    }

    for (i = 1; i < nef + nd; ++i) {	/*quadrado medio */
	if (ef[i][0] == -1 || ef[i][1] < 0) {
	    j = sv[i];
	    x1 = xlx[idx(nxlx, j)];
	    x2 = xlx[idx(j, j)];
	    if (fabs(x2) < 1.0e-14)
		saida[i] = 0.0;
	    else
		saida[i] = x1 * x1 / xlx[idx(j, j)];
	}
	obs[i] = (nv[i]) ? saida[i] / (double) nv[i] : 0.0;
    }

    sse[nef + nd - 1] = fabs(sse[nef + nd - 1]);

    qmr = (glr) ? sse[nef + nd - 1] / ((double) glr) : 0.0;	/* qm. do residuo */
    for (i = 1; i < nef + nd; ++i) {
	if ((ef[i][3] == 0) && (ef[i][0] >= 0 || ef[i][0] == -1)) {
	    x1 = (ef[i][2] == 0) ? qmr : obs[ef[i][2]];
	    j = (ef[i][2] == 0) ? glr : nv[ef[i][2]];
	    valorF = 0.0;
	    if (x1 > 1.0e-14)
		valorF = obs[i] / x1;
	    else
		valorF = 9999.9999;
	    if (valorF > 9999.0)
		valorF = 9999.9999;
	    if (ef[i][0] != -1 && ef[i][1] >= 0) {
		printf("%-20.20s  %4d %17s %16s %9s  %6s\n",
		       efts[i], nv[i],
		       rounddec(saida[i], 17, 8),
		       rounddec(obs[i], 16, 8),
		       rounddec(valorF, 9, 4),
		       rounddec(fprob(valorF, (double) nv[i], (double) j),
				6, 3));
	    } else {
		temp = sse[i - 1] - sse[i];	/* soma de quadrados */
		temp1 = (nv[i]) ? temp / (double) nv[i] : 0.0;
		if (x1 > 1.0e-14)
		    valorF = temp1 / x1;
		else
		    valorF = 9999.9999;
		if (valorF > 9999.0)
		    valorF = 9999.9999;
		printf("%-20.20s  %4d %17s %16s %9s  %6s\n",
		       efts[i], nv[i],
		       rounddec(temp, 17, 8),
		       rounddec(temp1, 16, 8),
		       rounddec(valorF, 9, 4),
		       rounddec(fprob(valorF, (double) nv[i], (double) j),
				6, 3));
	    }
	}
    }

    printf("%-20.20s  %4d %17s %16s\n\n",
	   "Residuo", glr,
	   rounddec(sse[nef + nd - 1], 17, 8), rounddec(qmr, 16, 8));
    printf("%-20.20s  %4d %17s\n",
	   "Total", (glt - 1), rounddec(sse[0], 17, 8));

    verifica();			/* Verifica se a matriz e' singular */

    if (!singul && !sflag) {
	for (i = 0; i <= nef + nd; ++i)
	    med1[i] = sv[i];
	for (i = nef + nd; i > 0; --i) {
	    if ((j = ef[i][3]) != 0) {
		med1[j] = med1[i];
	    }
	}
	printf("\n");
	printf
	    ("-------------------------------------------------------------------------------\n");
	printf("\n");
	printf
	    ("Fonte de variacao       gl  Soma de quadrados  Quadrado medio   Valor F  PR > F\n");
	printf("                            Parcial\n\n");

	for (i = 1; i < nef + nd; ++i) {
	    if ((ef[i][3] == 0) && (ef[i][0] >= 0 || ef[i][0] == -1)) {
		x0 = 0.0;
		valorF = 0.0;
		nm = med1[i + 1] - med1[i];
		if ((parte =
		     (double *) calloc((unsigned) (idx(nm, nm) + 1),
				       sizeof(double))) !=
		    (double *) NULL) {
		    n = 0;
		    for (j = med1[i]; j < med1[i + 1]; ++j) {
			m = 0;
			for (l = med1[i]; l <= j; ++l) {
			    id = idx(n, m++);
			    parte[id] = xlx[idx(j, l)];
			}
			n++;
		    }
		    m = 0;
		    for (j = med1[i]; j < med1[i + 1]; ++j) {
			id = idx(nm, m++);
			parte[id] = xlx[idx(nxlx, j)];
		    }

		    id = idx(nm, nm);
		    parte[id] = 0.0;
		    x0 = doolitle(parte, nm + 1);
		    saida[i] = x0;
		    free((char *) parte);
		} else
		    saida[i] = -9.0;
	    }
	}
	for (i = 1; i < nef + nd; ++i) {
	    if ((ef[i][3] == 0) && (ef[i][0] >= 0 || ef[i][0] == -1)) {
		x0 = saida[i];
		j = (ef[i][2] == 0) ? glr : nv[ef[i][2]];
		x1 = (ef[i][2] == 0) ? qmr : saida[ef[i][2]];
		if (ef[i][2] == 0)
		    x1 = qmr;
		else {
		    x1 = saida[ef[i][2]];
		    x1 = (j) ? x1 / (double) j : 0.0;
		}
		x2 = (nv[i]) ? x0 / (double) nv[i] : 0.0;
		if (x1 > 1.0e-14)
		    valorF = x2 / x1;
		else
		    valorF = 9999.99;
		if (valorF > 9999.0)
		    valorF = 9999.9999;
		if ((x0 == -9.0)
		    || (ef[i][2] != 0 && saida[ef[i][2]] == -9.0)) {
		    printf
			("%-20.20s  %4d Nao consegui espaco para alocar matriz\n",
			 efts[i], nv[i]);
		} else {
		    printf("%-20.20s  %4d %17s %16s %9s %6s\n",
			   efts[i], nv[i],
			   rounddec(x0, 17, 8),
			   rounddec(x2, 16, 8),
			   rounddec(valorF, 9, 4),
			   rounddec(fprob
				    (valorF, (double) nv[i], (double) j),
				    6, 3));
		}
	    }
	}
	for (i = 1; i < nef + nd; ++i) {
	    if (saida[i] != -9.0) {
		obs[i] = (nv[i]) ? saida[i] / (double) nv[i] : 0.0;
	    }
	}

    }
}
