
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Imprime o vetor beta

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/printbet.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "pcsgbd.h"
#include <string.h>

static char *sccsid = "@(#)printbet.c	3.4	(NTIA/modlin)	95/07/26";

void printbeta(n_d)
int n_d;
{
    int i, j;
    double x1;			/* variavel auxiliar */
    double qm;

    imptitulo("Estimativa do vetor de parametros");
    printf("\t\t\t\tVariavel: %-8.8s\n", efts[nd + nef + n_d]);
    printf
	("\nParametro                  Estimativa        Desvio Padrao\n",
	 efts[nd + nef + n_d]);
    j = 0;
    for (i = 0; i < nxlx; ++i) {
	if (i == sv[j]) {
	    qm = (ef[i][2] == 0) ? qmr : obs[ef[i][2]];

	    if (j == 0)
		printf("\nMedia Geral         ");
	    else
		printf("\n%-15.15s     ", efts[j]);
	    ++j;
	    x1 = xlx[idx(i, i)] * qm;
	    /*
	       printf("%17s    %17.8lf\n",
	       rounddec(xlx[idx(nxlx,i)], 17, 8), sqrt(x1));
	     */
	    printf("%17s    %17s\n",
		   rounddec(xlx[idx(nxlx, i)], 17, 8),
		   rounddec(sqrt(x1), 17, 8));
	} else {
	    x1 = xlx[idx(i, i)] * qm;
	    /*
	       printf("                    %17s    %17.8lf\n",
	       rounddec(xlx[idx(nxlx,i)], 17, 8), sqrt(x1));
	     */
	    printf("                    %17s    %17s\n",
		   rounddec(xlx[idx(nxlx, i)], 17, 8),
		   rounddec(sqrt(x1), 17, 8));
	}
    }
}
