
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Imprime a covariancia

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/printcov.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "pcsgbd.h"
#include "getoken.h"
#include "modelo.h"
#ifdef MSDOS
#include <stdlib.h>
#endif

static char *sccsid = "@(#)printcov.c	3.2	(NTIA/modlin)	94/12/20";


extern int singul;
extern int singul1;
extern int nclass;
extern int ndep;

void printcov(n_d)
int n_d;
{
    int i, temcov = 1;
    int j;
    double dp;			/* desvio padrao */
    double x1;			/* variavel auxiliar */
    double valorT;		/* valor de f ao quadrado */
    double qm;

    printf("\n");
    printf
	("-------------------------------------------------------------------------------\n");
    printf("\n");
    for (i = 1; i < nef + nd; ++i) {
	if ((ef[i][3] == 0) && (ef[i][0] == -1 || ef[i][1] < 0)) {
	    qm = (ef[i][2] == 0) ? qmr : obs[ef[i][2]];
	    if (temcov == 1) {
		printf
		    ("Covariavel                        Estimativa    Desvio Padrao Valor |T|  PR>|T|\n\n");
		temcov = 0;
	    }
	    /* 1. */

	    for (j = sv[i]; j < sv[i + 1]; ++j) {

		x1 = xlx[idx(j, j)] * qm;
		dp = sqrt(x1);
		if (nv[i] > 1) {
		    itoa(j - sv[i] + 1, buffer, 10);
		} else
		    strcpy(buffer, " ");

		x1 = xlx[idx(nxlx, j)];

		valorT = 0.0;
		if (dp > 1.0e-14)
		    valorT = fabs(x1 / dp);	/* obs=qm */

		if (j == sv[i]) {
		    printf("%-15.15s %-10.10s %17s %16s %9s  %6s\n",
			   efts[i], buffer,
			   rounddec(x1, 17, 8),
			   rounddec(dp, 16, 8),
			   rounddec(valorT, 9, 4),
			   rounddec(2.0 * tprob(valorT, (double) glr), 6,
				    3));
		} else {
		    printf("%-15.15s %-10.10s %17s %16s %9s  %6s\n",
			   " ", buffer,
			   rounddec(x1, 17, 8),
			   rounddec(dp, 16, 8),
			   rounddec(valorT, 9, 4),
			   rounddec(2.0 * tprob(valorT, (double) glr), 6,
				    3));
		}
	    }
	}
    }

    if (!temcov) {
	printf("\n");
	printf
	    ("-------------------------------------------------------------------------------\n");
    }
    dp = sqrt(qmr);		/* desvio padrao */

    printf("\n");
    printf(" Media                : %17s\n", rounddec(mean[nxlx], 17, 8));
    printf(" Raiz Quad. QMres.    : %17s\n", rounddec(dp, 17, 8));
    printf(" Coef. Variacao       : %17s\n",
	   rounddec(dp * 100.0 / mean[nxlx], 17, 8));

    if (singul1 > 0) {
	printf("\nAtencao: A matriz X'X e' singular. ");
	if (singul1 == 1) {
	    if (singul == 1)
		printf("Coluna associada ao efeito\n");
	    else
		printf("Colunas associadas ao efeito\n");
	} else {
	    printf("Colunas associadas aos efeitos\n");
	}

	printf("\t ");
	for (i = 1; i < nd + nef; ++i) {
	    for (j = sv[i]; j < sv[i + 1]; ++j) {
		if (linhazerada[j] == 1 && ef[i][3] == 0) {
		    printf("%s ", efts[i]);
		    break;
		}
	    }
	}
	if (singul1 == 1)
	    printf(" e' uma  combinacao  linear de  colunas  \n");
	else
	    printf(" sao uma combinacao linear  de  colunas  \n");
	printf
	    ("\t associadas  a  efeitos  que  o  precedem  no modelo.\n");
	printf
	    ("\t Nesta situacao nao  existe  solucao  unica  para  as\n");
	printf
	    ("\t equacoes   normais,   mesmo  com  a   imposicao  das\n");
	printf
	    ("\t restricoes nos parametros, e  as somas  de quadrados\n");
	printf("\t parciais nao sao fornecidas\n");
    }
}
