
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Imprime parametros lidos

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/printpar.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"
#include "pcsgbd.h"
#include "modelo.h"

static char *sccsid = "@(#)printpar.c	3.2	(NTIA/modlin)	94/12/20";


extern int ndep;
extern char *efts1[MAXEFTS];
extern int nh;

void print_par()
{
    int i;

    printf("ndim=%d  nxlx=%d  ntotal=%d  \n", ndim, nxlx, ntotal);
    printf("nf=%d  nd=%d  ndep=%d\nnv=", nf, nd, ndep);
    for (i = 0; i <= nef + nd; i++)
	printf("%d ", nv[i]);
    printf("\nsv=");
    for (i = 0; i <= nef + nd + 1; i++)
	printf("%d ", sv[i]);
    printf("\nTitulo: <%s>\n", titulo);
    printf("nef=%d\nef\n", nef);
    for (i = 0; i <= nef + nd; ++i) {
	printf("[%3d %d] [%d %d] [%d]\t<%-15.15s> \t<%-15.15s>  %d\n",
	       ef[i][0], ef[i][1], ef[i][2], ef[i][3], ef[i][4],
	       efts[i], efts1[i], i);
    }
    printf("\n");
    if (nh) {
	int j;

	for (i = 0; i < nh; i++) {
	    printf("Numero de Niveis do Hierarquico %d e' %d\n",
		   i, nchi[i]);
	    printf("Numero de Variaveis do Hierarquico %d e' %d\n", i,
		   nhi[i]);

	    for (j = 0; j <= nchi[i]; j++)
		printf("Numero de Rep. do Nivel %d do Fator %d e' %d\n",
		       j, i, nvhi[i][j]);

	    printf("\n\nFator Hierarquico %d:\n", i);
	    for (j = 0; j < nhi[i]; j++)
		printf(" <%d> ", hi[i][j]);

	    printf("\n");
	}
    }
}
