
/***********************************************************************************
 MODLIN - Anlise de Modelos Lineares Univariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Pivota uma linha da matriz z'z dando como resultado a matriz pivotada
	inversa

 Desenvolvido por:

	Carlos Paniago
	Dalton Francisco Andrade
	Maria Fernanda Moura
	Maurcio Noronha Festa
	Slvio Roberto Medeiros Evangelista
	Snia Ternes Frassetto	

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/modlin/fontes/sweep.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 18:39:29 $:

***********************************************************************************/

#include "anova.h"

static char *sccsid = "@(#)sweep.c	3.2	(NTIA/modlin)	94/12/20";


void sweep(k)
int k;
{
    double b, d, c;
    int i, j;
    TINT id;

    d = xlx[idy(k, k)];		/* set D = Akk */

    for (i = 0; i < ndim; i++) {	/* for every other row i != k let */
	if (i != k) {		/* B = Aik, subtract B * row k from */
	    b = xlx[idx(i, k)];
	    if (fabs(b) > 1.e-14) {
		b /= d;		/* row i */
		if (i > k)
		    b *= ((double) v[i] * (double) v[k]);
		for (j = i; j < ndim; j++) {
		    if (j != k) {
			if (k < j)
			    c = xlx[idy(k, j)];
			else
			    c = (double) (v[j] * v[k]) * xlx[idy(j, k)];
			id = idy(i, j);
			xlx[id] -= (b * c);
		    }
		}
	    }
	}
    }
    for (i = 0; i < k; ++i) {
	id = idy(i, k);
	xlx[id] /= (-d);
    }

    for (j = k; j < ndim; ++j) {
	id = idy(k, j);
	xlx[id] /= d;
    }

    id = idy(k, k);
    xlx[id] = 1. / d;		/* Akk = 1/D */
    v[k] = -v[k];
}
