/***********************************************************************************
 MULTVAR - Módulo para análise de modelos lineares multivariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informática Agropecuária

 Este programa é software livre; você pode redistribuí-lo e/ou modificá-lo sob os
 termos da Licença Pública Geral GNU conforme publicada pela Free Software
 Foundation; tanto a versão 2 da Licença, como (a seu critério) qualquer versão
 posterior.

 Este programa é distribuído na expectativa de que seja útil, porém, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implícita de COMERCIABILIDADE OU ADEQUAÇÃO A UMA
 FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU para mais detalhes.

 Você deve ter recebido uma cópia da Licença Pública Geral do GNU junto com este
 programa; se não, escreva para a Free Software Foundation, Inc., no endereço 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Científico

 Descrição:

	Imprime uma mensagem de erro. Se "quit" for 0, retorna para inicio
	do parser; se for 1, a execucao e' interrompida

 Desenvolvido por:

	Maurício Noronha Festa
	Sônia Ternes 
	Sílvio Roberto Medeiros Evangelista

 Informações do CVS:
        $Source: /cvsroot/soc/soc/src/multvar/fontes/mlmerro.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/24 16:08:44 $:

***********************************************************************************/
static char *sccsid = "@(#)mlmerro.c	3.4	(NTIA/modlin)	95/04/26";

#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include "pcsgbd.h"

extern jmp_buf inicio;
extern int fl_iter;

int erro_mul[] = {
    3223,			/*  0: Caracter '=' esperado */
    3224,			/*  1: Especificacao invalida no comando TESTEM */
    3005,			/*  2: Especificacao invalida do comando */
    3225,			/*  3: Caracter ',' ou um numero esperado na especificacao da matriz */
    1027,			/*  4: Dimensao de C incompativel com comando CPM */
    1028,			/*  5: Matrizes C e M devem ter o mesmo numero de linhas */
    1029,			/*  6: Dimensao invalida da matriz */
    1030,			/*  7: No. de linhas de U deve ser igual ao no. de respostas */
    1037,			/*  8: Matrizes U e M devem ter o mesmo numero de colunas */
    1041,			/*  9: Matriz M deve ser especificada antes da matriz U */
    1046,			/* 10: Todos os efts do cmdo CPM devem ser testados sob o mesmo erro */
    1047,			/* 11: Variavel de resposta nao pode ser especificada no comando CPM */
    1048,			/* 12: O no. maximo de efeitos em um comando CPM e' 20 */
    1063,			/* 13: Efeito invalido ou inexistente */
    3022,			/* 14: Caracter ';' esperado para finalizar comando */
    1069,			/* 15: Numero esperado na especificacao da matriz */
    1055,			/* 16: Efeitos devem respeitar a ordem em que estao no comando MOD */
    5058,			/* 17: Excedido o limite da area para armazenar os nomes dos efeitos */
    1057,			/* 18: Excedido o no. maximo de efeitos em um comando TESTEM */
    3226,			/* 19: Caracter ',' ou ';' esperado no comando */
    3227,			/* 20: Nome esperado apos a especificacao 'medrep' */
    3228,			/* 21: Caracter ',' esperado apos o nome no comando MEDREP */
    1058,			/* 22: Transformacao invalida no comando MEDREP */
    3235,			/* 23: Pelo menos 'mg', um efeito ou 'todos' deve ser especificado */
    3229,			/* 24: Numero esperado apos MEDIA, CONTRASTE ou POL no comando MEDREP */
    1070,			/* 25: Valor especificado como <n> e' maior que o no. de respostas */
    5059,			/* 26: Calculo do indice de composicao da matriz C */
    1071,			/* 27: Apenas um unico comando TLM pode ser especificado */
    1076,			/* 28: Apenas um unico comando ROTM pode ser especificado */
    1077,			/* 29: O numero maximo de caracteres para texto do comando TLM e' 80 */
    1091,			/* 30: O numero maximo de caracteres para texto do comando ROTM e' 20 */
    1094,			/* 31: No. de niveis para POL deve ser igual ao no. de respostas */
    1133,			/* 32: Apos 'liste' so' podem ser especificados 'h', 'e' ou 'v' */
    5060,			/* 33: Raiz quadrada de valor nao positivo na funcao mlmhip */
    3230,			/* 34: Caracter ',' ou ';' ou '=' esperado apos POL no comando MEDREP */
    1135,			/* 35: Modelo envolve so' a mg. Especifique 'mg' no comando TESTEM */
    1136,			/* 36: No. colunas de U deve ser menor ou igual ao no. de respostas */
    3231,			/* 37: Caracter '(' esperado apos o '=' na matriz U */
    3239,			/* 38: Especificacao 'm' ou 'u' ou 'c' esperada no comando CPM */
    1137,			/* 39: Variavel de resposta nao pode ser especificada no cmdo TESTEM */
    3232,			/* 40: Especificacao 'univar' esperada apos a ',' */
    3233,			/* 41: Especificacao invalida no  comando CPM. Esperava um efeito */
    3234,			/* 42: Pelo menos 'mg' ou um efeito deve ser especificado */
    3236,			/* 43: Especificacao 'liste' esperada apos a ',' */
    3237,			/* 44: Especificacao 'liste' ou 'univar' esperada apos a ',' */
    3238,			/* 45: Especificacao 'u' ou 'liste' ou 'univar' esperada apos a ',' */
    1150,			/* 46: Analise multivariada pressupoe mais de uma var. de resposta */
    3240,			/* 47: Especificacao 'rotm' ou 'm' ou 'u' ou 'c' esperada no comando CPM */
    0
};

void mlmerro(n, quit)
int n;
int quit;
{
    int i;

    while ((i = xgetc(stdin)) != '\n' && i != EOF);

    if (quit == 0) {
	if (fl_iter) {
	    fprintf(stderr, "%s \nEntre com o comando novamente.\n\n",
		    PegaMsg(erro_mul[n]));
	    longjmp(inicio, 0);
	} else {
	    fprintf(stderr, "%s\n", PegaMsg(erro_mul[n]));
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("*** Lista de memoria nao esta' vazia ***\n");
		Mem_Store("multvar");
		exit(2);
	    }
#endif
	    exit(1);
	}
    } else {
	fprintf(stderr, "%s\n", PegaMsg(erro_mul[n]));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("*** Lista de memoria nao esta' vazia ***\n");
	    Mem_Store("multvar");
	    exit(2);
	}
#endif
	exit(1);
    }
}
