/***********************************************************************************
 MULTVAR - Módulo para análise de modelos lineares multivariados

 Direitos Autorais Reservados (c) 2004 Embrapa Informática Agropecuária

 Este programa é software livre; você pode redistribuí-lo e/ou modificá-lo sob os
 termos da Licença Pública Geral GNU conforme publicada pela Free Software
 Foundation; tanto a versão 2 da Licença, como (a seu critério) qualquer versão
 posterior.

 Este programa é distribuído na expectativa de que seja útil, porém, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implícita de COMERCIABILIDADE OU ADEQUAÇÃO A UMA
 FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU para mais detalhes.

 Você deve ter recebido uma cópia da Licença Pública Geral do GNU junto com este
 programa; se não, escreva para a Free Software Foundation, Inc., no endereço 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Científico

 Descrição:

	Traducao da rotina MLMXLX.HIP para chamadas `as funcoes do CM 
	(em linguagem C). Trata teste de erro especifico

Desenvolvido por:

	Maurício Noronha Festa
	Sônia Ternes 
	Sílvio Roberto Medeiros Evangelista

 Informações do CVS:
        $Source: /cvsroot/soc/soc/src/multvar/fontes/mlmhip.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/24 16:08:44 $:

***********************************************************************************/
static char *sccsid = "@(#)mlmhip.c	3.8	(NTIA/modlin)	95/09/22";


#include "mod_incl.h"
#include "pcsgbd.h"
#include "multvar.h"

#include <string.h>
#include <malloc.h>

extern int fl_uni;
extern int imp_h;
extern int imp_e;
extern int imp_er;
extern int imp_v;
extern int imp_u;
extern int ctr;
extern int flu;			/* para cpm */

extern char rotulo[32];
extern char string[9];
extern char *nome_lin[MAXEFTS];
extern char nome_col[TAM];

extern Efeitos efeitos;

/*
** Vetores auxiliares para imprimir nome das linhas em printmat().
** Montados em monta_l() e monta_u().
*/
char *l1[1];
char *ln[MAXEFTS];
char *l_rwlp[4];
char *l_w[1];
char *l_lh[1];
char *l_pi[1];
char *lin_u[TAM];		/* nome das colunas de U para MEDREP */

/*
** Calculo das estatisticas sob c*beta*u-m
*/
void mlmhip(ief, ierr, esp, ixx, nly, ncx, nd, beta, c, u, m, aux, tipo)
int ief;
int ierr;
Simbolo_t *esp;
Simbolo_t *ixx;
Simbolo_t *nly;
Simbolo_t *ncx;
Simbolo_t *nd;
Simbolo_t *beta;
Simbolo_t *c;
Simbolo_t *u;
Simbolo_t *m;
Simbolo_t *aux;
int tipo;			/* 1: testem; 2: cpm s/ rot; 3: cpm c/ rot; 
				   4: medrep paralelismo; 5: medrep resposta */
{
    int i, k, ai, aj, ig;
    int nlcer, ncteta;
    int nlc, ncu, dim;

    double pv, f1, gld1, gln1, x21, gl1, mt;

    char titaux[96];
    char buf[20];

    /* Funcoes auxiliares para impressao de nomes de linhas e colunas */
    void monta_l();
    void monta_u();
    void lib_l();
    void lib_u();
    void print_V();

    Simbolo_t *s = (Simbolo_t *) NULL;
    Simbolo_t *t = (Simbolo_t *) NULL;
    Simbolo_t *paramet = (Simbolo_t *) NULL;
    Simbolo_t *val = (Simbolo_t *) NULL;
    Simbolo_t *vet = (Simbolo_t *) NULL;
    Simbolo_t *r = (Simbolo_t *) NULL;
    Simbolo_t *val1 = (Simbolo_t *) NULL;
    Simbolo_t *vet1 = (Simbolo_t *) NULL;
    Simbolo_t *pct = (Simbolo_t *) NULL;
    Simbolo_t *soma = (Simbolo_t *) NULL;
    Simbolo_t *w = (Simbolo_t *) NULL;
    Simbolo_t *lh = (Simbolo_t *) NULL;
    Simbolo_t *pi = (Simbolo_t *) NULL;
    Simbolo_t *valor = (Simbolo_t *) NULL;
    Simbolo_t *valores = (Simbolo_t *) NULL;

    Simbolo_t *f = (Simbolo_t *) NULL;
    Simbolo_t *gln = (Simbolo_t *) NULL;
    Simbolo_t *gld = (Simbolo_t *) NULL;
    Simbolo_t *p_value = (Simbolo_t *) NULL;
    Simbolo_t *x2 = (Simbolo_t *) NULL;
    Simbolo_t *gl = (Simbolo_t *) NULL;

    Simbolo_t *teta = (Simbolo_t *) NULL;
    Simbolo_t *aux1 = (Simbolo_t *) NULL;
    Simbolo_t *aux2 = (Simbolo_t *) NULL;
    Simbolo_t *aux3 = (Simbolo_t *) NULL;
    Simbolo_t *ord = (Simbolo_t *) NULL;
    Simbolo_t *ord1 = (Simbolo_t *) NULL;
    Simbolo_t *Cer = (Simbolo_t *) NULL;
    Simbolo_t *h = (Simbolo_t *) NULL;
    Simbolo_t *e = (Simbolo_t *) NULL;

    Simbolo_t *cov_teta = (Simbolo_t *) NULL;
    Simbolo_t *dp_teta = (Simbolo_t *) NULL;
    Simbolo_t *v = (Simbolo_t *) NULL;
    Simbolo_t *v1 = (Simbolo_t *) NULL;

    /*
     ** mod_include1.c
     */

    Simbolo_t *ipos = (Simbolo_t *) NULL;
    Simbolo_t *jpos = (Simbolo_t *) NULL;
    Simbolo_t *mpos = (Simbolo_t *) NULL;
    Simbolo_t *npos = (Simbolo_t *) NULL;

    ipos = faztemp(1, 1);
    jpos = faztemp(1, 1);

    TIPO(ipos) = ID;
    TIPO(jpos) = ID;

    /*
     ** Inicio da traducao
     */

    /*
     ** Monta nomes das linhas e colunas de H, E, V e Correl
     */

    aux1 = mIdent(nd);
    TIPO(aux1) = ID;
    ig = igualm(u, aux1);
    libsim(aux1);

    monta_lin(ig, tipo, (int) DADOij(nd, 0, 0));
    monta_col(ig, tipo, (int) DADOij(nd, 0, 0));

    /*
     ** Calcula as matrizes H e E
     */


    calc_h_e(ierr, esp, ixx, beta, c, u, m, aux, &h, &e);

    dim = NCOLS(ixx);

    /* TETA = c*BETA*u-m */
    teta = matdif(matmult(matmult(c, beta), u), m);
    TIPO(teta) = ID;
    libtemp();

    /* Calcula a matriz AUX1. */
    /* Verifica se ha' teste de erro especifico. */

    if (ierr != -1) {
	/* AUX1 = c*ixx*c'; */
	aux1 = matmult(matmult(c, ixx), mattran(c));
	TIPO(aux1) = ID;
	libtemp();
    } else {

	/* calcula a estimativa da matriz H e E */
	/* AUX1 = c*ixx*c' */
	aux1 = matmult(matmult(c, ixx), mattran(c));
	TIPO(aux1) = ID;
	libtemp();
    }

    /* COV_TETA = aux1@(e/(nly-ncx)) */
    cov_teta = matkron(aux1, matdivd(matdif(nly, ncx), e));
    TIPO(cov_teta) = ID;
    libtemp();

    /* calcula e lista DP_TETA, a estimativa da matriz dos desvios 
       padroes de TETA */

    /* V = sqrt(vdiag(cov_teta)) */
    v = mSqrt(mVdiag(cov_teta));
    TIPO(v) = ID;
    libtemp();

    /* NCTETA = ncol(teta) */
    ncteta = NCOLS(teta);

    /* DP_TETA = (v[1:ncteta,])' */
    mpos = mod_gindex(1, ncteta);
    dp_teta = mattran(matsubs(v, mpos, (Simbolo_t *) 0));
    TIPO(dp_teta) = ID;
    libtemp();

    /* 
       i = ncteta + 1;
       enquanto ( i <= nlin(v) ) {
       V1 = (v[i:(i+ncteta-1),])';
       DP_TETA = { dp_teta , v1 };
       i = i + ncteta;
       }
     */

    i = ncteta + 1;
    while (i <= (int) NLINS(v)) {
	mpos = mod_gindex(i, i + ncteta - 1);
	v1 = mod_atribuir(v1, mattran(matsubs(v, mpos, (Simbolo_t *) 0)));
	TIPO(v1) = ID;
	dp_teta = mod_atribuir(dp_teta, vconcat(dp_teta, v1));
	TIPO(dp_teta) = ID;
	i += ncteta;
	libtemp();
    }

    if ((ncteta + 1) <= (int) NLINS(v))	/* matriz v1 foi criada */
	libsim(v1);
    libsim(v);
    libsim(aux1);

    libsim(cov_teta);
    libsim(dp_teta);

    /* impressao de U somente a primeira vez na analise */
    if ((ig == 0) && (imp_u == 1)) {
	if (tipo < 4)
	    putchar1();
	else {
	    if (imp_e)		/* imprimiu correlacao em mlmmed */
		putchar2(1);	/* e necessita de um novo titulo */
	}

	if (tipo >= 4)
	    tit_analise();

	imptitulo("Matriz U Utilizada na Transformacao das Variaveis", 1);

	monta_u((int) DADOij(nd, 0, 0));
	printmat(DADOS(u), NLINS(u), NCOLS(u), " ",
		 lin_u, nome_col, 4, 10, 4, 1);
	lib_u((int) DADOij(nd, 0, 0));

	imp_u = 0;
    }

    if (imp_e) {
	if (ierr != -1) {	/* sempre imprime erro especifico */
	    if (tipo < 4)
		putchar1();
	    else
		putchar2(1);

	    titaux[0] = '\0';
	    strcpy(titaux,
		   "E = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, EFE_GetNome(efeitos, ierr - 1));
	    imptitulo(titaux, 1);

	    aux1 = mMin(mAbs(e));
	    TIPO(aux1) = ID;
	    aux2 = mMax(mAbs(e));
	    TIPO(aux2) = ID;
	    if ((DADOij(aux2, 0, 0) > 9.9e+9) ||
		(DADOij(aux1, 0, 0) < 9.9e-9))
		printmat(DADOS(e), NLINS(e), NCOLS(e), " ",
			 nome_lin, nome_col, 4, 16, 5, 0);
	    else
		printmat(DADOS(e), NLINS(e), NCOLS(e), " ",
			 nome_lin, nome_col, 4, 16, 5, 1);
	    libsim(aux1);
	    libsim(aux2);
	} else {
	    if (imp_er) {	/* so' imprime a primeira vez */
		if (tipo < 4)
		    putchar1();
		else
		    putchar2(1);
		imptitulo
		    ("E = Matriz de Somas de Quadrados e Produtos do Erro",
		     1);

		aux1 = mMin(mAbs(e));
		TIPO(aux1) = ID;
		aux2 = mMax(mAbs(e));
		TIPO(aux2) = ID;
		if ((DADOij(aux2, 0, 0) > 9.9e+9) ||
		    (DADOij(aux1, 0, 0) < 9.9e-9))
		    printmat(DADOS(e), NLINS(e), NCOLS(e), " ",
			     nome_lin, nome_col, 4, 16, 5, 0);
		else
		    printmat(DADOS(e), NLINS(e), NCOLS(e), " ",
			     nome_lin, nome_col, 4, 16, 5, 1);
		libsim(aux1);
		libsim(aux2);

		imp_er = 0;

		/* imprime a matriz de correlacoes parciais */
		if (tipo < 4) {
		    putchar1();
		    mlmcor(u, e, ixx, esp, nly, nd, tipo, ig);
		} else {
		    if ((int) DADOij(nd, 0, 0) > 2) {
			putchar2(1);
			mlmcor(u, e, ixx, esp, nly, nd, tipo, ig);

			/* teste de esfericidade */
			aux2 = matdif(nly, mposto(ixx));
			TIPO(aux2) = ID;
			mauchly(u, e, nd, DADOij(aux2, 0, 0));
			libsim(aux2);
		    }
		}
	    }
	}
    }

    if (imp_h) {
	if (tipo < 4)
	    putchar1();
	else
	    putchar2(1);

	titaux[0] = '\0';
	switch (tipo) {
	case 1:		/* testem */
	    strcpy(titaux,
		   "H = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, EFE_GetNome(efeitos, ief));
	    imptitulo(titaux, 1);
	    break;
	case 2:		/* cpm sem rotulo */
	    imptitulo
		("H = Matriz de Somas de Quadrados e Produtos para a Comparacao C.Beta.U = M",
		 1);
	    break;
	case 3:		/* cpm com rotulo */
	    strcpy(titaux,
		   "H = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, rotulo);
	    imptitulo(titaux, 1);
	    break;
	case 4:		/* medrep: paralelismo */
	    buf[0] = '\0';
	    if (strlen(EFE_GetNome(efeitos, ief)) < 10) {
		strcpy(buf, EFE_GetNome(efeitos, ief));
		strcat(buf, "*");
		strcat(buf, string);
	    } else
		sprintf(buf, "%s*%10s", EFE_GetNome(efeitos, ief), string);
	    strcpy(titaux,
		   "H = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, buf);
	    imptitulo(titaux, 1);
	    break;
	case 5:		/* medrep: resposta */
	    strcpy(titaux,
		   "H = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, string);
	    imptitulo(titaux, 1);
	    break;
	}

	aux1 = mMin(mAbs(h));
	TIPO(aux1) = ID;
	aux2 = mMax(mAbs(h));
	TIPO(aux2) = ID;
	if ((DADOij(aux2, 0, 0) > 9.9e+9) || (DADOij(aux1, 0, 0) < 9.9e-9))
	    printmat(DADOS(h), NLINS(h), NCOLS(h), " ",
		     nome_lin, nome_col, 4, 16, 5, 0);
	else
	    printmat(DADOS(h), NLINS(h), NCOLS(h), " ",
		     nome_lin, nome_col, 4, 16, 5, 1);
	libsim(aux1);
	libsim(aux2);
    }

    /* 
     ** Monta vetores auxiliares para nomes das linhas 
     ** das estatisticas a serem impressas
     */
    monta_l((int) NCOLS(e));

    /* Calculo dos parametros s,v e t usados nas estatisticas */
    nlc = (int) NLINS(c);
    ncu = (int) NCOLS(u);

    /* s=min({nlc ncu}) */
    s = faztemp(1, 1);
    TIPO(s) = ID;
    if (nlc <= ncu)
	DADOij(s, 0, 0) = (double) nlc;
    else
	DADOij(s, 0, 0) = (double) ncu;
    TIPO(s) = ID;

    /* v=(abs(nlc-ncu)-1)/!2; */
    v = faztemp(1, 1);
    TIPO(v) = ID;
    DADOij(v, 0, 0) = (double) (abs(nlc - ncu) - 1) / 2.0;

    t = faztemp(1, 1);
    TIPO(t) = ID;
    if (ierr != -1) {
	Cer =
	    mod_criamat((int)
			(DADOij(esp, 0, 2 + ierr) -
			 DADOij(esp, 0, 1 + ierr)), dim, 0.0);
	nlcer = (int) NLINS(Cer);
	/* t=(nlcer-ncu-1)/!2; */
	DADOij(t, 0, 0) = (double) (nlcer - ncu - 1) / 2.0;
	libtemp();
    } else {
	/* t=(nly-ncx-ncu-1)/!2; */
	DADOij(t, 0, 0) = (DADOij(nly, 0, 0) - DADOij(ncx, 0, 0) -
			   (double) (ncu) - 1.0) / 2.0;
    }

    /*
       printf("\n");
       printf("                 -  R  de Roy\n");
       printf("                 -  W  de Wilks\n");
       printf("                 -  LH de Lawley_Hotelling\n");
       printf("                 -  PI de Pillai\n");
       printf("\n");
       printf("onde :     s=min(c,u)  v=(|c-u|-1)/2   t=(e-u-1)/2\n");
       printf("\n");
       printf("   e :     c=# de linhas  de C          u=# de colunas de U\n");
       printf("           e=# grau de liberdade do erro utilizado\n");

       printf("\n");
     */

    /* calculo das estatisticas */

/* Suspenso por enquanto: 02/02/95 */
/* Vamos usar a funcao auto() nova para matrizes nao-simetricas tambem */
    /* aux1=inv(h+e) */
/* 
	aux1 = mInv(matsoma(h,e));
	TIPO(aux1) = ID;
	libtemp();

	ai = 1;
	while (ai <= (int) NLINS(aux1)) {
		aj = 1;
		while( aj < ai) {
			DADOij(aux1,ai-1,aj-1) = DADOij(aux1,aj-1,ai-1);
			aj++;
		}
		ai++;
	}
*/

    /* aux1=cho(aux1) */
/*
	aux1 = mod_atribuir(aux1,mcho(aux1));
*/

    /* aux1=aux1'*h*aux1 */
/*
	aux1 = mod_atribuir(aux1,matmult(matmult(mattran(aux1),h),aux1));

	ai = 1;
	while (ai <= NLINS(aux1)) {
		aj = 1;
		while (aj < ai) {
			DADOij(aux1,ai-1,aj-1) = DADOij(aux1,aj-1,ai-1);
			aj++;
		}
		ai++;
	}
*/

    /* val,vet=auto(aux1) */
/*
	MOD_AUTO(aux1,val,vet);
*/

    /* R=max(val) */
/*
	r = mMax(val);
	TIPO(r) = ID;

	if (imp_v) {
	printf("\n");
	printf("    Autovalores e autovetores de aux1 a partir de inv(H+E)\n");
	printf("\n");
	printf("\n");
	printmat(DADOS(val), NLINS(val), NCOLS(val), "VAL",
                 (char **) NULL, (char *) NULL, 1, 12, 5, 1);
	printmat(DADOS(vet), NLINS(vet), NCOLS(vet), "VET",
                 (char **) NULL, (char *) NULL, 1, 12, 5, 1);
	}
** Suspenso ate' aqui ! */


    /* val1,vet1=auto(inv(e)*h) */
    MOD_AUTO(matmult(mInv(e), h), val1, vet1);
    TIPO(vet1) = ID;
    TIPO(val1) = ID;
    libtemp();

    /* aux2 = vet1'*E*vet1 */
    aux2 = matmult(mattran(vet1), matmult(e, vet1));
    TIPO(aux2) = ID;
    libtemp();

    /* vet1[,k] = vet1[,k] / sqrt(aux2[k,k]) */
    for (k = 0; k < NCOLS(vet1); k++) {
	if (DADOij(aux2, k, k) <= 0.0)
	    mlmerro(33);
	mt = sqrt(DADOij(aux2, k, k));
	for (i = 0; i < NLINS(vet1); i++)
	    DADOij(vet1, i, k) = DADOij(vet1, i, k) / mt;
    }
    libsim(aux2);
    libtemp();

    if (imp_v) {
	if (tipo < 4)
	    putchar1();
	else
	    putchar2(1);

	imptitulo
	    ("Raizes Caracteristicas e Vetores Caracteristicos de inv(E)*H, onde",
	     2);
	titaux[0] = '\0';
	switch (tipo) {
	case 1:
	    printf("H = Matriz de Somas de Quadrados e Produtos para %s\n",
		   EFE_GetNome(efeitos, ief));
	    break;
	case 2:
	    printf
		("H = Matriz de Somas de Quadrados e Produtos para a Comparacao C.Beta.U = M\n");
	    break;
	case 3:
	    strcpy(titaux,
		   "H = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, rotulo);
	    printf("%s\n", titaux);
	    break;
	case 4:
	    buf[0] = '\0';
	    if (strlen(EFE_GetNome(efeitos, ief)) < 10) {
		strcpy(buf, EFE_GetNome(efeitos, ief));
		strcat(buf, "*");
		strcat(buf, string);
	    } else
		sprintf(buf, "%s*%10s", EFE_GetNome(efeitos, ief), string);
	    strcpy(titaux,
		   "H = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, buf);
	    printf("%s\n", titaux);
	    break;
	case 5:
	    strcpy(titaux,
		   "H = Matriz de Somas de Quadrados e Produtos para ");
	    strcat(titaux, string);
	    printf("%s\n", titaux);
	    break;
	}

	if (ierr != -1)
	    printf("E = Matriz de Somas de Quadrados e Produtos para %s\n",
		   EFE_GetNome(efeitos, ierr - 1));
	else
	    printf
		("E = Matriz de Somas de Quadrados e Produtos do Erro\n");

	/* descobre a ordem decrescente dos autovalores */
	ipos = mod_gindex(1, 1);
	mpos = matsubs(val1, (Simbolo_t *) 0, ipos);
	ord = ordem(mpos);
	TIPO(ord) = ID;
	for (k = 0; k < NLINS(ord); k++)
	    DADOij(ord, k, 0) =
		(double) NLINS(ord) + 1.0 - DADOij(ord, k, 0);

	/* 
	 ** calcula vetor ord1 com o no. das linhas correspondentes no
	 ** no vetor ord
	 */
	ord1 = mod_criamat(NLINS(ord), NCOLS(ord), 0.0);
	TIPO(ord1) = ID;
	for (i = 1; i <= NLINS(ord); i++) {
	    for (k = 1; i <= NLINS(ord); k++) {
		if (DADOij(ord, k - 1, 0) == i) {
		    DADOij(ord1, i - 1, 0) = (double) k;
		    break;
		}
	    }
	}

	/* calcula coluna da porcentagem doa autovalores */
	soma = mSum(val1);
	TIPO(soma) = ID;

	pct = faztemp(NLINS(val1), 1);
	TIPO(pct) = ID;
	for (i = 0; i < NLINS(val1); i++) {
	    DADOij(pct, i, 0) =
		fabs(DADOij(val1, i, 0) / DADOij(soma, 0, 0));
	    DADOij(pct, i, 0) = DADOij(pct, i, 0) * 100.0;
	}

	/* concatena val1 , pct e vet1' */
	aux2 = hconcat(hconcat(mpos, pct), mattran(vet1));
	TIPO(aux2) = ID;

	/* altera ordem da matriz concatenada para impressao */
	aux3 = matsubs(aux2, mattran(ord1), (Simbolo_t *) 0);
	TIPO(aux3) = ID;

	/* monta o nome das colunas de V */
	imptitulo("Vetor Caracteristico (V' E V = 1)", 1);
	print_V(aux3, tipo);

	libsim(aux2);
	libsim(aux3);
	libsim(ord);
	libsim(ord1);
	libsim(soma);
	libsim(pct);
	libtemp();
    }

    /*
     ** Imprime titulo para resultados estatisticos
     */
    if (tipo < 4)
	putchar1();
    else
	putchar2(1);

    titaux[0] = '\0';
    switch (tipo) {
    case 1:
	strcpy(titaux, "Resultados Multivariados para o Teste de ");
	strcat(titaux, EFE_GetNome(efeitos, ief));
	imptitulo(titaux, 1);
	break;
    case 2:
	imptitulo("Resultados Multivariados para o Teste de C.B.U = M", 1);
	break;
    case 3:
	strcpy(titaux, "Resultados Multivariados para o Teste de ");
	strcat(titaux, rotulo);
	imptitulo(titaux, 1);
	break;
    case 4:
	buf[0] = '\0';
	if (strlen(EFE_GetNome(efeitos, ief)) < 10) {
	    strcpy(buf, EFE_GetNome(efeitos, ief));
	    strcat(buf, "*");
	    strcat(buf, string);
	} else
	    sprintf(buf, "%s*%10s", EFE_GetNome(efeitos, ief), string);
	strcpy(titaux, "Resultados Multivariados para o Teste de ");
	strcat(titaux, buf);
	imptitulo(titaux, 1);
	break;
    case 5:
	strcpy(titaux, "Resultados Multivariados para o Teste de ");
	strcat(titaux, string);
	imptitulo(titaux, 1);
	break;
    }

    /*
     ** Imprime nome das matrizes H e E
     */
    titaux[0] = '\0';
    printf("\n");
    switch (tipo) {
    case 1:
	printf("H = Matriz de Somas de Quadrados e Produtos para %s\n",
	       EFE_GetNome(efeitos, ief));
	break;
    case 2:
	printf
	    ("H = Matriz de Somas de Quadrados e Produtos para a Comparacao C.Beta.U = M\n");
	break;
    case 3:
	strcpy(titaux,
	       "H = Matriz de Somas de Quadrados e Produtos para ");
	strcat(titaux, rotulo);
	printf("%s\n", titaux);
	break;
    case 4:
	buf[0] = '\0';
	if (strlen(EFE_GetNome(efeitos, ief)) < 10) {
	    strcpy(buf, EFE_GetNome(efeitos, ief));
	    strcat(buf, "*");
	    strcat(buf, string);
	} else
	    sprintf(buf, "%s*%10s", EFE_GetNome(efeitos, ief), string);
	strcpy(titaux,
	       "H = Matriz de Somas de Quadrados e Produtos para ");
	strcat(titaux, buf);
	printf("%s\n", titaux);
	break;
    case 5:
	strcpy(titaux,
	       "H = Matriz de Somas de Quadrados e Produtos para ");
	strcat(titaux, string);
	printf("%s\n", titaux);
	break;
    }

    if (ierr != -1)
	printf("E = Matriz de Somas de Quadrados e Produtos para %s\n",
	       EFE_GetNome(efeitos, ierr - 1));
    else
	printf("E = Matriz de Somas de Quadrados e Produtos do Erro\n");


    /* Estatistica R de Roy */
    /* R=max(val1) */
    r = mMax(val1);
    TIPO(r) = ID;

    /* Estatistica W de WILKS */
    /* W=det(e)/!det((h+e)) */
    w = matediv(mdet(e), mdet(matsoma(h, e)));
    TIPO(w) = ID;
    libtemp();

    /* Estatistica LH Traco de LAWLEY-HOTELLING */
    /* LH=traco((h*inv(e))) */
    lh = mTraco(matmult(h, mInv(e)));
    TIPO(lh) = ID;
    libtemp();

    /* Estatistica PI Traco de PILLAI */
    /* PI=traco((h*inv(h+e))) */
    pi = mTraco(matmult(h, mInv(matsoma(h, e))));
    TIPO(pi) = ID;
    libtemp();

    imptitulo("Parametros para os Criterios Estatisticos", 1);
    paramet = hconcat(hconcat(s, v), t);
    TIPO(paramet) = ID;
    printmat(DADOS(paramet), NLINS(paramet), NCOLS(paramet), " ",
	     l1, "s,m,n", 4, 14, 6, 0);
    libsim(paramet);

    imptitulo("Criterios Estatisticos", 1);
    valor = hconcat(hconcat(hconcat(r, w), lh), pi);
    printmat(DADOS(valor), NLINS(valor), NCOLS(valor), " ",
	     l1, "R-Roy,W-Wilks,LH-Law Hot,PI-Pillai", 4, 14, 5, 1);

    /* imprime as distribuicoes exatas para as estatisticas R e W no 
       caso s = 1 */

    if (DADOij(s, 0, 0) == 1.0) {
	imptitulo("Distribuicao Exata F para as Estatisticas", 1);

	/* Distribuicao exata F(GLN=2v+2,GLD=2t+2) para a estatistica R */

	/* F=r*(t+1)/!(v+1) */
	f1 = (DADOij(r, 0, 0) * ((DADOij(t, 0, 0) + 1.0))) /
	    (DADOij(v, 0, 0) + 1.0);
	f = faztemp(1, 1);
	DADOij(f, 0, 0) = f1;

	/* GLN=2*!v+2; */
	gln1 = 2.0 * DADOij(v, 0, 0) + 2.0;
	gln = faztemp(1, 1);
	DADOij(gln, 0, 0) = gln1;

	/* GLD=2*!t+2 */
	gld1 = 2.0 * DADOij(t, 0, 0) + 2.0;
	gld = faztemp(1, 1);
	DADOij(gld, 0, 0) = gld1;

	/* p_value=fprob(F,GLN,GLD) */
	pv = fprob(f1, gln1, gld1);
	p_value = faztemp(1, 1);
	DADOij(p_value, 0, 0) = pv;

	valores =
	    hconcat(hconcat(hconcat(hconcat(r, gln), gld), f), p_value);
	TIPO(valores) = ID;

	valores =
	    vconcat(valores,
		    hconcat(hconcat(hconcat(hconcat(w, gln), gld), f),
			    p_value));
	TIPO(valores) = ID;

	valores =
	    vconcat(valores,
		    hconcat(hconcat(hconcat(hconcat(lh, gln), gld), f),
			    p_value));
	TIPO(valores) = ID;

	valores =
	    vconcat(valores,
		    hconcat(hconcat(hconcat(hconcat(pi, gln), gld), f),
			    p_value));
	TIPO(valores) = ID;

	printmat(DADOS(valores), NLINS(valores), NCOLS(valores),
		 "Estatist", l_rwlp, "Valor,glNum,glDen,Valor F,Pr > F", 4,
		 14, 5, 0);

	libsim(valores);
	libtemp();
    }

    /* imprime a distribuicao exata para a estatistica W no caso s = 2 */

    if (DADOij(s, 0, 0) == 2.0) {
	imptitulo("Distribuicao Exata F para a Estatistica W de Wilks", 1);

	/* Distribuicao exata F(GLN=4v+6,GLD=4(t+1)) para a estatistica W */

	/* F=(1-sqrt(w))*!(2*!t+2)/!(sqrt(w)*!(2*!v+3)) */
	f1 = (1.0 - DADOij(mSqrt(w), 0, 0)) * (2.0 * DADOij(t, 0, 0) +
					       2.0) / (DADOij(mSqrt(w), 0,
							      0) * (2.0 *
								    DADOij
								    (v, 0,
								     0) +
								    3.0));
	f = faztemp(1, 1);
	DADOij(f, 0, 0) = f1;

	/* GLN=4*!v+6 */
	gln1 = 4.0 * DADOij(v, 0, 0) + 6.0;
	gln = faztemp(1, 1);
	DADOij(gln, 0, 0) = gln1;

	/* GLD=4*!(t+1) */
	gld1 = 4.0 * (DADOij(t, 0, 0) + 1.0);
	gld = faztemp(1, 1);
	DADOij(gld, 0, 0) = gld1;

	/* p_value=fprob(F,GLN,GLD) */
	pv = fprob(f1, gln1, gld1);
	p_value = faztemp(1, 1);
	DADOij(p_value, 0, 0) = pv;

	/* VALORES={ w GLN GLD F p_value} */
	valores =
	    hconcat(hconcat(hconcat(hconcat(w, gln), gld), f), p_value);
	printmat(DADOS(valores), NLINS(valores), NCOLS(valores),
		 "Estatist", l_w, "Valor,glNum,glDen,Valor F,Pr > F", 4,
		 14, 5, 0);

	libtemp();
    }

    /* imprime as distribuicoes assintoticas para as estatisticas  W,  
       LH e  PI nos casos em que s > 2 */

    if (DADOij(s, 0, 0) > 2.0) {

	/*  Aproximacao Qui-quadrado(GL=c*u) para a estatistica W */

	/* X2=-(nly-ncx-(ncu-nlc+1)/!2)*!log(w) */
	x21 = -(DADOij(nly, 0, 0) - DADOij(ncx, 0, 0) -
		((double) (ncu - nlc) + 1.0) / 2.0) * DADOij(mLog(w), 0,
							     0);
	x2 = faztemp(1, 1);
	DADOij(x2, 0, 0) = x21;

	/* GL=nlc*!ncu */
	gl1 = (double) (nlc * ncu);
	gl = faztemp(1, 1);
	DADOij(gl, 0, 0) = gl1;

	/* p_value=xprob(X2,GL) */
	pv = xprob(x21, gl1);
	p_value = faztemp(1, 1);
	DADOij(p_value, 0, 0) = pv;

	/* VALORES={X2 GL p_value}  */
	valores = hconcat(hconcat(x2, gl), p_value);

	imptitulo("Aproximacao Qui-Quadrado para a Estatistica W de Wilks",
		  1);
	printmat(DADOS(valores), NLINS(valores), NCOLS(valores),
		 "Estatist", l_w, "Valor,gl,Pr > Qui", 4, 14, 5, 0);

	libtemp();

	/* Aproximacao F(GLN=s(2v+s+1),GLD=2(st+1)) para a estatistica LH */

	/* F=(2*lh*(s*t+1))/(s*s*(2*v+s+1)) */
	f1 = (2.0 * DADOij(lh, 0, 0) *
	      (DADOij(s, 0, 0) * DADOij(t, 0, 0) + 1.0)) / (DADOij(s, 0,
								   0) *
							    DADOij(s, 0,
								   0) *
							    (2.0 *
							     DADOij(v, 0,
								    0) +
							     DADOij(s, 0,
								    0) +
							     1.0));
	f = faztemp(1, 1);
	DADOij(f, 0, 0) = f1;

	/* GLN=s*!(2*!v+s+1) */
	gln1 =
	    DADOij(s, 0,
		   0) * (2.0 * DADOij(v, 0, 0) + DADOij(s, 0, 0) + 1.0);
	gln = faztemp(1, 1);
	DADOij(gln, 0, 0) = gln1;

	/* GLD=2*!(s*!t+1) */
	gld1 = 2.0 * (DADOij(s, 0, 0) * DADOij(t, 0, 0) + 1.0);
	gld = faztemp(1, 1);
	DADOij(gld, 0, 0) = gld1;

	/* p_value=fprob(F,GLN,GLD) */
	pv = fprob(f1, gln1, gld1);
	p_value = faztemp(1, 1);
	DADOij(p_value, 0, 0) = pv;

	/* VALORES={ lh GLN GLD F p_value} */
	valores =
	    hconcat(hconcat(hconcat(hconcat(lh, gln), gld), f), p_value);

	imptitulo
	    ("Aproximacao F para a Estatistica LH de Lawley-Hotelling", 1);
	printmat(DADOS(valores), NLINS(valores), NCOLS(valores),
		 "Estatist", l_lh, "Valor,glNum,glDen,Valor F,Pr > F", 4,
		 14, 5, 0);

	libtemp();

	/* Aproximacao F(GLN=s(2v+s+1),GLD=s(2t+s+1)) para a estatistica PI */

	/* F=pi*!(2*!t+s+1)/!((s-pi)*!(2*!v+s+1)) */
	f1 = DADOij(pi, 0,
		    0) * (2.0 * DADOij(t, 0, 0) + DADOij(s, 0,
							 0) +
			  1.0) / ((DADOij(s, 0, 0) -
				   DADOij(pi, 0, 0)) * (2.0 * DADOij(v, 0,
								     0) +
							DADOij(s, 0,
							       0) + 1.0));
	f = faztemp(1, 1);
	DADOij(f, 0, 0) = f1;

	/* GLN=s*!(2*!v+s+1) */
	gln1 =
	    DADOij(s, 0,
		   0) * (2.0 * DADOij(v, 0, 0) + DADOij(s, 0, 0) + 1.0);
	gln = faztemp(1, 1);
	DADOij(gln, 0, 0) = gln1;

	/* GLD=s*!(2*!t+s+1) */
	gld1 =
	    DADOij(s, 0,
		   0) * (2.0 * DADOij(t, 0, 0) + DADOij(s, 0, 0) + 1.0);
	gld = faztemp(1, 1);
	DADOij(gld, 0, 0) = gld1;

	/* p_value=fprob(F,GLN,GLD) */
	pv = fprob(f1, gln1, gld1);
	p_value = faztemp(1, 1);
	DADOij(p_value, 0, 0) = pv;

	/* VALORES={ pi nly GLN GLD F p_value} */
	valores =
	    hconcat(hconcat(hconcat(hconcat(pi, gln), gld), f), p_value);

	imptitulo("Aproximacao F para a Estatistica PI de Pillai", 1);
	printmat(DADOS(valores), NLINS(valores), NCOLS(valores),
		 "Estatist", l_pi, "Valor,glNum,glDen,Valor F,Pr > F", 4,
		 14, 5, 0);

	libtemp();
    }

    lib_lin((int) DADOij(nd, 0, 0), tipo);
    lib_l((int) NCOLS(e));
}


/*
** Calcula as matrizes H, E e TETA.
*/
void calc_h_e(ierr, esp, ixx, beta, c, u, m, aux, h, e)
int ierr;
Simbolo_t *esp;
Simbolo_t *ixx;
Simbolo_t *beta;
Simbolo_t *c;
Simbolo_t *u;
Simbolo_t *m;
Simbolo_t *aux;
Simbolo_t **h;
Simbolo_t **e;
{
    int j, k, l, dim;

    Simbolo_t *m1 = (Simbolo_t *) NULL;
    Simbolo_t *h1 = (Simbolo_t *) NULL;
    Simbolo_t *Cer = (Simbolo_t *) NULL;
    Simbolo_t *aux1 = (Simbolo_t *) NULL;
    Simbolo_t *aux2 = (Simbolo_t *) NULL;
    Simbolo_t *teta = (Simbolo_t *) NULL;
    Simbolo_t *teta1 = (Simbolo_t *) NULL;

    dim = NCOLS(ixx);

    /* TETA = c*BETA*u-m */
    teta = matdif(matmult(matmult(c, beta), u), m);
    TIPO(teta) = ID;
    libtemp();

    /* Calcula as matrizes AUX1, H (uxu) e  E (uxu). */
    /* Verifica se ha' teste de erro especifico. */

    if (ierr != -1) {
	/* Cer = criamat(esp[1,3+ierr]-esp[1,2+ierr],dim,0) */
	Cer =
	    mod_criamat((int)
			(DADOij(esp, 0, 2 + ierr) -
			 DADOij(esp, 0, 1 + ierr)), dim, 0.0);
	TIPO(Cer) = ID;

	/* M1 = criamat(esp[1,3+ierr]-esp[1,2+ierr],ncols(m),0); */
	m1 = mod_criamat((int)
			 (DADOij(esp, 0, 2 + ierr) -
			  DADOij(esp, 0, 1 + ierr)), NCOLS(m), 0.0);
	TIPO(m1) = ID;

	/* preenchimento de 1's na matriz Cer */
	j = (int) DADOij(esp, 0, 1 + ierr);
	k = j + 1;
	l = 1;

	while (j < (int) DADOij(esp, 0, 2 + ierr)) {
	    DADOij(Cer, l - 1, k - 1) = 1.0;
	    k++;
	    j++;
	    l++;
	}

	/* calcula a estimativa da matriz H */
	/* AUX1 = c*ixx*c'; */
	aux1 = matmult(matmult(c, ixx), mattran(c));
	TIPO(aux1) = ID;
	libtemp();

	/* H = teta'*inv(aux1)*teta */
	*h = matmult(matmult(mattran(teta), mInv(aux1)), teta);
	TIPO(*h) = ID;
	libtemp();

	/* TETA1 = Cer*BETA*u-M1 */
	teta1 = matdif(matmult(matmult(Cer, beta), u), m1);
	TIPO(teta1) = ID;
	libtemp();

	/* AUX2 = Cer*ixx*Cer' */
	aux2 = matmult(matmult(Cer, ixx), mattran(Cer));
	TIPO(aux2) = ID;
	libtemp();

	/* H1 = teta1'*inv(aux2)*teta1 */
	h1 = matmult(matmult(mattran(teta1), mInv(aux2)), teta1);
	TIPO(h1) = ID;
	libtemp();

	/* E = H1 */
	/* criar matriz e para mod_atribuir */
	*e = mod_criamat(1, 1, 0.0);
	TIPO(*e) = ID;
	*e = mod_atribuir(*e, h1);

	/* libera espaco das matrizes nao mais necessarias */
	libsim(teta1);
	libsim(h1);
	libsim(m1);
	libsim(aux2);
	libsim(Cer);
    } else {

	/* calcula a estimativa da matriz H e E */
	/* AUX1 = c*ixx*c' */
	aux1 = matmult(matmult(c, ixx), mattran(c));
	TIPO(aux1) = ID;
	libtemp();

	/* H = teta'*inv(aux1)*teta; */
	*h = matmult(matmult(mattran(teta), mInv(aux1)), teta);
	TIPO(*h) = ID;
	libtemp();

	/* E = u'*aux*u; */
	*e = matmult(matmult(mattran(u), aux), u);
	TIPO(*e) = ID;
	libtemp();

	/* libera espaco das matrizes nao mais necessarias */
	libsim(aux1);
    }

    libsim(teta);
}

/* 
** Nomes das linhas para sa matrizes das estaticas calculadas. 
*/
void monta_l(dim)
int dim;
{
    int i;

    /* uma linha em branco */
    l1[0] = (char *) malloc(16 * sizeof(char));
    strcpy(l1[0], "  ");

    /* Para nome das linhas das estatisticas R e W */
    l_rwlp[0] = (char *) malloc(16 * sizeof(char));
    strcpy(l_rwlp[0], "R");
    l_rwlp[1] = (char *) malloc(16 * sizeof(char));
    strcpy(l_rwlp[1], "W");
    l_rwlp[2] = (char *) malloc(16 * sizeof(char));
    strcpy(l_rwlp[2], "LH");
    l_rwlp[3] = (char *) malloc(16 * sizeof(char));
    strcpy(l_rwlp[3], "PI");

    /* Para nome das linhas de W */
    l_w[0] = (char *) malloc(16 * sizeof(char));
    strcpy(l_w[0], "W");

    /* Para nome das linhas de LH */
    l_lh[0] = (char *) malloc(16 * sizeof(char));
    strcpy(l_lh[0], "LH");

    /* Para nome das linhas de PI */
    l_pi[0] = (char *) malloc(16 * sizeof(char));
    strcpy(l_pi[0], "PI");

    /* n linhas em branco */
    for (i = 0; i < dim; i++) {
	ln[i] = (char *) malloc(16 * sizeof(char));
	strcpy(ln[i], "   ");
    }

}

/*
** Libera areas alocadas em monta_l().
*/
void lib_l(dim)
int dim;
{
    int i;

    free(l1[0]);

    free(l_rwlp[0]);
    free(l_rwlp[1]);
    free(l_rwlp[2]);
    free(l_rwlp[3]);

    free(l_w[0]);

    free(l_lh[0]);

    free(l_pi[0]);

    for (i = 0; i < dim; i++)
	free(ln[i]);
}

/*
** Monta nome das linhas para impressao de U em medrep. 
*/
void monta_u(ndep)
int ndep;
{
    int i, ini;

    ini = EFE_GetNefe(efeitos) - ndep;

    /* var_dep1 ... var_depk */
    lin_u[0] = (char *) malloc(16 * sizeof(char));
    strcpy(lin_u[0], EFE_GetNome(efeitos, ini));

    for (i = 1; i < ndep; i++) {
	lin_u[i] = (char *) malloc(16 * sizeof(char));
	strcpy(lin_u[i], EFE_GetNome(efeitos, i + ini));
    }
}


/*
** Liberacao do nome das linhas da matriz U
*/
void lib_u(ndep)
int ndep;
{
    int i;

    for (i = 0; i < ndep; i++)
	free(lin_u[i]);
}

/*
** Imprime auto-valores e vetores caracteristicos
*/
void print_V(mv, tipo)
Simbolo_t *mv;
int tipo;
{
    int i, j, nl, nc;
    int col_ini, col_fim;
    int primeira, vez;
    int lim;

    char pc[2];
    char *p;
    char *p_nome();

    nl = NLINS(mv);
    nc = NCOLS(mv);

    lim = 5;
    col_ini = 0;
    col_fim = (nc < lim) ? nc : lim;

    printf("\n");

    strcpy(pc, "%");
    primeira = 0;
    vez = 1;
    do {
	/* Imprime nome das colunas */
	for (j = col_ini; j < col_fim; j++) {
	    if (primeira < 2) {
		if (j == col_ini)
		    printf("%14s ", "Raiz");
		if (j == (col_ini + 1))
		    printf("%14s ", pc);
		primeira++;
	    } else {
		p = p_nome(j - 2);
		printf("%14s ", p);
		free(p);
	    }
	}
	printf("\n\n");

	/* Para todas as linhas, imprime os valores das colunas */
	for (i = 0; i < nl; i++) {
	    for (j = col_ini; j < col_fim; j++) {
		if (vez) {
		    if (j == (col_ini + 1))
			printf("%14.2lf ", DADOij(mv, i, j));
		    else {
			if (fabs(DADOij(mv, i, j)) >= 0.00001)
			    printf("%14.5lf ", DADOij(mv, i, j));
			else {
			    DADOij(mv, i, j) = 0.0;
			    printf("%14.5lf ", DADOij(mv, i, j));
			}
		    }
		} else {
		    if (fabs(DADOij(mv, i, j)) >= 0.00001)
			printf("%14.5lf ", DADOij(mv, i, j));
		    else {
			DADOij(mv, i, j) = 0.0;
			printf("%14.5lf ", DADOij(mv, i, j));
		    }
		}
	    }
	    printf("\n");
	}
	vez = 0;

	/* Atualiza coluna final e inicial para proxima impressao */
	col_ini = col_fim;
	col_fim += lim;

	if ((col_fim > nc) && (col_ini < nc)) {
	    col_fim = nc;
	}

	printf("\n");

    } while (col_fim <= nc);
}

/*
** Dado nome_col = "nome_1,nome_2,...,nome_n", retira deste vetor 
** o nome associado a coluna j ("nome_j"). 
*/
char *p_nome(j)
int j;
{
    char *nome;
    int i, k, pos;

    nome = (char *) malloc(16 * sizeof(char));

    if (j == 0)
	i = 0;
    else {
	pos = 0;
	for (i = 0; i < (k = strlen(nome_col)); i++) {
	    if (nome_col[i] == ',')
		pos++;
	    if (pos == j)
		break;
	}
	i++;
    }

    k = 0;
    do {
	nome[k++] = nome_col[i++];
    } while ((nome_col[i] != ',') && (nome_col[i] != '\0'));

    nome[k] = '\0';

    return (nome);
}
