
/* ----------------------------------------------------------------------------
** @(#)multvar.h	3.3	(NTIA/modlin)	95/04/18
**
** 
**
** Data da ultima alteracao:
**
**		95/04/18 11:14:21
**
** ----------------------------------------------------------------------------
*/

/*
** MULTVAR.H
** 
** Definicao de estruturas e constantes para a analise multivariada
**
** Por: Silvio Evangelista e Sonia Ternes
**
** agosto de 1993
*/

/*
** Constantes usadas
*/

#define		EPS		1.e-15
#define 	MAXEFEITOSCP 	20

#ifdef MSDOS
#define 	MAXEFTS      100 /*os valores de MAXEFTS devem ser compativeis*/
#else                            /*com os do MODLIN, definidos em anova.h*/
#define 	MAXEFTS      300
#endif

#define		TAM		(MAXEFTS*8)

/*
** Estruturas usadas
*/

struct _Efeito {		/* efeitos do modelo */
        char *nome[MAXEFTS];	/* nome do efeito lido no arquivo "xlxefts" */
        int  np;		/* total de efeitos no modelo */
};

typedef struct _Efeito	Efeitos;

struct _Cp {			/* efeitos especificados no CP */
        int  efe[MAXEFEITOSCP];	/* indice do efeito na estrutura "Efeitos" */
        int  nef;		/* total de efeitos especificados */
};

typedef struct _Cp	Cps;

struct _Ef {			/* efeitos especificados no EFEITO */
        int  efe[MAXEFTS];	/* indice do efeito na estrutura "Efeitos" */
        int  nef;		/* total de efeitos especificados pelo usuario*/
};

typedef struct _Ef	EfUsu;

/*
** Macros para manipulacao da estrutura Efeitos
*/

#define	EFE_GetNome(ef,i)	ef.nome[i]
#define EFE_GetNefe(ef)		ef.np

#define EFE_SetNefe(ef,n)	ef.np = n
#define	EFE_SetNome(ef,i,p)	ef.nome[i] = p

/*
** Macros para manipulacao da estrutura Cps
*/

#define	CP_GetEfe(ef,i)		ef.efe[i]
#define CP_GetNefe(ef)		ef.nef

#define CP_SetEfe(ef,i,j)	ef.efe[i] = j
#define CP_SetNefe(ef,n)	ef.nef = n

/*
** Macros para manipulacao da estrutura EfUsu
*/

#define	EU_GetEfe(ef,i)		ef.efe[i]
#define EU_GetNefe(ef)		ef.nef

#define EU_SetEfe(ef,i,j)	ef.efe[i] = j
#define EU_SetNefe(ef,n)	ef.nef = n

/*
** Funcoes derivadas da traducao 
*/

extern	void	mlmaju();
extern	void	mlmhip();
extern	void	mlmerro();
extern	void	mlmger();
extern	void	mlm_GER();
extern	void	mlmcp();
extern	void	mlm_CP();
extern	void	mlmmed();
extern	void	mlm_MED();
extern	void	mlmEfts();
extern	void	mlmcor();

/*
** Funcoes auxiliares
*/
extern	void	analise();
extern	void	monta_CM();
extern	void	inicia();
extern	void	iniciat();
extern	void	printa();
extern	void	print_anova();
extern	void	print_erro();
extern	void	calc_h_e();
extern	void	lib_lin();
extern	void	monta_lin();
extern	void	monta_col();
extern	void	imptitulo();
extern	void	montatit();
extern	void	montarot();
extern	void	putchar1();
extern	void	putchar2();
extern	void	quadro();
extern	void	exec_univar();
extern	void	tit_analise();
extern	void	mauchly();

extern	double	calc_cor();
extern	double	calc_pv();

extern	int	col_c_atual();
extern	int	escolhido();
extern	int	igualm();

/*
** Fim
*/
