/***********************************************************************************
 ORDENA - Ferramenta para Ordenao de Arquivos SOC

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo getarg, da ferramenta de ordenao de arquivos SOC, concentra a
	interpretao dos argumentos (opes de execuo da ferramenta).

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Joo Camargo Neto
	  Maurcio Noronha Festa

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include "getoken.h"
#include "pcsgbd.h"
#include "ordena.h"

extern ARQ *parq;
extern int rflag;
extern int kflag;
extern int fflag;
extern int pflag;
extern char filein[];
extern char fileout[];
extern int flagX;
extern int flagP;
extern char ord[];
extern char cmd1[];
extern char cmd2[];
extern int arquivo;
extern int dois;
extern int nlins;
extern int ncols;

extern int descarq[2];
extern char exretstd[];		/* Contem o nome do arquivo exretstd */
extern int flagstd;

int flagA = 0;

void getarg(argc, argv)
int argc;
char *argv[];
{
    void controlC();

    int i;
    int j;
    int c;
    int testa_vazio;
    char *pdir;

    long ret;
    char tmpbuf[2];

    ++argv;			/* aponta para o primeiro parametro */
    --argc;			/* decrementa o apontador */
    testa_vazio = 1;		/* vai testar se o arquivo de entrada esta' vazio */
    flagX = 1;
    while (argc--) {
	if (argv[0][0] == '-') {
	    for (i = 1; argv[0][i]; ++i) {
		switch (argv[0][i]) {
		case 'p':
		    ++pflag;
		    break;
		case 'P':
		    flagP = 1;
		    break;
		case 'o':
		    ++kflag;
		    j = 0;
		    do {
			++i;
			c = argv[0][i];
			if (c != 'd' && c != 'a') {

/* *** Padroniz. msg erro - Luciana 03/01/95
						fprintf(stderr,
					"Erro: parametro <%c> invalido\n",c);
*** */
			    tmpbuf[0] = c;
			    tmpbuf[1] = '\0';
			    fprintf(stderr, PegaMsg(1023), tmpbuf);
			    setOSstdin();
			    exit(1);
			}
			++i;
			ord[j++] = (char) c;
		    } while (argv[0][i] == ',');
		    ord[j] = '\0';
		    --i;
		    break;
		case 'd':
		    ++rflag;
		    break;
		case 'f':
		    fflag = 0;
		    break;
		case 'A':
		    flagA = 1;
#ifdef RS6000
		    flagstd = 1;
		    /*
		     *strchr(&argv[0][i+1], '|') = '\0';
		     */
		    if (*strchr(&argv[0][i + 1], '|'))
			*strchr(&argv[0][i + 1], '|') = '\0';

		    if (freopen(&argv[0][i + 1], "r", stdin) ==
			(FILE *) NULL) {

			i += (strlen(&argv[0][i + 1]) + 1);
			*strchr(&argv[0][i + 1], '|') = '\0';
			i += (strlen(&argv[0][i + 1]) + 1);
			strcpy(exretstd, &argv[0][i + 1]);

/* *** Padroniz. msg erro - Luciana 03/01/95
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
			fprintf(stderr, PegaMsg(1034), "stdin");
			setOSstdin();
			exit(5);
		    }
		    i += (strlen(&argv[0][i + 1]) + 1);

		    *strchr(&argv[0][i + 1], '|') = '\0';
		    fseek(stdin, atol(&argv[0][i + 1]), 0);

		    i += (strlen(&argv[0][i + 1]) + 1);
		    strcpy(exretstd, &argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

#endif
		    setbuf(stdin, (char *) NULL);
		    break;
		case 'X':
		    if (strcmp(&argv[0][i + 1], "ntia") == 0) {
			flagX = 1;
			i += 4;
		    }
		    break;

		case 'l':

		    nlins = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);
		    break;

		    /*
		     ** Habilita impressao de mensagens
		     */

		case 'M':

		    break;

		    /*
		     ** Habilita impressao de tempo
		     */

		case 't':

		    break;

		case 'c':

		    ncols = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);
		    break;
		case 'k':
		    testa_vazio = 0;
		    break;
		default:

/* *** Padroniz. msg erro - Luciana 03/01/95
					printf("Flag <%c> ilegal\n",argv[0][1]);
*** */
		    printf(PegaMsg(3086), argv[0][1]);
		    setOSstdin();
		    exit(1);
		}
	    }
	}

	else
	    break;

	++argv;
    }

    if (!flagX) {

/* *** Padroniz. msg erro - Luciana 03/01/95
		fprintf(stderr, "Execucao nao permitida\n");
*** */
	fprintf(stderr, PegaMsg(1000));
	setOSstdin();
	exit(1);
    }

    if (argc < 0)
	usage();

    pdir = pega_env(argv[0], ".hdr");

    if (argc) {
	if (descarq[0] == -2) {
	    /* ERRO(1034): Nao conseguiu abrir o arquivo */
	    fprintf(stderr, PegaMsg(1034), pdir);
	    setOSstdin();
	    exit(5);
	}
    } else {
	if (descarq[0] == -2) {
	    /* ERRO(1034): Nao conseguiu abrir o arquivo */
	    fprintf(stderr, PegaMsg(1034), pdir);
	    setOSstdin();
	    exit(5);
	}
    }

    strcpy(filein, pdir);
    strcpy(cmd1, pdir);

    if ((ret = (long) (parq = abre_arq(filein, 0, testa_vazio))) < 0L
	&& ret > -5L) {
	if (testa_vazio != 0) {

/* *** Padroniz. msg erro - Luciana 03/01/95
			printf("ERRO(1480): Abertura do arquivo %s\n", filein);
*** */
	    printf(PegaMsg(1034), filein);
	    setOSstdin();

	    exit(3);
	}
    }

    if (argc) {
	dois = 0;
	strcpy(fileout, argv[1]);

	if (!strrchr(fileout, '/') && !strrchr(fileout, '\\')) {
	    char *ptr1, *ptr2;

	    strcpy(fileout, filein);
	    ptr1 = strrchr(fileout, '/');
	    ptr2 = strrchr(fileout, '\\');

	    if (ptr1 || ptr2) {
		if (ptr2 > ptr1)
		    ptr1 = ptr2;

		strcat(ptr1 + 1, argv[1]);
	    }

	    else
		strcpy(fileout, argv[1]);
	}

	strcpy(cmd2, fileout);
	strcat(cmd1, ".hdr");
	strcat(cmd2, ".hdr");

	if (strcmpi(cmd2, cmd1) != 0)
	    arquivo = -1;

	if (descarq[1] == -2) {
	    /* ERRO(1034): Nao conseguiu abrir o arquivo */
	    fprintf(stderr, PegaMsg(1034), fileout);
	    setOSstdin();
	    exit(5);
	}
    } else
	strcpy(fileout, filein);

    strcat(filein, ".dat");
    strcat(fileout, ".dat");

    signal(SIGINT, controlC);
}

void controlC(sig)
int sig;
{
    /* Eliminacao dos arquivos intermediarios */
#ifndef MSDOS
    apag_unix();
#else
    apag_dos();
#endif

    if (arquivo == -1)
	apag_hdr();


    if (flagA == 0)
	fprintf(stderr, "\n********  Interrompido pelo usuario\n");

    setOSstdin();

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Men_Store("ordena");
	exit(1);
    }
#endif

    exit(sig);
}
