/***********************************************************************************
 ORDENA - Ferramenta para Ordenao de Arquivos SOC

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Mdulo getspec, da ferramenta de ordenao de arquivos SOC.

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Joo Camargo Neto
	  Maurcio Noronha Festa

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "pcsgbd.h"
#include "sortcomp.h"
#include "ordena.h"
#include "sortspec.h"


int nkeys;
SORTKEY keys[MAX_KEYS];
SORTSPEC sspec;


void getspec(argc, argv)
int argc;
char *argv[];
{
    int i;
    char *p;

    sspec.pget = getl;
    sspec.pput = putl;
    sspec.pcomp = sortcomp;
    nkeys = 0;

    for (i = 3; i < argc; i++) {
	p = argv[i];
	if (*p == '-')
	    dospec(p + 1);
    }
}

void dospec(p)
char *p;
{
    switch (*p) {
    case 'k':
	if (nkeys == MAX_KEYS)
/* *** Padroniz. msg erro - Luciana 23/02/95
				err_msg("erro: quantidade de chaves");
*** */
	    err_msg(PegaMsg(1002));
	p = p + 1;
	getkparm(p);
	break;

    default:
/* *** Padroniz. msg erro - Luciana 23/02/95
			err_msg("opcao errada");
*** */
	err_msg(PegaMsg(1045));
	break;
    }
}

void getkparm(word)
char word[];
{
    int kt, ko, ks;
    char tc, oc;

    sscanf(word, "%c,%c,%d", &tc, &oc, &ks);
    kt = sindex(tc, "sf");
    if (oc == 'a')
	ko = ASCENDENTE;
    else if (oc == 'd')
	ko = DESCENDENTE;

    addkey(kt, ko, ks);
}

void addkey(itype, iorder, ioffset)
int itype;
int iorder;
int ioffset;
{

    keys[nkeys].ktype = itype;
    keys[nkeys].korder = iorder;
    keys[nkeys].kpos = ioffset;
    nkeys = nkeys + 1;
}

void err_msg(s)
char s[];
{
    printf("%s\n", s);
    setOSstdin();
    exit(1);
}
