/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    O mdulo contraste  responsvel pela interpretao dos comandos que especificam 
	os contrastes (testes de comparao dos parmetros do modelo) e seus clculos.

 Desenvolvido por:

	  Carlos Fernando Assis Paniago
	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Snia Ternes Frassetto

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <string.h>
#include <setjmp.h>

# include <stdlib.h>

#include "regress.h"
#include "getoken.h"
#include "pcsgbd.h" /* Luciana */

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)contrast.c	3.8	(NTIA/regress)	95/08/14";

#define IMPRIME  if (!iterativo && !tem_comando) fprintf(fout, "%s ", token);
#define IMPRIM1  if (!iterativo && !tem_comando) fprintf(fout, "\n");

int	ctoken;
extern int tem_comando;
extern FILE 	*fout;
extern int iterativo;
extern jmp_buf env;

static double  mean1[MAXMEM];	/* Vetor temporario para armazenar mean */
static int	med1[MAXMEM];

void contraste(par, faux,nd1)
int par;
FILE *faux;
int nd1;	/* numero de var. dependentes */
{
	int	c;
	int	i, j, k, l;
	int	m, n;
	int	cpflag;
	int	nm;
	int	nc;
	double	x1, sqc, qmc, valorF;
	double	qm;
	int	v[MAXMEM];
	char    titulo1[128];
	char	token[128];
	char 	tmpbuf[TAM_MSG + 1]; /* Luciana */
	TINT	id;

	extern	char *pchar;
	extern	int fl_int;

#ifdef EDIX
	double *dp;
#endif

	/* ajuste de sv para situacoes que tenham valores escondidos */
	for (i=0; i<= nef + nd1 - !fl_int; ++i) {
		med1[i] = sv[i];
	}

	nc = 0;	 
	cpflag = 0;
	nm     = -1;
	i =0;	
	k=0;
	titulo1[0] = 0;

	/* estou fazendo o parse do comando cp */
	if ((c = gtoken1(token, faux)) != VARIAV && c!=PTVG && c != VG)
		errocon(1,1);
	IMPRIME;
	if (c != PTVG) {
		cpflag = -1;
		m = 0;		/* contador de niveis de iteracao */
		do {
			buffer[0] = '\0';
			strcat(buffer, token);
			c = gtoken1(token, faux);
			IMPRIME;

			for (i=0; i<=nef+nd1-!fl_int; ++i) {
				if (strcmpi(efts[i], buffer) == 0) {
						v[m++] = med1[i];
					break;
				}
			}
			if (i > nef+nd1) {
				fprintf(stderr, "<%s> ", buffer);
				errocon(2,1);
			}
		} while (c == VARIAV);
			if (c != PTVG)
				errocon(3,1);
			c = gtoken1(token, faux);
			IMPRIM1;
			IMPRIME;
			/* terminou o parser do cp */
	}
	else {
		c = gtoken1(token, faux);
		IMPRIM1;
		IMPRIME;
	}

	if ((strcmpi(token, "rt") == 0) || (strcmpi(token,"rot") == 0) ||
		(strcmpi(token,"rotulo") == 0)) {
		while ((c = xgetc(faux)) == ' ' || c == '\t' 
			|| c == '\n' || c == '\r')
			;	/* tira brancos a direita */
		i = 0;
		while (c != ';' && i < 128) {
			titulo1[i++] = (char) c;
			if (!iterativo && !tem_comando)
				fprintf(fout,"%c",c);
			c = xgetc(faux);
		}
		if (!iterativo && !tem_comando)
			fprintf(fout,"%c\n",c);
		titulo1[i] = 0;
		c = gtoken1(token, faux);
		IMPRIME;	
	}	/* terminou de processar o titulo */

	if (cpflag == 0) {
		/* todos os valores pois nao achou o comando cp */
		m = nxlx;
		for (i=0; i<m; ++i)
			v[i] = i;	/* mapeio o vetor um a um */
	}

	if (strcmpi(token, "m") == 0) {
		/* vetor M'= */
		nm = 0;
		if ((c = gtoken1(token, faux)) != IGUAL)
			errocon(4,1);
		if (!iterativo && !tem_comando)
			fprintf(fout,"=");
		while ((c = gtoken1(token, faux)) != PTVG) {
			if (!iterativo && !tem_comando)
				fprintf(fout,"%s ",token);
			if (c != NUMBER)
				errocon(5,1);
			css[nm++] = atof(token);
		}
		IMPRIME;
		IMPRIM1;
		c = gtoken1(token, faux);
		IMPRIME;
	}
	if (strcmpi(token, "c") == 0) {
		/* vetor C= */
		nc = j = 0;
		i = 1;
		if ((c = gtoken1(token, faux)) != IGUAL)
			errocon(4,1);
		if (!iterativo && !tem_comando)
			fprintf(fout,"=");
		while ((c = gtoken1(token, faux)) != PTVG) {
			IMPRIME;
			if (j++ == m) {
				if (c == VG) {
					IMPRIM1;
					c = gtoken1(token, faux);
					IMPRIME;
					j=1;
				}
				else {    
					errocon(13,1);
				}
				++i;
			}
			if (c != NUMBER && c != PTVG)
				errocon(5,1);
			if (c != PTVG)
				saida[nc++] = atof(token);
		}
		if (!iterativo && !tem_comando)
			fprintf(fout,"%s\n",token);

		if (nm == -1) {
			for(nm=0; nm < i; ++nm) {
				css[nm] = 0.0;
			}
		}
		if (j != m || i != nm) {

/* *** Padroniz. msg erro - Luciana 19/12/94
			fprintf(stderr, "\nErro comando cp:\nA dimensao correta de c(%d,%d) e' diferente de c(%d,%d). Reinicie comando.\n\n", nm, m, i, j);
*** */
			sprintf(tmpbuf,PegaMsg(3025),nm,m);
			fprintf(stderr, tmpbuf);
			errocon(7,3);
		}
	}
	if (c != PTVG || (c == PTVG && nc == 0)) {
		errocon(8,1);
	}


	/* calculo da estimativa E = C*B-M */
	n = 0;
	for (i=0; i < nm; ++i) {
		x1 = 0.0;
		for (j=0; j < m; ++j) {
			x1 += saida[n++]*xlx[idx(nxlx, v[j])];
		}
		mean1[i] = x1 - css[i];
	}
	/* Calcular C*INV(XLX)*C' e colocar em sse[] */
	for (i=0; i<nm; ++i) {
		for (k=0; k<=i; ++k) {
			x1 = 0.0;
			for (j=0; j<m; ++j) {
				for (l=0; l<m; ++l) {
					x1 += saida[i*m+j] * saida[k*m+l] *
						xlx[idx(v[j],v[l])];
				}
			}
			id = idx(i,k);
#ifdef EDIX
			dp = &(sse[par][id]);
			*dp = x1; /* TESTE */
#else
			sse[par][id] = x1; /* TESTE */
#endif
		}
	}

	putchr1();
	imp_titulo("Comparacao entre parametros do modelo");
	printf("\t\t\t\tVariavel: %-8.8s\n",efts[fl_int+par]);
	printf("\n                         Estimativa     Desvio Padrao\n\n");
	qm = qmr;
	n = glr;
	for (i=0; i<nm; ++i) {
		k = v[i];
		for (j=0; j <= nef+nd1-!fl_int; ++j) {
			if (k == sv[j]) {
				qm = qmr;
				n = glr;
			}
		}
		x1 = sse[par][idx(i,i)] * qm; /* TESTE */
		printf("%8.8s          %17s %17s\n"," ", rounddec(mean1[i],17,8), rounddec(sqrt(x1),17,8));
	}
	/* calculo da sqc para a comparacao */
	for (j=0; j < nm; ++j) {
		id = idx(nm,j);
#ifdef EDIX
		dp = &(sse[par][id]);
		*dp = mean1[j]; /* TESTE */
#else
		sse[par][id]= mean1[j]; /* TESTE */
#endif
	}
	id = idx(nm,nm);
#ifdef EDIX
	dp = &(sse[par][id]);
	*dp = 0.0;	 /* TESTE */	/* acrecentou uma linha */
#else
	sse[par][id] = 0.0;	 /* TESTE */	/* acrecentou uma linha */
#endif
	sqc = doolitle(sse[par],nm+1);

	qmc = sqc / ((double) nm);
	if (fabs(qm) < 1e-14)
		valorF = 9999.999;
	else
		valorF = qmc / qm;
	if (valorF > 10000.0)
		valorF = 9999.999;

	printf("\nComparacao              gl Soma de quadrados   Quadrado medio   Valor F  PR > F\n\n");
	printf("%-20s  %4d %17s %16s %9s  %6.3f\n",
		titulo1,nm,rounddec(sqc,17,8),rounddec(qmc,16,8),rounddec(valorF,9,4),fprob(valorF,(double)nm,(double)n));
	printf("%-20s  %4d %17s %16s\n",
		"Erro", n, rounddec((qm*((double) n)), 17,8), rounddec(qm,16,8));

}

/* *** Padroniz. msg erro - Luciana 19/12/94
char *msg_e[] = {
	"Esperava comando 'cp' ou '}'",
	"Nome de contrastes ou 'todos'",
	"Contraste nao existe",
	"Esperava ';'",
	"Esperava '='",
	"Esperava um numero",
	"Esperava ','",
	"",
	"Subcomando invalido",
	"Variavel nao existe",
	"Nao consegui abrir arquivo 'regress.out' para executar 'cp'",
	"Comando invalido -> Apenas cp, fim ou '}' sao validos",
	"Esperava um fator ou combinacao de dois fatores",
	"Dimensao errada de 'c'. Esperava uma ','",
	0
};
*** */

int msg_e[] = {
	3075,
	3052, /* nao reproduzida */
	3076,
	3022,
	3054,
	3055,
	9999, /* nao usado */
	9999, /* nao usado */
	3056,
	9999, /* nao usado */
	5022,
	3075,
	9999, /* nao usado */
	3068,
	0
};

void errocon(n,tipo)
int n;
int tipo;
{
	extern int iterativo;

	if (tipo == 0 )

/* *** Padroniz. msg erro - Luciana 19/12/94
		fprintf(stderr, "\nErro : %s. \nReinicie comando.\n\n", msg_e[n]);
*** */
		fprintf(stderr, "%sEntre com o comando novamente.\n", PegaMsg(msg_e[n]));
	if (tipo == 1)

/* *** Padroniz. msg erro - Luciana 19/12/94
		fprintf(stderr, "\nErro comando cp:\n %s. \nReinicie comando.\n\n", msg_e[n]);
*** */
		fprintf(stderr, "%sEntre com o comando CP novamente.\n", PegaMsg(msg_e[n]));

	while ((n = xgetc(stdin)) != '\n' && n != EOF && n != '\r')
		;
	if (iterativo)
		longjmp(env, 1);
	else {
		if (tem_comando) {
	     		unlink("regress.out");
		}
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(1);
		}
#endif
		exit(1);
	}
}

