/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    O mdulo cria_xlx  responsvel pela criao/atualizao da matriz ZZ,
	realizando os somatrios dos produtos cruzados para cada linha de ob-
	servaes lida do arquivo de entrada; e, imprime as linahs trasnformadas
	de ZZ.
	Chama a rotina idx para calcular o ndice de ZZ.
 	Variaveis de entrada:	
			saida[] para armazenar a linha lida da matriz z
			ndim	dimensao da matriz z'z
			pflag	flag de impressao de linha
	Variaveis de sada:	Nenhuma
	Impressao	imprime as linhas transformadas de z'z

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Snia Ternes Frassetto

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include "regress.h"

static char *sccsid = "@(#)criaxlx.c	3.3	(NTIA/regress)	95/07/25";

void cria_xlx()
{
	int i, j, k;
	double d, e;

	for(i=0; i<ndim; ++i) {
		d = saida[i];
		if (d != 0.0) {
			k = idx(i,0);
			for (j=0; j<=i; ++j) {
				if ((e = saida[j]) != 0.0) {
					xlx[k] += (d*e); /* substitui idx */
				}
				++k;
			/* pois idx(i,j) e' equivalente a soma de k */
			}
		}
	}
	if(pflag) {
		for(i=0; i<ndim-1; ++i)
			printf("%2.0f ", saida[i]);
		printf("%5.2g\n", saida[i]);
	}
}
