/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    O mdulo diagf  responsvel pelo clculo das estatsticas de diagnstico de
	regresso a partir de: 
		ci  : valor da diag. i da "matriz chapeu"
		i   : numero da observacao lida
		res : residuo correspondente a esta observacao

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Snia Ternes Frassetto

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#ifndef VAXVMS
#include <malloc.h>
#endif

#ifdef MSDOS
#include <stdlib.h>
#endif

#include "regress.h"
#include "diagnost.h"
#include "pcsgbd.h" /* Luciana */

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)diagf.c	3.5	(NTIA/regress)	95/07/25";

extern struct Diag  st_ci;
extern struct Diag  st_ri;
extern struct Diag  st_ti;
extern struct Diag   st_di;
extern struct Diag st_df;

extern int fl_dg1;
extern int fl_dg;
extern char *efts[MAXMEM];


void f_ci(k)
unsigned int  k;
{
	if (ci >= st_ci.lim) {
		if ((int) st_ci.ii > st_ci.mem) {
			st_ci.mem += EXPAND;
			st_ci.pts = di_realoc(st_ci.pts,st_ci.mem);
			st_ci.vpt = dd_realoc(st_ci.vpt,st_ci.mem);
		}
		st_ci.pts[st_ci.ii] = k;
		st_ci.vpt[st_ci.ii] = ci;
		++st_ci.ii;
	}
	if (fl_dg1) {
		printf("%15s",rounddec(ci,15,4));
	}
}


double f_ri(k,res)
unsigned int  k;
double res;
{

	double ri;

	ri = res / (s*sqrt(vci));

	if ( (ri >= st_ri.lim) || (ri <= -st_ri.lim) ) {
		if ((int) st_ri.ii > st_ri.mem) {
			st_ri.mem += EXPAND;
			st_ri.pts = di_realoc(st_ri.pts,st_ri.mem);
			st_ri.vpt = dd_realoc(st_ri.vpt,st_ri.mem);
		}
		st_ri.pts[st_ri.ii] = k;
		st_ri.vpt[st_ri.ii] = ri;
		++st_ri.ii;
	}
	if (fl_dg1) {
		printf("%15s",rounddec(ri,15,4));
	}
	return(ri);
}


void f_ti(k,res)
unsigned int  k;
double res;
{

	double ti;

	ti = res/(si*sqrt(vci));

	if ( (ti >= st_ti.lim) || (ti <= -st_ti.lim) ) {
		if ((int) st_ti.ii > st_ti.mem) {
			st_ti.mem += EXPAND;
			st_ti.pts = di_realoc(st_ti.pts,st_ti.mem);
			st_ti.vpt = dd_realoc(st_ti.vpt,st_ti.mem);
		}
		st_ti.pts[st_ti.ii] = k;
		st_ti.vpt[st_ti.ii] = ti;
		++st_ti.ii;
	}
	if (fl_dg1) {
		printf("%15s",rounddec(ti,15,4));
	}
}


void f_dcook(k,res,ri)
unsigned int  k;
double res;
double ri;
{
	double dc;

	dc = (1.0/pp) * (ri*ri) * (ci/vci);

	if ( dc >= st_di.lim ) {
		if ((int) st_di.ii > st_di.mem) {
			st_di.mem += EXPAND;
			st_di.pts = di_realoc(st_di.pts,st_di.mem);
			st_di.vpt = dd_realoc(st_di.vpt,st_di.mem);
		}
		st_di.pts[st_di.ii] = k;
		st_di.vpt[st_di.ii] = dc;
		++st_di.ii;
	}
	if (fl_dg1) {
		printf("%14s",rounddec(dc,14,4));
	}
}


void f_dffits(k,res)
unsigned int  k;
double res;
{
	double df;

	df = (res*sqrt(ci))/(si*vci);

	if ( (df >= st_df.lim) || (df <= -st_df.lim) ){
		if ((int) st_df.ii > st_df.mem) {
			st_df.mem += EXPAND;
			st_df.pts = di_realoc(st_df.pts,st_df.mem);
			st_df.vpt = dd_realoc(st_df.vpt,st_df.mem);
		}
		st_df.pts[st_df.ii] = k;
		st_df.vpt[st_df.ii] = df;
		++st_df.ii;
	}
	if (fl_dg1) {
		printf("%14s",rounddec(df,14,4));
	}
}



void imp_dg(st)
struct Diag st;
{
	extern int fl_int;
	extern int fl_imp;

	int i;

	printf("\n         	Limite : %8.4f\n",st.lim);

	if (st.ii > 0) {
		printf("\n         	Obs         Valor");
		for (i = 0; i < (int) st.ii ; ++i) {
			printf("\n       	      %5d    %10s",st.pts[i],rounddec(st.vpt[i],10,4));
		}
	}
	else {
		printf("\n	 	Nenhum ponto parece ser influente ");
	}

	printf("\n\n");
}

unsigned int *di_realoc(vetor, tam)
unsigned int *vetor;
int    tam;
{
	unsigned int *pt;

	pt = (unsigned int * ) realloc((char *) vetor,
			(unsigned) (tam*(sizeof(unsigned))));
	if ( pt == INULL ) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		fprintf(stderr,"*** MEMORIA ESGOTADA ***\n");
*** */
		fprintf(stderr,PegaMsg(1039));
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(1);
		}
#endif
		exit(1);
	}
	return(pt);
}

double *dd_realoc(vetor, tam)
double *vetor;
int    tam;
{
	double *pt;

	pt = (double *) realloc((char *) vetor,
			(unsigned) (tam*(sizeof(double))));
	if ( pt == DNULL ) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		fprintf(stderr,"*** MEMORIA ESGOTADA ***\n");
*** */
		fprintf(stderr,PegaMsg(1039));
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(1);
		}
#endif
		exit(1);
	}
	return(pt);
}

double *dd_aloc()
{
	double *pt;

	pt = (double *) calloc(TAM,(sizeof(double)));
	if ( pt == DNULL ) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		fprintf(stderr,"*** MEMORIA ESGOTADA ***\n");
*** */
		fprintf(stderr,PegaMsg(1039));
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(1);
		}
#endif
		exit(1);
	}
	return(pt);
}

unsigned int *di_aloc()
{
	unsigned int  *pt;

	pt = (unsigned int  *) calloc(TAM,(sizeof(unsigned int)));
	if ( pt == INULL ) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		fprintf(stderr,"*** MEMORIA ESGOTADA ***\n");
*** */
		fprintf(stderr,PegaMsg(1039));
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(1);
		}
#endif
		exit(1);
	}
	return(pt);
}

void libera()
{
if(fl_dg == 1){
free( st_ci.pts );
free( st_ri.pts );
free( st_di.pts );
free( st_df.pts );
free( st_ti.pts );
free( st_ci.vpt );
free( st_ri.vpt );
free( st_di.vpt );
free( st_df.vpt );
free( st_ti.vpt );
	}
}
