/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    O mdulo diagnost.h  contem a definio das estruturas relacionadas a cada 
		uma das estatisticas usadas no diagnostico de Regressao e a definio
		das funcoes usadas para calculos.
 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Snia Ternes Frassetto

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#ifndef EXTERN
#define EXTERN  extern
#endif

#define EXPAND  100
#define TAM	100
#define INULL   ((unsigned int *) NULL)
#define DNULL   ((double *) NULL)

/* ================= Estrutura Usada  ============================ */

struct Diag {
	double   	lim;		/* limite de comparacao */
	unsigned int 	*pts;		/* pontos influentes */
	double   	*vpt;		/* valor dos pontos influentes */
	unsigned 	ii;		/* total de pontos influentes */
	int		mem;		/* memoria usada */
}; 


/* ================== Variaveis usadas ================================ */

EXTERN int pp;		/* numero de colunas da matriz X */

EXTERN double ci;	/* diagonal da "matriz chapeu" */
EXTERN double vci;	/* raiz quadrada de ci */

EXTERN double sdi;	/* media quadratica dos residuos do modelo sem x[i,] */
EXTERN double si;	/* raiz quadrada de sdi */

EXTERN double s;	/* desvio padrao do modelo */


/* ================== Funcoes usadas ================================ */

#ifdef MSDOS
	extern void   imp_dg(struct Diag);
	extern void   f_ci(unsigned int);
	extern void   f_dcook(unsigned int,double,double);
	extern void   f_dffits(unsigned int,double);
	extern void   f_ti(unsigned int,double);
	extern void   f_dfbetas(unsigned int,double);
	extern double f_ri(unsigned int,double);
	extern void   libera(void);
#else
	extern void   imp_dg();
	extern void   f_ci();
	extern void   f_dcook();
	extern void   f_dffits();
	extern void   f_ti();
	extern double f_ri();
	extern void   libera();
#endif
