/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo expand_mat, a  partir da linha da observao lida, cria 
	a linha da matriz expandida z'z.
	Variveis de entrada:
		ef[][]	 apontador para niveis de efeito
		obs[]	 linha de observacao lida
		nef	 numero de variaveis independentes
		nd	 numero de variaveis dependentes
		fl_int uso do intercepto
	Variveis de sada: 
		saida[]	para armazenar a linha de z'z
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Sonia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdlib.h>
#include "regress.h"

static char *sccsid = "@(#)expand.c	3.2	(NTIA/regress)	95/01/03";

void expand_mat(nd1)
int nd1;
{
	int j,i;
	extern char *obs1[];

	j = fl_int;

	/* coloca variaveis independentes em saida */
	for (i=fl_int+nd1; i<= nd1+nef-!fl_int; ++i) {
		saida[j++]= atof(obs1[ef[i][1]]);
	}

	/* coloca variaveis dependentes em saida */
	for (i=fl_int; i<= (nd1 - !fl_int); ++i) {
		saida[j++]= atof(obs1[ef[i][1]]);
	}
}
