/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo ler_par realiza o parsing do modelo.
	Variveis de sada:
		nv[]	vetor de  niveis
		nf	numero de efeitos
		nd	numero de variaveis dependentes
		sv[]	vetor de soma de niveis
		efts[]	nome dos efeitos
		ef[][]	matriz contendo os numeros dos efeitos
		nxlx	dimensao da matriz x'x
		ndim	dimensao total da matriz z'z
	Variveis auxialiares:	
		v[]	para armazenar nv nos calculos
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maria Fernanda Moura
	  Maurcio Noronha Festa
	  Oscar Ivan Palma Pacheco
        Slvio Roberto Medeiros Evangelista
	  Sonia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/


#include "regress.h"
#include <string.h>
#include "getoken.h"

static char *sccsid = "@(#)lerpar.c	3.4	(NTIA/regress)	97/01/29";

extern ARQ * fd;

void ler_par()
{
	int c;
	char token[128];

	while((c=getoken(token)) != EOF && c!=RB && (strcmpi(token,"mod")!=0)) {
	 	switch (c) {
			case VARIAV:
				if (strcmpi(token,"tl") == 0) {
					token_tl();
				}
				else {
					if (strcmpi(token,"class") == 0) 
						token_class();
					else {
						if (strcmpi(token,"peso") == 0) 
							token_peso(); 
						else
							erro(4);
					}
				}	
				break;
			case PTVG:
				break;
			default:
				erro(4);
				break;
		}
	}
	if (strcmpi(token,"mod") == 0) {
		token_mod(); 
	}
	else {
		/* exit(); Erro: 3258 */
		erro(13);
	}
	
}

void token_tl()
{
	int i = 0;
	int c;

	while ((c = xgetc(stdin)) == ' ' || c == '\t' 
		|| c == '\n' || c == '\r')
		;
	while ( c != ';' && i < 127) {
		titulo[i++] = (char) c;
		c = xgetc(stdin);
	}
	titulo[i] = 0;
}

void token_mod()
{
	int j, i;
	int c;
	double mmin;
	double mmax;
	char nome[15];
	char token[128];
	char tipo;
	long ret;

	nd = 0;
	nef= 0;
	if (fl_int) {
		nv[0] = 1;
		sv[0] = 0;
		ef[0][0] = -2;
		strcpy(p,"cl");
		efts[0] = p;
		p += (strlen(p)+1);
	}

	while ( (c = getoken(token)) != IGUAL ) {
		if (c != VARIAV)
			erro(5);		/* Esperava uma variavel */

		if ((i = veri_var(fd, token)) < 0) 
			erro(3);		/* Variavel nao existe */
	
		if( (ret=(long)pega_var(fd,i,nome,&tipo,(MINVAL *) &mmin,(MAXVAL *)&mmax)) < 0L){
                	fprintf(stderr, PegaMsg(1062));
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                	setOSstdin();
                	exit(2);
                }
		if (tipo != 'n')
			erro(8);

		strcpy(p,token);
		efts[fl_int+nd] = p;
		p += (strlen(p) + 1);

		if (nd >= MAXDEP)
			erro(10);
		ef[fl_int+nd][0]= -2;/* Tipo da variavel (Dependente) */
		ef[fl_int+nd][1]= i;	/* Posicao da variavel no arquivo */
		nd++;
	}

	if ( c != IGUAL) 
		erro(6);		/* Esperava simbolo '=' */
	
	c = getoken(token);
	if (c != VARIAV)
		erro(5);		/* Esperava uma variavel */

	while( c != PTVG) {
		if ( c != VARIAV)
			erro(5);	/* Token invalido */

		if ((i = veri_var(fd, token)) < 0) 
			erro(3);		/* Variavel nao existe */
		
		if( ( ret=(long)pega_var(fd,i,nome,&tipo,(MINVAL *) &mmin,(MAXVAL *)&mmax)) < 0L){
                	fprintf(stderr, PegaMsg(1062));
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                	setOSstdin();
                	exit(2);
                }
		if (tipo != 'n')
			erro(8);

		strcpy(p,token);
		efts[nef+nd+fl_int] = p;
		p += (strlen(p) + 1);
		ef[nef+nd+fl_int][0] = -1;	/*Tipo da variavel (indep) */
		ef[nef+nd+fl_int][1]= i;	/* Posicao da variavel */
		nef++;
		c = getoken(token);
	}


	j = fl_int;
	for(i = ((nd+1)-!fl_int); i < nd+nef+fl_int; ++i) {
		nv[i] = 1;
		sv[i] = j;
		j += nv[i];
	}

	for(c = 0; c < nd; c++) {
		nv[c+fl_int] = 1;
		sv[c+fl_int] = j++;
	}
	sv[i] = j;

	nxlx = j - nd;
	ndim = j;
	if (ndim>=MAXMEM)
		erro(0);
	if (pflag)
		print_par();
}

void token_class()
{
	extern ARQ *fd;

	int i;
	int c;
	char token[128];
	double mmin,mmax;
	char tipo;
	char nome[16];
	long ret;

	nby = 0;

	c = getoken(token);
	if (c != VARIAV)
		erro(5);		/* Esperava uma variavel */

	if ((i = veri_var(fd, token)) < 0) 
		erro(3);		/* Variavel nao existe */
	
	strcpy(p,token);
	
	if (nby >= MAXCLASS)
		erro(11);		/* Ultrapassou o limite */
	
	efts_by[nby] = p;
	p += (strlen(p) + 1);
	ef_by[nby]= i;		/* Posicao da variavel no arquivo */

	if( (ret=(long)pega_var(fd,i,nome,&tipo,(MINVAL *) &mmin,(MAXVAL *) &mmax)) < 0L){
                fprintf(stderr, PegaMsg(1062));
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                setOSstdin();
                exit(2);
                }
	if ( tipo == 'n')
		tip_by[nby++] = 1;	/* tipo numerica */
	else if (tipo == 'd')		/* tipo data */
		tip_by[nby++] = 2;
	else
		tip_by[nby++] = 0;	/* tipo alfa */
	
	while( ((c=getoken(token)) != PTVG) && (strcmpi(token,"ord")!=0)) {
		if ( c != VARIAV)
			erro(5);	/* Token invalido */

		if ((i = veri_var(fd, token)) < 0) 
			erro(3);	/* Variavel nao existe */
		
		strcpy(p,token);
		efts_by[nby] = p;
		p += (strlen(p) + 1);
		ef_by[nby]= i;	/* Posicao da variavel */

		if( (ret=(long)pega_var(fd,i,nome,&tipo,(MINVAL *) &mmin,(MAXVAL *) &mmax)) < 0L){
                	fprintf(stderr, PegaMsg(1062));
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                	setOSstdin();
                	exit(2);
                }
		if ( tipo == 'n')
			tip_by[nby++] = 1;	/* tipo numerica */
/* OSCAR: Ate' a marca. */
		else if (tipo == 'd')		/* tipo data */
			tip_by[nby++] = 2;
/* XXXXXXXXXXXXXXXXXXXX */
		else
			tip_by[nby++] = 0;	/* tipo alfa */
	}

	if (strcmpi(token,"ord")==0) {
		c = getoken(token);
		if ( c != IGUAL ) {
			erro(6);
		}
		else {
			c = getoken(token);
			if( strcmpi(token,"asc") == 0 ) {
				ordc=1; 	/* ordem ascendente */
			}
			else {
				if (strcmpi(token,"desc")==0)
					ordc=0; 	/* ordem descendente */
				else
					erro(12); /* opcao invalida no class */
			}
			if ( (c=getoken(token)) != PTVG)
					erro(7); /* Falta ';' */
		}
	}
}

void token_peso()
{
	extern int fl_wt;

	int i;
	int c;
	double mmin;
	double mmax;
	char nome[15];
	char token[128];
	char tipo;
	long ret;

	fl_wt = 1;

	c = getoken(token);
	if (c != VARIAV)
		erro(5);		/* Esperava uma variavel */

	if ((i = veri_var(fd, token)) < 0) 
		erro(3);		/* Variavel nao existe */

	if( (ret=(long)pega_var(fd,i,nome,&tipo,(MINVAL *) &mmin,(MAXVAL *)&mmax)) < 0L){
                fprintf(stderr, PegaMsg(1062));
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                setOSstdin();
                exit(2);
                }
	if (tipo != 'n')
		erro(8);
	
	strcpy(p,token);
	efts_wt = p;
	p += (strlen(p) + 1);
	ef_wt = i;		/* Posicao da variavel no arquivo */
	c=getoken(token) ;
	if (c != PTVG) 
		erro(7);
	
}
