/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo outhdr1  responsvel pela gerao do header do arquivo de sada.
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Sonia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <stdlib.h>

#include "regress.h"
#include "pcsgbd.h" /* Luciana */

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)outhdr1.c	3.4	(NTIA/regress)	95/01/11";
extern ARQ *fd;

void outhdr1()
{
	int i;
	char tipo;
	double mmin;
	double mmax;
	char temp[15];
	char tmpbuf[128]; /* Luciana */
	int ret;	  /* Luciana */

 	for(i=0; i < nby; ++i) {
		if( ret=(long)pega_var(fd,ef_by[i],temp,&tipo,(MINVAL *)&mmin,(MAXVAL *)&mmax) < 0L){
                fprintf(stderr, PegaMsg(1062));
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                setOSstdin();
                exit(2);
                }
		if (ret = def_var(fe,temp,tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
			printf("Erro: nao pode criar mais variaveis");
*** */
			sprintf(tmpbuf,PegaMsg(1013),temp,ret);
			printf(tmpbuf);
			setOSstdin();
#ifdef  MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("regress");
				exit(100);
			}
#endif

			exit(100);
		}
	}

	tipo = 'n';
	if (ret = def_var(fe,efts[fl_int],tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		printf("Erro: nao pode criar mais variaveis");
*** */
		sprintf(tmpbuf,PegaMsg(1013),efts[fl_int],ret);
		printf(tmpbuf);
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(100);
		}
#endif
		exit(100);
	}
	
	if (ret = def_var(fe,"vest",tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		printf("Erro: nao pode criar mais variaveis");
*** */
		sprintf(tmpbuf,PegaMsg(1013),"vest",ret);
		printf(tmpbuf);
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(100);
		}
#endif
		exit(100);
	}
	if (ret = def_var(fe,"vres",tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		printf("Erro: nao pode criar mais variaveis");
*** */
		sprintf(tmpbuf,PegaMsg(1013),"vres",ret);
		printf(tmpbuf);
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(100);
		}
#endif
		exit(100);
	}
	if (ret = def_var(fe,"vdp",tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		printf("Erro: nao pode criar mais variaveis");
*** */
		sprintf(tmpbuf,PegaMsg(1013),"vdp",ret);
		printf(tmpbuf);
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(100);
		}
#endif
		exit(100);
	}
	if (ret = def_var(fe,"vinf",tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		printf("Erro: nao pode criar mais variaveis");
*** */
		sprintf(tmpbuf,PegaMsg(1013),"vinf",ret);
		printf(tmpbuf);
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(100);
		}
#endif
		exit(100);
	}
	if (ret = def_var(fe,"vsup",tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		printf("Erro: nao pode criar mais variaveis");
*** */
		sprintf(tmpbuf,PegaMsg(1013),"vsup",ret);
		printf(tmpbuf);
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(100);
		}
#endif
		exit(100);
	}
	

	for(i=0; i < ndim; ++i) {
		if (ef[i][0] == -1) {
			if (ret = def_var(fe,efts[i],tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
				printf("Erro: nao pode criar mais variaveis");
*** */
				sprintf(tmpbuf,PegaMsg(1013),efts[i],ret);
				printf(tmpbuf);
				setOSstdin();
#ifdef  MEM_DEBUG
				if (Mem_Used() != 0) {
					printf("*** Lista de memoria nao esta' vazia ***\n");
					Mem_Store("regress");
					exit(100);
				}
#endif
				exit(100);
			}
		}
	}
}

