/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo printbeta grava o vetor dos parmetros estimados (vetor Beta).  
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Sonia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include <string.h>
#include <stdlib.h>

#include "regress.h"
#include "pcsgbd.h" /* Luciana */

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)printbet.c	3.4	(NTIA/regress)	95/01/11";

static	char *obs3[OBSSIZE];
extern ARQ* fd;

void printbeta(par,ndim1)
int par;	/* indice da var. dep. sendo analisada */
int ndim1;	/* dimensao de z'z */
{
	int i=0;
	int k;	  
	extern char *pchar;
	extern char obs2[20][80];
	long ret;

	/* gravar variaveis de classe */
	for(i=0; i<nby ; ++i) {
		obs3[i] = pchar;
		strcpy(pchar,obs2[i]);
		pchar += (strlen(pchar)+1);
	}

	/* gravar nome da var. dependente */
	obs3[i] = pchar;
	strcpy(pchar,efts[fl_int + par]);
	pchar += (strlen(pchar)+1);

	/* gravar valores dos betas */
	k = 1;	/* controle da observacao no ponteiro */
	for (i=0; i<ndim1; ++i) {
		if (ef[i][0] == -1 || (i == 0 && fl_int)) {
			obs3[nby+k] = pchar;
			gcvt(xlx[idx(nxlx,sv[i])],15,pchar);
			pchar += (strlen(pchar) + 1);
			++k; 
		}
	}
	if( (ret=grav_obs(fb,obs3)) < 0L){
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                fprintf(stderr, PegaMsg(5018), "");
                setOSstdin();
                exit(2);
        }
}

void outhdr(ndep,ndim1)
int ndep;
int ndim1;
{
	int i,j;
	char tipo;
	double mmin;
	double mmax;
	char nome[15];
	char temp[15];
	char tmpbuf[128]; /* Luciana */
	int ret;	  /* Luciana */

	/* nome das var. de classe */
 	for(i=0; i < nby; ++i) {
		if((ret=(long)pega_var(fd,ef_by[i],nome,&tipo,(MINVAL *)&mmin,(MAXVAL *)&mmax)) < 0L){
                	fprintf(stderr, PegaMsg(1062));
#ifdef  MEM_DEBUG
                if (Mem_Used() != 0) {
                        printf("*** Lista de memoria nao esta' vazia ***\n");
                        Mem_Store("regress");
                        exit(2);
                }
#endif
                	setOSstdin();
                	exit(2);
                	}
		if (ret = def_var(fb,nome,tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
			printf("Erro: nao pode criar mais variaveis");
*** */
			sprintf(tmpbuf,PegaMsg(1013),nome,ret);
			printf(tmpbuf);
			setOSstdin();
#ifdef  MEM_DEBUG
			if (Mem_Used() != 0) {
				printf("*** Lista de memoria nao esta' vazia ***\n");
				Mem_Store("regress");
				exit(100);
			}
#endif

			exit(100);
		}
	}

	/* nome das var. dependentes */
	tipo = 'c';
	if (ret = def_var(fb,"vardep",tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
		printf("Erro: nao pode criar mais variaveis");
*** */
		sprintf(tmpbuf,PegaMsg(1013),"vardep",ret);
		printf(tmpbuf);
		setOSstdin();
#ifdef  MEM_DEBUG
		if (Mem_Used() != 0) {
			printf("*** Lista de memoria nao esta' vazia ***\n");
			Mem_Store("regress");
			exit(100);
		}
#endif
		exit(100);
	}
	
	/* nome dos betas */
	j = 0;
	for(i=0; i < ndim1; ++i) {
		tipo = 'n';
		if (ef[i][0] == -1 || (i == 0 && fl_int)) {
			if (i == 0 && fl_int)
				strcpy(nome,"b0");
			else {
				++j;
				strcpy(nome,"b");
				itoa(j,temp,10);
				strcat(nome,temp);
			}
			if (ret = def_var(fb,nome,tipo) == -1) {

/* *** Padroniz. msg erro - Luciana 20/12/94
				printf("Erro: nao pode criar mais variaveis");
*** */
				sprintf(tmpbuf,PegaMsg(1013),nome,ret);
				printf(tmpbuf);
				setOSstdin();
#ifdef  MEM_DEBUG
				if (Mem_Used() != 0) {
					printf("*** Lista de memoria nao esta' vazia ***\n");
					Mem_Store("regress");
					exit(100);
				}
#endif
				exit(100);
			}
		}
	}
}

