/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	O mdulo printcov imprime a todas as estimativas dos parmetros.  
 
Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Sonia Ternes

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#include "regress.h"

static char *sccsid = "@(#)printcov.c	3.3	(NTIA/regress)	95/07/25";


void printcov(par,nd1)
int par;	/* indice da var. indep. em analise */
int nd1;
{
	int i, temcov=1;
	double dp;		/* desvio padrao */
	double x1, x2;		/* variavel auxiliar */
	double x3;		/* variavel auxiliar */
	double valorF;		/* valor de f ao quadrado */
	extern double squad;
	extern double media2[MAXDEP];

	for (i=0; i<=nef+nd1-!fl_int; ++i) {
		if ((ef[i][0] == -1) || (i == 0 && fl_int)) {
			x1 = qmr;
			valorF = 0.0;
			if (x1 > 1.0e-14)
				valorF = obs[i] / x1;	/* obs=qm */
                        if (temcov == 1) { 
                                printf("\n");
                                printf("Parametro                   Estimativa    Desvio Padrao  Valor |T| PR > |T|\n\n");
                                temcov = 0;
                        }
			x1 = xlx[idx(nxlx,sv[i])];
			x2 = sqrt(valorF);
			if (fabs(x2) < 1.0e-14)
				x2 = 0.0;
			else
				x2 = fabs(x1) / x2;
			if (i == 0 && fl_int)
				printf("%-20s ","Coef. linear");
			else
				printf("%-20s ",efts[i]);
			x3 = sqrt(valorF);
			if (x3 > 10000.)
				x3 = 9999.9999;
			printf("%17s %16s  %9s   %6.3f\n",
				rounddec(x1,17,8) , rounddec(x2,16,8) , rounddec(x3,9,4),
				fprob(valorF,(double) nv[i],(double) glr));
		}
	}
	printf("\n");
	printf("------------------------------------------------------------------------------\n");

	dp = sqrt(qmr);				/* desvio padrao */

	x1 = squad -  sse[par][nef+nd-1];	

	printf(" Media                    : %14.7g\n", media2[par]);
	printf(" Raiz Quad. QMres.        : %14.7g\n", dp);
	printf(" Coef. Variacao           : %14.7g\n", dp*100.0/media2[par]);
	printf(" Coef. Determinacao       : %14.7g\n",(x1/squad)); 
	printf(" Coef. Determinacao Ajust.: %14.7g\n", (1.0-(1.0-(x1/squad))*(glt-fl_int)/glr) ); 
    

}
