

/***********************************************************************************
 REGRESS - Anlise de Regresso Linear Univariada

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

    Este  o principal mdulo de definio de funes e variveis globais do 
	software de anlise de regresso linear univariada. 

 Desenvolvido por:

	  Dalton Francisco Andrade
	  Maurcio Noronha Festa
        Slvio Roberto Medeiros Evangelista
	  Snia Ternes Frassetto

 Informaes do CVS:
        $Source:
        $Revision:
        $Date:

***********************************************************************************/

#ifndef EXTERN
# define	EXTERN	extern
#endif

#define NRO_OBS(parq) (parq->proxobs)	 /* Numero atualizado de observacoes */

#ifdef MSDOS
# define MY_HUGE	huge
# define TIPO		long
# define HALLOC		halloc
# define HFREE		hfree
# define TINT		unsigned
#else
# define MY_HUGE
# define TIPO		unsigned
# define HALLOC		calloc
# define HFREE		free
# define TINT		int
#endif

#include <stdio.h>
#include <math.h>

#if !defined(VAXVMS) & !defined(SCO) & !defined(i486)
#include <search.h>
#endif

#include "pcsgbd.h"

#define MAXMEM		100
#define MAXMEM1		MAXMEM-1
#define MAXCLASS 	8
#define MAXDEP   	10
#define EPS   		1.e-15

EXTERN ARQ 		*fb;		/* apontador para o arquivo de dados */
EXTERN ARQ 		*fe;		/* apontador para o arquivo de dados */
EXTERN ARQ		*fd;		/* apontador para o arquivo de dados */
EXTERN char  		buffer[128];
EXTERN int		nf;		/* numero de fatores */
EXTERN int		nby;		/* numero de variaveis by */
EXTERN int		nd;		/* numero variaveis dependentes (Y) */
EXTERN int		nxlx;		/* dimensao da matriz x'x */
EXTERN int		ndim;		/* dimensao da matriz z'z */
EXTERN int		nef;		/* numero de efeitos */
EXTERN int		glr;		/* graus de liberdade do residuo */
EXTERN int		glt;		/* graus de liberdade do total */
EXTERN double		qmr;		/* quadrado medio do erro */
EXTERN char		*efts_by[MAXCLASS];
					/* apontador para nome variaveis by */
EXTERN int		ef_wt; 		/* posicao da variavel peso */
EXTERN char		*efts_wt;
					/* apontador para nome variavel wt */
EXTERN int		ef_by[MAXCLASS]; /* posicao das variaveis by */
EXTERN int		tip_by[MAXCLASS]; /* tipo das variaveis by */
					/* 1 = numerica ; 0 = alfa */

EXTERN int		ef[MAXMEM1][2];	/* par de efeitos */
EXTERN int		nv[MAXMEM1];	/* numero de niveis */
EXTERN int		sv[MAXMEM1];	/* soma dos niveis */
EXTERN int		v[MAXMEM1];	/* */
EXTERN double		saida[5*MAXMEM];	/* saida de cada observacao */
EXTERN double		css[MAXMEM];	/* corrected sum of squares */
EXTERN double		mean[MAXMEM];	/* media das observacoes */
EXTERN double		sse[MAXDEP][MAXMEM];	/* sum squares of error */
EXTERN double MY_HUGE	*xlx;		/* matriz z'z */
EXTERN double 		obs[MAXMEM];
EXTERN char		area[1024];	/* area para quardar strings */
EXTERN char		titulo[128];	/* titulo geral do programa */
EXTERN char		*efts[MAXMEM];
					/* apontador para area, onde ficam
						os nomes dos efeitos */
EXTERN int		linhazerada[MAXMEM1];
					/* vetor que indica a linha zerada */
extern char		*p;		/* ponteiro para a area nao usada */

extern int		pflag;		/* impressao de leitura */
extern int		xflag;		/* impressao de x'x */
extern int		lflag;		/* impressao de dados originais */
extern int		rflag;		/* impressao de passos de calculo */
extern int		bflag;		/* imprimir beta */
extern int		fl_int;		/* Usar intercpeto ou nao */
extern int		ordc;		/* Ordenacao do class */

#ifdef MSDOS

 extern double	calc_cor(int, int);
 extern double	calc_pv(double);
 extern int	class(void);
 extern void	contraste(int, FILE *, int);
 extern void	cria_xlx(void);
 extern double	cxlxcl(void);
 extern double	*dd_aloc(void);
 extern double	*dd_realoc(double *, int);
 extern unsigned int *di_realoc(unsigned int *, int);
 extern unsigned int *di_aloc(void);
 extern void	diagnostico(int, int, int, double);
 extern double	doolitle(double *, int);
 extern void	erro(int);
 extern void	erroclass(void);
 extern void	errocon(int, int);
 extern int	executa(int, int);
 extern void	expand_mat(int);
 extern void	getarg(int, char **);
 extern TINT	idx(int, int);
 extern TINT	idy(int, int);
 extern void	imp_titulo(char *);
 extern void	imprime(void);
 extern void	ini_niveis(void);
 extern void	inicializa(void);
 extern void	inicioby(void);
 extern void	ler_par(void);
 extern int	missing(void);
 extern int	number(double *, char **, int *);
 extern void	outhdr(int, int);
 extern void	outhdr1(void);
 extern void	padroniza(void);
 extern void	pivota(void);
 extern void	pondera(int);
 extern void	print_par(void);
 extern void	print_xlx(void);
 extern int	printanv(int, int);
 extern void	printbeta(int, int);
 extern void	printcov(int, int);
 extern void	printest(int, int, int, int, double *);
 extern void	prtcor(void);
 extern void	prtdes(int);
 extern void	putchr1(void);
 extern double	residuo(int, int);
 extern void	sweep(int);
 extern void	token_class(void);
 extern void	token_mod(void);
 extern void	token_peso(void);
 extern void	token_tl(void);
 extern void	troca(int);
 extern void	usage(void);
 extern void	vol_niveis(void);
 extern void	x_calc(int);
 extern double	x_ixlx_xl(void);
 extern void	zera_linha(int);

#else

 extern double	calc_cor();
 extern double	calc_pv();
 extern int	class();
 extern void	contraste();
 extern void	cria_xlx();
 extern double	cxlxcl();
 extern double	*dd_aloc();
 extern double	*dd_realoc();
 extern unsigned int *di_aloc();
 extern unsigned int *di_realoc();
 extern void	diagnostico();
 extern double	doolitle();
 extern void	erro();
 extern void	erroclass();
 extern void	errocon();
 extern int	executa();
 extern void	expand_mat();
 extern char	*gcvt();
 extern void	getarg();
 extern TINT	idx();
 extern TINT	idy();
 extern void	imp_titulo();
 extern void	imprime();
 extern void	ini_niveis();
 extern void	inicializa();
 extern void	inicioby();
 extern void	ler_par();
 extern int	missing();
 extern int	number();
 extern void	outhdr();
 extern void	outhdr1();
 extern void	padroniza();
 extern void	pivota();
 extern void	pondera();
 extern void	print_par();
 extern void	print_xlx();
 extern int	printanv();
 extern void	printbeta();
 extern void	printcov();
 extern void	printest();
 extern void	prtcor();
 extern void	prtdes();
 extern void	putchr1();
 extern double	residuo();
 extern void	sweep();
 extern void	token_class();
 extern void	token_mod();
 extern void	token_peso();
 extern void	token_tl();
 extern void	troca();
 extern void	usage();
 extern void	vol_niveis();
 extern void	x_calc();
 extern double	x_ixlx_xl();
 extern void	zera_linha();

#endif

