
/***********************************************************************************
 SPLINE - Gera valores atravs de interpolaes via Mtodo Spline Cbico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/spline/fontes/getpar.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:12:01 $:

***********************************************************************************/

#include <stdlib.h>
#include <signal.h>

#include "spline.h"
#include "pcsgbd.h"		/* Luciana */
#include <string.h>
/*#include "lockfile.h"*/

static char *sccsid = "@(#)getpar.c	3.15	(NTIA/spline)	95/09/20";

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

extern int flagX;
extern int flagP;
extern int nlins;
extern int ncols;
static int flag_exec = 0;
extern void controlC();


extern int descarq[2];
extern char exretstd[];
extern int flagstd;

void getpar(argc, argv)
int argc;
char *argv[];
{
    int i;
    char *pdir;
    char pout[TAMSTR];
    long ret;
    char namelock[TAMSTR];


    ++argv;			/* aponta para o primeiro parametro */
    --argc;
    flagX = 1;
    while (argc--) {
	if (argv[0][0] == '-') {
	    for (i = 1; argv[0][i]; ++i) {
		switch (argv[0][i]) {

		case 'A':
		    flag_exec = 1;
#ifdef RS6000
		    flagstd = 1;
		    if (*strchr(&argv[0][i + 1], '|'))
			*strchr(&argv[0][i + 1], '|') = '\0';

		    if (freopen(&argv[0][i + 1], "r", stdin) ==
			(FILE *) NULL) {

/* *** Padroniz. msg erro - Luciana 19/12/94
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
			fprintf(stderr, PegaMsg(1034), "stdin");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("***Lista de memoria nao esta vazia ***\n");
			    Mem_Store("spline");
			    exit(5);
			}
#endif
			exit(5);
		    }
		    i += (strlen(&argv[0][i + 1]) + 1);

		    *strchr(&argv[0][i + 1], '|') = '\0';
		    fseek(stdin, atol(&argv[0][i + 1]), 0);

		    i += (strlen(&argv[0][i + 1]) + 1);
		    strcpy(exretstd, &argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

#endif
		    setbuf(stdin, (char *) NULL);

		    break;

		case 'X':

		    if (strcmp(&argv[0][i + 1], "ntia") == 0) {
			flagX = 1;
			i += 4;
		    }

		    break;

		case 'a':

		    auta = 1;

		    if (!number(&dx, argv, &i))
			dx = (float) 1.;

		    break;

		case 'i':

		    flag_id = 1;

		    break;

		case 'k':

		    number(&konst, argv, &i);

		    break;

		case 'n':

		    number(&ni, argv, &i);

		    break;

		case 'p':

		    periodic = 1;

		    break;

		case 'P':

		    flagP = 1;

		    break;

		    /*
		     ** Habilita impressao de mensagens
		     */

		case 'M':

		    break;

		    /*
		     ** Habilita impressao de tempo
		     */

		case 't':

		    break;

		case 'x':
		    if (!number(&x.lb, argv, &i))
			break;

		    x.lbf = 1;
		    ++i;

		    if (!number(&x.ub, argv, &i)) {
			--i;

			break;
		    }

		    x.ubf = 1;
		    break;

		case 'l':

		    nlins = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

		    break;

		case 'c':

		    ncols = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

		    break;

		default:

/* *** Padroniz. msg erro - Luciana 19/12/94
					printf("Flag <%c> ilegal\n",argv[0][1]);
*** */
		    printf(PegaMsg(3086), argv[0][1]);
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf("***Lista de memoria nao esta vazia ***\n");
			Mem_Store("spline");
			exit(1);
		    }
#endif

		    exit(1);
		}
	    }
	}

	else {
	    break;
	}

	++argv;
    }

    if (!flagX) {

/* *** Padroniz. msg erro - Luciana 19/12/94
		fprintf(stderr, "Execucao nao permitida\n");
*** */
	fprintf(stderr, PegaMsg(1000));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("spline");
	    exit(1);
	}
#endif

	exit(1);
    }

    if (argc < 0)
	usage();

    pdir = pega_env(argv[0], ".hdr");

    /* Bloqueio de escrita do arquivo de entrada */
    strcpy(namelock, pdir);
    strcat(namelock, ".dat");

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("spline");
	exit(5);
    }
#endif
    /* Abertura do arquivo de entrada */
    if ((ret = (long) (fd = abre_arq(pdir, 0, 1))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Luciana 19/12/94
		fprintf(stderr,"Nao consegui abrir <%s> %ld\n", pdir, ret);
*** */
	fprintf(stderr, PegaMsg(1034), pdir);
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("spline");
	    exit(2);
	}
#endif

	exit(2);
    }

    if (argc == 0)
	strcpy(pout, "spline");
    else
	strcpy(pout, argv[1]);

    /* Bloqueio de escrita do arquivo de saida */
    strcpy(namelock, pout);
    strcat(namelock, ".dat");

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("*** Lista de memoria nao esta' vazia ***\n");
	Mem_Store("spline");
	exit(5);
    }
#endif

    /* Abertura do arquivo de saida */
    if ((ret = (long) (fout = cria_arq(pout))) < 0L && ret > -4L) {

/* *** Padroniz. msg erro - Luciana 19/12/94
                fprintf(stderr,"Nao consegui abrir <%s> %ld\n", pout , ret);
*** */
	fprintf(stderr, PegaMsg(5006), pout);
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia * **\n");
	    Mem_Store("spline");
	    exit(2);
	}
#endif

	exit(2);
    }

    signal(SIGINT, controlC);

}


number(alfa, argv, k)
float *alfa;
char *argv[];
int *k;
{
    int j, i;
    char s[80];
    j = 0;
    i = (*k);
    for (i = i + 1;; ++i) {
	switch (argv[0][i]) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case '.':
	case '+':
	case '-':
	case 'E':
	    s[j++] = argv[0][i];
	    break;
	default:
	    s[j] = '\0';
	    *alfa = (float) atof(s);
	    --i;
	    (*k) = i;
	    if (s[0] == '\0')
		return (0);
	    else
		return (1);
	    break;
	}
    }
}

void usage()
{

/* *** Padroniz. msg erro - Luciana 19/12/94
	fprintf(stderr,"Falta nome de arquivo\n");
*** */
    fprintf(stderr, PegaMsg(3000));

    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("spline");
	exit(1);
    }
#endif
    exit(1);
}


void controlC(sig)
int sig;
{
    /*
     ** Apagar, se necessario, arquivos temporarios
     */

    if (!flag_exec)
	fprintf(stderr, "\n********  Interrompido pelo usuario\n");
    /* Desbloqueio dos arquivos */

    if (descarq[0] != -1) {
	/*UnlockAFile(descarq[0]); */
    }
    if (descarq[1] != -1) {
	/*UnlockAFile(descarq[1]); */
    }


    setOSstdin();

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Men_Store("nome_modulo");
	exit(1);
    }
#endif
    exit(sig);
}
