
/***********************************************************************************
 SPLINE - Gera valores atravs de interpolaes via Mtodo Spline Cbico

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Modulo para suavizar curvas pelo metodo Spline.

 Desenvolvido por:

	Dalton Francisco Andrade
	Sonia Ternes
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/spline/fontes/spline.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:12:01 $:

***********************************************************************************/

#include <string.h>
#include <stdlib.h>
#include <malloc.h>

#define  VAR1
#include "spline.h"
#include "pcsgbd.h"		/* Luciana */
/*#include "lockfile.h"*/

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)spline.c	3.9	(NTIA/spline)	95/07/27";


int flagX = 0;
int flagP = 0;
#ifdef MSDOS
int nlins = 25;
#else
int nlins = 24;
#endif
int ncols = 80;

int descarq[2];			/* descritor de arquivo para funcoes de bloqueio */

float rhs(i)
int i;
{
    int i_;
    float zz;

    i_ = i == n - 1 ? 0 : i;
    zz = (y.val[i] - y.val[i - 1]) / (x.val[i] - x.val[i - 1]);
    return (6 *
	    ((y.val[i_ + 1] - y.val[i_]) / (x.val[i + 1] - x.val[i]) -
	     zz));
}

spline()
{
    float d, s, u, v, hi, hi1;
    float h;
    float D2yi, D2yi1, D2yn1, x0, x1, yy, a;
    int end;
    float corr;
    int i, j, m, l;
    long ret;

    if (n < 3)
	return (0);
    if (periodic)
	konst = (float) 0.;
    d = (float) 1.;
    r[0] = (float) 0.;
    s = periodic ? -(float) 1. : (float) 0.;
    for (i = 0; ++i < n - !periodic;) {	/* triangularize */
	hi = x.val[i] - x.val[i - 1];
	hi1 = i == n - 1 ? x.val[1] - x.val[0] : x.val[i + 1] - x.val[i];
	if (hi1 * hi <= (float) 0.)
	    return (0);
	u = i == 1 ? zero : u - s * s / d;
	v = i == 1 ? zero : v - s * r[i - 1] / d;
	r[i] = rhs(i) - hi * r[i - 1] / d;
	s = -hi * s / d;
	a = 2 * (hi + hi1);
	if (i == 1)
	    a += konst * hi;
	if (i == n - 2)
	    a += konst * hi1;
	diag[i] = d = i == 1 ? a : a - hi * hi / d;
    }
    D2yi = D2yn1 = (float) 0.;
    for (i = n - !periodic; --i >= 0;) {	/* back substitute */
	end = i == n - 1;
	hi1 = end ? x.val[1] - x.val[0] : x.val[i + 1] - x.val[i];
	D2yi1 = D2yi;
	if (i > 0) {
	    hi = x.val[i] - x.val[i - 1];
	    corr = end ? 2 * s + u : zero;
	    D2yi = (end * v + r[i] - hi1 * D2yi1 - s * D2yn1) /
		(diag[i] + corr);
	    if (end)
		D2yn1 = D2yi;
	    if (i > 1) {
		a = 2 * (hi + hi1);
		if (i == 1)
		    a += konst * hi;
		if (i == n - 2)
		    a += konst * hi1;
		d = diag[i - 1];
		s = -s * d / hi;
	    }
	} else
	    D2yi = D2yn1;
	if (!periodic) {
	    if (i == 0)
		D2yi = konst * D2yi1;
	    if (i == n - 2)
		D2yi1 = konst * D2yi;
	}
	if (end)
	    continue;
	m = (int) (hi1 > (float) 0. ? ni : -ni);
	m = (int) ((float) 1.001 * (float) m * hi1 / (x.ub - x.lb));
	if (m <= 0)
	    m = 1;
	h = hi1 / m;
	for (j = m; j > 0 || i == 0 && j == 0; j--) {	/* interpolate */
	    x0 = (m - j) * h / hi1;
	    x1 = j * h / hi1;
	    yy = D2yi * (x0 - x0 * x0 * x0) + D2yi1 * (x1 - x1 * x1 * x1);
	    yy = y.val[i] * x0 + y.val[i + 1] * x1 - hi1 * hi1 * yy / 6;

	    obs2[0] = pchar;
	    gcvt(x.val[i] + j * h, 15, pchar);
	    pchar += (strlen(pchar) + 1);

	    obs2[1] = pchar;
	    gcvt(yy, 15, pchar);
	    pchar += (strlen(pchar) + 1);

	    if (flag_id) {
		if (j == m || (i == 0 && j == 0)) {
		    l = (i == 0 && j == 0) ? 0 : 1;
		    obs2[2] = pchar;
		    gcvt(x.val[i + l], 15, pchar);
		    pchar += (strlen(pchar) + 1);

		    obs2[3] = pchar;
		    gcvt(y.val[i + l], 15, pchar);
		    pchar += (strlen(pchar) + 1);
		} else {
		    obs2[2] = pchar;
		    strcpy(pchar, ".");
		    pchar += (strlen(pchar) + 1);

		    obs2[3] = pchar;
		    strcpy(pchar, ".");
		    pchar += (strlen(pchar) + 1);
		}
	    }
	    if ((ret = grav_obs(fout, obs2)) < 0L) {
		fprintf(stderr, PegaMsg(5018), "");
#ifdef MEM_DEBUG
		if (Mem_Used() != 0) {
		    printf("***Lista de memoria nao esta vazia ***\n");
		    Mem_Store("spline");
		    exit(5);
		}
#endif
		setOSstdin();
		exit(2);
	    }
	    pchar = obser;

	}
    }
    return (1);
}

void getlim(p)
struct proj *p;
{
    int i;
    for (i = 0; i < n; i++) {
	if (!p->lbf && p->lb > (p->val[i]))
	    p->lb = p->val[i];
	if (!p->ubf && p->ub < (p->val[i]))
	    p->ub = p->val[i];
    }
}

main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{

    int i;
    long ret;

    /* Inicializacao dos descritores */
    descarq[0] = -1;
    descarq[1] = -1;


#ifdef VAXVMS
    argc = prepvax(argc, argv);
#endif

    pchar = obser;
    dx = (float) 1.0;
    ni = (float) 100.0;
    konst = (float) 0.0;
    zero = (float) 0.0;
    auta = 0;
    periodic = 0;
    flag_id = 0;

    x.lbf = x.ubf = y.lbf = y.ubf = 0;
    x.lb = (float) INF;
    x.ub = -(float) INF;
    y.lb = (float) INF;
    y.ub = -(float) INF;
    getpar(argc, argv);
    semantica();
    outhdr();
    if (auta && !x.lbf)
	x.lb = (float) 0.;
    lerobs();
    getlim(&x);
    getlim(&y);
    i = (n + 1) * sizeof(dx);
    diag = (float *) malloc((unsigned) i);
    r = (float *) malloc((unsigned) i);
    if (r == NULL || !spline()) {
	if (r == NULL)

/* *** Padroniz. msg erro - Luciana 19/12/94
			fprintf(stderr,"Nao consegui alocar memoria\n");
*** */
	    fprintf(stderr, PegaMsg(1039));
	else
/* *** Padroniz. msg erro - Luciana 19/12/94
			fprintf(stderr,"'X' nao esta em ordem crescente \n");
*** */
	    fprintf(stderr, PegaMsg(1106));
    }

/****
 ****  Retirado o tratamento: .dat vazio grava .hdr vazio.
 ****  18/07/95
 ****
	if ( NRO_OBS(fout) == 0L ) {
		if (ret = fech_vazio(fout) < 0) {
                	setOSstdin();
 			fprintf(stderr, PegaMsg(5005),"");
#ifdef MEM_DEBUG
        		if(Mem_Used() != 0){
                		printf("***Lista de memoria nao esta vazia ***\n");
                		Mem_Store("spline");
                		exit(5);
        		}
#endif
                	exit(2);
                }
	}
	else {
 ****
 ****  fim comentario
 ****/
    if ((ret = fech_arq(fout)) < 0 && ret >= -2) {
	setOSstdin();
	fprintf(stderr, PegaMsg(5005), "");
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("spline");
	    exit(5);
	}
#endif
	exit(2);
    }
/****
 **** 
	}
 ****
 ****/

    if ((ret = fech_arq(fd)) < 0 && ret >= -2) {
	fprintf(stderr, PegaMsg(1011), "");
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("spline");
	    exit(5);
	}
#endif
	setOSstdin();
	exit(2);
    }
    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("spline");
	exit(5);
    }
#endif

    /* Desbloqueio dos arquivos */
    if (descarq[0] != -1) {
	/*UnlockAFile(descarq[0]); */
    }
    if (descarq[1] != -1) {
	/*                UnlockAFile(descarq[1]); */
    }

    /* Final da execucao do programa */
    exit(0);
}

numb(np, argcp, argvp)
int *argcp;
float *np;
char ***argvp;
{
    char c;
    if (*argcp <= 1)
	return (0);
    c = (*argvp)[1][0];
    if (!('0' <= c && c <= '9' || c == '-' || c == '.'))
	return (0);
    *np = (float) atof((*argvp)[1]);
    (*argcp)--;
    (*argvp)++;
    return (1);
}
