
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/class.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include "stepwise.h"
#include "pcsgbd.h"		/* Luciana */

#include <stdlib.h>

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)class.c	3.3	(NTIA/stepwise)	94/12/19";

extern int n_class;
extern int classv[MAXCLASS];
extern int tip_by[MAXCLASS];

extern char obs2[MAXCLASS][80];
extern char *obs1[OBSSIZE];

/*
** Inicializacao do vetor de class
*/
void inicioby()
{				/* inicializa obs2 com as classes */
    int ii;

    for (ii = 0; ii < n_class; ++ii) {
	strcpy(obs2[ii], obs1[classv[ii]]);
    }
}

/* ------------------------------------------------------------------------
** class
**	Descricao      : verifica mudanca de classe
** ------------------------------------------------------------------------- */

class()
{
    int i;
    int k;
    int flag;
    double x;
    double y;
    extern int ordc;

    if (n_class == 0)
	return 0;

    flag = 0;
    for (i = 0; i < n_class; ++i) {
	k = classv[i];
	if (tip_by[i]) {	/* Var. Numerica ou Data */
	    x = (strcmpi(obs1[k], ".") == 0) ? MISSING : atof(obs1[k]);
	    y = (strcmpi(obs2[i], ".") == 0) ? MISSING : atof(obs2[i]);
	    if (x != y) {
		flag = -1;
		if (ordc) {
		    if (x < y)
			erroclass();
		} else {
		    if (x > y)
			erroclass();
		}
		break;
	    }
	} else {
	    if (strcmpi(obs1[k], obs2[i]) != 0) {
		flag = -1;
		if (ordc) {
		    if (strcmpi(obs1[k], obs2[i]) < 0)
			erroclass();
		} else {
		    if (strcmpi(obs1[k], obs2[i]) > 0)
			erroclass();
		}
		break;
	    }
	}
    }
    return flag;
}

/* ====================================================================== */

void erroclass()
{
/* *** Padroniz. msg erro - Luciana 19/12/94
	fprintf(stderr,"\r            \n");
	printf("\nADVERTENCIA :\n");
	printf("	Arquivo nao ordenado pela(s) variavel(is) do comando CLASS.\n");
	printf("	Use o modulo ORDENA para obter ordenacao apropriada.\n");
*** */
    printf(PegaMsg(1082));
    setOSstdin();
#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("stepwise");
	exit(1);
    }
#endif

    exit(1);
}

/* ------------------------------------------------------------------------
** by
**	Descricao      : tratamento de variaveis de classe
** ------------------------------------------------------------------------- */

void by(pos)
int pos;
{
    extern int n_class;
    extern int classv[MAXCLASS];
    extern int tip_by[MAXCLASS];
    extern ARQ *fd;

    char nome[16];
    double mmin, mmax;
    char tipo;

    ++n_class;
    if (n_class > MAXCLASS) {
	erro(7, 1);
    } else {
	classv[n_class - 1] = pos;
	pega_var(fd, pos, nome, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
	strcpy(p, nome);
	efts_by[n_class - 1] = p;
	p += (strlen(p) + 1);
	if (tipo == 'n')
	    tip_by[n_class - 1] = 1;	/* Tipo numerica */
/* OSCAR: Ate' a marca. */
	else if (tipo == 'd')
	    tip_by[n_class - 1] = 2;	/* Tipo data */
/* XXXXXXXXXXXXXXXXXXXX */
	else
	    tip_by[n_class - 1] = 0;	/* Tipo alfa */
    }
}
