
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Rotinas para impresso da matriz de correlaes

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/correl.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include "pcsgbd.h"
#include "stepwise.h"

static char *sccsid = "@(#)correl.c	3.2	(NTIA/stepwise)	95/07/26";

int prtcor()
{
    int inic;			/* inicio de linha e coluna a imprimir */
    int fimc;			/* coluna final a imprimir */
    int ncor;			/* limite de linha e coluna a imprimir */
    int lim;			/* numero de colunas a serem impressas por linha */
    int i, j, k;
    int e_y, pos;
    double correl;		/* valor da correlacao */
    double mcor;		/* valor da maior correlacao */
    double pv[5];		/* valor do p_value para cada correl na linha */

    inic = fl_int;
    ncor = np - 1;
    lim = (fl_int) ? 5 : 4;
    fimc = (ncor > lim) ? lim : ncor;

    mcor = 0.0;
    pos = -1;

    if (fl_correl)
	printf
	    ("\n    Matriz de Correlacoes e Niveis Descritivos do Teste Ho:Correl=0\n\n");

    do {
	if (fl_correl) {
	    printf("%9.9s ", " ");
	    for (j = inic; j <= fimc; ++j)
		printf("%9.9s ", efts[j]);
	    printf("\n\n");
	}

	for (i = inic; i <= ncor; ++i) {
	    if (fl_correl)
		printf("%9.9s ", efts[i]);

	    /* calcula p_value e correl */
	    k = 0;
	    for (j = inic; j <= ((i < fimc) ? i : fimc); ++j) {
		if (ef[j][0] == -3)
		    e_y = 1;
		else
		    e_y = 0;

		if (i == j) {
		    correl = 1.0;
		    pv[k++] = 0.0;
		} else {
		    correl = calc_cor(i, j);
		    if (fabs(correl) < EPS)
			pv[k++] = 1.0;
		    else {
			if (fabs(correl - 1.0) < EPS)
			    pv[k++] = 0.0;
			else {
			    pv[k++] = calc_pv(correl);
			}
		    }
		    if (e_y) {
			if (fabs(correl) > mcor) {
			    mcor = fabs(correl);
			    pos = i;
			}
		    }
		}
		if (fl_correl)
		    printf("%9.4lf ", correl);
	    }

	    if (fl_correl) {
		printf("\n%9s", " ");

		/* imprime p_value */
		k = 0;
		for (j = inic; j <= ((i < fimc) ? i : fimc); ++j)
		    printf("   (%5.3lf)", pv[k++]);
		printf("\n\n");
	    }

	}
	inic = fimc + 1;
	fimc += lim;
	if ((fimc >= ncor) && (inic <= ncor)) {
	    fimc = ncor;
	    if (fl_correl)
		putchr1();
	}
    } while (fimc <= ncor);
    if (pos != -1)
	return (sv[pos]);
    else
	return (-1);
}

double calc_pv(r)
double r;
{
    extern int glt;

    double t;

    t = r * sqrt((double) (glt) - 2.0) / sqrt(1.0 - r * r);
    return (2.0 * tprob(fabs(t), (double) (glt - 2)));
}

double calc_cor(i, j)
int i, j;
{
    double correl;
    int k, l;
    double tmp, tmp1, tmp2;

    /* Observacao: O vetor soma e' usado como soma 
       O vetor varia e' usado como variancia */
    k = sv[i];
    l = sv[j];
    tmp = sqrt(fabs(varia[i]));
    tmp1 = sqrt(fabs(varia[j]));
    tmp2 = (((double) glt) * ((double) (glt - 1)) * tmp * tmp1);
    if (tmp == 0.0 && tmp1 == 0.0)
	return (1.0);
    if (tmp == 0.0 || tmp1 == 0.0 || tmp2 <= 1.e-77)
	return (0.0);

    correl = (((double) glt) * xlx[idx(k, l)] - soma[i] * soma[j]) / tmp2;

    return (correl);
}
