
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	A partir da linha lida (saida) cria a matriz z'z fazendo
	o somatorio dos produtos cruzados

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/criaxlx.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/

#include <stdio.h>
#include "pcsgbd.h"
#include "stepwise.h"

static char *sccsid = "@(#)criaxlx.c	3.2	(NTIA/stepwise)	95/07/26";

void cria_xlx()
{
    int i, j, k;
    double d, e;

    for (i = 0; i < ndim; ++i) {
	d = saida[i];
	if (d != 0.0) {
	    k = idx(i, 0);
	    for (j = 0; j <= i; ++j) {
		if ((e = saida[j]) != 0.0) {
		    xlx[k] += (d * e);	/* substitui idx */
		}
		++k;
		/* pois idx(i,j) e' equivalente a soma de k */
	    }
	}
    }
    if (pflag) {
	for (i = 0; i < ndim - 1; ++i)
	    /*
	       printf("  %2.0f", saida[i]);
	     */
	    printf("  %2s", rounddec(saida[i], 2, 0));
	/*
	   printf("  %5.2f\n", saida[i]);
	 */
	printf("  %5s\n", rounddec(saida[i], 5, 2));
    }
}
