
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Pivota uma linha da matriz z'z dando como resultado a matriz pivotada 
	e a matriz identidade

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/doolitle.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/

#include <stdio.h>
#include "stepwise.h"

static char *sccsid = "@(#)doolitle.c	3.1	(NTIA/stepwise)	94/10/24";

double doolitle(x, n)
double x[];
int n;
{
    int i, j, k;
    int n1;
    double b, d;
    TINT id;

    n1 = n - 1;
    for (k = 0; k < n1; ++k) {
	d = x[idx(k, k)];
	if (fabs(d) >= 1.0e-8) {
	    for (i = k + 1; i < n; ++i) {
		b = x[idx(i, k)] / d;
		for (j = k + 1; j <= i; ++j) {
		    id = idx(i, j);
		    x[id] -= (b * x[idx(k, j)]);
		}
	    }
	}
    }
    return -x[idx(n1, n1)];
}
