
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Le as flags e abre o arquivo de dados

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/getarg.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/

#include <stdio.h>
#include <signal.h>

#include <stdlib.h>
#include <string.h>

#ifdef MSDOS
#include <io.h>
#endif

#ifdef RS6000
#include <sys/io.h>
#endif

#include "stepwise.h"
#include "getoken.h"
#include "pcsgbd.h"
/*#include "lockfile.h"*/

#ifdef MEM_DEBUG
#include "mshell.h"
#endif

static int flag_exec = 0;
extern void controlC();

extern char exretstd[];
extern int flagstd;

static char *sccsid = "@(#)getarg.c	3.12	(NTIA/stepwise)	95/09/21";

extern int nlins;
extern int ncols;

extern int descarq;
extern int flagX;

void getarg(argc, argv)
int argc;
char *argv[];
{
    int i, n;
    long ret;
    double t;
    char *pdir;
    char namelock[TAMSTR];

    extern int iterativo;

    flagX = 1;
    ++argv;			/* aponta para o primeiro parametro */
    --argc;			/* decrementa o apontador */
    while (argc--) {
	if (argv[0][0] == '-') {
	    for (i = 1; argv[0][i]; ++i) {
		switch (argv[0][i]) {

		case 'm':

		    fl_correl = 0;

		    break;

		    /*
		     ** Habilita impressao de mensagens
		     */

		case 'M':

		    break;

		    /*
		     ** Habilita impressao de tempo
		     */

		case 't':

		    break;

		case 'i':

		    fl_int = 0;

		    break;

		case 's':
		    {
			int msg_erro = 0;

			if (argv[0][i + 1] == 'e') {
			    if (nao_dgt(&argv[0][i + 2])) {
				msg_erro = 1;
			    } else {
				i++;

				number(&t, argv, &i);

				if ((t <= 1.0) && (t >= 0.0))
				    alfae = t;
				else
				    alfae = 0.1;

				--i;
			    }
			}

			else {
			    if (argv[0][i + 1] == 's') {
				if (nao_dgt(&argv[0][i + 2])) {
				    msg_erro = 1;
				} else {
				    i++;

				    number(&t, argv, &i);

				    if ((t <= 1.0) && (t >= 0.0))
					alfas = t;
				    else
					alfas = 0.1;

				    --i;
				}
			    } else {
				msg_erro = 1;
			    }
			}
			if (msg_erro) {
			    fprintf(stderr, PegaMsg(3154), argv[0]);
			    setOSstdin();
#ifdef MEM_DEBUG
			    if (Mem_Used() != 0) {
				printf
				    ("***Lista de memoria nao esta vazia ***\n");
				Mem_Store("stepwise");
				exit(1);
			    }
#endif
			    exit(1);
			}

			break;
		    }

		case 'P':

		    fl_imp = 1;

		    break;

		case 'p':

		    pflag = 1;

		    break;

		case 'r':

		    rflag = 1;

		    break;

		case 'n':

		    if (argv[0][i + 1] == 'i') {
			i++;

			number(&t, argv, &i);

			n = (int) t;

			if ((n < MAXITER) && (n > 0))
			    n_iter = n;

			--i;
		    }

		case 'A':
		    flag_exec = 1;

#ifdef RS6000
		    flagstd = 1;

		    /*
		     *strchr(&argv[0][i+1], '|') = '\0';
		     */
		    if (*strchr(&argv[0][i + 1], '|'))
			*strchr(&argv[0][i + 1], '|') = '\0';

		    if (freopen(&argv[0][i + 1], "r", stdin) ==
			(FILE *) NULL) {

/* *** Padroniz. msg erro - Luciana 19/12/94
						fprintf(stderr,
						"Arquivo stdin nao abre.\n");
*** */
			i += (strlen(&argv[0][i + 1]) + 1);
			*strchr(&argv[0][i + 1], '|') = '\0';
			i += (strlen(&argv[0][i + 1]) + 1);
			strcpy(exretstd, &argv[0][i + 1]);

			fprintf(stderr, PegaMsg(1034), "stdin");
			setOSstdin();
#ifdef MEM_DEBUG
			if (Mem_Used() != 0) {
			    printf
				("***Lista de memoria nao esta vazia ***\n");
			    Mem_Store("stepwise");
			    exit(5);
			}
#endif

			exit(5);
		    }

		    i += (strlen(&argv[0][i + 1]) + 1);
		    *strchr(&argv[0][i + 1], '|') = '\0';
		    fseek(stdin, atol(&argv[0][i + 1]), 0);
		    i += (strlen(&argv[0][i + 1]) + 1);
		    strcpy(exretstd, &argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);
#endif
		    setbuf(stdin, (char *) NULL);
		    iterativo = 0;

		    break;

		case 'X':

		    if (strcmp(&argv[0][i + 1], "ntia") == 0) {
			flagX = 1;
			i += 4;
		    }

		    break;

		case 'l':

		    nlins = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

		    break;

		case 'c':

		    ncols = atoi(&argv[0][i + 1]);
		    i += strlen(&argv[0][i + 1]);

		    break;

		default:


/* *** Padroniz. msg erro - Luciana 19/12/94
					fprintf(stderr, "Flag <%c> ilegal\n", argv[0][1]);
*** */
		    fprintf(stderr, PegaMsg(3086), argv[0][1]);
		    setOSstdin();
#ifdef MEM_DEBUG
		    if (Mem_Used() != 0) {
			printf("***Lista de memoria nao esta vazia ***\n");
			Mem_Store("stepwise");
			exit(1);
		    }
#endif
		    exit(1);
		}
	    }
	} else
	    break;
	++argv;
    }

    if (!flagX) {

/* *** Padroniz. msg erro - Luciana 19/12/94
		fprintf(stderr, "Execucao nao permitida\n");
*** */
	fprintf(stderr, PegaMsg(1000));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("stepwise");
	    exit(1);
	}
#endif

	exit(1);
    }

    if (argc < 0)
	usage();

    pdir = pega_env(argv[0], ".hdr");


    strcpy(namelock, pdir);
    strcat(namelock, ".dat");


#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Mem_Store("stepwise");
	exit(5);
    }
#endif

    /* Abertura do arquivo de entrada */
    if (argc == 0) {
	if ((ret = (long) (fd = abre_arq(pdir, 0, 1))) < 0L && ret > -5L) {

/* *** Padroniz. msg erro - Luciana 19/12/94
			fprintf(stderr, "Nao consegui abrir <%s> %ld\n", pdir,
				ret);
*** */
	    fprintf(stderr, PegaMsg(1034), pdir);
	    setOSstdin();
#ifdef MEM_DEBUG
	    if (Mem_Used() != 0) {
		printf("***Lista de memoria nao esta vazia ***\n");
		Mem_Store("stepwise");
		exit(2);
	    }
#endif
	    exit(2);

	}
    }

    else {

/* *** Padroniz. msg erro - Luciana 19/12/94
		fprintf(stderr,"Erro de sintaxe\n");
*** */
	fprintf(stderr, PegaMsg(3085));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("stepwise");
	    exit(2);
	}
#endif

	exit(2);
    }
    signal(SIGINT, controlC);

}


void controlC(sig)
int sig;
{
    /*
     ** Apagar, se necessario, arquivos temporarios
     */

    if (!flag_exec)
	fprintf(stderr, "\n********  Interrompido pelo usuario\n");
    /* Desbloqueio dos arquivos */

    if (descarq != -1) {
	/*        UnlockAFile(descarq); */
    }


    setOSstdin();

#ifdef MEM_DEBUG
    if (Mem_Used() != 0) {
	printf("***Lista de memoria nao esta vazia ***\n");
	Men_Store("stepwise");
	exit(1);
    }
#endif
    exit(sig);
}
