
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/impinic.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include "pcsgbd.h"
#include "stepwise.h"


static char *sccsid = "@(#)impinic.c	3.2	(NTIA/stepwise)	95/07/26";

/* ------------------------------------------------------------------------
**	Funcoes referentes a impressao da iteracao 1 do stepwise
** 	Programado por : Sonia Ternes
**	Data	       : Setembro 1989 
** ------------------------------------------------------------------------- */

/* ------------------------------------------------------------------------
** anv_i
**	Descricao      : Calcula e imprime ANOVA para primeira variavel
**			 a entrar no modelo 
** ------------------------------------------------------------------------- */

void anv_i()
{
    extern double squad;

    double x1, x2, valorf, a;

    imp_titulo("Quadro de analise de variancia");
    printf("\n");
    printf
	("Fonte de variacao     gl Soma de quadrados   Quadrado medio    Valor F  PR > F\n\n");

    /* calcula estat. da regressao */
    par_reg(&x1, &x2, &valorf, &a);

    if (x1 > 1.e8) {
	/*
	   printf("%-18s  %4d %17.8g %16.8g %10.4f %7.4f\n\n",
	   "Modelo",glm,x1,x2,valorf,a);
	   printf("%-18s  %4d %17.8g %16.8g\n\n",
	   "Residuo", glr, sse[ultcol],qmr);
	 */
	printf("%-18s  %4d %17s %16s %10s %7.4f\n\n",
	       "Modelo", glm, rounddec(x1, 17, 8),
	       rounddec(x2, 16, 8), rounddec(valorf, 10, 4), a);
	printf("%-18s  %4d %17s %16s\n\n",
	       "Residuo", glr, rounddec(sse[ultcol], 17, 8),
	       rounddec(qmr, 16, 8));
	if (fl_int) {
	    /*
	       printf("%-18s  %4d %17.8g\n",
	       "Total", (glt-fl_int), sse[0]);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(sse[0], 17, 8));
	} else {
	    /*
	       printf("%-18s  %4d %17.8g\n",
	       "Total", (glt-fl_int), squad);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(squad, 17, 8));
	}
    } else {
	/*
	   printf("%-18s  %4d %17.8f %16.8f %10.4f %7.4f\n\n",
	   "Modelo",glm,x1,x2,valorf,a);
	   printf("%-18s  %4d %17.8f %16.8f\n\n",
	   "Residuo", glr, sse[ultcol],qmr);
	 */
	printf("%-18s  %4d %17s %16s %10s %7.4f\n\n",
	       "Modelo", glm, rounddec(x1, 17, 8),
	       rounddec(x2, 16, 8), rounddec(valorf, 10, 4), a);
	printf("%-18s  %4d %17s %16s\n\n",
	       "Residuo", glr, rounddec(sse[ultcol], 17, 8),
	       rounddec(qmr, 16, 8));
	if (fl_int) {
	    /*
	       printf("%-18s  %4d %17.8f\n",
	       "Total", (glt-fl_int), sse[0]);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(sse[0], 17, 8));
	} else {
	    /*
	       printf("%-18s  %4d %17.8f\n",
	       "Total", (glt-fl_int), squad);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(squad, 17, 8));
	}
    }
    printf("\n");
    printf
	("-------------------------------------------------------------------------------\n");
}

/* ------------------------------------------------------------------------
** sai_i
**	Descricao      : Calcula e imprime o pvalue da primeira var. do modelo
**	Variaveis sai. : -1 se var. deve sair do modelo
**			  0 caso contrario
** ------------------------------------------------------------------------- */

int sai_i()
{
    int i, cont;
    double a;
    double x1;			/* variavel auxiliar */
    double x3;			/* variavel auxiliar */
    double valorF;		/* valor de f ao quadrado */
    double dp;			/* desvio padrao */
    extern double squad;
    extern double media2;

    imp_titulo("Variaveis pertencentes a equacao");
    printf("\n");
    printf
	("Variavel              Estimativa    Desvio Padrao       F para sair     PR > F\n");
    printf
	("------------------------------------------------------------------------------\n");

    cont = 0;
    for (i = 0; i < nxlx; ++i) {
	if (v[i] == -1) {
	    valorF = 0.0;
	    if (qmr > 1.0e-14)
		valorF = obs[i] / qmr;	/* obs=qm */
	    x1 = xlx[idx(nxlx, i)];
	    dp = sqrt(xlx[idx(i, i)] * qmr);
	    if (i == 0 && fl_int)
		printf("%-17s ", "Coef. Linear");
	    else {
		printf("%-17s ", efts[peg_pos(i)]);
	    }
	    x3 = valorF;
	    if (x3 > 10000.)
		x3 = 9999.9999;

	    a = fprob(valorF, 1.0, (double) glr);

	    if (i != 0 || !fl_int) {
		/*
		   printf("%14.8f %16.4f %17.4f %10.4f\n",x1,dp,x3,a);
		 */
		printf("%14s %16s %17s %10.4f\n",
		       rounddec(x1, 14, 8), rounddec(dp, 16, 4),
		       rounddec(x3, 17, 4), a);
	    } else {
		/*
		   printf("%14.8f %16.4f\n",x1,dp);
		 */
		printf("%14s %16s\n",
		       rounddec(x1, 14, 8), rounddec(dp, 16, 4));
	    }

	    ++cont;
	}
	if (cont == nxlxs)
	    break;
    }
    printf("\n\n");
    if (a > alfas)
	return (-1);
    else
	return (0);
}

/* ------------------------------------------------------------------------
** ite_i
**	Descricao      : Imprime numero do passo e valores referentes aos
**			 coeficientes de determinacao	
**	Variaveis ent. : k   : numero da iteracao
**			 col : coluna da var. a entrar
** ------------------------------------------------------------------------- */

void ite_i(k, col)
int k;
int col;
{
    extern double squad;

    int i;
    double x1;

    printf("\n\t Iteracao numero   : %d", k);

    if (nm > 1)
	printf("\n\t Variaveis a entrar: ");
    else
	printf("\n\t Variavel a entrar : ");

    if (col != -1)
	printf("%-s ", efts[peg_pos(col)]);
    else {
	for (i = fl_int; i < fl_int + nm; ++i) {
	    printf("%-s ", efts[peg_pos(i)]);
	}
    }
    printf("\n");

    glm = nxlxs - fl_int;
    glr = (glt - fl_int) - glm;

    if (fl_int)
	x1 = sse[0] - sse[ultcol];
    else
	x1 = squad - sse[ultcol];

    printf("\t Coef. Determinacao       : %6.4f\n",
	   (x1 / ((fl_int) ? sse[0] : squad)));
    printf("\t Coef. Determinacao Ajust.: %6.4f\n",
	   (1.0 -
	    (1.0 - (x1 / ((fl_int) ? sse[0] : squad))) * (glt -
							  fl_int) / glr));

    printf("\n\n");

}
