
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/impsweep.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include "pcsgbd.h"
#include "stepwise.h"

static char *sccsid = "@(#)impsweep.c	3.2	(NTIA/stepwise)	95/07/26";

/* ------------------------------------------------------------------------
**	Funcoes referentes as tabelas impressas em cada passo do stepwise
** 	Programado por : Sonia Ternes
**	Data	       : Setembro 1989 
** ------------------------------------------------------------------------- */

/* ------------------------------------------------------------------------
** anv_s
**	Descricao      : Imprime quadro de Analise de Variancia	
**	Rot. chamadas  : Nenhuma
**	Variaveis ent. : reg : estrutura com os valores relativos a regressao
**			 res : estrutura com os valores relativos ao residuo
** ------------------------------------------------------------------------- */
void anv_s()
{

    extern double squad;

    imp_titulo("Quadro de analise de variancia");
    printf("\n");
    printf
	("Fonte de variacao     gl Soma de quadrados   Quadrado medio    Valor F  PR > F\n\n");

    if (reg.squad > 1.e8) {
	/*
	   printf("%-18s  %4d %17.8g %16.8g %10.4f %7.4f\n\n",
	   "Modelo",reg.gl,reg.squad,reg.msquad,reg.vF,reg.pF);
	   printf("%-18s  %4d %17.8g %16.8g\n\n",
	   "Residuo", res.gl, res.squad, res.msquad);
	 */
	printf("%-18s  %4d %17s %16s %10.4f %7.4f\n\n",
	       "Modelo", reg.gl,
	       rounddec(reg.squad, 17, 8),
	       rounddec(reg.msquad, 16, 8), reg.vF, reg.pF);
	printf("%-18s  %4d %17s %16s\n\n",
	       "Residuo", res.gl,
	       rounddec(res.squad, 17, 8), rounddec(res.msquad, 16, 8));
	if (fl_int) {
	    /*
	       printf("%-18s  %4d %17.8g\n",
	       "Total", (glt-fl_int), sse[0]);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(sse[0], 17, 8));
	} else {
	    /*
	       printf("%-18s  %4d %17.8g\n",
	       "Total", (glt-fl_int), squad);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(squad, 17, 8));
	}
    } else {
	/*
	   printf("%-18s  %4d %17.8f %16.8f %10.4f %7.4f\n\n",
	   "Modelo",reg.gl,reg.squad,reg.msquad,reg.vF,reg.pF);
	   printf("%-18s  %4d %17.8f %16.8f\n\n",
	   "Residuo", res.gl, res.squad, res.msquad);
	 */
	printf("%-18s  %4d %17s %16s %10.4f %7.4f\n\n",
	       "Modelo", reg.gl, rounddec(reg.squad, 17, 8),
	       rounddec(reg.msquad, 16, 8), reg.vF, reg.pF);
	printf("%-18s  %4d %17s %16s\n\n",
	       "Residuo", res.gl,
	       rounddec(res.squad, 17, 8), rounddec(res.msquad, 16, 8));
	if (fl_int) {
	    /*
	       printf("%-18s  %4d %17.8f\n",
	       "Total", (glt-fl_int), sse[0]);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(sse[0], 17, 8));
	} else {
	    /*
	       printf("%-18s  %4d %17.8f\n",
	       "Total", (glt-fl_int), squad);
	     */
	    printf("%-18s  %4d %17s\n",
		   "Total", (glt - fl_int), rounddec(squad, 17, 8));
	}
    }
    printf("\n");
    printf
	("-------------------------------------------------------------------------------\n");
}

/* ------------------------------------------------------------------------
** ite_s
**	Descricao      : Imprime numero do passo e valores referentes aos
**			 coeficientes de determinacao	
**	Variaveis ent. : col : coluna da var a entrar no modelo
**			 k   : numero da iteracao
** ------------------------------------------------------------------------- */
void ite_s(col, k)
int col;
int k;
{
    printf("\n\t Iteracao numero   : %d", k);
    printf("\n\t Variavel a entrar : %-s\n", efts[peg_pos(col)]);

    printf("\t Coef. Determinacao       : %6.4f\n", c_det);
    printf("\t Coef. Determinacao Ajust.: %6.4f\n", c_aju);

    printf("\n\n");
}

/* ------------------------------------------------------------------------
** ent_s
**	Descricao      : imprime F das var que nao estao na equacao	
**	Rot. chamadas  : Nenhuma
**	Variaveis ent. : Fenter : estrut de informacoes sobre var fora do modelo
** ------------------------------------------------------------------------- */

void ent_s()
{
    int i, j;

    imp_titulo("Variaveis fora da equacao");
    printf("\n");
    printf
	("Variavel              Estimativa    Desvio Padrao     F para entrar     PR > F\n");
    printf
	("------------------------------------------------------------------------------\n");

    for (i = 0; i < tenter; ++i) {
	j = peg_pos(Fenter[i].col);
	if (Fenter[i].dp != -1.0) {
	    /*
	       printf("%-17s %14.8f %16.4f %17.4f %10.4f\n",efts[j],
	       Fenter[i].coef,Fenter[i].dp,Fenter[i].vF,Fenter[i].pF);
	     */
	    printf("%-17s %14s %16s %17s %10.4f\n", efts[j],
		   rounddec(Fenter[i].coef, 14, 8),
		   rounddec(Fenter[i].dp, 16, 4),
		   rounddec(Fenter[i].vF, 17, 4), Fenter[i].pF);
	} else {
	    printf("%-17s   ", efts[j]);
	    printf
		("  **** Combinacao   linear  de  variaveis  do  modelo ****\n");
	    i++;
	}
    }
    printf("\n\n");
}

/* ------------------------------------------------------------------------
** sai_s
**	Descricao      : imprime F das var que estao na equacao	
**	Variaveis ent. : Fsai : estrut de informacoes sobre var no modelo
** ------------------------------------------------------------------------- */
void sai_s()
{
    int i, j;

    imp_titulo("Variaveis pertencentes a equacao");
    printf("\n");
    printf
	("Variavel              Estimativa      Desvio Padrao     F para sair     PR > F\n");
    printf
	("------------------------------------------------------------------------------\n");

    if (fl_int) {
	/*
	   printf("%-17s %14.8f %18.4f\n","Coef. Linear",Coef.vl,Coef.dp);
	 */
	printf("%-17s %14s %18s\n", "Coef. Linear",
	       rounddec(Coef.vl, 14, 8), rounddec(Coef.dp, 18, 4));
    }

    for (i = 0; i < (nxlxs - fl_int); ++i) {
	j = peg_pos(Fsai[i].col);
	/*
	   printf("%-17s %14.8f %18.4f %15.4f %10.4f\n",efts[j],
	   Fsai[i].coef,Fsai[i].dp,Fsai[i].vF,Fsai[i].pF);
	 */
	printf("%-17s %14s %18s %15s %10.4f\n", efts[j],
	       rounddec(Fsai[i].coef, 14, 8),
	       rounddec(Fsai[i].dp, 18, 4),
	       rounddec(Fsai[i].vF, 15, 4), Fsai[i].pF);
    }
    printf("\n\n");
}

/* ------------------------------------------------------------------------
** ites_s
**	Descricao      : Imprime numero do passo e valores referentes as
**			 var. que sairam do modelo
**	Variaveis ent. : s : numero de var. que sairam
**			 k   : numero da iteracao
**			 col : coluna da var. a sair do modelo
** ------------------------------------------------------------------------- */
void ites_s(k, col)
int k;
int col;
{
    printf("\n\t Iteracao numero    : %d", k);
    printf("\n\t Variavel retirada  : %-s\n", efts[peg_pos(col)]);

    printf("\t Coef. Determinacao       : %6.4f\n", c_det);
    printf("\t Coef. Determinacao Ajust.: %6.4f\n", c_aju);

    printf("\n\n");
}
