
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Modulo para calculo de regressao stepwise,derivado do codigo do modulo
	REGRESS de Fevereiro/88, baseando-se no sweep das  colunas da
	matriz x'x correspondente as variaveis que devem entrar e sair do
	modelo a cada iteracao.

	Forma de usar:
		Stepwise [opcoes] nomebase
		[ manter <variaveis_independentes_1> ;]
		mod <var_dep> = <variaveis_independentes_2>;
		}

	Opcoes envolvidas:
		-i       : nao usa intercepto no modelo
		-ssnn    : nivel de confianca para Fsai
		-senn    : nivel de confianca para Fenter
		-P	 : pula pagina na impressao
		-ninn    : numero de iteracoes
		-se	 : nivel de significancia para entrar
		-ss	 : nivel de significancia para sair
		nomebase : nome da base de dados a ser atualizada

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/main.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/

#define EXTERN

#include <stdio.h>
#include <setjmp.h>
#include <stdlib.h>

#include "getoken.h"
#include "pcsgbd.h"		/* Luciana */

#ifdef VAXVMS
#include <stdlib.h>
#else
#include <malloc.h>
#endif

#include <string.h>

#include "stepwise.h"
/*#include "lockfile.h"*/

#ifdef  MEM_DEBUG
#include "mshell.h"
#endif

static char *sccsid = "@(#)main.c	3.6	(NTIA/stepwise)	95/04/10";

char *pchar;			/* ponteiro para a area nao usada */

jmp_buf env;
char *obs1[OBSSIZE];
char obs2[MAXCLASS][80];
char area1[1024];

double squad;
double media2;			/* Variavel que armazena valor da media de Y */

int descarq;			/* descritor para bloqueio do arquivo de entrada */
int flagX = 0;

#define MUDA_PAG 12

main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{
    int i, m;
    TINT ii;
    int n;
    long l;

#ifdef VAXVMS
    argc = prepvax(argc, argv);
#endif

    pflag = rflag = fl_imp = ni = nm = np = 0;
    fl_int = fl_correl = ordc = iterativo = 1;
    n_iter = 20;

    alfas = 0.1;
    alfae = 0.1;

    descarq = -1;

    getarg(argc, argv);		/* le os argumentos e abre arquivo */

    p = area;
    pchar = area1;

    int_var();			/* inicializa valores para o parse */

    setjmp(env);
printf("passou 1\n");
    for (initcode(); yyparse(); initcode());

    set_val();			/* define ultimas variaveis apos parse */

    l = ((long) ndim + 1l) * (long) ndim / 2l;
    if ((xlx = (double MY_HUGE *) HALLOC((TIPO) l, sizeof(double))) ==
	(double MY_HUGE *) NULL) {

/* *** Padroniz. msg erro - Luciana 19/12/94
		fprintf(stderr, "Nao consegui espaco para x'x.\n");
*** */
	fprintf(stderr, PegaMsg(1042));
	setOSstdin();
#ifdef MEM_DEBUG
	if (Mem_Used() != 0) {
	    printf("***Lista de memoria nao esta vazia ***\n");
	    Mem_Store("stepwise");
	    exit(1);
	}
#endif
	exit(1);
    }

    inicializa();

    m = 1;
    n = 1;

    while (ler_obs(fd, obs1) != (long) EOF) {
	if ((m == 1) && (n_class > 0))
	    inicioby();
	if (class() == 0) {
	    if (missing() == -1) {
		expand_mat();

		for (i = fl_int; i < np - 1; ++i) {
		    soma[i + 1] += saida[i];
		}
		soma[fl_int] += saida[np - 1];

		cria_xlx();
		m++;
	    }
	    ++n;
	} else {
	    executa(m, n);
	    pchar = area1;
	    inicioby();
	    m = 1;
	    n = 1;
	    inicializa();
	    for (ii = 0; ii < (unsigned) l; ++ii)
		xlx[ii] = 0.0;
	    if (missing() == -1) {
		expand_mat();

		for (i = fl_int; i < np - 1; ++i) {
		    soma[i + 1] += saida[i];
		}
		soma[fl_int] += saida[np - 1];

		cria_xlx();
		m++;
	    }
	    ++n;
	}

    }

    executa(m, n);

    fech_arq(fd);

    HFREE((char MY_HUGE *) xlx);

    setOSstdin();
    /*
     ** Verificacao de  memoria alocada e  liberada
     */
#ifdef MEM_DEBUG

    if (Mem_Used() != 0) {

	printf("*** Lista de memoria nao esta' vazia ***\n");

	Mem_Store("stepwise");

	exit(0);

    }
#endif

    /* Desbloqueio dos arquivos */
    if (descarq != -1) {
	/*        UnlockAFile(descarq); */
    }

    /* Finalizacao da execucao  */
    exit(0);
}

void executa(m, n)
int m;				/* numero de obs. utilizadas */
int n;				/* numero de obs. lidas */
{
    int col, s;

    glt = m - 1;

    if ((m - 1) <= nxlx) {
	printf
	    ("\n*** Num. de observacoes insuficiente para calculo da regressao. num. obs=%d ***\n\n",
	     (m - 1));
	return;
    }

    media2 = soma[fl_int] / (double) glt;

    putchr1();
    prtdes(n - 1);

    if (fl_correl) {
	if (np - 1 > 5)
	    putchr1();
    }

    col = prtcor();		/* coluna da var mais correlacionada com Y */
    if (col == -1) {
	printf
	    ("\nNenhuma das variaveis independentes pode ser selecionada para entrar no\n");
	printf
	    ("modelo, pois nao sao correlacionadas com a variavel dependente.\n");
	return;
    }

    squad = xlx[idx(nxlx, nxlx)];

    exec();

    if (nm == 0) {
	s = sem_manter(col);
	if (s) {
	    printf
		("\nNenhuma das variaveis satisfaz o criterio para entrar no modelo.\n");
	    return;
	}
    } else {
	com_manter();
	s = 0;
    }

    if (s == 0)			/* nao vai sair */
	s = stepwise(m);	/* calcula as iteracoes do stepwise */
}

int sem_manter(col)
int col;			/* coluna da var. mais correlacionada com Y */
{
    int s = 0;

    nxlxs = 1 + fl_int;		/* seta dimensao de xlx */

    s = s_sweep(col);
    if (s == 1) {
	ultcol = col;
	putchr1();
	ite_i(1, col);		/* imprime no. da iteracao */
	anv_i();		/* imprime ANOVA */

	s = sai_i();		/* ve se a var deve sair do modelo */
	return (s);
    } else {
	return (-1);
    }
}

void com_manter()
{
    int i;
    int s = 0;

    nxlxs = fl_int + nm;

    for (i = fl_int; i < fl_int + nm; ++i) {
	s = s_sweep(i);
	if (s == 0)
	    erro(4, 1);
    }
    ultcol = fl_int + nm - 1;

    putchr1();
    ite_i(1, -1);		/* imprime no. da iteracao */
    anv_i();
    s = sai_i();
}

void exec()
{
    int i;

    for (i = 0; i < ndim; ++i)
	v[i] = 1;
    if (fl_int) {
	sweep(0);
	sse[0] = xlx[idx(nxlx, nxlx)];
	if (rflag) {
	    printf("\nAplicado sweep em : 0");
	    print_xlx();
	}
    }
    for (i = 0; i < ndim; ++i)
	css[i] = xlx[idx(i, i)];
}

void initcode()
{
    p = area;
    pchar = area1;

    ni = 0;			/* total de var. indep. */
    nm = 0;			/* total de var. do manter */
    np = 0;			/* total de parametros */

    int_var();
}
