
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Imprime descrio das variveis do modelo

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/prtdes.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>
#include "stepwise.h"


static char *sccsid = "@(#)prtdes.c	3.1	(NTIA/stepwise)	94/10/24";

void prtdes(num)
int num;
{
    int i, j, tam;
    double tmp;
    int l;

    printf("\tDescricao das variaveis do modelo\n\n");

    l = 0;
    tam = 36;			/* controle do nome das var. a imprimir */
    for (i = fl_int; i < np; ++i) {
	if ((ef[i][0] == -2) || (ef[i][0] == -1)) {
	    if (l == 0) {
		if (ni > 1)
		    printf("\n\tVariaveis independentes : ");
		else
		    printf("\n\tVariavel independente   : ");
		printf("%s ", efts[i]);
		tam += (strlen(efts[i]) + 1);
	    } else {
		if (tam >= 79) {
		    printf("\n\t                          ");
		    printf("%s", efts[i]);
		    tam = (strlen(efts[i]) + 36);
		} else {
		    printf(", %s ", efts[i]);
		    tam += (strlen(efts[i]) + 3);
		}
	    }
	    ++l;
	}
    }

    l = 0;
    if (nm > 1) {
	printf("\n\n\tVariaveis a serem mantidas : ");
	for (i = 0; i < nm; ++i) {
	    if (l == 0)
		printf("%s", efts[peg_pos(i + fl_int)]);
	    else
		printf(", %s ", efts[peg_pos(i + fl_int)]);
	    ++l;
	}
    } else {
	if (nm == 1)
	    printf("\n\n\tVariavel a ser mantida  : %s",
		   efts[peg_pos(fl_int)]);
    }

    printf("\n\n\tVariavel dependente     : ");

    for (i = fl_int; i < np; ++i) {
	if (ef[i][0] == -3) {
	    printf("%s", efts[i]);
	}
    }
    printf("\n");
    printf("\n");
    printf("\tNumero de observacoes lidas     : %d\n", num);
    printf("\tNumero de observacoes utilizadas: %d\n", glt);

    putchr1();
    imp_titulo("Estatisticas Descritivas");
    printf("%-8s %18s %20s %20s\n", "Variavel", "Media", "Variancia",
	   "Desvio");
    printf("       %20s %20s %20s\n", " ", " ", "Padrao");
    printf("\n");

    for (i = fl_int; i < np; ++i) {
	j = sv[i];
	printf("%-9s ", efts[i]);
	tmp = (((double) glt) * xlx[idx(j, j)] - (soma[i] * soma[i]));
	varia[i] = tmp / (((double) glt) * ((double) (glt - 1)));
	tmp = soma[i] / (double) glt;
	if (tmp > 1.e9 || varia[i] > 1.e9) {
	    printf("%17.8g    %17.8g    %17.8g\n",
		   (soma[i] / (double) glt), (varia[i]),
		   sqrt(fabs(varia[i])));
	} else {
	    printf("%17.8f    %17.8f    %17.8f\n",
		   (soma[i] / (double) glt), (varia[i]),
		   sqrt(fabs(varia[i])));
	}
	printf("\n\n");
    }
}
