
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Controla a coluna a ser sweepada, atualizando sse

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/s_sweep.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include "stepwise.h"

static char *sccsid = "@(#)s_sweep.c	3.1	(NTIA/stepwise)	94/10/24";

int s_sweep(i)
int i;
{
    int j = 0;

    if (fabs(css[i]) < 1.e-14) {
	j = mensagem(i);
    } else {
	if ((fabs(xlx[idx(i, i)]) / css[i]) < 1.e-14) {
	    j = mensagem(i);
	} else {
	    sweep(i);
	    if (rflag) {
		printf("\nAplicado sweep em : %d", i);
		print_xlx();
	    }
	}
    }

    if (j == 0) {
	sse[i] = xlx[idx(nxlx, nxlx)];
	return (1);
    }
    return (0);
}


/* ------------------------------------------------------------------------
** mensagem
**	Descricao      : coloca uma marca em Fenter dizendo que
**			 a variavel e' uma combinacao linear das demais
**	Rot. chamadas  : Nenhuma
**	Variaveis ent. : Fenter : estrutura
**			 i : coluna da var. que e' combinacao
**	Variaveis sai. : 1 : e' comb. linear
**			 0 : nao e' comb. linear
** ------------------------------------------------------------------------- */

int mensagem(i)
int i;
{
    int j, k;
    int cont = 0;
#ifdef EDIX
    double *dp;
#endif

    for (k = 1; k < nxlx; ++k) {
	if (v[k] == -1) {
	    for (j = 0; j < ndim; ++j) {
		if ((j == k) && (j != i)) {
#ifdef EDIX
		    dp = &(Fenter[tenter].dp);
		    *dp = -1.0;
#else
		    Fenter[tenter].dp = -1.0;
#endif
		    Fenter[tenter++].col = i;
		    return (1);
		}
	    }
	    cont++;
	}
	if (cont == nxlxs)
	    break;
    }

    return (0);
}
