
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Analisados lexico da gramtica descrita em step.y

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/steplex.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include <string.h>

#include "getoken.h"
#include "stepwise.h"
#include "pcsgbd.h"		/* Luciana */

#ifdef MSDOS
# include "y_tab.h"
# include <stdlib.h>
#else
#ifdef VAXVMS
# include "y_tab.h"
#else
# include "y.tab.h"
#endif
#endif

static char *sccsid = "@(#)steplex.c	3.2	(NTIA/stepwise)	95/01/11";

static int fl_tl = 0;		/* Flag de controle de titulo */
extern YYSTYPE yylval;
extern ARQ *fd;


yylex()
{

    char error[128];
    char token[128];
    int c;
    int s;

    if (!fl_tl) {
	c = getoken(token);
	if (strcmpi(token, "mod") == 0)
	    return MOD;
	if (strcmpi(token, "ord") == 0)
	    return ORD;
	if (strcmpi(token, "asc") == 0)
	    return ASC;
	if (strcmpi(token, "desc") == 0)
	    return DESC;
	if (strcmpi(token, "manter") == 0)
	    return MANTER;
	if (strcmpi(token, "tl") == 0) {
	    fl_tl = 1;
	    return TL;
	}
	if (strcmpi(token, "class") == 0)
	    return CLASS;
	if (strcmpi(token, "}") == 0)
	    return '}';

	switch (c) {
	case VARIAV:{
		if ((s = veri_var(fd, token)) < 0) {

/* *** Padroniz. msg erro - Luciana 19/12/94
					strcpy(error,"Variavel ");
					strcat(error,token);
					execerro(error,"nao existe no arquivo");
*** */
		    sprintf(error, PegaMsg(3056), token);
		    execerro(error, CNULL);
		} else {
		    yylval.simb = s;
		    return VARIAVEL;
		}
	    }

	case PTVG:
	    return ';';

	case IGUAL:
	    return '=';
	}
    } else {
	token_tl();
	fl_tl = 0;
	return STRING;
    }

    return 0;

}

/* ------------------------------------------------------------------ */

void int_var()
{				/* preenche ef, efts com informacoes sobre intercepto */

    if (fl_int) {
	sv[0] = 0;
	np = 1;
	ef[0][0] = -3;
	strcpy(p, "cl");
	efts[0] = p;
	p += (strlen(p) + 1);
    } else {
	np = 0;
    }
}

/* ------------------------------------------------------------------ */

void m_var(pos)
int pos;			/* preenche ef,efts,sv com info sobre var. do MANTER */
{
    char tipo;
    double mmin, mmax;
    char nomev[16];


    ++nm;

    if (nm >= MAXMAN) {
	erro(2, 1);
    } else {
	pega_var(fd, pos, nomev, &tipo, (MINVAL *) & mmin,
		 (MAXVAL *) & mmax);
	if (tipo != 'n')
	    erro(1, 1);

	strcpy(p, nomev);
	efts[np + nm] = p;
	p += (strlen(p) + 1);

	v_man[nm - 1] = pos;
	ef[np + nm][0] = -2;
	ef[np + nm][1] = pos;
	sv[np + nm] = nm - !fl_int;
    }
}

/* ------------------------------------------------------------------ */

void d_var(pos)
int pos;			/* preenche ef, etfs, sv com info sobre var. dependente */
{
    int i;
    char tipo;
    double mmin, mmax;
    char nomev[16];

    extern int ndep;

    for (i = 0; i < nm; ++i) {
	if (v_man[i] == pos) {
	    erro(6, 0);
	}
    }

    pega_var(fd, pos, nomev, &tipo, (MINVAL *) & mmin, (MAXVAL *) & mmax);
    if (tipo != 'n')
	erro(1, 1);

    strcpy(p, nomev);
    efts[fl_int] = p;
    p += (strlen(p) + 1);

    ef[fl_int][0] = -3;
    ef[fl_int][1] = pos;

    np += (nm + 1);		/* local para a proxima var. a ser lida */
}


/* ------------------------------------------------------------------ */

void i_var(pos)
int pos;			/* preenche ef, efts, sv com info sobre vars independentes */
{
    int i;
    int ok = 1;
    char tipo;
    double mmin, mmax;
    char nomev[16];


    for (i = 0; i < nm; ++i) {
	if (v_man[i] == pos) {
	    ok = 0;
	    break;
	}
    }

    if (ef[fl_int][1] == pos)
	erro(5, 0);

    if (ok) {			/* so para var. que nao esteja no manter */
	++ni;

	if (ni >= MAXIND) {
	    erro(3, 1);
	} else {
	    pega_var(fd, pos, nomev, &tipo, (MINVAL *) & mmin,
		     (MAXVAL *) & mmax);
	    if (tipo != 'n')
		erro(1, 1);

	    strcpy(p, nomev);
	    efts[np] = p;
	    p += (strlen(p) + 1);

	    ef[np][0] = -1;
	    ef[np][1] = pos;
	    sv[np++] = ni + nm - !fl_int;
	}
    }
}

/* ------------------------------------------------------------------ */

void set_val()
{				/* seta valor final de np, nxlx, ndim ,sv */
    extern int ndep;

    sv[fl_int] = np - 1;
    sv[np] = np;

    nxlx = np - 1;
    ndim = np;

    if (ndim >= MAXMEM)
	erro(0, 1);

    if (pflag)
	print_par();
}

/* ------------------------------------------------------------------ */

void token_tl()
{
    int i = 0;
    int c;

    while (((c = xgetc(stdin)) == ' ') || (c == '\t') || (c == '\n') || (c == '\r'));
    while (c != ';' && i < 127) {
	titulo[i++] = (char) c;
	c = xgetc(stdin);
    }
    titulo[i] = 0;

    if (i < 80)
	unxgetc(c, stdin);
    else {
	i = 0;
	while (c != ';' && (i < 256));
	if (i < 256)
	    unxgetc(c, stdin);
	else
	    erro(8, 1);
    }
}
