
/* ----------------------------------------------------------------------------
** @(#)stepwise.h	3.2	(NTIA/stepwise)	95/05/25
**
** 
**
** Programado por:
**
**	Sonia Ternes
**
** Data da ultima alteracao:
**
**		95/05/25 09:38:30
**
** ----------------------------------------------------------------------------
*/


#ifndef EXTERN
# define	EXTERN	extern
#endif

#ifdef MSDOS
# define MY_HUGE	huge
# define TIPO		long
# define HALLOC		halloc
# define HFREE		hfree
# define TINT		unsigned
#else
# define MY_HUGE
# define TIPO		unsigned
# define HALLOC		calloc
# define HFREE		free
# define TINT		int
#endif

#include <math.h>

#if !defined(VAXVMS) & !defined(SCO) & !defined (i486)
#include <search.h>
#endif

#include "pcsgbd.h"

#define MAXMEM	 111
#define MAXMAN   10
#define MAXIND   100
#define MAXCLASS 8
#define MAXMEM1  MAXMEM-1
#define MAXITER  MAXIND

#define EPS	1.e-15
#define CNULL	(char *) NULL

/* estruturas com informacoes sobre o modelo corrente */

EXTERN struct s_anova {
	int gl;		 /* grau de liberdade */
	double squad;	 /* soma de quadrados */
	double msquad;   /* quadrado medio */
	double vF;	 /* teste F */
	double pF;	 /* p value */
} s_anova ;

EXTERN struct s_anova reg;
EXTERN struct s_anova res;

EXTERN struct tabelaF { /* variaveis a entrar e a sair do modelo */
	int col;	/* coluna da variavel em xlx */
	double coef;	/* valor do coeficiente */
	double dp;	/* desvio padrao */
	double vF;	/* teste F */
	double pF;	/* p value */
} tabelaF ;

EXTERN struct tabelaF Fenter[MAXIND];
EXTERN struct tabelaF Fsai[MAXIND];

EXTERN struct coeficiente { /* informacoes sobre o coef. linear */
	double vl;	/* valor do coef. linear */
	double dp;	/* desvio padrao */
} coeficiente ;

EXTERN struct coeficiente Coef;

EXTERN ARQ		*fd;		/* apontador para o arquivo de dados */
EXTERN char  		buffer[128];

EXTERN int tenter;			/* numero de elementos de Fenter */
EXTERN int		n_class;	/* numero de var. de classe */
EXTERN int		ordc;		/* tipo de ordenacao em class */
EXTERN int		nxlx;		/* dimensao da matriz x'x */
EXTERN int		ndim;		/* dimensao da matriz z'z */
EXTERN int		nxlxs;		/* dimensao da matriz x'x corrente*/
EXTERN int		ni;		/* numero de var. independentes */
EXTERN int		nm;		/* numero de var. do MANTER */
EXTERN int		np;		/* num. total de parametros */
EXTERN int		ultcol;		/* ultima coluna sweepada */

EXTERN int		glr;		/* graus de liberdade do residuo */
EXTERN int		glt;		/* graus de liberdade do total */
EXTERN int		glm;		/* graus de liberdade do modelo */
EXTERN double		qmr;		/* quadrado medio do erro */
EXTERN double		alfas;		/* nivel de significancia para sair*/
EXTERN double		alfae;		/* nivel de significancia para entrar*/
EXTERN double		c_det;		/* Coef. determinacao */
EXTERN double		c_aju;		/* Coef. Det. Ajustado */

EXTERN int		sv[MAXMEM1];	/* coluna da var. em xlx */
EXTERN int		v[MAXMEM1];	/* */
EXTERN double		saida[5*MAXMEM];/* saida de cada observacao */
EXTERN double		css[MAXMEM];	/* corrected sum of squares */
EXTERN double		sse[MAXMEM];	/* sum squares of error */
EXTERN double		soma[MAXMEM];	/* soma das observacoes */
EXTERN double		varia[MAXMEM];	/*  variancia */
EXTERN int		ef[MAXMEM1][2];	/* par de efeitos */
EXTERN int		v_man[MAXMAN];	/* posicao das var. do manter */
EXTERN int		classv[MAXCLASS]; /* posicao das var. de classe */
EXTERN int		tip_by[MAXCLASS]; /* tipo das var. de classe */

EXTERN double 		obs[MAXMEM];	/* observacao lida */
EXTERN double MY_HUGE	*xlx;		/* matriz z'z */
EXTERN char		*p;		/* ponteiro para a area nao usada */
EXTERN char		area[1024];	/* area para quardar strings */
EXTERN char		titulo[128];	/* titulo geral do programa */
EXTERN char		*efts[MAXMEM];  /* nomes dos efeitos */
EXTERN char		*efts_by[MAXCLASS];  /* nomes das var. de classe */

EXTERN int		fl_int;		/* Usar intercpeto ou nao */
EXTERN int		fl_imp;		/* pular pagina */
EXTERN int		fl_correl;	/* imprime matriz de correlacao */
EXTERN int		pflag;		/* impressao de leitura */
EXTERN int		rflag;		/* passos do sweep */
EXTERN int		flagX;		/* permissao para execucao */
EXTERN int		iterativo;	/* iterativo ou batch */
EXTERN int		n_iter;		/* numero de iteracoes */

/* ----------------------- Funcoes utilizadas --------------------------- */

#ifdef MSDOS
 extern void	inicioby(void);
 extern void 	by(int);
 extern int	class(void);
 extern void	cria_xlx(void);
 extern double	cxlxcl(void);
 extern double	doolitle(double *,int );
 extern void	erro(int,int);
 extern void	execerro(char *,char *);
 extern void	expand_mat(void);
 extern void	getarg(int ,char * *);
 extern TINT	idx(int ,int );
 extern TINT	idy(int ,int );
 extern int	missing(void);
 extern void	print_par(void);
 extern void	print_xlx(void);
 extern void	sweep(int);
 extern void	usage(void);
 extern void 	executa(int ,int );
 extern void 	inicializa(void);
 extern void 	imp_titulo(char *);
 extern void	token_tl(void);
 extern int 	number(double *, char * *, int *);
 extern int 	prtcor(void);
 extern double  calc_pv(double);
 extern double	calc_cor(int,int);
 extern void	prtdes(int);
 extern	int	stepwise(int);
 extern void 	anv_s(void);
 extern void 	anv_i(void);
 extern void	ite_s(int,int);
 extern void	ites_s(int,int);
 extern void	ite_i(int,int);
 extern void	ent_s(void);
 extern void	sai_s(void);
 extern void	poe_tabF();
 extern void	par_reg(double *,double *,double *,double *);
 extern void	poe_reg(double,double,double,double);
 extern int	sai_i(void);
 extern void 	putchr1(void);
 extern int	s_sweep(int);
 extern int 	mensagem(int);
 extern void	int_var(void);
 extern void	m_var(int);
 extern void	d_var(int);
 extern void	i_var(int);
 extern int	tab_F(int,double,double *);
 extern int  	v_ent(void);
 extern int  	v_sai(void);
 extern int	poe(int, int *);
 extern int	peg_pos(int);
 extern void	tira(int, int *);
 extern int	tira_var(int,int *,int *);
 extern void	zera_F(void);
 extern void	erroclass(void);
 extern void	com_manter(void);
 extern void	exec(void);
 extern void	initcode(void);
 extern void	f_qm(int);
 extern void	cop_mod(int *);
 extern void	atu_Fsai(void);
 extern void	set_val(void);
 extern void	yyerror(char *);
 extern int	yylex(void);
 extern int	yyparse(void);
 extern int	sem_manter(int);
 extern int	escolhe(int, int *);
 extern void	poe_tabF(void);
#else
 extern void	inicioby();
 extern void 	by();
 extern int	class();
 extern void	cria_xlx();
 extern double	cxlxcl();
 extern double	doolitle();
 extern void	erro();
 extern void	execerro();
 extern void	expand_mat();
 extern void	getarg();
 extern TINT	idx();
 extern TINT	idy();
 extern int	missing();
 extern void	print_par();
 extern void	print_xlx();
 extern void	sweep();
 extern void	usage();
 extern void 	executa();
 extern void 	inicializa();
 extern void 	imp_titulo();
 extern void	token_tl();
 extern int 	number();
 extern int 	prtcor();
 extern double  calc_pv();
 extern double	calc_cor();
 extern void	prtdes();
 extern	int	stepwise();
 extern void 	anv_s();
 extern void 	anv_i();
 extern void	ite_s();
 extern void	ites_s();
 extern void	ite_i();
 extern void	ent_s();
 extern void	sai_s();
 extern void	poe_tabF();
 extern void	par_reg();
 extern void	poe_reg();
 extern int	sai_i();
 extern void 	putchr1();
 extern int	s_sweep();
 extern int 	mensagem();
 extern void	int_var();
 extern void	m_var();
 extern void	d_var();
 extern void	i_var();
 extern int	tab_F();
 extern int  	v_ent();
 extern int  	v_sai();
 extern int	poe();
 extern int	peg_pos();
 extern int	tira_var();
 extern void	tira();
 extern void	zera_F();
 extern void	erroclass();
 extern void	com_manter();
 extern void	exec();
 extern void	initcode();
 extern void	f_qm();
 extern void	cop_mod();
 extern void	atu_Fsai();
 extern void	set_val();
 extern void	yyerror();
 extern int	yylex();
 extern int	yyparse();
 extern int	sem_manter();
 extern int	escolhe();
 extern void	poe_tabF();
#endif

