
/***********************************************************************************
 STEPWISE - Anlise de Modelos de Regresso via mtodo stepwise

 Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

 Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob os
 termos da Licena Pblica Geral GNU conforme publicada pela Free Software
 Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
 posterior.

 Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
 GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
 FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais detalhes.

 Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
 programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

 **********************************************************************************

 Parte integrante do SOC - SOftware Cientfico

 Descrio:

	Preenche o quadro de F para entrar e se a varivel for
	uam boa candidata para entrar no modelo, preenceh o quadro
	de anlise de varincia e o quadro de F para sair.

 Desenvolvido por:

	Dalton Francisco Andrade
	Snia Ternes 
	Slvio Roberto Medeiros Evangelista

 Informaes do CVS:
        $Source: /cvsroot/soc/soc/src/stepwise/fontes/tabf.c,v $:
        $Revision: 1.1 $:
        $Date: 2005/03/22 19:17:18 $:

***********************************************************************************/


#include <stdio.h>
#include "stepwise.h"

static char *sccsid = "@(#)tabf.c	3.1	(NTIA/stepwise)	94/10/24";

int tab_F(k, Sq, maiorF)
int k;
double Sq;
double *maiorF;
{
    extern double squad;
#ifdef EDIX
    double *dp;
#endif

    int flag = 0;
    double x1, x2, valorf, vf, a, a1;

    /* Preencher a tabela de F para entrar */

    glm = nxlxs - fl_int;
    glr = (glt - fl_int) - glm;	/* gl do residuo */

    /* Calcula as estatisticas da regressao */
    par_reg(&x1, &x2, &valorf, &a);

    vf = (Sq - sse[ultcol]) / qmr;
    a1 = fprob(vf, 1.0, (double) glr);

    if ((a1 < alfae) && (vf > *maiorF)) {	/* entrou no modelo */
	/* preenche ANV */
	poe_reg(x1, x2, valorf, a);

	/* preenche quadro de F para sair */
	poe_tabF();

	*maiorF = vf;
	flag = 1;
    }

    /* preenche quadro de F para entrar */
    Fenter[tenter].coef = xlx[idx(nxlx, k)];
    Fenter[tenter].dp = sqrt(xlx[idx(k, k)] * qmr);
    Fenter[tenter].col = k;
#ifdef EDIX
    dp = &(Fenter[tenter].vF);
    *dp = vf;
    dp = &(Fenter[tenter++].pF);
    *dp = a1;
#else
    Fenter[tenter].vF = vf;
    Fenter[tenter++].pF = a1;
#endif

    return (flag);
}
