
/***********************************************************************************
Video - Biblioteca padro para Recursos de Vdeo

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
		Pegar resposta num campo especifico da tela, permitindo
		edicao do mesmo.

	Forma de uso:

		ret = pegares(buffer, tipo, tam, linha, coluna)

		int   ret    : Retorna ultimo caracter.
		char *buffer : Cadeia contendo conteudo do campo.
		int tipo     : ALFANUM_C = campo alfanumerico entre [].
			       NUMERIC_C = campo numerico entre [].
			       FLOAT_C   = campo flutuante entre [].
			       DATA_C    = campo data entre [].	
			       ALFANUM_S = campo alfanumerico sem [].
			       NUMERIC_S = campo numerico sem [].
			       FLOAT_S   = campo flutuante sem [].
			       DATA_S    = campo data sem [].	
			       ....._M   = idem anteriores com formato.
		int   tam    : Numero de caracteres do campo.
		int   linha  : Numero da linha onde sera lido o campo.
		int   coluna : Numero da coluna onde comeca o campo.

	Desenvolvido por:

		Oscar Ivan Palma Pacheco, NTIA/EMBRAPA, Campinas.

            Paulo Cesar de Oliveira

		Adriano de Carvalho
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#ifdef ULTRIX
# include	<cursesX.h>
#else 
# include	<stdio.h>

# ifdef i486
#   include 	<ncurses.h>
# else
#   include	<curses.h>
# endif

#endif

#ifdef MSDOS
# include	<stdlib.h>
#endif

#include	<ctype.h>
#include	<string.h>

#include	"video.h"

/*
** Tratamento de Cores no Form.
*/

#include "color.h"
#include "colorf.h"

#ifdef MSDOS
# define A_NORMAL	0
#endif

extern WINDOW	*werr;

#ifdef WERR
void		 list_err(char *);
#endif

#if defined(WERR) | defined(WERR1)
  static char	 bufferr[50];
#endif

#define  Bissexto(a)	(((a)%4 == 0) && ((a)%100 != 0) || ((a)%400 == 0)) 

int		 diadomes[12] = {
				31,	/* Janeiro	*/
				29,	/* Fevereiro	*/
				31,	/* Marco	*/
				30,	/* Abril	*/
				31,	/* Maio		*/
				30,	/* Junho	*/
				31,	/* Julho	*/
				31,	/* Agosto	*/
				30,	/* Setembro	*/
				31,	/* Outubro	*/
				30,	/* Novembro	*/
				31	/* Dezembro	*/
};

#ifdef MSDOS
  int	datatonum(char *, int);
#endif
 
/*
** ----------------------------------------------------------------------------
** Esta funcao verifica a consistencia de strings que correspondem a datas
** no DISPLAY.
** ----------------------------------------------------------------------------
*/

int	datatonum(s, ret)
char	s[];		/* string que corresponde a data no display */
int	ret;		/* ultimo caracter digitado */
{
	int	 i;
	char	*pchar;
	int	 dia;
	int	 mes;
	int	 ano;
	int	 barra;	/* Numero de barras ('/') na string */

	/*
	* Inicializa variaveis de contagem.
	*/

	barra = dia = mes = ano = 0;

	/*
	** Conta o numero de barras na string e as substitui por '\0'
	** para tratamento de dia, mes e ano em separado.
	*/

	for (i = 0; s[i]; ++i) {
		if (s[i] == '/') {
			++barra;
			s[i] = '\0';
		}
	}

	/*
	** Se nao tiver duas barras, ERRO: Campo data invalido.
	*/

	if (barra != 2)
		return 8;

	/*
	** Verifica se o campo data esta' vazio.
	*/

	if (ret == '\n' && s[0] == ' ' && s[1] == ' ') {
		s[0] = '\0';

		return 2;
	}

	/*
	** Verifica caracter de busca de campo vazio.
	*/

	if (s[0] == '!') {
		if (s[1] == '!')
			return 7;

		if (ret == '\n')
			return 2;

		if (ret == '!')
			return 0;

		return 6;
	}

	else if ((s[0] == '*' || s[1] == '*') && ret == '\n') {
		if (atoi(&s[3]) == 0 && atoi(&s[6]) == 0) {
			strcpy(s, "*");

			return 2;
		}
	}

	/*
	** Interpreta area correspondente ao dia
	*/

	pchar = s;

	if (strlen(pchar) && (pchar[0] == '*' || pchar[1] == '*'))
		/*
		** Busca de dia
		*/

		dia = 10000;
	else
		/*
		** Pega o dia
		*/

		dia = atoi(pchar);

	/*
	** Interpreta area correspondente ao mes
	*/

	pchar += (strlen(pchar) + 1);

	if (strlen(pchar) && (pchar[0] == '*' || pchar[1] == '*'))
		/*
		** Indica busca de mes
		*/

		mes = 10000;
	else
		/*
		** Pega o mes
		*/

		mes = atoi(pchar);

	/*
	** Interpreta area correspondente ao ano
	*/

	pchar += (strlen(pchar) + 1);

	if (strlen(pchar) && (pchar[0] == '*' || pchar[1] == '*'))
		/*
		** Indica busca de ano
		*/

		ano = 10000;
	else {
		/*
		** Obtem ano
		*/

		ano = atoi(pchar);

		if (ano > 9999)
			/*
			** ERRO: Ano invalido
			*/

			return 5;
	}

	/*
	** Primeiro teste de validade do dia.
	*/

	if (dia > 31 && dia != 10000)
		return 3;

	if (mes > 0 && dia == 0)
		return 3;

	/*
	** Primeiro teste de validade do mes.
	*/

	if (mes > 12 && mes != 10000)
		return 4;

	if (ano > 0) {
		/*
		* Segundo teste de validade do mes
		*/

		if (mes == 0)
			return 4;

		/*
		* Segundo teste de validade do dia
		*/

		if (mes != 10000 && dia > diadomes[mes-1] && dia != 10000)
			return 3;
	}

	/*
	** Verifica dias do mes de fevereiro no caso de ano bissexto.
	*/

	if ((ret == '\n' || ano > 1500) && mes == 2) {
		if (ano != 10000 && dia != 10000) {
			if (!Bissexto(ano))
				diadomes[1] = 28;

			if (dia > diadomes[1]) {
				diadomes[1] = 29;

				/*
				** ERRO: Dia Invalido
				*/

				return 3;
			}

			diadomes[1] = 29;
		}
	}

	/*
	** modifica o conteudo da string s retirando as barras e
	** escrevendo a data no formato ano mes dia
	*/

	if (ret == '\n') {
		/*
		** Terceiro teste de validade do dia.
		*/

		if (dia == 0)
			return 3;

		/*
		** Ultimo teste de validade do mes.
		*/

		if (mes == 0)
			return 4;

		/*
		** Ultimo teste de validade do dia.
		*/

		if (ano == 0) {
			if (mes!=10000 && dia>diadomes[mes-1] && dia!=10000)
				return 3;
		}

		if (ano == 10000)
			sprintf(s, "&&&&");
		else
			sprintf(s, "%4d", ano);

		if (mes == 10000)
			sprintf(&s[4], "&&");
		else
			sprintf(&s[4], "%02d", mes);

		if (dia == 10000)
			sprintf(&s[6], "&&");
		else
			sprintf(&s[6], "%02d", dia);

	}

	return barra;
}

#ifdef RS6000
int	chtecla(aux)
int	aux;
{
	switch (aux) {

	case 0xc3:

		aux = KEY_LEFT;

		break;

	case 0xb4:

		aux = KEY_RIGHT;

		break;

	case 0xc2:

		aux = KEY_UP;

		break;

	case 0xc1:

		aux = KEY_DOWN;

		break;

	case 0xda:

		aux = KEY_HOME;

		break;

	case 0xc0:

		aux = KEY_LL;

		break;

	case 0xbf:

		aux = KEY_PPAGE;

		break;

	case 0xd9:

		aux = KEY_NPAGE;

		break;

	case 0xb3:

		aux = KEY_IC;

		break;

	case 0xc4:

		aux = KEY_DC;

		break;
	}

	return aux;
}
#endif

static int	 aux;	/* Armazena o que foi teclado por ultimo */
static int	 ilin;	/* Linha atual na janela corrente */
static int	 icol;	/* Coluna atual na linha atual da janela corrente */
static char	 trat;
static int	 itam;		/* Numero de posicoes preenchidas no campo */
static WINDOW	*win;		/* Janela que representa o conteudo do campo */
static WINDOW	*winf;		/* Janela de fundo para para colocar [] */
static WINDOW	*winm;		/* Janela para mostra mensagens */
static int	 nlins;		/* Numero de linhas do campo na tela */
static int	 ncols;		/* Numero de colunas do campo na tela */
static int	 firstline;	/* Variavel auxiliar para normalizar a primeira
				   linha do campo */
static int	 lastline;	/* Variavel auxiliar para normalizar a ultima
				   linha do campo */
static int	 estado;	/* Estado da maquina de estados para controlar
				   CCTRL('A') e CCTRL('W') */
static char	 format[30];
static char	 charcmp;
static char	 toContinue = 0;
static int	 prevTam;

#ifdef MSDOS
void wputcampo(WINDOW *, char *, int, int);
#else
void wputcampo();
#endif

void wputcampo(winc, res, itamc, ncolsc)
WINDOW *winc;
char *res;
int itamc;
int ncolsc;
{
	int i;
	int j;

	j = -1;

	for (i = 0; i < itamc; ++i) {
		if (i % ncolsc == 0)
			wmove(winc, ++j, 0);

		waddch(winc, res[i]);
	}

	wnoutrefresh(winc);
}

int	 pegares(res, tipo, tam, linha, coluna)
char	*res;
int	 tipo;
int	 tam;
int	 linha;
int	 coluna;
{
	int	 i;
	int	 tipoa;	/* Armazena tipo original */ /* ALTERADO */
	int	 j;
	int	 k;
	int	 l;
	int	 datatam;
	int	 nsch1;
	int	 nsch2;
	int	 chbusca;
	int	 ii;
	char	 c;
	char	 ch;
	int	 loop;

	loop = 1;
	tipoa = tipo;

	if (limpaResp(tipo)) {
		toContinue = 0;
		loop = 0;
		res[0] = '\0';
	}

	else if (toContinue)
		tam = prevTam;

	else {
		charcmp = 0;

#ifdef WERR
		list_err("ENTRANDO NO PEGARES");
#endif

		if (tam < 0) {
			tam = - tam;
			trat = 1;
		}
		else
			trat = 0;

		ncols = UNPACKCOLS(tam);
		nlins = UNPACKLINES(tam);

		/*
		** Linhas em uma janela sao numeradas de 0 a nlins-1.
		** A variavel nlins guarda o numero de linhas da janela.
		** Devido a forma como nlins e' calculada, ha' um ajuste
		** quando ela vale 0. Firstline e lastline sao definidas
		** neste ponto do programa
		** Paulo Cesar & Adriano           02/07/1992
		*/

		firstline = 0;

		if (nlins == 0) {
			nlins = 1;
			lastline = 0;
		}

		else
			lastline = nlins - 1;

		tam = ncols * nlins;

		/*
		** Reproduzir texto de acordo com opcoes.
		*/

		datatam = strlen(res);

		if (isData(tipo)) {
			if (datatam && res[0] == ' ' && res[1] == ' ')
				datatam = 0;

			if (!datatam)
				strcpy(res, "  /  /    ");
		}

		if (isNumeric(tipo)) {
			char *p;
			
			if (isMasked(tipo)) {
				strncpy(format, res+strlen(res)+1, tam);
				format[tam] = '\0';

				p = format;

				while (*p) {
					if (*p != '.' && *p != ',')
						*p = ' ';

					++p;
				}

				if (datatam) {
					p = &res[tam-1];

					while (*p == '.' || *p == ',')
						--p;

					if (*p == ' ')
						datatam = 0;
				}

				if (datatam) {
					for (i = 0; i < datatam; ++i) {
						if (res[i] == ' ')
							res[i] = format[i];
					}
				}

				else
					strcpy(res, format);
			}

			else {
				strncpy(format,
					"                            ", tam);
				format[tam] = '\0';

				if (datatam) {
					i = tam;
					j = datatam;

					while (j >= 0) {
						res[i--] = res[j--];
					}

					while (i >= 0) {
						res[i--] = ' ';
					}
				}

				else
					strcpy(res, format);
			}
		}

		itam = strlen(res);

		if (itam > tam) {
			res[tam] = '\0';
			itam = tam;
		}

		winf = (WINDOW *) NULL;

		if(win  != (WINDOW  *) NULL)
		/* Vide o comentario (1) abaixo */
			delwin(win);
		win = newwin(nlins, ncols, linha, coluna);
#ifdef WERR1
		winm = newwin(1, 50, linha+nlins+1, 5);
#endif

		keypad(win, TRUE);
		wattrset(win, A_REVERSE);

		/*
		** Ajusta cor do campo se for permitido cores.
		*/

		ajustaAtributos(win,menu_colors[ncolor_set][COR_JANELA_DESCRICAO]);

		for (i = 0; i < nlins; ++i) {
			wmove(win, i, 0);
			putnchar(win, ncols, ' ');
		}

		wmove(win, 0, 0);

		if(winf  != (WINDOW  *) NULL)
			/* Vide o comentario (1) abaixo */
			delwin(winf);

		winf = newwin(nlins, ncols+2, linha, coluna > 0 ? coluna-1 : 0);
		keypad(winf, TRUE);

		/*
		** Ajusta cor do campo se for permitido cores.
		*/

		ajustaAtributos(winf,menu_colors[ncolor_set][COR_JANELA_DESCRICAO]);
		if (isBracketed(tipo)) {
			/*
			** Insere delimitadores de campo ('[', '|', ']').
			*/

			ajustaVideoReverso(winf, TRUE);

			for (i = 0; i < nlins; ++i) {
				wmove(winf, i, 0);

				if (i == 0)
					waddch(winf, '[');
				else
					waddch(winf, '|');

				if (i == nlins - 1)
					mvwprintw(winf, i, ncols+1, "]");
				else
					mvwprintw(winf, i, ncols+1, "|");
			}

			ajustaVideoReverso(winf, FALSE);
			wnoutrefresh(winf);
		}

		wputcampo(win, res, itam, ncols);

		doupdate();

		/*
		** Colocar cursor na posicao especificada no campo de resposta.
		*/

		if (isData(tipo) && !datatam) {
			icol = 0;
			ilin = 0;
		}
		else if (isNumeric(tipo)) {
			icol = itam;

			if (startCurPosAtBeg(tipo)) {
				if (res[icol-1] != ' ') {
					while (--icol && res[icol] != ' ')
						;
				}
			}

			ilin = 0;
		}
		else {
			if (startCurPosAtBeg(tipo)) {
				icol = 0;
				ilin = 0;
			}
			else {
				icol = itam % ncols;
				ilin = itam / ncols;
			}
		}
	}


	/*
	** Editar resposta.
	*/

	 while (loop) {

		/*
		** Verificar se esta' desistindo do comando "=..." (tipo 0).
		*/

		if (tipo == 0 && icol == 0 && ilin == 0) {
			tipo = tipoa;

			if (isData(tipo)) {
				strcpy(res, "  /  /    ");
				itam = strlen(res);
				wputcampo(win, res, itam, ncols);
				doupdate();
			}
		}

		/*
		** Se for numerico mascarado, refresh() nele.
		*/

		if (isNumeric(tipo) || isMasked(tipo))
			wrefresh(win);

		/*
		** Ler caracter.
		*/

		if (ilin == nlins || icol > ncols - 1) {
			wmove(winf, nlins - 1, ncols + 1);
			wrefresh(winf);

			aux = pgetch(winf);
		}
		else {
			wmove(win, ilin, icol);
			wrefresh(win);

			aux = pgetch(win);
		}

#ifdef RS6000
		aux = chtecla(aux);
#endif

#ifdef IRIX
		if (aux == KEY_ENTER)
			aux = '\n';
#endif

#ifdef WERR1
		sprintf(bufferr, "Tecla = 0x%04x", aux);
		ajustaVideoReverso(winm, TRUE);
		wmove(winm, 0, 0);
		wprintw(winm, bufferr);
		ajustaVideoReverso(winm, FALSE);
		wrefresh(winm);
#endif

		if (icol == 0 && ilin == 0 && aux == '=') {
			tipo = 0;

			if (isData(tipoa)) {
				res[0] = '\0';
				itam = 0;
				werase(win);
				wputcampo(win, res, itam, ncols);
				doupdate();
			}
		}

		switch (aux) {

		/*
		** Verificar termino e aceitacao do texto editado.
		*/

		case '\n':
		case KEY_UP:
		case KEY_DOWN:
		case KEY_HOME:
		case KEY_LL:
		case CCTRL('B'):
		case CCTRL('D'):
		case CCTRL('E'):
		case CCTRL('F'):
		case CCTRL('G'):
		case CCTRL('K'):
		case CCTRL('N'):
		case CCTRL('O'):
		case CCTRL('R'):
		case CCTRL('T'):
		case CCTRL('U'):
		case CCTRL('V'):
		case CCTRL('X'):
		case KEY_PPAGE:
		case KEY_NPAGE:
		case KEY_F(1):
		case KEY_F(2):
		case KEY_F(3):
		case KEY_F(4):
		case KEY_F(5):
		case KEY_F(6):
		case KEY_F(7):
		case KEY_F(8):
		case KEY_F(9):
		case KEY_F(10):
		case 0x1b:

			/*
			** Aceitacao do campo editado
			*/

			if (aux == '\n') {
				j = -1;

				/*
				** Leitura do campo para o buffer res.
				*/

				for (l = 0; l < itam; ++l) {
					if (l % ncols == 0) {
						++j;
						k = 0;
					}

					res[l] = (char) mvwinch(win, j, k);

					++k;
				}

				res[l] = '\0';

				/*
				** Verifica a consistencia da data
				*/

				if (isData(tipo)){
					if (datatonum(res, aux) != 2) {
						beep();

						continue;
					}

					if (charcmp) {
						char tmpb[30];

						strcpy(tmpb, res);
						res[0] = charcmp;
						res[1] = '\0';
						strcat(res, tmpb);
					}

					if (!strcmp(res, "00000000"))
						res[0] = '\0';
				}

				/*
				** Prepara campo numerico para retorno.
				*/

				if (isNumeric(tipo) || isFloat(tipo)) {
					char *p1, *p2;
					char tmpb[30];

					strcpy(tmpb, res);

					if (isMasked(tipo)) {
						tmpb[0] = '\0';

						p1 = p2 = res;

						while (*p2) {
							if (*p2=='.'||*p2==','){
								*p2 = '\0';
								strcat(tmpb,p1);

								p1 = p2 + 1;
							}

							++p2;
						}

						strcat(tmpb, p1);
					}

					p1 = tmpb;

					while (*p1 == ' ')
						++p1;

					if (strchr(res, '*'))
						strcpy(res, "*");

					else {
						i = 0;

						if (charcmp)
							res[i++] = charcmp;

						res[i] = '\0';

						strcat(res, p1);
					}
				}

				if (res[0] == '!')
					res[1] = '\0';

				toContinue = 0;
			}

			/*
			** Seta para acima.
			*/

			else if ( aux == KEY_UP ) {
				if (ilin == firstline ||
						(ilin == 1 && nlins == 1))
					res[0] = '\0';

				else {
					if (icol == ncols || ilin == nlins) {
						ilin = nlins - 2;
						icol = ncols - 1;
					}

					else
						--ilin;

					continue;
				}
			}

			/*
			** Seta para abaixo.
			*/

			else if ( aux == KEY_DOWN ){
				if (ilin == lastline || ilin == itam/ncols)
					res[0] = '\0';

				else {
					++ilin;

					if (!(ilin * ncols + icol < itam )){
						/*
						** corrige posicao do cursor se
						** posicao na linha ultrapassa o
						** tamanho do campo
						*/

						if ( itam == 0)
							icol = 0;
						else
							icol = itam - ilin*ncols;
					}

					continue;
				}
			}
			/*
			** KEY_F(8): ativa menu
			*/

			else if ( aux == KEY_F(8) || CCTRL('K')){
				return aux;
			}
			/*
			** Outras teclas: vai voltar.
			*/

			else if (aux != '\n' && retChgedStr(tipo)) {
				toContinue = 1;

				prevTam = tam;

				return aux;
			}

			/*
			** Outras teclas: nao vai voltar.
			*/

			else 
				res[0] = '\0';

			trat = 2;

			break;

		/*
		** Limpa o buffer.
		*/

		case CCTRL('Y'):

			for (i = 0; i < nlins; ++i)
				limpacam(win, res, i, 0, ncols);

			if (isData(tipo) || isNumeric(tipo)) {
				if (isData(tipo)) {
					strcpy(res, "  /  /    ");

					itam = strlen(res);
				}

				else {
					strcpy(res, format);

					itam = strlen(res);
				}

				j = -1;

				for (i = 0; i < itam; ++i) {
					if (i % ncols == 0)
						wmove(win, ++j, 0);

					waddch(win, res[i]);
				}

				wnoutrefresh(win);

				doupdate();

				if (isData(tipo))
					icol = 0;
				else
					icol = i;
			}

			else {
				itam = 0;
				icol = 0;
			}

			ilin = 0;

			continue;

		/*
		** Avancar ate' o comeco da proxima palavra.
		*/

		case CCTRL('W'):

			/*
			** Verificacao do uso no tipo apropriado.
			*/

			if (!isAlfaNum(tipo) || ilin*ncols+icol == itam) {
				beep();

				continue;
			}

			/*
			** Caracter corrente
			*/

			ch = (char) mvwinch(win, ilin, icol);

			/*
			** Estado inicial.
			*/

			if (isalnum(ch))
				estado = 1;

			else if (ispunct(ch))
				estado = 2;

			else
				estado = 3;

			/*
			** Maquina de estado para tratamento de palavras.
			*/

			while (estado) {
				++icol;

				/*
				** Verificando posicao do cursor
				*/

				if (ilin * ncols + icol == itam) {
					/*
					** Atingiu final do campo
					*/

					estado = 0;

					continue;
				}

				else if (icol == ncols) {
					++ilin;
					icol = 0;
				}

				ch = (char) mvwinch(win, ilin, icol);

				/*
				** Tratamento dos estados.
				*/

				switch(estado) {

				/*
				** Alfanumerico
				*/

				case 1:

					if ( ispunct(ch) ) {
						/*
						** Achou comeco da proxima
						** palavra
						*/

						estado = 0;
					}

					else if (isspace(ch))
						estado = 3;

					break;

				/*
				** Pontuacao
				*/

				case 2:

					if (isalnum(ch)) {
						/*
						** Achou comeco da proxima
						** palavra
						*/

						estado = 0;
					}

					else if (isspace(ch))
						estado = 3;

					break;

				/*
				** Branco
				*/

				case 3:

					if ( ispunct(ch) || isalnum(ch) ) {
						/*
						** Achou comeco da proxima
						** palavra
						*/

						estado = 0;
					}

					break;
				}
			}

			continue;

		/*
		** Voltar ate' o proximo comeco de palavra.
		*/

		case CCTRL('A'):

			/*
			** Verificacao do uso no tipo apropriado.
			*/

			if (!isAlfaNum(tipo) || (ilin == 0 && icol == 0)) {
				beep();

				continue;
			}

			/*
			** Caracter corrente
			*/

			--icol;

			if (icol < 0) {
				--ilin;
				icol = ncols - 1;
			}

			ch = (char) mvwinch(win, ilin, icol);

			/*
			** Determinar estado atual.
			*/

			if (isalnum(ch))
				estado = 1;

			else if (ispunct(ch))
				estado = 2;

			else
				estado = 3;

			/*
			** Maquina de estados para tratamento de palavras.
			*/

			while (estado) {
				/*
				** Verificando posicao do cursor
				*/

				if (ilin == 0 && icol == 0) {
					/*
					** Atingiu inicio do campo
					*/

					estado = 0;

					continue;
				}

				/*
				** Recuando o cursor.
				*/

				--icol;

				if (icol < 0) {
					--ilin;
					icol = ncols - 1;
				}

				ch = (char) mvwinch(win, ilin, icol);

				/*
				** Tratamento dos estados.
				*/

				switch(estado) {

				/*
				** Alfanumerico
				*/

				case 1:

					if (ispunct(ch) || isspace(ch)) {
						++icol;
						estado = 0;
					}

					break;

				/*
				* Pontuacao
				*/

				case 2:

					if (isspace(ch) || isalnum(ch)) {
						++icol;
						estado = 0;
					}

					break;

				/*
				* Branco
				*/

				case 3:

					if ( isalnum(ch) )
						estado = 1;

					else if ( ispunct(ch) )
						estado = 2;

					break;
				}

				if (icol == ncols && ilin < nlins -1) {
					icol = 0;
					++ilin;
				}
			}

			continue;

		/*
		** Tecla DELETE: Apaga o caracter na posicao corrente
		** deslocando os demais caracteres..
		*/

		case 0x7f:
		case KEY_DC:
#ifndef Solaris
			if ((icol >= 0 || ilin > 0) && icol < itam) {
				char	c1;
				int	k1;
				int	k2;

				if (!isData(tipo) && !isNumeric(tipo))
					--itam;

				c1 = (char) mvwinch(win, ilin, icol);

				if (isData(tipo)) {
					if (c1 == ' ')
						beep();
					else {
						wmove(win, ilin, icol);
						waddch(win, ' ');
					}
				}

				else if (isNumeric(tipo)) {
					k1 = k2 = icol;

					if (c1 == ' ' || icol == itam) {
						beep();
						k1 = 0;
					}

					while (k1) {
						do {
							--k1;

							c1 = (char)mvwinch(win,
								ilin,k1);

							if (!isMasked(tipo))
								break;
						} while (c1=='.' || c1==',');

						wmove(win, ilin, k2);
						waddch(win, c1);

						wmove(win, ilin, k1);
						waddch(win, ' ');

						if (c1 == ' ')
							break;

						k2 = k1;
					}

					if (icol == 0) {
						wmove(win, ilin, icol);
						waddch(win, ' ');
					}

					c1 = (char) mvwinch(win, ilin, icol);

					if (c1 == ' ') {
						while (icol < itam) {
							++icol;

							c1 = (char) mvwinch(win,
								ilin,icol);

							if (!isMasked(tipo))
								break;

							if (c1!='.' && c1!=',')
								break;
						}
					}
				}

				else {
					wmove(win, ilin, icol);

					wdelch(win);

					for (j = ilin; j < nlins-1; ++j) {
						c = (char) mvwinch(win, j+1, 0);
						wdelch(win);

						wmove(win, j, ncols-1);
						waddch(win, c);
					}

					wmove(win, j, ncols-1);
					waddch(win, ' ');
				}
			}

			else
				beep();

			continue;

		/*
		** Tecla BSP: Volta o cursor apagando o caracter anterior.
		** Se for Numerico com Mascara fica na mesma posicao.
		*/

#endif /* SUN */
		case CCTRL('H'):
#if defined(RS6000) | defined(i486)
		case KEY_BACKSPACE:
#endif

			if (icol > 0 || ilin > 0) {
				if (!isData(tipo) && !isNumeric(tipo))
					--itam;

				ii = icol;

				if (icol == 0) {
					icol = ncols - 1;
					--ilin;
				}

				else
					--icol;

				if (isData(tipo)) {
					if (icol == 2 || icol == 5)
						--icol;

					wmove(win, ilin, icol);

					waddch(win, ' ');
				}

				else if (isNumeric(tipo)) {
					int	k1;
					int	k2;

					c = (char) mvwinch(win, ilin, icol);

					j = icol;

					while (j && (c == '.' || c == ',')) {
						if (!isMasked(tipo))
							break;

						c = (char)mvwinch(win,ilin,--j);
					}

					k1 = k2 = j;

					if (c == ' ') {
						beep();
						k1 = 0;
					}

					while (k1) {
						do {
							if (--k1 < 0)
								break;

							c = (char)mvwinch(win,
								ilin,k1);

							if (!isMasked(tipo))
								break;
						} while (c=='.' || c==',');

						if (k1 < 0)
							break;

						wmove(win, ilin, k2);
						waddch(win, c);

						wmove(win, ilin, k1);
						waddch(win, ' ');

						k2 = k1;

						if (c == ' ')
							break;
					}

					if (k1 <= 0) {
						wmove(win, ilin, k2);
						waddch(win, ' ');
					}

					icol = ii;

				}

				else {
					wmove(win, ilin, icol);

					wdelch(win);

					for (j = ilin; j < nlins-1; ++j) {
						c = (char) mvwinch(win, j+1, 0);
						wdelch(win);

						wmove(win, j, ncols-1);
						waddch(win, c);
					}

					wmove(win, j, ncols-1);
					waddch(win, ' ');
				}
			}

			else
				beep();

			continue;

		/*
		** Tecla de retroceso: volta o cursor uma posicao.
		*/

		case KEY_LEFT:

			if (isNumeric(tipo)) {
				c = (char) mvwinch(win, ilin, icol-1);

				if (c != ' ' && icol > 0) {
					j = icol-1;

					while (j && (c == '.' || c == ',')) {
						if (!isMasked(tipo))
							break;

						c = (char)mvwinch(win,ilin,--j);
					}

					if (isMasked(tipo)) {
						if (c!='.' && c!=',' && c!=' ')
							icol = j;
						else
							beep();
					}

					else if (c != ' ')
						icol = j;

					else
						beep();
				}

				else
					beep();
			}

			else if (icol > 0 || ilin > 0) {
				if (icol == 0) {
					icol = ncols -1;
					--ilin;
				}

				else
					--icol;
			}

			else if (trat) {
				trat = 2;

				break;
			}

			else
				beep();

			if (isData(tipo)) {
				if ((char) mvwinch(win, ilin, icol) == '/')
					--icol;
			}
			
			continue;

		/*
		** Tecla de avanco: avanca o cursor uma posicao.
		*/

		case KEY_RIGHT:

			if (isData(tipo) && icol == 0 && trat &&
					(char) mvwinch(win, ilin, 0) == ' ' &&
					(char) mvwinch(win, ilin, 1) == ' ') {
				trat = 2;

				break;
			}

			if (ilin * ncols + icol < itam && ilin < nlins) {
				if (icol < ncols-1 && !isMasked(tipo)) {
					++icol;
				}

				else if (isMasked(tipo)) {
					j = icol;

					c = (char)mvwinch(win,ilin,++j);

					while (c == '.' || c == ',') {
						if (++j == ncols)
							break;

						c = (char) mvwinch(win,ilin,j);
					}

					if (j==ncols || (c != '.' && c != ','))
						icol = j;
				}

				else {
					icol = 0;
					++ilin;
				}
			}

			else if (trat) {
				trat = 2;

				break;
			}

			else
				beep();

			if (isData(tipo)) {
				if ((char) mvwinch(win, ilin, icol) == '/')
					++icol;
			}

			continue;

		/*
		** Outras teclas.
		*/

		default:

			if (aux < 0x20 || aux > 0x7f) {
				beep();

				continue;
			}
		}

		if (trat == 2)
			break;

		/*
		** Emite som de advertencia caso tente incluir um caracter
		** com o buffer cheio num tipo nao apropriado.
		*/

		if (!isData(tipo) && !isNumeric(tipo) &&
			!(icol < tam && overWrite(tipo)) && itam == tam) {
			beep();

			continue;
		}

		/*
		** Verificacao de caracteres de busca se for o caso.
		*/

		chbusca = 0;
		nsch1 = 0;
		nsch2 = 0;

		if (isForSearch(tipo)) {
			for (j = 0; j < itam; ++j) {
				c = (char) mvwinch(win, 0, j);

				if (c == '!')
					++nsch1;

				if (c == '*')
					++nsch2;
			}

			if (charcmp)
				++nsch2;

			if (isNumeric(tipo) || isFloat(tipo) || isData(tipo)) {
				if (nsch1 || (!isData(tipo) && nsch2 > 1)) {
					beep();

					continue;
				}

				if (aux == '<' || aux == '>') {
					charcmp = (char) aux;
					chbusca = 1;

					wmove(winf, 0, 0);
					ajustaVideoReverso(winf, TRUE);
					waddch(winf, aux);
					ajustaVideoReverso(winf, FALSE);
					wrefresh(winf);

					continue;
				}
			}

			else if (nsch1) {
				beep();

				continue;
			}

			if (aux == '*' || aux == '!')
				chbusca = 1;
		}
		 
		/*
		** Emite som de advertencia caso se tente entrar com um
		** caracter nao numerico.
		*/

		if (isNumeric(tipo) && !chbusca) {
			if (nsch1 || !(isdigit(aux) || aux == '-')) {
				beep();

				continue;
			}
		}

		/*
		** Emite som de advertencia caso se tente entrar com um
		** caracter nao valido para ponto flutuante.
		*/

		if (isFloat(tipo) && !chbusca) {
			if (nsch1 || !(isdigit(aux) || aux == '.' || aux == 'e'
					|| aux == 'E' || aux == '-')) {
				beep();

				continue;
			}
		}

		/*
		** Tratamento do tipo data.
		*/

		if (isData(tipo)) {
			if (!chbusca && !(isdigit(aux) || aux == '/')) {
				beep();

				continue;
			}

			if (ilin) {
				beep();

				continue;
			}

			if (aux == '/') {
				if (icol == 1 || icol == 4) {
					c = (char) mvwinch(win, ilin, icol-1);

					mvwaddch(win, ilin, icol, c);
					mvwaddch(win, ilin, icol-1, ' ');

					icol += 2;
				}

				else {
					beep();

					continue;
				}
			}

			j = -1;
			k = ncols;

			for (l = 0; l < itam; ++l) {
				if (k % ncols == 0) {
					++j;
					k = 0;
				}

				if (j == ilin && l == icol && aux != '/')
					res[l] = (char) aux;
				else
					res[l] = (char) mvwinch(win, j, k);

				++k;
			}

			res[l] = '\0';

			/*
			** Verifica a consistencia da data
			*/

			if (datatonum(res, aux) > 2) {
				beep();

				continue;
			}

			if (aux == '/')
				continue;
		}


		/*
		** Tratamento do tipo numerico.
		*/

		if (isNumeric(tipo)) {
			char	c1;
			int	k1;
			int	k2;

			if (overWrite(tipo)) {
				if (icol == itam) {
					beep();

					continue;
				}

				k2 = icol;

				while (++icol < itam) {
					c1 = (char) mvwinch(win, ilin, icol);

					if (!isMasked(tipo))
						break;

					if (c1 != '.' && c1 != ',')
						break;
				}
			}

			else {
				k2 = 0;

				while (1) {
					c1=(char) mvwinch(win,ilin,k2);

					if (!isMasked(tipo))
						break;

					if (c1 != '.' && c1 != ',')
						break;

					++k2;
				}

				if (c1 != ' ') {
					beep();

					continue;
				}

				k2 = itam;

				while ((char) mvwinch(win, ilin, --k2) != ' ')
					;

				k1 = k2;

				while (1) {
					do {
						c1=(char)mvwinch(win,ilin,++k1);

						if (!isMasked(tipo))
							break;
					} while (c1 == '.' || c1 == ',');

					if (k1 == itam || k1 == icol)
						break;

					wmove(win, ilin, k2);
					waddch(win, c1);

					k2 = k1;
				}
			}

			wmove(win, ilin, k2);
			waddch(win, aux);

			wrefresh(win);
		}

		/*
		** Atualizar posicao do buffer e mostrar na tela.
		*/

		else if (isData(tipo) || itam < tam ||
				(icol < itam && overWrite(tipo))) {
			j = itam / ncols;

			if (!isData(tipo) && !overWrite(tipo)) {
				for (k = itam%ncols; k>icol || j > ilin; --k) {
					if (k < 0) {
						k = ncols - 1;
						--j;
					}

					if (k == 0)
						c = (char) mvwinch(win, j-1,
							ncols-1);
					else
						c = (char) mvwinch(win, j, k-1);

					mvwaddch(win, j, k, c);
				}
			}
				
			mvwaddch(win, ilin, icol, aux);

			wrefresh(win);

			++icol;

			if (isData(tipo)) {
				if ((char) mvwinch(win, ilin, icol) == '/')
					++icol;
			}

			else if (overWrite(tipo)) {
				if (icol > itam)
					++itam;
			}

			else
				++itam;

			if (icol > ncols-1 && ilin < nlins-1) {
				icol = 0;
				++ilin;
			}
		}
		else
			beep();

	}

	/*
	** Retornar tela ao modo normal.
	*/

	werase(win);
	wnoutrefresh(win);
	/*
	Comentario (1)
	Este delwin() foi retirado porque ele eliminava uma janela que e' pos-
	teriormente utilizda. Para solucionar este problema, delwin() foi re-
	tirada deste ponto do  programa. Esta funcao foi colocada antes da
	nova alocacao de janela (newwin) para evitar a criacao de "dangling
	pointers".
	Evandro Bacarin & Marcos Chaim 21/11/94.

	delwin(win);
	*/

	if (winf != (WINDOW *) NULL) {
		werase(winf);
		wnoutrefresh(winf);
	/*
	Comentario (1)
	Este delwin() foi retirado porque ele eliminava uma janela que e' pos-
	teriormente utilizda. Para solucionar este problema, delwin() foi re-
	tirada deste ponto do  programa. Esta funcao foi colocada antes da
	nova alocacao de janela (newwin) para evitar a criacao de "dangling
	pointers".
	Evandro Bacarin & Marcos Chaim 21/11/94.

		delwin(winf);
	*/
	}

#ifdef WERR
	sprintf(bufferr, "SAINDO DO PEGARES <%s>", res);
	list_err(bufferr);

	werase(winm);
	wnoutrefresh(winm);
	delwin(winm);
#endif

	doupdate();

	return aux;
}

