/***********************************************************************************
Video - Biblioteca padro para Recursos de Vdeo

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	

		Gerar linha de tracos horizontais e verticais.

	Forma de uso:

		trahorz(win, i, pj, nv, li, hd, ha, co, vd, va);
	Desenvolvido por:

		Oscar Ivan Palma Pacheco, NTIA/EMBRAPA, Campinas.
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/

#ifdef ULTRIX
# include	<cursesX.h>
#else
# include	<stdio.h>

# ifdef i486
#   include 	<ncurses.h>
# else
#   include	<curses.h>
# endif

#endif

#include	"video.h"

void	 trahorz(win, fecha, i, pj, nv, nh, li, hd, ha, co, vd, va)
WINDOW	*win;
int	 fecha;
int	 i;
int	*pj;
int	 nv;
int	 nh;
int	 li[];
int	 hd[];
int	 ha[];
int	 co[];
int	 vd[];
int	 va[];
{
	int	nv1;
	int	nh1;
	int	k;
	int	colant;
	int	linhainf = wlines(win);
	int	colunad = wcols(win);

	nv1 = nv - 1;
	nh1 = nh - 1;

	wmove(win, i, hd[*pj]);

	/*
	** Linha so' com traco horizontal
	*/

	if (nv1 < 0) {

		if (i < linhainf || ha[*pj] < colunad)
			putnchar(win, ha[*pj] - hd[*pj] + 1, D205);

		else
			putnchar(win, ha[*pj] - hd[*pj], D205);

		++(*pj);

		return;

	}

	/*
	** Geracao do traco horizontal considerando
	** a existencia de tracos verticais.
	*/

	colant = -1;

	for (k = 0; k < nv; ++k) {

		/*
		** Garante que cada coluna e' processada apenas
		** uma vez em cada linha.`
		*/

		if (co[k] == colant)
			continue;

		/*
		** Se a linha atual e' maior que o termino de
		** um traco vertical, pegar o proximo traco
		** vertical se corresponder `a mesma coluna.
		*/

		if (i > va[k])
			if (k < nv1 && co[k] == co[k+1])
				continue;

		/*
		** Se coluna atual e' maior que o termino de
		** um traco horizontal, pegar o proximo traco
		** horizontal se corresponder `a mesma linha.
		*/

		if (co[k] > ha[*pj])
			if (*pj < nh1 && li[*pj] == li[*pj+1])
				++(*pj);

		/*
		** Se a coluna atual estiver sobre o traco
		** vertical, completar o traco horizontal
		** ate a posicao imediatamente anterior.
		*/

		if (co[k] > hd[*pj] && co[k] <= ha[*pj]) {

			if (k > 0 && colant != hd[*pj])
				putnchar(win, co[k] - colant - 1, D205);
			else
				putnchar(win, co[k] - hd[*pj] - 1, D205);

		}

		colant = co[k];

		/*
		** Atualizar posicao do cursor, interrompendo
		** a geracao da tabela se estiver indo para a
		** linha 24 coluna 80.
		*/

		/*
		if (i == linhainf && co[k] == colunad)
			break;
		*/

		wmove(win, i, co[k]);
	
		/*
		** Cursor fora do traco vertical.
		*/

		if (i < vd[k] || i > va[k]) {

			if (co[k] >= hd[*pj] && co[k] <= ha[*pj])
				waddch(win, D205);

			continue;

		}
	
		/*
		** Cursor fora do traco horizontal.
		*/

		if (co[k] < hd[*pj] || co[k] > ha[*pj]) {

			if (i >= vd[k] && i <= va[k])
				waddch(win, D186);

			continue;

		}
	
		/*
		** Cursor no inicio do traco horizontal.
		*/

		if (co[k] == hd[*pj]) {

			if (i == vd[k] && i != va[k]) {
				if (fecha == 5)
					waddch(win, D206);
				else if (fecha == 4)
					waddch(win, D203);
				else if (fecha == 1)
					waddch(win, D204);
				else
					waddch(win, D201);
			}

			else if (i == va[k] && i != vd[k]) {
				if (fecha == 6)
					waddch(win, D206);
				else if (fecha == 4)
					waddch(win, D202);
				else if (fecha == 2)
					waddch(win, D204);
				else
					waddch(win, D200);
			}

			else if (i == vd[k] && i == va[k]) {
				if (fecha == 3)
					waddch(win, D204);
				else if (fecha == 2)
					waddch(win, D201);
				else if (fecha == 1)
					waddch(win, D200);
				else
					waddch(win, D205);
			}

			else
				waddch(win, D204);

			continue;

		}
	
		/*
		** Cursor no fim do traco horizontal.
		*/

		if (co[k] == ha[*pj]) {

			if (i == vd[k] && i != va[k]) {
				if (fecha == 9)
					waddch(win, D206);
				if (fecha == 8)
					waddch(win, D203);
				if (fecha == 1)
					waddch(win, D185);
				else
					waddch(win, D187);
			}

			else if (i == va[k] && i != vd[k]) {
				if (fecha == 10)
					waddch(win, D206);
				if (fecha == 8)
					waddch(win, D202);
				if (fecha == 2)
					waddch(win, D185);
				else
					waddch(win, D188);
			}

			else if (i == vd[k] && i == va[k]) {
				if (fecha == 3)
					waddch(win, D185);
				else if (fecha == 2)
					waddch(win, D187);
				else if (fecha == 1)
					waddch(win, D188);
				else
					waddch(win, D205);
			}

			else
				waddch(win, D185);

			continue;

		}
	
		/*
		** Cursor sobre o traco horizontal.
		*/

		if (co[k] > hd[*pj] && co[k] < ha[*pj]) {

			if (i > vd[k] && i < va[k])
				waddch(win, D206);

			else if (i == vd[k] && i != va[k]) {
				if (fecha == 1)
					waddch(win, D206);
				else
					waddch(win, D203);
			}

			else if (i == va[k] && i != vd[k]) {
				if (fecha == 2)
					waddch(win, D206);
				else
					waddch(win, D202);
			}

			else if (i == vd[k] && i == va[k]) {
				if (fecha == 3)
					waddch(win, D206);
				else if (fecha == 2)
					waddch(win, D203);
				else if (fecha == 1)
					waddch(win, D202);
				else
					waddch(win, D205);
			}

			else
				waddch(win, D205);

		}

	}

	/*
	** Traco horizontal `a direita do ultimo
	** traco vertical.
	*/

	if (co[nv1] < ha[*pj]) {

		if (i < linhainf || ha[*pj] < colunad)
			putnchar(win, ha[*pj] - co[nv1], D205);
		else
			putnchar(win, ha[*pj] - co[nv1] - 1, D205);

	}

	++(*pj);

}

