/***********************************************************************************
Video - Biblioteca padro para Recursos de Vdeo

Direitos Autorais Reservados (c) 2004 Embrapa Informtica Agropecuria

Esta biblioteca  software livre; voc pode redistribu-la e/ou modific-la sob
os termos da Licena Pblica Geral Menor do GNU conforme publicada pela Free
Software Foundation; tanto a verso 2.1 da Licena, ou (a seu critrio)
qualquer verso posterior.

Esta biblioteca  distribuda na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral Menor do GNU para mais
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral Menor do GNU junto com
esta biblioteca; se no, escreva para a Free Software Foundation, Inc., no
endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

***********************************************************************************

Parte integrante do SOC - SOftware Cientfico 

Descrio: 	
 
	Definicoes para uso das rotinas de video.


Desenvolvido por:

		Oscar Ivan Palma Pacheco, NTIA/EMBRAPA, Campinas.

            Paulo Cesar de Oliveira

		Adriano de Carvalho
		
	Informaes do CVS:
	$Source:
	$Revision:
	$Date:

***********************************************************************************/


/*
** Macros para definir tipos de campos no uso da funcao pegares().
*/

/*
** Definicoes basicas.
*/

#define	BRACKETED		0x00000100 /* bracketed ON/OFF bit.	*/
#define	MASKED			0x00000200 /* masked ON/OFF bit.	*/
#define	FORSEARCH		0x00000400 /* search ON/OFF bit.	*/
#define	STARTCURPOS		0x00000800 /* Starting cursor position.	*/
#define	OVERWRITE		0x00001000 /* Allows overwriting.	*/
#define	RETCHGEDSTR		0x00002000 /* Return changed string.	*/
#define	LIMPARESP		0x00004000 /* Resetar area no pegares.	*/

/*
** Campos sem colchetes e sem mascara.
*/

#define	ALFANUM_S		0x00000001 /* campo alfanumerico.	*/
#define	NUMERIC_S		0x00000002 /* campo numerico.		*/
#define	FLOAT_S			0x00000004 /* campo flutuante.		*/
#define	DATA_S			0x00000008 /* campo data.		*/

/*
** Campos entre colchetes e sem mascara.
*/

#define	ALFANUM_C		(ALFANUM_S | BRACKETED)
#define	NUMERIC_C		(NUMERIC_S | BRACKETED)
#define	FLOAT_C			(FLOAT_S | BRACKETED)
#define	DATA_C			(DATA_S | BRACKETED)
#define SEMTIPO_C			-1

/*
** Campos sem colchetes e com mascara.
*/

#define	ALFANUM_S_M		(ALFANUM_S | MASKED)
#define	NUMERIC_S_M		(NUMERIC_S | MASKED)
#define	FLOAT_S_M		(FLOAT_S | MASKED)
#define	DATA_S_M		(DATA_S | MASKED)

/*
** Campos entre colchetes e com mascara.
*/

#define	ALFANUM_C_M		(ALFANUM_S | BRACKETED | MASKED)
#define	NUMERIC_C_M		(NUMERIC_S | BRACKETED | MASKED)
#define	FLOAT_C_M		(FLOAT_S | BRACKETED | MASKED)
#define	DATA_C_M		(DATA_S | BRACKETED | MASKED)

/*
** Macros envolvendo tipos de campos.
*/

#define	isAlfaNum(x)		(x&ALFANUM_S)
#define	isNumeric(x)		(x&NUMERIC_S)
#define	isFloat(x)		(x&FLOAT_S)
#define	isData(x)		(x&DATA_S)
#define	isBracketed(x)		(x&BRACKETED)
#define	isMasked(x)		(x&MASKED)
#define	isForSearch(x)		(x&FORSEARCH)
#define	startCurPosAtBeg(x)	(x&STARTCURPOS)
#define	overWrite(x)		(x&OVERWRITE)
#define	retChgedStr(x)		(x&RETCHGEDSTR)
#define	limpaResp(x)		(x&LIMPARESP)

/*
** Macros para compactacao e descompactacao das dimensoes de um campo.
*/

#define PACK(l,c)		(((l&0x7f)<<8)|c)
#define UNPACKLINES(x)		((x&0x7f00)>>8)
#define UNPACKCOLS(x)		(x&0xff)

/*
******************************************************************************
*/

/*
** Macro para obter ^Char
*/

#define CCTRL(c)		(c & 037)

/*
******************************************************************************
*/

/*
** Macros para utilizacao na funcao faztab.
*/

#define VERT(c,d,a)		((long) (a) * 10000000L + (long) (d) * 10000 + \
				(long) (c) * 10L + 1L)

#define HORZ(l,d,a)		((long) (a) * 10000000L + (long) (d) * 10000 + \
				(long) (l) * 10L + 2L)

/*
******************************************************************************
*/

#ifdef ULTRIX
# define	D184			0x6b
# define	D185			0x75
# define	D186			0x78
# define	D187			0x6b
# define	D188			0x6a
# define	D190			0x6a
# define	D198			0x74
# define	D200			0x6d
# define	D201			0x6c
# define	D202			0x76
# define	D203			0x77
# define	D204			0x74
# define	D205			0x71
# define	D206			0x6e
# define	D212			0x6d
# define	D213			0x6c
#else
# ifdef MSDOS
#  define	D184			184
#  define	D185			185
#  define	D186			186
#  define	D187			187
#  define	D188			188
#  define	D190			190
#  define	D198			198
#  define	D200			200
#  define	D201			201
#  define	D202			202
#  define	D203			203
#  define	D204			204
#  define	D205			205
#  define	D206			206
#  define	D212			212
#  define	D213			213
# else
#  define	D184			'+'
#  define	D185			'+'
#  define	D186			'|'
#  define	D187			'+'
#  define	D188			'+'
#  define	D190			'+'
#  define	D198			'+'
#  define	D200			'+'
#  define	D201			'+'
#  define	D202			'+'
#  define	D203			'+'
#  define	D204			'+'
#  define	D205			'-'
#  define	D206			'+'
#  define	D212			'+'
#  define	D213			'+'
# endif
#endif

/*
******************************************************************************
*/

/*
** Macros para uso do curses.
*/

#ifdef IRIX

# define InitScreenError	(WINDOW *) NULL

#else

# define InitScreenError	ERR

#endif

#ifdef VAXVMS

# define mvwprintw(a,b,c,d)	wmove(a,b,c); wprintw(a,d)
# define wattron		setattr
# define wattroff		clrattr
# define A_STANDOUT		_STANDOUT
# define A_UNDERLINE		_UNDERLINE
# define A_REVERSE		_REVERSE
# define A_BLINK		_BLINK
# define A_DIM			_DIM
# define A_BOLD			_BOLD
# define A_ALTCHARSET		_ALTCHARSET

#endif

#define setvstand(w,b)		{\
					if (b)\
						wattron(w, A_STANDOUT);\
					else\
						wattroff(w, A_STANDOUT);\
				}

#define setvunder(w,b)		{\
					if (b)\
						wattron(w, A_UNDERLINE);\
					else\
						wattroff(w, A_UNDERLINE);\
				}

#define setvrev(w,b)		{\
					if (b)\
						wattron(w, A_REVERSE);\
					else\
						wattroff(w, A_REVERSE);\
				}

#define setvblink(w,b)		{\
					if (b)\
						wattron(w, A_BLINK);\
					else\
						wattroff(w, A_BLINK);\
				}

#define setvdim(w,b)		{\
					if (b)\
						wattron(w, A_DIM);\
					else\
						wattroff(w, A_DIM);\
				}

#define setvbold(w,b)		{\
					if (b)\
						wattron(w, A_BOLD);\
					else\
						wattroff(w, A_BOLD);\
				}

#define setvaltch(w,b)		{\
					if (b)\
						wattron(w, A_ALTCHARSET);\
					else\
						wattroff(w, A_ALTCHARSET);\
				}

#define	wlines(w)		(w->_maxy)
#define	wcols(w)		(w->_maxx)
#define	limpalin(w,l,c)		wmove(w, l, c); wclrtoeol(w)

/*
******************************************************************************
*/

/*
** Define para ser usado na RISC6000 E SUN, mas definidos ja' para
** poder utilizar um unico formato de chamada.
*/

# define LIN_S	0
# define LIN_D	1

#ifdef MSDOS
  int	faztab(WINDOW *,int,...);
  int	gettraco(WINDOW *,long ,int *,int *,int *,int *,int *,int *,int);
  int	ordtraco(WINDOW *,int *,int *,int *,int);
  int	pegares(char *,int ,int ,int ,int);
  int	pfaztab(WINDOW *, int, long *);
  void	trahorz(WINDOW *,int ,int ,int *,int ,int ,int *,int *,int *,int *,
		int *,int *);
  void	travert(WINDOW *,int ,int ,int *,int *,int *);
  void	vdmsg(WINDOW *,char *);
  void	putnchar(WINDOW *,int ,int);
  void	limpacam(WINDOW *,char *,int ,int ,int);
  int	wlen(WINDOW *,int);
  int	pgetch(WINDOW *);
  void	xpsetbuf(char *);
  int	xpgetch(WINDOW *);
  void	mvwprintl(WINDOW *, int, char *);
  int	vid_box(WINDOW *, int);	
#else
  int	faztab();
  int	gettraco();
  int	ordtraco();
  int	pegares();
  int	pfaztab();
  void	trahorz();
  void	travert();
  void	vdmsg();
  void	putnchar();
  void	limpacam();
  int	wlen();
  int	pgetch();
  void	xpsetbuf();
  int	xpgetch();
  void	mvwprintl();
  int	vid_box();	
#endif

#ifdef MEM_DEBUG
#include "mshell.h"
#endif
